SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;


DROP TABLE IF EXISTS `#__action_logs`;
CREATE TABLE IF NOT EXISTS `#__action_logs` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `message_language_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `message` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `log_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `extension` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `item_id` int(11) NOT NULL DEFAULT '0',
  `ip_address` varchar(40) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0.0.0.0',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_user_id_logdate` (`user_id`,`log_date`),
  KEY `idx_user_id_extension` (`user_id`,`extension`),
  KEY `idx_extension_item_id` (`extension`,`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__action_logs_extensions`;
CREATE TABLE IF NOT EXISTS `#__action_logs_extensions` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `extension` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__action_logs_extensions` (`id`, `extension`) VALUES
(1, 'com_banners'),
(2, 'com_cache'),
(3, 'com_categories'),
(4, 'com_config'),
(5, 'com_contact'),
(6, 'com_content'),
(7, 'com_installer'),
(8, 'com_media'),
(9, 'com_menus'),
(10, 'com_messages'),
(11, 'com_modules'),
(12, 'com_newsfeeds'),
(13, 'com_plugins'),
(14, 'com_redirect'),
(15, 'com_tags'),
(16, 'com_templates'),
(17, 'com_users'),
(18, 'com_checkin');

DROP TABLE IF EXISTS `#__action_logs_users`;
CREATE TABLE IF NOT EXISTS `#__action_logs_users` (
  `user_id` int(11) UNSIGNED NOT NULL,
  `notify` tinyint(1) UNSIGNED NOT NULL,
  `extensions` text COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`user_id`),
  KEY `idx_notify` (`notify`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__action_log_config`;
CREATE TABLE IF NOT EXISTS `#__action_log_config` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `type_title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `type_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `id_holder` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `title_holder` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `table_name` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `text_prefix` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__action_log_config` (`id`, `type_title`, `type_alias`, `id_holder`, `title_holder`, `table_name`, `text_prefix`) VALUES
(1, 'article', 'com_content.article', 'id', 'title', '#__content', 'PLG_ACTIONLOG_JOOMLA'),
(2, 'article', 'com_content.form', 'id', 'title', '#__content', 'PLG_ACTIONLOG_JOOMLA'),
(3, 'banner', 'com_banners.banner', 'id', 'name', '#__banners', 'PLG_ACTIONLOG_JOOMLA'),
(4, 'user_note', 'com_users.note', 'id', 'subject', '#__user_notes', 'PLG_ACTIONLOG_JOOMLA'),
(5, 'media', 'com_media.file', '', 'name', '', 'PLG_ACTIONLOG_JOOMLA'),
(6, 'category', 'com_categories.category', 'id', 'title', '#__categories', 'PLG_ACTIONLOG_JOOMLA'),
(7, 'menu', 'com_menus.menu', 'id', 'title', '#__menu_types', 'PLG_ACTIONLOG_JOOMLA'),
(8, 'menu_item', 'com_menus.item', 'id', 'title', '#__menu', 'PLG_ACTIONLOG_JOOMLA'),
(9, 'newsfeed', 'com_newsfeeds.newsfeed', 'id', 'name', '#__newsfeeds', 'PLG_ACTIONLOG_JOOMLA'),
(10, 'link', 'com_redirect.link', 'id', 'old_url', '#__redirect_links', 'PLG_ACTIONLOG_JOOMLA'),
(11, 'tag', 'com_tags.tag', 'id', 'title', '#__tags', 'PLG_ACTIONLOG_JOOMLA'),
(12, 'style', 'com_templates.style', 'id', 'title', '#__template_styles', 'PLG_ACTIONLOG_JOOMLA'),
(13, 'plugin', 'com_plugins.plugin', 'extension_id', 'name', '#__extensions', 'PLG_ACTIONLOG_JOOMLA'),
(14, 'component_config', 'com_config.component', 'extension_id', 'name', '', 'PLG_ACTIONLOG_JOOMLA'),
(15, 'contact', 'com_contact.contact', 'id', 'name', '#__contact_details', 'PLG_ACTIONLOG_JOOMLA'),
(16, 'module', 'com_modules.module', 'id', 'title', '#__modules', 'PLG_ACTIONLOG_JOOMLA'),
(17, 'access_level', 'com_users.level', 'id', 'title', '#__viewlevels', 'PLG_ACTIONLOG_JOOMLA'),
(18, 'banner_client', 'com_banners.client', 'id', 'name', '#__banner_clients', 'PLG_ACTIONLOG_JOOMLA'),
(19, 'application_config', 'com_config.application', '', 'name', '', 'PLG_ACTIONLOG_JOOMLA');

DROP TABLE IF EXISTS `#__acymailing_action`;
CREATE TABLE IF NOT EXISTS `#__acymailing_action` (
  `action_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `frequency` int(10) UNSIGNED NOT NULL,
  `nextdate` int(10) UNSIGNED NOT NULL,
  `server` varchar(255) NOT NULL,
  `port` varchar(50) NOT NULL,
  `connection_method` varchar(10) NOT NULL DEFAULT '0',
  `secure_method` varchar(10) NOT NULL DEFAULT '0',
  `self_signed` tinyint(4) NOT NULL DEFAULT '0',
  `username` varchar(255) NOT NULL,
  `password` varchar(50) NOT NULL,
  `userid` int(10) UNSIGNED DEFAULT NULL,
  `conditions` text,
  `actions` text,
  `report` text,
  `published` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` smallint(5) UNSIGNED DEFAULT '0',
  `delete_wrong_emails` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`action_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_config`;
CREATE TABLE IF NOT EXISTS `#__acymailing_config` (
  `namekey` varchar(200) NOT NULL,
  `value` text,
  PRIMARY KEY (`namekey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_config` (`namekey`, `value`) VALUES
('level', 'Starter'),
('version', '5.10.1'),
('smtp_port', '25'),
('from_name', ''),
('from_email', ''),
('bounce_email', ''),
('mailer_method', 'phpmail'),
('sendmail_path', '/usr/sbin/sendmail'),
('smtp_secured', ''),
('smtp_auth', '0'),
('smtp_username', ''),
('smtp_password', ''),
('reply_name', ''),
('reply_email', ''),
('cron_sendto', 'admin@admin.com'),
('add_names', '1'),
('encoding_format', '8bit'),
('charset', 'UTF-8'),
('word_wrapping', '150'),
('hostname', ''),
('embed_images', '0'),
('embed_files', '1'),
('editor', 'acyeditor'),
('multiple_part', '1'),
('smtp_host', 'localhost'),
('queue_nbmail', '40'),
('queue_nbmail_auto', '70'),
('queue_type', 'auto'),
('queue_try', '3'),
('queue_pause', '120'),
('allow_visitor', '1'),
('require_confirmation', '0'),
('priority_newsletter', '3'),
('allowedfiles', 'zip,doc,docx,pdf,xls,txt,gzip,rar,jpg,gif,xlsx,pps,csv,bmp,ico,odg,odp,ods,odt,png,ppt,swf,xcf,mp3,wma'),
('uploadfolder', 'media/com_acymailing/upload'),
('confirm_redirect', ''),
('subscription_message', '1'),
('notification_unsuball', ''),
('cron_next', '1251990901'),
('confirmation_message', '1'),
('welcome_message', '1'),
('unsub_message', '1'),
('cron_last', '0'),
('cron_fromip', ''),
('cron_report', ''),
('cron_frequency', '900'),
('cron_sendreport', '2'),
('cron_fullreport', '1'),
('cron_savereport', '2'),
('cron_savepath', 'media/com_acymailing/logs/report{year}_{month}.log'),
('notification_created', ''),
('notification_accept', ''),
('notification_refuse', ''),
('forward', '0'),
('description_starter', 'Joomla!® Mailing Extension'),
('description_essential', 'Joomla!® E-mail Marketing'),
('description_business', 'Joomla!® Mailing Extension'),
('description_enterprise', 'Joomla!® Newsletter Extension'),
('priority_followup', '2'),
('unsub_redirect', ''),
('show_footer', '0'),
('use_sef', '0'),
('itemid', '0'),
('css_module', ''),
('css_frontend', 'default'),
('css_backend', ''),
('bootstrap_frontend', '0'),
('menu_position', 'above'),
('unsub_reasons', 'a:2:{i:0;s:21:\"UNSUB_SURVEY_FREQUENT\";i:1;s:21:\"UNSUB_SURVEY_RELEVANT\";}'),
('security_key', 'VvpaKMHVvjyqdWN9RX4g42Ukd2b5GC'),
('installcomplete', '1'),
('Starter', '0'),
('Essential', '1'),
('Business', '2'),
('Enterprise', '3'),
('website', 'http://localhost/joomla/master-b3-t3_update11/test/full/'),
('max_execution_time', '0'),
('last_maxexec_check', '1503508032'),
('ssl_links', '0'),
('smtp_keepalive', '1'),
('elasticemail_username', ''),
('elasticemail_password', ''),
('elasticemail_port', 'rest'),
('bounce_action_maxtry', 'noaction'),
('bounce_action_lists_maxtry', '1'),
('sendorder', 'subid,ASC'),
('autosub', 'None'),
('allow_modif', 'data'),
('generate_name', '1'),
('notification_unsub', ''),
('notification_contact', ''),
('notification_contact_menu', ''),
('notification_confirm', ''),
('sub_redirect', ''),
('modif_redirect', ''),
('module_redirect', ''),
('redirect_tags', '0'),
('show_order', '1'),
('unsubscription_message', '1'),
('confirm_message', '0'),
('comments_feature', ''),
('disqus_shortname', ''),
('frontend_subject', '1'),
('frontend_print', '0'),
('show_description', '1'),
('show_filter', '1'),
('show_headings', '1'),
('show_senddate', '1'),
('show_colnumber', '1'),
('open_popup', '1'),
('popup_width', '750'),
('popup_height', '550'),
('indexFollow', '1'),
('unsub_intro', 'UNSUB_INTRO'),
('unsub_dispoptions', '1'),
('unsub_survey', '1'),
('acyrss_format', ''),
('acyrss_name', ''),
('acyrss_description', ''),
('acyrss_element', '20'),
('acyrss_order', 'senddate'),
('email_checkdomain', '0'),
('email_botscout', '0'),
('email_botscout_key', ''),
('email_stopforumspam', '0'),
('email_iptimecheck', '0'),
('mediafolder', 'media/com_acymailing/upload'),
('description_sidekick', 'Joomla!® Newsletter System'),
('Sidekick', '4'),
('captcha_plugin', 'no'),
('latestversion', '5.10.1'),
('expirationdate', '0'),
('lastlicensecheck', '1528122609'),
('special_chars', '0'),
('unsub_dispothersubs', '0'),
('pluginNeedUpdate', ''),
('export_excelsecurity', '1'),
('gdpr_export', '0'),
('anonymous_tracking', '0'),
('anonymizeold', '0');

DROP TABLE IF EXISTS `#__acymailing_fields`;
CREATE TABLE IF NOT EXISTS `#__acymailing_fields` (
  `fieldid` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT,
  `fieldname` varchar(250) NOT NULL,
  `namekey` varchar(50) NOT NULL,
  `type` varchar(50) DEFAULT NULL,
  `value` text NOT NULL,
  `published` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `ordering` smallint(5) UNSIGNED DEFAULT '99',
  `options` text,
  `core` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `required` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `backend` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `frontcomp` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `default` text,
  `listing` tinyint(3) UNSIGNED DEFAULT NULL,
  `frontlisting` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `frontjoomlaprofile` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `frontjoomlaregistration` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `joomlaprofile` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `access` varchar(250) NOT NULL DEFAULT 'all',
  `fieldcat` int(11) NOT NULL DEFAULT '0',
  `listingfilter` tinyint(4) DEFAULT NULL,
  `frontlistingfilter` tinyint(4) DEFAULT NULL,
  `frontform` tinyint(4) DEFAULT '1',
  PRIMARY KEY (`fieldid`),
  UNIQUE KEY `namekey` (`namekey`),
  KEY `orderingindex` (`published`,`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_fields` (`fieldid`, `fieldname`, `namekey`, `type`, `value`, `published`, `ordering`, `options`, `core`, `required`, `backend`, `frontcomp`, `default`, `listing`, `frontlisting`, `frontjoomlaprofile`, `frontjoomlaregistration`, `joomlaprofile`, `access`, `fieldcat`, `listingfilter`, `frontlistingfilter`, `frontform`) VALUES
(1, 'NAMECAPTION', 'name', 'text', '', 1, 1, '', 1, 0, 1, 1, '', 1, 1, 0, 0, 0, 'all', 0, NULL, NULL, 1),
(2, 'EMAILCAPTION', 'email', 'text', '', 1, 2, '', 1, 1, 1, 1, '', 1, 1, 0, 0, 0, 'all', 0, NULL, NULL, 1),
(3, 'RECEIVE', 'html', 'radio', '0::JOOMEXT_TEXT\n1::HTML', 1, 3, '', 1, 1, 1, 1, '1', 1, 0, 0, 0, 0, 'all', 0, NULL, NULL, 1);

DROP TABLE IF EXISTS `#__acymailing_filter`;
CREATE TABLE IF NOT EXISTS `#__acymailing_filter` (
  `filid` mediumint(8) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(250) DEFAULT NULL,
  `description` text,
  `published` tinyint(3) UNSIGNED DEFAULT NULL,
  `lasttime` int(10) UNSIGNED DEFAULT NULL,
  `trigger` text,
  `report` text,
  `action` text,
  `filter` text,
  `daycron` int(10) UNSIGNED DEFAULT NULL,
  PRIMARY KEY (`filid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_forward`;
CREATE TABLE IF NOT EXISTS `#__acymailing_forward` (
  `subid` int(10) UNSIGNED NOT NULL,
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  `date` int(10) UNSIGNED NOT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `nbforwarded` int(10) UNSIGNED NOT NULL,
  PRIMARY KEY (`subid`,`mailid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_geolocation`;
CREATE TABLE IF NOT EXISTS `#__acymailing_geolocation` (
  `geolocation_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `geolocation_subid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `geolocation_type` varchar(255) NOT NULL DEFAULT 'subscription',
  `geolocation_ip` varchar(255) NOT NULL DEFAULT '',
  `geolocation_created` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `geolocation_latitude` decimal(9,6) NOT NULL DEFAULT '0.000000',
  `geolocation_longitude` decimal(9,6) NOT NULL DEFAULT '0.000000',
  `geolocation_postal_code` varchar(255) NOT NULL DEFAULT '',
  `geolocation_country` varchar(255) NOT NULL DEFAULT '',
  `geolocation_country_code` varchar(255) NOT NULL DEFAULT '',
  `geolocation_state` varchar(255) NOT NULL DEFAULT '',
  `geolocation_state_code` varchar(255) NOT NULL DEFAULT '',
  `geolocation_city` varchar(255) NOT NULL DEFAULT '',
  `geolocation_continent` varchar(255) NOT NULL DEFAULT '',
  `geolocation_timezone` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`geolocation_id`),
  KEY `geolocation_type` (`geolocation_subid`,`geolocation_type`),
  KEY `geolocation_ip_created` (`geolocation_ip`,`geolocation_created`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_history`;
CREATE TABLE IF NOT EXISTS `#__acymailing_history` (
  `subid` int(10) UNSIGNED NOT NULL,
  `date` int(10) UNSIGNED NOT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `action` varchar(50) NOT NULL COMMENT 'different actions: created,modified,confirmed',
  `data` text,
  `source` text,
  `mailid` mediumint(8) UNSIGNED DEFAULT NULL,
  KEY `subid` (`subid`,`date`),
  KEY `dateindex` (`date`),
  KEY `actionindex` (`action`,`mailid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_history` (`subid`, `date`, `ip`, `action`, `data`, `source`, `mailid`) VALUES
(3, 1418120944, '192.168.9.17', 'created', '', 'HTTP_REFERER::http://192.168.9.17/framework/default/index.php/user-registration\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/default/index.php/user-registration?task=registration.register\nQUERY_STRING::task=registration.register', 0),
(3, 1418121419, '192.168.9.17', 'confirmed', 'EXECUTED_BY::846 ( demo )', 'HTTP_REFERER::http://192.168.9.17/framework/default/administrator/index.php?option=com_users\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/default/administrator/index.php?option=com_users&view=users\nQUERY_STRING::option=com_users&view=users', 0),
(4, 1418121448, '192.168.9.17', 'created', '', 'HTTP_REFERER::http://192.168.9.17/framework/default/index.php/user-registration\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/default/index.php/user-registration?task=registration.register\nQUERY_STRING::task=registration.register', 0),
(4, 1418121459, '192.168.9.17', 'confirmed', 'EXECUTED_BY::846 ( demo )', 'HTTP_REFERER::http://192.168.9.17/framework/default/administrator/index.php?option=com_users&view=users\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/default/administrator/index.php?option=com_users&view=users\nQUERY_STRING::option=com_users&view=users', 0),
(5, 1418218543, '192.168.9.125', 'created', '', 'HTTP_REFERER::http://192.168.9.17/framework/default/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.1\nREQUEST_URI::/framework/default/index.php', 0),
(6, 1427376525, '192.168.9.17', 'created', '', 'HTTP_REFERER::http://192.168.9.17/framework/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:36.0) Gecko/20100101 Firefox/36.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/index.php', 0),
(2, 1430752922, '192.168.9.17', 'modified', 'EXECUTED_BY::846 ( demo )', 'HTTP_REFERER::http://192.168.9.17/framework/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:37.0) Gecko/20100101 Firefox/37.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/framework/index.php', 0),
(7, 1443442316, '192.168.9.17', 'created', '', 'HTTP_REFERER::http://192.168.9.17/joomla/beta/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:40.0) Gecko/20100101 Firefox/40.0\nHTTP_HOST::192.168.9.17\nSERVER_ADDR::192.168.9.17\nREMOTE_ADDR::192.168.9.17\nREQUEST_URI::/joomla/beta/index.php', 0),
(8, 1466683696, '192.168.9.155', 'created', '', 'HTTP_REFERER::http://192.168.9.155/joomla/master-update/v1/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:47.0) Gecko/20100101 Firefox/47.0\nHTTP_HOST::192.168.9.155\nSERVER_ADDR::192.168.9.155\nREMOTE_ADDR::192.168.9.155\nREQUEST_URI::/joomla/master-update/v1/index.php', 0),
(9, 1517242706, '127.0.0.1', 'created', '', 'HTTP_REFERER::http://localhost/joomla/master-b3-t3_update2/master/\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0\nHTTP_HOST::localhost\nSERVER_ADDR::127.0.0.1\nREMOTE_ADDR::127.0.0.1\nREQUEST_URI::/joomla/master-b3-t3_update2/master/index.php', 0),
(10, 1532357995, '192.168.9.55', 'created', '', 'HTTP_REFERER::http://192.168.9.55/framework/2018/06June/theme3589/index.php/user-registration\nHTTP_USER_AGENT::Mozilla/5.0 (Windows NT 6.1; WOW64; rv:45.0) Gecko/20100101 Firefox/45.0\nHTTP_HOST::192.168.9.55\nSERVER_ADDR::192.168.9.55\nREMOTE_ADDR::192.168.9.55\nREQUEST_URI::/framework/2018/06June/theme3589/index.php/user-registration?task=registration.register\nQUERY_STRING::task=registration.register', 0);

DROP TABLE IF EXISTS `#__acymailing_list`;
CREATE TABLE IF NOT EXISTS `#__acymailing_list` (
  `name` varchar(250) NOT NULL,
  `description` text,
  `ordering` smallint(5) UNSIGNED DEFAULT '0',
  `listid` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT,
  `published` tinyint(4) DEFAULT NULL,
  `userid` int(10) UNSIGNED DEFAULT NULL,
  `alias` varchar(250) DEFAULT NULL,
  `color` varchar(30) DEFAULT NULL,
  `visible` tinyint(4) NOT NULL DEFAULT '1',
  `welmailid` mediumint(9) DEFAULT NULL,
  `unsubmailid` mediumint(9) DEFAULT NULL,
  `type` enum('list','campaign') NOT NULL DEFAULT 'list',
  `access_sub` varchar(250) NOT NULL DEFAULT 'all',
  `access_manage` varchar(250) NOT NULL DEFAULT 'none',
  `languages` varchar(250) NOT NULL DEFAULT 'all',
  `startrule` varchar(50) NOT NULL DEFAULT '0',
  `category` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`listid`),
  KEY `typeorderingindex` (`type`,`ordering`),
  KEY `useridindex` (`userid`),
  KEY `typeuseridindex` (`type`,`userid`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_list` (`name`, `description`, `ordering`, `listid`, `published`, `userid`, `alias`, `color`, `visible`, `welmailid`, `unsubmailid`, `type`, `access_sub`, `access_manage`, `languages`, `startrule`, `category`) VALUES
('Newsletters', 'Receive our latest news', 1, 1, 1, 846, 'mailing_list', '#3366ff', 1, NULL, NULL, 'list', 'all', 'none', 'all', '0', '');

DROP TABLE IF EXISTS `#__acymailing_listcampaign`;
CREATE TABLE IF NOT EXISTS `#__acymailing_listcampaign` (
  `campaignid` smallint(5) UNSIGNED NOT NULL,
  `listid` smallint(5) UNSIGNED NOT NULL,
  PRIMARY KEY (`campaignid`,`listid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_listmail`;
CREATE TABLE IF NOT EXISTS `#__acymailing_listmail` (
  `listid` smallint(5) UNSIGNED NOT NULL,
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  PRIMARY KEY (`listid`,`mailid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_listsub`;
CREATE TABLE IF NOT EXISTS `#__acymailing_listsub` (
  `listid` smallint(5) UNSIGNED NOT NULL,
  `subid` int(10) UNSIGNED NOT NULL,
  `subdate` int(10) UNSIGNED DEFAULT NULL,
  `unsubdate` int(10) UNSIGNED DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  PRIMARY KEY (`listid`,`subid`),
  KEY `subidindex` (`subid`),
  KEY `listidstatusindex` (`listid`,`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_listsub` (`listid`, `subid`, `subdate`, `unsubdate`, `status`) VALUES
(1, 1, 1415263735, NULL, 1),
(1, 2, 1415263735, NULL, 1),
(1, 5, 1418218543, NULL, 1),
(1, 6, 1427376525, NULL, 1),
(1, 7, 1443442316, NULL, 1),
(1, 8, 1466683696, NULL, 1),
(1, 9, 1517242706, NULL, 1);

DROP TABLE IF EXISTS `#__acymailing_mail`;
CREATE TABLE IF NOT EXISTS `#__acymailing_mail` (
  `mailid` mediumint(8) UNSIGNED NOT NULL AUTO_INCREMENT,
  `subject` text,
  `body` longtext NOT NULL,
  `altbody` longtext NOT NULL,
  `published` tinyint(4) DEFAULT '1',
  `senddate` int(10) UNSIGNED DEFAULT NULL,
  `created` int(10) UNSIGNED DEFAULT NULL,
  `fromname` varchar(250) DEFAULT NULL,
  `fromemail` varchar(250) DEFAULT NULL,
  `replyname` varchar(250) DEFAULT NULL,
  `replyemail` varchar(250) DEFAULT NULL,
  `type` enum('news','autonews','followup','unsub','welcome','notification','joomlanotification','action','article') NOT NULL DEFAULT 'news',
  `visible` tinyint(4) NOT NULL DEFAULT '1',
  `userid` int(10) UNSIGNED DEFAULT NULL,
  `alias` varchar(250) DEFAULT NULL,
  `attach` text,
  `html` tinyint(4) NOT NULL DEFAULT '1',
  `tempid` smallint(6) NOT NULL DEFAULT '0',
  `key` varchar(200) DEFAULT NULL,
  `frequency` varchar(50) DEFAULT NULL,
  `params` text,
  `sentby` int(10) UNSIGNED DEFAULT NULL,
  `metakey` text,
  `metadesc` text,
  `filter` text,
  `language` varchar(50) NOT NULL DEFAULT '',
  `abtesting` varchar(250) DEFAULT NULL,
  `thumb` varchar(250) DEFAULT NULL,
  `summary` text NOT NULL,
  `favicon` text,
  `bccaddresses` varchar(250) DEFAULT NULL,
  `lastupdate` int(10) UNSIGNED DEFAULT NULL,
  `userlastupdate` int(10) UNSIGNED DEFAULT NULL,
  PRIMARY KEY (`mailid`),
  KEY `senddate` (`senddate`),
  KEY `typemailidindex` (`type`,`mailid`),
  KEY `useridindex` (`userid`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_mail` (`mailid`, `subject`, `body`, `altbody`, `published`, `senddate`, `created`, `fromname`, `fromemail`, `replyname`, `replyemail`, `type`, `visible`, `userid`, `alias`, `attach`, `html`, `tempid`, `key`, `frequency`, `params`, `sentby`, `metakey`, `metadesc`, `filter`, `language`, `abtesting`, `thumb`, `summary`, `favicon`, `bccaddresses`, `lastupdate`, `userlastupdate`) VALUES
(1, 'New Subscriber on your website : {user:email}', '<p>Hello {subtag:name},</p><p>A new user has been created in AcyMailing : </p><blockquote><p>Name : {user:name}</p><p>Email : {user:email}</p><p>IP : {user:ip} </p><p>Subscription : {user:subscription}</p></blockquote>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_created', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(2, 'A User unsubscribed from all your lists : {user:email}', '<p>Hello {subtag:name},</p><p>The user {user:name} : {user:email} unsubscribed from all your lists</p><p>Subscription : {user:subscription}</p><p>{survey}</p>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_unsuball', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(3, 'A User unsubscribed : {user:email}', '<p>Hello {subtag:name},</p><p>The user {user:name} : {user:email} unsubscribed from your list</p><p>Subscription : {user:subscription}</p><p>{survey}</p>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_unsub', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(4, 'A User refuses to receive e-mails from your website : {user:email}', '<p>The User {user:name} : {user:email} refuses to receive any e-mail anymore from your website.</p><p>Subscription : {user:subscription}</p><p>{survey}</p>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_refuse', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(5, 'New contact from your website : {user:email}', '<p>Hello {subtag:name},</p><p>A user submitted the form : </p><blockquote><p>Name : {user:name}</p><p>Email : {user:email}</p><p>IP : {user:ip} </p><p>Subscription : {user:subscription}</p></blockquote>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_contact', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(6, 'A user subscribed or modified his subscription : {user:email}', '<p>Hello {subtag:name},</p><p>A user submitted the form : </p><blockquote><p>Name : {user:name}</p><p>Email : {user:email}</p><p>IP : {user:ip} </p><p>Subscription : {user:subscription}</p></blockquote>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_contact_menu', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(7, 'A user confirmed his subscription : {user:email}', '<p>Hello {subtag:name},</p><p>A user confirmed his subscription : </p><blockquote><p>Name : {user:name}</p><p>Email : {user:email}</p><p>IP : {user:ip} </p><p>Subscription : {user:subscription}</p></blockquote>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'notification_confirm', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(8, '{subtag:name|ucfirst}, {trans:PLEASE_CONFIRM_SUB}', '<div style=\"text-align: center; width: 100%; background-color: #ffffff;\">\r\n			<table style=\"text-align:justify; margin:auto; background-color:#ebebeb; border:1px solid #e7e7e7\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"600\" align=\"center\" bgcolor=\"#ebebeb\">\r\n			<tbody>\r\n			<tr style=\"line-height: 0px;\">\r\n			<td style=\"line-height: 0px;\" height=\"38px\"><img src=\"media/com_acymailing/templates/newsletter-4/top.png\" border=\"0\" alt=\" - - - \" /></td>\r\n			</tr>\r\n			<tr>\r\n			<td style=\"text-align:center\" width=\"600\">\r\n			<table style=\"margin:auto;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"520\">\r\n			<tbody>\r\n			<tr>\r\n			<td style=\"background-color: #ffffff; border: 1px solid #dbdbdb; padding: 20px; width: 500px; margin: 15px auto; text-align: left;\">\r\n			<h1>Hello {subtag:name|ucfirst},</h1>\r\n			<p>{trans:CONFIRM_MSG}<br /><br />{trans:CONFIRM_MSG_ACTIVATE}</p>\r\n			<br />\r\n			<p style=\"text-align:center;\"><strong>{confirm}{trans:CONFIRM_SUBSCRIPTION}{/confirm}</strong></p>\r\n			</td>\r\n			</tr>\r\n			</tbody>\r\n			</table>\r\n			</td>\r\n			</tr>\r\n			<tr style=\"line-height: 0px;\">\r\n			<td style=\"line-height: 0px;\" height=\"40px\"><img src=\"media/com_acymailing/templates/newsletter-4/bottom.png\" border=\"0\" alt=\" - - - \" /></td>\r\n			</tr>\r\n			</tbody>\r\n			</table>\r\n			</div>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'confirmation', NULL, 1, 1, NULL, NULL, 'a:3:{s:6:\"action\";s:7:\"confirm\";s:13:\"actionbtntext\";s:28:\"{trans:CONFIRM_SUBSCRIPTION}\";s:9:\"actionurl\";s:19:\"{confirm}{/confirm}\";}', NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(9, 'AcyMailing Cron Report {mainreport}', '<p>{report}</p><p>{detailreport}</p>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'report', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(10, 'Modify your subscription', '<p>Hello {subtag:name}, </p><p>You requested some changes on your subscription,</p><p>Please {modify}click here{/modify} to be identified as the owner of this account and then modify your subscription.</p>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'notification', 0, NULL, 'modif', NULL, 1, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL),
(11, '{joomlacontent:current| type:title}', '<div style=\"text-align: center; width: 100%; background-color:#ffffff;\">\r\n		<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" style=\"text-align: justify; margin: auto; width: 600px;\">\r\n			<tbody>\r\n				<tr class=\"acyeditor_delete\" style=\"line-height: 0px;\" id=\"zone_2\">\r\n					<td class=\"w600\" colspan=\"5\" style=\"background-color: #69b4c0;\" valign=\"bottom\" width=\"600\" id=\"zone_3\"><img id=\"zone_29\" alt=\" - - - \" border=\"0\" src=\"http://localhost/joomla/master-b3-t3_update2/master//media/com_acymailing/templates/newsletter-4/images/top.png\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\" id=\"zone_4\">\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_5\"></td>\r\n					<td class=\"w520 acyeditor_text\" colspan=\"3\" height=\"80\" style=\"text-align: left; background-color: #ebebeb;\" width=\"520\" id=\"zone_6\"><strong>​</strong>​​​​​​​​<img alt=\"-\" border=\"0\" src=\"http://localhost/joomla/master-b3-t3_update2/master//media/com_acymailing/templates/newsletter-4/images/message_icon.png\" style=\"float: left; margin-right: 10px;\">\r\n						<h3>{joomlacontent:current| type:title}<span style=\"display: none;\">&nbsp;</span></h3>\r\n					</td>\r\n					<td class=\"acyeditor_picture w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_7\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\" id=\"zone_8\">\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_9\"></td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_10\"></td>\r\n					<td class=\"w480\" height=\"20\" style=\"background-color: #fff;\" width=\"480\" id=\"zone_11\"></td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_12\"></td>\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_13\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\" id=\"zone_14\">\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_15\"></td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_16\"></td>\r\n					<td class=\"w480 pict acyeditor_text\" style=\"background-color: #fff; text-align: left;\" width=\"480\" id=\"zone_17\">{joomlacontent:current| type:intro| format:TOP_LEFT| pict:1| link}</td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_18\"></td>\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_19\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\" id=\"zone_20\">\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_21\"></td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_22\"></td>\r\n					<td class=\"w480\" height=\"20\" style=\"background-color: #fff;\" width=\"480\" id=\"zone_23\"></td>\r\n					<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\" id=\"zone_24\"></td>\r\n					<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\" id=\"zone_25\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\" style=\"line-height: 0px;\" id=\"zone_26\">\r\n					<td class=\"w600\" colspan=\"5\" style=\"background-color: #ebebeb;\" width=\"600\" id=\"zone_27\"><img id=\"zone_31\" alt=\" - - - \" border=\"0\" src=\"http://localhost/joomla/master-b3-t3_update2/master//media/com_acymailing/templates/newsletter-4/images/bottom.png\"></td>\r\n				</tr>\r\n			</tbody>\r\n		</table>\r\n		</div>', '', 1, NULL, NULL, NULL, NULL, NULL, NULL, 'article', 0, NULL, 'send-in-article', NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, NULL, '', NULL, NULL, NULL, NULL);

DROP TABLE IF EXISTS `#__acymailing_queue`;
CREATE TABLE IF NOT EXISTS `#__acymailing_queue` (
  `senddate` int(10) UNSIGNED NOT NULL,
  `subid` int(10) UNSIGNED NOT NULL,
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  `priority` tinyint(3) UNSIGNED DEFAULT '3',
  `try` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `paramqueue` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`subid`,`mailid`),
  KEY `listingindex` (`senddate`,`subid`),
  KEY `mailidindex` (`mailid`),
  KEY `orderingindex` (`priority`,`senddate`,`subid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_rules`;
CREATE TABLE IF NOT EXISTS `#__acymailing_rules` (
  `ruleid` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `ordering` smallint(6) DEFAULT NULL,
  `regex` text NOT NULL,
  `executed_on` text NOT NULL,
  `action_message` text NOT NULL,
  `action_user` text NOT NULL,
  `published` tinyint(3) UNSIGNED NOT NULL,
  PRIMARY KEY (`ruleid`),
  KEY `ordering` (`published`,`ordering`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_stats`;
CREATE TABLE IF NOT EXISTS `#__acymailing_stats` (
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  `senthtml` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `senttext` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `senddate` int(10) UNSIGNED NOT NULL,
  `openunique` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `opentotal` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `bounceunique` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `fail` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `clicktotal` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `clickunique` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `unsub` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `forward` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `bouncedetails` text,
  PRIMARY KEY (`mailid`),
  KEY `senddateindex` (`senddate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_subscriber`;
CREATE TABLE IF NOT EXISTS `#__acymailing_subscriber` (
  `subid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `email` varchar(200) NOT NULL,
  `userid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `name` varchar(250) NOT NULL DEFAULT '',
  `created` int(10) UNSIGNED DEFAULT NULL,
  `confirmed` tinyint(4) NOT NULL DEFAULT '0',
  `enabled` tinyint(4) NOT NULL DEFAULT '1',
  `accept` tinyint(4) NOT NULL DEFAULT '1',
  `ip` varchar(100) DEFAULT NULL,
  `html` tinyint(4) NOT NULL DEFAULT '1',
  `key` varchar(250) DEFAULT NULL,
  `confirmed_date` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `confirmed_ip` varchar(100) DEFAULT NULL,
  `lastopen_date` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lastopen_ip` varchar(100) DEFAULT NULL,
  `lastclick_date` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lastsent_date` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `source` varchar(50) NOT NULL DEFAULT '',
  `filterflags` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`subid`),
  UNIQUE KEY `email` (`email`),
  KEY `userid` (`userid`),
  KEY `queueindex` (`enabled`,`accept`,`confirmed`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_subscriber` (`subid`, `email`, `userid`, `name`, `created`, `confirmed`, `enabled`, `accept`, `ip`, `html`, `key`, `confirmed_date`, `confirmed_ip`, `lastopen_date`, `lastopen_ip`, `lastclick_date`, `lastsent_date`, `source`, `filterflags`) VALUES
(1, 'admin@admin.com', 787, 'Super User', 1414757087, 1, 1, 1, NULL, 1, NULL, 0, NULL, 0, NULL, 0, 0, '', ''),
(2, 'demo@demolink.org', 846, 'Demo User', 1350460572, 1, 1, 1, NULL, 1, NULL, 0, NULL, 0, NULL, 0, 0, '', ''),
(3, 'lorem_ipsum@demolink.org', 847, 'Lorem Ipsum', 1418120944, 1, 1, 1, '192.168.9.17', 1, 'VgqgGnB4hRm6xz', 1418121419, '192.168.9.17', 0, NULL, 0, 0, 'joomla', ''),
(4, 'dolor_sit@demolink.org', 848, 'Dolor Sit', 1418121448, 1, 1, 1, '192.168.9.17', 1, 'GrHSwPnkMc0MCT', 1418121459, '192.168.9.17', 0, NULL, 0, 0, 'joomla', ''),
(5, 'rwrw2@1312.aa', 0, 'Rwrw', 1418218543, 0, 1, 1, '192.168.9.125', 1, 'jcRABK1Y1ZSxa9', 0, NULL, 0, NULL, 0, 0, '', ''),
(6, 'admin@admin.co', 0, 'Admin', 1427376525, 0, 1, 1, '192.168.9.17', 1, 'bywCJIRslYdTAD', 0, NULL, 0, NULL, 0, 0, '', ''),
(7, 'm@m.com', 0, 'M', 1443442316, 0, 1, 1, '192.168.9.17', 1, 'XzmOX7h6mH83Cx', 0, NULL, 0, NULL, 0, 0, '', ''),
(8, 'as@as.cxom', 0, 'As', 1466683696, 0, 1, 1, '192.168.9.155', 1, 'VQvZj62Cnyia8z', 0, NULL, 0, NULL, 0, 0, '', ''),
(9, 'asgas@asd.com', 0, 'sad', 1517242706, 0, 1, 1, '127.0.0.1', 1, 'TiE9eySsrjDhyx', 0, NULL, 0, NULL, 0, 0, 'module_279', ''),
(10, 'xfd@dfg.dswer', 849, 'gfhgfh', 1532357994, 0, 0, 1, '192.168.9.55', 1, 'ddyg583iqgydFx', 0, NULL, 0, NULL, 0, 0, 'joomla', '');

DROP TABLE IF EXISTS `#__acymailing_tag`;
CREATE TABLE IF NOT EXISTS `#__acymailing_tag` (
  `tagid` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `userid` int(10) UNSIGNED DEFAULT NULL,
  PRIMARY KEY (`tagid`),
  KEY `useridindex` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_tagmail`;
CREATE TABLE IF NOT EXISTS `#__acymailing_tagmail` (
  `tagid` smallint(5) UNSIGNED NOT NULL,
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  PRIMARY KEY (`tagid`,`mailid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_template`;
CREATE TABLE IF NOT EXISTS `#__acymailing_template` (
  `tempid` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(250) DEFAULT NULL,
  `description` text,
  `body` longtext,
  `altbody` longtext,
  `created` int(10) UNSIGNED DEFAULT NULL,
  `published` tinyint(4) NOT NULL DEFAULT '1',
  `premium` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` smallint(5) UNSIGNED DEFAULT '0',
  `namekey` varchar(50) NOT NULL,
  `styles` text,
  `subject` varchar(250) DEFAULT NULL,
  `stylesheet` text,
  `fromname` varchar(250) DEFAULT NULL,
  `fromemail` varchar(250) DEFAULT NULL,
  `replyname` varchar(250) DEFAULT NULL,
  `replyemail` varchar(250) DEFAULT NULL,
  `thumb` varchar(250) DEFAULT NULL,
  `readmore` varchar(250) DEFAULT NULL,
  `access` varchar(250) NOT NULL DEFAULT 'all',
  `category` varchar(250) NOT NULL DEFAULT '',
  `header` longtext,
  PRIMARY KEY (`tempid`),
  UNIQUE KEY `namekey` (`namekey`),
  KEY `orderingindex` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO `#__acymailing_template` (`tempid`, `name`, `description`, `body`, `altbody`, `created`, `published`, `premium`, `ordering`, `namekey`, `styles`, `subject`, `stylesheet`, `fromname`, `fromemail`, `replyname`, `replyemail`, `thumb`, `readmore`, `access`, `category`, `header`) VALUES
(1, 'Notification template', '', '<div style=\"text-align: center; width: 100%; background-color:#ffffff;\">\r\n<div class=\"acymailing_online acyeditor_delete acyeditor_text\" style=\"text-align:center\">{readonline}This email contains graphics, so if you don\'t see them, view it in your browser{/readonline}</div>\r\n\r\n<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" style=\"text-align: justify; margin: auto; width:600px\">\r\n	<tbody class=\"acyeditor_sortable\">\r\n		<tr style=\"line-height: 0px;\" class=\"acyeditor_delete\">\r\n			<td class=\"w600\" colspan=\"5\" style=\"background-color: #69b4c0;\" valign=\"bottom\" width=\"600\"><img alt=\" - - - \" src=\"media/com_acymailing/templates/newsletter-4/images/top.png\" /></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n			<td class=\"acyeditor_text w520\" colspan=\"3\" height=\"80\" style=\"text-align: left; background-color: rgb(235, 235, 235);\" width=\"520\"><img alt=\"-\" src=\"media/com_acymailing/templates/newsletter-4/images/message_icon.png\" style=\"float:left; margin-right:10px;\" />\r\n				<h3>Topic of your message</h3>\r\n\r\n				<h4>Subtitle for your message</h4>\r\n			</td>\r\n			<td class=\"acyeditor_picture w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"w480\" height=\"20\" style=\"background-color:#fff;\" width=\"480\"></td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"acyeditor_text w480 pict\" style=\"background-color:#fff; text-align: left;\" width=\"480\">\r\n			<h1>Dear {subtag:name},</h1>\r\n			Your message here...<br />\r\n			</td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"w480\" height=\"20\" style=\"background-color:#fff;\" width=\"480\"></td>\r\n			<td class=\"w20\" style=\"background-color: #fff;\" width=\"20\"></td>\r\n			<td class=\"w40\" style=\"background-color: #ebebeb;\" width=\"40\"></td>\r\n		</tr>\r\n		<tr style=\"line-height: 0px;\" class=\"acyeditor_delete\">\r\n			<td class=\"w600\" colspan=\"5\" style=\"background-color:#ebebeb;\" width=\"600\"><img alt=\" - - - \" src=\"media/com_acymailing/templates/newsletter-4/images/bottom.png\" /></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n\r\n<div class=\"acyeditor_delete acyeditor_text\" style=\"text-align:center\">Not interested any more? {unsubscribe}Unsubscribe{/unsubscribe}</div>\r\n</div>', '', NULL, 1, 0, 1, 'newsletter-4', 'a:10:{s:6:\"tag_h1\";s:76:\"color:#393939 !important; font-size:14px; font-weight:bold; margin:10px 0px;\";s:6:\"tag_h2\";s:106:\"color: #309fb3 !important; font-size: 14px; font-weight: normal; text-align:left; margin:0px; padding:0px;\";s:6:\"tag_h3\";s:144:\"color: #393939 !important; font-size: 18px; font-weight: bold; text-align:left; margin:0px; padding-bottom:5px; border-bottom:1px solid #bdbdbd;\";s:6:\"tag_h4\";s:117:\"color: #309fb3 !important; font-size: 14px; font-weight: bold; text-align:left; margin:0px; padding: 5px 0px 0px 0px;\";s:5:\"tag_a\";s:71:\"color:#309FB3; text-decoration:none; font-style:italic; cursor:pointer;\";s:19:\"acymailing_readmore\";s:90:\"font-size: 12px; color: #fff; background-color:#309fb3; font-weight:bold; padding:3px 5px;\";s:17:\"acymailing_online\";s:52:\"color:#a3a3a3; text-decoration:none; font-size:11px;\";s:16:\"acymailing_unsub\";s:52:\"color:#a3a3a3; text-decoration:none; font-size:11px;\";s:8:\"color_bg\";s:7:\"#ffffff\";s:18:\"acymailing_content\";s:19:\"text-align:justify;\";}', NULL, 'div,table,p, td{font-family: Verdana, Arial, Helvetica, sans-serif; font-size:12px; text-align:justify; color:#8c8c8c; margin:0px}\r\ndiv.info{text-align:center;padding:10px;font-size:11px;color:#a3a3a3;}\r\n\r\n@media (min-width:10px){\r\n	table[class=w600], td[class=w600] { width: 320px !important;}\r\n	table[class=w520], td[class=w520] { width: 280px !important;}\r\n	table[class=w480], td[class=w480] { width: 260px !important;}\r\n	td[class=w40] { width: 20px !important;}\r\n	td[class=w20] { width: 10px !important;}\r\n	.w600 img {max-width:320px; height:auto !important}\r\n	.w480 img {max-width:260px; height:auto !important;}\r\n}\r\n\r\n@media (min-width:480px) {\r\n	table[class=w600], td[class=w600] { width: 480px !important;}\r\n	table[class=w520], td[class=w520] { width: 440px !important;}\r\n	table[class=w480], td[class=w480] { width: 420px !important;}\r\n	td[class=w40] { width: 20px !important;}\r\n	td[class=w20] { width: 10px !important;}\r\n	.w600 img {max-width:480px; height:auto !important}\r\n	.w480 img {max-width:420px;  height:auto !important;}\r\n}\r\n@media (min-width:600px){\r\n	table[class=w600], td[class=w600] { width: 600px !important;}\r\n	table[class=w520], td[class=w520] { width: 520px !important;}\r\n	table[class=w480], td[class=w480] { width: 480px !important;}\r\n	td[class=w40] { width40px !important;}\r\n	td[class=w20] { width: 20px !important;}\r\n	.w600 img {max-width:600px; height:auto !important}\r\n	.w480 img {max-width:480px;  height:auto !important;}\r\n}\r\n', NULL, NULL, NULL, NULL, 'media/com_acymailing/templates/newsletter-4/newsletter-4.png', '', 'all', '', NULL),
(2, 'Newspaper', '', '<div align=\"center\" style=\"width:100%; background-color:#454545; padding-bottom:20px; color:#ffffff;\">\r\n<div class=\"acymailing_online acyeditor_delete acyeditor_text\">{readonline}This e-mail contains graphics, if you don\'t see them <strong>» view it online.</strong>{/readonline}</div>\r\n\r\n<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" style=\"margin:auto; background-color:#ffffff; color:#454545;\" width=\"600\">\r\n		<tr>\r\n			<td class=\"w600\">\r\n			<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" width=\"600\">\r\n					<tr class=\"acyeditor_delete\" >\r\n						<td class=\"w30\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n						<td class=\"acyeditor_text w540\" style=\"font-family:Times New Roman, Times, serif; background-color:#ffffff; text-align:left\" width=\"540\">&nbsp;\r\n						<h1><img alt=\"logo\" src=\"media/com_acymailing/templates/newsletter-5/images/logo.png\" style=\"float: right; width: 107px; height: 70px;\" /></h1>\r\n\r\n						<h1>Your title here</h1>\r\n\r\n						<h3>your subtitle</h3>\r\n						</td>\r\n						<td class=\"w30\" style=\"line-height:0px; background-color:#ffffff\" width=\"30\"></td>\r\n					</tr>\r\n					<tr class=\"acyeditor_delete\">\r\n						<td class=\"w600\" colspan=\"3\" style=\"line-height:0px; background-color:#e4e4e4\" valign=\"top\" width=\"600\"><img alt=\"---\" src=\"media/com_acymailing/templates/newsletter-5/images/header.png\" /></td>\r\n					</tr>\r\n					<tr class=\"acyeditor_delete\">\r\n						<td class=\"acyeditor_picture w600\" colspan=\"3\" style=\"line-height:0px; background-color:#ffffff\" valign=\"top\" width=\"600\"><img alt=\"banner\" src=\"media/com_acymailing/templates/newsletter-5/images/banner.png\" /></td>\r\n					</tr>\r\n					<tr class=\"acyeditor_delete\">\r\n						<td class=\"w600\" colspan=\"3\" style=\"line-height:0px;\" valign=\"top\" width=\"600\"><img alt=\"---\" src=\"media/com_acymailing/templates/newsletter-5/images/separator.png\" /></td>\r\n					</tr>\r\n					<tr>\r\n						<td class=\"w30\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n						<td class=\"acyeditor_text w540\" style=\"text-align:justify; color:#575757; font-family:Times New Roman, Times, serif; font-size:13px; background-color:#ffffff\" width=\"540\">\r\n							<div>This issue will present the 5 last articles.<br />\r\n							{tableofcontents}<br />\r\n							{autocontent:|max:5|order:id,DESC|type:intro|link|pict:1}</div>\r\n						</td>\r\n						<td class=\"w30\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n					</tr>\r\n					<tr style=\"line-height: 0px;\">\r\n						<td class=\"w600\" colspan=\"3\" style=\"background-color:#ffffff\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/newsletter-5/images/footer1.png\" width=\"600\" /></td>\r\n					</tr>\r\n					<tr>\r\n						<td class=\"acyfooter acyeditor_text w600\" colspan=\"3\" height=\"25\" style=\"text-align:center; background-color:#ebebeb;  color:#454545; font-family:Times New Roman, Times, serif; font-size:13px\" width=\"600\"><a href=\"#\">www.mywebsite.com</a> | <a href=\"#\">contact</a> | <a href=\"#\">Facebook</a> | <a href=\"#\">Twitter</a></td>\r\n					</tr>\r\n					<tr style=\"line-height: 0px;\">\r\n						<td class=\"w600\" colspan=\"3\" style=\"background-color:#454545;\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/newsletter-5/images/footer2.png\" width=\"600\" /></td>\r\n					</tr>\r\n			</table>\r\n			</td>\r\n		</tr>\r\n</table>\r\n\r\n<div class=\"acymailing_unsub acyeditor_delete acyeditor_text\">{unsubscribe}If you\'re not interested any more <strong>» unsubscribe</strong>{/unsubscribe}</div>\r\n</div>\r\n', '', NULL, 1, 0, 2, 'newsletter-5', 'a:10:{s:6:\"tag_h1\";s:71:\"color:#454545 !important; font-size:24px; font-weight:bold; margin:0px;\";s:6:\"tag_h2\";s:145:\"color:#b20000 !important; font-size:18px; font-weight:bold; margin:0px; margin-bottom:10px; padding-bottom:4px; border-bottom: 1px solid #d6d6d6;\";s:6:\"tag_h3\";s:76:\"color:#b20101 !important; font-weight:bold; font-size:18px; margin:10px 0px;\";s:6:\"tag_h4\";s:67:\"color:#e52323 !important; font-weight:bold; margin:0px; padding:0px\";s:5:\"tag_a\";s:65:\"cursor:pointer; color:#9d0000; text-decoration:none; border:none;\";s:19:\"acymailing_readmore\";s:152:\"cursor:pointer; color:#ffffff; background-color:#9d0000; border-top:1px solid #9d0000; border-bottom:1px solid #9d0000; padding:3px 5px; font-size:13px;\";s:17:\"acymailing_online\";s:148:\"color:#dddddd; text-decoration:none; font-size:13px; margin:10px; text-align:center; font-family:Times New Roman, Times, serif; padding-bottom:10px;\";s:8:\"color_bg\";s:7:\"#454545\";s:18:\"acymailing_content\";s:0:\"\";s:16:\"acymailing_unsub\";s:131:\"color:#dddddd; text-decoration:none; font-size:13px; text-align:center; font-family:Times New Roman, Times, serif; padding-top:10px\";}', NULL, '.acyfooter a{\r\n	color:#454545;\r\n}\r\n.dark{\r\n	color:#454545;\r\n	font-weight:bold;\r\n}\r\ndiv,table,p, td{font-family:\"Times New Roman\", Times, serif;font-size:13px;color:#575757;}\r\n\r\n\r\n\r\n@media (min-width:10px){\r\n	table[class=w600], td[class=w600] { width:320px !important; }\r\n	table[class=w540], td[class=w540] { width:260px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img {max-width:320px; height:auto !important; }\r\n	.w540 img {max-width:260px; height:auto !important; }\r\n}\r\n\r\n@media (min-width: 480px){\r\n	table[class=w600], td[class=w600] { width:480px !important; }\r\n	table[class=w540], td[class=w540] { width:420px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img {max-width:480px; height:auto !important; }\r\n	.w540 img {max-width:420px; height:auto !important; }\r\n}\r\n\r\n@media (min-width:600px){\r\n	table[class=w600], td[class=w600] { width:600px !important; }\r\n	table[class=w540], td[class=w540] { width:540px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img     {max-width:600px; height:auto !important; }\r\n	.w540 img {max-width:540px; height:auto !important; }\r\n}\r\n', NULL, NULL, NULL, NULL, 'media/com_acymailing/templates/newsletter-5/newsletter-5.png', '', 'all', '', NULL),
(3, 'Build Bio', '', '<div align=\"center\" style=\"width:100%; background-color:#3c3c3c; padding-bottom:20px; color:#ffffff;\">\r\n<div class=\"acymailing_online acyeditor_delete acyeditor_text\">{readonline}This e-mail contains graphics, if you don\'t see them <strong>» view it online.</strong>{/readonline}</div>\r\n\r\n<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" style=\"margin:auto; background-color:#ffffff; color:#575757;\" width=\"600\">\r\n	<tbody class=\"acyeditor_sortable\">\r\n		<tr>\r\n			<td>\r\n			<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" width=\"600\">\r\n				<tr class=\"acyeditor_delete\">\r\n					<td class=\"w600\" colspan=\"3\" style=\"line-height:0px; background-color:#eeeeee\" valign=\"bottom\" width=\"600\"><img alt=\"mail\" height=\"41\" src=\"media/com_acymailing/templates/newsletter-6/images/header.png\" width=\"600\" /></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\">\r\n					<td class=\"w30\" style=\"color:#ffffff;\" width=\"30\"></td>\r\n					<td class=\"acyeditor_picture w540\" style=\"line-height:0px; background-color:#ffffff; text-align:center\" width=\"540\"><img alt=\"\" src=\"media/com_acymailing/templates/newsletter-6/images/banner.png\" style=\"width: 540px; height: 122px;\" /></td>\r\n					<td class=\"w30\" height=\"122\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n				</tr>\r\n				<tr class=\"acyeditor_delete\">\r\n					<td class=\"w30\" style=\"background-color:#b9cf00; color:#ffffff;\" width=\"30\"></td>\r\n					<td class=\"acyeditor_text w540\" height=\"25\" style=\"text-align:right; background-color:#b9cf00; color:#ffffff;\" width=\"540\"><span class=\"hide\">Newsletter</span> {date:3}</td>\r\n					<td class=\"w30\" style=\"background-color:#b9cf00; color:#ffffff;\" width=\"30\"></td>\r\n				</tr>\r\n				<tr>\r\n					<td class=\"w600\" colspan=\"3\" height=\"25\" style=\"background-color:#ffffff\" width=\"600\"></td>\r\n				</tr>\r\n				<tr>\r\n					<td class=\"w30\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n					<td class=\"acyeditor_text w540\" style=\"text-align:justify; color:#575757; background-color:#ffffff\" width=\"540\"><span class=\"intro\">Hello {subtag:name},</span><br />\r\n					<br />\r\n					Your introduction text here\r\n					<br />\r\n					<h2>Your title</h2>\r\n					<strong>Your catchphrase</strong><br />\r\n					Your content here <a href=\"#\">with some link</a><br />\r\n					<br />\r\n					More content<br />\r\n					<br />\r\n					<span class=\"acymailing_readmore\">Read More</span>\r\n\r\n					<h2>Another title</h2>\r\n					<img alt=\"picture\" height=\"160\" src=\"media/com_acymailing/templates/newsletter-6/images/picture.png\" style=\"float:left;\" width=\"193\" /> <strong>Another catchphrase</strong> Some content and <a href=\"#\">another link</a><br />\r\n					<br />\r\n					More content<br />\r\n					<br />\r\n					<span class=\"acymailing_readmore\">Read More</span></td>\r\n					<td class=\"w30\" style=\"background-color:#ffffff\" width=\"30\"></td>\r\n				</tr>\r\n			</table>\r\n			</td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td>\r\n			<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" width=\"600\">\r\n				<tr style=\"line-height: 0px;\">\r\n					<td class=\"w600\" colspan=\"3\" style=\"line-height:0px; background-color:#efefef;\" valign=\"top\" width=\"600\"><img alt=\"--\" height=\"18\" src=\"media/com_acymailing/templates/newsletter-6/images/footer1.png\" width=\"600\" /></td>\r\n				</tr>\r\n				<tr>\r\n					<td class=\"w30\" height=\"20\" style=\"line-height:0px; background-color:#efefef;\" width=\"30\"></td>\r\n					<td class=\"acyfooter acyeditor_text w540\" style=\"text-align:right; background-color:#efefef; color:#575757;\" width=\"540\"><a href=\"#\">www.mywebsite.com</a> | <a href=\"#\">Contact</a><a href=\"#\"><img alt=\"message\" class=\"hide\" src=\"media/com_acymailing/templates/newsletter-6/images/mail.png\" style=\"border: medium none; width: 35px; height: 20px;\" /></a></td>\r\n					<td class=\"w30\" height=\"20\" style=\"line-height:0px; background-color:#efefef;\" width=\"30\"></td>\r\n				</tr>\r\n				<tr style=\"line-height: 0px;\">\r\n					<td class=\"w600\" colspan=\"3\" style=\"background-color:#efefef; line-height:0px;\" valign=\"top\" width=\"600\"><img alt=\"--\" height=\"24\" src=\"media/com_acymailing/templates/newsletter-6/images/footer2.png\" width=\"600\" /></td>\r\n				</tr>\r\n			</table>\r\n			</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n\r\n<div class=\"acymailing_unsub acyeditor_delete acyeditor_text\" >{unsubscribe}If you\'re not interested any more <strong>» unsubscribe</strong>{/unsubscribe}</div>\r\n</div>', '', NULL, 1, 0, 3, 'newsletter-6', 'a:9:{s:6:\"tag_h1\";s:69:\"font-weight:bold; font-size:14px;color:#3c3c3c !important;margin:0px;\";s:6:\"tag_h2\";s:129:\"color:#b9cf00 !important; font-size:14px; font-weight:bold; margin-top:20px; border-bottom:1px solid #d6d6d6; padding-bottom:4px;\";s:6:\"tag_h3\";s:149:\"color:#7e7e7e !important; font-size:14px; font-weight:bold; margin:20px 0px 0px 0px; border-bottom:1px solid #d6d6d6; padding-bottom:0px 0px 4px 0px;\";s:6:\"tag_h4\";s:84:\"color:#879700 !important; font-size:12px; font-weight:bold; margin:0px; padding:0px;\";s:8:\"color_bg\";s:7:\"#3c3c3c\";s:5:\"tag_a\";s:65:\"cursor:pointer; color:#a2b500; text-decoration:none; border:none;\";s:17:\"acymailing_online\";s:91:\"color:#dddddd; text-decoration:none; font-size:11px; text-align:center; padding-bottom:10px\";s:16:\"acymailing_unsub\";s:88:\"color:#dddddd; text-decoration:none; font-size:11px; text-align:center; padding-top:10px\";s:19:\"acymailing_readmore\";s:73:\"cursor:pointer; color:#ffffff; background-color:#b9cf00; padding:3px 5px;\";}', NULL, 'table, div, p, td{\r\n	font-family: Verdana, Arial, Helvetica, sans-serif;\r\n	font-size:11px;\r\n	color:#575757;\r\n}\r\n.intro{\r\n	font-weight:bold;\r\n	font-size:12px;}\r\n\r\n.acyfooter a{\r\n	color:#575757;}\r\n\r\n@media (min-width: 10px){\r\n	table[class=w600], td[class=w600]  { width:320px !important; }\r\n	table[class=w540], td[class=w540]  { width:260px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img{max-width:320px; height:auto !important}\r\n	.w540 img{max-width:260px; height:auto !important}\r\n}\r\n\r\n@media (min-width: 480px){\r\n	table[class=w600], td[class=w600]  { width:480px !important; }\r\n	table[class=w540], td[class=w540]  { width:420px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img{max-width:480px; height:auto !important}\r\n	.w540 img{max-width:420px; height:auto !important}\r\n}\r\n\r\n@media (min-width:600px){\r\n	table[class=w600], td[class=w600]  { width:600px !important; }\r\n	table[class=w540], td[class=w540]  { width:540px !important; }\r\n	td[class=w30] { width:30px !important; }\r\n	.w600 img{max-width:600px; height:auto !important}\r\n	.w540 img{max-width:540px; height:auto !important}\r\n}\r\n', NULL, NULL, NULL, NULL, 'media/com_acymailing/templates/newsletter-6/newsletter-6.png', '', 'all', '', NULL),
(4, 'Technology', '', '<div align=\"center\" style=\"width:100%; background-color:#575757; padding-bottom:20px; color:#999999;\">\r\n<table align=\"center\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"w600\" style=\"background-color:#fff; color:#999999; margin:auto\" width=\"600\">\r\n	<tbody class=\"acyeditor_sortable\">\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w30\" style=\"background-color:#575757\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text w540\" style=\"text-align:right; color:#d2d1d1; background-color:#575757\" width=\"540\"><span class=\"acymailing_online\">{readonline}If you can\'t see this e-mail properly, <span style=\"text-decoration:underline\">view it online</span>{/readonline}</span></td>\r\n			<td class=\"w30\" style=\"background-color:#575757\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"acyeditor_picture w600\" colspan=\"3\" style=\"line-height:0px; background-color:#575757\" valign=\"bottom\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/technology_resp/images/shadowtop.jpg\" /></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"acyeditor_picture w600\" colspan=\"3\" style=\"line-height:0px; background-color:#f5f5f5\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/technology_resp/images/top.jpg\" /></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w30\" height=\"32\" style=\"background-color:#f5f5f5; border-bottom:1px solid #ddd\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text links w540\" style=\"background-color:#f5f5f5; border-bottom:1px solid #ddd; text-align:right; color:#ababab\" width=\"540\"><a href=\"#\"><img alt=\"mail\" src=\"media/com_acymailing/templates/technology_resp/images/mail.jpg\" style=\"float:right; border:none\" /></a> Newsletter {mailid} | {date:%B %Y} |&nbsp; <a href=\"#\">www.acyba.com</a> |</td>\r\n			<td class=\"w30\" height=\"32\" style=\"background-color:#f5f5f5; border-bottom:1px solid #ddd\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w600\" colspan=\"3\" height=\"16\" width=\"600\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w30\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text w540\" width=\"540\"><img alt=\"picture\" src=\"media/com_acymailing/templates/technology_resp/images/pic1.jpg\" style=\"float:right\" />\r\n			<h1>Your title !</h1>\r\n\r\n			<h3>Your catchphrase</h3>\r\n			Your introduction content here</td>\r\n			<td class=\"w30\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n			<td class=\"acyeditor_picture w540\" style=\"background-color:#fafafa; line-height:0px\" width=\"540\"><img alt=\"---\" src=\"media/com_acymailing/templates/technology_resp/images/separator1.jpg\" /></td>\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\">\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text w540\" style=\"background-color:#fafafa; color:#999999\" width=\"540\">\r\n			<h2>Your subtitle</h2>\r\n			<img alt=\"picture\" src=\"media/com_acymailing/templates/technology_resp/images/pic2.jpg\" style=\"float:left\" />\r\n			<h3>Your catchphrase</h3>\r\n			Your content here<br />\r\n			<a href=\"#\">Some link</a> and some content<br />\r\n			<br />\r\n			<img alt=\"buy this product\" src=\"media/com_acymailing/templates/technology_resp/images/buyproduct.jpg\" /><br />\r\n			<br />\r\n			<br />\r\n			<br />\r\n			&nbsp;\r\n			<h2>Another subtitle</h2>\r\n			<img alt=\"picture\" src=\"media/com_acymailing/templates/technology_resp/images/pic3.jpg\" style=\"float:right\" />\r\n			<h3>Another catchphrase</h3>\r\n			Other content<br />\r\n			<br />\r\n			<img alt=\"buy this product\" src=\"media/com_acymailing/templates/technology_resp/images/buyproduct.jpg\" /></td>\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n			<td class=\"acyeditor_picture w540\" style=\"background-color:#fafafa; line-height:0px\" width=\"540\"><img alt=\"---\" src=\"media/com_acymailing/templates/technology_resp/images/separator2.jpg\" /></td>\r\n			<td class=\"w30\" style=\"background-color:#fafafa\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w600\" colspan=\"3\" height=\"16\" width=\"600\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w30\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text special w540\" style=\"color:#999999\" width=\"540\">\r\n			<h2>Best product of the month</h2>\r\n\r\n			<h3>Lorem ipsum dolor sit amet.</h3>\r\n			Liget, volutpat esvft sem. Praesent auctor posuere orci, sit amet molee. Integer nec scelerisque quam. Lore uctor posum ipsum doLiget, volutpat esvft sem. Praesent auctor posuere orci, sit amet molee. Integer nec scelerisque quam. Lore uctor posum ipsum dolor sit amesent.<br />\r\n			<br />\r\n			<img alt=\"read more\" src=\"media/com_acymailing/templates/technology_resp/images/readmore.jpg\" style=\"border:none\" /></td>\r\n			<td class=\"w30\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w600\" colspan=\"3\" height=\"16\" width=\"600\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w30\" height=\"30\" style=\"background-color:#f5f5f5; border-top:1px solid #ddd\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text w540\" height=\"30\" style=\"background-color:#f5f5f5; border-top:1px solid #ddd; text-align:right; color:#ababab\" valign=\"bottom\" width=\"540\">Follow us | <img alt=\"facebook\" src=\"media/com_acymailing/templates/technology_resp/images/facebook.jpg\" style=\"border:none\" /> <img alt=\"twitter\" src=\"media/com_acymailing/templates/technology_resp/images/twitter.jpg\" style=\"border:none\" /> <img alt=\"pinterest\" src=\"media/com_acymailing/templates/technology_resp/images/pinterest.jpg\" style=\"border:none\" /> <img alt=\"rss\" src=\"media/com_acymailing/templates/technology_resp/images/rss.jpg\" style=\"border:none\" /></td>\r\n			<td class=\"w30\" height=\"30\" style=\"background-color:#f5f5f5; border-top:1px solid #ddd\" width=\"30\"></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"acyeditor_picture w600\" colspan=\"3\" style=\"line-height:0px; background-color:#f5f5f5\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/technology_resp/images/bottom.jpg\" /></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"acyeditor_picture w600\" colspan=\"3\" style=\"line-height:0px; background-color:#575757\" valign=\"bottom\" width=\"600\"><img alt=\"--\" src=\"media/com_acymailing/templates/technology_resp/images/shadowbottom.jpg\" /></td>\r\n		</tr>\r\n		<tr class=\"acyeditor_delete\" >\r\n			<td class=\"w30\" style=\"background-color:#575757\" width=\"30\"></td>\r\n			<td class=\"acyeditor_text w540\" style=\"text-align:right; color:#d2d1d1; background-color:#575757\" width=\"540\"><span class=\"acymailing_unsub\">{unsubscribe}If you don\'t want to receive our news anymore, <span style=\"text-decoration:underline\">unsubscribe</span>{/unsubscribe} </span></td>\r\n			<td class=\"w30\" style=\"background-color:#575757\" width=\"30\"></td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n</div>', '', NULL, 1, 0, 4, 'technology_resp', 'a:9:{s:6:\"tag_h1\";s:104:\"font-size:20px; margin:0px; margin-bottom:15px; padding:0px; font-weight:bold; color:#01bbe5 !important;\";s:6:\"tag_h2\";s:165:\"font-size:12px; font-weight:bold; color:#565656 !important; text-transform:uppercase; margin:10px 0px; padding:0px; padding-bottom:5px; border-bottom:1px solid #ddd;\";s:6:\"tag_h3\";s:104:\"color:#565656 !important; font-weight:bold; font-size:12px; margin:0px; margin-bottom:10px; padding:0px;\";s:6:\"tag_h4\";s:0:\"\";s:8:\"color_bg\";s:7:\"#575757\";s:5:\"tag_a\";s:62:\"cursor:pointer;color:#01bbe5;text-decoration:none;border:none;\";s:17:\"acymailing_online\";s:30:\"color:#d2d1d1; cursor:pointer;\";s:16:\"acymailing_unsub\";s:30:\"color:#d2d1d1; cursor:pointer;\";s:19:\"acymailing_readmore\";s:88:\"cursor:pointer; font-weight:bold; color:#fff; background-color:#01bbe5; padding:2px 5px;\";}', NULL, 'table, div, p , td{\r\n	font-family:Arial, Helvetica, sans-serif;\r\n	font-size:12px;\r\n}\r\np{margin:0px; padding:0px}\r\n\r\n.special h2{font-size:18px;\r\n	margin:0px;\r\n	margin-bottom:15px;\r\n	padding:0px;\r\n	font-weight:bold;\r\n	color:#01bbe5 !important;\r\n	text-transform:none;\r\n	border:none}\r\n\r\n.links a{color:#ababab}\r\n\r\n@media (min-width:10px){\r\n	table[class=w600], td[class=w600] { width:320px !important;}\r\n	table[class=w540], td[class=w540] { width:260px !important;}\r\n	td[class=w30] { width:30px !important;}\r\n	.w600 img {max-width:320px; height:auto !important}\r\n	.w540 img {max-width:260px; height:auto !important}\r\n}\r\n\r\n@media (min-width: 480px){\r\n	table[class=w600], td[class=w600] { width:480px !important;}\r\n	table[class=w540], td[class=w540] { width:420px !important;}\r\n	td[class=w30] { width:30px !important;}\r\n	.w600 img {max-width:480px; height:auto !important}\r\n	.w540 img {max-width:420px; height:auto !important}\r\n}\r\n\r\n@media (min-width:600px){\r\n	table[class=w600], td[class=w600] { width:600px !important;}\r\n	table[class=w540], td[class=w540] { width:540px !important;}\r\n	td[class=w30] { width:30px !important;}\r\n	.w600 img {max-width:600px; height:auto !important}\r\n	.w540 img {max-width:540px; height:auto !important}\r\n}\r\n', NULL, NULL, NULL, NULL, 'media/com_acymailing/templates/technology_resp/thumb.jpg', '', 'all', '', NULL);

DROP TABLE IF EXISTS `#__acymailing_url`;
CREATE TABLE IF NOT EXISTS `#__acymailing_url` (
  `urlid` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `url` text NOT NULL,
  PRIMARY KEY (`urlid`),
  KEY `url` (`url`(250))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_urlclick`;
CREATE TABLE IF NOT EXISTS `#__acymailing_urlclick` (
  `urlid` int(10) UNSIGNED NOT NULL,
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  `click` smallint(5) UNSIGNED NOT NULL DEFAULT '0',
  `subid` int(10) UNSIGNED NOT NULL,
  `date` int(10) UNSIGNED NOT NULL,
  `ip` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`urlid`,`mailid`,`subid`),
  KEY `dateindex` (`date`),
  KEY `mailidindex` (`mailid`),
  KEY `subidindex` (`subid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__acymailing_userstats`;
CREATE TABLE IF NOT EXISTS `#__acymailing_userstats` (
  `mailid` mediumint(8) UNSIGNED NOT NULL,
  `subid` int(10) UNSIGNED NOT NULL,
  `html` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `sent` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `senddate` int(10) UNSIGNED NOT NULL,
  `open` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `opendate` int(11) NOT NULL,
  `bounce` tinyint(4) NOT NULL DEFAULT '0',
  `fail` tinyint(4) NOT NULL DEFAULT '0',
  `ip` varchar(100) DEFAULT NULL,
  `browser` varchar(255) DEFAULT NULL,
  `browser_version` tinyint(3) UNSIGNED DEFAULT NULL,
  `is_mobile` tinyint(3) UNSIGNED DEFAULT NULL,
  `mobile_os` varchar(255) DEFAULT NULL,
  `user_agent` varchar(255) DEFAULT NULL,
  `bouncerule` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`mailid`,`subid`),
  KEY `senddateindex` (`senddate`),
  KEY `subidindex` (`subid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE IF NOT EXISTS `#__assets` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) UNSIGNED NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=882 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 0, 769, 0, 'root.1', 'Root Asset', '{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(2, 1, 1, 2, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 3, 6, 1, 'com_banners', 'com_banners', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(4, 1, 7, 8, 1, 'com_cache', 'com_cache', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
(5, 1, 9, 10, 1, 'com_checkin', 'com_checkin', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
(6, 1, 11, 12, 1, 'com_config', 'com_config', '{}'),
(7, 1, 13, 18, 1, 'com_contact', 'com_contact', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(8, 1, 19, 302, 1, 'com_content', 'com_content', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
(9, 1, 303, 304, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 305, 306, 1, 'com_installer', 'com_installer', '{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}'),
(11, 1, 307, 308, 1, 'com_languages', 'com_languages', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(12, 1, 309, 310, 1, 'com_login', 'com_login', '{}'),
(13, 1, 311, 312, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 313, 314, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 315, 316, 1, 'com_media', 'com_media', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),
(16, 1, 317, 322, 1, 'com_menus', 'com_menus', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(17, 1, 323, 324, 1, 'com_messages', 'com_messages', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
(18, 1, 325, 506, 1, 'com_modules', 'com_modules', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(19, 1, 507, 510, 1, 'com_newsfeeds', 'com_newsfeeds', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(20, 1, 511, 512, 1, 'com_plugins', 'com_plugins', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(21, 1, 513, 514, 1, 'com_redirect', 'com_redirect', '{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),
(22, 1, 515, 516, 1, 'com_search', 'com_search', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
(23, 1, 517, 518, 1, 'com_templates', 'com_templates', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(24, 1, 519, 522, 1, 'com_users', 'com_users', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(25, 1, 523, 526, 1, 'com_weblinks', 'com_weblinks', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
(26, 1, 527, 528, 1, 'com_wrapper', 'com_wrapper', '{}'),
(27, 8, 20, 29, 2, 'com_content.category.2', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(28, 3, 4, 5, 2, 'com_banners.category.3', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(29, 7, 14, 15, 2, 'com_contact.category.4', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(30, 19, 508, 509, 2, 'com_newsfeeds.category.5', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(31, 25, 524, 525, 2, 'com_weblinks.category.6', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(32, 24, 520, 521, 1, 'com_users.category.7', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(33, 1, 529, 530, 1, 'com_finder', 'com_finder', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
(34, 1, 531, 532, 1, 'com_joomlaupdate', 'com_joomlaupdate', '{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}'),
(35, 1, 533, 534, 1, 'com_tags', 'com_tags', '{\"core.admin\":[],\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(36, 1, 535, 536, 1, 'com_contenthistory', 'com_contenthistory', '{}'),
(37, 1, 537, 538, 1, 'com_ajax', 'com_ajax', '{}'),
(38, 1, 539, 540, 1, 'com_postinstall', 'com_postinstall', '{}'),
(40, 18, 326, 327, 2, 'com_modules.module.2', 'Login', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(41, 18, 328, 329, 2, 'com_modules.module.3', 'Popular Articles', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(42, 18, 330, 331, 2, 'com_modules.module.4', 'Recently Added Articles', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(43, 18, 332, 333, 2, 'com_modules.module.8', 'Toolbar', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(44, 18, 334, 335, 2, 'com_modules.module.9', 'Quick Icons', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(45, 18, 336, 337, 2, 'com_modules.module.10', 'Logged-in Users', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(46, 18, 338, 339, 2, 'com_modules.module.12', 'Admin Menu', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(47, 18, 340, 341, 2, 'com_modules.module.13', 'Admin Submenu', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(48, 18, 342, 343, 2, 'com_modules.module.14', 'User Status', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(49, 18, 344, 345, 2, 'com_modules.module.15', 'Title', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(52, 18, 346, 347, 2, 'com_modules.module.79', 'Multilanguage status', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(53, 18, 348, 349, 2, 'com_modules.module.86', 'Joomla Version', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(54, 18, 350, 351, 2, 'com_modules.module.87', 'Komento activities', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(55, 18, 352, 353, 2, 'com_modules.module.88', 'Komento comments', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(61, 18, 354, 355, 2, 'com_modules.module.93', 'Superfish menu', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(62, 18, 356, 357, 2, 'com_modules.module.94', 'Recent templates', ''),
(63, 1, 541, 542, 1, 'com_kunena', 'com_kunena', '{}'),
(64, 8, 30, 39, 2, 'com_content.category.8', 'Home', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(65, 8, 40, 41, 2, 'com_content.category.9', 'About', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(66, 8, 42, 45, 2, 'com_content.category.10', 'Policies', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(67, 8, 46, 83, 2, 'com_content.category.11', 'Blog', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(70, 67, 47, 50, 3, 'com_content.category.14', 'Recent', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(71, 67, 51, 54, 3, 'com_content.category.15', 'Latest', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(74, 475, 172, 179, 4, 'com_content.category.18', 'Accordions and Toggles', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(81, 342, 109, 122, 3, 'com_content.category.25', 'History', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(82, 342, 123, 142, 3, 'com_content.category.26', 'Team', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(83, 342, 143, 156, 3, 'com_content.category.27', 'FAQs', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(84, 342, 157, 170, 3, 'com_content.category.28', 'Testimonials', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(85, 8, 84, 87, 2, 'com_content.category.29', 'Help', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(91, 66, 43, 44, 3, 'com_content.article.6', 'Privacy policy', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(96, 406, 56, 57, 4, 'com_content.article.11', 'Children\'s Book Exhibition', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(97, 70, 48, 49, 4, 'com_content.article.12', 'Participate in discussion of an important topic', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(98, 71, 52, 53, 4, 'com_content.article.13', 'Improving your confidence and self-defense skills', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(99, 407, 60, 61, 4, 'com_content.article.14', 'Pen & Paintbruh', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(100, 409, 72, 73, 4, 'com_content.article.15', 'Music is now officially proved to have influence on us', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(101, 74, 173, 174, 5, 'com_content.article.16', 'Do you offer replacement parts?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(102, 74, 175, 176, 5, 'com_content.article.17', 'Do you offer delivery services?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(103, 74, 177, 178, 5, 'com_content.article.18', 'Meet Our Experts', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(120, 81, 110, 111, 4, 'com_content.article.35', 'Our first steps on the market', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(121, 81, 112, 113, 4, 'com_content.article.36', 'Continuous innovation and transformation', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(122, 81, 114, 115, 4, 'com_content.article.37', 'Further development', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(123, 81, 116, 117, 4, 'com_content.article.38', 'Company acquisition', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(124, 81, 118, 119, 4, 'com_content.article.39', 'The Hayford was established in 1940 in New York as the National Committee of Investment Companies.', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(125, 81, 120, 121, 4, 'com_content.article.40', 'When we decided to set up our operations 25 years ago, we had a list of principles that we all stood', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(126, 82, 124, 125, 4, 'com_content.article.41', 'Jorinde Voigt', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(127, 82, 126, 127, 4, 'com_content.article.42', 'Allen Jones', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(128, 82, 128, 129, 4, 'com_content.article.43', 'Megan Ramos', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(129, 82, 130, 131, 4, 'com_content.article.44', 'Steve Donavan', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(130, 82, 132, 133, 4, 'com_content.article.45', 'Andrew Rooney', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(131, 82, 134, 135, 4, 'com_content.article.46', 'Frank Roberts', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(133, 84, 158, 159, 4, 'com_content.article.48', 'Guy Richie', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(134, 84, 160, 161, 4, 'com_content.article.49', 'Lenny Stevens', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(135, 84, 162, 163, 4, 'com_content.article.50', 'Adam Cooper', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(136, 83, 144, 145, 4, 'com_content.article.51', '6. Do I need an account and what are the benefits?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(137, 83, 146, 147, 4, 'com_content.article.52', '5. How long will my order take to be delivered?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(138, 83, 148, 149, 4, 'com_content.article.53', '4. Can I return an item?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(139, 83, 150, 151, 4, 'com_content.article.54', '3. Can I track my order?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(140, 83, 152, 153, 4, 'com_content.article.55', '2. How can I pay for my order?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(141, 83, 154, 155, 4, 'com_content.article.56', '1. How can I change something in my order?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(142, 85, 85, 86, 3, 'com_content.article.57', 'Template settings', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(144, 7, 16, 17, 2, 'com_contact.category.30', 'Website Administrators', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(167, 18, 358, 359, 2, 'com_modules.module.103', 'Search', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"module.edit.frontend\":[]}'),
(168, 18, 360, 361, 2, 'com_modules.module.104', 'JoomGallery News', ''),
(169, 1, 559, 646, 1, 'com_joomgallery', 'joomgallery', '{}'),
(170, 169, 560, 645, 2, 'com_joomgallery.category.2', 'Gallery', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":{\"6\":1,\"3\":1},\"joom.create.inown\":[],\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(198, 27, 21, 22, 3, 'com_content.article.65', '404 Page', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(206, 18, 362, 363, 2, 'com_modules.module.111', 'Pinterest feed', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(208, 18, 364, 365, 2, 'com_modules.module.113', 'Pinterest feed', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(210, 18, 366, 367, 2, 'com_modules.module.115', 'TM Ajax Contact Form', '{}'),
(273, 342, 231, 250, 3, 'com_content.category.31', 'Portfolio', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(274, 800, 247, 248, 5, 'com_content.article.66', 'Popular', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(275, 800, 245, 246, 5, 'com_content.article.67', 'Architecture', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(276, 799, 241, 242, 5, 'com_content.article.68', 'Art & Illustration', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(277, 799, 239, 240, 5, 'com_content.article.69', 'Web & Interactive', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(278, 798, 235, 236, 5, 'com_content.article.70', 'Promotional', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(279, 798, 233, 234, 5, 'com_content.article.71', 'Games & Entertainment', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(284, 342, 89, 108, 3, 'com_content.category.32', 'Pricing table', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(285, 304, 97, 98, 5, 'com_content.article.75', 'Basic', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(286, 304, 95, 96, 5, 'com_content.article.76', 'Advanced', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(287, 304, 93, 94, 5, 'com_content.article.77', 'Elite', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(288, 304, 91, 92, 5, 'com_content.article.78', 'Deluxe', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(289, 18, 368, 369, 2, 'com_modules.module.118', 'Detailed', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(304, 284, 90, 99, 4, 'com_content.category.35', 'Detailed', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(305, 284, 100, 107, 4, 'com_content.category.36', 'Simple', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(307, 305, 101, 102, 5, 'com_content.article.88', 'Basic', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(308, 305, 103, 104, 5, 'com_content.article.89', 'Advanced', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(309, 305, 105, 106, 5, 'com_content.article.90', 'Professional', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(310, 18, 370, 371, 2, 'com_modules.module.122', 'Simple', '{}'),
(315, 18, 372, 373, 2, 'com_modules.module.126', 'Lorem ipsum', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(316, 18, 374, 375, 2, 'com_modules.module.127', 'Dolor sit', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(317, 18, 376, 377, 2, 'com_modules.module.128', 'Fusce molestie', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(318, 18, 378, 379, 2, 'com_modules.module.129', 'Aenean sem', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(319, 18, 380, 381, 2, 'com_modules.module.130', 'Duis vitae', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(320, 18, 382, 383, 2, 'com_modules.module.131', 'Maecenas vestibulum', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(342, 8, 88, 281, 2, 'com_content.category.43', 'Pages', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(348, 18, 384, 385, 2, 'com_modules.module.145', 'Accordion 1', '{}'),
(353, 438, 185, 186, 5, 'com_content.article.100', 'Tab Title 3', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(354, 438, 183, 184, 5, 'com_content.article.101', 'Tab Title 2', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(355, 438, 181, 182, 5, 'com_content.article.102', 'Tab Title 1', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(357, 84, 164, 165, 4, 'com_content.article.103', 'Adam Smith', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(358, 84, 166, 167, 4, 'com_content.article.104', 'Nick Harris', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(359, 84, 168, 169, 4, 'com_content.article.105', 'John Anderson', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(374, 342, 213, 230, 3, 'com_content.category.46', 'Careers', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(375, 374, 214, 215, 4, 'com_content.article.110', 'We truly believe that the success of our business depends on our employees.', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(376, 374, 216, 223, 4, 'com_content.category.47', 'Careers additional info', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(377, 18, 386, 387, 2, 'com_modules.module.159', 'Careers accordion', '{}'),
(378, 374, 224, 225, 4, 'com_content.article.111', 'The Sunday Times Best Company to work for', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(379, 374, 226, 227, 4, 'com_content.article.112', 'IT Careers', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(380, 18, 388, 389, 2, 'com_modules.module.160', 'Apply now', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(381, 374, 228, 229, 4, 'com_content.article.113', 'Machine learning', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(382, 18, 390, 391, 2, 'com_modules.module.161', 'Requirements', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(383, 18, 392, 393, 2, 'com_modules.module.162', 'What we Expect from you?', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(384, 376, 217, 218, 5, 'com_content.article.114', 'Business intelligence (BI) professionals', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(385, 376, 219, 220, 5, 'com_content.article.115', 'Business Program Managers (BPM)', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(386, 376, 221, 222, 5, 'com_content.article.116', 'Software Engineers (SWE)', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(387, 18, 394, 395, 2, 'com_modules.module.163', 'Careers accordion', '{}'),
(388, 18, 396, 397, 2, 'com_modules.module.164', 'Careers accordion', '{}'),
(389, 18, 398, 399, 2, 'com_modules.module.165', 'Careers accordion', '{}'),
(390, 18, 400, 401, 2, 'com_modules.module.166', 'Pages', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(391, 18, 402, 403, 2, 'com_modules.module.167', 'Blog posts', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(392, 18, 404, 405, 2, 'com_modules.module.168', 'Portfolio posts', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(393, 18, 406, 407, 2, 'com_modules.module.169', 'User menu', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(395, 18, 408, 409, 2, 'com_modules.module.170', 'Breadcrumbs', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(398, 18, 410, 411, 2, 'com_modules.module.171', 'Our team', '{}'),
(400, 18, 412, 413, 2, 'com_modules.module.173', 'Frequently asked questions', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(405, 1, 647, 648, 1, 'com_komento', 'com_komento', '{}'),
(406, 67, 55, 58, 3, 'com_content.category.48', 'Archived publications', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(407, 67, 59, 66, 3, 'com_content.category.49', 'Events & Programs', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(409, 67, 71, 74, 3, 'com_content.category.51', 'Fresh topic', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(410, 67, 67, 70, 3, 'com_content.category.52', 'Information', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(411, 67, 79, 82, 3, 'com_content.category.53', 'News', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(412, 67, 75, 78, 3, 'com_content.category.54', 'Updates', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(425, 410, 68, 69, 4, 'com_content.article.118', 'Things I’ve Learned about Investing and Business', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(427, 411, 80, 81, 4, 'com_content.article.119', 'LinkedIn Stock Downgraded After Microsoft Deal ', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(429, 412, 76, 77, 4, 'com_content.article.120', 'London SE in Frankfurt?', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
(433, 475, 210, 211, 4, 'com_content.article.121', 'Elements', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(437, 18, 414, 415, 2, 'com_modules.module.183', 'Tabs', '{}'),
(438, 475, 180, 187, 4, 'com_content.category.57', 'Tabs', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(442, 18, 416, 417, 2, 'com_modules.module.184', 'Accordion 2', '{}'),
(446, 475, 188, 209, 4, 'com_content.category.58', 'Progress Bars', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(447, 446, 189, 198, 5, 'com_content.category.59', 'Horizontal', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(448, 446, 199, 208, 5, 'com_content.category.60', 'Circle', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(449, 447, 190, 191, 6, 'com_content.article.125', 'Leadership', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(450, 447, 192, 193, 6, 'com_content.article.126', 'Management', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(451, 447, 194, 195, 6, 'com_content.article.127', 'Innovation and creativity', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(452, 448, 200, 201, 6, 'com_content.article.128', 'Leadership', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(453, 448, 202, 203, 6, 'com_content.article.129', 'Management', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(454, 448, 204, 205, 6, 'com_content.article.130', 'Innovation and creativity', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(456, 18, 418, 419, 2, 'com_modules.module.189', 'Pricing Tables', '{}'),
(457, 18, 420, 421, 2, 'com_modules.module.190', 'Simple', '{}'),
(459, 18, 422, 423, 2, 'com_modules.module.192', 'Accordions and Toggles', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(462, 18, 424, 425, 2, 'com_modules.module.195', 'Menu search', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(475, 342, 171, 212, 3, 'com_content.category.62', 'Elements', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(476, 447, 196, 197, 6, 'com_content.article.135', 'Resilience', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
(477, 448, 206, 207, 6, 'com_content.article.136', 'Resilience', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(478, 64, 31, 38, 3, 'com_content.category.63', 'Slider', '{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
(479, 478, 32, 33, 4, 'com_content.article.137', 'Professional Investment Consulting', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(480, 478, 34, 35, 4, 'com_content.article.138', 'Set your own pace', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(481, 478, 36, 37, 4, 'com_content.article.139', 'Why You Need an Advisor?', '{\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
(519, 8, 282, 283, 2, 'com_content.category.64', 'Site map', '{}'),
(521, 170, 561, 574, 3, 'com_joomgallery.category.9', 'Gallery 1', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(522, 170, 575, 588, 3, 'com_joomgallery.category.10', 'Gallery 2', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(523, 170, 589, 602, 3, 'com_joomgallery.category.11', 'Gallery 3', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(524, 170, 603, 616, 3, 'com_joomgallery.category.12', 'Gallery 4', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(525, 170, 617, 630, 3, 'com_joomgallery.category.13', 'Gallery 5', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(526, 170, 631, 644, 3, 'com_joomgallery.category.14', 'Gallery 6', '{\"joom.upload\":[],\"joom.upload.inown\":[],\"core.create\":[],\"joom.create.inown\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
(672, 1, 737, 738, 1, 'com_slogin', 'com_slogin', '{}'),
(676, 1, 739, 740, 1, 'com_fields', 'com_fields', '{}'),
(677, 1, 741, 742, 1, 'com_associations', 'com_associations', '{}'),
(679, 16, 318, 319, 2, 'com_menus.menu.19', 'Header menu', '{}'),
(697, 1, 743, 744, 1, '#__ucm_content.9', '#__ucm_content.9', '[]'),
(698, 1, 745, 746, 1, '#__ucm_content.10', '#__ucm_content.10', '[]'),
(699, 1, 747, 748, 1, '#__ucm_content.11', '#__ucm_content.11', '{}'),
(713, 16, 320, 321, 2, 'com_menus.menu.20', 'Navigation', '{}'),
(718, 1, 749, 750, 1, '#__ucm_content.8', '#__ucm_content.8', '[]'),
(719, 1, 751, 752, 1, '#__ucm_content.1', '#__ucm_content.1', '{}'),
(738, 521, 562, 563, 4, 'com_joomgallery.image.219', 'gallery-image01', '{}'),
(739, 521, 564, 565, 4, 'com_joomgallery.image.220', 'gallery-image02', '{}'),
(740, 521, 566, 567, 4, 'com_joomgallery.image.221', 'gallery-image03', '{}'),
(741, 521, 568, 569, 4, 'com_joomgallery.image.222', 'gallery-image04', '{}'),
(742, 521, 570, 571, 4, 'com_joomgallery.image.223', 'gallery-image05', '{}'),
(743, 521, 572, 573, 4, 'com_joomgallery.image.224', 'gallery-image06', '{}'),
(744, 522, 576, 577, 4, 'com_joomgallery.image.225', 'gallery-image07', '{}'),
(745, 522, 578, 579, 4, 'com_joomgallery.image.226', 'gallery-image08', '{}'),
(746, 522, 580, 581, 4, 'com_joomgallery.image.227', 'gallery-image09', '{}'),
(747, 522, 582, 583, 4, 'com_joomgallery.image.228', 'gallery-image10', '{}'),
(748, 522, 584, 585, 4, 'com_joomgallery.image.229', 'gallery-image11', '{}'),
(749, 522, 586, 587, 4, 'com_joomgallery.image.230', 'gallery-image12', '{}'),
(750, 523, 590, 591, 4, 'com_joomgallery.image.231', 'gallery-image13', '{}'),
(751, 523, 592, 593, 4, 'com_joomgallery.image.232', 'gallery-image14', '{}'),
(752, 523, 594, 595, 4, 'com_joomgallery.image.233', 'gallery-image15', '{}'),
(753, 523, 596, 597, 4, 'com_joomgallery.image.234', 'gallery-image16', '{}'),
(754, 523, 598, 599, 4, 'com_joomgallery.image.235', 'gallery-image17', '{}'),
(755, 523, 600, 601, 4, 'com_joomgallery.image.236', 'gallery-image18', '{}'),
(756, 524, 604, 605, 4, 'com_joomgallery.image.237', 'gallery-image19', '{}'),
(757, 524, 606, 607, 4, 'com_joomgallery.image.238', 'gallery-image20', '{}'),
(758, 524, 608, 609, 4, 'com_joomgallery.image.239', 'gallery-image21', '{}'),
(759, 524, 610, 611, 4, 'com_joomgallery.image.240', 'gallery-image22', '{}'),
(760, 524, 612, 613, 4, 'com_joomgallery.image.241', 'gallery-image23', '{}'),
(761, 524, 614, 615, 4, 'com_joomgallery.image.242', 'gallery-image24', '{}'),
(762, 525, 618, 619, 4, 'com_joomgallery.image.243', 'gallery-image25', '{}'),
(763, 525, 620, 621, 4, 'com_joomgallery.image.244', 'gallery-image26', '{}'),
(764, 525, 622, 623, 4, 'com_joomgallery.image.245', 'gallery-image27', '{}'),
(765, 525, 624, 625, 4, 'com_joomgallery.image.246', 'gallery-image28', '{}'),
(766, 525, 626, 627, 4, 'com_joomgallery.image.247', 'gallery-image29', '{}'),
(767, 525, 628, 629, 4, 'com_joomgallery.image.248', 'gallery-image30', '{}'),
(768, 526, 632, 633, 4, 'com_joomgallery.image.249', 'gallery-image31', '{}'),
(769, 526, 634, 635, 4, 'com_joomgallery.image.250', 'gallery-image32', '{}'),
(770, 526, 636, 637, 4, 'com_joomgallery.image.251', 'gallery-image33', '{}'),
(771, 526, 638, 639, 4, 'com_joomgallery.image.252', 'gallery-image34', '{}'),
(772, 526, 640, 641, 4, 'com_joomgallery.image.253', 'gallery-image35', '{}'),
(773, 526, 642, 643, 4, 'com_joomgallery.image.254', 'gallery-image36', '{}'),
(774, 1, 753, 754, 1, '#__ucm_content.6', '#__ucm_content.6', '{}'),
(775, 1, 755, 756, 1, '#__ucm_content.4', '#__ucm_content.4', '[]'),
(776, 1, 757, 758, 1, '#__ucm_content.5', '#__ucm_content.5', '[]'),
(778, 82, 136, 137, 4, 'com_content.article.164', 'Steven Jackson', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
(779, 82, 138, 139, 4, 'com_content.article.165', 'Andrew Edwards', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
(780, 18, 426, 427, 2, 'com_modules.module.234', 'Text Elements', '{}'),
(781, 18, 428, 429, 2, 'com_modules.module.235', 'TM Ajax Style Switcher', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"module.edit.frontend\":[]}'),
(783, 1, 759, 760, 1, 'com_acymailing', 'AcyMailing', '{}'),
(784, 18, 430, 431, 2, 'com_modules.module.238', 'Portfolio', '{}'),
(785, 18, 432, 433, 2, 'com_modules.module.239', 'Linear bars', '{}'),
(786, 18, 434, 435, 2, 'com_modules.module.240', 'Radial bars', '{}'),
(787, 18, 436, 437, 2, 'com_modules.module.241', 'Tags', '{}'),
(788, 18, 438, 439, 2, 'com_modules.module.242', 'Recent posts', '{}'),
(789, 18, 440, 441, 2, 'com_modules.module.243', 'Categories', '{}'),
(794, 18, 442, 443, 2, 'com_modules.module.248', 'Blog categories', '{}'),
(795, 18, 444, 445, 2, 'com_modules.module.249', 'Latest posts', '{}'),
(797, 18, 446, 447, 2, 'com_modules.module.251', 'Latest works', '{}'),
(798, 273, 232, 237, 4, 'com_content.category.70', 'Category 1', '{}'),
(799, 273, 238, 243, 4, 'com_content.category.71', 'Category 2', '{}'),
(800, 273, 244, 249, 4, 'com_content.category.72', 'Category 3', '{}'),
(801, 18, 448, 449, 2, 'com_modules.module.252', 'Login form megamenu', '{}'),
(802, 18, 450, 451, 2, 'com_modules.module.253', 'Social menu', '{}'),
(817, 18, 452, 453, 2, 'com_modules.module.268', 'Counters', '{}'),
(818, 18, 454, 455, 2, 'com_modules.module.269', 'Google map', '{}'),
(822, 18, 456, 457, 2, 'com_modules.module.273', 'Portfolio default', '{}'),
(823, 18, 458, 459, 2, 'com_modules.module.274', 'Portfolio masonry', '{}'),
(824, 82, 140, 141, 4, 'com_content.article.166', 'Karl Williams', '{}'),
(825, 18, 460, 461, 2, 'com_modules.module.275', 'Working time', '{}'),
(826, 342, 251, 252, 3, 'com_content.article.167', 'Do You Have any Questions?', '{}'),
(827, 18, 462, 463, 2, 'com_modules.module.276', 'Do You Have any Questions?', '{}'),
(828, 342, 253, 266, 3, 'com_content.category.73', 'Partners', '{}'),
(829, 828, 254, 255, 4, 'com_content.article.168', 'Partner 1', '{}'),
(830, 828, 256, 257, 4, 'com_content.article.169', 'Partner 2', '{}'),
(831, 828, 258, 259, 4, 'com_content.article.170', 'Partner 3', '{}'),
(832, 828, 260, 261, 4, 'com_content.article.171', 'Partner 4', '{}'),
(833, 828, 262, 263, 4, 'com_content.article.172', 'Partner 5', '{}'),
(834, 828, 264, 265, 4, 'com_content.article.173', 'Partner 6', '{}'),
(835, 18, 464, 465, 2, 'com_modules.module.277', 'Partners', '{}'),
(836, 342, 267, 280, 3, 'com_content.category.74', 'Services', '{}'),
(837, 836, 268, 269, 4, 'com_content.article.174', 'Preconstruction planning', '{}'),
(838, 836, 270, 271, 4, 'com_content.article.175', 'Building engineering', '{}'),
(839, 836, 272, 273, 4, 'com_content.article.176', 'Interior design', '{}'),
(840, 836, 274, 275, 4, 'com_content.article.177', 'Architecture & building', '{}'),
(841, 836, 276, 277, 4, 'com_content.article.178', 'House renovation', '{}'),
(842, 836, 278, 279, 4, 'com_content.article.179', 'Construction Consultant', '{}'),
(843, 18, 466, 467, 2, 'com_modules.module.278', 'Services prices', '{}'),
(844, 18, 468, 469, 2, 'com_modules.module.279', 'Popular questions', '{}'),
(845, 18, 470, 471, 2, 'com_modules.module.280', 'Our services', '{}'),
(847, 18, 472, 473, 2, 'com_modules.module.282', 'Google map footer', '{}'),
(848, 18, 474, 475, 2, 'com_modules.module.283', 'Get in Touch', '{}'),
(849, 18, 476, 477, 2, 'com_modules.module.284', 'Welcome img', '{}'),
(850, 27, 23, 24, 3, 'com_content.article.180', 'Magical World of Art', '{}'),
(851, 18, 478, 479, 2, 'com_modules.module.285', 'Welcome to artesma', '{}'),
(852, 18, 480, 481, 2, 'com_modules.module.286', 'Exhibitions', '{}'),
(853, 18, 482, 483, 2, 'com_modules.module.287', 'Exhibitions gallery', '{}'),
(854, 8, 284, 291, 2, 'com_content.category.75', 'Home services 1', '{}'),
(855, 18, 484, 485, 2, 'com_modules.module.288', 'Home services 1', '{}'),
(856, 854, 285, 286, 3, 'com_content.article.181', 'Meet Our Experts', '{}'),
(857, 854, 287, 288, 3, 'com_content.article.182', 'Tour the Gallery', '{}'),
(858, 854, 289, 290, 3, 'com_content.article.183', 'Visitor Information', '{}'),
(859, 27, 25, 26, 3, 'com_content.article.184', 'exhibitions', '{}'),
(860, 18, 486, 487, 2, 'com_modules.module.289', 'exhibitions', '{}'),
(861, 18, 488, 489, 2, 'com_modules.module.290', 'our blog', '{}'),
(862, 18, 490, 491, 2, 'com_modules.module.291', 'Home Blog', '{}'),
(863, 407, 62, 63, 4, 'com_content.article.185', 'Etching Demonstration', '{}'),
(864, 1, 761, 762, 1, '#__ucm_content.12', '#__ucm_content.12', '{}'),
(865, 407, 64, 65, 4, 'com_content.article.186', 'Miniature Art Show', '{}'),
(866, 1, 763, 764, 1, '#__ucm_content.13', '#__ucm_content.13', '{}'),
(867, 18, 492, 493, 2, 'com_modules.module.292', 'who we are', '{}'),
(868, 27, 27, 28, 3, 'com_content.article.187', 'We Are ARTESMA', '{}'),
(869, 8, 292, 301, 2, 'com_content.category.76', 'About services', '{}'),
(870, 18, 494, 495, 2, 'com_modules.module.293', 'About services', '{}'),
(871, 869, 293, 294, 3, 'com_content.article.188', 'Years of Experience', '{}'),
(872, 869, 295, 296, 3, 'com_content.article.189', ' Famous Artists', '{}'),
(873, 869, 297, 298, 3, 'com_content.article.190', ' Successful Exhibitions', '{}'),
(874, 869, 299, 300, 3, 'com_content.article.191', 'Current Exhibitions', '{}'),
(875, 18, 496, 497, 2, 'com_modules.module.294', 'meet the Team', '{}'),
(876, 18, 498, 499, 2, 'com_modules.module.295', 'Our Artists', '{}'),
(877, 18, 500, 501, 2, 'com_modules.module.296', 'what people say', '{}'),
(878, 18, 502, 503, 2, 'com_modules.module.297', 'Questions img', '{}'),
(879, 18, 504, 505, 2, 'com_modules.module.298', 'FAQ', '{}'),
(880, 1, 765, 766, 1, 'com_privacy', 'com_privacy', '{}'),
(881, 1, 767, 768, 1, 'com_actionlogs', 'com_actionlogs', '{}');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE IF NOT EXISTS `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE IF NOT EXISTS `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `description` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `custombannercode` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL,
  `sticky` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_metakey_prefix` (`metakey_prefix`(100))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE IF NOT EXISTS `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `contact` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `email` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `extrainfo` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`(100))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE IF NOT EXISTS `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) UNSIGNED NOT NULL,
  `banner_id` int(10) UNSIGNED NOT NULL,
  `count` int(10) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `path` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `extension` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_path` (`path`(100)),
  KEY `idx_alias` (`alias`(100))
) ENGINE=InnoDB AUTO_INCREMENT=77 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES
(1, 0, 0, 0, 93, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '{}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(2, 27, 1, 1, 2, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(3, 28, 1, 31, 32, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(4, 29, 1, 33, 34, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(5, 30, 1, 35, 36, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(6, 31, 1, 37, 38, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(7, 32, 1, 39, 40, 1, 'uncategorised', 'com_users', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(8, 64, 1, 3, 6, 1, 'home', 'com_content', 'Home', 'home', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(9, 65, 1, 7, 8, 1, 'about', 'com_content', 'About', 'about', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(10, 66, 1, 27, 28, 1, 'policies', 'com_content', 'Policies', 'policies', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(11, 67, 1, 9, 26, 1, 'blog', 'com_content', 'Blog', 'blog', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(14, 70, 11, 10, 11, 2, 'blog/recent', 'com_content', 'Recent', 'recent', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(15, 71, 11, 12, 13, 2, 'blog/latest', 'com_content', 'Latest', 'latest', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(18, 74, 62, 65, 66, 3, 'pages/elements/accordions-and-toggles', 'com_content', 'Accordions and Toggles', 'accordions-and-toggles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(25, 81, 43, 54, 55, 2, 'pages/history', 'com_content', 'History', 'history', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(26, 82, 43, 52, 53, 2, 'pages/team', 'com_content', 'Team', 'team', '', '<p><strong> </strong></p>', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(27, 83, 43, 50, 51, 2, 'pages/faqs', 'com_content', 'FAQs', 'faqs', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(28, 84, 43, 56, 57, 2, 'pages/testimonials', 'com_content', 'Testimonials', 'testimonials', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(29, 85, 1, 29, 30, 1, 'help', 'com_content', 'Help', 'help', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(30, 144, 1, 41, 42, 1, 'website-administrators', 'com_contact', 'Website Administrators', 'website-administrators', '', '<p>\'Website Administrators\' contact category description. Ut sapien enim, rhoncus sit amet fermentum at, sagittis ac massa. Fusce quis odio sit amet ipsum gravida faucibus vel et turpis. Aliquam a dui pretium elit feugiat interdum. Suspendisse tortor velit, bibendum vitae sollicitudin non, congue quis risus. Aliquam lacus nibh, viverra ut porta ac, luctus sit amet orci. Etiam euismod lacinia lectus et pulvinar. Integer dictum, dui id fermentum auctor, sem nunc ultricies ipsum, sed sagittis est justo nec neque. Integer sit amet justo elit, a dictum nisl.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(31, 273, 43, 74, 81, 2, 'pages/portfolio', 'com_content', 'Portfolio', 'portfolio', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(32, 284, 43, 44, 49, 2, 'pages/pricing-table', 'com_content', 'Pricing table', 'pricing-table', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(35, 304, 32, 45, 46, 3, 'pages/pricing-table/detailed', 'com_content', 'Detailed', 'detailed', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(36, 305, 32, 47, 48, 3, 'pages/pricing-table/simple', 'com_content', 'Simple', 'simple', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(43, 342, 1, 43, 86, 1, 'pages', 'com_content', 'Pages', 'pages', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(46, 374, 43, 58, 61, 2, 'pages/careers', 'com_content', 'Careers', 'careers', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(47, 376, 46, 59, 60, 3, 'pages/careers/careers-additional-info', 'com_content', 'Careers additional info', 'careers-additional-info', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '0000-00-00 00:00:00', 0, '*', 1),
(48, 406, 11, 14, 15, 2, 'blog/archived-publications', 'com_content', 'Archived publications', 'archived-publications', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(49, 407, 11, 16, 17, 2, 'blog/events-programs', 'com_content', 'Events & Programs', 'events-programs', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 846, '2018-06-29 13:23:53', 0, '*', 1),
(51, 409, 11, 18, 19, 2, 'blog/fresh-topic', 'com_content', 'Fresh topic', 'fresh-topic', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(52, 410, 11, 20, 21, 2, 'blog/information', 'com_content', 'Information', 'information', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(53, 411, 11, 22, 23, 2, 'blog/news', 'com_content', 'News', 'news', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(54, 412, 11, 24, 25, 2, 'blog/updates', 'com_content', 'Updates', 'updates', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(57, 438, 62, 63, 64, 3, 'pages/elements/tabs', 'com_content', 'Tabs', 'tabs', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(58, 446, 62, 67, 72, 3, 'pages/elements/progress-bars', 'com_content', 'Progress Bars', 'progress-bars', 'For \"Elements\" page', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(59, 447, 58, 68, 69, 4, 'pages/elements/progress-bars/horizontal', 'com_content', 'Horizontal', 'horizontal', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(60, 448, 58, 70, 71, 4, 'pages/elements/progress-bars/vertical', 'com_content', 'Circle', 'vertical', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(62, 475, 43, 62, 73, 2, 'pages/elements', 'com_content', 'Elements', 'elements', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(63, 478, 8, 4, 5, 2, 'home/slider', 'com_content', 'Slider', 'slider', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(64, 519, 1, 87, 88, 1, 'site-map', 'com_content', 'Site map', 'site-map', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', 0, '*', 1),
(70, 798, 31, 75, 76, 3, 'pages/portfolio/category-1', 'com_content', 'Category 1', 'category-1', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(71, 799, 31, 77, 78, 3, 'pages/portfolio/category-2', 'com_content', 'Category 2', 'category-2', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(72, 800, 31, 79, 80, 3, 'pages/portfolio/category-3', 'com_content', 'Category 3', 'category-3', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(73, 828, 43, 82, 83, 2, 'pages/partners', 'com_content', 'Partners', 'partners', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(74, 836, 43, 84, 85, 2, 'pages/services', 'com_content', 'Services', 'services', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', 0, '2018-06-25 16:06:04', 0, '*', 1),
(75, 854, 1, 89, 90, 1, 'home-services-1', 'com_content', 'Home services 1', 'home-services-1', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 846, '2018-06-29 09:32:28', 0, '2018-06-29 09:32:28', 0, '*', 1),
(76, 869, 1, 91, 92, 1, 'about-services', 'com_content', 'About services', 'about-services', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"category_layout\":\"\",\"image\":\"\",\"image_alt\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', 846, '2018-06-29 16:33:46', 0, '2018-06-29 16:33:46', 0, '*', 1);

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `address` mediumtext COLLATE utf8mb4_unicode_ci,
  `suburb` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `state` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `country` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `postcode` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `telephone` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `fax` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `misc` longtext COLLATE utf8mb4_unicode_ci,
  `image` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `email_to` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `default_con` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `mobile` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `webpage` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `sortname1` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `sortname2` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `sortname3` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `language` varchar(7) COLLATE utf8mb4_unicode_ci NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadata` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `featured` tinyint(3) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`) VALUES
(1, 'Website Owner', 'website-owner', 'website owner', '138 Atlantis Ln', 'Kingsport', 'Illinois', 'U.S.', '121164', '800-2345-6789', '800-2345-6789', '<p>Email us with any questions or inquiries or use our contact data.</p>', '', 'mail@demolink.org', 0, 1, 0, '0000-00-00 00:00:00', 1, '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_tags\":\"\",\"show_name\":\"0\",\"show_position\":\"0\",\"show_email\":\"1\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"\",\"show_telephone\":\"1\",\"show_mobile\":\"0\",\"show_fax\":\"1\",\"show_webpage\":\"\",\"show_misc\":\"1\",\"show_image\":\"0\",\"allow_vcard\":\"1\",\"show_articles\":\"0\",\"articles_display_num\":\"\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linka\":false,\"linkb_name\":\"\",\"linkb\":false,\"linkc_name\":\"\",\"linkc\":false,\"linkd_name\":\"\",\"linkd\":false,\"linke_name\":\"\",\"linke\":false,\"contact_layout\":\"\",\"show_email_form\":\"0\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', 846, 30, 1, '+1 959 603 6035', 'http://demolink.org', '', '', '', '*', '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, '', '', '{\"robots\":\"\",\"rights\":\"\"}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 8, 980);

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `introtext` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `fulltext` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `urls` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `attribs` varchar(5120) COLLATE utf8mb4_unicode_ci NOT NULL,
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `metadata` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `featured` tinyint(3) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`),
  KEY `idx_alias` (`alias`(191))
) ENGINE=InnoDB AUTO_INCREMENT=192 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(6, 91, 'Privacy policy', 'privacy-policy', '<h4>What does this privacy policy cover?</h4>\r\n<p>We take your privacy very seriously. This privacy policy governs and details the main privacy principles we apply to the data we collect through our services.Click here to access our privacy policy governing our corporate website.</p>\r\n\r\n<h4>About our services</h4>\r\n<p>We specialize in a variety of services. Our aim is to deliver services based on your recent browsing behavior. With our service, you should receive personalized help that is more relevant for you than the standard one you would receive without us. Click here for more information on our services.</p>\r\n\r\n<h4>User Choices</h4>\r\n<p>If you do not want to receive ads displayed by us, on your current browser and browsers we have linked to your technical identifier you can disable the display of our ads here.If you only want to opt out from your current browser uncheck the opt-out box.You can also opt-out of all matched browsers and know more about user choices.</p>\r\n\r\n<h4>Our commitments and adherence</h4>\r\n<p>Our company is an early adopter to initiatives of greater transparency and control for users. Read more about transparency and control.</p>\r\n\r\n<h4>Our Technology</h4>\r\n<p>We collect information via technical cookies placed on your browser. Read more about our technology.</p>\r\n\r\n<h4>Data security and retention</h4>\r\n<p>The security of your information is fundamental to us. We have implemented industry-standard security measures, which include the use of firewalls and encryption. Read more about data security and retention.</p>\r\n\r\n<p>Please note that we may update or change this privacy policy. If we revise our privacy policy, we will post those changes to this privacy statement, and to other places we deem appropriate, so that you are aware of what information we collect, how we use it, and under what circumstances, if any we disclose it. If we make any material changes we will notify you by means of a notice on this site prior to the change becoming effective. Please click here for the latest version of the privacy policy.</p>\r\n\r\n<p>E-mail: <a href=\"mailto:info@demolink.org\">info@demolink.org</a></p>', '', 1, 10, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 14, 1, '', '', 1, 95, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(11, 96, 'Children\'s Book Exhibition', 'anniversary-showcase-of-fox-tv-shows-and-movies', '<p>In this article, you will find out about the Children\'s Book Exhibition - an annual event that gathers the world\'s most famous authors of infantile and teenage literature.</p>\r\n', '\r\n<p>Children\'s Book Exhibition is a very important event for modern literature as well as for young and talented authors whose aim is to make modern infantile and teenage literature better. Every year the event takes place in a different American city. Previous year it was Seattle, WA, and this year the exhibition was hosted by LA Tower Center, located in Los Angeles, CA.</p>\r\n\r\n<p>This year, the Children\'s Book Exhibition celebrates the important anniversary of 35 years since the Children\'s Literature Committee has started its work in the USA. At this exhibition visitors could see and visit stands of famous publishing houses and authors and get autographs of the latter while children could take a photo with their favorite book heroes and have fun at the children\'s playground constructed specifically for this event.</p>\r\n\r\n<p>The event was a great chance for everyone interested in literature to show their knowledge of their favorite books as well as to take part in various contests. According to the words of the visitors and organizers, it was an outstanding opportunity where both children and teenagers could participate and win valuable prizes.</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 48, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb8.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img8.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:blog\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 54, 1, '', '', 1, 512, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(12, 97, 'Participate in discussion of an important topic', 'participate-in-discussion-of-an-important-topic', '<p>Are you a journalist or a creative personality? Do you want to share information with the world? Then our new project will be perfect for you to express your ideas and concepts.</p>\r\n', '\r\n<p>This project will change the way of public discussions we used to have 5 or 10 years ago in various clubs and non-profit organizations devoted to solving problems and answering the questions experts could not deal with.</p>\r\n<p>We are talking about a new social idea - a project that will unite people of various ages, interests, and professions into a discussion club that will be created on a basis of our website. If you have an idea to share with the world and society, or would like to offer a solution to a problem that seems to be unsolvable but is very important for your country, city or town, you will be a valuable member of our discussion club.<br>\r\nMembers of our club will have a unique opportunity to take part in discussions concerning world problems featuring America\'s leading political and economic consultants, celebrities, and just people who want to express their opinions about various concerns.</p>\r\n\r\n<p>\"We will create four groups, each consisting of 15 volunteers aged from 18 to 60. Representatives of these groups will cooperate with scientists and psychologists to search for solutions to local and national economic and social issues\", says Jim Smith, the coordinator of the project.</p>\r\n\r\n<p>As an experimental startup, the discussion club will concentrate on the following topics this year:</p>\r\n<ol>\r\n  <li>Social diversity and cultural competence;</li>\r\n  <li>Demographic situation in developing countries and possible methods of its control;</li>\r\n  <li>Economic crisis, its influence on situation in the world, and possible improvements that could be introduced.</li>\r\n</ol>\r\n<p>If you are interested in the activity of our discussion club or would like to join it, don\'t hesitate to contact us and ask your questions to find out more.</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 14, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb7.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img7.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 33, 0, '', '', 1, 16, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(13, 98, 'Improving your confidence and self-defense skills', 'improving-your-confidence-and-self-defense-skills', '<p>Today we would like to touch the topic which is gaining popularity among employees of big and small companies as well as students, teachers and other strata of the population.</p>\r\n', '\r\n<blockquote>\r\n<p>If you have experienced assault and aggression of your colleagues, coworkers or roommates, then this set of courses and tutorials devoted to self-defense is worth paying your attention to.</p>\r\n<cite>Bradley Roberts</cite>\r\n</blockquote>\r\n<p>Self-defense is of great importance for every member of modern society aged 12 and older. While 10 years ago we could only visit training or courses about self-defense measures in specialized centers, today it is not necessary to pay money to specialists if you have the desire to train your self-defense skills. Various tutorials on The Web are designed to help you deal with your fear of assaulter and give you necessary recommendations of preventing traumas in case of unavoidable attack.<br />\r\nOur business partner Bradley Roberts is the licensed provider of self-defense training services. He is also widely known for offering effective tutorials, some of which you can find on the Internet and download for free.</p>\r\n\r\n<p>Bradley has recently designed a special self-defense tutorial course that will help you deal with prevailing issues of assault, avoid panicking and raise your confidence.</p>\r\n\r\n<p>Here\'s what this course includes and what you will learn with benefit from it:</p>\r\n<ol>\r\n  <li>Theory of self-defense and basics of various defense techniques;</li>\r\n  <li>Famous defense technique of Brandon Roberts - combining elements of martial arts for self-defense with practical training;</li>\r\n  <li>Developing your self-confidence and eliminating your fear of unknown people as well as various threat sources.</li>\r\n</ol>\r\n<p>This course of tutorials is available exclusively to anyone who subscribes to our newsletter (and it\'s absolutely free). Every tutorial video is fully downloadable via our website.</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 15, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb6.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img6.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 24, 0, '', '', 1, 16, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(14, 99, 'Pen & Paintbruh', 'pen-paintbruh', '<p>Discover the top secrets of creating a beautiful and original painting with a pen and a paintbrush...</p>\r\n', '\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 49, '2018-06-25 16:06:04', 213, '', '2018-06-29 13:25:32', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb5.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img5.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 29, 2, '', '', 1, 15, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(15, 100, 'Music is now officially proved to have influence on us', 'music-is-now-officially-proved-to-have-influence-on-us', '<p>During our latest visit, the scientists of the Seattle Scientific Company laboratory have unveiled some information about their current project, and today we can share the results of their research with you.</p>\r\n', '\r\n<p>The main goal of the research was to confirm or refute the positive influence of music on a human being. Ann Johnson, Ph.D., states that everything we hear around us is not just sound waves of different amplitude. According to her words, every wave includes some \"emotional substance\" that defines the way we perceive it on subliminal level.<br>\r\nThe other participant of the research team, John Robertson, Ph.D. says that even sounds we do not actually pay attention to, are very important to the sonic perception of the environment. Moreover, music we listen to defines our mood and some streaks of our character.</p>\r\n\r\n<p>\"We created two groups, each consisting of 10 volunteers aged from 15 to 60. Representatives of the first group listened to fast-paced, merry and cheerful music of various genres\", says Mr. Robertson. Then he added that the second group was given heavy electronic and rock music as well as classic yet a bit gloomy melodies to listen to.</p>\r\n\r\n<p>The results of research confirm what all music fans have already guessed:</p>\r\n\r\n<ol>\r\n  <li>As each group went through a constantly increasing amount of \"music therapy\", the scientists made a suggestion that amount of music you listen to during a day, only increases its influence on you.</li>\r\n  <li>The emotional impact can be positive and negative - it depends on what kind of music you listen to (though even Metalcore and Dubstep may benefit to the way you feel).</li>\r\n  <li>You can select music according to your own tastes, but don\'t forget to pay attention to the feelings of the people around you - remember that tastes differ.</li>\r\n</ol>\r\n<p>We will keep you informed about further interesting researches of Seattle Scientific Company.</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 51, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb4.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img4.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:blog\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 29, 0, '', '', 1, 10, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(16, 101, 'Do you offer replacement parts?', 'do-you-offer-replacement-parts', '<p>Need an expert opinion? Our dedicated staff works to ensure that all the details of the artists\' representation are handled efficiently.</p>', '', 1, 18, '2018-06-25 16:06:04', 213, '', '2018-06-26 15:38:56', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 10, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(17, 102, 'Do you offer delivery services?', 'do-you-offer-delivery-services', '<p>Need an expert opinion? Our dedicated staff works to ensure that all the details of the artists\' representation are handled efficiently.</p>', '', 1, 18, '2018-06-25 16:06:04', 213, '', '2018-06-26 15:38:51', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 2, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(18, 103, 'Meet Our Experts', 'meet-our-experts', '<p>Need an expert opinion? Our dedicated staff works to ensure that all the details of the artists\' representation are handled efficiently.</p>', '', 1, 18, '2018-06-25 16:06:04', 213, '', '2018-06-26 15:38:49', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 12, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(35, 120, 'Our first steps on the market', 'excepteur-sint-occaecat-cupidatat', '<p>Our history begins back in 1998, when the first European office was opened in Cham, Switzerland, by the Anglo-Swiss Company. The founder of the company, himself an immigrant from Germany, was instrumental in turning his Company towards international expansion from the very start. We owe more than our name, our logo and our first product to our founder. He embodied many of the key attitudes and values that form part and parcel of our corporate culture: pragmatism, flexibility, the willingness to learn, an open mind and respect for other people and cultures.</p>', '', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 1, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(36, 121, 'Continuous innovation and transformation', 'phasellus-vitae-risus-non-erat-euismod', '<p>Continuous innovation and rapid transformation have been themes throughout our history, which the company traces to the 1998 with the installation of the first computer system for commercial use in the United States at General Electric’s Park facility. The company has built its solid reputation thanks to thorough employees selection. By the 2001, the company began offering a new breed of solutions to clients - solutions that aligned organizations\' technologies, processes and people with their strategies.</p>', '', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 11, 2, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(37, 122, 'Further development', 'etiam-dignissim-leo-quam', '<p>Throughout its history, the company has expanded its offerings and capitalized on evolving management trends and technologies to benefit its clients. The company pioneered systems integration and business integration; led the deployment of enterprise resource planning, customer relationship management and electronic services; and has established itself as a leader in today\'s global marketplace. Combining unparalleled experience, comprehensive capabilities across all industries and business functions, and extensive research on the world’s most successful companies, we collaborate with clients to help them in each and every requirement.<br /><br /></p>', '', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 3, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(38, 123, 'Company acquisition', 'nullam-auctor-vehicula-dui', '<p>In 2009 the Co Name Group was acquired from Co Name, thereby creating one of the leading European companies. At the time of the acquisition, Co Name Group employed 20,000 staff and generated annual revenues of approximately EUR 2.4 billion. Co Name employed 26,500 staff, generating annual revenues of more than EUR 3 billion. The acquisition of Co Name and the beneficial partnership is the logical continuation of the company strategy. With a workforce of more than 48,000 employees, Co Name generated revenues of over EUR 5 billion during the year.</p>', '', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 11, 4, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(39, 124, 'The Hayford was established in 1940 in New York as the National Committee of Investment Companies.', 'the-hayford-was-established-in-1940-in-new-york-as-the-national-committee-of-investment-companies', '<p>It became the National Association of Investment Companies in 1941. In 1940, company members included 68 mutual funds and 43 closed-end funds, and assets for the fund industry totaled $2.1 billion. The Hayford instituted its first public information program in 1943, published its first annual statistical summary in 1958, and held its first General Membership Meeting in 1959. Unit investment trusts were welcomed as Institute members in 1985. In 2015, the company celebrated the 75th anniversary of its founding and of the key legislation that gave rise to the modern fund industry.</p>\r\n', '\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/history\\/history-2.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 5, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(40, 125, 'When we decided to set up our operations 25 years ago, we had a list of principles that we all stood by, as co-founders...', 'history-1', '<p>They did not change a bit. It was and still is a distinct desire to deliver complex, 360° investment consulting services, that would fill any gap in any business’ daily, monthly and yearly operations. With that in mind, we continue to implement our expertise to help hundreds of companies! The Hayford enjoys all guarantees and concessions provided by the national and foreign investment codes in the shareholder countries. In particular, its assets are granted full mobility and freedom of expatriation and are immune against nationalization and expropriation.</p>\r\n', '\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>', 1, 25, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/history\\/history-1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 10, 6, '', '', 1, 4, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(41, 126, 'Jorinde Voigt', 'jorinde-voigt', '<p class=\"post\">Portrait Art​​​​​​​</p>\r\n\r\n', '\r\n<p>Jorinde Voigt manages the warehouse aspect of each of BuildWall’s projects. Anthony receives materials for each project at BuildWall’s warehouse.</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Portrait Art​​​​​​​</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Anthony manages the warehouse aspect of each of BuildWall’s projects. Anthony receives materials for each project at BuildWall’s warehouse. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Anthony is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Anthony approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Steven acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:38:39', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-1.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-1.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 15, 1, '', '', 1, 8, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(42, 127, 'Allen Jones', 'allen-jones', '<p class=\"post\">Expressionist Paintings</p>\r\n', '\r\n<p>Allen Jones is the best expert in eco design. Her favourite materials are wood and stone. With them Allen Jones creates amazing</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Expressionist Paintings</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Stacey is the best expert in eco design. Her favourite materials are wood and stone. With them Stacey creates amazing works. She is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Stacey is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind her, Stacey approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>She is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to her clients and to the production crews that she oversees. Vicky acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to her.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:34:21', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-2.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-2.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 15, 2, '', '', 1, 2, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(43, 128, 'Megan Ramos', 'megan-ramos', '<p class=\"post\">Modern Art</p>\r\n\r\n', '\r\n<p>Megan Ramos is at your service on any organisation and finance issues. She surpervises every project and can answer your non-design</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Modern Art</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Jerry is at your service on any organisation and finance issues. He surpervises every project and can answer your non-design questions. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Jerry is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Anthony approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Steven acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:38:21', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-3.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 16, 3, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(44, 129, 'Steve Donavan', 'steve-donavan', '<p class=\"post\">Experimental Art</p>\r\n\r\n', '\r\n<p>Nick managed the warehouse for 2 years and was promoted to be a Project Manager. </p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Experimental Art</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Nick managed the warehouse for 2 years and was promoted to be a Project Manager. He values customer service and is known for his ethics. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Nick is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Anthony approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Nick acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:40:46', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-4.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-4.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 18, 4, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(45, 130, 'Andrew Rooney', 'andrew-rooney', '<p class=\"post\">Remodeling Consultant</p>\r\n\r\n', '\r\n<p>With a decade at BuidWall and a lifetime in the industry, Andrew Rooney has been an invaluable...</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Remodeling Consultant</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>With a decade at BuidWall and a lifetime in the industry, Andrew Rooney has been an invaluable part of our puzzle. He values customer service and is known for his ethics. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Andrew is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Andrew approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Andrew acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:41:10', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-5.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-5.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 16, 5, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(46, 131, 'Frank Roberts', 'frank-roberts', '<p class=\"post\">Senior Foreman</p>\r\n\r\n', '\r\n<p>Frank is in charge of all our workers. He joined us in 2006 and managed to organize a close-knit team...</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Senior Foreman</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Frank is in charge of all our workers. He joined us in 2006 and managed to organize a close-knit team, where every person is at his place. He values customer service and is known for his ethics. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Frank is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Andrew approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Frank acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:41:28', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-6.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-6.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 17, 6, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(48, 133, 'Guy Richie', 'guy-richie', '<blockquote><p>I never thought that I would ever need anyone\'s help managing my fund... But after making a fatal decision to buy real estate bonds in 2007, I changed my mind. This firm\'s consultants helped me to recover my finances and achieve a steady growth once more!</p><small>Guy Richie</small></blockquote>\r\n', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-3.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-3.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 11, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(49, 134, 'Lenny Stevens', 'lenny-stevens', '<blockquote><p>Whenever I feel like I am head over heels with the decision on which exact investment option to take, I call these guys up. They\'ve made me more than $789 million in profit, and that\'s just in the last few years! Whatever they advised me, turned out to be gold!</p><small>Lenny Stevens</small></blockquote>', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-2.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-2.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 12, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(50, 135, 'Adam Cooper', 'adam-cooper', '<blockquote><p>The guys at your company are amazing! Your service has added a great value to my life. I love that I can jump to your site any time and have access to support 24/7.</p><small>Adam Cooper</small></blockquote>', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-1.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-1.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 11, 3, '', '', 1, 4, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(51, 136, '6. Do I need an account and what are the benefits?', '6-do-i-need-an-account-and-what-are-the-benefits', '<p>It\'s not required to create an account. But, having an account provides easier checkout, the ability to create and send a wishlist, and a customized shopping experience.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 9, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(52, 137, '5. How long will my order take to be delivered?', '5-how-long-will-my-order-take-to-be-delivered', '<p>Delivery times will depend on your location. Once payment is confirmed your order will be packaged. Delivery can be expected within 10 business days.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(53, 138, '4. Can I return an item?', '4-can-i-return-an-item', '<p>Please visit our Returns & Exchanges page for more information.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 8, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(54, 139, '3. Can I track my order?', '3-can-i-track-my-order', '<p>Yes, you can! After placing your order you will receive an order confirmation via email. Each order starts production 24 hours after your order is placed. Within 72 hours of you placing your order, you will receive an expected delivery date. When the order ships, you will receive another email with the tracking number and a link to trace the order online with the carrier.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 10, 4, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(55, 140, '2. How can I pay for my order?', '2-how-can-i-pay-for-my-order', '<p>We accept Visa, MasterCard, and American Express credit and debit cards for your convenience.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 5, 5, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(56, 141, '1. How can I change something in my order?', '1-how-can-i-change-something-in-my-order', '<p>If you need to change something your order, please contact us immediately. We usually process orders within 2-4 hours, and once we have processed your order, we will be unable to make any changes.</p>', '', 1, 27, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 6, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(57, 142, 'Template settings', 'template-settings', '<h5>Modules configuration table</h5>\r\n<p>This table shows theme modules settings. Please make sure you have read <a href=\"http://www.templatemonster.com/help/quick-start-guide/joomla-templates/v3-2/index_en.html#modules-config-table\" target=\"_blank\">theme documentation. </a> </p>\r\n\r\n<div id=\"mod_table\">\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>1 - Search</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_search</li>\r\n				<li><strong>Position:</strong> 404-search</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>2 - TM Ajax Contact Form</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_ajax_contact_form</li>\r\n				<li><strong>Position:</strong> contact-form</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>3 - Detailed</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-7</li>\r\n				<li><strong>Class Suffix:</strong> pricing_detailed</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>4 - Simple</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> pricing_simple</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 2</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>5 - Accordion 1</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> custom</li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 11</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>6 - Careers accordion</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> careers-accordion-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>7 - Apply now</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_ajax_contact_form</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> careers_form</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>8 - Requirements</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_menu</li>\r\n				<li><strong>Position:</strong> careers-accordion-requirements</li>\r\n				<li><strong>Class Suffix:</strong>  requirements</li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>9 - What we Expect from you?</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_menu</li>\r\n				<li><strong>Position:</strong> careers-accordion-expect</li>\r\n				<li><strong>Class Suffix:</strong>  expect</li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>10 - Careers accordion</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> careers-accordion-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>11 - Careers accordion</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> careers-accordion-3</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>12 - Careers accordion</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> careers-accordion-4</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>13 - Pages</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_menu</li>\r\n				<li><strong>Position:</strong> content-bottom</li>\r\n				<li><strong>Class Suffix:</strong> site_map</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>14 - Blog posts</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_category</li>\r\n				<li><strong>Position:</strong> content-bottom</li>\r\n				<li><strong>Class Suffix:</strong>  site_map</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>15 - Portfolio posts</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_category</li>\r\n				<li><strong>Position:</strong> content-bottom</li>\r\n				<li><strong>Class Suffix:</strong>  site_map</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>16 - User menu</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_menu</li>\r\n				<li><strong>Position:</strong> content-bottom</li>\r\n				<li><strong>Class Suffix:</strong> site_map</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>17 - Breadcrumbs</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_breadcrumbs</li>\r\n				<li><strong>Position:</strong> breadcrumbs</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>18 - Our team</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> content-top</li>\r\n				<li><strong>Class Suffix:</strong> team</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>19 - Frequently asked questions</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 3</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>20 - Tabs</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstraptabs</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 13</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>21 - Accordion 2</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 10</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>22 - Pricing Tables</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> pricing_detailed</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 14</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>23 - Simple</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> pricing_simple</li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 15</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>24 - Accordions and Toggles</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> title_only</li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 9</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>25 - Menu search</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_search</li>\r\n				<li><strong>Position:</strong> modal</li>\r\n				<li><strong>Class Suffix:</strong>  modal_search</li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>26 - Text Elements</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_single</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>27 - TM Ajax Style Switcher</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_style_switcher</li>\r\n				<li><strong>Position:</strong> fixed-sidebar-left</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>28 - Portfolio</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_portfolio</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 4</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>29 - Linear bars</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_progress_bars</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 5</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>30 - Radial bars</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_progress_bars</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 6</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>31 - Tags</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tags_popular</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 5</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>32 - Recent posts</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 6</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>33 - Categories</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_categories</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 2</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>34 - Blog categories</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_categories</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>35 - Latest posts</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>36 - Latest works</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>37 - Login form megamenu</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_slogin</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>38 - Social menu</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_menu</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>39 - Counters</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_counters</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 8</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>40 - Google map</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_google_map</li>\r\n				<li><strong>Position:</strong> map</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>41 - Portfolio default</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_portfolio</li>\r\n				<li><strong>Position:</strong> position-6</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 4</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>42 - Portfolio masonry</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_portfolio</li>\r\n				<li><strong>Position:</strong> position-6</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 4</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>43 - Working time</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 3</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>44 - Do You Have any Questions?</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_single</li>\r\n				<li><strong>Position:</strong> sidebar-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 4</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>45 - Partners</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> content-top</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>46 - Services prices</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>47 - Popular questions</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> none</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>48 - Our services</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>49 - Google map home</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_tm_google_map</li>\r\n				<li><strong>Position:</strong> map</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>50 - Get in Touch</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> footer</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>51 - Welcome img</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>52 - Welcome to artesma</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_single</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>53 - Exhibitions</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>54 - Exhibitions gallery</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_owl_carousel</li>\r\n				<li><strong>Position:</strong> position-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>55 - Home services 1</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-3</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>56 - exhibitions</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_single</li>\r\n				<li><strong>Position:</strong> position-4</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>57 - our blog</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-5</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>58 - Home Blog</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-5</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>59 - who we are</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_single</li>\r\n				<li><strong>Position:</strong> position-1</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>60 - About services</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-2</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>61 - meet the Team</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-3</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>62 - Our Artists</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_articles_news_adv</li>\r\n				<li><strong>Position:</strong> position-3</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>63 - what people say</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_owl_carousel</li>\r\n				<li><strong>Position:</strong> position-4</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>64 - Questions img</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_custom</li>\r\n				<li><strong>Position:</strong> position-5</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> no</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n\r\n	<div class=\'module\'>\r\n	<div class=\'row\'>\r\n		<div class=\'col-sm-3\'><b>65 - FAQ</b></div>\r\n\r\n		<div class=\'col-sm-4\'>\r\n			<ul>\r\n				<li><strong>Type:</strong> mod_bootstrap_collapse</li>\r\n				<li><strong>Position:</strong> position-5</li>\r\n				<li><strong>Class Suffix:</strong> </li>\r\n				<li><strong>Show Title:</strong> yes</li>\r\n				<li><strong>Order:</strong> 1</li>				\r\n			</ul>\r\n		</div>\r\n		<div class=\'col-sm-5\'>\r\n			<ul>\r\n				<li><strong>Pages:</strong> </li>\r\n				<li><strong>Additional info:</strong> &nbsp;</li>\r\n			</ul>\r\n		</div>\r\n		<div class=\'clearfix\'></div>\r\n	</div>\r\n	</div>\r\n</div>', '', 1, 29, '2018-06-25 16:06:04', 213, '', '2018-06-30 13:52:10', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 14, 1, '', '', 1, 74, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(65, 198, '404 Page', '404-page', '<h1>404</h1>\r\n<h3>Sorry!<br> Page Not Found</h3>\r\n<big>The page you are looking for might have been removed, had its name changed, or is temporarily unavailable.</big>\r\n<p>Please try using our search box below to look for information on the internet.</p>\r\n{loadposition 404-search}', '', 1, 2, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 18, 3, '', '', 1, 345, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(66, 274, 'Popular', 'popular', '\r\n', '\r\n<p>Here you will find artworks that are most frequently viewed and liked by site visitors.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Popular</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>Mighty creative studio</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>Would you like to know what do other people love the most? Click here and view. You will come across a really inspiring stuff. Have creative works of your own to show to the public? Post them and see if they are enjoyed by many people. This maybe your own way to popularity. As a rule, if some content becomes really popular on the Internet, the users tend to make a research about its author. Every gifted person has chances to become appreciated, loved and followed.</p>', 1, 72, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:36:38', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb1.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Popular\",\"image_fulltext\":\"images\\/portfolio\\/project1.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 45, 1, '', '', 1, 219, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(67, 275, 'Architecture', 'architecture', '\r\n', '\r\n<p>Here we feature artworks related to architecture.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Architecture</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>leading architecture technology</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>Architecture is both the process and the product of planning, designing, and constructing buildings and other physical structures. Architectural works, in the material form of buildings, are often perceived as cultural symbols and as works of art. Historical civilizations are often identified with their surviving architectural achievements. Architecture has to do with planning, designing and constructing form, space and ambience to reflect functional, technical, social, environmental and aesthetic considerations. It requires the creative manipulation and coordination of materials and technology, and of light and shadow.</p>', 1, 72, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:36:23', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb2.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Architecture\",\"image_fulltext\":\"images\\/portfolio\\/project2.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 32, 2, '', '', 1, 53, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(68, 276, 'Art & Illustration', 'art-illustration', '\r\n', '\r\n<p>An illustration is a visual approach to a verbal story.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Art & Illustration</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>Interactive form of visual communication</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>Is there any difference between art and illustration? In an illustration, there is little, if anything, for the viewer to do. All the information is there available for the viewer to see. There can be several themes at once but it precisely includes all the visual information the audience is expected to use upon viewing it.  Illustration is easily given words to express it that are appropriate to it. Art is something else and represents a more interactive form of visual communication. It does require something from the viewer in order to be recognized. Art is not intended as a verbal communication represented in a visual format.</p>', 1, 71, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:36:01', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Art & Illustration\",\"image_fulltext\":\"images\\/portfolio\\/project3.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 27, 3, '', '', 1, 25, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(69, 277, 'Web & Interactive', 'web-interactive', '\r\n', '\r\n<p>Best website designs showcased.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Web & Interactivem</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>The collection has about 100.000 pieces of art in total.</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>The collection has about 100.000 pieces of art in total. Just like a real visit to the museum it is possible to discuss a piece of art, or ask a question with all registered users of the site. Active discussions or questions are shown on the user account page. It is also possible to choose your favorite detail of an artwork and discuss it with other users. There is a lot of cross-referencing going on between all these content types and nodes to create certain elements. Especially the interactive elements make heavy use of this.</p>', 1, 71, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:35:47', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb4.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Web & Interactive\",\"image_fulltext\":\"images\\/portfolio\\/project4.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 30, 4, '', '', 1, 12, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(70, 278, 'Promotional', 'promotional', '', '\r\n<p>Promotion can be done by different media. Here you will see the artistic approach to promotion.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Promotional</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>Present information to consumers and others.</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>The purpose of a promotion can have a wide range, including: sales increases, new product acceptance, creation of brand equity, positioning, competitive retaliations, or creation of a corporate image. The goal of a promotion is then to reach the most people possible in a time efficient and a cost efficient manner. Fundamentally, there are three basic objectives of promotion. These are: to present information to consumers and others, to increase demand, to differentiate a product.</p>', 1, 70, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:35:31', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb5.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Promotional\",\"image_fulltext\":\"images\\/portfolio\\/project5.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 31, 5, '', '', 1, 33, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(71, 279, 'Games & Entertainment', 'games-entertainment', '', '\r\n<p>Traditional art forms are things you cannot win; you can only experience them.</p>\r\n<ul class=\"portfolio-meta-list\">\r\n	<li><strong class=\"portfolio-meta-key\">Client:</strong><span>Games & Entertainment</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Date:</strong><span>07/07/2012</span></li>\r\n	<li><strong class=\"portfolio-meta-key\">Info:</strong><span>Controlled passage through an overwhelming aesthetic experience.</span></li>\r\n</ul>\r\n<p><a href=\"#\" target=\"_blank\" class=\"btn btn-info\">View Project</a></p>\r\n<p>Video games can be measured as art of imitation nature and reality. Games and entertainment art grows better the more it improves or alters nature through a passage through what we might call the artist\'s soul, or vision. Video games are nothing if not experiential. They are visuals and music and poetry all wrapped up into a single package. A video game isn\'t just a game—it is a controlled passage through an overwhelming aesthetic experience.</p>', 1, 70, '2018-06-25 16:06:04', 213, '', '2018-06-28 15:30:41', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/portfolio\\/project-thumb6.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Games & Entertainment\",\"image_fulltext\":\"images\\/portfolio\\/project6.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 32, 6, '', '', 1, 34, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(75, 285, 'Basic', 'first-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Basic</h6>\r\n    <em class=\"pricing-table__subtitle\">Basic plan great for online, small & local businesses</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">100</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__list\">\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Object analysis</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Territory analysis</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Options selection</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Details discussion</span>\r\n      </div>\r\n    </div>\r\n  </div> \r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 35, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 0, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 1, '*', '', ''),
(76, 286, 'Advanced', 'second-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Advanced</h6>\r\n    <em class=\"pricing-table__subtitle\">Advanced plan great for online, small & local businesses</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">245</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__list\">\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Object analysis</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Calculations</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Options selection</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Materials selection</span>\r\n      </div>\r\n    </div>\r\n  </div> \r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 35, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 17, 0, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(77, 287, 'Elite', 'third-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Elite</h6>\r\n    <em class=\"pricing-table__subtitle\">Elite plan great for online, small & local businesses</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">345</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__list\">\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Object analysis</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Calculations</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Options selection</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Materials selection</span>\r\n      </div>\r\n    </div>\r\n  </div> \r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 35, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 0, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(78, 288, 'Deluxe', 'fourth-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Deluxe</h6>\r\n    <em class=\"pricing-table__subtitle\">Deluxe plan great for online, small & local businesses</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">499</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__list\">\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Object analysis</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Calculations</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item active\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Options selection</span>\r\n      </div>\r\n    </div>\r\n    <div class=\"pricing__list-item\">\r\n      <div class=\"pricing-feature__inner\">\r\n        <i class=\"item-icon\"></i>\r\n        <span class=\"pricing-feature__text\">Materials selection</span>\r\n      </div>\r\n    </div>\r\n  </div> \r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 35, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 0, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(88, 307, 'Basic', 'first-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Basic</h6>\r\n    <em class=\"pricing-table__subtitle\">Special offer</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">100</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 36, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 15, 0, '', '', 1, 2, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 1, '*', '', ''),
(89, 308, 'Advanced', 'second-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Advanced</h6>\r\n    <em class=\"pricing-table__subtitle\">For first-time clients</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">200</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 36, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 12, 0, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(90, 309, 'Professional', 'third-package', '<div class=\"pricing-table\">\r\n  <div class=\"pricing-table__heading\">\r\n    <h6 class=\"pricing-table__title\">Professional</h6>\r\n    <em class=\"pricing-table__subtitle\">For businesses</em>\r\n    <div class=\"pricing-table__price\">\r\n      <span class=\"pricing-table__price-prefix\">$</span>\r\n      <span class=\"pricing-table__price-val\">299</span>\r\n      <span class=\"pricing-table__price-suffix\">/mo</span>\r\n    </div>\r\n  </div>\r\n  <div class=\"pricing-table__action\">\r\n    <a class=\"btn\" href=\"#\">Buy Now</a>\r\n  </div> \r\n</div>', '', 1, 36, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 10, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(100, 353, 'Tab Title 3', 'tab-title-3', '<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. </p>', '', 1, 57, '2018-06-25 16:06:04', 213, '', '2018-06-27 13:21:10', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 12, -1, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(101, 354, 'Tab Title 2', 'tab-title-2', '<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. </p>', '', 1, 57, '2018-06-25 16:06:04', 213, '', '2018-06-27 12:21:20', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 12, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(102, 355, 'Tab Title 1', 'tab-title-1', '<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. </p>', '', 1, 57, '2018-06-25 16:06:04', 213, '', '2018-06-27 12:21:14', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(103, 357, 'Adam Smith', 'adam-smith', '<blockquote><p>I just don\'t know how to describe your services... They are extraordinary! I am quite happy with them! Just keep up going this way!</p><small>Adam Smith</small></blockquote>', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-4.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-1.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 15, 4, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(104, 358, 'Nick Harris', 'nick-harris', '<blockquote><p>Great organization!! Your prompt answer became a pleasant surprise for me. You’ve rendered an invaluable service! Thank you very much!</p><small>Nick Harris</small></blockquote>', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-5.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-2.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 14, 5, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(105, 359, 'John Anderson', 'john-anderson', '<blockquote><p>I just want to thank you for your help. I was so pleased and grateful. Keep up the excellent work. Your site provides the best support I have ever encountered.</p><small>John Anderson</small></blockquote>\r\n', '', 1, 28, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/testimonials\\/testimonials-6.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/testimonials\\/testimonials-3.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"1\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 14, 6, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(110, 375, 'We truly believe that the success of our business depends on our employees.', 'lorem-ipsum-dolor-sit-amet', '<p>We offer excellent opportunities for individuals seeking to strive and flourish in the research and consultancy industry, focusing on their professional as well as personal development. Our distinctive environment offers careers that are exciting, challenging and rewarding. We encourage our people to learn, experiment and grow - for both their own personal benefit and the company’s.</p>\r\n{loadposition careers-accordion-1}', '', 1, 46, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 9, -1, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(111, 378, 'The Sunday Times Best Company to work for', 'etiam-in-neque-non-sapien-lobortis', '<p>We’re proud to say that our office has made The Sunday Times Best Small Companies to work for list at our first attempt. Our Company is the top-ranking research consultancy in the small companies category to have achieved a listing, achieving 50th place out of the top 100  companies  recognised as great places to work in the UK. The accolade acknowledges “that senior employees truly live the values of the firm”, that people say “their jobs are good for growth” and the company “clearly values new ideas from employees”. We received top rankings for the My Manager, Personal Growth and Fair Deal categories. This is truly a testament to the talented collection of people, special energy and morale we have at The Futures Company.</p>\r\n{loadposition careers-accordion-2}', '', 1, 46, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 9, -1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(112, 379, 'IT Careers', 'porro-magni-dolore-eos-eius-ducimus', '<p>Each day our world creates new technology: devices, apps, and services. Which means new ways to do things, new ways to connect, new things to learn. While each holds the promise of helping us get more done with less effort, they also can become one more thing competing for our scarce time and attention.</p>\r\n{loadposition careers-accordion-3}', '', 1, 46, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 10, 1, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(113, 381, 'Machine learning', 'vestibulum-commodo-mollis', '<p>We are looking to hire mathematically minded people who have the talent to analyze and derive meaning from data, as well as those who know how to deploy techniques of machine learning. We work with a diverse set of technologies, including deep learning, probabilistic programming, large-scale learning, and causal reasoning. For scientists who’ve got algorithmic ability, this skill set can be the ticket to one of the hottest jobs on the market.</p>\r\n{loadposition careers-accordion-4}', '', 1, 46, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 11, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(114, 384, 'Business intelligence (BI) professionals', 'business-intelligence-bi-professionals', '{loadposition careers-accordion-requirements}', '', 1, 47, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 5, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(115, 385, 'Business Program Managers (BPM)', 'business-program-managers-bpm', '{loadposition careers-accordion-expect}', '', 1, 47, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 4, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(116, 386, 'Software Engineers (SWE)', 'software-engineers-swe', '<p>They’re responsible for production code quality and service performance, and accountable for automation of test cases to enable flighting. These engineers can evaluate requirements, estimate costs, design, implement, validate and measure to understand the quality of the end users’ experience. They can improve engineering processes, assure quality, communicate status, and manage risks.</p>', '', 1, 47, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 4, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(118, 425, 'Things I’ve Learned about Investing and Business', 'things-i-ve-learned-about-investing-and-business', '<p>The North American Auto Show, one of the most important annual events that influence the international automotive industry and exhibits its main achievements, is eventually confirmed to take place in Chicago, IL. Located on the southwestern coast of Lake Michigan, this city will host representatives of vehicle manufacturers from all over the world. They include American companies (Ford, General Motors), European (Alfa Romeo, Lotus, BMW, FIAT, Seat) as well as Japanese ones and many others.</p>\r\n', '\r\n<p>The North American Auto Show, one of the most important annual events that influence the international automotive industry and exhibits its main achievements, is eventually confirmed to take place in Chicago, IL. Located on the southwestern coast of Lake Michigan, this city will host representatives of vehicle manufacturers from all over the world. They include American companies (Ford, General Motors), European (Alfa Romeo, Lotus, BMW, FIAT, Seat) as well as Japanese ones and many others.</p>\r\n<p>Even if you are not considered to be a fan of cool cars and international automotive industry, this event is worth visiting. This year organizers promise not just great exhibits to be presented at the event, but also a great amount of entertainment for adults and children. If you happen to be in Chicago this summer, you should definitely visit this show. Unlike any other car exhibition, be it muscle car show or old car show, the North American Auto Show offers vast possibilities of entertaining and spending free time for your good.</p>\r\n\r\n<p>The North American Show was first held in 1970 in Ontario, Canada. During more than 30 years of the exhibition\'s history, it has been attracting a lot of attention of automotive industry representatives including vehicle manufacturers and investors. The exhibition takes place in one of three North American countries - Mexico, USA or Canada.</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 52, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb1.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img1.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 56, 1, '', '', 1, 372, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(119, 427, 'LinkedIn Stock Downgraded After Microsoft Deal ', 'linkedin-stock-downgraded-after-microsoft-deal', '<p>Fox TV Channel is showcasing the most successful series and full-length films of 20th Century Fox this month in all American cinemas with wide promotional campaign of their upcoming projects.</p>\r\n', '\r\n<p>Fox TV Channel is showcasing the most successful series and full-length films of 20th Century Fox this month in all American cinemas with wide promotional campaign of their upcoming projects.</p>\r\n<p><b>What is Fox TV?</b><br>You all probably know the famous intro of 20th Century Fox that we all have seen (of course if you have visited cinema at least once). This company is a part of Fox International Company, a global media corporation that delivers high-quality content pleasing your eyes and ears. One of its other subsidiaries is Fox TV Channel. So here\'s the main point:</p>\r\n<blockquote><p>20th Century Fox brings to your screen full-length films and cartoons that we all love.</p></blockquote>\r\n<blockquote><p>Fox Television is offering us unique content, broadcasting amazing series and shows of the channel\'s own production.</p></blockquote>\r\n\r\n<p><b>Anniversary Showcase</b><br>This year, the Fox International Company celebrates the great anniversary of 70 years since their film production activity has started. Managers and executive officers of the company have decided to give all American residents and guests a chance to enjoy the films, cartoons and the best moments of series and shows that they love so much. To make it possible, almost all big cinemas take part in Fox 70th Anniversary Showcase - an event that promotes the art of making memorable movies and series, and also raises money for charity worldwide. Everyone is invited to watch the greatest movies and series of all times throughout the USA!</p>\r\n\r\n<p><b>Taking Part in the Event</b><br>Though this event is free for participation, it still requires registration. All you need is to proceed to Fox\'s official website and enter next data:</p>\r\n<ol>\r\n<li>your name and surname;</li>\r\n<li>your age;</li>\r\n<li>your place of residence (country and region, state or province);</li>\r\n<li>number of people that will accompany you at the event.</li>\r\n</ol>\r\n<p>After that you will be given an electronic ticket to the nearest Fox 70th Anniversary Showcase alongside with a program of the event. And that\'s all you need to do! Just print your ticket, invite your friends, and enjoy the greatest hits of Fox International Company!</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 53, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb2.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img2.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 31, 0, '', '', 1, 24, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(120, 429, 'London SE in Frankfurt?', 'london-se-in-frankfurt', '<p>Recently our partner, Jerry Conrad Lewis has revealed some of his own global plans alongside with a new set of social measures, designed to improve the world we live in.</p>\r\n', '\r\n<p>Recently our partner, Jerry Conrad Lewis has revealed some of his own global plans alongside with a new set of social measures, designed to improve the world we live in.</p>\r\n<blockquote>\r\n<p>Due to global changes our planet is experiencing, we all have surely thought about something that would complement governmental measures, so that our way of life could be improved.</p>\r\n<cite>Jerry C. Lewis</cite>\r\n</blockquote>\r\n<p>Our partner and good friend who is also a great scientist, has recently revealed some of his own global plans. \"As you probably know, I strive for excellence in every sphere of my activity, be it science or art, and that\'s why I would like to present you how I see changing the future and society for the better\", said Jerry C. Lewis at the Pinarini Ecologic conference in Milan, Italy.<br />\r\nAccording to his words, he extensively deals with various spheres of activity, e.g. technology, traditional art, IT, web design, business consulting etc., and this year he is going to concentrate his efforts on social development and ecological improvement of the environment we all live in.</p>\r\n\r\n<p>\"I hope to improve worldwide social and ecological policies of local governments that influence us as citizens\", said Jerry. He also added that his upcoming innovations would help small companies and individual entrepreneurs to develop and improve their internal infrastructure.</p>\r\n\r\n<p>Here\'s what is planned to be offered to your region during next 12 months:</p>\r\n\r\n<ol>\r\n  <li>Greening encouragement. It means encouraging people to devote more time and efforts to make their region greener, so that it could be possible to resist the urbanization problems.</li>\r\n  <li>	Social experiments. It is a series of social measures used to control the limit of poverty and to help people in need that fill the streets of European and American towns and cities.</li>\r\n  <li>Promoting social projects. It helps social activists and members of international organizations promote their projects as governmental acts, making them easier to implement.</li>\r\n</ol>\r\n<p>Of course, these programs and services won\'t work without your participation. So take your chance today in changing the world around you!</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 54, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img3.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 38, 0, '', '', 1, 24, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(121, 433, 'Elements', 'elements', '<h1 class=\"heading-style-1\">Heading style 1</h1>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.<b>this is strong text</b>  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<h2 class=\"heading-style-2\">Heading style 2</h2>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. <a href=\"#\">this is inline link </a>  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<h3 class=\"heading-style-3\">Heading style 3</h3>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.<mark> this is marked out text</mark>  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<h4 class=\"heading-style-4\">Heading style 4</h4>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<h5 class=\"heading-style-5\">Heading style 5</h5>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<h6 class=\"heading-style-6\">Heading style 6</h6>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.  We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<div class=\"spacer\"></div>\r\n<div class=\"row\">\r\n	<div class=\"col-sm-4\">\r\n		<div class=\"item_img img-intro__none img-offset1\">\r\n			<img src=\"images/elements_img1.jpg\" alt=\"\" />\r\n		</div>\r\n		<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.</p>\r\n	</div>\r\n	<div class=\"col-sm-8\">\r\n		<div class=\"item_img img-intro__left img-offset1\">\r\n			<img src=\"images/elements_img2.jpg\" alt=\"\" />\r\n		</div>\r\n		<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n		<div class=\"row\">\r\n			<div class=\"col-sm-12\">\r\n				<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. </p>\r\n			</div>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"spacer\"></div>\r\n<div class=\"row\">\r\n	    <div class=\"col-sm-4\">\r\n        <ul class=\"list\">\r\n            <li><a href=\"#\">Modern Art</a></li>\r\n            <li><a href=\"#\">Portrait Art</a></li>\r\n            <li><a href=\"#\">Expressionist Paintings</a></li>\r\n            <li><a href=\"#\">Miniature Paintings</a></li>\r\n            <li><a href=\"#\">Experimental Art</a></li>\r\n            <li><a href=\"#\">Tempera Painting​​​​​​​</a></li>\r\n        </ul>\r\n    </div>\r\n    <div class=\"col-sm-4\">\r\n        <ol>\r\n            <li><a href=\"#\">Modern Art</a></li>\r\n            <li><a href=\"#\">Portrait Art</a></li>\r\n            <li><a href=\"#\">Expressionist Paintings</a></li>\r\n            <li><a href=\"#\">Miniature Paintings</a></li>\r\n            <li><a href=\"#\">Experimental Art</a></li>\r\n            <li><a href=\"#\">Tempera Painting​​​​​​​</a></li>\r\n        </ol>\r\n    </div>\r\n</div>\r\n<div class=\"spacer\"></div>\r\n\r\n<blockquote>\r\n	<p>I love your exhibitions; there are many different styles of paintings and a big range of types of art with affordable prices. Seeing so much variety of art is exciting and there\'s something for everyone. I\'ve never been to a gallery before, but after visiting your gallery I feel in love with fine art.</p>\r\n	<small>Mark Johnson</small>\r\n</blockquote>\r\n\r\n<div class=\"spacer\"></div>\r\n<div class=\"page_header\">\r\n	<h1 class=\"center\">Get Started</h1>\r\n</div>\r\n<form>\r\n	<div class=\"row\">\r\n		<div class=\"control control-group-input col-sm-4\">\r\n			<div class=\"controls\">\r\n				<input type=\"text\" placeholder=\"Text input\">\r\n			</div>\r\n			<div class=\"controls\">\r\n				<input type=\"text\" placeholder=\"Text input:\" class=\"error\"><mark><label class=\"error\">This field is required.</label></mark>\r\n			</div>\r\n		</div>\r\n		<div class=\"col-sm-4\">\r\n			<div class=\"controls\">\r\n				<textarea placeholder=\"Text area field\"></textarea>\r\n			</div>\r\n		</div>\r\n		<div class=\"col-sm-4\">\r\n			<div class=\"control-group\">\r\n				<select>\r\n					<option disabled selected value=\"\">Select option</option>\r\n					<option>Option 1</option>\r\n					<option>Option 2</option>\r\n				</select>\r\n			</div>\r\n			<div class=\"row\">\r\n				<div class=\"col-sm-6\">\r\n					<div class=\"control-group reset-margin\">\r\n						<input type=\"checkbox\" id=\"checkbox_1\" checked>\r\n						<label for=\"checkbox_1\" class=\"inline\">Checkbox label</label>\r\n					</div>\r\n					<div class=\"control-group\">\r\n						<input type=\"checkbox\" id=\"checkbox_2\">\r\n						<label for=\"checkbox_2\" class=\"inline\">Checkbox label</label>\r\n					</div>\r\n				</div>\r\n				<div class=\"col-sm-6\">\r\n					<div class=\"control-group reset-margin\">\r\n						<input type=\"radio\" id=\"radio_1\" name=\"radio\" checked>\r\n						<label for=\"radio_1\" class=\"inline\">Radio label</label>\r\n					</div>\r\n					<div class=\"control-group\">\r\n						<input type=\"radio\" id=\"radio_2\" name=\"radio\">\r\n						<label for=\"radio_2\" class=\"inline\">Radio label</label>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class=\"col-sm-12\">\r\n			<a href=\"#\" class=\"btn\">send message</a>\r\n		</div>\r\n	</div>\r\n</form>', '', 1, 62, '2018-06-25 16:06:04', 213, '', '2018-06-27 12:10:32', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 116, 1, '', '', 1, 1830, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(125, 449, 'Leadership', 'conse-ctetu', '', '', 1, 59, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"0\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(126, 450, 'Management', 'dolor-sit-amet-conse', '', '', 1, 59, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"25\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(127, 451, 'Innovation and creativity', 'sit-amet-conse', '', '', 1, 59, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"75\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(128, 452, 'Leadership', 'conse-ctetu', '', '', 1, 60, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"0\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(129, 453, 'Management', 'dolor-sit-amet-conse', '', '', 1, 60, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"25\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(130, 454, 'Innovation and creativity', 'sit-amet-conse', '', '', 1, 60, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"75\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(135, 476, 'Resilience', 'sit-amet-consectetur', '', '', 1, 59, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"100\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(136, 477, 'Resilience', 'sit-amet-consectetur', '', '', 1, 60, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"100\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(137, 479, 'Professional Investment Consulting', 'slide-1', '<p>We are an international acknowledged management consulting firm that provides localized solutions in partnership with our clients. Our aim is to enhance corporate competency and performance through result-based solutions to match clients’ individual requirements.</p>\r\n', '\r\n<p>We are an international acknowledged management consulting firm that provides localized solutions in partnership with our clients. Our aim is to enhance corporate competency and performance through result-based solutions to match clients’ individual requirements.</p>\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>\r\n', 1, 63, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/slider\\/slide-thumb-1.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/slider\\/slide-1.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 13, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(138, 480, 'Set your own pace', 'slide-2', '<p>We are confident about the fact, that clear goals, a long-term investment philosophy, a balanced portfolio, and low costs create a path to your financial goals. There\'s investing, and there\'s smart investing. We\'re the latter, we\'re better!</p>\r\n', '\r\n<p>We are confident about the fact, that clear goals, a long-term investment philosophy, a balanced portfolio, and low costs create a path to your financial goals. There\'s investing, and there\'s smart investing. We\'re the latter, we\'re better!</p>\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>', 1, 63, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/slider\\/slide-thumb-2.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/slider\\/slide-2.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 8, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(139, 481, 'Why You Need an Advisor?', 'slide-3', '<p>We help you in creating a financial strategy that represents your personality. Getting to know you is financial advisor’s primary goal. - An approach centered around your life’s priorities. It’s time for a financial strategy that puts your needs and priorities front and center.</p>\r\n', '\r\n<p>We help you in creating a financial strategy that represents your personality. Getting to know you is financial advisor’s primary goal. - An approach centered around your life’s priorities. It’s time for a financial strategy that puts your needs and priorities front and center.</p>\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>', 1, 63, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/slider\\/slide-thumb-3.jpg\",\"float_intro\":\"left\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/slider\\/slide-3.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 9, 1, '', '', 1, 15, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(164, 778, 'Steven Jackson', 'steven-jackson', '<p class=\"post\">Owner</p>\r\n\r\n', '\r\n<p>Steven co-founded BuildWall in 1990. Steven is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to his clients and to the production crews that he oversees. He is involved in every step of the process. Steven is known for his exceptional attention to organization</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Owner</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Steven co-founded BuildWall in 1990. Steven is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to his clients and to the production crews that he oversees. He is involved in every step of the process.</p>\r\n      <p>Steven is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Steven approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Steven acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:42:00', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-7.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-7.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 5, 7, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(165, 779, 'Andrew Edwards', 'andrew-edwards', '<p class=\"post\">Architect</p>\r\n\r\n', '\r\n<p>Andrew can create design of any complexity. He has 15 years of experience working in industrial design sphere..</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Architect</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Andrew can create design of any complexity. He has 15 years of experience working in industrial design sphere.. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Andrew is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Gary approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Andrew acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:42:30', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-8.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-8.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 8, '', '', 1, 2, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(166, 824, 'Karl Williams', 'karl-williams', '<p class=\"post\">Interior Designer</p>\r\n\r\n', '\r\n<p>Karl Williams began working with BuildWall in 2012. Karl is reliable and safety-oriented with over 10 years of experience.</p>\r\n<div class=\"team-content-wrap\">\r\n	<div class=\"post\">Interior Designer</div>\r\n	<div class=\"team-meta\">\r\n		<div class=\"team-meta-location\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-map-marker\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Address Info</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item location\">4578 Marmora Road, Glasgow</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-phone\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-telephone\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">Phones:</h5>\r\n			<span class=\"team-macros\">\r\n				<span class=\"team-meta_item phone\">+7-495-1234567; +7-495-1234568</span>\r\n			</span>\r\n		</div>\r\n		<div class=\"team-meta-email\">\r\n			<span class=\"team-icon\">\r\n				<i class=\"linearicons-envelope\"></i>\r\n			</span>\r\n			<h5 class=\"team-meta-title\">E-mail:</h5>\r\n			<span class=\"team-email\">\r\n				<a href=\"mailto:info@demolink.org\">info@demolink.org</a>\r\n			</span>\r\n		</div>\r\n	</div>\r\n        <div class=\"team-socials\">\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.facebook.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-facebook\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://twitter.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-twitter\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.google.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-google\"></i>\r\n			</a>\r\n		</div>\r\n		<div class=\"team-socials_item\">\r\n			<a href=\"https://www.instagram.com\" class=\"team-socials_link\" rel=\"nofollow\">\r\n				<i class=\"fa fa-instagram\"></i>\r\n			</a>\r\n		</div>\r\n	</div>\r\n</div>\r\n<div class=\"post-content\">\r\n       <p>Karl Williams began working with BuildWall in 2012. Karl is reliable and safety-oriented with over 10 years of experience. He is also an amazing visualizer who creates the vas majority of our design-projects either for private residences and for commercial ones.</p>\r\n      <p>Karl is known for her exceptional attention to organization and her hands-on approach to management. With twelve years of experience behind him, Karl approaches every project ready to manage a workflow that is efficient, organized, and ultimately successful.</p>\r\n      <p>He is constantly discovering new solutions to issues that arise during the work process and is a dependable supervisor both to him clients and to the production crews that she oversees. Steven acts as a liaison between the production and design teams and the client throughout the entire process of every BuildWall project. Vicky is the eyes and ears of every project and is a trusted presence both to clients and to the architects, managers, and contractors who report to him.</p>\r\n</div>', 1, 26, '2018-06-25 16:06:04', 213, '', '2018-06-30 07:42:49', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/team\\/team-9.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/team\\/team-9.jpg\",\"float_fulltext\":\"left\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"theme3589:team\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 6, 9, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(167, 826, 'Do You Have any Questions?', 'do-you-have-any-questions', '<p>Submit a business inquiry online or visit the nearest office.</p>', '', 1, 43, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/questions.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(168, 829, 'Partner 1', 'partner-1', '<h5 class=\"item_title\">Project Management, Construction</h5>\r\n<h6 class=\"item_subtitle\">2016 revenues: $10.2 billion</h6>\r\n<p>Hytellux is a professional services firm providing engineering consultancy, design, planning, project management and consulting services for all aspects of buildings, infrastructure and the environment.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-01.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 5, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(169, 830, 'Partner 2', 'partner-2', '<h5 class=\"item_title\">Construction, Engineering</h5>\r\n<h6 class=\"item_subtitle\">2017 revenues: $6.5 billion</h6>\r\n<p>Berksho Construction is a Canadian multinational consultancy, engineering and project management company headquartered in Alberta, Canada. It is focused on the infrastructure markets and has offices in over 50 countries worldwide.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-02.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 4, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(170, 831, 'Partner 3', 'partner-3', '<h5 class=\"item_title\">Construction, Manufacturing, Plastic Products</h5>\r\n<h6 class=\"item_subtitle\">2016 revenues: $10.1 billion</h6>\r\n<p>Fatestar Group is a Pennsylvania corporation incorporated in 1891. It is an international designer and manufacturer of floors and ceilings. Based in Lancaster, Pennsylvania, Fatestar Group operates 32 plants in 8 countries.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-03.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(171, 832, 'Partner 4', 'partner-4', '<h5 class=\"item_title\">Project Management, Construction</h5>\r\n<h6 class=\"item_subtitle\">2016 revenues: $8.6 billion</h6>\r\n<p>TMT Corporation is the largest construction and civil engineering company in the United States, ranking as the 4th-largest privately owned company in the United States. Its headquarters are in the South of Market, San Francisco.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-04.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(172, 833, 'Partner 5', 'partner-5', '<h5 class=\"item_title\">Civil Engineering, Construction</h5>\r\n<h6 class=\"item_subtitle\">2016 revenues: $9.7 billion</h6>\r\n<p>Pigliri Pro is a global contracting and development company that designs, builds and maintains property and infrastructure assets. Headquartered in Cranbury, New Jersey, it works all over North America.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-05.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(173, 834, 'Partner 6', 'partner-6', '<h5 class=\"item_title\">Infrastructure, Civil Engineering</h5>\r\n<h6 class=\"item_subtitle\">2016 revenues: $5.2 billion</h6>\r\n<p>Fireball is a global design, engineering and management consulting company based in Toronto, Ontario, Canada. It has its origins in 1868. The company is a member of the Next 150 index.</p>', '', 1, 73, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/partners\\/partner-06.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(174, 837, 'Preconstruction planning', 'preconstruction-planning', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb01.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service01.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 5, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(175, 838, 'Building engineering', 'building-engineering', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>\r\n', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb02.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service02.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 4, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(176, 839, 'Interior design', 'interior-design', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>\r\n', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 213, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb03.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service03.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 3, '', '', 1, 8, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(177, 840, 'Architecture & building', 'architecture-building', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>\r\n', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb04.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service04.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(178, 841, 'House renovation', 'house-renovation', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>\r\n', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb05.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service05.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 1, '', '', 1, 1, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`, `note`) VALUES
(179, 842, 'Construction Consultant', 'construction-consultant', '<p>You will have a meeting with one of our consultants and discuss all the details regarding your future project.</p>\r\n', '\r\n<div class=\"service-content\">\r\n  <h5>Service overview</h5>\r\n  <p>With experience in commercial contracting and professional industry practices, our consultants understand technical, business, regulatory and legal matters, allowing them to identify key issues quickly and find the best solutions for our clients. Our clients hire us to ensure that every aspect of their capital program or project is properly governed, well-executed and fully supported from beginning to end.</p>\r\n  <p>BuildWall Consulting draws on its breadth of international construction experience and knowledge to deliver the best outcome for our clients, wherever their projects may be located.</p>\r\n\r\n    <div class=\"row\">\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img1.jpg\" alt=\"\">\r\n      </div>\r\n      <div class=\"col-sm-6\">\r\n        <img src=\"images/elements_img2.jpg\" alt=\"\">\r\n      </div>\r\n    </div>\r\n\r\n  <h5>Details</h5>\r\n  <p>Our professionals are industry leaders who understand technical, business, regulatory and legal matters and are seasoned in giving expert testimony. They represent top talent across disciplines, including engineers, architects, accountants, quantity surveyors, planning and scheduling specialists, cost engineers, project managers communications professionals.</p>\r\n  <table class=\"service-table\">\r\n    <tbody>\r\n      <tr>\r\n        <th>Construction Advisory</th>\r\n        <td>Defining the key construction issues</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Cost Analytics</th>\r\n        <td>Discussing preliminary estimate</td>\r\n      </tr>\r\n      <tr>\r\n        <th>Risk Management</th>\r\n        <td>Eliminating possible risks</td>\r\n      </tr>\r\n     <tr>\r\n        <th>Planning &amp; Scheduling</th>\r\n        <td>Discussing future plan of work </td>\r\n      </tr>\r\n      <tr>\r\n        <th>Contract</th>\r\n        <td>Reading the contract</td>\r\n      </tr>\r\n    </tbody>\r\n  </table>\r\n  <h5>Our price list</h5>\r\n  {loadmodule mod_articles_news_adv, Services prices}\r\n  {loadmodule mod_bootstrap_collapse, Popular questions}\r\n</div>\r\n', 1, 74, '2018-06-25 16:06:04', 213, '', '2018-06-25 16:06:04', 0, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/services\\/service-thumb06.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/services\\/service06.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(180, 850, 'Magical World of Art', 'magical-world-of-art', '<p><b>Welcome this magical world of art, masterpieces and amazing collections!</b></p>\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n', '\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n', 1, 2, '2018-06-28 10:20:41', 846, '', '2018-06-28 10:55:28', 846, 0, '0000-00-00 00:00:00', '2018-06-28 10:20:41', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"more info\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 4, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(181, 856, 'Meet Our Experts', 'meet-our-experts', '<p>Need an expert opinion? Our dedicated staff works to ensure that all the details of the artists\' representation are handled efficiently.</p>\r\n', '\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>', 1, 75, '2018-06-29 10:45:11', 846, '', '2018-06-29 10:45:11', 0, 0, '0000-00-00 00:00:00', '2018-06-29 10:45:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"linearicons linearicons-users2 \",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 1, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(182, 857, 'Tour the Gallery', 'tour-the-gallery', '<p>The Gallery is located in the heart of New York City’s renowned Chelsea art district, home to some of the world’s most prestigious galleries.</p>\r\n', '\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>', 1, 75, '2018-06-29 10:45:11', 846, '', '2018-06-29 10:51:53', 846, 0, '0000-00-00 00:00:00', '2018-06-29 10:45:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"linearicons linearicons-picture2 \",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(183, 858, 'Visitor Information', 'visitor-information', '<p>The Gallery showcases the variety and skill present in contemporary art – so be sure to visit us during your time in our city!</p>\r\n', '\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n<p>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide. We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>', 1, 75, '2018-06-29 10:45:11', 846, '', '2018-06-29 10:53:08', 846, 0, '0000-00-00 00:00:00', '2018-06-29 10:45:11', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"linearicons linearicons-document2 \",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(184, 859, 'exhibitions', 'peasant-scenes-and-landscapes', '<h1>Peasant Scenes and Landscapes</h1>\r\n<div class=\'list-1\'>\r\n    <ul class=\'list\'>\r\n        <li><i class=\"flinearicons linearicons-clock3 \"></i> 19 July - 19 August, 2018</li>\r\n        <li><i class=\"linearicons linearicons-map-marker \"></i>WEST, LONDON MUSEUM</li>\r\n    </ul>\r\n</div>\r\n<p>This exhibition was named after world-known book by Larry Silver, although there is no connection with the content. It’s fully devoted to gorgeous landscapes of North America depicted by the best US modern artists.</p>\r\n', '\r\n<p>This exhibition was named after world-known book by Larry Silver, although there is no connection with the content. It’s fully devoted to gorgeous landscapes of North America depicted by the best US modern artists.</p>\r\n<p>This exhibition was named after world-known book by Larry Silver, although there is no connection with the content. It’s fully devoted to gorgeous landscapes of North America depicted by the best US modern artists.</p>\r\n<p>This exhibition was named after world-known book by Larry Silver, although there is no connection with the content. It’s fully devoted to gorgeous landscapes of North America depicted by the best US modern artists.</p>', 1, 2, '2018-06-29 11:51:19', 846, '', '2018-06-29 12:15:01', 846, 0, '0000-00-00 00:00:00', '2018-06-29 11:51:19', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/home\\/page1_img2.jpg\",\"float_intro\":\"right\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/home\\/page1_img2.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"more info\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 7, 1, '', '', 1, 3, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(185, 863, 'Etching Demonstration', 'etching-demonstration', '<p>Meet the renowned artists during their demonstrations on September 4th through 7th...</p>\r\n', '\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 49, '2018-06-25 16:06:04', 213, '', '2018-06-29 14:30:36', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb9.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img9.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(186, 865, 'Miniature Art Show', 'miniature-art-show', '<p>Visit the world\'s most original Miniature Art Show that will take place in our art gallery...</p>\r\n', '\r\n<p>James R. Bernard is famous for his unique style of paintings that comprises elements of contemporary and abstract art as well as photography and computer graphics. This approach allows him to transfer images of the surrounding world into canvas preserving the original idea of the author. In one of his latest interviews, James said that the atmosphere of sunny weather and friendly people had always attracted him and had been a great source of inspiration for a lot of his widely known artworks, it was not a surprise that the exhibition of his school\'s artworks would take place in this great city.</p>\r\n\r\n<p>Recent years have showed a great rise of Bernard\'s paintings popularity among young people and businessmen. \"It is not a coincidence\", says Jessica McMillan, James Bernard\'s manager. \"Today people want to experience a wide range of emotions when they look at the painting of an artist. James knows what modern lovers of art need, and he expresses it through his innovative and captivating artworks.\"</p>\r\n\r\n<div class=\"video_frame\" style=\"padding-top: 56%\"><iframe src=\"http://www.youtube.com/embed/Ok2VamxrYAY?rel=0&amp;controls=0&amp;showinfo=0&amp;wmode=transparent\" allowfullscreen>&nbsp;</iframe></div>', 1, 49, '2018-06-25 16:06:04', 213, '', '2018-06-29 14:31:45', 846, 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/blog\\/blog-thumb3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img10.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(187, 868, 'We Are ARTESMA', 'we-are-artesma', '<p><b>It is our mission to make it easy for you to discover and collect fine art from renowned artists, galleries, and cultural institutions worldwide.  </b></p>\r\n<p>We celebrate creativity, openness, tolerance, and generosity. We aim to be inclusive places—both onsite and online—where diverse cultural, artistic, social, and political positions are welcome. We’re committed to sharing the most thought-provoking modern and contemporary art, and hope you will join us in exploring the art, ideas, and issues of our time.</p>\r\n', '\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>\r\n<p>Our Gallery was established by Helen Stone to provide opportunities to artists entering the global art market. Ms. Stone was a visionary who founded the gallery on the principle that all artists benefit from having their artwork promoted by a professional gallery. </p>', 1, 2, '2018-06-28 10:20:41', 846, '', '2018-06-29 16:15:20', 846, 0, '0000-00-00 00:00:00', '2018-06-28 10:20:41', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/about\\/page2_img1.jpg\",\"float_intro\":\"right\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/about\\/page2_img1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"more info\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 5, 0, '', '', 1, 6, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(188, 871, 'Years of Experience', 'years-of-experience', '<p>Our gallery was established in 2002 to display masterpieces from all over the world.</p>', '', 1, 76, '2018-06-29 16:41:32', 846, '', '2018-06-29 16:41:54', 846, 0, '0000-00-00 00:00:00', '2018-06-29 16:41:32', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"15\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 3, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(189, 872, ' Famous Artists', 'famous-artists', '<p>We have gathered the greatest artworks of 20th century.</p>', '', 1, 76, '2018-06-29 16:41:32', 846, '', '2018-06-29 16:42:46', 846, 0, '0000-00-00 00:00:00', '2018-06-29 16:41:32', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"34\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 2, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(190, 873, ' Successful Exhibitions', 'successful-exhibitions', '<p>Amazing collections of modern and experimental art, abstract and portrait art  was represented in our gallery.</p>', '', 1, 76, '2018-06-29 16:41:32', 846, '', '2018-06-29 16:43:23', 846, 0, '0000-00-00 00:00:00', '2018-06-29 16:41:32', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"89\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 2, 1, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', ''),
(191, 874, 'Current Exhibitions', 'current-exhibitions', '<p>We have a selection of thousands of artworks from some of the best names in contemporary fine art.</p>', '', 1, 76, '2018-06-29 16:41:32', 846, '', '2018-06-30 06:46:12', 846, 0, '0000-00-00 00:00:00', '2018-06-29 16:41:32', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"25\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 3, 0, '', '', 1, 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 0, '*', '', '');

DROP TABLE IF EXISTS `#__contentitem_tag_map`;
CREATE TABLE IF NOT EXISTS `#__contentitem_tag_map` (
  `type_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `core_content_id` int(10) UNSIGNED NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) UNSIGNED NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table',
  UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`),
  KEY `idx_tag_type` (`tag_id`,`type_id`),
  KEY `idx_date_id` (`tag_date`,`tag_id`),
  KEY `idx_core_content_id` (`core_content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Maps items from content tables to tags';

INSERT INTO `#__contentitem_tag_map` (`type_alias`, `core_content_id`, `content_item_id`, `tag_id`, `tag_date`, `type_id`) VALUES
('com_content.article', 1, 11, 7, '2018-06-25 16:06:04', 1),
('com_content.article', 1, 11, 17, '2018-06-25 16:06:04', 1),
('com_content.article', 5, 12, 9, '2018-06-25 16:06:04', 1),
('com_content.article', 5, 12, 10, '2018-06-25 16:06:04', 1),
('com_content.article', 4, 13, 3, '2018-06-25 16:06:04', 1),
('com_content.article', 4, 13, 8, '2018-06-25 16:06:04', 1),
('com_content.article', 6, 14, 11, '2018-06-29 13:25:33', 1),
('com_content.article', 6, 14, 12, '2018-06-29 13:25:33', 1),
('com_content.article', 8, 15, 15, '2018-06-25 16:06:04', 1),
('com_content.article', 8, 15, 16, '2018-06-25 16:06:04', 1),
('com_content.article', 9, 118, 7, '2018-06-25 16:06:04', 1),
('com_content.article', 9, 118, 17, '2018-06-25 16:06:04', 1),
('com_content.article', 10, 119, 4, '2018-06-25 16:06:04', 1),
('com_content.article', 10, 119, 14, '2018-06-25 16:06:04', 1),
('com_content.article', 11, 120, 3, '2018-06-25 16:06:04', 1),
('com_content.article', 11, 120, 5, '2018-06-25 16:06:04', 1),
('com_content.article', 11, 120, 6, '2018-06-25 16:06:04', 1),
('com_content.article', 12, 185, 11, '2018-06-29 14:30:36', 1),
('com_content.article', 12, 185, 12, '2018-06-29 14:30:36', 1),
('com_content.article', 13, 186, 11, '2018-06-29 14:31:45', 1),
('com_content.article', 13, 186, 12, '2018-06-29 14:31:45', 1);

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(75, 2),
(88, 1);

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `rating_count` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lastip` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__content_types`;
CREATE TABLE IF NOT EXISTS `#__content_types` (
  `type_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `type_title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `type_alias` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `table` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `rules` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `field_mappings` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `router` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `content_history_options` varchar(5120) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'JSON string for com_contenthistory options',
  PRIMARY KEY (`type_id`),
  KEY `idx_alias` (`type_alias`(100))
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__content_types` (`type_id`, `type_title`, `type_alias`, `table`, `rules`, `field_mappings`, `router`, `content_history_options`) VALUES
(1, 'Article', 'com_content.article', '{\"special\":{\"dbtable\":\"#__content\",\"key\":\"id\",\"type\":\"Content\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"state\",\"core_alias\":\"alias\",\"core_created_time\":\"created\",\"core_modified_time\":\"modified\",\"core_body\":\"introtext\", \"core_hits\":\"hits\",\"core_publish_up\":\"publish_up\",\"core_publish_down\":\"publish_down\",\"core_access\":\"access\", \"core_params\":\"attribs\", \"core_featured\":\"featured\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"images\", \"core_urls\":\"urls\", \"core_version\":\"version\", \"core_ordering\":\"ordering\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"catid\", \"core_xreference\":\"xreference\", \"asset_id\":\"asset_id\", \"note\":\"note\"}, \"special\":{\"fulltext\":\"fulltext\"}}', 'ContentHelperRoute::getArticleRoute', '{\"formFile\":\"administrator\\/components\\/com_content\\/models\\/forms\\/article.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\"],\"ignoreChanges\":[\"modified_by\", \"modified\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\"],\"convertToInt\":[\"publish_up\", \"publish_down\", \"featured\", \"ordering\"],\"displayLookup\":[{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"created_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"} ]}'),
(2, 'Weblink', 'com_weblinks.weblink', '{\"special\":{\"dbtable\":\"#__weblinks\",\"key\":\"id\",\"type\":\"Weblink\",\"prefix\":\"WeblinksTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"state\",\"core_alias\":\"alias\",\"core_created_time\":\"created\",\"core_modified_time\":\"modified\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"publish_up\",\"core_publish_down\":\"publish_down\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"featured\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"images\", \"core_urls\":\"urls\", \"core_version\":\"version\", \"core_ordering\":\"ordering\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"catid\", \"core_xreference\":\"xreference\", \"asset_id\":\"null\"}, \"special\":{}}', 'WeblinksHelperRoute::getWeblinkRoute', '{\"formFile\":\"administrator\\/components\\/com_weblinks\\/models\\/forms\\/weblink.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"featured\",\"images\"], \"ignoreChanges\":[\"modified_by\", \"modified\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\"], \"convertToInt\":[\"publish_up\", \"publish_down\", \"featured\", \"ordering\"], \"displayLookup\":[{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"created_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"} ]}'),
(3, 'Contact', 'com_contact.contact', '{\"special\":{\"dbtable\":\"#__contact_details\",\"key\":\"id\",\"type\":\"Contact\",\"prefix\":\"ContactTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"name\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created\",\"core_modified_time\":\"modified\",\"core_body\":\"address\", \"core_hits\":\"hits\",\"core_publish_up\":\"publish_up\",\"core_publish_down\":\"publish_down\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"featured\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"image\", \"core_urls\":\"webpage\", \"core_version\":\"version\", \"core_ordering\":\"ordering\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"catid\", \"core_xreference\":\"xreference\", \"asset_id\":\"null\"}, \"special\":{\"con_position\":\"con_position\",\"suburb\":\"suburb\",\"state\":\"state\",\"country\":\"country\",\"postcode\":\"postcode\",\"telephone\":\"telephone\",\"fax\":\"fax\",\"misc\":\"misc\",\"email_to\":\"email_to\",\"default_con\":\"default_con\",\"user_id\":\"user_id\",\"mobile\":\"mobile\",\"sortname1\":\"sortname1\",\"sortname2\":\"sortname2\",\"sortname3\":\"sortname3\"}}', 'ContactHelperRoute::getContactRoute', '{\"formFile\":\"administrator\\/components\\/com_contact\\/models\\/forms\\/contact.xml\",\"hideFields\":[\"default_con\",\"checked_out\",\"checked_out_time\",\"version\",\"xreference\"],\"ignoreChanges\":[\"modified_by\", \"modified\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\"],\"convertToInt\":[\"publish_up\", \"publish_down\", \"featured\", \"ordering\"], \"displayLookup\":[ {\"sourceColumn\":\"created_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"} ] }'),
(4, 'Newsfeed', 'com_newsfeeds.newsfeed', '{\"special\":{\"dbtable\":\"#__newsfeeds\",\"key\":\"id\",\"type\":\"Newsfeed\",\"prefix\":\"NewsfeedsTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"name\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created\",\"core_modified_time\":\"modified\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"publish_up\",\"core_publish_down\":\"publish_down\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"featured\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"images\", \"core_urls\":\"link\", \"core_version\":\"version\", \"core_ordering\":\"ordering\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"catid\", \"core_xreference\":\"xreference\", \"asset_id\":\"null\"}, \"special\":{\"numarticles\":\"numarticles\",\"cache_time\":\"cache_time\",\"rtl\":\"rtl\"}}', 'NewsfeedsHelperRoute::getNewsfeedRoute', '{\"formFile\":\"administrator\\/components\\/com_newsfeeds\\/models\\/forms\\/newsfeed.xml\",\"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\"],\"ignoreChanges\":[\"modified_by\", \"modified\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\"],\"convertToInt\":[\"publish_up\", \"publish_down\", \"featured\", \"ordering\"],\"displayLookup\":[{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"created_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"} ]}'),
(5, 'User', 'com_users.user', '{\"special\":{\"dbtable\":\"#__users\",\"key\":\"id\",\"type\":\"User\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"name\",\"core_state\":\"null\",\"core_alias\":\"username\",\"core_created_time\":\"registerdate\",\"core_modified_time\":\"lastvisitDate\",\"core_body\":\"null\", \"core_hits\":\"null\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"access\":\"null\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"null\", \"core_language\":\"null\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"null\", \"core_ordering\":\"null\", \"core_metakey\":\"null\", \"core_metadesc\":\"null\", \"core_catid\":\"null\", \"core_xreference\":\"null\", \"asset_id\":\"null\"}, \"special\":{}}', 'UsersHelperRoute::getUserRoute', ''),
(6, 'Article Category', 'com_content.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', 'ContentHelperRoute::getCategoryRoute', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"],\"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}'),
(7, 'Contact Category', 'com_contact.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', 'ContactHelperRoute::getCategoryRoute', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"],\"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}'),
(8, 'Newsfeeds Category', 'com_newsfeeds.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', 'NewsfeedsHelperRoute::getCategoryRoute', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"],\"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}'),
(9, 'Weblinks Category', 'com_weblinks.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', 'WeblinksHelperRoute::getCategoryRoute', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"],\"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}'),
(10, 'Tag', 'com_tags.tag', '{\"special\":{\"dbtable\":\"#__tags\",\"key\":\"tag_id\",\"type\":\"Tag\",\"prefix\":\"TagsTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"featured\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"images\", \"core_urls\":\"urls\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"null\", \"core_xreference\":\"null\", \"asset_id\":\"null\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\"}}', 'TagsHelperRoute::getTagRoute', '{\"formFile\":\"administrator\\/components\\/com_tags\\/models\\/forms\\/tag.xml\", \"hideFields\":[\"checked_out\",\"checked_out_time\",\"version\", \"lft\", \"rgt\", \"level\", \"path\", \"urls\", \"publish_up\", \"publish_down\"],\"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"],\"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}, {\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}, {\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}]}'),
(11, 'Banner', 'com_banners.banner', '{\"special\":{\"dbtable\":\"#__banners\",\"key\":\"id\",\"type\":\"Banner\",\"prefix\":\"BannersTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"name\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created\",\"core_modified_time\":\"modified\",\"core_body\":\"description\", \"core_hits\":\"null\",\"core_publish_up\":\"publish_up\",\"core_publish_down\":\"publish_down\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"images\", \"core_urls\":\"link\", \"core_version\":\"version\", \"core_ordering\":\"ordering\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"catid\", \"core_xreference\":\"null\", \"asset_id\":\"null\"}, \"special\":{\"imptotal\":\"imptotal\", \"impmade\":\"impmade\", \"clicks\":\"clicks\", \"clickurl\":\"clickurl\", \"custombannercode\":\"custombannercode\", \"cid\":\"cid\", \"purchase_type\":\"purchase_type\", \"track_impressions\":\"track_impressions\", \"track_clicks\":\"track_clicks\"}}', '', '{\"formFile\":\"administrator\\/components\\/com_banners\\/models\\/forms\\/banner.xml\", \"hideFields\":[\"checked_out\",\"checked_out_time\",\"version\", \"reset\"],\"ignoreChanges\":[\"modified_by\", \"modified\", \"checked_out\", \"checked_out_time\", \"version\", \"imptotal\", \"impmade\", \"reset\"], \"convertToInt\":[\"publish_up\", \"publish_down\", \"ordering\"], \"displayLookup\":[{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}, {\"sourceColumn\":\"cid\",\"targetTable\":\"#__banner_clients\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}, {\"sourceColumn\":\"created_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"modified_by\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"} ]}'),
(12, 'Banners Category', 'com_banners.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\": {\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', '', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"asset_id\",\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"], \"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}'),
(13, 'Banner Client', 'com_banners.client', '{\"special\":{\"dbtable\":\"#__banner_clients\",\"key\":\"id\",\"type\":\"Client\",\"prefix\":\"BannersTable\"}}', '', '', '', '{\"formFile\":\"administrator\\/components\\/com_banners\\/models\\/forms\\/client.xml\", \"hideFields\":[\"checked_out\",\"checked_out_time\"], \"ignoreChanges\":[\"checked_out\", \"checked_out_time\"], \"convertToInt\":[], \"displayLookup\":[]}'),
(14, 'User Notes', 'com_users.note', '{\"special\":{\"dbtable\":\"#__user_notes\",\"key\":\"id\",\"type\":\"Note\",\"prefix\":\"UsersTable\"}}', '', '', '', '{\"formFile\":\"administrator\\/components\\/com_users\\/models\\/forms\\/note.xml\", \"hideFields\":[\"checked_out\",\"checked_out_time\", \"publish_up\", \"publish_down\"],\"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\"], \"convertToInt\":[\"publish_up\", \"publish_down\"],\"displayLookup\":[{\"sourceColumn\":\"catid\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}, {\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}, {\"sourceColumn\":\"user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}, {\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}]}'),
(15, 'User Notes Category', 'com_users.category', '{\"special\":{\"dbtable\":\"#__categories\",\"key\":\"id\",\"type\":\"Category\",\"prefix\":\"JTable\",\"config\":\"array()\"},\"common\":{\"dbtable\":\"#__ucm_content\",\"key\":\"ucm_id\",\"type\":\"Corecontent\",\"prefix\":\"JTable\",\"config\":\"array()\"}}', '', '{\"common\":{\"core_content_item_id\":\"id\",\"core_title\":\"title\",\"core_state\":\"published\",\"core_alias\":\"alias\",\"core_created_time\":\"created_time\",\"core_modified_time\":\"modified_time\",\"core_body\":\"description\", \"core_hits\":\"hits\",\"core_publish_up\":\"null\",\"core_publish_down\":\"null\",\"core_access\":\"access\", \"core_params\":\"params\", \"core_featured\":\"null\", \"core_metadata\":\"metadata\", \"core_language\":\"language\", \"core_images\":\"null\", \"core_urls\":\"null\", \"core_version\":\"version\", \"core_ordering\":\"null\", \"core_metakey\":\"metakey\", \"core_metadesc\":\"metadesc\", \"core_catid\":\"parent_id\", \"core_xreference\":\"null\", \"asset_id\":\"asset_id\"}, \"special\":{\"parent_id\":\"parent_id\",\"lft\":\"lft\",\"rgt\":\"rgt\",\"level\":\"level\",\"path\":\"path\",\"extension\":\"extension\",\"note\":\"note\"}}', '', '{\"formFile\":\"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml\", \"hideFields\":[\"checked_out\",\"checked_out_time\",\"version\",\"lft\",\"rgt\",\"level\",\"path\",\"extension\"], \"ignoreChanges\":[\"modified_user_id\", \"modified_time\", \"checked_out\", \"checked_out_time\", \"version\", \"hits\", \"path\"], \"convertToInt\":[\"publish_up\", \"publish_down\"], \"displayLookup\":[{\"sourceColumn\":\"created_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"}, {\"sourceColumn\":\"access\",\"targetTable\":\"#__viewlevels\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"},{\"sourceColumn\":\"modified_user_id\",\"targetTable\":\"#__users\",\"targetColumn\":\"id\",\"displayColumn\":\"name\"},{\"sourceColumn\":\"parent_id\",\"targetTable\":\"#__categories\",\"targetColumn\":\"id\",\"displayColumn\":\"title\"}]}');

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE IF NOT EXISTS `#__core_log_searches` (
  `search_term` varchar(128) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE IF NOT EXISTS `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Parent package ID for extensions installed as a package.',
  `name` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL,
  `element` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL,
  `folder` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '0',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `custom_data` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `system_data` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10243 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__extensions` (`extension_id`, `package_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 0, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mailto\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 0, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"wrapper\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 0, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 0, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"banners\"}', '{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\",\"save_history\":\"0\",\"history_limit\":5}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 0, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 0, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 0, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 0, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contact\"}', '{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"save_history\":\"0\",\"history_limit\":5,\"show_contact_list\":\"1\",\"presentation_style\":\"plain\",\"show_name\":\"0\",\"show_position\":\"0\",\"show_email\":\"0\",\"show_street_address\":\"0\",\"show_suburb\":\"0\",\"show_state\":\"0\",\"show_postcode\":\"0\",\"show_country\":\"0\",\"show_telephone\":\"0\",\"show_mobile\":\"0\",\"show_fax\":\"0\",\"show_webpage\":\"0\",\"show_misc\":\"1\",\"show_image\":\"0\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_tags\":\"1\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_cat_tags\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"filter_field\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"1\",\"show_fax_headings\":\"1\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"initial_sort\":\"ordering\",\"captcha\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 0, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 0, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 0, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 0, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 0, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"media\"}', '{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 0, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 0, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 0, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 0, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"newsfeeds\"}', '{\"newsfeed_layout\":\"_:default\",\"save_history\":\"0\",\"history_limit\":5,\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_character_count\":\"0\",\"feed_display_order\":\"des\",\"float_first\":\"right\",\"float_second\":\"right\",\"show_tags\":\"1\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_cat_tags\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"filter_field\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 0, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 0, 'com_search', 'component', 'com_search', '', 1, 1, 1, 0, '{\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"search\"}', '{\"enabled\":\"0\",\"show_date\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 0, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"template_positions_display\":\"0\",\"upload_limit\":\"2\",\"image_formats\":\"gif,bmp,jpg,jpeg,png\",\"source_formats\":\"txt,less,ini,xml,js,php,css\",\"font_formats\":\"woff,ttf,otf\",\"compressed_formats\":\"zip\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 0, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2014 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"target\":\"0\",\"save_history\":\"0\",\"history_limit\":5,\"count_clicks\":\"1\",\"icons\":1,\"link_icons\":\"\",\"float_first\":\"right\",\"float_second\":\"right\",\"show_tags\":\"1\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_links\":\"1\",\"show_cat_tags\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_links_cat\":\"1\",\"filter_field\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"0\",\"show_link_description\":\"1\",\"show_link_hits\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 0, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"content\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"info_block_show_title\":\"1\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_associations\":\"0\",\"flags\":\"1\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_tags\":\"1\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"0\",\"captcha\":\"\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"save_history\":\"0\",\"history_limit\":10,\"show_urls_images_frontend\":\"1\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"none\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_heading_title_text\":\"1\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"0\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"0\",\"show_subcat_desc\":\"0\",\"show_cat_num_articles\":\"0\",\"show_cat_tags\":\"1\",\"show_base_description\":\"0\",\"maxLevelcat\":\"1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"0\",\"show_cat_num_articles_cat\":\"0\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"-1\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"list_show_votes\":\"0\",\"list_show_ratings\":\"0\",\"orderby_pri\":\"order\",\"orderby_sec\":\"order\",\"order_date\":\"published\",\"show_pagination\":\"0\",\"show_pagination_results\":\"0\",\"show_featured\":\"show\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"feed_show_readmore\":\"0\",\"custom_fields_enable\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 0, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}', '{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"9\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 0, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 0, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"users\"}', '{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"9\",\"sendpassword\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"0\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"minimum_length\":\"4\",\"minimum_integers\":\"0\",\"minimum_symbols\":\"0\",\"minimum_uppercase\":\"0\",\"save_history\":\"1\",\"history_limit\":5,\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(27, 0, 'com_finder', 'component', 'com_finder', '', 1, 1, 0, 0, '{\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"finder\"}', '{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(28, 0, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 0, 1, '{\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.6.2\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(29, 0, 'com_tags', 'component', 'com_tags', '', 1, 1, 1, 1, '{\"name\":\"com_tags\",\"type\":\"component\",\"creationDate\":\"December 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"COM_TAGS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"tags\"}', '{\"tag_layout\":\"_:default\",\"save_history\":\"0\",\"history_limit\":5,\"show_tag_title\":\"0\",\"tag_list_show_tag_image\":\"1\",\"tag_list_show_tag_description\":\"1\",\"tag_list_image\":\"\",\"show_tag_num_items\":\"0\",\"tag_list_orderby\":\"c.core_title\",\"tag_list_orderby_direction\":\"ASC\",\"show_headings\":\"1\",\"tag_list_show_date\":\"published\",\"tag_list_show_item_image\":\"1\",\"tag_list_show_item_description\":\"1\",\"tag_list_item_maximum_characters\":10000,\"min_term_length\":\"3\",\"return_any_or_all\":\"1\",\"include_children\":\"0\",\"maximum\":200,\"tag_list_language_filter\":\"all\",\"tags_layout\":\"_:default\",\"all_tags_orderby\":\"publish_up\",\"all_tags_orderby_direction\":\"ASC\",\"all_tags_show_tag_image\":\"1\",\"all_tags_show_tag_descripion\":\"1\",\"all_tags_tag_maximum_characters\":10000,\"all_tags_show_tag_hits\":\"0\",\"filter_field\":\"0\",\"show_pagination_limit\":\"0\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"tag_field_ajax_mode\":\"0\",\"show_feed_link\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(30, 0, 'com_contenthistory', 'component', 'com_contenthistory', '', 1, 1, 1, 0, '{\"name\":\"com_contenthistory\",\"type\":\"component\",\"creationDate\":\"May 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.0\",\"description\":\"COM_CONTENTHISTORY_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contenthistory\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(31, 0, 'com_ajax', 'component', 'com_ajax', '', 1, 1, 1, 0, '{\"name\":\"com_ajax\",\"type\":\"component\",\"creationDate\":\"August 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.0\",\"description\":\"COM_AJAX_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"ajax\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(32, 0, 'com_postinstall', 'component', 'com_postinstall', '', 1, 1, 1, 1, '{\"name\":\"com_postinstall\",\"type\":\"component\",\"creationDate\":\"September 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.0\",\"description\":\"COM_POSTINSTALL_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(35, 0, 'com_privacy', 'component', 'com_privacy', '', 1, 1, 1, 1, '{\"name\":\"com_privacy\",\"type\":\"component\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"COM_PRIVACY_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"privacy\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(36, 0, 'com_actionlogs', 'component', 'com_actionlogs', '', 1, 1, 1, 1, '{\"name\":\"com_actionlogs\",\"type\":\"component\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"COM_ACTIONLOGS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"ip_logging\":0,\"csv_delimiter\":\",\",\"loggable_extensions\":[\"com_banners\",\"com_cache\",\"com_categories\",\"com_checkin\",\"com_config\",\"com_contact\",\"com_content\",\"com_installer\",\"com_media\",\"com_menus\",\"com_messages\",\"com_modules\",\"com_newsfeeds\",\"com_plugins\",\"com_redirect\",\"com_tags\",\"com_templates\",\"com_users\"]}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 0, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, 'false', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 0, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"simplepie\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 0, 'LIB_PHPUTF8', 'library', 'phputf8', '', 0, 1, 1, 1, '{\"name\":\"LIB_PHPUTF8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"phputf8\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 0, 'LIB_JOOMLA', 'library', 'joomla', '', 0, 1, 1, 1, '{\"name\":\"LIB_JOOMLA\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"https:\\/\\/www.joomla.org\",\"version\":\"13.1\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '{\"mediaversion\":\"69edebc11a4c714c2d211ace8965238d\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(104, 0, 'LIB_IDNA', 'library', 'idna_convert', '', 0, 1, 1, 1, '{\"name\":\"LIB_IDNA\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"phlyLabs\",\"copyright\":\"2004-2011 phlyLabs Berlin, http:\\/\\/phlylabs.de\",\"authorEmail\":\"phlymail@phlylabs.de\",\"authorUrl\":\"http:\\/\\/phlylabs.de\",\"version\":\"0.8.0\",\"description\":\"LIB_IDNA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"idna_convert\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(105, 0, 'FOF', 'library', 'fof', '', 0, 1, 1, 1, '{\"name\":\"FOF\",\"type\":\"library\",\"creationDate\":\"2015-04-22 13:15:32\",\"author\":\"Nicholas K. Dionysopoulos \\/ Akeeba Ltd\",\"copyright\":\"(C)2011-2015 Nicholas K. Dionysopoulos\",\"authorEmail\":\"nicholas@akeebabackup.com\",\"authorUrl\":\"https:\\/\\/www.akeebabackup.com\",\"version\":\"2.4.3\",\"description\":\"LIB_FOF_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"fof\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(106, 0, 'LIB_PHPASS', 'library', 'phpass', '', 0, 1, 1, 1, '{\"name\":\"LIB_PHPASS\",\"type\":\"library\",\"creationDate\":\"2004-2006\",\"author\":\"Solar Designer\",\"copyright\":\"\",\"authorEmail\":\"solar@openwall.com\",\"authorUrl\":\"http:\\/\\/www.openwall.com\\/phpass\\/\",\"version\":\"0.3\",\"description\":\"LIB_PHPASS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"phpass\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 0, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_archive\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 0, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_latest\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 0, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_popular\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 0, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 0, '{\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_banners\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 0, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_breadcrumbs\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 0, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_custom\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 0, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 0, '{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_feed\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 0, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 0, '{\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_footer\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 0, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_login\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 0, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_menu\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 0, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_news\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 0, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_random_image\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 0, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_related_items\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 0, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_search\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 0, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_stats\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 0, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_syndicate\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 0, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 0, '{\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_users_latest\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 0, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2014 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 0, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_whosonline\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 0, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_wrapper\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 0, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_category\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 0, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 0, '{\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_articles_categories\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 0, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.5.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_languages\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(223, 0, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 0, 0, '{\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_finder\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 0, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_custom\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 0, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_feed\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 0, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_latest\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 0, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_logged\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 0, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_login\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 0, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_menu\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 0, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_popular\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 0, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_quickicon\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 0, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_status\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 0, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_submenu\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 0, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_title\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 0, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_toolbar\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 0, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_multilangstatus\"}', '{\"cache\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(314, 0, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_version\"}', '{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(315, 0, 'mod_stats_admin', 'module', 'mod_stats_admin', '', 1, 1, 1, 0, '{\"name\":\"mod_stats_admin\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_stats_admin\"}', '{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(316, 0, 'mod_tags_popular', 'module', 'mod_tags_popular', '', 0, 1, 1, 0, '{\"name\":\"mod_tags_popular\",\"type\":\"module\",\"creationDate\":\"January 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"MOD_TAGS_POPULAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_tags_popular\"}', '{\"maximum\":\"5\",\"timeframe\":\"alltime\",\"owncache\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(317, 0, 'mod_tags_similar', 'module', 'mod_tags_similar', '', 0, 1, 1, 0, '{\"name\":\"mod_tags_similar\",\"type\":\"module\",\"creationDate\":\"January 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.1.0\",\"description\":\"MOD_TAGS_SIMILAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_tags_similar\"}', '{\"maximum\":\"5\",\"matchtype\":\"any\",\"owncache\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `package_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(318, 0, 'mod_sampledata', 'module', 'mod_sampledata', '', 1, 1, 1, 0, '{\"name\":\"mod_sampledata\",\"type\":\"module\",\"creationDate\":\"July 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.8.0\",\"description\":\"MOD_SAMPLEDATA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_sampledata\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(319, 0, 'mod_latestactions', 'module', 'mod_latestactions', '', 1, 1, 1, 0, '{\"name\":\"mod_latestactions\",\"type\":\"module\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"MOD_LATESTACTIONS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_latestactions\"}', '{}', '', '', 0, '1970-01-01 00:00:00', 0, 0),
(320, 0, 'mod_privacy_dashboard', 'module', 'mod_privacy_dashboard', '', 1, 1, 1, 0, '{\"name\":\"mod_privacy_dashboard\",\"type\":\"module\",\"creationDate\":\"June 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"MOD_PRIVACY_DASHBOARD_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_privacy_dashboard\"}', '{}', '', '', 0, '1970-01-01 00:00:00', 0, 0),
(400, 0, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"gmail\"}', '{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 0, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 0, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"ldap\"}', '{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(403, 0, 'plg_content_contact', 'plugin', 'contact', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_contact\",\"type\":\"plugin\",\"creationDate\":\"January 2014\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.2\",\"description\":\"PLG_CONTENT_CONTACT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contact\"}', '', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(404, 0, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 0, 1, 0, '{\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"emailcloak\"}', '{\"mode\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(406, 0, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"loadmodule\"}', '{\"style\":\"xhtml\"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(407, 0, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"pagebreak\"}', '{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(408, 0, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"pagenavigation\"}', '{\"position\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(409, 0, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"vote\"}', '', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(410, 0, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"Copyright (C) 2014 - 2017 by Marijn Haverbeke <marijnh@gmail.com> and others\",\"authorEmail\":\"marijnh@gmail.com\",\"authorUrl\":\"http:\\/\\/codemirror.net\\/\",\"version\":\"5.40.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"codemirror\"}', '{\"lineNumbers\":\"1\",\"lineWrapping\":\"1\",\"matchTags\":\"1\",\"matchBrackets\":\"1\",\"marker-gutter\":\"1\",\"autoCloseTags\":\"1\",\"autoCloseBrackets\":\"1\",\"autoFocus\":\"1\",\"theme\":\"default\",\"tabmode\":\"indent\"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 0, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"September 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"none\"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 0, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 0, '{\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2018\",\"author\":\"Ephox Corporation\",\"copyright\":\"Ephox Corporation\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"http:\\/\\/www.tinymce.com\",\"version\":\"4.5.9\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"tinymce\"}', '{\"configuration\":{\"toolbars\":{\"2\":{\"toolbar1\":[\"bold\",\"underline\",\"strikethrough\",\"|\",\"undo\",\"redo\",\"|\",\"bullist\",\"numlist\",\"|\",\"pastetext\"]},\"1\":{\"menu\":[\"edit\",\"insert\",\"view\",\"format\",\"table\",\"tools\"],\"toolbar1\":[\"bold\",\"italic\",\"underline\",\"strikethrough\",\"|\",\"alignleft\",\"aligncenter\",\"alignright\",\"alignjustify\",\"|\",\"formatselect\",\"|\",\"bullist\",\"numlist\",\"|\",\"outdent\",\"indent\",\"|\",\"undo\",\"redo\",\"|\",\"link\",\"unlink\",\"anchor\",\"code\",\"|\",\"hr\",\"table\",\"|\",\"subscript\",\"superscript\",\"|\",\"charmap\",\"pastetext\",\"preview\"]},\"0\":{\"menu\":[\"edit\",\"insert\",\"view\",\"format\",\"table\",\"tools\"],\"toolbar1\":[\"bold\",\"italic\",\"underline\",\"strikethrough\",\"|\",\"alignleft\",\"aligncenter\",\"alignright\",\"alignjustify\",\"|\",\"styleselect\",\"|\",\"formatselect\",\"fontselect\",\"fontsizeselect\",\"|\",\"searchreplace\",\"|\",\"bullist\",\"numlist\",\"|\",\"outdent\",\"indent\",\"|\",\"undo\",\"redo\",\"|\",\"link\",\"unlink\",\"anchor\",\"image\",\"|\",\"code\",\"|\",\"forecolor\",\"backcolor\",\"|\",\"fullscreen\",\"|\",\"table\",\"|\",\"subscript\",\"superscript\",\"|\",\"charmap\",\"emoticons\",\"media\",\"hr\",\"ltr\",\"rtl\",\"|\",\"cut\",\"copy\",\"paste\",\"pastetext\",\"|\",\"visualchars\",\"visualblocks\",\"nonbreaking\",\"blockquote\",\"template\",\"|\",\"print\",\"preview\",\"codesample\",\"insertdatetime\",\"removeformat\"]}},\"setoptions\":{\"2\":{\"access\":[\"1\"],\"skin\":\"0\",\"skin_admin\":\"0\",\"mobile\":\"0\",\"drag_drop\":\"1\",\"path\":\"\",\"entity_encoding\":\"raw\",\"lang_mode\":\"1\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"use_config_textfilters\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"valid_elements\":\"\",\"extended_elements\":\"\",\"resizing\":\"1\",\"resize_horizontal\":\"1\",\"element_path\":\"1\",\"wordcount\":\"1\",\"image_advtab\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"},\"1\":{\"access\":[\"6\",\"2\"],\"skin\":\"0\",\"skin_admin\":\"0\",\"mobile\":\"0\",\"drag_drop\":\"1\",\"path\":\"\",\"entity_encoding\":\"raw\",\"lang_mode\":\"1\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"use_config_textfilters\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"valid_elements\":\"\",\"extended_elements\":\"\",\"resizing\":\"1\",\"resize_horizontal\":\"1\",\"element_path\":\"1\",\"wordcount\":\"1\",\"image_advtab\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"},\"0\":{\"access\":[\"7\",\"4\",\"8\"],\"skin\":\"0\",\"skin_admin\":\"0\",\"mobile\":\"0\",\"drag_drop\":\"1\",\"path\":\"\",\"entity_encoding\":\"raw\",\"lang_mode\":\"1\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"use_config_textfilters\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"valid_elements\":\"\",\"extended_elements\":\"\",\"resizing\":\"1\",\"resize_horizontal\":\"1\",\"element_path\":\"1\",\"wordcount\":\"1\",\"image_advtab\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}}},\"sets_amount\":3,\"html_height\":\"550\",\"html_width\":\"750\"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 0, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"article\"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 0, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"image\"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 0, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"pagebreak\"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 0, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"readmore\"}', '', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 0, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"categories\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 0, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contacts\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 0, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"content\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 0, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"newsfeeds\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 0, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2014 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 0, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"languagefilter\"}', '', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(423, 0, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"p3p\"}', '{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(424, 0, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"cache\"}', '{\"browsercache\":\"0\",\"cachetime\":\"15\"}', '', '', 0, '0000-00-00 00:00:00', 21, 0),
(425, 0, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"debug\"}', '{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 13, 0),
(426, 0, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"log\"}', '', '', '', 0, '0000-00-00 00:00:00', 14, 0),
(427, 0, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 0, 1, 1, '{\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"redirect\"}', '', '', '', 0, '0000-00-00 00:00:00', 15, 0),
(428, 0, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"remember\"}', '', '', '', 0, '0000-00-00 00:00:00', 17, 0),
(429, 0, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"sef\"}', '', '', '', 0, '0000-00-00 00:00:00', 18, 0),
(430, 0, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"logout\"}', '', '', '', 0, '0000-00-00 00:00:00', 12, 0),
(431, 0, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 0, '{\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contactcreator\"}', '{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 0, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '{\"strong_passwords\":\"1\",\"autoregister\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 0, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 1, 1, 0, '{\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"profile\"}', '{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 0, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 0, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(436, 0, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"languagecode\"}', '', '', '', 0, '0000-00-00 00:00:00', 20, 0),
(437, 0, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 1, '{\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomlaupdate\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(438, 0, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 1, '{\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"extensionupdate\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(439, 0, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 0, 1, 0, '{\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.4.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"recaptcha\"}', '{\"version\":\"1.0\",\"public_key\":\" \",\"private_key\":\" \",\"theme\":\"clean\",\"theme2\":\"light\",\"size\":\"normal\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(440, 0, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"highlight\"}', '', '', '', 0, '0000-00-00 00:00:00', 16, 0),
(441, 0, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"finder\"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(442, 0, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"categories\"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(443, 0, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contacts\"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(444, 0, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"content\"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(445, 0, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"newsfeeds\"}', '', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(446, 0, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2014 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(447, 0, 'plg_finder_tags', 'plugin', 'tags', 'finder', 0, 1, 1, 0, '{\"name\":\"plg_finder_tags\",\"type\":\"plugin\",\"creationDate\":\"February 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_TAGS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"tags\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(448, 0, 'plg_twofactorauth_totp', 'plugin', 'totp', 'twofactorauth', 0, 0, 1, 0, '{\"name\":\"plg_twofactorauth_totp\",\"type\":\"plugin\",\"creationDate\":\"August 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.0\",\"description\":\"PLG_TWOFACTORAUTH_TOTP_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"totp\"}', '{\"section\":\"3\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(449, 0, 'plg_authentication_cookie', 'plugin', 'cookie', 'authentication', 0, 1, 1, 0, '{\"name\":\"plg_authentication_cookie\",\"type\":\"plugin\",\"creationDate\":\"July 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_AUTH_COOKIE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"cookie\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(450, 0, 'plg_twofactorauth_yubikey', 'plugin', 'yubikey', 'twofactorauth', 0, 0, 1, 0, '{\"name\":\"plg_twofactorauth_yubikey\",\"type\":\"plugin\",\"creationDate\":\"September 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.2.0\",\"description\":\"PLG_TWOFACTORAUTH_YUBIKEY_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"yubikey\"}', '{\"section\":\"3\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(451, 0, 'plg_search_tags', 'plugin', 'tags', 'search', 0, 0, 1, 0, '{\"name\":\"plg_search_tags\",\"type\":\"plugin\",\"creationDate\":\"March 2014\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_TAGS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"tags\"}', '{\"search_limit\":\"50\",\"show_tagged_items\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(479, 0, 'plg_sampledata_blog', 'plugin', 'blog', 'sampledata', 0, 0, 1, 0, '{\"name\":\"plg_sampledata_blog\",\"type\":\"plugin\",\"creationDate\":\"July 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.8.0\",\"description\":\"PLG_SAMPLEDATA_BLOG_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"blog\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(480, 0, 'plg_system_sessiongc', 'plugin', 'sessiongc', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_sessiongc\",\"type\":\"plugin\",\"creationDate\":\"February 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.8.6\",\"description\":\"PLG_SYSTEM_SESSIONGC_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"sessiongc\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(481, 0, 'plg_fields_repeatable', 'plugin', 'repeatable', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_repeatable\",\"type\":\"plugin\",\"creationDate\":\"April 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_FIELDS_REPEATABLE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"repeatable\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(482, 0, 'plg_content_confirmconsent', 'plugin', 'confirmconsent', 'content', 0, 0, 1, 0, '{\"name\":\"plg_content_confirmconsent\",\"type\":\"plugin\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_CONTENT_CONFIRMCONSENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"confirmconsent\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(483, 0, 'PLG_SYSTEM_ACTIONLOGS', 'plugin', 'actionlogs', 'system', 0, 0, 1, 0, '{\"name\":\"PLG_SYSTEM_ACTIONLOGS\",\"type\":\"plugin\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_SYSTEM_ACTIONLOGS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"actionlogs\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(484, 0, 'PLG_ACTIONLOG_JOOMLA', 'plugin', 'joomla', 'actionlog', 0, 1, 1, 0, '{\"name\":\"PLG_ACTIONLOG_JOOMLA\",\"type\":\"plugin\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_ACTIONLOG_JOOMLA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(485, 0, 'plg_system_privacyconsent', 'plugin', 'privacyconsent', 'system', 0, 0, 1, 0, '{\"name\":\"plg_system_privacyconsent\",\"type\":\"plugin\",\"creationDate\":\"April 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_SYSTEM_PRIVACYCONSENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"privacyconsent\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(486, 0, 'plg_system_logrotation', 'plugin', 'logrotation', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_logrotation\",\"type\":\"plugin\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_SYSTEM_LOGROTATION_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"logrotation\"}', '{\"lastrun\":1549559004}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(487, 0, 'plg_privacy_user', 'plugin', 'user', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_user\",\"type\":\"plugin\",\"creationDate\":\"May 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_USER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"user\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(488, 0, 'plg_quickicon_privacycheck', 'plugin', 'privacycheck', 'quickicon', 0, 1, 1, 0, '{\"name\":\"plg_quickicon_privacycheck\",\"type\":\"plugin\",\"creationDate\":\"June 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_QUICKICON_PRIVACYCHECK_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"privacycheck\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(489, 0, 'plg_user_terms', 'plugin', 'terms', 'user', 0, 0, 1, 0, '{\"name\":\"plg_user_terms\",\"type\":\"plugin\",\"creationDate\":\"June 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_USER_TERMS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"terms\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(490, 0, 'plg_privacy_contact', 'plugin', 'contact', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_contact\",\"type\":\"plugin\",\"creationDate\":\"July 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_CONTACT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contact\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(491, 0, 'plg_privacy_content', 'plugin', 'content', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_content\",\"type\":\"plugin\",\"creationDate\":\"July 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_CONTENT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"content\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(492, 0, 'plg_privacy_message', 'plugin', 'message', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_message\",\"type\":\"plugin\",\"creationDate\":\"July 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_MESSAGE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"message\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(493, 0, 'plg_privacy_actionlogs', 'plugin', 'actionlogs', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_actionlogs\",\"type\":\"plugin\",\"creationDate\":\"July 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_ACTIONLOGS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"actionlogs\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(494, 0, 'plg_captcha_recaptcha_invisible', 'plugin', 'recaptcha_invisible', 'captcha', 0, 0, 1, 0, '{\"name\":\"plg_captcha_recaptcha_invisible\",\"type\":\"plugin\",\"creationDate\":\"November 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.8\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_INVISIBLE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"recaptcha_invisible\"}', '{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(495, 0, 'plg_privacy_consents', 'plugin', 'consents', 'privacy', 0, 1, 1, 0, '{\"name\":\"plg_privacy_consents\",\"type\":\"plugin\",\"creationDate\":\"July 2018\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.0\",\"description\":\"PLG_PRIVACY_CONSENTS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"consents\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 0, 'beez3', 'template', 'beez3', '', 0, 1, 1, 0, '{\"name\":\"beez3\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"3.1.0\",\"description\":\"TPL_BEEZ3_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"templateDetails\"}', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 0, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"3.0.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"templateDetails\"}', '{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(506, 0, 'protostar', 'template', 'protostar', '', 0, 1, 1, 0, '{\"name\":\"protostar\",\"type\":\"template\",\"creationDate\":\"4\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_PROTOSTAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"templateDetails\"}', '{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(507, 0, 'isis', 'template', 'isis', '', 1, 1, 1, 0, '{\"name\":\"isis\",\"type\":\"template\",\"creationDate\":\"3\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_ISIS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"templateDetails\"}', '{\"templateColor\":\"\",\"logoFile\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 0, 'English (en-GB)', 'language', 'en-GB', '', 0, 1, 1, 1, '{\"name\":\"English (en-GB)\",\"type\":\"language\",\"creationDate\":\"February 2019\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.3\",\"description\":\"en-GB site language\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 0, 'English (en-GB)', 'language', 'en-GB', '', 1, 1, 1, 1, '{\"name\":\"English (en-GB)\",\"type\":\"language\",\"creationDate\":\"February 2019\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.3\",\"description\":\"en-GB administrator language\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 0, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"February 2019\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.3\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(802, 0, 'English (en-GB) Language Pack', 'package', 'pkg_en-GB', '', 0, 1, 1, 1, '{\"name\":\"English (en-GB) Language Pack\",\"type\":\"package\",\"creationDate\":\"February 2019\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.9.3.1\",\"description\":\"en-GB language pack\",\"group\":\"\",\"filename\":\"pkg_en-GB\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10006, 0, 'mod_articles_single', 'module', 'mod_articles_single', '', 0, 1, 0, 0, '{\"name\":\"mod_articles_single\",\"type\":\"module\",\"creationDate\":\"Unknown\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"\",\"authorUrl\":\"\",\"version\":\"1.2.2\",\"description\":\"MOD_ARTICLES_SINGLE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"item_heading\":\"h4\",\"item_title\":\"0\",\"published_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"0\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 0, 'mod_articles_news_adv', 'module', 'mod_articles_news_adv', '', 0, 1, 0, 0, '{\"name\":\"mod_articles_news_adv\",\"type\":\"module\",\"creationDate\":\"April 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (c) 2012-2014 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.5.5\",\"description\":\"MOD_ARTICLES_NEWS_ADV_XML_DESCRIPTION\",\"group\":\"\"}', '{\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"5\",\"columns\":\"1\",\"ordering\":\"a.publish_up\",\"article_ordering_direction\":\"DESC\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"item_title\":\"0\",\"item_heading\":\"h4\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"masonry\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10011, 0, 'mod_tm_templates', 'module', 'mod_tm_templates', '', 1, 1, 2, 0, '{\"name\":\"mod_tm_templates\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.0.0\",\"description\":\"MOD_TM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"cache\":\"1\",\"cache_time\":\"900\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `package_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10013, 0, 'Content - TM AddThis', 'plugin', 'tmaddthis', 'content', 0, 1, 1, 0, '{\"name\":\"Content - TM AddThis\",\"type\":\"plugin\",\"creationDate\":\"April 2013\",\"author\":\"TM\",\"copyright\":\"Copyright (C) 2012 All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"\",\"version\":\"1.0.8\",\"description\":\"AddThis content plugin\",\"group\":\"\"}', '{\"addthis_id\":\"ra-5497f2254123130b\",\"addthis_categories\":[\"2\",\"10\",\"29\",\"62\"]}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10014, 0, 'bundle', 'package', 'pkg_bundle', '', 0, 1, 1, 0, '{\"name\":\"bundle\",\"type\":\"package\",\"creationDate\":\"Unknown\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"\",\"authorUrl\":\"\",\"version\":\"1.6.5\",\"description\":\"\\n\\t\\t\\n\\t\\t\\t<p>This package installs the following Joomla extensions:<\\/p>\\n\\t\\t\\t<ul>\\n\\t\\t\\t\\t<li>Module Articles Single<\\/li>\\n\\t\\t\\t\\t<li>Module Newsflash Advanced<\\/li>\\n\\t\\t\\t\\t<li>Module Image Swoop<\\/li>\\n\\t\\t\\t\\t<li>Module Superfish Menu<\\/li>\\n\\t\\t\\t\\t<li>Plugin Google Map<\\/li>\\n\\t\\t\\t\\t<li>Plugin AddThis<\\/li>\\n\\t\\t\\t\\t<li>Module CarouFredSel<\\/li>\\n\\t\\t\\t\\t<li>Module Recent templates (admin panel)<\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\n\\t\",\"group\":\"\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10015, 10020, 'plg_system_kunena', 'plugin', 'kunena', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_kunena\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_SYSTEM_KUNENA_DESC\",\"group\":\"\",\"filename\":\"kunena\"}', '{\"jcontentevents\":\"0\",\"jcontentevent_target\":\"body\"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(10016, 10020, 'plg_quickicon_kunena', 'plugin', 'kunena', 'quickicon', 0, 1, 1, 0, '{\"name\":\"plg_quickicon_kunena\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_QUICKICON_KUNENA_DESC\",\"group\":\"\",\"filename\":\"kunena\"}', '{\"context\":\"mod_quickicon\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10018, 10020, 'Kunena Media Files', 'file', 'kunena_media', '', 0, 1, 0, 0, '{\"name\":\"Kunena Media Files\",\"type\":\"file\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"Kunena media files.\",\"group\":\"\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10019, 10020, 'com_kunena', 'component', 'com_kunena', '', 1, 1, 0, 0, '{\"name\":\"com_kunena\",\"type\":\"component\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"COM_KUNENA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"kunena\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10020, 0, 'Kunena Forum Package', 'package', 'pkg_kunena', '', 0, 1, 1, 0, '{\"name\":\"Kunena Forum Package\",\"type\":\"package\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"Kunena Forum Package.\",\"group\":\"\",\"filename\":\"pkg_kunena\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10022, 0, 'plg_kunena_community', 'plugin', 'community', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_community\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_COMMUNITY_DESCRIPTION\",\"group\":\"\",\"filename\":\"community\"}', '{\"access\":\"1\",\"login\":\"1\",\"activity\":\"1\",\"avatar\":\"1\",\"profile\":\"1\",\"private\":\"1\",\"activity_points_limit\":\"0\",\"activity_stream_limit\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10023, 0, 'plg_kunena_comprofiler', 'plugin', 'comprofiler', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_comprofiler\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_COMPROFILER_DESCRIPTION\",\"group\":\"\",\"filename\":\"comprofiler\"}', '{\"access\":\"1\",\"login\":\"1\",\"activity\":\"1\",\"avatar\":\"1\",\"profile\":\"1\",\"private\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(10024, 0, 'plg_kunena_gravatar', 'plugin', 'gravatar', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_gravatar\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_GRAVATAR_DESCRIPTION\",\"group\":\"\",\"filename\":\"gravatar\"}', '{\"avatar\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(10025, 0, 'plg_kunena_uddeim', 'plugin', 'uddeim', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_uddeim\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_UDDEIM_DESCRIPTION\",\"group\":\"\",\"filename\":\"uddeim\"}', '{\"private\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10026, 0, 'plg_kunena_kunena', 'plugin', 'kunena', 'kunena', 0, 1, 1, 0, '{\"name\":\"plg_kunena_kunena\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_KUNENA_DESCRIPTION\",\"group\":\"\",\"filename\":\"kunena\"}', '{\"avatar\":\"1\",\"profile\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(10027, 0, 'plg_kunena_joomla', 'plugin', 'joomla', 'kunena', 0, 1, 1, 0, '{\"name\":\"plg_kunena_joomla\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_JOOMLA_25_30_DESCRIPTION\",\"group\":\"\",\"filename\":\"joomla\"}', '{\"access\":\"1\",\"login\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(10032, 0, 'JoomGallery', 'component', 'com_joomgallery', '', 1, 1, 0, 0, '{\"name\":\"JoomGallery\",\"type\":\"component\",\"creationDate\":\"2018\\/01\\/21\",\"author\":\"JoomGallery::ProjectTeam\",\"copyright\":\"This component is released under the GNU\\/GPL License\",\"authorEmail\":\"team@joomgallery.net\",\"authorUrl\":\"http:\\/\\/www.joomgallery.net\",\"version\":\"3.3.4\",\"description\":\"JoomGallery 3 is a native Joomla! 3.x gallery component\",\"group\":\"\",\"filename\":\"joomgallery\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10033, 0, 'PLG_JOOMGALLERY_JOOMFANCYBOX', 'plugin', 'joomfancybox', 'joomgallery', 0, 1, 1, 0, '{\"name\":\"PLG_JOOMGALLERY_JOOMFANCYBOX\",\"type\":\"plugin\",\"creationDate\":\"20.01.2013\",\"author\":\"fabrice jossa\",\"copyright\":\"Copyright (C) 2013 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"team@joomgallery.net\",\"authorUrl\":\"http:\\/\\/www.en.joomgallery.net\",\"version\":\"1.1\",\"description\":\"PLG_JOOMGALLERY_JOOMFANCYBOX_XML_DESCRIPTION\",\"group\":\"\"}', '{\"global_box_existent\":\"1\",\"mousewheel\":\"0\",\"buttons\":\"0\",\"thumbs\":\"0\",\"init_script\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10043, 0, 'system - EUCookieDirectiveLite', 'plugin', 'EUCookieDirectiveLite', 'system', 0, 0, 1, 0, '{\"name\":\"system - EUCookieDirectiveLite\",\"type\":\"plugin\",\"creationDate\":\"2013-11-19\",\"author\":\"Channel Digital.\",\"copyright\":\"All rights reserved by channeldigital.co.uk 2013.\",\"authorEmail\":\"info@channeldigital.co.uk\",\"authorUrl\":\"www.channeldigital.co.uk\",\"version\":\"1.1.1\",\"description\":\"Displays a cookie acceptance banner at the top of the site to warn about the site using cookies.\",\"group\":\"\"}', '{\"width\":\"0\",\"warningMessage\":\"We use cookies to improve our website and your experience when using it. Cookies used for the essential operation of this site have already been set. To find out more about the cookies we use and how to delete them, see our privacy policy.\\r\\nBy clicking \\\"Agree\\\" button, you accept cookies from this site and you give permission to use your personal data within the EU\'s General Data Protection Regulation (GDPR)\",\"detailsUrl\":\"index.php\"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(10044, 0, 'TM Ajax Contact Form', 'module', 'mod_tm_ajax_contact_form', '', 0, 1, 0, 0, '{\"name\":\"TM Ajax Contact Form\",\"type\":\"module\",\"creationDate\":\"August ,2014\",\"author\":\"TemplateMonster\",\"copyright\":\"Copyright (c) 2012-2014 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"MOD_TM_AJAX_CONTACT_FORM_XML_DESCRIPTION\",\"group\":\"\"}', '{\"email_req\":\"required\",\"phone_req\":\"required\",\"admin_email\":\"\",\"cc_email\":\"\",\"bcc_email\":\"\",\"success_notify\":\"Thank You! Your message has been sent.\",\"failure_notify\":\"Something went wrong, please try again later.\",\"recaptcha_failure_notify\":\"Please enter a correct Captcha answer.\",\"msg_minlength\":\"0\",\"errors_position\":\"right-top\",\"captcha_req\":\"0\",\"public_key\":\"\",\"private_key\":\"\",\"captcha_theme\":\"red\",\"email_publish\":\"1\",\"phone_publish\":\"1\",\"subject_publish\":\"1\",\"subject_type\":\"1\",\"reset_publish\":\"1\",\"name_name\":\"Name\",\"email_name\":\"Email\",\"phone_name\":\"Phone\",\"subject_name\":\"Subject\",\"message_name\":\"Message\",\"br_name\":\"Clear\",\"bs_name\":\"Send\",\"labels_pos\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10065, 0, 'Bootstrap Collapse', 'module', 'mod_bootstrap_collapse', '', 0, 1, 0, 0, '{\"name\":\"Bootstrap Collapse\",\"type\":\"module\",\"creationDate\":\"September 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (c) 2012-20013 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"MOD_BOOTSTRAP_COLLAPSE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"catid\":\"\",\"count\":\"5\",\"ordering\":\"a.publish_up\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10066, 0, 'Bootstrap Tabs', 'module', 'mod_bootstraptabs', '', 0, 1, 0, 0, '{\"name\":\"Bootstrap Tabs\",\"type\":\"module\",\"creationDate\":\"August 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (c) 2012-20013 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.2\",\"description\":\"MOD_BOOTSTRAPTABS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"catid\":\"\",\"count\":\"5\",\"ordering\":\"a.publish_up\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10067, 0, 'Content - Komento', 'plugin', 'komento', 'content', 0, 1, 1, 0, '{\"name\":\"Content - Komento\",\"type\":\"plugin\",\"creationDate\":\"01\\/01\\/2012\",\"author\":\"StackIdeas\",\"copyright\":\"Copyright (C) 2012 StackIdeas. All rights reserved.\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"1.0\",\"description\":\"This plugin adds a discussion\\/comment interface at the bottom of the article\",\"group\":\"\",\"filename\":\"komento\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10068, 0, 'System - Komento', 'plugin', 'komento', 'system', 0, 1, 1, 0, '{\"name\":\"System - Komento\",\"type\":\"plugin\",\"creationDate\":\"07\\/01\\/2012\",\"author\":\"StackIdeas\",\"copyright\":\"Copyright (C) 2012 StackIdeas. All rights reserved.\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"1.0\",\"description\":\"This plugin adds a discussion\\/comment interface at the bottom of the article\",\"group\":\"\",\"filename\":\"komento\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10069, 0, 'User - Komento Users', 'plugin', 'komentousers', 'user', 0, 1, 1, 0, '{\"name\":\"User - Komento Users\",\"type\":\"plugin\",\"creationDate\":\"February 2012\",\"author\":\"StackIdeas\",\"copyright\":\"Copyright 2012 StackIdeas. All rights reserved.\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"1.0.0\",\"description\":\"Komento user plugin. This plugin is responsible to delete user\'s related records.\",\"group\":\"\",\"filename\":\"komentousers\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10070, 0, 'Komento Activities', 'module', 'mod_komento_activities', '', 0, 1, 0, 0, '{\"name\":\"Komento Activities\",\"type\":\"module\",\"creationDate\":\"May 2012\",\"author\":\"StackIdeas\",\"copyright\":\"Copyright 2009 - 2012 Stack Ideas. All rights reserved.\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"1.0.4\",\"description\":\"Display activities from Komento\",\"group\":\"\",\"filename\":\"mod_komento_activities\"}', '{\"limit\":\"5\",\"component\":\"all\",\"includelikes\":\"1\",\"includecomments\":\"1\",\"includereplies\":\"1\",\"showcomment\":\"1\",\"maxcommentlength\":\"100\",\"maxtitlelength\":\"30\",\"cache\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10071, 0, 'Komento Comments', 'module', 'mod_komento_comments', '', 0, 1, 0, 0, '{\"name\":\"Komento Comments\",\"type\":\"module\",\"creationDate\":\"May 2012\",\"author\":\"StackIdeas\",\"copyright\":\"Copyright 2009 - 2012 Stack Ideas. All rights reserved.\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"1.0.7\",\"description\":\"Display comments from Komento\",\"group\":\"\",\"filename\":\"mod_komento_comments\"}', '{\"limit\":\"5\",\"component\":\"all\",\"category\":\"\",\"sort\":\"latest\",\"random\":\"0\",\"filtersticked\":\"0\",\"showtitle\":\"1\",\"showcomponent\":\"1\",\"showavatar\":\"1\",\"showauthor\":\"1\",\"maxcommentlength\":\"100\",\"maxtitlelength\":\"30\",\"cache\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10072, 0, 'com_komento', 'component', 'com_komento', '', 1, 1, 0, 0, '{\"name\":\"com_komento\",\"type\":\"component\",\"creationDate\":\"Jan 2012\",\"author\":\"Stack Ideas\",\"copyright\":\"Copyright 2012 Stack Ideas. All rights reserved\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/www.stackideas.com\",\"version\":\"2.0.4\",\"description\":\"\\n\\t\\tKomento is a Joomla! comment component.\\n\\t\",\"group\":\"\",\"filename\":\"komento\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10103, 0, 'plg_system_tmwrapper', 'plugin', 'tmwrapper', 'system', 0, 1, 1, 0, '{\"name\":\"TM Wrapper\",\"type\":\"plugin\",\"creationDate\":\"2015-05-29\",\"author\":\"Template Monster\",\"copyright\":\"Copyright 2014 Template Monster. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"\",\"version\":\"1.0.0\",\"description\":\"PLG_TMWRAPPER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"tmwrapper\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10120, 0, 'mod_owl_carousel', 'module', 'mod_owl_carousel', '', 0, 1, 1, 0, '{\"name\":\"mod_owl_carousel\",\"type\":\"module\",\"creationDate\":\"February 2016\",\"author\":\"TemplateMonster\",\"copyright\":\"Copyright (c) 2012-2016 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"MOD_OWL_CAROUSEL_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_owl_carousel\"}', '{\"catid\":\"\",\"image\":\"0\",\"item_title\":\"0\",\"published\":\"0\",\"item_heading\":\"h4\",\"show_tags\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"readmore\":\"0\",\"count\":\"5\",\"ordering\":\"a.publish_up\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"theme\":\"0\",\"script\":\"0\",\"items\":\"4\",\"autoplay\":\"1\",\"autoplay_speed\":\"5000\",\"scene_padding_0\":\"50\",\"items_padding_0\":\"50\",\"use_responsive\":\"1\",\"scene_padding_1200\":\"50\",\"items_padding_1200\":\"50\",\"scene_padding_992\":\"50\",\"items_padding_992\":\"50\",\"scene_padding_768\":\"50\",\"items_padding_768\":\"50\",\"scene_padding_480\":\"50\",\"items_padding_480\":\"50\",\"navigation\":\"1\",\"pagination\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10122, 0, 'plg_editors-xtd_module', 'plugin', 'module', 'editors-xtd', 0, 0, 1, 0, '{\"name\":\"plg_editors-xtd_module\",\"type\":\"plugin\",\"creationDate\":\"October 2015\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.5.0\",\"description\":\"PLG_MODULE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"module\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10123, 0, 'plg_system_stats', 'plugin', 'stats', 'system', 0, 0, 1, 0, '{\"name\":\"plg_system_stats\",\"type\":\"plugin\",\"creationDate\":\"November 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.5.0\",\"description\":\"PLG_SYSTEM_STATS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"stats\"}', '{\"interval\":\"12\",\"mode\":\"1\",\"lastrun\":\"\",\"debug\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10124, 0, 'plg_system_updatenotification', 'plugin', 'updatenotification', 'system', 0, 0, 1, 0, '{\"name\":\"plg_system_updatenotification\",\"type\":\"plugin\",\"creationDate\":\"May 2015\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.5.0\",\"description\":\"PLG_SYSTEM_UPDATENOTIFICATION_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"updatenotification\"}', '{\"email\":\"\",\"language_override\":\"\",\"lastrun\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10125, 0, 'System - Form XML Override', 'plugin', 'form_xml_override', 'system', 0, 1, 1, 0, '{\"name\":\"System - Form XML Override\",\"type\":\"plugin\",\"creationDate\":\"July 2013\",\"author\":\"iCueProject, Randy Carey\",\"copyright\":\"(C) 2013-2014 Randy Carey, iCue Project. All rights reserved.\",\"authorEmail\":\"support@iCueProject.com\",\"authorUrl\":\"http:\\/\\/iCueProject.com\",\"version\":\"1.0.1\",\"description\":\"PLG_FORM_XML_OVERRIDE_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"form_xml_override\"}', '{\"admin_com_name\":\"com_modules\",\"site_com_name\":\"\",\"slash_dir\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10138, 0, 'PLG_INSTALLER_FOLDERINSTALLER', 'plugin', 'folderinstaller', 'installer', 0, 1, 1, 0, '{\"name\":\"PLG_INSTALLER_FOLDERINSTALLER\",\"type\":\"plugin\",\"creationDate\":\"May 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.6.0\",\"description\":\"PLG_INSTALLER_FOLDERINSTALLER_PLUGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"folderinstaller\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10139, 0, 'plg_installer_packageinstaller', 'plugin', 'packageinstaller', 'installer', 0, 1, 1, 0, '{\"name\":\"plg_installer_packageinstaller\",\"type\":\"plugin\",\"creationDate\":\"May 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.6.0\",\"description\":\"PLG_INSTALLER_PACKAGEINSTALLER_PLUGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"packageinstaller\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10140, 0, 'PLG_INSTALLER_URLINSTALLER', 'plugin', 'urlinstaller', 'installer', 0, 1, 1, 0, '{\"name\":\"PLG_INSTALLER_URLINSTALLER\",\"type\":\"plugin\",\"creationDate\":\"May 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.6.0\",\"description\":\"PLG_INSTALLER_URLINSTALLER_PLUGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"urlinstaller\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10143, 10163, 'com_slogin', 'component', 'com_slogin', '', 1, 1, 0, 0, '{\"name\":\"com_slogin\",\"type\":\"component\",\"creationDate\":\"13.03.2018\",\"author\":\"SmokerMan, Arkadiy, Joomline\",\"copyright\":\"\\u00a9 2012-2018. All rights reserved.\",\"authorEmail\":\"sale@joomline.ru\",\"authorUrl\":\"\",\"version\":\"2.7.2\",\"description\":\"COM_SLOGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"slogin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10144, 10163, 'mod_slogin', 'module', 'mod_slogin', '', 0, 1, 0, 0, '{\"name\":\"mod_slogin\",\"type\":\"module\",\"creationDate\":\"02.03.2018\",\"author\":\"SmokerMan, Arkadiy, Joomline\",\"copyright\":\"\\u00a9 2012-2018. All rights reserved.\",\"authorEmail\":\"sale@joomline.ru\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"2.4.0\\t\",\"description\":\"MOD_SLOGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_slogin\"}', '{\"slogin_link_profile\":\"1\",\"slogin_link_auch_edit\":\"1\",\"cache\":\"0\",\"load_css\":\"0\",\"load_js\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10147, 10163, 'Social Login', 'plugin', 'slogin', 'user', 0, 1, 1, 0, '{\"name\":\"Social Login\",\"type\":\"plugin\",\"creationDate\":\"21.09.2012\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.0\",\"description\":\"Delete User info from slogin table\",\"group\":\"\",\"filename\":\"slogin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10148, 10163, 'Plugin profile Slogin', 'plugin', 'profile', 'slogin_integration', 0, 1, 1, 0, '{\"name\":\"Plugin profile Slogin\",\"type\":\"plugin\",\"creationDate\":\"20.11.2014\",\"author\":\"Arkadiy Sedelnikov, Joomline\",\"copyright\":\"(C) 2012. All rights reserved.\",\"authorEmail\":\"a.sedelnikov@gmail.com\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.0.2\",\"description\":\"PLG_SLOGIN_PROFILE_DESC\",\"group\":\"\",\"filename\":\"profile\"}', '{\"rootfolder\":\"images\\/avatar\",\"img_quality\":\"80\",\"imgparam\":\"150\",\"updatetime\":\"86400\",\"enable_geo\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10149, 10163, 'Social Login Facebook auth', 'plugin', 'facebook', 'slogin_auth', 0, 1, 1, 0, '{\"name\":\"Social Login Facebook auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Facebook auth\",\"group\":\"\",\"filename\":\"facebook\"}', '{\"id\":\"1770184923308057\",\"password\":\"acb935bae3641b597d3bdd8dafc5530d\",\"callback_url\":null}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10150, 10163, 'Social Login Google auth', 'plugin', 'google', 'slogin_auth', 0, 1, 1, 0, '{\"name\":\"Social Login Google auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Google auth\",\"group\":\"\",\"filename\":\"google\"}', '{\"id\":\"4ea43331a8b16c6ddb33685fc03635a8\",\"password\":\"Apmhll5UyD-Llm7-FJRsbWuP\",\"callback_url\":null}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10151, 10163, 'Social Login mail.ru auth', 'plugin', 'mail', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login mail.ru auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"mail.ru auth\",\"group\":\"\",\"filename\":\"mail\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10152, 10163, 'Social Login Odnoklassniki auth', 'plugin', 'odnoklassniki', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Odnoklassniki auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Odnoklassniki auth\",\"group\":\"\",\"filename\":\"odnoklassniki\"}', '{\"id\":\"\",\"password\":\"\",\"public_key\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10153, 10163, 'Social Login Twitter auth', 'plugin', 'twitter', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Twitter auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Twitter auth\",\"group\":\"\",\"filename\":\"twitter\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10154, 10163, 'Social Login Vkontakte auth', 'plugin', 'vkontakte', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Vkontakte auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.3.0\",\"description\":\"Vkontakte auth\",\"group\":\"\",\"filename\":\"vkontakte\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10155, 10163, 'Social Login Yandex auth', 'plugin', 'yandex', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Yandex auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Yandex auth. Instructions for setting up the plugin: http:\\/\\/joomline.ru\\/stati\\/53-komponenty\\/306-sozdanie-prilozhenij-dlja-socialnoj-avtoriziacii.html\",\"group\":\"\",\"filename\":\"yandex\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10156, 10163, 'Social Login LinkedIn auth', 'plugin', 'linkedin', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login LinkedIn auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"LinkedIn auth\",\"group\":\"\",\"filename\":\"linkedin\"}', '{\"api_key\":\"\",\"secret_key\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10157, 10163, 'Social Login Ulogin auth', 'plugin', 'ulogin', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Ulogin auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Ulogin auth. Instructions for setting up the plugin: http:\\/\\/joomline.ru\\/stati\\/53-komponenty\\/306-sozdanie-prilozhenij-dlja-socialnoj-avtoriziacii.html\",\"group\":\"\",\"filename\":\"ulogin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10158, 10163, 'Social Login Live.com auth', 'plugin', 'live', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Live.com auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Live.com auth\",\"group\":\"\",\"filename\":\"live\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10159, 10163, 'Social Login Yahoo auth', 'plugin', 'yahoo', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Yahoo auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Yahoo auth\",\"group\":\"\",\"filename\":\"yahoo\"}', '{\"key\":\"\",\"secret\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10160, 10163, 'Social Login Wordpress auth', 'plugin', 'wordpress', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Wordpress auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Wordpress auth\",\"group\":\"\",\"filename\":\"wordpress\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10161, 10163, 'Social Login Instagram auth', 'plugin', 'instagram', 'slogin_auth', 0, 0, 1, 0, '{\"name\":\"Social Login Instagram auth\",\"type\":\"plugin\",\"creationDate\":\"26.05.2017\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012-2017. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.2.0\",\"description\":\"Instagram auth\",\"group\":\"\",\"filename\":\"instagram\"}', '{\"id\":\"\",\"password\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10162, 10163, 'Social Login Auth', 'plugin', 'slogin', 'authentication', 0, 1, 1, 0, '{\"name\":\"Social Login Auth\",\"type\":\"plugin\",\"creationDate\":\"21.09.2012\",\"author\":\"Arkadiy, Joomline\",\"copyright\":\"(C) 2012. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.0\",\"description\":\"Authenticate User on SLogin data\",\"group\":\"\",\"filename\":\"slogin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10163, 0, 'Pkg Slogin', 'package', 'pkg_slogin', '', 0, 1, 1, 0, '{\"name\":\"Pkg Slogin\",\"type\":\"package\",\"creationDate\":\"13.03.2018\",\"author\":\"SmokerMan, Arkadiy, Joomline\",\"copyright\":\"\\u00a9 2012 - 2018. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"\",\"version\":\"2.7.2\",\"description\":\"Packet authentication via social networking joomla. The package: plugin, module, component. After installing the plugin activate Social Login.<iframe frameborder=\'0\' allowtransparency=\'true\' scrolling=\'no\' src=\'https:\\/\\/joomline.ru\\/donateen.html\' width=\'100%\' height=\'700\'>\",\"group\":\"\",\"filename\":\"pkg_slogin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10164, 10193, 'T3 Framework', 'plugin', 't3', 'system', 0, 1, 1, 0, '{\"name\":\"T3 Framework\",\"type\":\"plugin\",\"creationDate\":\"May 04, 2018\",\"author\":\"JoomlArt.com\",\"copyright\":\"Copyright (C) 2005 - 2018 Open Source Matters. All rights reserved.\",\"authorEmail\":\"info@joomlart.com\",\"authorUrl\":\"http:\\/\\/www.t3-framework.org\",\"version\":\"2.7.1\",\"description\":\"\\n\\t\\n\\t<div align=\\\"center\\\">\\n\\t\\t<div class=\\\"alert alert-success\\\" style=\\\"background-color:#DFF0D8;border-color:#D6E9C6;color: #468847;padding: 1px 0;\\\">\\n\\t\\t\\t\\t<a href=\\\"http:\\/\\/t3-framework.org\\/\\\"><img src=\\\"http:\\/\\/static.joomlart.com\\/images\\/jat3v3-documents\\/message-installation\\/logo.png\\\" alt=\\\"some_text\\\" width=\\\"300\\\" height=\\\"99\\\"><\\/a>\\n\\t\\t\\t\\t<h4><a href=\\\"http:\\/\\/t3-framework.org\\/\\\" title=\\\"\\\">Home<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/\\\" title=\\\"\\\">Demo<\\/a> | <a href=\\\"http:\\/\\/t3-framework.org\\/documentation\\\" title=\\\"\\\">Document<\\/a> | <a href=\\\"https:\\/\\/github.com\\/t3framework\\/t3\\/blob\\/master\\/CHANGELOG.md\\\" title=\\\"\\\">Changelog<\\/a><\\/h4>\\n\\t\\t<p> <\\/p>\\n\\t\\t<p>Copyright 2004 - 2018 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n     <style>table.adminform{width: 100%;}<\\/style>\\n\\t <\\/div>\\n\\t\\t\\n\\t\",\"group\":\"\",\"filename\":\"t3\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10167, 0, 'theme3589', 'template', 'theme3589', '', 0, 1, 1, 0, '{\"name\":\"theme3589\",\"type\":\"template\",\"creationDate\":\"April 2017\",\"author\":\"Unknown\",\"copyright\":\"Copyright  2003-2017 template-help.com. All Rights Reserved.\",\"authorEmail\":\"info@template-help.com\",\"authorUrl\":\"\",\"version\":\"1.0.0\",\"description\":\"\\n\\t\\t\\n\\t\\t\\n\\t\",\"group\":\"\",\"filename\":\"templateDetails\"}', '[]', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10168, 0, 'com_associations', 'component', 'com_associations', '', 1, 1, 1, 0, '{\"name\":\"com_associations\",\"type\":\"component\",\"creationDate\":\"January 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"COM_ASSOCIATIONS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10169, 0, 'com_fields', 'component', 'com_fields', '', 1, 1, 1, 0, '{\"name\":\"com_fields\",\"type\":\"component\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"COM_FIELDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"fields\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10170, 0, 'plg_content_fields', 'plugin', 'fields', 'content', 0, 1, 1, 0, '{\"name\":\"plg_content_fields\",\"type\":\"plugin\",\"creationDate\":\"February 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_CONTENT_FIELDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"fields\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10171, 0, 'plg_editors-xtd_contact', 'plugin', 'contact', 'editors-xtd', 0, 0, 1, 0, '{\"name\":\"plg_editors-xtd_contact\",\"type\":\"plugin\",\"creationDate\":\"October 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_EDITORS-XTD_CONTACT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"contact\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10172, 0, 'plg_editors-xtd_fields', 'plugin', 'fields', 'editors-xtd', 0, 0, 1, 0, '{\"name\":\"plg_editors-xtd_fields\",\"type\":\"plugin\",\"creationDate\":\"February 2017\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_EDITORS-XTD_FIELDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"fields\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10173, 0, 'plg_editors-xtd_menu', 'plugin', 'menu', 'editors-xtd', 0, 0, 1, 0, '{\"name\":\"plg_editors-xtd_menu\",\"type\":\"plugin\",\"creationDate\":\"August 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_EDITORS-XTD_MENU_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"menu\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10174, 0, 'plg_fields_calendar', 'plugin', 'calendar', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_calendar\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_CALENDAR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"calendar\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10175, 0, 'plg_fields_checkboxes', 'plugin', 'checkboxes', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_checkboxes\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_CHECKBOXES_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"checkboxes\"}', '[]', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10176, 0, 'plg_fields_color', 'plugin', 'color', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_color\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_COLOR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"color\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10177, 0, 'plg_fields_editor', 'plugin', 'editor', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_editor\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_EDITOR_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"editor\"}', '{\"buttons\":\"0\",\"width\":\"100%\",\"height\":\"250px\",\"filter\":\"JComponentHelper::filterText\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10178, 0, 'plg_fields_imagelist', 'plugin', 'imagelist', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_imagelist\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_IMAGELIST_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"imagelist\"}', '{\"directory\":\"\\/\",\"multiple\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10179, 0, 'plg_fields_integer', 'plugin', 'integer', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_integer\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_INTEGER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"integer\"}', '{\"multiple\":\"0\",\"first\":\"1\",\"last\":\"100\",\"step\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10180, 0, 'plg_fields_list', 'plugin', 'list', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_list\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_LIST_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"list\"}', '{\"multiple\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10181, 0, 'plg_fields_media', 'plugin', 'media', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_media\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_MEDIA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"media\"}', '{\"preview\":\"tooltip\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10182, 0, 'plg_fields_radio', 'plugin', 'radio', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_radio\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_RADIO_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"radio\"}', '[]', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10183, 0, 'plg_fields_sql', 'plugin', 'sql', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_sql\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_SQL_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"sql\"}', '{\"multiple\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10184, 0, 'plg_fields_text', 'plugin', 'text', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_text\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_TEXT_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"text\"}', '{\"filter\":\"JComponentHelper::filterText\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10185, 0, 'plg_fields_textarea', 'plugin', 'textarea', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_textarea\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_TEXTAREA_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"textarea\"}', '{\"rows\":\"10\",\"cols\":\"10\",\"filter\":\"JComponentHelper::filterText\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10186, 0, 'plg_fields_url', 'plugin', 'url', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_url\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_URL_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"url\"}', '{\"relative\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10187, 0, 'plg_fields_user', 'plugin', 'user', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_user\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_USER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"user\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10188, 0, 'plg_fields_usergrouplist', 'plugin', 'usergrouplist', 'fields', 0, 1, 1, 0, '{\"name\":\"plg_fields_usergrouplist\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_FIELDS_USERGROUPLIST_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"usergrouplist\"}', '{\"multiple\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10189, 0, 'plg_quickicon_phpversioncheck', 'plugin', 'phpversioncheck', 'quickicon', 0, 0, 1, 0, '{\"name\":\"plg_quickicon_phpversioncheck\",\"type\":\"plugin\",\"creationDate\":\"August 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_QUICKICON_PHPVERSIONCHECK_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"phpversioncheck\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10190, 0, 'plg_system_fields', 'plugin', 'fields', 'system', 0, 1, 1, 0, '{\"name\":\"plg_system_fields\",\"type\":\"plugin\",\"creationDate\":\"March 2016\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2019 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.7.0\",\"description\":\"PLG_SYSTEM_FIELDS_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"fields\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10193, 0, 'T3 Framework Package', 'package', 'pkg_t3', '', 0, 1, 1, 0, '{\"name\":\"T3 Framework Package\",\"type\":\"package\",\"creationDate\":\"May 04, 2018\",\"author\":\"t3-framework.org\",\"copyright\":\"(C) 2012 - 2018. All rights reserved.\",\"authorEmail\":\"support@t3-framework.org\",\"authorUrl\":\"www.t3-framework.org\",\"version\":\"2.7.1\",\"description\":\"\\t\\n\\t\\n\\t<div align=\\\"center\\\">\\n\\t\\t<div class=\\\"alert alert-success\\\" style=\\\"background-color:#DFF0D8;border-color:#D6E9C6;color: #468847;padding: 1px 0;\\\">\\n\\t\\t\\t\\t<a href=\\\"http:\\/\\/t3-framework.org\\/\\\"><img src=\\\"http:\\/\\/static.joomlart.com\\/images\\/jat3v3-documents\\/message-installation\\/logo.png\\\" alt=\\\"some_text\\\" width=\\\"300\\\" height=\\\"99\\\"><\\/a>\\n\\t\\t\\t\\t<h4><a href=\\\"http:\\/\\/t3-framework.org\\/\\\" title=\\\"\\\">Home<\\/a> | <a href=\\\"http:\\/\\/demo.t3-framework.org\\/\\\" title=\\\"\\\">Demo<\\/a> | <a href=\\\"http:\\/\\/t3-framework.org\\/documentation\\\" title=\\\"\\\">Document<\\/a> | <a href=\\\"https:\\/\\/github.com\\/t3framework\\/t3\\/blob\\/master\\/CHANGELOG.md\\\" title=\\\"\\\">Changelog<\\/a><\\/h4>\\n\\t\\t<p> <\\/p>\\n\\t\\t<p>Copyright 2004 - 2018 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n     <style>table.adminform{width: 100%;}<\\/style>\\n\\t <\\/div>\\n\\t\\t\\n\\t\",\"group\":\"\",\"filename\":\"pkg_t3\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10196, 0, 'mod_tm_style_switcher', 'module', 'mod_tm_style_switcher', '', 0, 1, 0, 0, '{\"name\":\"mod_tm_style_switcher\",\"type\":\"module\",\"creationDate\":\"February, 2013\",\"author\":\"TemplateMonster\",\"copyright\":\"Copyright (c) 2012-2015 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.2\",\"description\":\"MOD_TM_STYLE_SWITCHER_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_tm_style_switcher\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10197, 0, 'TM Progress bars', 'module', 'mod_tm_progress_bars', '', 0, 1, 0, 0, '{\"name\":\"TM Progress bars\",\"type\":\"module\",\"creationDate\":\"June, 2017\",\"author\":\"TemplateMonster http:\\/\\/www.templatemonster.com\",\"copyright\":\"Copyright (c) 2012-2017 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"Thanks for installing TM Progress bars\",\"group\":\"\",\"filename\":\"mod_tm_progress_bars\"}', '{\"choose_type\":\"0\",\"columns\":\"1\",\"items_data2\":\"{\\\"item_name\\\":[\\\"Name\\\"],\\\"item_value\\\":[\\\"30\\\"],\\\"item_color1\\\":[\\\"#eaeaea\\\"],\\\"item_color2\\\":[\\\"#eaeaea\\\"],\\\"item_color3\\\":[\\\"#f5f5f5\\\"]}\",\"items_data\":\"{\\\"item_name\\\":[\\\"Name\\\"],\\\"item_value\\\":[\\\"30\\\"],\\\"item_color\\\":[\\\"#eaeaea\\\"]}\",\"moduleclass_sfx\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `package_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10199, 0, 'plg_finder_kunena', 'plugin', 'kunena', 'finder', 0, 0, 1, 0, '{\"name\":\"plg_finder_kunena\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_FINDER_KUNENA_DESCRIPTION\",\"group\":\"\",\"filename\":\"kunena\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10200, 0, 'plg_kunena_altauserpoints', 'plugin', 'altauserpoints', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_altauserpoints\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"www.kunena.org\",\"authorEmail\":\"Kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_ALTAUSERPOINTS_DESCRIPTION\",\"group\":\"\",\"filename\":\"altauserpoints\"}', '{\"activity\":\"1\",\"avatar\":\"1\",\"profile\":\"1\",\"activity_points_limit\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10201, 0, 'PLG_KUNENA_EASYPROFILE', 'plugin', 'easyprofile', 'kunena', 0, 0, 1, 0, '{\"name\":\"PLG_KUNENA_EASYPROFILE\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Onlinecommunityhub\",\"copyright\":\"https:\\/\\/onlinecommunityhub.nl\",\"authorEmail\":\"info@onlinecommunityhub.nl\",\"authorUrl\":\"https:\\/\\/onlinecommunityhub.nl\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_EASYPROFILE_DESCRIPTION\",\"group\":\"\",\"filename\":\"easyprofile\"}', '{\"avatar\":\"1\",\"guestavatar\":\"easyprofile\",\"profile\":\"1\",\"userlist\":\"1\"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10202, 0, 'plg_kunena_easysocial', 'plugin', 'easysocial', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_easysocial\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"StackIdeas\",\"copyright\":\"http:\\/\\/stackideas.com\",\"authorEmail\":\"support@stackideas.com\",\"authorUrl\":\"http:\\/\\/stackideas.com\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_EASYSOCIAL_DESCRIPTION\",\"group\":\"\",\"filename\":\"easysocial\"}', '{\"login\":\"1\",\"activity\":\"1\",\"avatar\":\"1\",\"profile\":\"1\",\"private\":\"1\",\"activity_badge_limit\":\"0\",\"activity_points_limit\":\"0\"}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(10203, 0, 'plg_kunena_finder', 'plugin', 'finder', 'kunena', 0, 0, 1, 0, '{\"name\":\"plg_kunena_finder\",\"type\":\"plugin\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"PLG_KUNENA_FINDER_DESCRIPTION\",\"group\":\"\",\"filename\":\"finder\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(10204, 0, 'AcyMailing', 'component', 'com_acymailing', '', 1, 1, 0, 0, '{\"name\":\"AcyMailing\",\"type\":\"component\",\"creationDate\":\"May 2018\",\"author\":\"Acyba\",\"copyright\":\"Copyright (C) 2009-2018 ACYBA SAS - All rights reserved.\",\"authorEmail\":\"dev@acyba.com\",\"authorUrl\":\"http:\\/\\/www.acyba.com\",\"version\":\"5.10.1\",\"description\":\"Manage your Mailing lists, Newsletters, e-mail marketing campaigns\",\"group\":\"\",\"filename\":\"acymailing_j3\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10205, 0, 'AcyMailing : trigger Joomla Content plugins', 'plugin', 'contentplugin', 'acymailing', 0, 0, 1, 0, '{\"version\":\"3.7.0\",\"author\":\"Acyba\",\"creationDate\":\"November 2009\"}', '', '', '', 0, '0000-00-00 00:00:00', 15, 0),
(10206, 0, 'AcyMailing Manage text', 'plugin', 'managetext', 'acymailing', 0, 1, 1, 0, '{\"version\":\"1.0.0\",\"author\":\"Acyba\",\"creationDate\":\"October 2010\"}', '', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(10207, 0, 'AcyMailing Tag : Website links', 'plugin', 'online', 'acymailing', 0, 1, 1, 0, '{\"version\":\"3.7.0\",\"author\":\"Acyba\",\"creationDate\":\"September 2009\"}', '', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(10208, 0, 'AcyMailing : share on social networks', 'plugin', 'share', 'acymailing', 0, 1, 1, 0, '{\"version\":\"1.0.0\",\"author\":\"Acyba\",\"creationDate\":\"August 2010\"}', '', '', '', 0, '0000-00-00 00:00:00', 20, 0),
(10209, 0, 'AcyMailing : Statistics Plugin', 'plugin', 'stats', 'acymailing', 0, 1, 1, 0, '{\"version\":\"3.7.0\",\"author\":\"Acyba\",\"creationDate\":\"September 2009\"}', '', '', '', 0, '0000-00-00 00:00:00', 50, 0),
(10210, 0, 'AcyMailing table of contents generator', 'plugin', 'tablecontents', 'acymailing', 0, 1, 1, 0, '{\"version\":\"1.0.0\",\"author\":\"Acyba\",\"creationDate\":\"January 2011\"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10211, 0, 'AcyMailing Tag : content insertion', 'plugin', 'tagcontent', 'acymailing', 0, 1, 1, 0, '{\"version\":\"3.7.0\",\"author\":\"Acyba\",\"creationDate\":\"September 2009\"}', '', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(10212, 0, 'AcyMailing Tag : Subscriber information', 'plugin', 'tagsubscriber', 'acymailing', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(10213, 0, 'AcyMailing Tag : Manage the Subscription', 'plugin', 'tagsubscription', 'acymailing', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10214, 0, 'AcyMailing Tag : Date / Time', 'plugin', 'tagtime', 'acymailing', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10215, 0, 'AcyMailing Tag : Joomla User Information', 'plugin', 'taguser', 'acymailing', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(10216, 0, 'AcyMailing Template Class Replacer', 'plugin', 'template', 'acymailing', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 52, 0),
(10217, 0, 'AcyMailing Editor', 'plugin', 'acyeditor', 'editors', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10218, 0, 'AcyMailing : (auto)Subscribe during Joomla registration', 'plugin', 'regacymailing', 'system', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10219, 0, 'AcyMailing Module', 'module', 'mod_acymailing', '', 0, 1, 1, 0, '{\"version\":\"3.7.0\",\"author\":\"Acyba\",\"creationDate\":\"September 2009\"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10220, 0, 'mod_tm_portfolio', 'module', 'mod_tm_portfolio', '', 0, 1, 0, 0, '{\"name\":\"mod_tm_portfolio\",\"type\":\"module\",\"creationDate\":\"July 2017\",\"author\":\"TemplateMonster\",\"copyright\":\"Copyright (c) 2012-2017 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"MOD_TM_PORTFOLIO_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_tm_portfolio\"}', '{\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"5\",\"columns\":\"1\",\"show_filter\":\"1\",\"show_sort\":\"1\",\"ordering\":\"a.publish_up\",\"article_ordering_direction\":\"DESC\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h4\",\"limit_introtext\":\"0\",\"show_introtext\":\"1\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"show_modify_date\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"masonry\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10223, 0, 'AcyMailing JCE integration', 'plugin', 'jceacymailing', 'system', 0, 1, 1, 0, '{\"version\":\"5.10.1\",\"author\":\"Acyba\",\"creationDate\":\"May 2018\"}', '', '', '', 0, '0000-00-00 00:00:00', 23, 0),
(10228, 0, 'TM Counters', 'module', 'mod_tm_counters', '', 0, 1, 1, 0, '{\"name\":\"TM Counters\",\"type\":\"module\",\"creationDate\":\"December, 2017\",\"author\":\"TemplateMonster http:\\/\\/www.templatemonster.com\",\"copyright\":\"Copyright (c) 2012-2017 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"Thanks for installing TM Counters\",\"group\":\"\",\"filename\":\"mod_tm_counters\"}', '{\"columns\":\"1\",\"animation_speed\":\"6000\",\"items_data\":\"{\\\"item_name\\\":[\\\"Name\\\"],\\\"item_value\\\":[\\\"30\\\"]}\",\"moduleclass_sfx\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10229, 0, 'TM Google map', 'module', 'mod_tm_google_map', '', 0, 1, 1, 0, '{\"name\":\"TM Google map\",\"type\":\"module\",\"creationDate\":\"December, 2017\",\"author\":\"TemplateMonster http:\\/\\/www.templatemonster.com\",\"copyright\":\"Copyright (c) 2012-2017 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.0\",\"description\":\"Thanks for installing TM Google map\",\"group\":\"\",\"filename\":\"mod_tm_google_map\"}', '{\"animation_speed\":\"6000\",\"items_data\":\"{\\\"item_x\\\":[\\\"-73.9874068\\\"],\\\"item_y\\\":[\\\"40.643180\\\"],\\\"item_label\\\":[\\\"2130 Fulton Street San Diego, CA 94117-1080 USA\\\"]}\",\"moduleclass_sfx\":\"\"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10236, 10163, 'slogin', 'library', 'slogin_oauth', '', 0, 1, 1, 0, '{\"name\":\"slogin\",\"type\":\"library\",\"creationDate\":\"2013-04-28\",\"author\":\"Arkadiy Sedelnikov, Joomline\",\"copyright\":\"\",\"authorEmail\":\"a.sedelnikov@gmail.com\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.0\",\"description\":\"\\n  \\n  \\u0411\\u0438\\u0431\\u043b\\u0438\\u043e\\u0442\\u0435\\u043a\\u0430 \\u0430\\u0432\\u0442\\u043e\\u0440\\u0438\\u0437\\u0430\\u0446\\u0438\\u0438 OAuth \\u0441 \\u0438\\u0437\\u043c\\u0435\\u043d\\u0435\\u043d\\u043d\\u044b\\u043c\\u0438 \\u043d\\u0430\\u0437\\u0432\\u0430\\u043d\\u0438\\u044f\\u043c\\u0438 \\u043a\\u043b\\u0430\\u0441\\u0441\\u043e\\u0432 \\u0434\\u043b\\u044f \\u0438\\u0441\\u043a\\u043b\\u044e\\u0447\\u0435\\u043d\\u0438\\u044f \\u043a\\u043e\\u043d\\u0444\\u043b\\u0438\\u043a\\u0442\\u043e\\u0432 \\u0438\\u043c\\u0435\\u043d.\\n  \\n  \",\"group\":\"\",\"filename\":\"slogin_oauth\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10237, 10163, 'amcharts', 'library', 'amcharts', '', 0, 1, 1, 0, '{\"name\":\"amcharts\",\"type\":\"library\",\"creationDate\":\"2014-04-21\",\"author\":\"Arkadiy Sedelnikov, Joomline\",\"copyright\":\"\",\"authorEmail\":\"a.sedelnikov@gmail.com\",\"authorUrl\":\"http:\\/\\/joomline.ru\",\"version\":\"1.0\",\"description\":\"\\n         Chart Library AmCharts \\n    \",\"group\":\"\",\"filename\":\"amcharts\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10240, 10020, 'Kunena Framework', 'library', 'kunena', '', 0, 1, 1, 0, '{\"name\":\"Kunena Framework\",\"type\":\"library\",\"creationDate\":\"2018-05-13\",\"author\":\"Kunena Team\",\"copyright\":\"(C) 2008 - 2018 Kunena Team. All rights reserved.\",\"authorEmail\":\"kunena@kunena.org\",\"authorUrl\":\"https:\\/\\/www.kunena.org\",\"version\":\"5.1.0\",\"description\":\"Kunena Framework.\",\"group\":\"\",\"filename\":\"kunena\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10241, 0, 'mod_sw_twitterdisplay', 'module', 'mod_sw_twitterdisplay', '', 0, 0, 1, 0, '{\"name\":\"SW Twitter Display\",\"type\":\"module\",\"creationDate\":\"October, 2013\",\"author\":\"Muhammad Riduan\",\"copyright\":\"Copyright - Social Widgets\",\"authorEmail\":\"admin@socialwidgets.net\",\"authorUrl\":\"http:\\/\\/socialwidgets.net\\/\",\"version\":\"1.0\",\"description\":\"Thanks for installing SW Twitter Display\",\"group\":\"\",\"filename\":\"mod_sw_twitterdisplay\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, -1),
(10242, 0, 'mod_tm_facebook_page_plugin', 'module', 'mod_tm_facebook_page_plugin', '', 0, 0, 1, 0, '{\"name\":\"mod_tm_facebook_page_plugin\",\"type\":\"module\",\"creationDate\":\"May 2015\",\"author\":\"TemplateMonster\",\"copyright\":\"Copyright (c) 2012-2015 by TemplateMonster - www.templatemonster.com\",\"authorEmail\":\"\",\"authorUrl\":\"www.templatemonster.com\",\"version\":\"1.0.3\",\"description\":\"MOD_TM_FACEBOOK_PAGE_PLUGIN_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"mod_tm_facebook_page_plugin\"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, -1);

DROP TABLE IF EXISTS `#__fields`;
CREATE TABLE IF NOT EXISTS `#__fields` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `context` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `group_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `label` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `default_value` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'text',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `required` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `fieldparams` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_created_user_id` (`created_user_id`),
  KEY `idx_access` (`access`),
  KEY `idx_context` (`context`(191)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__fields_categories`;
CREATE TABLE IF NOT EXISTS `#__fields_categories` (
  `field_id` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`field_id`,`category_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__fields_groups`;
CREATE TABLE IF NOT EXISTS `#__fields_groups` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `context` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_created_by` (`created_by`),
  KEY `idx_access` (`access`),
  KEY `idx_context` (`context`(191)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__fields_values`;
CREATE TABLE IF NOT EXISTS `#__fields_values` (
  `field_id` int(10) UNSIGNED NOT NULL,
  `item_id` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Allow references to items which have strings as ids, eg. none db systems.',
  `value` text COLLATE utf8mb4_unicode_ci NOT NULL,
  KEY `idx_field_id` (`field_id`),
  KEY `idx_item_id` (`item_id`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__joomgallery`;
CREATE TABLE IF NOT EXISTS `#__joomgallery` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `imgtitle` text NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `imgauthor` varchar(50) DEFAULT NULL,
  `imgtext` text NOT NULL,
  `imgdate` datetime NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `downloads` int(11) NOT NULL DEFAULT '0',
  `imgvotes` int(11) NOT NULL DEFAULT '0',
  `imgvotesum` int(11) NOT NULL DEFAULT '0',
  `access` tinyint(3) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `hidden` tinyint(1) NOT NULL DEFAULT '0',
  `featured` tinyint(1) NOT NULL,
  `imgfilename` varchar(255) NOT NULL,
  `imgthumbname` varchar(255) NOT NULL,
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `owner` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `useruploaded` tinyint(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_catid` (`catid`),
  KEY `idx_owner` (`owner`)
) ENGINE=InnoDB AUTO_INCREMENT=255 DEFAULT CHARSET=utf8;

INSERT INTO `#__joomgallery` (`id`, `asset_id`, `catid`, `imgtitle`, `alias`, `imgauthor`, `imgtext`, `imgdate`, `hits`, `downloads`, `imgvotes`, `imgvotesum`, `access`, `published`, `hidden`, `featured`, `imgfilename`, `imgthumbname`, `checked_out`, `owner`, `approved`, `useruploaded`, `ordering`, `params`, `metakey`, `metadesc`) VALUES
(219, 738, 9, 'gallery-image01', 'gallery-image01-219', '', '', '2017-06-13 07:52:55', 4, 0, 0, 0, 1, 1, 0, 0, 'gallery-image01_20170613_1642419993.jpg', 'gallery-image01_20170613_1642419993.jpg', 0, 0, 1, 0, 1, '', '', ''),
(220, 739, 9, 'gallery-image02', 'gallery-image02-220', '', '', '2017-06-13 07:53:04', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image02_20170613_1954889876.jpg', 'gallery-image02_20170613_1954889876.jpg', 0, 0, 1, 0, 2, '', '', ''),
(221, 740, 9, 'gallery-image03', 'gallery-image03-221', '', '', '2017-06-13 07:53:13', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image03_20170613_1473578199.jpg', 'gallery-image03_20170613_1473578199.jpg', 0, 0, 1, 0, 3, '', '', ''),
(222, 741, 9, 'gallery-image04', 'gallery-image04-222', '', '', '2017-06-13 07:53:19', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image04_20170613_1808821392.jpg', 'gallery-image04_20170613_1808821392.jpg', 0, 0, 1, 0, 4, '', '', ''),
(223, 742, 9, 'gallery-image05', 'gallery-image05-223', '', '', '2017-06-13 07:53:29', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image05_20170613_1142159046.jpg', 'gallery-image05_20170613_1142159046.jpg', 0, 0, 1, 0, 5, '', '', ''),
(224, 743, 9, 'gallery-image06', 'gallery-image06-224', '', '', '2017-06-13 07:53:40', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image06_20170613_1566802544.jpg', 'gallery-image06_20170613_1566802544.jpg', 0, 0, 1, 0, 6, '', '', ''),
(225, 744, 10, 'gallery-image07', 'gallery-image07-225', '', '', '2017-06-13 07:57:07', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image07_20170613_1163557361.jpg', 'gallery-image07_20170613_1163557361.jpg', 0, 0, 1, 0, 1, '', '', ''),
(226, 745, 10, 'gallery-image08', 'gallery-image08-226', '', '', '2017-06-13 07:57:21', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image08_20170613_1081681655.jpg', 'gallery-image08_20170613_1081681655.jpg', 0, 0, 1, 0, 2, '', '', ''),
(227, 746, 10, 'gallery-image09', 'gallery-image09-227', '', '', '2017-06-13 07:57:22', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image09_20170613_1092974928.jpg', 'gallery-image09_20170613_1092974928.jpg', 0, 0, 1, 0, 3, '', '', ''),
(228, 747, 10, 'gallery-image10', 'gallery-image10-228', '', '', '2017-06-13 07:57:39', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image10_20170613_1155577399.jpg', 'gallery-image10_20170613_1155577399.jpg', 0, 0, 1, 0, 4, '', '', ''),
(229, 748, 10, 'gallery-image11', 'gallery-image11-229', '', '', '2017-06-13 07:57:51', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image11_20170613_1760941948.jpg', 'gallery-image11_20170613_1760941948.jpg', 0, 0, 1, 0, 5, '', '', ''),
(230, 749, 10, 'gallery-image12', 'gallery-image12-230', '', '', '2017-06-13 07:58:03', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image12_20170613_1079538080.jpg', 'gallery-image12_20170613_1079538080.jpg', 0, 0, 1, 0, 6, '', '', ''),
(231, 750, 11, 'gallery-image13', 'gallery-image13-231', '', '', '2017-06-13 07:59:03', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image13_20170613_1750916203.jpg', 'gallery-image13_20170613_1750916203.jpg', 0, 0, 1, 0, 1, '', '', ''),
(232, 751, 11, 'gallery-image14', 'gallery-image14-232', '', '', '2017-06-13 07:59:19', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image14_20170613_1387647013.jpg', 'gallery-image14_20170613_1387647013.jpg', 0, 0, 1, 0, 2, '', '', ''),
(233, 752, 11, 'gallery-image15', 'gallery-image15-233', '', '', '2017-06-13 07:59:26', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image15_20170613_1503213720.jpg', 'gallery-image15_20170613_1503213720.jpg', 0, 0, 1, 0, 3, '', '', ''),
(234, 753, 11, 'gallery-image16', 'gallery-image16-234', '', '', '2017-06-13 07:59:45', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image16_20170613_1917512631.jpg', 'gallery-image16_20170613_1917512631.jpg', 0, 0, 1, 0, 4, '', '', ''),
(235, 754, 11, 'gallery-image17', 'gallery-image17-235', '', '', '2017-06-13 07:59:51', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image17_20170613_1427981441.jpg', 'gallery-image17_20170613_1427981441.jpg', 0, 0, 1, 0, 5, '', '', ''),
(236, 755, 11, 'gallery-image18', 'gallery-image18-236', '', '', '2017-06-13 07:59:59', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image18_20170613_1977506227.jpg', 'gallery-image18_20170613_1977506227.jpg', 0, 0, 1, 0, 6, '', '', ''),
(237, 756, 12, 'gallery-image19', 'gallery-image19-237', '', '', '2017-06-13 08:01:18', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image19_20170613_1275119800.jpg', 'gallery-image19_20170613_1275119800.jpg', 0, 0, 1, 0, 1, '', '', ''),
(238, 757, 12, 'gallery-image20', 'gallery-image20-238', '', '', '2017-06-13 08:01:30', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image20_20170613_1600031160.jpg', 'gallery-image20_20170613_1600031160.jpg', 0, 0, 1, 0, 2, '', '', ''),
(239, 758, 12, 'gallery-image21', 'gallery-image21-239', '', '', '2017-06-13 08:01:37', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image21_20170613_1866437866.jpg', 'gallery-image21_20170613_1866437866.jpg', 0, 0, 1, 0, 3, '', '', ''),
(240, 759, 12, 'gallery-image22', 'gallery-image22-240', '', '', '2017-06-13 08:01:38', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image22_20170613_1668831893.jpg', 'gallery-image22_20170613_1668831893.jpg', 0, 0, 1, 0, 4, '', '', ''),
(241, 760, 12, 'gallery-image23', 'gallery-image23-241', '', '', '2017-06-13 08:01:47', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image23_20170613_1421546958.jpg', 'gallery-image23_20170613_1421546958.jpg', 0, 0, 1, 0, 5, '', '', ''),
(242, 761, 12, 'gallery-image24', 'gallery-image24-242', '', '', '2017-06-13 08:01:54', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image24_20170613_1503564385.jpg', 'gallery-image24_20170613_1503564385.jpg', 0, 0, 1, 0, 6, '', '', ''),
(243, 762, 13, 'gallery-image25', 'gallery-image25-243', '', '', '2017-06-13 08:04:13', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image25_20170613_1577153239.jpg', 'gallery-image25_20170613_1577153239.jpg', 0, 0, 1, 0, 1, '', '', ''),
(244, 763, 13, 'gallery-image26', 'gallery-image26-244', '', '', '2017-06-13 08:04:25', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image26_20170613_1440346434.jpg', 'gallery-image26_20170613_1440346434.jpg', 0, 0, 1, 0, 2, '', '', ''),
(245, 764, 13, 'gallery-image27', 'gallery-image27-245', '', '', '2017-06-13 08:04:33', 1, 0, 0, 0, 1, 1, 0, 0, 'gallery-image27_20170613_1255706010.jpg', 'gallery-image27_20170613_1255706010.jpg', 0, 0, 1, 0, 3, '', '', ''),
(246, 765, 13, 'gallery-image28', 'gallery-image28-246', '', '', '2017-06-13 08:04:43', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image28_20170613_1776623647.jpg', 'gallery-image28_20170613_1776623647.jpg', 0, 0, 1, 0, 4, '', '', ''),
(247, 766, 13, 'gallery-image29', 'gallery-image29-247', '', '', '2017-06-13 08:04:52', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image29_20170613_1937311829.jpg', 'gallery-image29_20170613_1937311829.jpg', 0, 0, 1, 0, 5, '', '', ''),
(248, 767, 13, 'gallery-image30', 'gallery-image30-248', '', '', '2017-06-13 08:05:20', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image30_20170613_1300295342.jpg', 'gallery-image30_20170613_1300295342.jpg', 0, 0, 1, 0, 6, '', '', ''),
(249, 768, 14, 'gallery-image31', 'gallery-image31-249', '', '', '2017-06-13 08:06:50', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image31_20170613_1202462711.jpg', 'gallery-image31_20170613_1202462711.jpg', 0, 0, 1, 0, 1, '', '', ''),
(250, 769, 14, 'gallery-image32', 'gallery-image32-250', '', '', '2017-06-13 08:07:00', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image32_20170613_2083019644.jpg', 'gallery-image32_20170613_2083019644.jpg', 0, 0, 1, 0, 2, '', '', ''),
(251, 770, 14, 'gallery-image33', 'gallery-image33-251', '', '', '2017-06-13 08:07:13', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image33_20170613_1682111566.jpg', 'gallery-image33_20170613_1682111566.jpg', 0, 0, 1, 0, 3, '', '', ''),
(252, 771, 14, 'gallery-image34', 'gallery-image34-252', '', '', '2017-06-13 08:07:23', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image34_20170613_1096610765.jpg', 'gallery-image34_20170613_1096610765.jpg', 0, 0, 1, 0, 4, '', '', ''),
(253, 772, 14, 'gallery-image35', 'gallery-image35-253', '', '', '2017-06-13 08:07:37', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image35_20170613_1628331383.jpg', 'gallery-image35_20170613_1628331383.jpg', 0, 0, 1, 0, 5, '', '', ''),
(254, 773, 14, 'gallery-image36', 'gallery-image36-254', '', '', '2017-06-13 08:07:53', 0, 0, 0, 0, 1, 1, 0, 0, 'gallery-image36_20170613_1795893777.jpg', 'gallery-image36_20170613_1795893777.jpg', 0, 0, 1, 0, 6, '', '', '');

DROP TABLE IF EXISTS `#__joomgallery_category_details`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_category_details` (
  `id` int(11) NOT NULL,
  `details_key` varchar(255) NOT NULL,
  `details_value` text NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`,`details_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_catg`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_catg` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(2048) NOT NULL,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(1) UNSIGNED NOT NULL DEFAULT '0',
  `description` text,
  `access` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `hidden` tinyint(1) NOT NULL DEFAULT '0',
  `in_hidden` tinyint(1) NOT NULL DEFAULT '0',
  `password` varchar(100) NOT NULL DEFAULT '',
  `owner` int(11) DEFAULT '0',
  `thumbnail` int(11) DEFAULT NULL,
  `img_position` int(10) DEFAULT '0',
  `catpath` varchar(2048) NOT NULL,
  `params` text NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `exclude_toplists` int(1) NOT NULL,
  `exclude_search` int(1) NOT NULL,
  PRIMARY KEY (`cid`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;

INSERT INTO `#__joomgallery_catg` (`cid`, `asset_id`, `name`, `alias`, `parent_id`, `lft`, `rgt`, `level`, `description`, `access`, `published`, `hidden`, `in_hidden`, `password`, `owner`, `thumbnail`, `img_position`, `catpath`, `params`, `metakey`, `metadesc`, `exclude_toplists`, `exclude_search`) VALUES
(1, 0, 'ROOT', 'root', 0, 0, 15, 0, NULL, 1, 1, 0, 0, '', 0, NULL, 0, '', '', '', '', 0, 0),
(2, 170, 'Gallery', 'gallery', 1, 1, 14, 1, '', 1, 1, 0, 0, '', 846, 0, -1, 'gallery_2', '', '', '', 0, 0),
(9, 521, 'Gallery 1', 'gallery/gallery-1', 2, 2, 3, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_1_9', '', '', '', 0, 0),
(10, 522, 'Gallery 2', 'gallery/gallery-2', 2, 4, 5, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_2_10', '', '', '', 0, 0),
(11, 523, 'Gallery 3', 'gallery/gallery-3', 2, 6, 7, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_3_11', '', '', '', 0, 0),
(12, 524, 'Gallery 4', 'gallery/gallery-4', 2, 8, 9, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_4_12', '', '', '', 0, 0),
(13, 525, 'Gallery 5', 'gallery/gallery-5', 2, 10, 11, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_5_13', '', '', '', 0, 0),
(14, 526, 'Gallery 6', 'gallery/gallery-6', 2, 12, 13, 2, '', 1, 1, 0, 0, '', 0, 0, -1, 'gallery_2/gallery_6_14', '', '', '', 0, 0);

DROP TABLE IF EXISTS `#__joomgallery_comments`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_comments` (
  `cmtid` int(11) NOT NULL AUTO_INCREMENT,
  `cmtpic` int(11) NOT NULL DEFAULT '0',
  `cmtip` varchar(15) NOT NULL DEFAULT '',
  `userid` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `cmtname` varchar(50) NOT NULL DEFAULT '',
  `cmttext` text NOT NULL,
  `cmtdate` datetime NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`cmtid`),
  KEY `idx_cmtpic` (`cmtpic`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_config`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_config` (
  `id` int(1) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `jg_pathimages` varchar(100) NOT NULL,
  `jg_pathoriginalimages` varchar(100) NOT NULL,
  `jg_paththumbs` varchar(100) NOT NULL,
  `jg_pathftpupload` varchar(100) NOT NULL,
  `jg_pathtemp` varchar(100) NOT NULL,
  `jg_wmpath` varchar(100) NOT NULL,
  `jg_wmfile` varchar(50) NOT NULL,
  `jg_use_real_paths` int(1) NOT NULL,
  `jg_checkupdate` int(1) NOT NULL,
  `jg_filenamewithjs` int(1) NOT NULL,
  `jg_filenamereplace` text NOT NULL,
  `jg_thumbcreation` varchar(5) NOT NULL,
  `jg_fastgd2thumbcreation` int(1) NOT NULL,
  `jg_impath` varchar(50) NOT NULL,
  `jg_resizetomaxwidth` int(1) NOT NULL,
  `jg_maxwidth` int(5) NOT NULL,
  `jg_picturequality` int(3) NOT NULL,
  `jg_useforresizedirection` int(1) NOT NULL,
  `jg_cropposition` int(1) NOT NULL,
  `jg_thumbwidth` int(5) NOT NULL,
  `jg_thumbheight` int(5) NOT NULL,
  `jg_thumbquality` int(3) NOT NULL,
  `jg_uploadorder` int(1) NOT NULL,
  `jg_useorigfilename` int(1) NOT NULL,
  `jg_filenamenumber` int(1) NOT NULL,
  `jg_delete_original` int(1) NOT NULL,
  `jg_msg_upload_type` int(1) NOT NULL,
  `jg_msg_upload_recipients` text NOT NULL,
  `jg_msg_download_type` int(1) NOT NULL,
  `jg_msg_download_recipients` text NOT NULL,
  `jg_msg_zipdownload` int(1) NOT NULL,
  `jg_msg_comment_type` int(1) NOT NULL,
  `jg_msg_comment_recipients` text NOT NULL,
  `jg_msg_comment_toowner` int(1) NOT NULL,
  `jg_msg_nametag_type` int(1) NOT NULL,
  `jg_msg_nametag_recipients` text NOT NULL,
  `jg_msg_nametag_totaggeduser` int(1) NOT NULL,
  `jg_msg_nametag_toowner` int(1) NOT NULL,
  `jg_msg_report_type` int(1) NOT NULL,
  `jg_msg_report_recipients` text NOT NULL,
  `jg_msg_report_toowner` int(1) NOT NULL,
  `jg_msg_rejectimg_type` int(1) NOT NULL,
  `jg_msg_global_from` int(1) NOT NULL,
  `jg_realname` int(1) NOT NULL,
  `jg_contentpluginsenabled` int(1) NOT NULL,
  `jg_itemid` varchar(10) NOT NULL,
  `jg_ajaxcategoryselection` int(1) NOT NULL,
  `jg_disableunrequiredchecks` int(1) NOT NULL,
  `jg_use_listbox_max_user_count` int(1) NOT NULL,
  `jg_userspace` int(1) NOT NULL,
  `jg_useruploaddefaultcat` int(1) NOT NULL,
  `jg_approve` int(1) NOT NULL,
  `jg_unregistered_permissions` int(1) NOT NULL,
  `jg_maxusercat` int(5) NOT NULL,
  `jg_maxuserimage` int(9) NOT NULL,
  `jg_maxuserimage_timespan` int(9) NOT NULL,
  `jg_maxfilesize` int(9) NOT NULL,
  `jg_usercatacc` int(1) NOT NULL,
  `jg_usercatthumbalign` int(1) NOT NULL,
  `jg_useruploadsingle` int(1) NOT NULL,
  `jg_maxuploadfields` int(3) NOT NULL,
  `jg_useruploadajax` int(1) NOT NULL,
  `jg_useruploadbatch` int(1) NOT NULL,
  `jg_useruploadjava` int(1) NOT NULL,
  `jg_useruseorigfilename` int(1) NOT NULL,
  `jg_useruploadnumber` int(1) NOT NULL,
  `jg_special_gif_upload` int(1) NOT NULL,
  `jg_delete_original_user` int(1) NOT NULL,
  `jg_newpiccopyright` int(1) NOT NULL,
  `jg_newpicnote` int(1) NOT NULL,
  `jg_redirect_after_upload` int(1) NOT NULL,
  `jg_edit_metadata` int(1) NOT NULL,
  `jg_download` int(1) NOT NULL,
  `jg_download_unreg` int(1) NOT NULL,
  `jg_download_hint` int(1) NOT NULL,
  `jg_downloadfile` int(1) NOT NULL,
  `jg_downloadwithwatermark` int(1) NOT NULL,
  `jg_showrating` int(1) NOT NULL,
  `jg_maxvoting` int(1) NOT NULL,
  `jg_ratingcalctype` int(1) NOT NULL,
  `jg_ratingdisplaytype` int(1) NOT NULL,
  `jg_ajaxrating` int(1) NOT NULL,
  `jg_votingonlyonce` int(1) NOT NULL,
  `jg_votingonlyreg` int(1) NOT NULL,
  `jg_showcomment` int(1) NOT NULL,
  `jg_anoncomment` int(1) NOT NULL,
  `jg_namedanoncomment` int(1) NOT NULL,
  `jg_anonapprovecom` int(1) NOT NULL,
  `jg_approvecom` int(1) NOT NULL,
  `jg_bbcodesupport` int(1) NOT NULL,
  `jg_smiliesupport` int(1) NOT NULL,
  `jg_anismilie` int(1) NOT NULL,
  `jg_smiliescolor` varchar(10) NOT NULL,
  `jg_report_images` int(1) NOT NULL,
  `jg_report_unreg` int(1) NOT NULL,
  `jg_report_hint` int(1) NOT NULL,
  `jg_alternative_layout` varchar(255) NOT NULL,
  `jg_anchors` int(1) NOT NULL,
  `jg_tooltips` int(1) NOT NULL,
  `jg_dyncrop` int(1) NOT NULL,
  `jg_dyncropposition` int(1) NOT NULL,
  `jg_dyncropwidth` int(5) NOT NULL,
  `jg_dyncropheight` int(5) NOT NULL,
  `jg_dyncropbgcol` varchar(12) NOT NULL,
  `jg_hideemptycats` int(1) NOT NULL,
  `jg_skipcatview` int(1) NOT NULL,
  `jg_imgalign` int(3) NOT NULL,
  `jg_showrestrictedcats` int(1) NOT NULL,
  `jg_showrestrictedhint` int(1) NOT NULL,
  `jg_firstorder` varchar(20) NOT NULL,
  `jg_secondorder` varchar(20) NOT NULL,
  `jg_thirdorder` varchar(20) NOT NULL,
  `jg_pagetitle_cat` text NOT NULL,
  `jg_pagetitle_detail` text NOT NULL,
  `jg_showgalleryhead` int(1) NOT NULL,
  `jg_showpathway` int(1) NOT NULL,
  `jg_completebreadcrumbs` int(1) NOT NULL,
  `jg_search` int(1) NOT NULL,
  `jg_searchcols` int(1) NOT NULL,
  `jg_searchthumbalign` int(1) NOT NULL,
  `jg_searchtextalign` int(1) NOT NULL,
  `jg_showsearchdownload` int(1) NOT NULL,
  `jg_showsearchfavourite` int(1) NOT NULL,
  `jg_search_report_images` int(1) NOT NULL,
  `jg_showsearcheditorlinks` int(1) NOT NULL,
  `jg_showallpics` int(1) NOT NULL,
  `jg_showallhits` int(1) NOT NULL,
  `jg_showbacklink` int(1) NOT NULL,
  `jg_suppresscredits` int(1) NOT NULL,
  `jg_showuserpanel` int(1) NOT NULL,
  `jg_showuserpanel_hint` int(1) NOT NULL,
  `jg_showuserpanel_unreg` int(1) NOT NULL,
  `jg_showallpicstoadmin` int(1) NOT NULL,
  `jg_showminithumbs` int(1) NOT NULL,
  `jg_openjs_padding` int(3) NOT NULL,
  `jg_openjs_background` varchar(12) NOT NULL,
  `jg_dhtml_border` varchar(12) NOT NULL,
  `jg_show_title_in_popup` int(1) NOT NULL,
  `jg_show_description_in_popup` int(1) NOT NULL,
  `jg_lightbox_speed` int(3) NOT NULL,
  `jg_lightbox_slide_all` int(1) NOT NULL,
  `jg_resize_js_image` int(1) NOT NULL,
  `jg_disable_rightclick_original` int(1) NOT NULL,
  `jg_showgallerysubhead` int(1) NOT NULL,
  `jg_showallcathead` int(1) NOT NULL,
  `jg_colcat` int(1) NOT NULL,
  `jg_catperpage` int(1) NOT NULL,
  `jg_ordercatbyalpha` int(1) NOT NULL,
  `jg_showgallerypagenav` int(1) NOT NULL,
  `jg_showcatcount` int(1) NOT NULL,
  `jg_showcatthumb` int(1) NOT NULL,
  `jg_showrandomcatthumb` int(1) NOT NULL,
  `jg_ctalign` int(1) NOT NULL,
  `jg_showtotalcatimages` int(1) NOT NULL,
  `jg_showtotalcathits` int(1) NOT NULL,
  `jg_showcatasnew` int(1) NOT NULL,
  `jg_catdaysnew` int(3) NOT NULL,
  `jg_showdescriptioningalleryview` int(1) NOT NULL,
  `jg_uploadicongallery` int(1) NOT NULL,
  `jg_showsubsingalleryview` int(1) NOT NULL,
  `jg_category_rss` int(9) NOT NULL,
  `jg_category_rss_icon` varchar(10) NOT NULL,
  `jg_uploadiconcategory` int(1) NOT NULL,
  `jg_showcathead` int(1) NOT NULL,
  `jg_usercatorder` int(1) NOT NULL,
  `jg_usercatorderlist` varchar(50) NOT NULL,
  `jg_showcatdescriptionincat` int(1) NOT NULL,
  `jg_showpagenav` int(1) NOT NULL,
  `jg_showpiccount` int(1) NOT NULL,
  `jg_perpage` int(3) NOT NULL,
  `jg_catthumbalign` int(1) NOT NULL,
  `jg_colnumb` int(3) NOT NULL,
  `jg_detailpic_open` varchar(50) NOT NULL,
  `jg_lightboxbigpic` int(1) NOT NULL,
  `jg_showtitle` int(1) NOT NULL,
  `jg_showpicasnew` int(1) NOT NULL,
  `jg_daysnew` int(3) NOT NULL,
  `jg_showhits` int(1) NOT NULL,
  `jg_showdownloads` int(1) NOT NULL,
  `jg_showauthor` int(1) NOT NULL,
  `jg_showowner` int(1) NOT NULL,
  `jg_showcatcom` int(1) NOT NULL,
  `jg_showcatrate` int(1) NOT NULL,
  `jg_showcatdescription` int(1) NOT NULL,
  `jg_showcategorydownload` int(1) NOT NULL,
  `jg_showcategoryfavourite` int(1) NOT NULL,
  `jg_category_report_images` int(1) NOT NULL,
  `jg_showcategoryeditorlinks` int(1) NOT NULL,
  `jg_showsubcathead` int(1) NOT NULL,
  `jg_showsubcatcount` int(1) NOT NULL,
  `jg_colsubcat` int(3) NOT NULL,
  `jg_subperpage` int(3) NOT NULL,
  `jg_showpagenavsubs` int(1) NOT NULL,
  `jg_subcatthumbalign` int(1) NOT NULL,
  `jg_showsubthumbs` int(1) NOT NULL,
  `jg_showrandomsubthumb` int(1) NOT NULL,
  `jg_showdescriptionincategoryview` int(1) NOT NULL,
  `jg_ordersubcatbyalpha` int(1) NOT NULL,
  `jg_showtotalsubcatimages` int(1) NOT NULL,
  `jg_showtotalsubcathits` int(1) NOT NULL,
  `jg_uploadiconsubcat` int(1) NOT NULL,
  `jg_showdetailpage` int(1) NOT NULL,
  `jg_disabledetailpage` int(1) NOT NULL,
  `jg_showdetailnumberofpics` int(1) NOT NULL,
  `jg_cursor_navigation` int(1) NOT NULL,
  `jg_disable_rightclick_detail` int(1) NOT NULL,
  `jg_detail_report_images` int(1) NOT NULL,
  `jg_showdetaileditorlinks` int(1) NOT NULL,
  `jg_showdetailtitle` int(1) NOT NULL,
  `jg_showdetail` int(1) NOT NULL,
  `jg_showdetailaccordion` int(1) NOT NULL,
  `jg_accordionduration` int(3) NOT NULL,
  `jg_accordiondisplay` int(3) NOT NULL,
  `jg_accordionopacity` int(1) NOT NULL,
  `jg_accordionalwayshide` int(1) NOT NULL,
  `jg_accordioninitialeffect` int(1) NOT NULL,
  `jg_showdetaildescription` int(1) NOT NULL,
  `jg_showdetaildatum` int(1) NOT NULL,
  `jg_showdetailhits` int(1) NOT NULL,
  `jg_showdetaildownloads` int(1) NOT NULL,
  `jg_showdetailrating` int(1) NOT NULL,
  `jg_showdetailfilesize` int(1) NOT NULL,
  `jg_showdetailauthor` int(1) NOT NULL,
  `jg_showoriginalfilesize` int(1) NOT NULL,
  `jg_showdetaildownload` int(1) NOT NULL,
  `jg_watermark` int(1) NOT NULL,
  `jg_watermarkpos` int(1) NOT NULL,
  `jg_watermarkzoom` int(1) NOT NULL,
  `jg_watermarksize` int(1) NOT NULL,
  `jg_bigpic` int(1) NOT NULL,
  `jg_bigpic_unreg` int(1) NOT NULL,
  `jg_bigpic_open` varchar(50) NOT NULL,
  `jg_bbcodelink` int(1) NOT NULL,
  `jg_showcommentsunreg` int(1) NOT NULL,
  `jg_showcommentsarea` int(1) NOT NULL,
  `jg_send2friend` int(1) NOT NULL,
  `jg_minis` int(1) NOT NULL,
  `jg_motionminis` int(1) NOT NULL,
  `jg_motionminiWidth` int(3) NOT NULL,
  `jg_motionminiHeight` int(3) NOT NULL,
  `jg_motionminiLimit` int(2) NOT NULL DEFAULT '0',
  `jg_miniWidth` int(3) NOT NULL,
  `jg_miniHeight` int(3) NOT NULL,
  `jg_minisprop` int(1) NOT NULL,
  `jg_nameshields` int(1) NOT NULL,
  `jg_nameshields_others` int(1) NOT NULL,
  `jg_nameshields_unreg` int(1) NOT NULL,
  `jg_show_nameshields_unreg` int(1) NOT NULL,
  `jg_nameshields_height` int(3) NOT NULL,
  `jg_nameshields_width` int(3) NOT NULL,
  `jg_slideshow` int(1) NOT NULL,
  `jg_slideshow_timer` int(3) NOT NULL,
  `jg_slideshow_transition` int(1) NOT NULL,
  `jg_slideshow_transtime` int(3) NOT NULL,
  `jg_slideshow_maxdimauto` int(1) NOT NULL,
  `jg_slideshow_width` int(3) NOT NULL,
  `jg_slideshow_heigth` int(3) NOT NULL,
  `jg_slideshow_infopane` int(1) NOT NULL,
  `jg_slideshow_carousel` int(1) NOT NULL,
  `jg_slideshow_arrows` int(1) NOT NULL,
  `jg_slideshow_repeat` int(1) NOT NULL,
  `jg_showexifdata` int(1) NOT NULL,
  `jg_showgeotagging` int(1) NOT NULL,
  `jg_geotaggingkey` text NOT NULL,
  `jg_subifdtags` text NOT NULL,
  `jg_ifdotags` text NOT NULL,
  `jg_gpstags` text NOT NULL,
  `jg_showiptcdata` int(1) NOT NULL,
  `jg_iptctags` text NOT NULL,
  `jg_showtoplist` int(1) NOT NULL,
  `jg_toplist` int(3) NOT NULL,
  `jg_topthumbalign` int(1) NOT NULL,
  `jg_toptextalign` int(1) NOT NULL,
  `jg_toplistcols` int(3) NOT NULL,
  `jg_whereshowtoplist` int(1) NOT NULL,
  `jg_showrate` int(1) NOT NULL,
  `jg_showlatest` int(1) NOT NULL,
  `jg_showcom` int(1) NOT NULL,
  `jg_showthiscomment` int(1) NOT NULL,
  `jg_showmostviewed` int(1) NOT NULL,
  `jg_showtoplistdownload` int(1) NOT NULL,
  `jg_showtoplistfavourite` int(1) NOT NULL,
  `jg_toplist_report_images` int(1) NOT NULL,
  `jg_showtoplisteditorlinks` int(1) NOT NULL,
  `jg_favourites` int(1) NOT NULL,
  `jg_favouritesshownotauth` int(1) NOT NULL,
  `jg_maxfavourites` int(5) NOT NULL,
  `jg_zipdownload` int(1) NOT NULL,
  `jg_usefavouritesforpubliczip` int(1) NOT NULL,
  `jg_usefavouritesforzip` int(1) NOT NULL,
  `jg_allimagesofcategory` int(1) NOT NULL,
  `jg_showfavouritesdownload` int(1) NOT NULL,
  `jg_showfavouriteseditorlinks` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__joomgallery_config` (`id`, `group_id`, `ordering`, `jg_pathimages`, `jg_pathoriginalimages`, `jg_paththumbs`, `jg_pathftpupload`, `jg_pathtemp`, `jg_wmpath`, `jg_wmfile`, `jg_use_real_paths`, `jg_checkupdate`, `jg_filenamewithjs`, `jg_filenamereplace`, `jg_thumbcreation`, `jg_fastgd2thumbcreation`, `jg_impath`, `jg_resizetomaxwidth`, `jg_maxwidth`, `jg_picturequality`, `jg_useforresizedirection`, `jg_cropposition`, `jg_thumbwidth`, `jg_thumbheight`, `jg_thumbquality`, `jg_uploadorder`, `jg_useorigfilename`, `jg_filenamenumber`, `jg_delete_original`, `jg_msg_upload_type`, `jg_msg_upload_recipients`, `jg_msg_download_type`, `jg_msg_download_recipients`, `jg_msg_zipdownload`, `jg_msg_comment_type`, `jg_msg_comment_recipients`, `jg_msg_comment_toowner`, `jg_msg_nametag_type`, `jg_msg_nametag_recipients`, `jg_msg_nametag_totaggeduser`, `jg_msg_nametag_toowner`, `jg_msg_report_type`, `jg_msg_report_recipients`, `jg_msg_report_toowner`, `jg_msg_rejectimg_type`, `jg_msg_global_from`, `jg_realname`, `jg_contentpluginsenabled`, `jg_itemid`, `jg_ajaxcategoryselection`, `jg_disableunrequiredchecks`, `jg_use_listbox_max_user_count`, `jg_userspace`, `jg_useruploaddefaultcat`, `jg_approve`, `jg_unregistered_permissions`, `jg_maxusercat`, `jg_maxuserimage`, `jg_maxuserimage_timespan`, `jg_maxfilesize`, `jg_usercatacc`, `jg_usercatthumbalign`, `jg_useruploadsingle`, `jg_maxuploadfields`, `jg_useruploadajax`, `jg_useruploadbatch`, `jg_useruploadjava`, `jg_useruseorigfilename`, `jg_useruploadnumber`, `jg_special_gif_upload`, `jg_delete_original_user`, `jg_newpiccopyright`, `jg_newpicnote`, `jg_redirect_after_upload`, `jg_edit_metadata`, `jg_download`, `jg_download_unreg`, `jg_download_hint`, `jg_downloadfile`, `jg_downloadwithwatermark`, `jg_showrating`, `jg_maxvoting`, `jg_ratingcalctype`, `jg_ratingdisplaytype`, `jg_ajaxrating`, `jg_votingonlyonce`, `jg_votingonlyreg`, `jg_showcomment`, `jg_anoncomment`, `jg_namedanoncomment`, `jg_anonapprovecom`, `jg_approvecom`, `jg_bbcodesupport`, `jg_smiliesupport`, `jg_anismilie`, `jg_smiliescolor`, `jg_report_images`, `jg_report_unreg`, `jg_report_hint`, `jg_alternative_layout`, `jg_anchors`, `jg_tooltips`, `jg_dyncrop`, `jg_dyncropposition`, `jg_dyncropwidth`, `jg_dyncropheight`, `jg_dyncropbgcol`, `jg_hideemptycats`, `jg_skipcatview`, `jg_imgalign`, `jg_showrestrictedcats`, `jg_showrestrictedhint`, `jg_firstorder`, `jg_secondorder`, `jg_thirdorder`, `jg_pagetitle_cat`, `jg_pagetitle_detail`, `jg_showgalleryhead`, `jg_showpathway`, `jg_completebreadcrumbs`, `jg_search`, `jg_searchcols`, `jg_searchthumbalign`, `jg_searchtextalign`, `jg_showsearchdownload`, `jg_showsearchfavourite`, `jg_search_report_images`, `jg_showsearcheditorlinks`, `jg_showallpics`, `jg_showallhits`, `jg_showbacklink`, `jg_suppresscredits`, `jg_showuserpanel`, `jg_showuserpanel_hint`, `jg_showuserpanel_unreg`, `jg_showallpicstoadmin`, `jg_showminithumbs`, `jg_openjs_padding`, `jg_openjs_background`, `jg_dhtml_border`, `jg_show_title_in_popup`, `jg_show_description_in_popup`, `jg_lightbox_speed`, `jg_lightbox_slide_all`, `jg_resize_js_image`, `jg_disable_rightclick_original`, `jg_showgallerysubhead`, `jg_showallcathead`, `jg_colcat`, `jg_catperpage`, `jg_ordercatbyalpha`, `jg_showgallerypagenav`, `jg_showcatcount`, `jg_showcatthumb`, `jg_showrandomcatthumb`, `jg_ctalign`, `jg_showtotalcatimages`, `jg_showtotalcathits`, `jg_showcatasnew`, `jg_catdaysnew`, `jg_showdescriptioningalleryview`, `jg_uploadicongallery`, `jg_showsubsingalleryview`, `jg_category_rss`, `jg_category_rss_icon`, `jg_uploadiconcategory`, `jg_showcathead`, `jg_usercatorder`, `jg_usercatorderlist`, `jg_showcatdescriptionincat`, `jg_showpagenav`, `jg_showpiccount`, `jg_perpage`, `jg_catthumbalign`, `jg_colnumb`, `jg_detailpic_open`, `jg_lightboxbigpic`, `jg_showtitle`, `jg_showpicasnew`, `jg_daysnew`, `jg_showhits`, `jg_showdownloads`, `jg_showauthor`, `jg_showowner`, `jg_showcatcom`, `jg_showcatrate`, `jg_showcatdescription`, `jg_showcategorydownload`, `jg_showcategoryfavourite`, `jg_category_report_images`, `jg_showcategoryeditorlinks`, `jg_showsubcathead`, `jg_showsubcatcount`, `jg_colsubcat`, `jg_subperpage`, `jg_showpagenavsubs`, `jg_subcatthumbalign`, `jg_showsubthumbs`, `jg_showrandomsubthumb`, `jg_showdescriptionincategoryview`, `jg_ordersubcatbyalpha`, `jg_showtotalsubcatimages`, `jg_showtotalsubcathits`, `jg_uploadiconsubcat`, `jg_showdetailpage`, `jg_disabledetailpage`, `jg_showdetailnumberofpics`, `jg_cursor_navigation`, `jg_disable_rightclick_detail`, `jg_detail_report_images`, `jg_showdetaileditorlinks`, `jg_showdetailtitle`, `jg_showdetail`, `jg_showdetailaccordion`, `jg_accordionduration`, `jg_accordiondisplay`, `jg_accordionopacity`, `jg_accordionalwayshide`, `jg_accordioninitialeffect`, `jg_showdetaildescription`, `jg_showdetaildatum`, `jg_showdetailhits`, `jg_showdetaildownloads`, `jg_showdetailrating`, `jg_showdetailfilesize`, `jg_showdetailauthor`, `jg_showoriginalfilesize`, `jg_showdetaildownload`, `jg_watermark`, `jg_watermarkpos`, `jg_watermarkzoom`, `jg_watermarksize`, `jg_bigpic`, `jg_bigpic_unreg`, `jg_bigpic_open`, `jg_bbcodelink`, `jg_showcommentsunreg`, `jg_showcommentsarea`, `jg_send2friend`, `jg_minis`, `jg_motionminis`, `jg_motionminiWidth`, `jg_motionminiHeight`, `jg_motionminiLimit`, `jg_miniWidth`, `jg_miniHeight`, `jg_minisprop`, `jg_nameshields`, `jg_nameshields_others`, `jg_nameshields_unreg`, `jg_show_nameshields_unreg`, `jg_nameshields_height`, `jg_nameshields_width`, `jg_slideshow`, `jg_slideshow_timer`, `jg_slideshow_transition`, `jg_slideshow_transtime`, `jg_slideshow_maxdimauto`, `jg_slideshow_width`, `jg_slideshow_heigth`, `jg_slideshow_infopane`, `jg_slideshow_carousel`, `jg_slideshow_arrows`, `jg_slideshow_repeat`, `jg_showexifdata`, `jg_showgeotagging`, `jg_geotaggingkey`, `jg_subifdtags`, `jg_ifdotags`, `jg_gpstags`, `jg_showiptcdata`, `jg_iptctags`, `jg_showtoplist`, `jg_toplist`, `jg_topthumbalign`, `jg_toptextalign`, `jg_toplistcols`, `jg_whereshowtoplist`, `jg_showrate`, `jg_showlatest`, `jg_showcom`, `jg_showthiscomment`, `jg_showmostviewed`, `jg_showtoplistdownload`, `jg_showtoplistfavourite`, `jg_toplist_report_images`, `jg_showtoplisteditorlinks`, `jg_favourites`, `jg_favouritesshownotauth`, `jg_maxfavourites`, `jg_zipdownload`, `jg_usefavouritesforpubliczip`, `jg_usefavouritesforzip`, `jg_allimagesofcategory`, `jg_showfavouritesdownload`, `jg_showfavouriteseditorlinks`) VALUES
(1, 1, 1, 'images/joomgallery/details/', 'images/joomgallery/originals/', 'images/joomgallery/thumbnails/', 'administrator/components/com_joomgallery/temp/ftp_upload/', 'administrator/components/com_joomgallery/temp/', 'media/joomgallery/images/', 'watermark.png', 1, 1, 1, 'Š|S,Œ|O,Ž|Z,š|s,œ|oe,ž|z,Ÿ|Y,¥|Y,µ|u,À|A,Á|A,Â|A,Ã|A,Ä|AE,Å|A,Æ|A,Ç|C,È|E,É|E,Ê|E,Ë|E,Ì|I,Í|I,Î|I,Ï|I,Ð|D,Ñ|N,Ò|O,Ó|O,Ô|O,Õ|O,Ö|OE,Ø|O,Ù|U,Ú|U,Û|U,Ü|UE,Ý|Y,à|a,á|a,â|a,ã|a,ä|ae,å|a,æ|a,ç|c,è|e,é|e,ê|e,ë|e,ì|i,í|i,î|i,ï|i,ð|o,ñ|n,ò|o,ó|o,ô|o,õ|o,ö|oe,ø|o,ù|u,ú|u,û|u,ü|ue,ý|y,ÿ|y,ß|ss,ă|a,ş|s,ţ|t,ț|t,Ț|T,Ș|S,ș|s,Ş|S', 'gd2', 1, '', 1, 1900, 100, 2, 2, 768, 540, 100, 2, 1, 1, 0, 2, '-1', 2, '-1', 0, 2, '-1', 0, 2, '-1', 1, 0, 2, '-1', 0, 1, 0, 0, 1, '', 0, 0, 25, 0, 0, 0, 0, 10, 500, 0, 2000000, 1, 1, 1, 3, 1, 1, 1, 0, 1, 1, 2, 1, 1, 1, 0, 0, 1, 1, 2, 1, 0, 5, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 'grey', 0, 1, 1, '_:default', 0, 0, 0, 2, 100, 100, '#ffffff', 0, 0, 0, 1, 0, 'ordering ASC', 'imgdate DESC', 'imgtitle DESC', '#page_title - [! COM_JOOMGALLERY_COMMON_CATEGORY!]: #cat', '#page_title - [! COM_JOOMGALLERY_COMMON_CATEGORY!]: #cat - [! COM_JOOMGALLERY_COMMON_IMAGE!]:  #img', 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, '#000000', '#808080', 1, 1, 5, 1, 1, 1, 1, 0, 3, 9, 0, 1, 0, 1, 3, 3, 0, 0, 0, 7, 0, 0, 0, 10, '0', 0, 0, 0, 'date', 0, 3, 0, 9, 3, 3, 'fancyBox', 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 9, 1, 3, 2, 3, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 300, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 15, 0, 0, '6', 0, 0, 1, 0, 0, 2, 400, 50, 0, 28, 28, 2, 0, 1, 1, 0, 10, 6, 0, 6000, 0, 2000, 0, 640, 480, 0, 0, 0, 0, 0, 0, '', '', '', '', 0, '', 0, 12, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

DROP TABLE IF EXISTS `#__joomgallery_countstop`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_countstop` (
  `cspicid` int(11) NOT NULL DEFAULT '0',
  `csip` varchar(20) NOT NULL,
  `cssessionid` varchar(200) DEFAULT NULL,
  `cstime` datetime DEFAULT NULL,
  KEY `idx_cspicid` (`cspicid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__joomgallery_countstop` (`cspicid`, `csip`, `cssessionid`, `cstime`) VALUES
(219, '::1', 'VnASaXKwCjt25MVwuahjg4nYqf8b3nya', '2018-03-14 13:49:38');

DROP TABLE IF EXISTS `#__joomgallery_image_details`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_image_details` (
  `id` int(11) NOT NULL,
  `details_key` varchar(255) NOT NULL,
  `details_value` text NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`,`details_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_maintenance`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_maintenance` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `refid` int(11) NOT NULL,
  `catid` int(11) NOT NULL,
  `owner` int(11) NOT NULL,
  `title` text NOT NULL,
  `thumb` varchar(255) NOT NULL,
  `img` varchar(255) NOT NULL,
  `orig` varchar(255) NOT NULL,
  `thumborphan` int(11) NOT NULL,
  `imgorphan` int(11) NOT NULL,
  `origorphan` int(11) NOT NULL,
  `type` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_nameshields`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_nameshields` (
  `nid` int(11) NOT NULL AUTO_INCREMENT,
  `npicid` int(11) NOT NULL DEFAULT '0',
  `nuserid` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `nxvalue` int(11) NOT NULL DEFAULT '0',
  `nyvalue` int(11) NOT NULL DEFAULT '0',
  `by` int(11) NOT NULL DEFAULT '0',
  `nuserip` varchar(15) NOT NULL DEFAULT '0',
  `ndate` datetime NOT NULL,
  `nzindex` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`nid`),
  KEY `idx_picid` (`npicid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_orphans`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_orphans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fullpath` varchar(255) NOT NULL,
  `type` varchar(7) NOT NULL,
  `refid` int(11) NOT NULL,
  `title` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fullpath` (`fullpath`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_users`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_users` (
  `uid` int(11) NOT NULL AUTO_INCREMENT,
  `uuserid` int(11) NOT NULL DEFAULT '0',
  `piclist` text,
  `layout` int(1) NOT NULL,
  `time` datetime NOT NULL,
  `zipname` varchar(70) NOT NULL,
  PRIMARY KEY (`uid`),
  KEY `idx_uid` (`uuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__joomgallery_votes`;
CREATE TABLE IF NOT EXISTS `#__joomgallery_votes` (
  `voteid` int(11) NOT NULL AUTO_INCREMENT,
  `picid` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `userip` varchar(15) NOT NULL DEFAULT '0',
  `datevoted` datetime NOT NULL,
  `vote` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`voteid`),
  KEY `idx_picid` (`picid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_acl`;
CREATE TABLE IF NOT EXISTS `#__komento_acl` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `cid` varchar(255) NOT NULL,
  `component` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `rules` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `komento_acl_content_type` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

INSERT INTO `#__komento_acl` (`id`, `cid`, `component`, `type`, `rules`) VALUES
(1, '1', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":false,\"report_comment\":false,\"share_comment\":true,\"reply_comment\":false,\"upload_attachment\":false,\"download_attachment\":true,\"edit_own_comment\":false,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":false,\"author_delete_comment\":false,\"author_publish_comment\":false,\"author_unpublish_comment\":false,\"author_stick_comment\":false,\"author_delete_attachment\":false,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(2, '9', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":false,\"report_comment\":false,\"share_comment\":true,\"reply_comment\":false,\"upload_attachment\":false,\"download_attachment\":true,\"edit_own_comment\":false,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":false,\"author_delete_comment\":false,\"author_publish_comment\":false,\"author_unpublish_comment\":false,\"author_stick_comment\":false,\"author_delete_attachment\":false,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(3, '2', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":false,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":false,\"author_delete_comment\":false,\"author_publish_comment\":false,\"author_unpublish_comment\":false,\"author_stick_comment\":false,\"author_delete_attachment\":false,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(4, '6', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":true,\"delete_own_attachment\":true,\"author_edit_comment\":false,\"author_delete_comment\":false,\"author_publish_comment\":false,\"author_unpublish_comment\":false,\"author_stick_comment\":false,\"author_delete_attachment\":false,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(5, '7', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":true,\"delete_own_attachment\":true,\"author_edit_comment\":false,\"author_delete_comment\":false,\"author_publish_comment\":false,\"author_unpublish_comment\":false,\"author_stick_comment\":false,\"author_delete_attachment\":false,\"edit_all_comment\":true,\"delete_all_comment\":true,\"publish_all_comment\":true,\"unpublish_all_comment\":true,\"stick_all_comment\":true,\"delete_all_attachment\":true,\"read_others_comment\":true}'),
(6, '3', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":true,\"author_delete_comment\":true,\"author_publish_comment\":true,\"author_unpublish_comment\":true,\"author_stick_comment\":true,\"author_delete_attachment\":true,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(7, '4', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":true,\"author_delete_comment\":true,\"author_publish_comment\":true,\"author_unpublish_comment\":true,\"author_stick_comment\":true,\"author_delete_attachment\":true,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":false,\"unpublish_all_comment\":false,\"stick_all_comment\":false,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(8, '5', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":false,\"delete_own_attachment\":false,\"author_edit_comment\":true,\"author_delete_comment\":true,\"author_publish_comment\":true,\"author_unpublish_comment\":true,\"author_stick_comment\":true,\"author_delete_attachment\":true,\"edit_all_comment\":false,\"delete_all_comment\":false,\"publish_all_comment\":true,\"unpublish_all_comment\":true,\"stick_all_comment\":true,\"delete_all_attachment\":false,\"read_others_comment\":true}'),
(9, '8', 'com_content', 'usergroup', '{\"read_comment\":true,\"read_stickies\":true,\"read_lovies\":true,\"add_comment\":true,\"like_comment\":true,\"report_comment\":true,\"share_comment\":true,\"reply_comment\":true,\"upload_attachment\":true,\"download_attachment\":true,\"edit_own_comment\":true,\"delete_own_comment\":true,\"delete_own_attachment\":true,\"author_edit_comment\":true,\"author_delete_comment\":true,\"author_publish_comment\":true,\"author_unpublish_comment\":true,\"author_stick_comment\":true,\"author_delete_attachment\":true,\"edit_all_comment\":true,\"delete_all_comment\":true,\"publish_all_comment\":true,\"unpublish_all_comment\":true,\"stick_all_comment\":true,\"delete_all_attachment\":true,\"read_others_comment\":true}');

DROP TABLE IF EXISTS `#__komento_actions`;
CREATE TABLE IF NOT EXISTS `#__komento_actions` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `type` varchar(20) NOT NULL,
  `comment_id` bigint(20) UNSIGNED NOT NULL,
  `action_by` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `actioned` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `komento_actions` (`type`,`comment_id`,`action_by`),
  KEY `komento_actions_comment_id` (`comment_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_activities`;
CREATE TABLE IF NOT EXISTS `#__komento_activities` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `type` varchar(20) NOT NULL,
  `comment_id` bigint(20) NOT NULL,
  `uid` bigint(20) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;

INSERT INTO `#__komento_activities` (`id`, `type`, `comment_id`, `uid`, `created`, `published`) VALUES
(2, 'comment', 30, 0, '2016-05-06 14:28:30', 1),
(3, 'comment', 29, 0, '2016-05-06 14:28:30', 1),
(4, 'comment', 50, 0, '2016-05-06 14:28:41', 1),
(5, 'comment', 49, 0, '2016-05-06 14:28:41', 1),
(6, 'comment', 48, 0, '2016-05-06 14:28:41', 1),
(7, 'comment', 47, 0, '2016-05-06 14:28:41', 1),
(8, 'comment', 46, 0, '2016-05-06 14:28:41', 1),
(9, 'comment', 45, 0, '2016-05-06 14:28:41', 1),
(10, 'comment', 44, 0, '2016-05-06 14:28:41', 1),
(11, 'comment', 43, 0, '2016-05-06 14:28:41', 1),
(12, 'comment', 42, 0, '2016-05-06 14:28:41', 1),
(13, 'comment', 41, 0, '2016-05-06 14:28:41', 1),
(14, 'comment', 40, 0, '2016-05-06 14:28:41', 1),
(15, 'comment', 39, 0, '2016-05-06 14:28:41', 1),
(16, 'comment', 38, 0, '2016-05-06 14:28:41', 1),
(17, 'comment', 37, 0, '2016-05-06 14:28:41', 1),
(18, 'comment', 36, 0, '2016-05-06 14:28:41', 1),
(19, 'comment', 35, 0, '2016-05-06 14:28:41', 1),
(20, 'comment', 34, 0, '2016-05-06 14:28:41', 1),
(21, 'comment', 33, 0, '2016-05-06 14:28:41', 1),
(22, 'comment', 32, 0, '2016-05-06 14:28:41', 1),
(23, 'comment', 31, 0, '2016-05-06 14:28:41', 1);

DROP TABLE IF EXISTS `#__komento_captcha`;
CREATE TABLE IF NOT EXISTS `#__komento_captcha` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `response` varchar(5) NOT NULL,
  `created` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_comments`;
CREATE TABLE IF NOT EXISTS `#__komento_comments` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `component` varchar(255) NOT NULL,
  `cid` bigint(20) UNSIGNED NOT NULL,
  `comment` text,
  `name` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `email` varchar(255) DEFAULT '',
  `url` varchar(255) DEFAULT '',
  `ip` varchar(255) DEFAULT '',
  `created_by` bigint(20) UNSIGNED DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` bigint(20) UNSIGNED DEFAULT '0',
  `modified` datetime DEFAULT '0000-00-00 00:00:00',
  `deleted_by` bigint(20) UNSIGNED DEFAULT '0',
  `deleted` datetime DEFAULT '0000-00-00 00:00:00',
  `flag` tinyint(1) DEFAULT '0',
  `published` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `publish_up` datetime DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime DEFAULT '0000-00-00 00:00:00',
  `sticked` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `sent` tinyint(1) DEFAULT '0',
  `parent_id` int(11) UNSIGNED DEFAULT '0',
  `lft` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `rgt` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `depth` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `latitude` varchar(255) DEFAULT NULL,
  `longitude` varchar(255) DEFAULT NULL,
  `address` text,
  `params` text,
  `ratings` int(11) UNSIGNED DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `komento_threaded` (`component`,`cid`,`published`,`lft`,`rgt`),
  KEY `komento_threaded_reverse` (`component`,`cid`,`published`,`rgt`),
  KEY `komento_module_comments` (`component`,`cid`,`published`,`created`),
  KEY `komento_backend` (`parent_id`,`created`)
) ENGINE=InnoDB AUTO_INCREMENT=51 DEFAULT CHARSET=utf8;

INSERT INTO `#__komento_comments` (`id`, `component`, `cid`, `comment`, `name`, `title`, `email`, `url`, `ip`, `created_by`, `created`, `modified_by`, `modified`, `deleted_by`, `deleted`, `flag`, `published`, `publish_up`, `publish_down`, `sticked`, `sent`, `parent_id`, `lft`, `rgt`, `depth`, `latitude`, `longitude`, `address`, `params`, `ratings`) VALUES
(1, 'com_content', 118, 'The author did a great job with all these research work. Really valuable information, thank you!', 'James Bernard', '', 'james_bernard@gmail.com', '', '127.0.0.1', 0, '2014-05-03 09:58:29', 846, '2015-10-15 12:20:08', 0, '0000-00-00 00:00:00', 0, 0, '2015-02-25 13:41:36', '2016-04-01 05:36:34', 0, 0, 0, 1, 4, 0, '', '', '', '{}', 0),
(2, 'com_content', 118, 'Completely agree with the author. Modern businessmen should involve young people, introduce brands to them, socialize… Looks like a fresh product market!', 'Bill Brown', '', 'bill_brown@gmail.com', '', '127.0.0.1', 0, '2014-05-03 09:59:15', 846, '2015-10-15 12:20:34', 0, '0000-00-00 00:00:00', 0, 0, '2014-05-03 09:59:30', '2016-04-01 05:36:27', 0, 0, 0, 5, 8, 0, '', '', '', '{}', 0),
(3, 'com_content', 118, 'That’s awesome! Future belongs to youngsters, so businessmen can’t ignore their needs in any case.', 'Demo User', '', 'demo@demoolink.org', '', '127.0.0.1', 846, '2014-05-03 10:02:21', 846, '2015-10-15 12:20:52', 0, '0000-00-00 00:00:00', 0, 0, '2014-05-03 10:02:21', '2016-04-01 05:36:27', 0, 0, 2, 6, 7, 1, '', '', '', '{}', 0),
(4, 'com_content', 118, 'fdghfsdfg', 'asdasd', '', 'asdas@r.ru', '', '192.168.9.111', 0, '2015-07-03 14:13:52', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 2, '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 0, 0, 9, 10, 0, '', '', '', NULL, 0),
(5, 'com_content', 118, 'DSFGJHGDFDGH', 'asdsad', '', 'ssad@r.ru', '', '192.168.9.111', 0, '2015-07-03 14:21:06', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 2, '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 0, 0, 11, 12, 0, '', '', '', NULL, 0),
(29, 'com_content', 118, 'I\'ve already been to this show several times. Each time the organizers have something to amaze the visitors with - various kinds of vehicles, new concept cars, amazing presentations etc. Last year exhibition was outstanding, and I think this show is definitely worth visiting.', 'Diane Howard', '', 'howard@demolink.org', '', '::1', 0, '2016-05-06 14:12:10', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:30', '0000-00-00 00:00:00', 0, 0, 0, 13, 14, 0, '', '', '', '{}', 0),
(30, 'com_content', 118, 'I believe all enthusiasts know about this show. As for me, I was really excited when I visited it in Ontario, Canada, 6 years ago. I hope it has not changed much or at least changed for the better, as it is the only source of getting the latest information about motor industry trends and its fresh news.', 'James Cox', '', 'cox@demolink.org', '', '::1', 0, '2016-05-06 14:12:58', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:30', '0000-00-00 00:00:00', 0, 0, 0, 15, 16, 0, '', '', '', '{}', 0),
(31, 'com_content', 119, 'Wow, it\'s great news! I am a big fan of everything Fox TV produces, especially of their successful show \"Bones\" that has already experienced more than 10 years of broadcast. I will certainly invite my friends to this highly anticipated event!', 'Keith Hernandez', '', 'hernandez@demolink.org', '', '::1', 0, '2016-05-06 14:14:11', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(32, 'com_content', 119, 'I heard enough rumors about this event from executive directors and employees of other American TV channels but still couldn\'t believe it can be done in such scale. However, I am satisfied that Fox\'s board of directors decided to make this venture real, and I hope it will be successful.', 'Fred Martin', '', 'martin@demolink.org', '', '::1', 0, '2016-05-06 14:14:40', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(33, 'com_content', 120, 'The works by Mr. Lewis have always attracted me with their topicality, and his civic stand is the reason why I became a specialist in ecology. I am glad that his ideas will be used to change the situation of environment protection in our world.', 'Nancy Phillips', '', 'phillips@demolink.org', '', '::1', 0, '2016-05-06 14:15:32', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(34, 'com_content', 120, 'I do not support Jerry C. Lewis in everything he does, but his latest ideas and initiatives are really worthy ones. I hope they can be implemented in the world\'s governmental acts without any difficulties. The issue of climate regulation and environmental protection is now the most critical one.', 'Russell Hughes', '', 'hughes@demolink.org', '', '::1', 0, '2016-05-06 14:16:22', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(35, 'com_content', 15, 'I haven\'t expected science can be beneficial to studying human feelings and emotions. However, the result of the research appeared to be quite predictable. Music is often the only relief for me when I feel depressed or sad. Still, we have to respect the tastes of others as it is a key to our musical satisfaction.', 'Rose Torres', '', 'torres@demolink.org', '', '::1', 0, '2016-05-06 14:19:55', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(36, 'com_content', 15, 'I\'m not surprised that scientists have come to such a result. Music has been human\'s concomitant since the beginning of our civilization and I think music and humanity are closely connected. However, if you do not enjoy a certain style, it will be hard for you to benefit from music emotionally.', 'Daniel Richards', '', 'richards@demolink.org', '', '::1', 0, '2016-05-06 14:20:19', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(37, 'com_content', 8, 'As a resident of Miami, I\'m not very satisfied with the decision of organizers to change the venue. However, it must have really been a forced step. I hope this year fair will be worthy or even better than last year. And I hope Miami Exhibition Center will become available again next year.', 'Jonathan Russell', '', 'russell@demolink.org', '', '::1', 0, '2016-05-06 14:20:57', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(38, 'com_content', 8, 'As for me, the American Tea and Coffee Fair is one of the most original events devoted to two widely spread drinks. If you love tea and enjoy drinking coffee, this fair is number one event for you. You can freely invite your family and friends to visit it and benefit from your free time.', 'Peter Clark', '', 'clark@demolink.org', '', '::1', 0, '2016-05-06 14:21:52', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(39, 'com_content', 14, 'My sister has been talking a lot about Bernard\'s pictures and his special approach to every masterpiece he creates. It all sounded so interesting that I could not resist visiting his exhibition in Dallas 3 months ago. What I saw surpassed my expectations. James\'s works are really spectacular. If you live in LA, I recommend you to visit the upcoming exhibition in this city.', 'Russell Turner', '', 'turner@demolink.org', '', '::1', 0, '2016-05-06 14:22:25', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(40, 'com_content', 14, 'Great news! I visited the exhibition of Bernard\'s Art School in 2010 and it was spectacular. I was completely satisfied with what I saw last month in Miami at his art exhibition. You should definitely visit the upcoming one in LA, you won\'t regret!', 'Jim Johnson', '', 'johnson@demolink.org', '', '::1', 0, '2016-05-06 14:22:58', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(41, 'com_content', 12, 'I doubt that simple discussion can change anything in our country, but if you really have an idea to share, this is your chance to shake our government up. It\'s quite a good initiative, but to my mind, it will only work when all results of discussion are formed into real suggestions for statesmen.', 'Bonnie Ross', '', 'ross@demolink.org', '', '::1', 0, '2016-05-06 14:23:38', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(42, 'com_content', 12, 'I hope this project will change something in our social and political state because many of our state\'s residents are really fed up with the current situation including the world economic crisis, poverty, overpopulation etc.', 'Katherine Cook', '', 'cook@demolink.org', '', '::1', 0, '2016-05-06 14:24:09', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(43, 'com_content', 13, 'I am grateful for the opportunities you provide to everyone who wants to learn basic and advanced defense skills. Every evening I have to make my way through a dangerous area, and your course is a real rescue for me.', 'Jane Ramirez', '', 'ramirez@demolink.org', '', '::1', 0, '2016-05-06 14:24:37', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(44, 'com_content', 13, 'This course includes everything you may need to learn basic self-defense skills. As a professional fighter, I recommend you to check out the video tutorials of Bradley Roberts. He is the acknowledged and licensed professional in self-defense and martial arts. With his guidance, you can benefit from learning how to defend yourself.', 'Wesley Mills', '', 'mills@demolink.org', '', '::1', 0, '2016-05-06 14:25:00', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(45, 'com_content', 9, 'Management is an important element of every company\'s work, but cost management is even more important because it gives every businessman an opportunity to control the financial side of his company, and manage its resources effectively.', 'Kelly Murphy', '', 'murphy@demolink.org', '', '::1', 0, '2016-05-06 14:25:39', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(46, 'com_content', 9, 'It\'s amazing! These services have really helped my company to manage several important projects and to establish good reputation of my business. And I think if cost management is applied correctly, it can improve the whole financial state of any company.', 'Kate Doyle', '', 'doyle@demolink.org', '', '::1', 0, '2016-05-06 14:26:04', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(47, 'com_content', 10, 'My town has always been deprived of the latest technological achievements of humanity. It\'s great news that our government has supported this initiative. I hope we will have high-quality digital television network by next year.', 'Bert McGuire', '', 'mcguire@demolink.org', '', '::1', 0, '2016-05-06 14:26:36', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(48, 'com_content', 10, 'This initiative may seem very risky, but I am very glad that my city is one of the first introduced to the digital broadcasting technologies and entertainment in my country.', 'Brandon Morrison', '', 'morrison@demolink.org', '', '::1', 0, '2016-05-06 14:27:00', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0),
(49, 'com_content', 11, 'My younger sister was not interested in reading books at all until we visited this exhibition. It was an experience full of positive emotions and great impressions. The most important fact is that the event aroused her interest in reading, though I didn\'t expect it to happen.', 'Mary Lee', '', 'lee@demolink.org', '', '::1', 0, '2016-05-06 14:27:39', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 1, 2, 0, '', '', '', '{}', 0),
(50, 'com_content', 11, 'My son had a lot of fun at the exhibition - he took photos of his favorite book heroes, read some short stories by young yet exceptionally talented authors and had a good time at the CBE\'s playground. It was a perfect opportunity to spend our free time and learn something new.', 'Michael jenkins', '', 'jenkins@demolink.org', '', '::1', 0, '2016-05-06 14:28:05', 0, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0, 1, '2016-05-06 14:28:41', '0000-00-00 00:00:00', 0, 0, 0, 3, 4, 0, '', '', '', '{}', 0);

DROP TABLE IF EXISTS `#__komento_configs`;
CREATE TABLE IF NOT EXISTS `#__komento_configs` (
  `component` varchar(255) NOT NULL,
  `params` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__komento_configs` (`component`, `params`) VALUES
('com_komento_comments_columns', '{\"column_comment\":\"1\",\"column_published\":\"1\",\"column_sticked\":\"1\",\"column_link\":\"1\",\"column_edit\":\"1\",\"column_component\":\"1\",\"column_article\":\"1\",\"column_date\":\"1\",\"column_author\":\"1\",\"column_id\":\"1\",\"column_email\":\"1\",\"column_homepage\":\"0\",\"column_ip\":\"0\",\"column_latitude\":\"0\",\"column_longitude\":\"0\",\"column_address\":\"0\"}'),
('com_komento_pending_columns', '{\"column_comment\":1,\"column_published\":1,\"column_link\":1,\"column_edit\":1,\"column_component\":1,\"column_article\":1,\"column_date\":1,\"column_author\":1,\"column_id\":1}'),
('com_komento_reports_columns', '{\"column_comment\":1,\"column_published\":1,\"column_link\":1,\"column_edit\":1,\"column_component\":1,\"column_article\":1,\"column_date\":1,\"column_author\":1,\"column_id\":1}'),
('com_komento', '{\"profile_enable\":\"0\",\"profile_tab_comments\":\"1\",\"profile_tab_activities\":\"1\",\"profile_tab_popular\":\"1\",\"profile_tab_sticked\":\"1\",\"name_type\":\"default\",\"layout_avatar_integration\":\"gravatar\",\"layout_phpbb_path\":\"\",\"layout_phpbb_url\":\"\",\"profile_activities_comments\":\"1\",\"profile_activities_replies\":\"1\",\"profile_activities_likes\":\"1\"}'),
('com_content', '{\"enable_komento\":\"1\",\"disable_komento_on_tmpl_component\":\"1\",\"allowed_categories_mode\":\"1\",\"allowed_categories\":[\"11\",\"12\",\"13\",\"14\",\"15\",\"48\",\"49\",\"50\",\"51\",\"52\",\"53\",\"54\"],\"enable_orphanitem_convert\":\"0\",\"orphanitem_ownership\":\"0\",\"enable_login_form\":\"0\",\"login_provider\":\"joomla\",\"enable_moderation\":\"1\",\"requires_moderation\":[\"1\",\"9\",\"2\"],\"subscription_auto\":\"0\",\"subscription_confirmation\":\"0\",\"pagebreak_load\":\"last\",\"antispam_akismet\":\"0\",\"antispam_akismet_key\":\"\",\"antispam_akismet_trackback\":\"0\",\"antispam_flood_control\":\"0\",\"antispam_flood_interval\":\"10\",\"antispam_min_length_enable\":\"0\",\"antispam_min_length\":\"10\",\"antispam_max_length_enable\":\"0\",\"antispam_max_length\":\"300\",\"filter_word\":\"0\",\"filter_word_text\":\"\",\"blacklist_ip\":\"\",\"antispam_captcha_enable\":\"0\",\"antispam_captcha_type\":\"0\",\"show_captcha\":[\"1\"],\"antispam_recaptcha_ssl\":\"0\",\"antispam_recaptcha_public_key\":\"\",\"antispam_recaptcha_private_key\":\"\",\"antispam_recaptcha_theme\":\"clean\",\"antispam_recaptcha_lang\":\"en\",\"layout_theme\":\"kuro\",\"enable_responsive\":\"1\",\"tabbed_comments\":\"0\",\"max_threaded_level\":\"5\",\"enable_threaded\":\"1\",\"thread_indentation\":\"20\",\"show_sort_buttons\":\"0\",\"default_sort\":\"oldest\",\"load_previous\":\"0\",\"max_comments_per_page\":\"10\",\"layout_template_override\":\"1\",\"layout_component_override\":\"1\",\"layout_inherit_kuro_css\":\"0\",\"layout_css_admin\":\"kmt-comment-item-admin\",\"layout_css_registered\":\"kmt-comment-item-registered\",\"layout_css_author\":\"kmt-comment-item-author\",\"layout_css_public\":\"kmt-comment-item-public\",\"name_type\":\"default\",\"guest_label\":\"1\",\"auto_hyperlink\":\"1\",\"links_nofollow\":\"1\",\"datetime_permalink\":\"1\",\"date_format\":\"l, M j Y g:i:sa\",\"max_image_width\":\"300\",\"max_image_height\":\"300\",\"allow_video\":\"1\",\"bbcode_video_width\":\"350\",\"bbcode_video_height\":\"350\",\"layout_frontpage_comment\":\"1\",\"layout_frontpage_readmore\":\"1\",\"layout_frontpage_readmore_use_joomla\":\"1\",\"layout_frontpage_hits\":\"0\",\"layout_frontpage_alignment\":\"left\",\"enable_lapsed_time\":\"1\",\"layout_avatar_enable\":\"1\",\"enable_guest_link\":\"0\",\"enable_permalink\":\"0\",\"enable_share\":\"1\",\"enable_likes\":\"1\",\"enable_reply\":\"1\",\"enable_report\":\"0\",\"enable_location\":\"0\",\"enable_info\":\"0\",\"enable_syntax_highlighting\":\"0\",\"enable_id\":\"0\",\"enable_reply_reference\":\"1\",\"enable_rank_bar\":\"0\",\"enable_live_notification\":\"1\",\"live_notification_interval\":\"30\",\"form_position\":\"0\",\"form_toggle_button\":\"0\",\"autohide_form_notification\":\"1\",\"form_show_moderate_message\":\"1\",\"scroll_to_comment\":\"1\",\"show_location\":\"0\",\"enable_bbcode\":\"0\",\"enable_subscription\":\"0\",\"tnc_text\":\"Before submitting the comment, you agree that:\\r\\n\\r\\na. To accept full responsibility for the comment that you submit.\\r\\nb. To use this function only for lawful purposes.\\r\\nc. Not to post defamatory, abusive, offensive, racist, sexist, threatening, vulgar, obscene, hateful or otherwise inappropriate comments, or to post comments which will constitute a criminal offense or give rise to civil liability.\\r\\nd. Not to post or make available any material which is protected by copyright, trade mark or other proprietary right without the express permission of the owner of the copyright, trade mark or any other proprietary right.\\r\\ne. To evaluate for yourself the accuracy of any opinion, advice or other content.\",\"show_name\":\"1\",\"show_email\":\"1\",\"show_website\":\"1\",\"require_name\":\"1\",\"require_email\":\"1\",\"require_website\":\"0\",\"enable_email_regex\":\"1\",\"email_regex\":[\"%5CS%2B%40%5CS%2B\"],\"enable_website_regex\":\"1\",\"website_regex\":[\"%28http%3A%2F%2F%7Cftp%3A%2F%2F%7Cwww%29%5CS%2B\"],\"layout_avatar_integration\":\"gravatar\",\"use_komento_profile\":\"1\",\"easysocial_profile_popbox\":\"0\",\"gravatar_default_avatar\":\"mm\",\"layout_phpbb_path\":\"\",\"layout_phpbb_url\":\"\",\"bbcode_bold\":\"1\",\"bbcode_italic\":\"1\",\"bbcode_underline\":\"1\",\"bbcode_link\":\"1\",\"bbcode_picture\":\"1\",\"bbcode_video\":\"1\",\"bbcode_bulletlist\":\"1\",\"bbcode_numericlist\":\"1\",\"bbcode_bullet\":\"1\",\"bbcode_quote\":\"1\",\"bbcode_code\":\"1\",\"bbcode_clean\":\"1\",\"bbcode_smile\":\"1\",\"bbcode_happy\":\"1\",\"bbcode_surprised\":\"1\",\"bbcode_tongue\":\"1\",\"bbcode_unhappy\":\"1\",\"bbcode_wink\":\"1\",\"smileycode\":[],\"smileypath\":[],\"share_facebook\":\"1\",\"share_twitter\":\"1\",\"share_googleplus\":\"1\",\"share_linkedin\":\"1\",\"share_tumblr\":\"1\",\"share_digg\":\"1\",\"share_delicious\":\"1\",\"share_reddit\":\"1\",\"share_stumbleupon\":\"1\",\"enable_conversation_bar\":\"0\",\"conversation_bar_max_authors\":\"10\",\"conversation_bar_include_guest\":\"0\",\"enable_stickies\":\"0\",\"max_stickies\":\"5\",\"enable_lovies\":\"0\",\"minimum_likes_lovies\":\"0\",\"max_lovies\":\"5\",\"syntaxhighlighter_theme\":\"default\",\"notification_enable\":\"0\",\"notification_sendmailonpageload\":\"0\",\"notification_sendmailinhtml\":\"0\",\"notification_event_new_comment\":\"0\",\"notification_event_new_reply\":\"0\",\"notification_event_new_pending\":\"0\",\"notification_event_reported_comment\":\"0\",\"notification_to_author\":\"0\",\"notification_to_subscribers\":\"0\",\"activities_comment\":\"1\",\"activities_reply\":\"1\",\"activities_like\":\"1\",\"trigger_method\":\"component\",\"target\":\"com_content\",\"tnc\":\"\",\"show_tnc\":[],\"notification_to_usergroup_comment\":[],\"notification_to_usergroup_reply\":[],\"notification_to_usergroup_pending\":[],\"notification_to_usergroup_reported\":[],\"notification_es_to_usergroup_comment\":[],\"notification_es_to_usergroup_reply\":[],\"notification_es_to_usergroup_like\":[]}');

DROP TABLE IF EXISTS `#__komento_hashkeys`;
CREATE TABLE IF NOT EXISTS `#__komento_hashkeys` (
  `id` bigint(11) NOT NULL AUTO_INCREMENT,
  `uid` bigint(11) NOT NULL,
  `type` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `key` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_ipfilter`;
CREATE TABLE IF NOT EXISTS `#__komento_ipfilter` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `component` varchar(255) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `rules` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `komento_ipfilter` (`component`,`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_mailq`;
CREATE TABLE IF NOT EXISTS `#__komento_mailq` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mailfrom` varchar(255) DEFAULT NULL,
  `fromname` varchar(255) DEFAULT NULL,
  `recipient` varchar(255) NOT NULL,
  `subject` text NOT NULL,
  `body` text NOT NULL,
  `created` datetime NOT NULL,
  `type` varchar(10) NOT NULL DEFAULT 'text',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `komento_mailq_status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_subscription`;
CREATE TABLE IF NOT EXISTS `#__komento_subscription` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `type` varchar(20) NOT NULL,
  `component` varchar(255) NOT NULL,
  `cid` bigint(20) UNSIGNED NOT NULL,
  `userid` bigint(20) UNSIGNED NOT NULL DEFAULT '0',
  `fullname` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `komento_subscription` (`type`,`component`,`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__komento_uploads`;
CREATE TABLE IF NOT EXISTS `#__komento_uploads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `filename` text NOT NULL,
  `hashname` text NOT NULL,
  `path` text,
  `created` datetime NOT NULL,
  `created_by` bigint(20) UNSIGNED DEFAULT '0',
  `published` tinyint(1) NOT NULL,
  `mime` text NOT NULL,
  `size` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__kunena_aliases`;
CREATE TABLE IF NOT EXISTS `#__kunena_aliases` (
  `alias` varchar(255) CHARACTER SET utf8 NOT NULL,
  `type` varchar(10) CHARACTER SET utf8 NOT NULL,
  `item` varchar(32) CHARACTER SET utf8 NOT NULL,
  `state` tinyint(4) NOT NULL DEFAULT '0',
  UNIQUE KEY `alias` (`alias`),
  KEY `state` (`state`),
  KEY `item` (`item`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_aliases` (`alias`, `type`, `item`, `state`) VALUES
('announcement', 'view', 'announcement', 1),
('category', 'view', 'category', 1),
('category/create', 'layout', 'category.create', 1),
('category/default', 'layout', 'category.default', 1),
('category/edit', 'layout', 'category.edit', 1),
('category/manage', 'layout', 'category.manage', 1),
('category/moderate', 'layout', 'category.moderate', 1),
('category/user', 'layout', 'category.user', 1),
('common', 'view', 'common', 1),
('create', 'layout', 'category.create', 0),
('credits', 'view', 'credits', 1),
('default', 'layout', 'category.default', 0),
('edit', 'layout', 'category.edit', 0),
('home', 'view', 'home', 1),
('ideal-forum', 'catid', '5', 0),
('kunena-the-communication-platform-for-joomla', 'catid', '4', 0),
('main-forum', 'catid', '1', 1),
('manage', 'layout', 'category.manage', 0),
('misc', 'view', 'misc', 1),
('moderate', 'layout', 'category.moderate', 0),
('more-about-the-kunena', 'catid', '6', 0),
('search', 'view', 'search', 1),
('statistics', 'view', 'statistics', 1),
('suggestion-box', 'catid', '3', 1),
('topic', 'view', 'topic', 1),
('topics', 'view', 'topics', 1),
('user', 'view', 'user', 1),
('welcome-mat', 'catid', '2', 1);

DROP TABLE IF EXISTS `#__kunena_announcement`;
CREATE TABLE IF NOT EXISTS `#__kunena_announcement` (
  `id` int(3) NOT NULL AUTO_INCREMENT,
  `title` tinytext CHARACTER SET utf8 NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `sdescription` text CHARACTER SET utf8 NOT NULL,
  `description` text CHARACTER SET utf8 NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` tinyint(4) NOT NULL DEFAULT '0',
  `showdate` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_attachments`;
CREATE TABLE IF NOT EXISTS `#__kunena_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mesid` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `protected` tinyint(4) NOT NULL DEFAULT '0',
  `hash` char(32) CHARACTER SET utf8 DEFAULT NULL,
  `size` int(11) DEFAULT NULL,
  `folder` varchar(255) CHARACTER SET utf8 NOT NULL,
  `filetype` varchar(20) CHARACTER SET utf8 NOT NULL,
  `filename` varchar(255) CHARACTER SET utf8 NOT NULL,
  `filename_real` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `caption` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `inline` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `mesid` (`mesid`),
  KEY `userid` (`userid`),
  KEY `hash` (`hash`),
  KEY `filename` (`filename`),
  KEY `filename_real` (`filename_real`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_categories`;
CREATE TABLE IF NOT EXISTS `#__kunena_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) DEFAULT '0',
  `name` tinytext CHARACTER SET utf8,
  `alias` varchar(255) CHARACTER SET utf8 NOT NULL,
  `icon` varchar(60) CHARACTER SET utf8 DEFAULT NULL,
  `icon_id` tinyint(4) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `accesstype` varchar(20) CHARACTER SET utf8 NOT NULL DEFAULT 'joomla.level',
  `access` int(11) NOT NULL DEFAULT '0',
  `pub_access` int(11) NOT NULL DEFAULT '1',
  `pub_recurse` tinyint(4) DEFAULT '1',
  `admin_access` int(11) NOT NULL DEFAULT '0',
  `admin_recurse` tinyint(4) DEFAULT '1',
  `ordering` smallint(6) NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL DEFAULT '0',
  `channels` text CHARACTER SET utf8,
  `checked_out` int(11) DEFAULT NULL,
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review` tinyint(4) NOT NULL DEFAULT '0',
  `allow_anonymous` tinyint(4) NOT NULL DEFAULT '0',
  `post_anonymous` tinyint(4) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `description` text CHARACTER SET utf8 NOT NULL,
  `headerdesc` text CHARACTER SET utf8 NOT NULL,
  `topictemplate` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `class_sfx` varchar(20) CHARACTER SET utf8 NOT NULL,
  `allow_polls` tinyint(4) NOT NULL DEFAULT '0',
  `topic_ordering` varchar(16) CHARACTER SET utf8 NOT NULL DEFAULT 'lastpost',
  `iconset` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT 'default',
  `numTopics` mediumint(8) NOT NULL DEFAULT '0',
  `numPosts` mediumint(8) NOT NULL DEFAULT '0',
  `last_topic_id` int(11) NOT NULL DEFAULT '0',
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `last_post_time` int(11) NOT NULL DEFAULT '0',
  `allow_ratings` tinyint(4) NOT NULL DEFAULT '0',
  `params` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `category_access` (`accesstype`,`access`),
  KEY `published_pubaccess_id` (`published`,`pub_access`,`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_categories` (`id`, `parent_id`, `name`, `alias`, `icon`, `icon_id`, `locked`, `accesstype`, `access`, `pub_access`, `pub_recurse`, `admin_access`, `admin_recurse`, `ordering`, `published`, `channels`, `checked_out`, `checked_out_time`, `review`, `allow_anonymous`, `post_anonymous`, `hits`, `description`, `headerdesc`, `topictemplate`, `class_sfx`, `allow_polls`, `topic_ordering`, `iconset`, `numTopics`, `numPosts`, `last_topic_id`, `last_post_id`, `last_post_time`, `allow_ratings`, `params`) VALUES
(1, 0, 'Main Forum', 'main-forum', '', 0, 0, 'joomla.group', 0, 1, 1, 0, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'This is the main forum section. It serves as a container for categories for your topics.', 'The section header is used to display additional information about the categories of topics that it contains.', '', '', 0, 'lastpost', 'default', 0, 0, 0, 0, 0, 0, ''),
(2, 1, 'Welcome Mat', 'welcome-mat', '', 0, 0, 'joomla.group', 1, 1, 1, 0, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'We encourage new members to introduce themselves here. Get to know one another and share your interests.', 'Welcome to the Kunena forum! Tell us and our members who you are, what you like and why you became a member of this site. We welcome all new members and hope to see you around a lot!', '', '', 0, 'lastpost', 'default', 1, 1, 1, 1, 1399057228, 0, '{\"access_post\":[\"6\",\"2\",\"8\"],\"access_reply\":[\"6\",\"2\",\"8\"]}'),
(3, 1, 'Suggestion Box', 'suggestion-box', '', 0, 0, 'joomla.group', 0, 1, 1, 0, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Have some feedback and input to share? \n Don\'t be shy and drop us a note. We want to hear from you and strive to make our site better and more user friendly for our guests and members a like.', 'This is the optional category header for the Suggestion Box.', '', '', 1, 'lastpost', 'default', 0, 0, 0, 0, 0, 0, ''),
(4, 0, 'Kunena, the Communication Platform for Joomla', 'kunena-the-communication-platform-for-joomla', '', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Kunena is the ideal forum extension for Joomla. It\'s free, fully integrated, and no bridges or hacks are required.', 'Want to know more about the Kunena Project? See how the open source philosophy drives our community, follow our development on GitHub, and how you can participate to make Kunena even better.', '', '', 0, 'lastpost', 'default', 0, 0, 0, 0, 0, 0, '{}'),
(5, 4, 'Ideal forum', 'ideal-forum', '', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 1, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Kunena is the ideal forum extension for Joomla. It\'s free, fully integrated, and no bridges or hacks are required.', 'Kunena is the ideal forum extension for Joomla. It\'s free, fully integrated, and no bridges or hacks are required.', '', '', 0, 'lastpost', 'default', 1, 4, 2, 5, 1418121786, 0, '{\"access_post\":[\"6\",\"2\",\"8\"],\"access_reply\":[\"6\",\"2\",\"8\"]}'),
(6, 4, 'More about the Kunena', 'more-about-the-kunena', '', 0, 0, 'joomla.level', 1, 1, 1, 8, 1, 2, 1, NULL, 0, '0000-00-00 00:00:00', 0, 0, 0, 0, 'Want to know more about the Kunena Project? See how the open source philosophy drives our community, follow our development on GitHub, and how you can participate to make Kunena even better.', 'Want to know more about the Kunena Project? See how the open source philosophy drives our community, follow our development on GitHub, and how you can participate to make Kunena even better.', '', '', 0, 'lastpost', 'default', 1, 2, 3, 7, 1418122011, 0, '{\"access_post\":[\"6\",\"2\",\"8\"],\"access_reply\":[\"6\",\"2\",\"8\"]}');

DROP TABLE IF EXISTS `#__kunena_configuration`;
CREATE TABLE IF NOT EXISTS `#__kunena_configuration` (
  `id` int(11) NOT NULL DEFAULT '0',
  `params` text CHARACTER SET utf8,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_configuration` (`id`, `params`) VALUES
(1, '{\"board_title\":\"Kunena\",\"email\":\"\",\"board_offline\":\"0\",\"offline_message\":\"The Forum is currently offline for maintenance.\\r\\nCheck back soon!\",\"enablerss\":\"0\",\"threads_per_page\":\"20\",\"messages_per_page\":\"6\",\"messages_per_page_search\":\"15\",\"showhistory\":\"1\",\"historylimit\":\"6\",\"shownew\":\"1\",\"disemoticons\":\"0\",\"template\":\"tm_custom\",\"showannouncement\":\"1\",\"avataroncat\":\"0\",\"catimagepath\":\"category_images\",\"showchildcaticon\":\"1\",\"rtewidth\":\"450\",\"rteheight\":\"300\",\"enableforumjump\":\"1\",\"reportmsg\":\"1\",\"username\":\"1\",\"askemail\":\"0\",\"showemail\":\"0\",\"showuserstats\":\"1\",\"showkarma\":\"1\",\"useredit\":\"1\",\"useredittime\":\"0\",\"useredittimegrace\":\"600\",\"editmarkup\":\"1\",\"allowsubscriptions\":\"1\",\"subscriptionschecked\":\"1\",\"allowfavorites\":\"1\",\"maxsubject\":\"50\",\"maxsig\":\"300\",\"regonly\":\"0\",\"pubwrite\":\"0\",\"floodprotection\":\"0\",\"mailmod\":\"0\",\"mailadmin\":\"0\",\"captcha\":\"0\",\"mailfull\":\"1\",\"allowavatarupload\":\"1\",\"allowavatargallery\":\"1\",\"avatarquality\":\"75\",\"avatarsize\":\"2048\",\"imageheight\":\"800\",\"imagewidth\":\"800\",\"imagesize\":\"150\",\"filetypes\":\"txt,rtf,pdf,zip,tar.gz,tgz,tar.bz2\",\"filesize\":\"120\",\"showranking\":\"1\",\"rankimages\":\"1\",\"userlist_rows\":\"30\",\"userlist_online\":\"1\",\"userlist_avatar\":\"1\",\"userlist_posts\":\"1\",\"userlist_karma\":\"1\",\"userlist_email\":\"0\",\"userlist_joindate\":\"1\",\"userlist_lastvisitdate\":\"1\",\"userlist_userhits\":\"1\",\"latestcategory\":\"\",\"showstats\":\"1\",\"showwhoisonline\":\"1\",\"showgenstats\":\"1\",\"showpopuserstats\":\"1\",\"popusercount\":\"5\",\"showpopsubjectstats\":\"1\",\"popsubjectcount\":\"5\",\"showspoilertag\":\"1\",\"showvideotag\":\"1\",\"showebaytag\":\"1\",\"trimlongurls\":\"1\",\"trimlongurlsfront\":\"40\",\"trimlongurlsback\":\"20\",\"autoembedyoutube\":\"1\",\"autoembedebay\":\"1\",\"ebaylanguagecode\":\"en-us\",\"sessiontimeout\":\"1800\",\"highlightcode\":\"0\",\"rss_type\":\"topic\",\"rss_timelimit\":\"month\",\"rss_limit\":\"100\",\"rss_included_categories\":\"\",\"rss_excluded_categories\":\"\",\"rss_specification\":\"rss2.0\",\"rss_allow_html\":\"1\",\"rss_author_format\":\"name\",\"rss_author_in_title\":\"1\",\"rss_word_count\":\"0\",\"rss_old_titles\":\"1\",\"rss_cache\":\"900\",\"defaultpage\":\"recent\",\"default_sort\":\"asc\",\"sef\":\"1\",\"showimgforguest\":\"1\",\"showfileforguest\":\"1\",\"pollnboptions\":\"4\",\"pollallowvoteone\":\"1\",\"pollenabled\":\"1\",\"poppollscount\":\"5\",\"showpoppollstats\":\"1\",\"polltimebtvotes\":\"00:15:00\",\"pollnbvotesbyuser\":\"100\",\"pollresultsuserslist\":\"1\",\"maxpersotext\":\"50\",\"ordering_system\":\"mesid\",\"post_dateformat\":\"ago\",\"post_dateformat_hover\":\"datetime\",\"hide_ip\":\"1\",\"imagetypes\":\"jpg,jpeg,gif,png\",\"checkmimetypes\":\"1\",\"imagemimetypes\":\"image\\/jpeg,image\\/jpg,image\\/gif,image\\/png\",\"imagequality\":\"50\",\"thumbheight\":\"32\",\"thumbwidth\":\"32\",\"hideuserprofileinfo\":\"put_empty\",\"boxghostmessage\":\"0\",\"userdeletetmessage\":\"0\",\"latestcategory_in\":\"1\",\"topicicons\":\"0\",\"debug\":\"0\",\"catsautosubscribed\":0,\"showbannedreason\":\"0\",\"showthankyou\":\"1\",\"showpopthankyoustats\":\"1\",\"popthankscount\":\"5\",\"mod_see_deleted\":\"0\",\"bbcode_img_secure\":\"text\",\"listcat_show_moderators\":\"1\",\"lightbox\":\"1\",\"show_list_time\":\"720\",\"show_session_type\":\"0\",\"show_session_starttime\":\"0\",\"userlist_allowed\":\"1\",\"userlist_count_users\":\"1\",\"enable_threaded_layouts\":\"0\",\"category_subscriptions\":\"post\",\"topic_subscriptions\":\"every\",\"pubprofile\":\"1\",\"thankyou_max\":\"10\",\"email_recipient_count\":\"0\",\"email_recipient_privacy\":\"bcc\",\"email_visible_address\":\"\",\"captcha_post_limit\":\"0\",\"image_upload\":\"registered\",\"file_upload\":\"registered\",\"topic_layout\":\"flat\",\"time_to_create_page\":\"0\",\"show_imgfiles_manage_profile\":\"1\",\"hold_newusers_posts\":\"0\",\"hold_guest_posts\":\"0\",\"attachment_limit\":\"8\",\"pickup_category\":\"0\",\"article_display\":\"intro\",\"send_emails\":\"1\",\"fallback_english\":\"1\",\"cache\":\"1\",\"cache_time\":\"60\",\"ebay_affiliate_id\":\"5337089937\",\"iptracking\":\"1\",\"rss_feedburner_url\":\"\",\"autolink\":\"1\",\"access_component\":\"1\",\"statslink_allowed\":\"1\",\"superadmin_userlist\":\"0\",\"legacy_urls\":\"1\",\"attachment_protection\":\"0\",\"categoryicons\":1,\"avatarresizemethod\":\"1\",\"avatarcrop\":\"0\",\"user_report\":\"1\",\"searchtime\":\"365\",\"teaser\":\"0\",\"ebay_language\":\"0\",\"ebay_api_key\":\"\",\"twitter_consumer_key\":\"\",\"twitter_consumer_secret\":\"\",\"allow_change_subject\":\"1\",\"max_links\":\"6\",\"read_only\":\"0\",\"ratingenabled\":\"0\",\"url_subject_topic\":\"0\",\"log_moderation\":\"0\",\"attach_start\":\"0\",\"attach_end\":\"14\",\"google_map_api_key\":\"\",\"attachment_utf8\":\"1\",\"autoembedsoundcloud\":\"1\",\"emailheader\":\"\\/media\\/kunena\\/email\\/hero-wide.png\",\"user_status\":\"1\",\"signature\":1,\"personal\":1,\"social\":1,\"plain_email\":\"0\",\"moderator_permdelete\":0,\"avatartypes\":\"gif, jpeg, jpg, png\",\"smartlinking\":0,\"defaultavatar\":\"nophoto.png\",\"defaultavatarsmall\":\"s_nophoto.png\",\"stopforumspam_key\":\"\",\"quickreply\":1,\"avataredit\":0,\"activemenuitem\":\"\",\"mainmenu_id\":\"\",\"home_id\":\"\",\"index_id\":\"\",\"moderators_id\":\"\",\"topiclist_id\":\"\",\"misc_id\":\"\",\"profile_id\":\"\",\"search_id\":\"\",\"avatar_type\":1,\"recaptcha_publickey\":\"\",\"recaptcha_privatekey\":\"\",\"recaptcha_theme\":\"white\",\"keywords\":0,\"userkeywords\":0,\"userlist_name\":\"1\",\"usernamechange\":\"0\",\"version_check\":\"1\",\"plugins\":[]}');

DROP TABLE IF EXISTS `#__kunena_logs`;
CREATE TABLE IF NOT EXISTS `#__kunena_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(4) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL DEFAULT '0',
  `topic_id` int(11) NOT NULL DEFAULT '0',
  `target_user` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(40) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `time` int(11) NOT NULL DEFAULT '0',
  `operation` varchar(40) CHARACTER SET utf8 NOT NULL,
  `data` mediumtext CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `category_id` (`category_id`),
  KEY `topic_id` (`topic_id`),
  KEY `target_user` (`target_user`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_messages`;
CREATE TABLE IF NOT EXISTS `#__kunena_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` int(11) DEFAULT '0',
  `thread` int(11) DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `name` tinytext CHARACTER SET utf8,
  `userid` int(11) NOT NULL DEFAULT '0',
  `email` tinytext CHARACTER SET utf8,
  `subject` tinytext CHARACTER SET utf8,
  `time` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `topic_emoticon` int(11) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `hold` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `hits` int(11) DEFAULT '0',
  `moved` tinyint(4) DEFAULT '0',
  `modified_by` int(7) DEFAULT NULL,
  `modified_time` int(11) DEFAULT NULL,
  `modified_reason` tinytext CHARACTER SET utf8,
  PRIMARY KEY (`id`),
  KEY `thread` (`thread`),
  KEY `ip` (`ip`),
  KEY `userid` (`userid`),
  KEY `time` (`time`),
  KEY `locked` (`locked`),
  KEY `hold_time` (`hold`,`time`),
  KEY `parent_hits` (`parent`,`hits`),
  KEY `catid_parent` (`catid`,`parent`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_messages` (`id`, `parent`, `thread`, `catid`, `name`, `userid`, `email`, `subject`, `time`, `ip`, `topic_emoticon`, `locked`, `hold`, `ordering`, `hits`, `moved`, `modified_by`, `modified_time`, `modified_reason`) VALUES
(1, 0, 1, 2, '', 317, '', 'Welcome to Kunena!', 1399057228, '127.0.0.1', 0, 0, 0, 0, 0, 0, 846, 1423728734, ''),
(2, 0, 2, 5, 'demo', 846, '', 'Morbi tincidunt sodales neque eu rutrum', 1415103771, '192.168.9.17', 0, 0, 0, 0, 0, 0, 846, 1444812838, ''),
(3, 2, 2, 5, 'demo', 846, '', 'General Template Issues, Questions And Problems', 1415179292, '192.168.9.17', 0, 0, 0, 0, 0, 0, 846, 1444813202, ''),
(4, 2, 2, 5, 'lorem_ipsum', 847, '', 'Personal diary in Kunena Forum', 1418121749, '192.168.9.17', 0, 0, 0, 0, 0, 0, 846, 1444813240, ''),
(5, 2, 2, 5, 'lorem_ipsum', 847, '', 'Multiples templates (linked to forum categories)', 1418121786, '192.168.9.17', 0, 0, 0, 0, 0, 0, 846, 1444813776, ''),
(6, 0, 3, 6, 'lorem_ipsum', 847, '', 'Pellentesque non libero', 1418121957, '192.168.9.17', 0, 0, 0, 0, 0, 0, NULL, NULL, ''),
(7, 6, 3, 6, 'dolor_sit', 848, '', 'Pellentesque non libero', 1418122011, '192.168.9.17', 0, 0, 0, 0, 0, 0, NULL, NULL, '');

DROP TABLE IF EXISTS `#__kunena_messages_text`;
CREATE TABLE IF NOT EXISTS `#__kunena_messages_text` (
  `mesid` int(11) NOT NULL DEFAULT '0',
  `message` mediumtext CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`mesid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_messages_text` (`mesid`, `message`) VALUES
(1, 'Thank you for choosing Kunena for your community forum needs in Joomla. \r\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \r\nAdditional Kunena Resources\r\nKunena Documentation: [url]http://www.kunena.org/docs[/url] \r\nKunena Support Forum: [url]http://www.kunena.org/forum[/url] \r\nKunena Downloads: [url]http://www.kunena.org/download[/url] \r\nKunena Blog: [url]http://www.kunena.org/blog[/url] \r\nFollow Kunena on Twitter: [url]http://www.kunena.org/twitter[/url]'),
(2, 'Kunena is the ideal forum extension for Joomla. It\'s free, fully integrated, and no bridges or hacks are required.\r\n\r\nWant to know more about the Kunena Project? See how the open source philosophy drives our community, follow our development on GitHub, and how you can participate to make Kunena even better.'),
(3, 'This is a community-driven self-help category to ask questions about designing or developing your own Kunena template. Please be aware that there are rules that apply to topics posted in this category:\r\n\r\n[b]Do not use this category for:[/b]\r\nasking questions about how to make simple changes to a template designed by the Kunena project team (use K 3.0 Templates instead);\r\nadvertising your own template designs.\r\n\r\nTopics that do not meet the above guidelines may be removed without notice.'),
(4, 'Hello mates. Can i setup Kunena Forum so that some user\'s notes (but not all) will be availible for other users and some not by their wish? The main idea is to create personalized diary of the users and functionality of Kunena Forum seems to be most suitable for this.'),
(5, 'Hi.\r\n\r\nI\'m looking to have 1 template for 1 categorie and an other template for all others catégories.\r\nSomeone he already well-considered the problem ?\r\n\r\nRegards.'),
(6, 'Sed justo felis, lacinia at scelerisque a, semper et ante. Fusce posuere lacus eu mi lacinia et fringilla elit sollicitudin. Maecenas non odio nunc. In ut sollicitudin magna. Sed sit amet tincidunt odio. Mauris pharetra adipiscing urna ut accumsan. Suspendisse nec risus in felis fermentum blandit.\r\n\r\nNam nec lectus ut orci porta volutpat id at purus. Sed sagittis congue dapibus. Proin dolor metus, pharetra ut pulvinar nec, condimentum quis libero. Sed fermentum tortor ac elit tristique vel dapibus sem porta. Suspendisse aliquet posuere ultrices. Proin facilisis libero lacinia erat pretium faucibus. In tortor nunc, posuere eget commodo et, eleifend vel risus.'),
(7, 'Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Aliquam erat volutpat. Pellentesque non libero dui, vitae pharetra urna. Vestibulum accumsan pulvinar magna sed consectetur. Nulla congue condimentum aliquam. Donec non libero lectus, id mollis nisi. Morbi turpis magna, varius in ullamcorper nec, suscipit sagittis nibh. Nam elementum aliquam turpis eget egestas. Cras ligula nisi, interdum et vulputate nec, sagittis a tellus. In hac habitasse platea dictumst. In in sem libero. Fusce cursus, metus eu commodo hendrerit, arcu nibh consequat lectus, nec suscipit eros urna in ipsum. Praesent et enim a nisl commodo sodales non id neque. Ut sodales dignissim massa vitae hendrerit. Sed porttitor purus ut ante fermentum quis mollis velit pellentesque.\r\n\r\nEtiam nisi felis, fermentum vitae ultrices non, euismod in magna. In mattis velit ut eros tristique a congue erat consequat. Suspendisse consequat, justo eu gravida semper, ligula turpis dignissim dolor, vitae lacinia velit metus id libero. Nullam consectetur rhoncus magna, quis pharetra tortor bibendum quis. Curabitur ac ante nisl. Nullam mauris arcu, malesuada eu consectetur non, eleifend quis est. Nullam dictum, leo vulputate elementum porttitor, enim mi posuere augue, id porttitor leo sapien sed libero. Quisque est velit, aliquam bibendum vestibulum eget, tristique a odio.');

DROP TABLE IF EXISTS `#__kunena_polls`;
CREATE TABLE IF NOT EXISTS `#__kunena_polls` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(150) CHARACTER SET utf8 DEFAULT NULL,
  `threadid` int(11) NOT NULL,
  `polltimetolive` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `threadid` (`threadid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_polls_options`;
CREATE TABLE IF NOT EXISTS `#__kunena_polls_options` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pollid` int(11) DEFAULT NULL,
  `text` varchar(100) CHARACTER SET utf8 DEFAULT NULL,
  `votes` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `pollid` (`pollid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_polls_users`;
CREATE TABLE IF NOT EXISTS `#__kunena_polls_users` (
  `pollid` int(11) DEFAULT NULL,
  `userid` int(11) DEFAULT NULL,
  `votes` int(11) DEFAULT NULL,
  `lasttime` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvote` int(11) DEFAULT NULL,
  UNIQUE KEY `pollid` (`pollid`,`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_ranks`;
CREATE TABLE IF NOT EXISTS `#__kunena_ranks` (
  `rank_id` mediumint(8) UNSIGNED NOT NULL AUTO_INCREMENT,
  `rank_title` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `rank_min` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `rank_special` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `rank_image` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  PRIMARY KEY (`rank_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_ranks` (`rank_id`, `rank_title`, `rank_min`, `rank_special`, `rank_image`) VALUES
(1, 'New Member', 0, 0, 'rank1.gif'),
(2, 'Junior Member', 20, 0, 'rank2.gif'),
(3, 'Senior Member', 40, 0, 'rank3.gif'),
(4, 'Premium Member', 80, 0, 'rank4.gif'),
(5, 'Elite Member', 160, 0, 'rank5.gif'),
(6, 'Platinum Member', 320, 0, 'rank6.gif'),
(7, 'Administrator', 0, 1, 'rankadmin.gif'),
(8, 'Moderator', 0, 1, 'rankmod.gif'),
(9, 'Spammer', 0, 1, 'rankspammer.gif'),
(10, 'Banned', 0, 1, 'rankbanned.gif');

DROP TABLE IF EXISTS `#__kunena_rate`;
CREATE TABLE IF NOT EXISTS `#__kunena_rate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `topic_id` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `rate` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `time` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_sessions`;
CREATE TABLE IF NOT EXISTS `#__kunena_sessions` (
  `userid` int(11) NOT NULL DEFAULT '0',
  `allowed` text CHARACTER SET utf8,
  `lasttime` int(11) NOT NULL DEFAULT '0',
  `readtopics` text CHARACTER SET utf8,
  `currvisit` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`userid`),
  KEY `currvisit` (`currvisit`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_sessions` (`userid`, `allowed`, `lasttime`, `readtopics`, `currvisit`) VALUES
(19, 'na', 1465478134, '0', 1466687744),
(55, 'na', 1444224132, '0', 1445433740),
(283, 'na', 1452089892, '0', 1452517940),
(757, 'na', 1475675596, '0', 1476885244),
(846, 'na', 1498456854, '0', 1508412960),
(847, 'na', 1416912031, '0', 1418121958),
(848, 'na', 1432031594, '0', 1432036031),
(895, 'na', 1469090890, '0', 1469094062);

DROP TABLE IF EXISTS `#__kunena_smileys`;
CREATE TABLE IF NOT EXISTS `#__kunena_smileys` (
  `id` int(4) NOT NULL AUTO_INCREMENT,
  `code` varchar(12) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `location` varchar(50) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `greylocation` varchar(60) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `emoticonbar` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=67 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_smileys` (`id`, `code`, `location`, `greylocation`, `emoticonbar`) VALUES
(1, 'B)', 'cool.png', 'cool-grey.png', 1),
(2, '8)', 'cool.png', 'cool-grey.png', 0),
(3, '8-)', 'cool.png', 'cool-grey.png', 0),
(4, ':-(', 'sad.png', 'sad-grey.png', 0),
(5, ':(', 'sad.png', 'sad-grey.png', 1),
(6, ':sad:', 'sad.png', 'sad-grey.png', 0),
(7, ':cry:', 'sad.png', 'sad-grey.png', 0),
(8, ':)', 'smile.png', 'smile-grey.png', 1),
(9, ':-)', 'smile.png', 'smile-grey.png', 0),
(10, ':cheer:', 'cheerful.png', 'cheerful-grey.png', 1),
(11, ';)', 'wink.png', 'wink-grey.png', 1),
(12, ';-)', 'wink.png', 'wink-grey.png', 0),
(13, ':wink:', 'wink.png', 'wink-grey.png', 0),
(14, ';-)', 'wink.png', 'wink-grey.png', 0),
(15, ':P', 'tongue.png', 'tongue-grey.png', 1),
(16, ':p', 'tongue.png', 'tongue-grey.png', 0),
(17, ':-p', 'tongue.png', 'tongue-grey.png', 0),
(18, ':-P', 'tongue.png', 'tongue-grey.png', 0),
(19, ':razz:', 'tongue.png', 'tongue-grey.png', 0),
(20, ':angry:', 'angry.png', 'angry-grey.png', 1),
(21, ':mad:', 'angry.png', 'angry-grey.png', 0),
(22, ':unsure:', 'unsure.png', 'unsure-grey.png', 1),
(23, ':o', 'shocked.png', 'shocked-grey.png', 0),
(24, ':-o', 'shocked.png', 'shocked-grey.png', 0),
(25, ':O', 'shocked.png', 'shocked-grey.png', 0),
(26, ':-O', 'shocked.png', 'shocked-grey.png', 0),
(27, ':eek:', 'shocked.png', 'shocked-grey.png', 0),
(28, ':ohmy:', 'shocked.png', 'shocked-grey.png', 1),
(29, ':huh:', 'wassat.png', 'wassat-grey.png', 1),
(30, ':?', 'confused.png', 'confused-grey.png', 0),
(31, ':-?', 'confused.png', 'confused-grey.png', 0),
(32, ':???', 'confused.png', 'confused-grey.png', 0),
(33, ':dry:', 'ermm.png', 'ermm-grey.png', 1),
(34, ':ermm:', 'ermm.png', 'ermm-grey.png', 0),
(35, ':lol:', 'grin.png', 'grin-grey.png', 1),
(36, ':X', 'sick.png', 'sick-grey.png', 0),
(37, ':x', 'sick.png', 'sick-grey.png', 0),
(38, ':sick:', 'sick.png', 'sick-grey.png', 1),
(39, ':silly:', 'silly.png', 'silly-grey.png', 1),
(40, ':y32b4:', 'silly.png', 'silly-grey.png', 0),
(41, ':blink:', 'blink.png', 'blink-grey.png', 1),
(42, ':blush:', 'blush.png', 'blush-grey.png', 1),
(43, ':oops:', 'blush.png', 'blush-grey.png', 1),
(44, ':kiss:', 'kissing.png', 'kissing-grey.png', 1),
(45, ':rolleyes:', 'blink.png', 'blink-grey.png', 0),
(46, ':roll:', 'blink.png', 'blink-grey.png', 0),
(47, ':woohoo:', 'w00t.png', 'w00t-grey.png', 1),
(48, ':side:', 'sideways.png', 'sideways-grey.png', 1),
(49, ':S', 'dizzy.png', 'dizzy-grey.png', 1),
(50, ':s', 'dizzy.png', 'dizzy-grey.png', 0),
(51, ':evil:', 'devil.png', 'devil-grey.png', 1),
(52, ':twisted:', 'devil.png', 'devil-grey.png', 0),
(53, ':whistle:', 'whistling.png', 'whistling-grey.png', 1),
(54, ':pinch:', 'pinch.png', 'pinch-grey.png', 1),
(55, ':D', 'laughing.png', 'laughing-grey.png', 0),
(56, ':-D', 'laughing.png', 'laughing-grey.png', 0),
(57, ':grin:', 'laughing.png', 'laughing-grey.png', 0),
(58, ':laugh:', 'laughing.png', 'laughing-grey.png', 0),
(59, ':|', 'neutral.png', 'neutral-grey.png', 0),
(60, ':-|', 'neutral.png', 'neutral-grey.png', 0),
(61, ':neutral:', 'neutral.png', 'neutral-grey.png', 0),
(62, ':mrgreen:', 'mrgreen.png', 'mrgreen-grey.png', 0),
(63, ':?:', 'question.png', 'question-grey.png', 0),
(64, ':!:', 'exclamation.png', 'exclamation-grey.png', 0),
(65, ':arrow:', 'arrow.png', 'arrow-grey.png', 0),
(66, ':idea:', 'idea.png', 'idea-grey.png', 0);

DROP TABLE IF EXISTS `#__kunena_thankyou`;
CREATE TABLE IF NOT EXISTS `#__kunena_thankyou` (
  `postid` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `targetuserid` int(11) NOT NULL,
  `time` datetime NOT NULL,
  UNIQUE KEY `postid` (`postid`,`userid`),
  KEY `userid` (`userid`),
  KEY `targetuserid` (`targetuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_thankyou` (`postid`, `userid`, `targetuserid`, `time`) VALUES
(6, 848, 847, '2014-12-09 10:46:29');

DROP TABLE IF EXISTS `#__kunena_topics`;
CREATE TABLE IF NOT EXISTS `#__kunena_topics` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL DEFAULT '0',
  `subject` tinytext CHARACTER SET utf8,
  `icon_id` int(11) NOT NULL DEFAULT '0',
  `label_id` int(11) NOT NULL DEFAULT '0',
  `locked` tinyint(4) NOT NULL DEFAULT '0',
  `hold` tinyint(4) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `posts` int(11) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `attachments` int(11) NOT NULL DEFAULT '0',
  `poll_id` int(11) NOT NULL DEFAULT '0',
  `moved_id` int(11) NOT NULL DEFAULT '0',
  `first_post_id` int(11) NOT NULL DEFAULT '0',
  `first_post_time` int(11) NOT NULL DEFAULT '0',
  `first_post_userid` int(11) NOT NULL DEFAULT '0',
  `first_post_message` text CHARACTER SET utf8,
  `first_post_guest_name` tinytext CHARACTER SET utf8,
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `last_post_time` int(11) NOT NULL DEFAULT '0',
  `last_post_userid` int(11) NOT NULL DEFAULT '0',
  `last_post_message` text CHARACTER SET utf8,
  `last_post_guest_name` tinytext CHARACTER SET utf8,
  `rating` tinyint(6) NOT NULL DEFAULT '0',
  `params` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id` (`category_id`),
  KEY `locked` (`locked`),
  KEY `hold` (`hold`),
  KEY `posts` (`posts`),
  KEY `hits` (`hits`),
  KEY `first_post_userid` (`first_post_userid`),
  KEY `last_post_userid` (`last_post_userid`),
  KEY `first_post_time` (`first_post_time`),
  KEY `last_post_time` (`last_post_time`),
  KEY `last_post_id` (`last_post_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_topics` (`id`, `category_id`, `subject`, `icon_id`, `label_id`, `locked`, `hold`, `ordering`, `posts`, `hits`, `attachments`, `poll_id`, `moved_id`, `first_post_id`, `first_post_time`, `first_post_userid`, `first_post_message`, `first_post_guest_name`, `last_post_id`, `last_post_time`, `last_post_userid`, `last_post_message`, `last_post_guest_name`, `rating`, `params`) VALUES
(1, 2, 'Welcome to Kunena!', 0, 0, 0, 0, 0, 1, 12, 0, 0, 0, 1, 1399057228, 317, 'Thank you for choosing Kunena for your community forum needs in Joomla. \r\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \r\nAdditional Kunena Resources\r\nKunena Documentation: [url]http://www.kunena.org/docs[/url] \r\nKunena Support Forum: [url]http://www.kunena.org/forum[/url] \r\nKunena Downloads: [url]http://www.kunena.org/download[/url] \r\nKunena Blog: [url]http://www.kunena.org/blog[/url] \r\nFollow Kunena on Twitter: [url]http://www.kunena.org/twitter[/url]', '', 1, 1399057228, 317, 'Thank you for choosing Kunena for your community forum needs in Joomla. \r\n Kunena, translated from Swahili meaning “to speak”, is built by a team of open source professionals with the goal of providing a top quality, tightly unified forum solution for Joomla. \r\nAdditional Kunena Resources\r\nKunena Documentation: [url]http://www.kunena.org/docs[/url] \r\nKunena Support Forum: [url]http://www.kunena.org/forum[/url] \r\nKunena Downloads: [url]http://www.kunena.org/download[/url] \r\nKunena Blog: [url]http://www.kunena.org/blog[/url] \r\nFollow Kunena on Twitter: [url]http://www.kunena.org/twitter[/url]', '', 0, ''),
(2, 5, 'General template issues, questions and problems', 0, 0, 0, 0, 0, 4, 18, 0, 0, 0, 2, 1415103771, 846, 'Kunena is the ideal forum extension for Joomla. It\'s free, fully integrated, and no bridges or hacks are required.\r\n\r\nWant to know more about the Kunena Project? See how the open source philosophy drives our community, follow our development on GitHub, and how you can participate to make Kunena even better.', 'demo', 5, 1418121786, 847, 'Hi.\r\n\r\nI\'m looking to have 1 template for 1 categorie and an other template for all others catégories.\r\nSomeone he already well-considered the problem ?\r\n\r\nRegards.', 'lorem_ipsum', 0, ''),
(3, 6, 'Pellentesque non libero', 0, 0, 0, 0, 0, 2, 3, 0, 0, 0, 6, 1418121957, 847, 'Sed justo felis, lacinia at scelerisque a, semper et ante. Fusce posuere lacus eu mi lacinia et fringilla elit sollicitudin. Maecenas non odio nunc. In ut sollicitudin magna. Sed sit amet tincidunt odio. Mauris pharetra adipiscing urna ut accumsan. Suspendisse nec risus in felis fermentum blandit.\r\n\r\nNam nec lectus ut orci porta volutpat id at purus. Sed sagittis congue dapibus. Proin dolor metus, pharetra ut pulvinar nec, condimentum quis libero. Sed fermentum tortor ac elit tristique vel dapibus sem porta. Suspendisse aliquet posuere ultrices. Proin facilisis libero lacinia erat pretium faucibus. In tortor nunc, posuere eget commodo et, eleifend vel risus.', 'lorem_ipsum', 7, 1418122011, 848, 'Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Aliquam erat volutpat. Pellentesque non libero dui, vitae pharetra urna. Vestibulum accumsan pulvinar magna sed consectetur. Nulla congue condimentum aliquam. Donec non libero lectus, id mollis nisi. Morbi turpis magna, varius in ullamcorper nec, suscipit sagittis nibh. Nam elementum aliquam turpis eget egestas. Cras ligula nisi, interdum et vulputate nec, sagittis a tellus. In hac habitasse platea dictumst. In in sem libero. Fusce cursus, metus eu commodo hendrerit, arcu nibh consequat lectus, nec suscipit eros urna in ipsum. Praesent et enim a nisl commodo sodales non id neque. Ut sodales dignissim massa vitae hendrerit. Sed porttitor purus ut ante fermentum quis mollis velit pellentesque.\r\n\r\nEtiam nisi felis, fermentum vitae ultrices non, euismod in magna. In mattis velit ut eros tristique a congue erat consequat. Suspendisse consequat, justo eu gravida semper, ligula turpis dignissim dolor, vitae lacinia velit metus id libero. Nullam consectetur rhoncus magna, quis pharetra tortor bibendum quis. Curabitur ac ante nisl. Nullam mauris arcu, malesuada eu consectetur non, eleifend quis est. Nullam dictum, leo vulputate elementum porttitor, enim mi posuere augue, id porttitor leo sapien sed libero. Quisque est velit, aliquam bibendum vestibulum eget, tristique a odio.', 'dolor_sit', 0, '');

DROP TABLE IF EXISTS `#__kunena_users`;
CREATE TABLE IF NOT EXISTS `#__kunena_users` (
  `userid` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `status_text` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `view` varchar(8) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `signature` text CHARACTER SET utf8,
  `moderator` int(11) DEFAULT '0',
  `banned` datetime DEFAULT NULL,
  `ordering` int(11) DEFAULT '0',
  `posts` int(11) DEFAULT '0',
  `avatar` varchar(255) CHARACTER SET utf8 DEFAULT NULL,
  `timestamp` int(11) DEFAULT NULL,
  `karma` int(11) DEFAULT '0',
  `karma_time` int(11) DEFAULT '0',
  `group_id` int(4) DEFAULT '1',
  `uhits` int(11) DEFAULT '0',
  `personalText` tinytext CHARACTER SET utf8,
  `gender` tinyint(4) NOT NULL DEFAULT '0',
  `birthdate` date NOT NULL DEFAULT '0001-01-01',
  `location` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `icq` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `yim` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `youtube` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `ok` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `microsoft` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `telegram` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `vk` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `skype` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `twitter` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `facebook` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `google` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `myspace` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `linkedin` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `delicious` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `friendfeed` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `digg` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `instagram` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `qq` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `qzone` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `whatsapp` varchar(25) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `weibo` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `wechat` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `apple` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `blogspot` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `flickr` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `bebo` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `websitename` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `websiteurl` varchar(50) CHARACTER SET utf8 DEFAULT NULL,
  `rank` tinyint(4) NOT NULL DEFAULT '0',
  `hideEmail` tinyint(1) NOT NULL DEFAULT '1',
  `showOnline` tinyint(1) NOT NULL DEFAULT '1',
  `canSubscribe` tinyint(1) NOT NULL DEFAULT '-1',
  `userListtime` int(11) NOT NULL DEFAULT '-2',
  `thankyou` int(11) DEFAULT '0',
  `ip` varchar(128) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `socialshare` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`userid`),
  KEY `group_id` (`group_id`),
  KEY `posts` (`posts`),
  KEY `uhits` (`uhits`),
  KEY `banned` (`banned`),
  KEY `moderator` (`moderator`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_users` (`userid`, `status`, `status_text`, `view`, `signature`, `moderator`, `banned`, `ordering`, `posts`, `avatar`, `timestamp`, `karma`, `karma_time`, `group_id`, `uhits`, `personalText`, `gender`, `birthdate`, `location`, `icq`, `yim`, `youtube`, `ok`, `microsoft`, `telegram`, `vk`, `skype`, `twitter`, `facebook`, `google`, `myspace`, `linkedin`, `delicious`, `friendfeed`, `digg`, `instagram`, `qq`, `qzone`, `whatsapp`, `weibo`, `wechat`, `apple`, `blogspot`, `flickr`, `bebo`, `websitename`, `websiteurl`, `rank`, `hideEmail`, `showOnline`, `canSubscribe`, `userListtime`, `thankyou`, `ip`, `socialshare`) VALUES
(19, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 1, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(55, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(220, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1),
(264, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, NULL, 1),
(283, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(317, 0, '', '', NULL, 0, NULL, 0, 1, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(545, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1),
(741, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(757, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1),
(797, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1),
(846, 0, '', '', '', 0, NULL, 0, 2, NULL, NULL, 1, 1435741740, 1, 2, '', 1, '0001-01-01', '', '', '', NULL, NULL, '', NULL, NULL, '', '', '', '', '', '', '', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', '', '', '', '', 0, 1, 1, 1, -2, 0, '', 1),
(847, 0, '', '', NULL, 0, NULL, 0, 3, NULL, NULL, 1, 1418121732, 1, 24, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 1, '', 1),
(848, 0, '', '', NULL, 0, NULL, 0, 1, NULL, NULL, 0, 1418121990, 1, 10, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(849, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, 1, -2, 0, '', 1),
(895, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1),
(898, 0, '', '', NULL, 0, NULL, 0, 0, NULL, NULL, 0, 0, 1, 0, NULL, 0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1, -1, -2, 0, '', 1);

DROP TABLE IF EXISTS `#__kunena_users_banned`;
CREATE TABLE IF NOT EXISTS `#__kunena_users_banned` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) DEFAULT NULL,
  `ip` varchar(128) CHARACTER SET utf8 DEFAULT NULL,
  `blocked` tinyint(4) NOT NULL DEFAULT '0',
  `expiration` datetime DEFAULT NULL,
  `created_by` int(11) NOT NULL,
  `created_time` datetime NOT NULL,
  `reason_private` text CHARACTER SET utf8,
  `reason_public` text CHARACTER SET utf8,
  `modified_by` int(11) DEFAULT NULL,
  `modified_time` datetime DEFAULT NULL,
  `comments` text CHARACTER SET utf8,
  `params` text CHARACTER SET utf8,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`),
  KEY `ip` (`ip`),
  KEY `expiration` (`expiration`),
  KEY `created_time` (`created_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__kunena_user_categories`;
CREATE TABLE IF NOT EXISTS `#__kunena_user_categories` (
  `user_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  `role` tinyint(4) NOT NULL DEFAULT '0',
  `allreadtime` int(11) NOT NULL DEFAULT '0',
  `subscribed` tinyint(4) NOT NULL DEFAULT '0',
  `params` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`user_id`,`category_id`),
  KEY `category_subscribed` (`category_id`,`subscribed`),
  KEY `role` (`role`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_user_categories` (`user_id`, `category_id`, `role`, `allreadtime`, `subscribed`, `params`) VALUES
(757, 0, 0, 1475675596, 0, ''),
(846, 0, 0, 1444738495, 0, ''),
(846, 2, 0, 1482315775, 0, ''),
(895, 0, 0, 1467881216, 0, '');

DROP TABLE IF EXISTS `#__kunena_user_read`;
CREATE TABLE IF NOT EXISTS `#__kunena_user_read` (
  `user_id` int(11) NOT NULL,
  `topic_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  `message_id` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  UNIQUE KEY `user_topic_id` (`user_id`,`topic_id`),
  KEY `category_user_id` (`category_id`,`user_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_user_read` (`user_id`, `topic_id`, `category_id`, `message_id`, `time`) VALUES
(846, 1, 2, 1, 1508412946),
(846, 2, 5, 5, 1497499466),
(847, 2, 5, 5, 1418121885),
(847, 3, 6, 6, 1418121958),
(848, 3, 6, 7, 1418122014);

DROP TABLE IF EXISTS `#__kunena_user_topics`;
CREATE TABLE IF NOT EXISTS `#__kunena_user_topics` (
  `user_id` int(11) NOT NULL DEFAULT '0',
  `topic_id` int(11) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL,
  `posts` mediumint(8) NOT NULL DEFAULT '0',
  `last_post_id` int(11) NOT NULL DEFAULT '0',
  `owner` tinyint(4) NOT NULL DEFAULT '0',
  `favorite` tinyint(4) NOT NULL DEFAULT '0',
  `subscribed` tinyint(4) NOT NULL DEFAULT '0',
  `params` text CHARACTER SET utf8 NOT NULL,
  UNIQUE KEY `user_topic_id` (`user_id`,`topic_id`),
  KEY `topic_id` (`topic_id`),
  KEY `posts` (`posts`),
  KEY `owner` (`owner`),
  KEY `favorite` (`favorite`),
  KEY `subscribed` (`subscribed`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_user_topics` (`user_id`, `topic_id`, `category_id`, `posts`, `last_post_id`, `owner`, `favorite`, `subscribed`, `params`) VALUES
(317, 1, 2, 1, 1, 1, 0, 0, ''),
(846, 2, 5, 2, 3, 1, 0, 1, ''),
(847, 2, 5, 2, 5, 0, 0, 1, ''),
(847, 3, 6, 1, 6, 1, 0, 1, ''),
(848, 3, 6, 1, 7, 0, 0, 1, '');

DROP TABLE IF EXISTS `#__kunena_version`;
CREATE TABLE IF NOT EXISTS `#__kunena_version` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `version` varchar(20) CHARACTER SET utf8 NOT NULL,
  `versiondate` date NOT NULL,
  `installdate` date NOT NULL,
  `build` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `versionname` varchar(40) CHARACTER SET utf8 DEFAULT NULL,
  `state` text CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__kunena_version` (`id`, `version`, `versiondate`, `installdate`, `build`, `versionname`, `state`) VALUES
(1, '3.0.5', '2014-03-09', '2014-05-02', '', 'Invecchiato', ''),
(2, '3.0.6', '2014-07-28', '2014-08-05', '', 'Tala', ''),
(3, '4.0.10', '2016-02-18', '2016-07-13', '', 'Villavicencio', ''),
(4, '4.0.12', '2016-10-01', '2016-10-19', '', 'Lima', ''),
(5, '5.0.8', '2017-05-15', '2017-07-04', '', 'Hoatzin', ''),
(6, '5.0.11', '2017-09-02', '2017-09-22', '', 'Kinkajou', ''),
(7, '5.0.13', '2017-12-31', '2018-01-29', '', 'Meerkat', ''),
(8, '5.0.14', '2018-03-14', '2018-03-14', '', 'Stephen Hawking', ''),
(9, '5.1.0', '2018-05-13', '2018-06-04', '5.1.0', 'Ariel', '');

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE IF NOT EXISTS `#__languages` (
  `lang_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lang_code` char(7) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
  `title` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `title_native` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `sef` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `image` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` varchar(512) COLLATE utf8mb4_unicode_ci NOT NULL,
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `sitename` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__languages` (`lang_id`, `asset_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 0, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 1, 1);

DROP TABLE IF EXISTS `#__loginradius_users`;
CREATE TABLE IF NOT EXISTS `#__loginradius_users` (
  `id` int(11) DEFAULT NULL,
  `loginradius_id` varchar(255) DEFAULT NULL,
  `provider` varchar(255) DEFAULT NULL,
  `lr_picture` varchar(255) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `path` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) UNSIGNED NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`(100),`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_alias` (`alias`(100)),
  KEY `idx_path` (`path`(100))
) ENGINE=InnoDB AUTO_INCREMENT=781 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 317, 0, '*', 0),
(2, 'main', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 1, 10, 0, '*', 1),
(3, 'main', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 2, 3, 0, '*', 1),
(4, 'main', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 4, 5, 0, '*', 1),
(5, 'main', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 6, 7, 0, '*', 1),
(6, 'main', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 8, 9, 0, '*', 1),
(7, 'main', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 73, 78, 0, '*', 1),
(8, 'main', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 74, 75, 0, '*', 1),
(9, 'main', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 76, 77, 0, '*', 1),
(10, 'main', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 79, 84, 0, '*', 1),
(11, 'main', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 80, 81, 0, '*', 1),
(12, 'main', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 82, 83, 0, '*', 1),
(13, 'main', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 85, 90, 0, '*', 1),
(14, 'main', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 86, 87, 0, '*', 1),
(15, 'main', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 88, 89, 0, '*', 1),
(16, 'main', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 91, 92, 0, '*', 1),
(17, 'main', 'com_search', 'Basic Search', '', 'Basic Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 93, 94, 0, '*', 1),
(18, 'main', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 95, 100, 0, '*', 1),
(19, 'main', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 96, 97, 0, '*', 1),
(20, 'main', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 98, 99, 0, '*', 1),
(21, 'main', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 101, 102, 0, '*', 1),
(23, 'main', 'com_tags', 'Tags', '', 'Tags', 'index.php?option=com_tags', 'component', 0, 1, 1, 29, 0, '0000-00-00 00:00:00', 0, 1, 'class:tags', 0, '', 103, 104, 0, '', 1),
(24, 'main', 'com_postinstall', 'Post-installation messages', '', 'Post-installation messages', 'index.php?option=com_postinstall', 'component', 0, 1, 1, 32, 0, '0000-00-00 00:00:00', 0, 1, 'class:postinstall', 0, '', 105, 106, 0, '*', 1),
(101, 'main-menu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 15, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"fullwidth\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"Welcome!\",\"pageclass_sfx\":\"home\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"7\",\"icemega_width\":\"100%\",\"icemega_colwidth\":\"25%, 25%, 25%, 25%\",\"icemega_cols_items\":\"1,2,1,1\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 11, 16, 1, '*', 0),
(124, 'kunenamenu', 'Forum', 'forum', '', 'forum', 'index.php?option=com_kunena&view=home&defaultmenu=125', 'component', 1, 1, 1, 10019, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"catids\":[\"0\"],\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 107, 124, 0, '*', 0),
(125, 'kunenamenu', 'Index', 'index', '', 'forum/index', 'index.php?option=com_kunena&view=category&layout=list&catid=0', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 108, 109, 0, '*', 0),
(126, 'kunenamenu', 'Recent Topics', 'recent', '', 'forum/recent', 'index.php?option=com_kunena&view=topics&mode=replies', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"topics_catselection\":\"\",\"topics_categories\":\"\",\"topics_time\":720}', 110, 111, 0, '*', 0),
(127, 'kunenamenu', 'New Topic', 'newtopic', '', 'forum/newtopic', 'index.php?option=com_kunena&view=topic&layout=create', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 112, 113, 0, '*', 0),
(128, 'kunenamenu', 'No Replies', 'noreplies', '', 'forum/noreplies', 'index.php?option=com_kunena&view=topics&mode=noreplies', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"topics_catselection\":\"\",\"topics_categories\":\"\",\"topics_time\":-1}', 114, 115, 0, '*', 0),
(129, 'kunenamenu', 'My Topics', 'mylatest', '', 'forum/mylatest', 'index.php?option=com_kunena&view=topics&layout=user&mode=default', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"topics_catselection\":\"2\",\"topics_categories\":\"0\",\"topics_time\":-1}', 116, 117, 0, '*', 0),
(130, 'kunenamenu', 'Profile', 'profile', '', 'forum/profile', 'index.php?option=com_kunena&view=user', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"integration\":1}', 118, 119, 0, '*', 0),
(131, 'kunenamenu', 'Help', 'help', '', 'forum/help', 'index.php?option=com_kunena&view=misc', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 3, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"body\":\"This help page is a menu item inside [b]Kunena Menu[\\/b], which allows easy navigation in your forum. \\n\\n You can use Joomla Menu Manager to edit items in this menu. Please go to [b]Administration[\\/b] >> [b]Menus[\\/b] >> [b]Kunena Menu[\\/b] >> [b]Help[\\/b] to edit or remove this menu item. \\n\\n In this menu item you can use Plain Text, BBCode or HTML. If you want to bind article into this page, you may use article BBCode (with article id): [code][article=full]123[\\/article][\\/code] \\n\\n If you want to create your own menu for Kunena, please start by creating [b]Home Page[\\/b] first. In that page you can select default menu item, which is shown when you enter to Kunena.\",\"body_format\":\"bbcode\"}', 120, 121, 0, '*', 0),
(132, 'kunenamenu', 'Search', 'search', '', 'forum/search', 'index.php?option=com_kunena&view=search', 'component', 1, 124, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 122, 123, 0, '*', 0),
(135, 'main-menu', 'History', 'history', '', 'pages/history', 'index.php?option=com_content&view=category&layout=theme3589:category&id=25', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"100\",\"num_columns\":\"2\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"1\",\"page_heading\":\"\",\"pageclass_sfx\":\"history\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 26, 27, 0, '*', 0),
(136, 'main-menu', 'Our team', 'our-team', '', 'pages/our-team', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"team\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 22, 23, 0, '*', 0),
(137, 'main-menu', 'Testimonials', 'testimonials', '', 'pages/testimonials', 'index.php?option=com_content&view=category&layout=theme3589:category&id=28', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"100\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"1\",\"page_heading\":\"\",\"pageclass_sfx\":\"testimonials\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 28, 29, 0, '*', 0),
(138, 'main-menu', 'FAQs', 'faqs', '', 'pages/faqs', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"Frequently asked questions\",\"pageclass_sfx\":\"faqs\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 20, 21, 0, '*', 0),
(142, 'main-menu', 'Contacts', 'contacts', '', 'contacts', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"presentation_style\":\"plain\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_tags\":\"\",\"show_info\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_misc\":\"\",\"show_articles\":\"\",\"articles_display_num\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 57, 58, 0, '*', 0),
(148, 'social-media', 'Facebook', '2014-05-03-08-53-37', '', '2014-05-03-08-53-37', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"Facebook\",\"menu-anchor_css\":\"fa fa-facebook\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":0,\"menu_show\":1}', 65, 66, 0, '*', 0),
(149, 'social-media', 'Google+', '2014-05-03-08-54-19', '', '2014-05-03-08-54-19', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"Google+\",\"menu-anchor_css\":\"fa fa-google-plus\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":0,\"menu_show\":1}', 69, 70, 0, '*', 0),
(150, 'social-media', 'Twitter', '2014-05-03-08-54-56', '', '2014-05-03-08-54-56', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"Twitter\",\"menu-anchor_css\":\"fa fa-twitter\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":0,\"menu_show\":1}', 67, 68, 0, '*', 0),
(152, 'social-media', 'Skype', '2014-05-03-08-56-20', '', '2014-05-03-08-56-20', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"Skype\",\"menu-anchor_css\":\"fa fa-skype\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":0,\"menu_show\":1}', 71, 72, 0, '*', 0),
(170, 'system-menu', 'Template settings', 'template-settings', '', 'template-settings', 'index.php?option=com_content&view=article&id=57', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"template_settings\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 125, 126, 0, '*', 0),
(171, 'main-menu', 'Template settings', '2014-05-03-11-32-48', '', 'pages/elements/2014-05-03-11-32-48', 'index.php?Itemid=', 'alias', 1, 426, 3, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"aliasoptions\":\"170\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 47, 48, 0, '*', 0),
(172, 'system-menu', 'Username reminder request', 'username-reminder-request', '', 'username-reminder-request', 'index.php?option=com_users&view=remind', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 127, 128, 0, '*', 0),
(173, 'system-menu', 'Password reset', 'password-reset', '', 'password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 129, 130, 0, '*', 0),
(174, 'system-menu', 'User registration', 'user-registration', '', 'user-registration', 'index.php?option=com_users&view=registration', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 131, 132, 0, '*', 0),
(175, 'system-menu', 'Login form', 'login-form', '', 'login-form', 'index.php?option=com_users&view=login', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 133, 134, 0, '*', 0),
(176, 'system-menu', 'Privacy policy', 'privacy-policy2', '', 'privacy-policy2', 'index.php?option=com_content&view=article&id=6', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 135, 136, 0, '*', 0),
(203, 'main-menu', 'Gallery', 'gallery', '', 'gallery', 'index.php?option=com_joomgallery&view=category&catid=2', 'component', 1, 1, 1, 10032, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"disable_global_info\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"gallery\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"3\",\"icemega_width\":\"100%\",\"icemega_colwidth\":\"20%, 80%, 100%\",\"icemega_cols_items\":\"6, 1, 1\",\"icemega_subtype\":\"menu\"}', 55, 56, 0, '*', 0),
(204, 'system-menu', '404 Page', '404', '', '404', 'index.php?option=com_content&view=article&id=65', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"404\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 137, 138, 0, '*', 0),
(280, 'social-media', 'Pinterest', '2015-01-05-08-40-38', '', '2015-01-05-08-40-38', '#', 'url', -2, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"Pinterest\",\"menu-anchor_css\":\"fa fa-pinterest\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":0,\"menu_show\":1}', 139, 140, 0, '*', 0),
(283, 'main-menu', 'Portfolio', 'portfolio', '', 'pages/portfolio', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"1\",\"page_heading\":\"Portfolio\",\"pageclass_sfx\":\"works\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 42, 43, 0, '*', 0),
(305, 'main-menu', 'Site map', 'site-map', '', 'pages/site-map', 'index.php?option=com_content&view=category&layout=theme3589:category&id=64', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"1\",\"page_heading\":\"\",\"pageclass_sfx\":\"site_map\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 34, 35, 0, '*', 0),
(309, 'what-we-offer', 'customer-friendly service', '2015-01-20-16-07-15', '', '2015-01-20-16-07-15', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 141, 142, 0, '*', 0),
(310, 'what-we-offer', '100% satisfaction', '2015-01-20-16-07-34', '', '2015-01-20-16-07-34', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 143, 144, 0, '*', 0),
(311, 'what-we-offer', 'quality guarantee', '2015-01-20-16-07-53', '', '2015-01-20-16-07-53', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 145, 146, 0, '*', 0),
(312, 'what-we-offer', 'reliability', '2015-01-20-16-08-12', '', '2015-01-20-16-08-12', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 147, 148, 0, '*', 0),
(317, 'requirements', 'B.Tech./ B.E / MCA degree in Computer Science, Engineering or a related stream.', 'b-tech-b-e-mca-degree-in-computer-science-engineering-or-a-related-stream', '', 'b-tech-b-e-mca-degree-in-computer-science-engineering-or-a-related-stream', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 149, 150, 0, '*', 0),
(318, 'requirements', '3+ years of software development experience.', '3-years-of-software-development-experience', '', '3-years-of-software-development-experience', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 151, 152, 0, '*', 0),
(319, 'requirements', '3+ years of Python / Java development projects experience.', '3-years-of-python-java-development-projects-experience', '', '3-years-of-python-java-development-projects-experience', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 153, 154, 0, '*', 0),
(320, 'requirements', 'Minimum of 4 live project roll outs.', 'minimum-of-4-live-project-roll-outs', '', 'minimum-of-4-live-project-roll-outs', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 155, 156, 0, '*', 0),
(321, 'requirements', 'Experience with third-party libraries and APIs.', 'experience-with-third-party-libraries-and-apis', '', 'experience-with-third-party-libraries-and-apis', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 157, 158, 0, '*', 0),
(322, 'requirements', 'In depth understanding and experience of either SDLC or PDLC.', 'in-depth-understanding-and-experience-of-either-sdlc-or-pdlc', '', 'in-depth-understanding-and-experience-of-either-sdlc-or-pdlc', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 159, 160, 0, '*', 0),
(323, 'requirements', 'Good Communication Skills', 'good-communication-skills', '', 'good-communication-skills', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 161, 162, 0, '*', 0),
(324, 'requirements', 'Team Player', 'team-player', '', 'team-player', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 163, 164, 0, '*', 0),
(325, 'what-we-expect-from-you', 'Design and build applications/ components using open source technology.', 'design-and-build-applications-components-using-open-source-technology', '', 'design-and-build-applications-components-using-open-source-technology', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 165, 166, 0, '*', 0),
(326, 'what-we-expect-from-you', 'Taking complete ownership of the deliveries assigned.', 'taking-complete-ownership-of-the-deliveries-assigned', '', 'taking-complete-ownership-of-the-deliveries-assigned', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 167, 168, 0, '*', 0),
(327, 'what-we-expect-from-you', 'Collaborate with cross-functional teams to define, design, and ship new features.', 'collaborate-with-cross-functional-teams-to-define-design-and-ship-new-features', '', 'collaborate-with-cross-functional-teams-to-define-design-and-ship-new-features', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 169, 170, 0, '*', 0),
(328, 'what-we-expect-from-you', 'Work with outside data sources and API\'s.', 'work-with-outside-data-sources-and-api-s', '', 'work-with-outside-data-sources-and-api-s', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 171, 172, 0, '*', 0),
(329, 'what-we-expect-from-you', 'Unit-test code for robustness, including edge cases, usability, and general reliability.', 'unit-test-code-for-robustness-including-edge-cases-usability-and-general-reliability', '', 'unit-test-code-for-robustness-including-edge-cases-usability-and-general-reliability', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 173, 174, 0, '*', 0),
(330, 'what-we-expect-from-you', 'Work on bug fixing and improving application performance.', 'work-on-bug-fixing-and-improving-application-performance', '', 'work-on-bug-fixing-and-improving-application-performance', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 175, 176, 0, '*', 0),
(331, 'user-menu', 'Login form', '2015-01-26-09-48-59', '', '2015-01-26-09-48-59', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 5, '', 0, '{\"aliasoptions\":\"175\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 177, 178, 0, '*', 0),
(332, 'user-menu', 'User profile', 'user-profile', '', 'user-profile', 'index.php?option=com_users&view=profile', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 179, 180, 0, '*', 0),
(333, 'user-menu', 'Create account', '2015-01-26-09-53-51', '', '2015-01-26-09-53-51', 'index.php?Itemid=', 'alias', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 5, '', 0, '{\"aliasoptions\":\"174\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 181, 182, 0, '*', 0),
(334, 'user-menu', 'Create article', 'create-article', '', 'create-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{\"enable_category\":\"1\",\"catid\":\"11\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 183, 184, 0, '*', 0),
(335, 'main-menu', 'Pages', 'pages', '', 'pages', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"150px\",\"icemega_colwidth\":\"150px\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 19, 52, 0, '*', 0),
(336, 'main-menu', 'Pricing', 'pricing', '', 'pages/elements/pricing', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 426, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 45, 46, 0, '*', 0),
(342, 'main-menu', 'Forum', '2015-02-25-09-04-57', '', 'pages/2015-02-25-09-04-57', 'index.php?Itemid=124', 'alias', 1, 335, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 14, '{\"aliasoptions\":\"124\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 36, 37, 0, '*', 0),
(343, 'main-menu', 'Careers', 'careers', '', 'pages/careers', 'index.php?option=com_content&view=category&layout=theme3589:category&id=46', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 16, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"1\",\"page_heading\":\"\",\"pageclass_sfx\":\"careers\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 40, 41, 0, '*', 0),
(416, 'what-we-do', 'influence policy decisions in favor of customers', '2015-02-17-20-38-27', '', '2015-02-17-20-38-27', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 185, 186, 0, '*', 0),
(417, 'what-we-do', 'support and expand efforts to fill these gaps', '2015-02-17-20-39-08', '', '2015-02-17-20-39-08', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 187, 188, 0, '*', 0),
(418, 'what-we-do', 'highlight the chronic and continuing gaps in the related data', '2015-02-17-20-39-31', '', '2015-02-17-20-39-31', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 189, 190, 0, '*', 0),
(419, 'what-we-do', 'monitor the changing business situation', '2015-02-17-20-39-53', '', '2015-02-17-20-39-53', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 191, 192, 0, '*', 0),
(422, 'system-menu', 'Search', 'search', '', 'search', 'index.php?option=com_search&view=search', 'component', 1, 1, 1, 19, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{\"search_areas\":\"0\",\"show_date\":\"0\",\"searchphrase\":\"0\",\"ordering\":\"newest\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\"}', 193, 194, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(426, 'main-menu', 'Elements', 'elements', '', 'pages/elements', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"elements\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 44, 49, 0, '*', 0),
(439, 'top-menu', 'Login form', '2015-04-24-14-59-37', '', '2015-04-24-14-59-37', '#modal', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 5, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 195, 196, 0, '*', 0),
(440, 'top-menu', 'User profile', 'user-profile-2', '', 'user-profile-2', 'index.php?option=com_users&view=profile', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 197, 198, 0, '*', 0),
(441, 'top-menu', 'Create account', '2015-04-27-07-43-33', '', '2015-04-27-07-43-33', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 5, '', 14, '{\"aliasoptions\":\"174\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 199, 200, 0, '*', 0),
(442, 'top-menu', 'Create article', 'create-article-2', '', 'create-article-2', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 2, '', 14, '{\"enable_category\":\"1\",\"catid\":\"11\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 201, 202, 0, '*', 0),
(492, 'main', 'Komento', 'komento', '', 'komento', 'index.php?option=com_komento', 'component', 0, 1, 1, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/komento-favicon.png', 0, '{}', 203, 222, 0, '', 1),
(493, 'main', 'COM_KOMENTO_MENU_COMMENTS', 'com-komento-menu-comments', '', 'komento/com-komento-menu-comments', 'index.php?option=com_komento&view=comments', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/comments-favicon.png', 0, '{}', 204, 205, 0, '', 1),
(494, 'main', 'COM_KOMENTO_MENU_PENDINGS', 'com-komento-menu-pendings', '', 'komento/com-komento-menu-pendings', 'index.php?option=com_komento&view=pending', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/pending-favicon.png', 0, '{}', 206, 207, 0, '', 1),
(495, 'main', 'COM_KOMENTO_MENU_REPORTS', 'com-komento-menu-reports', '', 'komento/com-komento-menu-reports', 'index.php?option=com_komento&view=reports', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/reports-favicon.png', 0, '{}', 208, 209, 0, '', 1),
(496, 'main', 'COM_KOMENTO_MENU_SUBSCRIBERS', 'com-komento-menu-subscribers', '', 'komento/com-komento-menu-subscribers', 'index.php?option=com_komento&view=subscribers', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/subscribers-favicon.png', 0, '{}', 210, 211, 0, '', 1),
(497, 'main', 'COM_KOMENTO_MENU_INTEGRATIONS', 'com-komento-menu-integrations', '', 'komento/com-komento-menu-integrations', 'index.php?option=com_komento&view=integrations', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/integrations-favicon.png', 0, '{}', 212, 213, 0, '', 1),
(498, 'main', 'COM_KOMENTO_MENU_CONFIGURATION', 'com-komento-menu-configuration', '', 'komento/com-komento-menu-configuration', 'index.php?option=com_komento&view=system', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/system-favicon.png', 0, '{}', 214, 215, 0, '', 1),
(499, 'main', 'COM_KOMENTO_MENU_ACL', 'com-komento-menu-acl', '', 'komento/com-komento-menu-acl', 'index.php?option=com_komento&view=acl', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/acls-favicon.png', 0, '{}', 216, 217, 0, '', 1),
(500, 'main', 'COM_KOMENTO_MENU_MIGRATORS', 'com-komento-menu-migrators', '', 'komento/com-komento-menu-migrators', 'index.php?option=com_komento&view=migrators', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/migrators-favicon.png', 0, '{}', 218, 219, 0, '', 1),
(501, 'main', 'COM_KOMENTO_MENU_MAILQ', 'com-komento-menu-mailq', '', 'komento/com-komento-menu-mailq', 'index.php?option=com_komento&view=mailq', 'component', 0, 492, 2, 10072, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_komento/assets/images/mailq-favicon.png', 0, '{}', 220, 221, 0, '', 1),
(513, 'user-menu', 'Log  Out', '2015-01-26-09-48-60', '', '2015-01-26-09-48-60', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 2, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"#modal\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 223, 224, 0, '*', 0),
(514, 'top-menu', 'Log Out', '2015-04-24-14-59-38', '', '2015-04-24-14-59-38', '#modal', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 2, ' ', 14, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"icemega_subtitle\":\"\",\"icemega_cols\":\"1\",\"icemega_width\":\"\",\"icemega_colwidth\":\"\",\"icemega_cols_items\":\"\",\"icemega_subtype\":\"menu\",\"icemega_anchorsmenuitem\":\"124\"}', 225, 226, 0, '*', 0),
(563, 'main', 'com_joomlaupdate', 'com-joomlaupdate', '', 'com-joomlaupdate', 'index.php?option=com_joomlaupdate', 'component', 0, 1, 1, 28, 0, '0000-00-00 00:00:00', 0, 1, 'class:joomlaupdate', 0, '{}', 227, 228, 0, '', 1),
(577, 'main', 'COM_ASSOCIATIONS', 'com-associations', '', 'com-associations', 'index.php?option=com_associations', 'component', 1, 1, 1, 10168, 0, '0000-00-00 00:00:00', 0, 1, 'class:associations', 0, '{}', 229, 230, 0, '', 1),
(578, 'header-menu', '800-2345-6789', '800-2345-6789', '', '800-2345-6789', 'tel:800-2345-6789', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"material-icons-local_phone telephone\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 231, 232, 0, '*', 0),
(579, 'header-menu', 'advisto@demolink.org', 'advisto-demolink-org', '', 'advisto-demolink-org', 'mailto:advisto@demolink.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"link-underline\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 233, 234, 0, '*', 0),
(580, 'navigation', 'About us', 'about2', '', 'about2', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"aliasoptions\":\"584\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 235, 236, 0, '*', 0),
(581, 'navigation', 'Blog', 'blog2', '', 'blog2', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 14, '{\"aliasoptions\":\"285\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 237, 238, 0, '*', 0),
(582, 'navigation', 'Gallery', 'gallery2', '', 'gallery2', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"aliasoptions\":\"203\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 239, 240, 0, '*', 0),
(583, 'navigation', 'Contacts', 'contacts2', '', 'contacts2', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"aliasoptions\":\"142\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 241, 242, 0, '*', 0),
(584, 'main-menu', 'About', 'about-us', '', 'about-us', 'index.php?option=com_content&view=category&layout=theme3589:category&id=9', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"about\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 17, 18, 0, '*', 0),
(608, 'main-menu', 'Latest posts', 'latest-posts', '', 'home/latest-posts', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"aliasoptions\":\"611\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 12, 13, 0, '*', 0),
(610, 'main-menu', 'Latest works', 'latest-works', '', 'home/latest-works', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"aliasoptions\":\"283\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 14, 15, 0, '*', 0),
(611, 'main-menu', 'Blog', 'blog', '', 'blog', 'index.php?option=com_content&view=category&layout=blog&id=11', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"layout_type\":\"blog\",\"show_category_heading_title_text\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"show_cat_tags\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"1\",\"show_pagination_results\":\"\",\"show_featured\":\"\",\"article_layout\":\"_:default\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 53, 54, 0, '*', 0),
(612, 'main-menu', 'Search', 'search-menu', '', 'search-menu', '#modal', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"menu-search\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1}', 63, 64, 0, '*', 0),
(622, 'main-menu', 'Login', 'login-menu-drop', '', 'login-menu-drop', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_css\":\"menu-login-form\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 59, 62, 0, '*', 0),
(623, 'main-menu', 'Login or register', 'login-or-register', '', 'login-menu-drop/login-or-register', '#', 'url', 1, 622, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu-anchor_rel\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"menu_show\":1}', 60, 61, 0, '*', 0),
(653, 'main', 'COM_JOOMGALLERY', 'com-joomgallery', '', 'com-joomgallery', 'index.php?option=com_joomgallery', 'component', 1, 1, 1, 10032, 0, '0000-00-00 00:00:00', 0, 1, '../media/joomgallery/images/joom_main.png', 0, '{}', 243, 270, 0, '', 1),
(654, 'main', 'COM_JOOMGALLERY_CATEGORY_MANAGER', 'com-joomgallery-category-manager', '', 'com-joomgallery/com-joomgallery-category-manager', 'index.php?option=com_joomgallery&controller=categories', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_categories.png', 0, '{}', 244, 245, 0, '', 1),
(655, 'main', 'COM_JOOMGALLERY_IMAGE_MANAGER', 'com-joomgallery-image-manager', '', 'com-joomgallery/com-joomgallery-image-manager', 'index.php?option=com_joomgallery&controller=images', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_pictures.png', 0, '{}', 246, 247, 0, '', 1),
(656, 'main', 'COM_JOOMGALLERY_COMMENTS_MANAGER', 'com-joomgallery-comments-manager', '', 'com-joomgallery/com-joomgallery-comments-manager', 'index.php?option=com_joomgallery&controller=comments', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_comments.png', 0, '{}', 248, 249, 0, '', 1),
(657, 'main', 'COM_JOOMGALLERY_IMAGE_UPLOAD', 'com-joomgallery-image-upload', '', 'com-joomgallery/com-joomgallery-image-upload', 'index.php?option=com_joomgallery&controller=upload', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_pictureupload.png', 0, '{}', 250, 251, 0, '', 1),
(658, 'main', 'COM_JOOMGALLERY_AJAX_UPLOAD', 'com-joomgallery-ajax-upload', '', 'com-joomgallery/com-joomgallery-ajax-upload', 'index.php?option=com_joomgallery&controller=ajaxupload', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_ajaxupload.png', 0, '{}', 252, 253, 0, '', 1),
(659, 'main', 'COM_JOOMGALLERY_BATCH_UPLOAD', 'com-joomgallery-batch-upload', '', 'com-joomgallery/com-joomgallery-batch-upload', 'index.php?option=com_joomgallery&controller=batchupload', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_batchupload.png', 0, '{}', 254, 255, 0, '', 1),
(660, 'main', 'COM_JOOMGALLERY_FTP_UPLOAD', 'com-joomgallery-ftp-upload', '', 'com-joomgallery/com-joomgallery-ftp-upload', 'index.php?option=com_joomgallery&controller=ftpupload', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_ftpupload.png', 0, '{}', 256, 257, 0, '', 1),
(661, 'main', 'COM_JOOMGALLERY_JAVA_UPLOAD', 'com-joomgallery-java-upload', '', 'com-joomgallery/com-joomgallery-java-upload', 'index.php?option=com_joomgallery&controller=jupload', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_jupload.png', 0, '{}', 258, 259, 0, '', 1),
(662, 'main', 'COM_JOOMGALLERY_CONFIGURATION_MANAGER', 'com-joomgallery-configuration-manager', '', 'com-joomgallery/com-joomgallery-configuration-manager', 'index.php?option=com_joomgallery&controller=config', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_config.png', 0, '{}', 260, 261, 0, '', 1),
(663, 'main', 'COM_JOOMGALLERY_CUSTOMIZE_CSS', 'com-joomgallery-customize-css', '', 'com-joomgallery/com-joomgallery-customize-css', 'index.php?option=com_joomgallery&controller=cssedit', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_css.png', 0, '{}', 262, 263, 0, '', 1),
(664, 'main', 'COM_JOOMGALLERY_MIGRATION_MANAGER', 'com-joomgallery-migration-manager', '', 'com-joomgallery/com-joomgallery-migration-manager', 'index.php?option=com_joomgallery&controller=migration', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_migration.png', 0, '{}', 264, 265, 0, '', 1),
(665, 'main', 'COM_JOOMGALLERY_MAINTENANCE_MANAGER', 'com-joomgallery-maintenance-manager', '', 'com-joomgallery/com-joomgallery-maintenance-manager', 'index.php?option=com_joomgallery&controller=maintenance', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_maintenance.png', 0, '{}', 266, 267, 0, '', 1),
(666, 'main', 'COM_JOOMGALLERY_HELP', 'com-joomgallery-help', '', 'com-joomgallery/com-joomgallery-help', 'index.php?option=com_joomgallery&controller=help', 'component', 1, 653, 2, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'media/joomgallery/images/joom_information.png', 0, '{}', 268, 269, 0, '', 1),
(745, 'main', 'COM_SLOGIN_MAIN_MENU', 'com-slogin-main-menu', '', 'com-slogin-main-menu', 'index.php?option=com_slogin', 'component', 1, 1, 1, 10143, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_slogin/icon_16x16.png', 0, '{}', 271, 272, 0, '', 1),
(746, 'main-menu', 'Partners', 'partners', '', 'pages/partners', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 38, 39, 0, '*', 0),
(747, 'main-menu', 'Single Team', 'single-team', '', 'pages/single-team', 'index.php?option=com_content&view=article&id=164', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 24, 25, 0, '*', 0),
(748, 'main-menu', '404 page', '404-page', '', 'pages/404-page', 'index.php?option=com_content&view=article&id=65', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"show_title\":\"0\",\"link_titles\":\"0\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"404\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 50, 51, 0, '*', 0),
(749, 'main-menu', 'Services', 'services', '', 'pages/services', 'index.php?option=com_content&view=category&layout=theme3589:category&id=2', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"0\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 30, 31, 0, '*', 0),
(750, 'main-menu', 'Single service', 'single-service', '', 'pages/single-service', 'index.php?option=com_content&view=article&id=174', 'component', 1, 335, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, ' ', 0, '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_tags\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_image_css\":\"\",\"menu_text\":1,\"menu_show\":1,\"page_title\":\"\",\"show_page_heading\":\"0\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', 32, 33, 0, '*', 0),
(759, 'main', 'COM_KUNENA', 'com-kunena', '', 'com-kunena', 'index.php?option=com_kunena', 'component', 1, 1, 1, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_kunena/media/icons/favicons/kunena-logo-white.png', 0, '{}', 273, 300, 0, '', 1),
(760, 'main', 'COM_KUNENA_DASHBOARD', 'com-kunena-dashboard', '', 'com-kunena/com-kunena-dashboard', 'index.php?option=com_kunena&view=cpanel', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 274, 275, 0, '', 1),
(761, 'main', 'COM_KUNENA_CATEGORY_MANAGER', 'com-kunena-category-manager', '', 'com-kunena/com-kunena-category-manager', 'index.php?option=com_kunena&view=categories', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 276, 277, 0, '', 1),
(762, 'main', 'COM_KUNENA_USER_MANAGER', 'com-kunena-user-manager', '', 'com-kunena/com-kunena-user-manager', 'index.php?option=com_kunena&view=users', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 278, 279, 0, '', 1),
(763, 'main', 'COM_KUNENA_FILE_MANAGER', 'com-kunena-file-manager', '', 'com-kunena/com-kunena-file-manager', 'index.php?option=com_kunena&view=attachments', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 280, 281, 0, '', 1),
(764, 'main', 'COM_KUNENA_EMOTICON_MANAGER', 'com-kunena-emoticon-manager', '', 'com-kunena/com-kunena-emoticon-manager', 'index.php?option=com_kunena&view=smilies', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 282, 283, 0, '', 1),
(765, 'main', 'COM_KUNENA_RANK_MANAGER', 'com-kunena-rank-manager', '', 'com-kunena/com-kunena-rank-manager', 'index.php?option=com_kunena&view=ranks', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 284, 285, 0, '', 1),
(766, 'main', 'COM_KUNENA_TEMPLATE_MANAGER', 'com-kunena-template-manager', '', 'com-kunena/com-kunena-template-manager', 'index.php?option=com_kunena&view=templates', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 286, 287, 0, '', 1),
(767, 'main', 'COM_KUNENA_CONFIGURATION', 'com-kunena-configuration', '', 'com-kunena/com-kunena-configuration', 'index.php?option=com_kunena&view=config', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 288, 289, 0, '', 1),
(768, 'main', 'COM_KUNENA_PLUGIN_MANAGER', 'com-kunena-plugin-manager', '', 'com-kunena/com-kunena-plugin-manager', 'index.php?option=com_kunena&view=plugins', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 290, 291, 0, '', 1),
(769, 'main', 'COM_KUNENA_LOG_MANAGER', 'com-kunena-log-manager', '', 'com-kunena/com-kunena-log-manager', 'index.php?option=com_kunena&view=logs', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 292, 293, 0, '', 1),
(770, 'main', 'COM_KUNENA_MENU_STATISTICS', 'com-kunena-menu-statistics', '', 'com-kunena/com-kunena-menu-statistics', 'index.php?option=com_kunena&view=statistics', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 294, 295, 0, '', 1),
(771, 'main', 'COM_KUNENA_FORUM_TOOLS', 'com-kunena-forum-tools', '', 'com-kunena/com-kunena-forum-tools', 'index.php?option=com_kunena&view=tools', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 296, 297, 0, '', 1),
(772, 'main', 'COM_KUNENA_TRASH_MANAGER', 'com-kunena-trash-manager', '', 'com-kunena/com-kunena-trash-manager', 'index.php?option=com_kunena&view=trash', 'component', 1, 759, 2, 10019, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '{}', 298, 299, 0, '', 1),
(773, 'main', 'AcyMailing', 'acymailing', '', 'acymailing', 'index.php?option=com_acymailing', 'component', 1, 1, 1, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-acymailing.png', 0, '{}', 301, 316, 0, '', 1),
(774, 'main', 'Users', 'users', '', 'acymailing/users', 'index.php?option=com_acymailing&ctrl=subscriber', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-users.png', 0, '{}', 302, 303, 0, '', 1),
(775, 'main', 'Lists', 'lists', '', 'acymailing/lists', 'index.php?option=com_acymailing&ctrl=list', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-acylist.png', 0, '{}', 304, 305, 0, '', 1),
(776, 'main', 'Newsletters', 'newsletters', '', 'acymailing/newsletters', 'index.php?option=com_acymailing&ctrl=newsletter', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-newsletter.png', 0, '{}', 306, 307, 0, '', 1),
(777, 'main', 'Templates', 'templates', '', 'acymailing/templates', 'index.php?option=com_acymailing&ctrl=template', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-acytemplate.png', 0, '{}', 308, 309, 0, '', 1),
(778, 'main', 'Queue', 'queue', '', 'acymailing/queue', 'index.php?option=com_acymailing&ctrl=queue', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-process.png', 0, '{}', 310, 311, 0, '', 1),
(779, 'main', 'Statistics', 'statistics', '', 'acymailing/statistics', 'index.php?option=com_acymailing&ctrl=stats', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-stats.png', 0, '{}', 312, 313, 0, '', 1),
(780, 'main', 'Configuration', 'configuration', '', 'acymailing/configuration', 'index.php?option=com_acymailing&ctrl=cpanel', 'component', 1, 773, 2, 10204, 0, '0000-00-00 00:00:00', 0, 1, '../media/com_acymailing/images/icons/icon-16-acyconfig.png', 0, '{}', 314, 315, 0, '', 1);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `menutype` varchar(24) COLLATE utf8mb4_unicode_ci NOT NULL,
  `title` varchar(48) COLLATE utf8mb4_unicode_ci NOT NULL,
  `description` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `client_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__menu_types` (`id`, `asset_id`, `menutype`, `title`, `description`, `client_id`) VALUES
(2, 0, 'kunenamenu', 'Kunena Menu', 'This is the default Kunena menu. It is used as the top navigation for Kunena. It can be publish in any module position. Simply unpublish items that are not required.', 0),
(3, 0, 'system-menu', 'System Menu', '', 0),
(5, 0, 'social-media', 'Social Media', '', 0),
(12, 0, 'main-menu', 'Main menu', '', 0),
(13, 0, 'what-we-offer', 'What we offer', '', 0),
(14, 0, 'requirements', 'Requirements', '', 0),
(15, 0, 'what-we-expect-from-you', 'What we Expect from you?', '', 0),
(16, 0, 'user-menu', 'User menu', '', 0),
(17, 0, 'what-we-do', 'What we do', '', 0),
(18, 0, 'top-menu', 'Top menu', '', 0),
(19, 679, 'header-menu', 'Header menu', '', 0),
(20, 713, 'navigation', 'Navigation', '', 0);

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE IF NOT EXISTS `#__messages` (
  `message_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `user_id_to` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `subject` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `message` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__messages` (`message_id`, `user_id_from`, `user_id_to`, `folder_id`, `date_time`, `state`, `priority`, `subject`, `message`) VALUES
(1, 846, 910, 0, '2018-06-25 16:06:04', 0, 0, 'An image has been downloaded', 'The image with the title Suspendisse (Filename: first_category_1_20140903_1689763756.jpg) has been downloaded by Guest!'),
(2, 322, 322, 0, '2018-06-25 16:06:04', -2, 0, 'New Comment', 'A new comment from Guest has been submitted. This comment needs to be approved before it can be published.'),
(5, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from ejhjkesh has been submitted. This comment needs to be approved before it can be published.'),
(6, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from ejhjkesh has been submitted. This comment needs to be approved before it can be published.'),
(7, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from dbdrt has been submitted. This comment needs to be approved before it can be published.'),
(8, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from rgdrvdr has been submitted. This comment needs to be approved before it can be published.'),
(9, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from 65rd has been submitted. This comment needs to be approved before it can be published.'),
(10, 729, 729, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from vsrtdrtrd has been submitted. This comment needs to be approved before it can be published.'),
(12, 504, 504, 0, '2018-06-25 16:06:04', 0, 0, 'New Comment', 'A new comment from xcz has been submitted. This comment needs to be approved before it can be published.'),
(13, 502, 502, 0, '2018-06-25 16:06:04', 0, 0, 'Error sending email', 'An error was encountered when sending the user registration email. The error is: Could not instantiate mail function. The user who attempted to register is: asggas'),
(14, 602, 602, 0, '2018-06-25 16:06:04', 0, 0, 'Error sending email', 'An error was encountered when sending the user registration email. The error is: Could not instantiate mail function. The user who attempted to register is: asggas'),
(15, 793, 793, 0, '2018-06-25 16:06:04', 0, 0, 'Error sending email', 'An error was encountered when sending the user registration email. The error is: Could not instantiate mail function. The user who attempted to register is: asggas');

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE IF NOT EXISTS `#__messages_cfg` (
  `user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `cfg_value` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `content` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=299 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__modules` (`id`, `asset_id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(2, 56, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 57, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', 1, '*'),
(4, 58, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', 1, '*'),
(8, 59, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 60, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 61, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', 1, '*'),
(12, 62, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}', 1, '*'),
(13, 63, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 64, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 65, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(79, 68, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', 1, '*'),
(86, 69, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', 1, '*'),
(94, 62, 'Recent templates', '', '', 5, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_templates', 1, 1, '', 1, '*'),
(103, 167, 'Search', '', '', 1, '404-search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 0, '{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"1\",\"button_pos\":\"right\",\"imagebutton\":\"0\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(104, 168, 'JoomGallery News', '', '', 1, 'joom_cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_feed', 1, 1, 'cache=1\n    cache_time=15\n    moduleclass_sfx=\n    rssurl=http://www.en.joomgallery.net/feed/rss.html\n    rssrtl=0\n    rsstitle=1\n    rssdesc=0\n    rssimage=1\n    rssitems=3\n    rssitemdesc=1\n    word_count=200', 1, '*'),
(115, 210, 'TM Ajax Contact Form', '', '', 1, 'contact-form', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_ajax_contact_form', 1, 0, '{\"pretext\":\"\",\"fields_list\":\"{\\\"label\\\":[\\\"Name\\\",\\\"Email\\\",\\\"Phone\\\",\\\"Time\\\",\\\"date\\\",\\\"Message\\\"],\\\"name\\\":[\\\"name\\\",\\\"email\\\",\\\"phone\\\",\\\"time\\\",\\\"date\\\",\\\"message\\\"],\\\"type\\\":[\\\"text\\\",\\\"email\\\",\\\"text\\\",\\\"times\\\",\\\"date\\\",\\\"textarea\\\"],\\\"options_list\\\":[\\\"{\\\\\\\"option_name\\\\\\\":[],\\\\\\\"option_value\\\\\\\":[]}\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\"],\\\"title\\\":[\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\"],\\\"req\\\":[\\\"1\\\",\\\"1\\\",\\\"0\\\",\\\"1\\\",\\\"1\\\",\\\"1\\\"],\\\"bootstrap_size\\\":[\\\"4\\\",\\\"4\\\",\\\"4\\\",\\\"6\\\",\\\"6\\\",\\\"12\\\"]}\",\"admin_email\":\"admin@admin.com\",\"cc_email\":\"\",\"bcc_email\":\"\",\"success_notify\":\"Thank You! Your message has been sent.\",\"failure_notify\":\"Something went wrong, please try again later.\",\"captcha_failure_notify\":\"Please enter a correct Captcha answer.\",\"captcha_req\":\"0\",\"reset_publish\":\"1\",\"br_name\":\"Clear\",\"bs_name\":\"Send\",\"labels_pos\":\"1\",\"textarea_minlength\":\"20\",\"time_format\":\"1\",\"date_format\":\"DD.MM.YYYY\",\"gdpr_check\":\"1\",\"moduleclass_sfx\":\"\",\"layout\":\"_:default\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(118, 289, 'Detailed', '', '', 1, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"35\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"4\",\"columns\":\"4\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"right\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"pricing_detailed\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(122, 310, 'Simple', '', '', 2, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"36\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"3\",\"columns\":\"3\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"right\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"pricing_simple\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(145, 348, 'Accordion 1', 'For \"Elements\" page', '', 11, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"18\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"custom\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"6\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h2\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(159, 377, 'Careers accordion', '', '', 1, 'careers-accordion-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"47\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(160, 380, 'Apply now', '', '', 1, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_ajax_contact_form', 1, 1, '{\"pretext\":\"Fill in the application form below and get your dream career of a lifetime.\",\"fields_list\":\"{\\\"label\\\":[\\\"Name\\\",\\\"Last Name\\\",\\\"Email\\\",\\\"Age\\\",\\\"City\\\",\\\"Position\\\",\\\"Expected Salary\\\",\\\"Start Date\\\",\\\"Website\\\",\\\"Experience\\\",\\\"Application\\\"],\\\"name\\\":[\\\"name\\\",\\\"lastname\\\",\\\"email\\\",\\\"age\\\",\\\"city\\\",\\\"position\\\",\\\"salary\\\",\\\"date\\\",\\\"website\\\",\\\"experience\\\",\\\"application\\\"],\\\"type\\\":[\\\"text\\\",\\\"text\\\",\\\"email\\\",\\\"text\\\",\\\"text\\\",\\\"select\\\",\\\"text\\\",\\\"text\\\",\\\"text\\\",\\\"textarea\\\",\\\"textarea\\\"],\\\"options_list\\\":[\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"{\\\\\\\"option_name\\\\\\\":[\\\\\\\"Chief Accountant\\\\\\\",\\\\\\\"Sales manager\\\\\\\",\\\\\\\"Sales assistant\\\\\\\",\\\\\\\"Office manager\\\\\\\"],\\\\\\\"option_value\\\\\\\":[\\\\\\\"Chief Accountant\\\\\\\",\\\\\\\"Sales manager\\\\\\\",\\\\\\\"Sales assistant\\\\\\\",\\\\\\\"Office manager\\\\\\\"]}\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\"],\\\"title\\\":[\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\"],\\\"req\\\":[\\\"1\\\",\\\"1\\\",\\\"1\\\",\\\"1\\\",\\\"1\\\",\\\"1\\\",\\\"1\\\",\\\"0\\\",\\\"0\\\",\\\"0\\\",\\\"1\\\"],\\\"bootstrap_size\\\":[\\\"6\\\",\\\"6\\\",\\\"12\\\",\\\"6\\\",\\\"6\\\",\\\"12\\\",\\\"6\\\",\\\"6\\\",\\\"12\\\",\\\"12\\\",\\\"12\\\"]}\",\"admin_email\":\"admin@admin.com\",\"cc_email\":\"\",\"bcc_email\":\"\",\"success_notify\":\"Thank You! Your message has been sent.\",\"failure_notify\":\"Something went wrong, please try again later.\",\"captcha_failure_notify\":\"Please enter a correct Captcha answer.\",\"captcha_req\":\"0\",\"reset_publish\":\"0\",\"br_name\":\"Clear\",\"bs_name\":\"Send\",\"labels_pos\":\"1\",\"textarea_minlength\":\"20\",\"time_format\":\"1\",\"moduleclass_sfx\":\"careers_form\",\"layout\":\"_:default\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(161, 382, 'Requirements', '', '', 1, 'careers-accordion-requirements', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{\"menutype\":\"requirements\",\"base\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" requirements\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(162, 383, 'What we Expect from you?', '', '', 1, 'careers-accordion-expect', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{\"menutype\":\"what-we-expect-from-you\",\"base\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" expect\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(163, 387, 'Careers accordion', '', '', 1, 'careers-accordion-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"47\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(164, 388, 'Careers accordion', '', '', 1, 'careers-accordion-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"47\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(165, 389, 'Careers accordion', '', '', 1, 'careers-accordion-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"47\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(166, 390, 'Pages', '', '', 1, 'content-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{\"menutype\":\"main-menu\",\"base\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"site_map\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h4\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(167, 391, 'Blog posts', '', '', 1, 'content-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_category', 1, 1, '{\"mode\":\"normal\",\"show_on_article_page\":\"1\",\"count\":\"0\",\"show_front\":\"show\",\"category_filtering_type\":\"1\",\"catid\":[\"11\"],\"show_child_category_articles\":\"1\",\"levels\":\"10\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"author_alias_filtering_type\":\"1\",\"created_by_alias\":[\"\"],\"excluded_articles\":\"\",\"date_filtering\":\"off\",\"date_field\":\"a.created\",\"start_date_range\":\"\",\"end_date_range\":\"\",\"relative_date\":\"30\",\"article_ordering\":\"publish_up\",\"article_ordering_direction\":\"DESC\",\"article_grouping\":\"none\",\"article_grouping_direction\":\"ksort\",\"month_year_format\":\"F Y\",\"link_titles\":\"1\",\"show_date\":\"0\",\"show_date_field\":\"created\",\"show_date_format\":\"Y-m-d H:i:s\",\"show_category\":\"0\",\"show_hits\":\"0\",\"show_author\":\"0\",\"show_introtext\":\"0\",\"introtext_limit\":\"100\",\"show_readmore\":\"0\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"15\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" site_map\",\"owncache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h4\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(168, 392, 'Portfolio posts', '', '', 1, 'content-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_category', 1, 1, '{\"mode\":\"normal\",\"show_on_article_page\":\"1\",\"count\":\"0\",\"show_front\":\"show\",\"category_filtering_type\":\"1\",\"catid\":[\"31\"],\"show_child_category_articles\":\"1\",\"levels\":\"10\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"author_alias_filtering_type\":\"1\",\"created_by_alias\":[\"\"],\"excluded_articles\":\"\",\"date_filtering\":\"off\",\"date_field\":\"a.created\",\"start_date_range\":\"\",\"end_date_range\":\"\",\"relative_date\":\"30\",\"article_ordering\":\"a.ordering\",\"article_ordering_direction\":\"ASC\",\"article_grouping\":\"none\",\"article_grouping_direction\":\"ksort\",\"month_year_format\":\"F Y\",\"link_titles\":\"1\",\"show_date\":\"0\",\"show_date_field\":\"created\",\"show_date_format\":\"Y-m-d H:i:s\",\"show_category\":\"0\",\"show_hits\":\"0\",\"show_author\":\"0\",\"show_introtext\":\"0\",\"introtext_limit\":\"100\",\"show_readmore\":\"0\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"15\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" site_map\",\"owncache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h4\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(169, 393, 'User menu', '', '', 1, 'content-bottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{\"menutype\":\"user-menu\",\"base\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"site_map\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"3\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h4\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(170, 395, 'Breadcrumbs', '', '', 1, 'breadcrumbs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 0, '{\"showHere\":\"0\",\"showHome\":\"1\",\"homeText\":\"\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"theme3589:first-last-item\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(171, 398, 'Our team', '', '', 1, 'content-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"26\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"9\",\"columns\":\"3\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"150\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"team\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(173, 400, 'Frequently asked questions', '', '', 3, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 1, '{\"catid\":[\"27\"],\"count\":\"100\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"If you need help, we have a list of frequently asked questions and answers. We strive to give you the best buying experience possible. Click a question below to view the answer. \",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(183, 437, 'Tabs', 'For \"Elements\" page', '', 13, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstraptabs', 1, 1, '{\"catid\":[\"57\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"8\",\"bootstrap_offset\":\"2\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(184, 442, 'Accordion 2', 'For \"Elements\" page', '', 10, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 0, '{\"catid\":[\"18\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"6\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h2\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(189, 456, 'Pricing Tables', 'For \"Elements\" page', '', 14, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"35\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"4\",\"columns\":\"4\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"right\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"pricing_detailed\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(190, 457, 'Simple', 'For \"Elements\" page', '', 15, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"36\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"3\",\"columns\":\"3\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"right\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"pricing_simple\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(192, 459, 'Accordions and Toggles', 'For \"Elements\" page', '', 9, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"title_only\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(195, 462, 'Menu search', '', '', 1, 'modal', 0, '0000-00-00 00:00:00', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 1, 'mod_search', 1, 0, '{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"1\",\"button_pos\":\"right\",\"imagebutton\":\"0\",\"button_text\":\" \",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"101\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" modal_search\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(234, 780, 'Text Elements', '', '', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_single', 1, 0, '{\"article_id\":\"121\",\"item_heading\":\"h4\",\"item_title\":\"0\",\"link_titles\":\"\",\"published_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"0\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(235, 781, 'TM Ajax Style Switcher', '', '', 1, 'fixed-sidebar-left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_style_switcher', 1, 0, '{\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(238, 784, 'Portfolio', '', '', 4, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_portfolio', 1, 0, '{\"catid\":[\"31\"],\"show_child_category_articles\":\"1\",\"levels\":\"1\",\"count\":\"6\",\"columns\":\"3\",\"show_filter\":\"1\",\"show_sort\":\"1\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h4\",\"limit_introtext\":\"0\",\"show_introtext\":\"1\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"show_modify_date\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(239, 785, 'Linear bars', '', '', 5, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_progress_bars', 1, 1, '{\"pretext\":\"\",\"choose_type\":\"0\",\"thickness\":\"60\",\"columns\":\"2\",\"items_data2\":\"{\\\"item_name\\\":[\\\"Name\\\"],\\\"item_value\\\":[\\\"30\\\"],\\\"item_color1\\\":[\\\"#eaeaea\\\"],\\\"item_color2\\\":[\\\"#eaeaea\\\"],\\\"item_color3\\\":[\\\"#f5f5f5\\\"]}\",\"items_data\":\"{\\\"item_name\\\":[\\\"HTML\\/CSS\\\",\\\"Java Script\\\",\\\"PHP\\\",\\\"UI\\/UX Design\\\"],\\\"item_value\\\":[\\\"70\\\",\\\"54\\\",\\\"87\\\",\\\"65\\\"],\\\"item_color\\\":[\\\"#abcc37\\\",\\\"#79ccf2\\\",\\\"#f5bf2f\\\",\\\"#f54b0f\\\"]}\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(240, 786, 'Radial bars', '', '', 6, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_progress_bars', 1, 1, '{\"pretext\":\"\",\"choose_type\":\"1\",\"thickness\":\"60\",\"columns\":\"4\",\"items_data2\":\"{\\\"item_name\\\":[\\\"HTML\\/CSS\\\",\\\"Java Script\\\",\\\"PHP\\\",\\\"UI\\/UX Design\\\"],\\\"item_value\\\":[\\\"30\\\",\\\"88\\\",\\\"44\\\",\\\"55\\\"],\\\"item_color1\\\":[\\\"#bd2828\\\",\\\"#2244a1\\\",\\\"#991313\\\",\\\"#22420d\\\"],\\\"item_color2\\\":[\\\"#1e7d77\\\",\\\"#8a1313\\\",\\\"#8c6e1c\\\",\\\"#cc29b1\\\"],\\\"item_color3\\\":[\\\"#f5f5f5\\\",\\\"#f5f5f5\\\",\\\"#f5f5f5\\\",\\\"#f5f5f5\\\"]}\",\"items_data\":\"{\\\"item_name\\\":[\\\"Name\\\"],\\\"item_value\\\":[\\\"30\\\"],\\\"item_color\\\":[\\\"#eaeaea\\\"]}\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(241, 787, 'Tags', '', '', 5, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tags_popular', 1, 1, '{\"maximum\":\"5\",\"timeframe\":\"alltime\",\"order_value\":\"count\",\"order_direction\":\"1\",\"display_count\":0,\"no_results_text\":\"0\",\"minsize\":1,\"maxsize\":2,\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(242, 788, 'Recent posts', '', '', 6, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"11\"],\"show_child_category_articles\":\"1\",\"levels\":\"10\",\"count\":\"5\",\"columns\":\"1\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h6\",\"show_introtext\":\"0\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"1\",\"createdby\":\"1\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"theme3589:recent-post\",\"masonry\":\"0\",\"moduleclass_sfx\":\"recent_posts\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(243, 789, 'Categories', '', '', 2, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{\"parent\":\"11\",\"show_description\":\"0\",\"numitems\":\"0\",\"show_children\":\"0\",\"count\":\"0\",\"maxlevel\":\"0\",\"layout\":\"_:default\",\"item_heading\":\"5\",\"moduleclass_sfx\":\" blog_categories\",\"owncache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(248, 794, 'Blog categories', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{\"parent\":\"11\",\"show_description\":\"0\",\"numitems\":\"0\",\"show_children\":\"0\",\"count\":\"0\",\"maxlevel\":\"0\",\"layout\":\"_:default\",\"item_heading\":\"5\",\"moduleclass_sfx\":\" blog_categories_megamenu\",\"owncache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(249, 795, 'Latest posts', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"11\"],\"show_child_category_articles\":\"1\",\"levels\":\"10\",\"count\":\"3\",\"columns\":\"1\",\"ordering\":\"a.publish_up\",\"article_ordering_direction\":\"DESC\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h6\",\"show_introtext\":\"0\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"left\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"theme3589:recent-post\",\"masonry\":\"0\",\"moduleclass_sfx\":\"latest_posts\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(251, 797, 'Latest works', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"31\"],\"show_child_category_articles\":\"1\",\"levels\":\"5\",\"count\":\"2\",\"columns\":\"2\",\"ordering\":\"a.publish_up\",\"article_ordering_direction\":\"DESC\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"1\",\"item_heading\":\"h4\",\"show_introtext\":\"0\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(252, 801, 'Login form megamenu', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_slogin', 1, 0, '{\"show_login_form\":1,\"slogin_link_profile\":\"0\",\"slogin_link_auch_edit\":\"1\",\"inittext\":\"\",\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"secretkey\":\"\",\"layout\":\"theme3589:megamenu\",\"moduleclass_sfx\":\"login_megamenu\",\"cache\":\"0\",\"load_css\":\"1\",\"load_js\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(253, 802, 'Social menu', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '2018-06-27 16:24:08', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{\"menutype\":\"social-media\",\"base\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"social-menu\",\"window_open\":\"\",\"layout\":\"theme3589:social\",\"moduleclass_sfx\":\"social-menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(268, 817, 'Counters', 'For \"Elements\" page', '', 8, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_counters', 1, 1, '{\"pretext\":\"\",\"columns\":\"4\",\"animation_speed\":\"6000\",\"items_data\":\"{\\\"item_name\\\":[\\\"COFFEE CUPS\\\",\\\"EXHIBITIONS\\\",\\\"ARTISTS\\\",\\\"VISITORS\\\"],\\\"item_value\\\":[\\\"358\\\",\\\"94\\\",\\\"156\\\",\\\"1245\\\"],\\\"item_symbol\\\":[\\\"\\\",\\\"\\\",\\\"\\\",\\\"\\\"],\\\"item_decimals\\\":[\\\"0\\\",\\\"0\\\",\\\"0\\\",\\\"0\\\"],\\\"item_icon_class\\\":[\\\"linearicons linearicons-coffee-cup\\\",\\\"linearicons linearicons-picture2\\\",\\\"linearicons linearicons-brush\\\",\\\"linearicons linearicons-users-plus\\\"]}\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(269, 818, 'Google map', '', '', 2, 'map', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_tm_google_map', 1, 0, '{\"pretext\":\"\",\"api_key\":\"AIzaSyAwH60q5rWrS8bXwpkZwZwhw9Bw0pqKTZM\",\"map_height\":\"400px\",\"map_zoom_level\":\"15\",\"marker-base\":\"images\\/gmap_marker.png\",\"marker-active\":\"images\\/gmap_marker_active.png\",\"items_data\":\"{\\\"item_x\\\":[\\\"-73.9874068\\\"],\\\"item_y\\\":[\\\"40.643180\\\"],\\\"item_label\\\":[\\\"2130 Fulton Street San Diego, CA 94117-1080 USA\\\"],\\\"item_image\\\":[\\\"\\\"]}\",\"map_styles\":\"[{\\\"featureType\\\":\\\"administrative.country\\\",\\\"elementType\\\":\\\"labels.text\\\",\\\"stylers\\\":[{\\\"visibility\\\":\\\"on\\\"}]}]\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(273, 822, 'Portfolio default', '', '', 4, 'position-6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_portfolio', 1, 1, '{\"catid\":[\"31\"],\"show_child_category_articles\":\"1\",\"levels\":\"1\",\"count\":\"6\",\"columns\":\"3\",\"show_filter\":\"1\",\"show_sort\":\"1\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h4\",\"limit_introtext\":\"0\",\"show_introtext\":\"1\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"show_modify_date\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(274, 823, 'Portfolio masonry', '', '', 4, 'position-6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_portfolio', 1, 1, '{\"catid\":[\"31\"],\"show_child_category_articles\":\"1\",\"levels\":\"1\",\"count\":\"6\",\"columns\":\"3\",\"show_filter\":\"1\",\"show_sort\":\"1\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h4\",\"limit_introtext\":\"0\",\"show_introtext\":\"1\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"show_modify_date\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"1\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(275, 825, 'Working time', '', '<p>Our support available to help you 24 hours a day, seven days a week.</p>\r\n<ul class=\"scheduled-time\">\r\n<li><i class=\"fa fa-clock-o\"></i> Mon–Fri: 08:00–18:00</li>\r\n<li><i class=\"fa fa-clock-o\"></i> Sat: 08:00–14:00</li>\r\n<li><i class=\"fa fa-clock-o\"></i> Sun: Closed</li>\r\n</ul>', 3, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"working-time\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(276, 827, 'Do You Have any Questions?', '', '', 4, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_single', 1, 0, '{\"article_id\":\"167\",\"item_heading\":\"h5\",\"item_title\":\"1\",\"link_titles\":\"0\",\"published_on\":\"0\",\"category_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"0\",\"mod_button\":\"1\",\"custom_link_title\":\"Contact us\",\"custom_link_route\":\"1\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"142\",\"pretext\":\"\",\"layout\":\"theme3589:questions\",\"moduleclass_sfx\":\"questions\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(277, 835, 'Partners', '', '', 1, 'content-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"73\"],\"show_child_category_articles\":\"1\",\"levels\":\"1\",\"count\":\"6\",\"columns\":\"1\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h4\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"theme3589:partners\",\"masonry\":\"0\",\"moduleclass_sfx\":\"partners\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(278, 843, 'Services prices', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"35\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"4\",\"columns\":\"4\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"0\",\"link_titles\":\"0\",\"item_heading\":\"h5\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"1\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"pricing_detailed\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(279, 844, 'Popular questions', '', '', 1, 'none', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 1, '{\"catid\":[\"27\"],\"count\":\"100\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h5\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*'),
(280, 845, 'Our services', '', '', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"74\"],\"show_child_category_articles\":\"1\",\"levels\":\"2\",\"count\":\"6\",\"columns\":\"3\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h4\",\"show_introtext\":\"1\",\"introtext_limit\":\"120\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"default-services\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h5\",\"header_class\":\"\",\"style\":\"theme3589-themeHtml5\"}', 0, '*');
INSERT INTO `#__modules` (`id`, `asset_id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(282, 847, 'Google map footer', '', '', 1, 'map', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tm_google_map', 1, 0, '{\"pretext\":\"\",\"api_key\":\"AIzaSyAwH60q5rWrS8bXwpkZwZwhw9Bw0pqKTZM\",\"map_height\":\"736px\",\"map_zoom_level\":\"15\",\"marker-base\":\"images\\/gmap_marker.png\",\"marker-active\":\"images\\/gmap_marker_active.png\",\"items_data\":\"{\\\"item_x\\\":[\\\"-73.9874068\\\"],\\\"item_y\\\":[\\\"40.643180\\\"],\\\"item_label\\\":[\\\"2130 Fulton Street San Diego, CA 94117-1080 USA\\\"],\\\"item_image\\\":[\\\"\\\"]}\",\"map_styles\":\"[\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"water\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#e9e9e9\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 17\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"landscape\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#f5f5f5\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 20\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"road.highway\\\",\\r\\n        \\\"elementType\\\": \\\"geometry.fill\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#ffffff\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 17\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"road.highway\\\",\\r\\n        \\\"elementType\\\": \\\"geometry.stroke\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#ffffff\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 29\\r\\n            },\\r\\n            {\\r\\n                \\\"weight\\\": 0.2\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"road.arterial\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#ffffff\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 18\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"road.local\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#ffffff\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 16\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"poi\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#f5f5f5\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 21\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"poi.park\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#dedede\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 21\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"elementType\\\": \\\"labels.text.stroke\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"visibility\\\": \\\"on\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"color\\\": \\\"#ffffff\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 16\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"elementType\\\": \\\"labels.text.fill\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"saturation\\\": 36\\r\\n            },\\r\\n            {\\r\\n                \\\"color\\\": \\\"#333333\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 40\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"elementType\\\": \\\"labels.icon\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"visibility\\\": \\\"off\\\"\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"transit\\\",\\r\\n        \\\"elementType\\\": \\\"geometry\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#f2f2f2\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 19\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"administrative\\\",\\r\\n        \\\"elementType\\\": \\\"geometry.fill\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#fefefe\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 20\\r\\n            }\\r\\n        ]\\r\\n    },\\r\\n    {\\r\\n        \\\"featureType\\\": \\\"administrative\\\",\\r\\n        \\\"elementType\\\": \\\"geometry.stroke\\\",\\r\\n        \\\"stylers\\\": [\\r\\n            {\\r\\n                \\\"color\\\": \\\"#fefefe\\\"\\r\\n            },\\r\\n            {\\r\\n                \\\"lightness\\\": 17\\r\\n            },\\r\\n            {\\r\\n                \\\"weight\\\": 1.2\\r\\n            }\\r\\n        ]\\r\\n    }\\r\\n]\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"map_footer\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(283, 848, 'Get in Touch', '', '<p><i class=\"linearicons linearicons-map-marker\"></i>WEST, LONDON MUSEUM</p>\r\n<p><i class=\"linearicons linearicons-telephone\"></i><a href=\"74951234567\">+7-495-1234567</a>, <a href=\"74951234568\">+7-495-1234568</a></p>\r\n<p><i class=\"linearicons linearicons-clock3\"></i><b>Monday to Friday:</b> 9.00 am to 8.00 pm EST</p>\r\n<p class=\"dat\"><b>Saturday:</b> 10.00 am to 6.00 pm EST</span>\r\n<p><i class=\"linearicons linearicons-envelope\"></i><a href=\"mailto:info@demolink.org\">info@demolink.org</a></p>\r\n{loadmodule mod_menu, Social menu}\r\n\r\n', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"address\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"11\",\"bootstrap_offset\":\"1\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(284, 849, 'Welcome img', '', '<img src=\"images/home/page1_img1.jpg\" alt=\"\"/>', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"wel_img\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"6\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(285, 851, 'Welcome to artesma', '', '', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_single', 1, 1, '{\"article_id\":\"180\",\"item_heading\":\"h1\",\"item_title\":\"1\",\"link_titles\":\"\",\"published_on\":\"0\",\"category_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"welcome\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"4\",\"bootstrap_offset\":\"1\",\"header_tag\":\"h6\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(286, 852, 'Exhibitions', '', '<p>We display, borrow and collect artworks from around the world.\r\nManages a permanent collection numbering over 6000 objects in total. The gallery is frequented by art lovers looking to find and buy original artwork.</p>', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"exhibitions\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"10\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(287, 853, 'Exhibitions gallery', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_owl_carousel', 1, 0, '{\"catid\":[\"70\",\"71\",\"72\"],\"image\":\"1\",\"item_title\":\"0\",\"link_titles\":\"\",\"published\":\"0\",\"item_heading\":\"h4\",\"show_tags\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"readmore\":\"0\",\"count\":\"6\",\"ordering\":\"a.publish_up\",\"direction\":\"0\",\"pretext\":\"\",\"layout\":\"theme3589:fancybox\",\"moduleclass_sfx\":\"home_gallery\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"items\":\"2\",\"autoplay\":\"1\",\"autoplay_speed\":\"5000\",\"scene_padding_0\":\"0\",\"items_padding_0\":\"30\",\"use_responsive\":\"1\",\"scene_padding_1200\":\"0\",\"items_padding_1200\":\"30\",\"scene_padding_992\":\"0\",\"items_padding_992\":\"30\",\"scene_padding_768\":\"0\",\"items_padding_768\":\"30\",\"scene_padding_480\":\"0\",\"items_padding_480\":\"30\",\"navigation\":\"1\",\"pagination\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"8\",\"bootstrap_offset\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(288, 855, 'Home services 1', '', '', 1, 'position-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"75\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"3\",\"columns\":\"3\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h2\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"home_serv_1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(289, 860, 'exhibitions', '', '', 1, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_single', 1, 0, '{\"article_id\":\"184\",\"item_heading\":\"h6\",\"item_title\":\"1\",\"link_titles\":\"\",\"published_on\":\"0\",\"category_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"layout\":\"theme3589:title-in\",\"moduleclass_sfx\":\"exhibitions\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h6\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(290, 861, 'our blog', '', '<h1>Events & Programs</h1>', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"our_blog center\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h6\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(291, 862, 'Home Blog', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"49\"],\"show_child_category_articles\":\"1\",\"levels\":\"2\",\"count\":\"3\",\"columns\":\"3\",\"ordering\":\"a.ordering\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h2\",\"show_introtext\":\"1\",\"introtext_limit\":\"200\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"1\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"theme3589:blog\",\"masonry\":\"0\",\"moduleclass_sfx\":\"home_blog\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(292, 867, 'who we are', '', '', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_single', 1, 1, '{\"article_id\":\"187\",\"item_heading\":\"h1\",\"item_title\":\"1\",\"link_titles\":\"\",\"published_on\":\"0\",\"category_on\":\"0\",\"show_intro_image\":\"1\",\"readmore\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"layout\":\"theme3589:title-in\",\"moduleclass_sfx\":\"we_are\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h6\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(293, 870, 'About services', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 0, '{\"catid\":[\"76\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"4\",\"columns\":\"2\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"\",\"item_heading\":\"h2\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"theme3589:custom\",\"masonry\":\"0\",\"moduleclass_sfx\":\"about_services1\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"9\",\"bootstrap_offset\":\"3\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(294, 875, 'meet the Team', '', '', 1, 'position-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"center meet\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h6\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(295, 876, 'Our Artists', '', '', 1, 'position-3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news_adv', 1, 1, '{\"catid\":[\"26\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"count\":\"4\",\"columns\":\"4\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"578\",\"pretext\":\"\",\"item_title\":\"1\",\"link_titles\":\"1\",\"item_heading\":\"h2\",\"show_introtext\":\"1\",\"introtext_limit\":\"0\",\"show_tags\":\"0\",\"show_category\":\"0\",\"show_hits\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"1\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"masonry\":\"0\",\"moduleclass_sfx\":\"team\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"12\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h1\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(296, 877, 'what people say', '', '', 1, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_owl_carousel', 1, 1, '{\"catid\":[\"28\"],\"image\":\"0\",\"item_title\":\"0\",\"link_titles\":\"\",\"published\":\"0\",\"item_heading\":\"h4\",\"show_tags\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"readmore\":\"0\",\"count\":\"5\",\"ordering\":\"a.publish_up\",\"direction\":\"1\",\"pretext\":\"Testimonials\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"people_say\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"items\":\"1\",\"autoplay\":\"1\",\"autoplay_speed\":\"5000\",\"scene_padding_0\":\"50\",\"items_padding_0\":\"50\",\"use_responsive\":\"1\",\"scene_padding_1200\":\"50\",\"items_padding_1200\":\"50\",\"scene_padding_992\":\"50\",\"items_padding_992\":\"50\",\"scene_padding_768\":\"50\",\"items_padding_768\":\"50\",\"scene_padding_480\":\"50\",\"items_padding_480\":\"50\",\"navigation\":\"1\",\"pagination\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"8\",\"bootstrap_offset\":\"2\",\"header_tag\":\"h6\",\"header_class\":\"center\",\"style\":\"0\"}', 0, '*'),
(297, 878, 'Questions img', '', '<img src=\"images/about/page2_img2.jpg\" alt=\"\"/>', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{\"prepare_content\":\"0\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"q_img\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"5\",\"bootstrap_offset\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*'),
(298, 879, 'FAQ', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_bootstrap_collapse', 1, 1, '{\"catid\":[\"18\"],\"count\":\"3\",\"ordering\":\"a.ordering\",\"collapsed\":\"1\",\"mod_button\":\"0\",\"custom_link_title\":\"\",\"custom_link_route\":\"0\",\"custom_link_url\":\"http:\\/\\/\",\"custom_link_menu\":\"124\",\"pretext\":\"Popular Questions\",\"show_tags\":\"0\",\"published\":\"0\",\"createdby\":\"0\",\"intro_image\":\"0\",\"intro_image_align\":\"none\",\"image\":\"0\",\"readmore\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"custom faq\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"6\",\"bootstrap_offset\":\"1\",\"header_tag\":\"h6\",\"header_class\":\"\",\"style\":\"0\"}', 0, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(79, 0),
(86, 0),
(94, 0),
(103, 0),
(104, 0),
(115, 142),
(118, 336),
(122, 336),
(126, 0),
(127, 0),
(128, 0),
(129, 0),
(130, 0),
(131, 0),
(145, 426),
(159, 0),
(160, 343),
(161, 0),
(162, 0),
(163, 0),
(164, 0),
(165, 0),
(166, 305),
(167, 305),
(168, 305),
(169, 305),
(170, -101),
(171, 136),
(173, 138),
(183, 426),
(184, 426),
(189, 426),
(190, 426),
(192, 426),
(195, 0),
(234, 426),
(235, 0),
(238, 283),
(239, 426),
(240, 426),
(241, 611),
(242, 611),
(243, 611),
(249, 0),
(251, 0),
(252, 0),
(253, 0),
(268, 426),
(269, 142),
(275, 136),
(275, 746),
(275, 747),
(276, 136),
(276, 746),
(276, 747),
(277, 746),
(278, 0),
(279, 0),
(280, 749),
(282, 0),
(283, 0),
(284, 101),
(285, 101),
(286, 101),
(287, 101),
(288, 101),
(289, 101),
(290, 101),
(291, 101),
(292, 584),
(293, 584),
(294, 584),
(295, 584),
(296, 584),
(297, 584),
(298, 584);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `link` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `cache_time` int(10) UNSIGNED NOT NULL DEFAULT '3600',
  `checked_out` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadata` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `xreference` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `images` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE IF NOT EXISTS `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `string` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `file` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7072 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(1, 'SEND_DATE', 'Send Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(2, 'ACTIVATED', 'Activated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(3, 'AFFECTED', 'Attached', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(4, 'PROCESS_CONFIRMATION', 'Are you sure you want to proceed?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(5, 'ERROR_SAVING', 'Error Saving', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(6, 'JOOMEXT_SUCC_SAVED', 'Successfully Saved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(7, 'SUCC_DELETE_ELEMENTS', 'Successfully deleted %s record(s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(8, 'CONTACT', 'Please Contact us at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(9, 'SUCC_MOVED', 'Successfully Moved Element', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(10, 'ERROR_ORDERING', 'Error Ordering Elements', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(11, 'PUBLISH_CLICK', 'Click here to Publish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(12, 'UNPUBLISH_CLICK', 'Click here to Unpublish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(13, 'UNSCHEDULE_CLICK', 'Click here to Unschedule', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(14, 'SUBSCRIBE_CLICK', 'Click here to Subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(15, 'UNSUBSCRIBE_CLICK', 'Click here to Unsubscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(16, 'CONFIRMATION_CLICK', 'Click here to Confirm the Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(17, 'ENTER_SUBJECT', 'Please enter a Subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(18, 'CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(19, 'RECEIVE_HTML', 'Receive HTML', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(20, 'JOOMEXT_YES', 'Yes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(21, 'JOOMEXT_NO', 'No', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(22, 'JOOMEXT_FILTER', 'Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(23, 'JOOMEXT_GO', 'Go', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(24, 'JOOMEXT_RESET', 'Reset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(25, 'ACY_CPANEL', 'Dashboard', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(26, 'NAMECAPTION', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(27, 'EMAILCAPTION', 'E-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(28, 'SUBSCRIBECAPTION', 'Subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(29, 'UNSUBSCRIBECAPTION', 'Unsubscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(30, 'ALREADY_CONFIRMED', 'You have already confirmed your subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(31, 'SUBSCRIPTION_CONFIRMED', 'Your subscription has been confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(32, 'JOOMEXT_SUBJECT', 'Subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(33, 'MAILING_LISTS', 'Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(34, 'CONFIRMATION_SENT', 'A confirmation e-mail has been sent, please click on the confirmation link in order to confirm your subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(35, 'SUBSCRIPTION_OK', 'You have successfully subscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(36, 'UNSUBSCRIPTION_OK', 'You have successfully unsubscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(37, 'UNSUBSCRIPTION_NOT_IN_LIST', 'You were not subscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(38, 'SUBSCRIPTION_UPDATED_OK', 'Subscription successfully updated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(39, 'ALREADY_SUBSCRIBED', 'You are already subscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(40, 'NOT_IN_LIST', 'The e-mail address %s is not in the list of users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(41, 'SCHEDULE', 'Schedule', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(42, 'UNSCHEDULE', 'Unschedule', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(43, 'SUCC_UNSCHED', 'Newsletter unscheduled Successfully', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(44, 'SPECIFY_DATE', 'Please specify a date to schedule your Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(45, 'DATE_FUTURE', 'Please specify a date in the future', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(46, 'AUTOSEND_DATE', 'The Newsletter %s will be automatically sent at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(47, 'NB_SCHED_NEWS', '%s Newsletters scheduled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(48, 'NO_SCHED', 'No Scheduled Newsletter needed to be generated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(49, 'SCHED_NEWS', 'The Newsletter is scheduled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(50, 'SCHEDULE_NEWS', 'Scheduled Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(51, 'SEND_CONTINUE', 'Do you want to continue the send process?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(52, 'CONTINUE', 'Continue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(53, 'SENT_BY', 'Sent by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(54, 'WRITABLE_FOLDER', 'Please make sure the folder ( %s ) is writeable', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(55, 'ACCEPTED_TYPE', 'This file type ( %s ) is not accepted, the accepted file types are : %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(56, 'FAIL_UPLOAD', 'Could not upload the file %s to %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(57, 'FAIL_SAVE', 'Could not save the file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(58, 'BROWSE_FILE', 'Please browse for a file to import', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(59, 'FAIL_OPEN', 'Could not open the file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(60, 'ADD_ATTACHMENT', 'Attach a new file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(61, 'MAX_UPLOAD', '( total max upload file size : %s )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(62, 'ALLOWED_FILES', 'Allowed files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(63, 'UPLOAD_FOLDER', 'Upload folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(64, 'VALID_EMAIL', 'Please enter a valid e-mail address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(65, 'ONLY_LOGGED', 'The subscription is restricted to logged in users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(66, 'ASK_LOG', 'Please log in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(67, 'INVALID_KEY', 'Key/User not found, please contact the Administrator of this website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(68, 'NOT_VALID_EMAIL', 'The e-mail address %s is not valid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(69, 'NAME_MISSING', 'Please enter your name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(70, 'AUTONEWSLETTERS', 'Auto-Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(71, 'AUTONEW', 'Auto-Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(72, 'NO_AUTONEWSLETTERS', 'No Auto-Newsletter needed to be generated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(73, 'NEWSLETTER_GENERATED', 'Newsletter Generated [%s] : %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(74, 'NEWSLETTER_NOT_GENERATED', 'Auto-Newsletter [%s] not generated : %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(75, 'AUTONEWS_SEND', 'Send the generated Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(76, 'AUTONEWS_WAIT', 'Wait for the confirmation before sending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(77, 'GENERATE', 'Generate', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(78, 'AUTONEWS_NOT_PUBLISHED', 'The Auto-Newsletter %s is not published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(79, 'AUTONEWS_NOT_READY', 'The next generate date of the Auto-Newsletter %s has not been reached', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(80, 'EMPTY_LOG', 'The log file is empty', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(81, 'SUCC_DELETE_LOG', 'Log file successfully deleted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(82, 'ERROR_DELETE_LOG', 'Could not delete the Log file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(83, 'EXIST_LOG', 'Log file does not exists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(84, 'THANK_YOU_SHARING', 'Thank you for your contribution', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(85, 'ALLOW_VISITOR', 'Allow non-logged in users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(86, 'REQUIRE_CONFIRM', 'Require Confirmation (double opt-in)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(87, 'MESSAGES', 'Messages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(88, 'DISPLAY_MSG_SUBSCRIPTION', 'Display a message on subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(89, 'DISPLAY_MSG_CONFIRM', 'Display a message on confirmation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(90, 'DISPLAY_MSG_WELCOME', 'Display a message when sending the welcome e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(91, 'DISPLAY_MSG_UNSUB', 'Display a message when sending the unsubscribe e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(92, 'NOTIFICATIONS', 'Notifications', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(93, 'NOTIF_CREATE', 'When a new user is created, send an e-mail to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(94, 'NOTIF_REFUSE', 'When a user refuses to receive e-mails, send an e-mail to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(95, 'NOTIF_UNSUBALL', 'When a user unsubscribes from all Lists, send an e-mail to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(96, 'REDIRECTIONS', 'Redirections', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(97, 'REDIRECTION_CONFIRM', 'Redirection after Confirmation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(98, 'REDIRECTION_UNSUB', 'Redirection after Unsubscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(99, 'JOOMEXT_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(100, 'JOOMEXT_EMAIL', 'E-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(101, 'USERS', 'Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(102, 'NO_SUBSCRIBER', 'No subscriber found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(103, 'NO_RECEIVER', 'No receiver found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(104, 'USER_INFORMATIONS', 'User Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(105, 'IP', 'IP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(106, 'USER_ID', 'User ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(107, 'VISITOR', 'Visitor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(108, 'ACY_GROUP', 'Group', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(109, 'EDIT_JOOMLA_USER', 'Edit User Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(110, 'QUEUE', 'Queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(111, 'CONFIRM_DELETE_QUEUE', 'Are you sure you want to delete those %s records?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(112, 'PRIORITY', 'Priority', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(113, 'NEWS_PRIORITY', 'Newsletter priority', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(114, 'FOLLOW_PRIORITY', 'Follow-up priority', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(115, 'TRY', 'Try', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(116, 'ADDED_QUEUE', '%s e-mails have been added to the queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(117, 'AUTOSEND_CONFIRMATION', 'The system will send them automatically as soon as possible', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(118, 'ALREADY_QUEUED', 'There are already %s e-mails in the queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(119, 'DELETE_QUEUE', 'Please delete those e-mails before scheduling your Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(120, 'QUEUE_NEXT_TRY', 'Next try in %s minutes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(121, 'QUEUE_DOUBLE', 'Send process running in parallel detected, the system stopped but you will be able to resume it', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(122, 'ADDED_QUEUE_SCHEDULE', '%s emails have been added to the queue for the Scheduled Newsletter [ID %s] %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(123, 'QUEUE_READY', 'The following e-mails are ready to be sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(124, 'EMAIL_READY', '[ID %s] %s to %s users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(125, 'QUEUE_SCHED', '[ID %s] %s will be sent after %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(126, 'QUEUE_STATUS', 'Queue status at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(127, 'QUEUE_NEXT_SCHEDULE', 'The next e-mail will be sent after %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(128, 'PROCESS', 'Process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(129, 'NO_PROCESS', 'There is nothing to send', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(130, 'NB_PENDING_EMAIL', 'There are %s e-mails in the queue for the Newsletter %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(131, 'ACY_CRON_TRIGGERED', 'AcyMailing Triggered at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(132, 'CRON_NEXT', 'The system won\'t be triggered before %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(133, 'ACY_CRON_PROCESS', '%s messages processed : %s successful, %s failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(134, 'CREATE_CRON', 'Create/Edit your Cron task', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(135, 'UNSUB_CURRENT', 'Unsubscribe from this Mailing List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(136, 'UNSUB_ALL', 'Unsubscribe from all Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(137, 'UNSUB_FULL', 'Do not receive any e-mails from this website in the future', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(138, 'CONFIRM_UNSUB_FULL', 'You won\'t receive any e-mails from this website in the future', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(139, 'CONFIRM_UNSUB_ALL', 'You have been unsubscribed from all Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(140, 'CONFIRM_UNSUB_CURRENT', 'You have been unsubscribed from the Mailing List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(141, 'ERROR_NOT_SUBSCRIBED', 'You were not subscribed to any Mailing List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(142, 'ERROR_NOT_SUBSCRIBED_CURRENT', 'You were not subscribed to the selected Mailing List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(143, 'ACCEPT_TERMS', 'Please check the Terms and Conditions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(144, 'JOOMEXT_TERMS', 'Terms and Conditions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(145, 'UNSUBSCRIBE', 'Unsubscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(146, 'UNSUBSCRIBED', 'Unsubscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(147, 'NO_SUBSCRIPTION', 'No Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(148, 'PENDING_SUBSCRIPTION', 'Wait Confirmation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(149, 'SUBSCRIBED', 'Subscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(150, 'ALL_STATUS', 'All Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(151, 'ACCEPT_REFUSE', 'Accept / Refuse', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(152, 'ACCEPT_EMAIL', 'Accept E-Mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(153, 'REFUSE_EMAIL', 'Refuse E-Mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(154, 'SUBSCRIPTION', 'Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(155, 'ENABLED_DISABLED', 'Enabled / Disabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(156, 'ENABLED', 'Enabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(157, 'DISABLED', 'Disabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(158, 'UNSUBSCRIBERS', 'Unsubscribers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(159, 'SUBSCRIBERS', 'Subscribers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(160, 'SUBSCRIBE_ALL', 'Subscribe to all', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(161, 'SUBSCRIBE', 'Subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(162, 'REMOVE', 'Remove', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(163, 'CONFIRMED', 'Confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(164, 'STATUS', 'Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(165, 'SUBSCRIPTION_DATE', 'Subscription Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(166, 'UNSUBSCRIPTION_DATE', 'Unsubscription Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(167, 'USER_REFUSE', 'This user refuses to receive future messages from your website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(168, 'SAVE_CHANGES', 'Save Changes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(169, 'SEND_EMPTY', 'There is no Subject or Body in this e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(170, 'SEND_ERROR', 'Error Sending Message %s to %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(171, 'SEND_SUCCESS', 'Message %s successfully sent to %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(172, 'SEND_ERROR_PUBLISHED', 'The e-mail ID %s is not published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(173, 'SEND_ERROR_USER', 'User not found : %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(174, 'SEND_ERROR_CONFIRMED', 'The User %s is not confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(175, 'SEND_ERROR_APPROVED', 'The User %s is not enabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(176, 'SEND_ERROR_ACCEPT', 'The User %s does not accept e-mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(177, 'SEND_PROCESS', 'Send Process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(178, 'SEND_REFRESH_TIMEOUT', 'Process refreshed to avoid a time limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(179, 'SEND_REFRESH_CONNECTION', 'Process refreshed to avoid a possible loss of connection', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(180, 'SEND_STOPED', 'The Send Process stopped because there are too many errors', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(181, 'SEND_KEPT_ALL', 'The system kept all non delivered e-mails in the queue, so you will be able to resume the send process later', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(182, 'SEND_CHECKONE', 'Please verify your mail configuration and make sure you can send a test of this e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(183, 'SEND_ADVISE_LIMITATION', 'If you recently, successfully, sent a lot of e-mails, those errors may also be due to your server limitations', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(184, 'SEND_REFUSE', 'Your server apparently refuses to send more e-mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(185, 'SEND_CONTINUE_COMMERCIAL', 'Using one of our commercial versions, the system would be able to continue automatically the send process using a Cron', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(186, 'SEND_CONTINUE_AUTO', 'If you configured a cron task, the system will automatically continue the send process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(187, 'TITLE_ONLY', 'Title Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(188, 'INTRO_ONLY', 'Intro Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(189, 'FULL_TEXT', 'Full text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(190, 'ACY_EACH_TIME', 'Each time AcyMailing is triggered', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(191, 'ACY_ONLY_ACTION', 'Only if AcyMailing executes an action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(192, 'SIMPLIFIED_REPORT', 'Simplified Report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(193, 'DETAILED_REPORT', 'Detailed Report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(194, 'ALL_EMAILS', 'All E-mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(195, 'FILTER_SELECT', 'Select a filter type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(196, 'ACYMAILING_LIST', 'AcyMailing List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(197, 'ACYMAILING_FIELD', 'AcyMailing Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(198, 'JOOMLA_FIELD', 'Joomla User Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(199, 'CB_FIELD', 'Community Builder Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(200, 'ALL_CREATORS', 'All Creators', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(201, 'ALL_LISTS', 'All lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(202, 'ALL_USERS', 'All Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(203, 'AUTO_ONLY', 'Automatic Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(204, 'AUTO_MAN', 'Automatic / Manual', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(205, 'MANUAL_ONLY', 'Manual Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(206, 'OTHER', 'Other', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(207, 'MANAGER', 'Manager', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(208, 'ADMINISTRATOR', 'Administrator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(209, 'SUPER_ADMIN', 'Super Administrator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(210, 'NO_UNSUB_MESSAGE', 'No unsubscribe message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(211, 'NO_WELCOME_MESSAGE', 'No welcome message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(212, 'EDIT_EMAIL', 'Edit the e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(213, 'CREATE_EMAIL', 'Create a new e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(214, 'ALL_URLS', 'All URLs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(215, 'HTML_VERSION', 'HTML Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(216, 'TEXT_VERSION', 'Text Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(217, 'INFOS', 'Infos', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(218, 'HOURS', 'Hours', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(219, 'DAYS', 'Days', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(220, 'WEEKS', 'Weeks', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(221, 'MONTHS', 'Months', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(222, 'NB_SUB_UNSUB', 'Number of subscribers/unsubscribers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(223, 'SUB_HISTORY', 'Subscription History', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(224, 'STATISTICS', 'Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(225, 'GLOBAL_STATISTICS', 'Global Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(226, 'DETAILED_STATISTICS', 'Detailed Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(227, 'OPEN', 'E-mail Opens', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(228, 'OPEN_UNIQUE', 'Unique Opens', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(229, 'OPEN_TOTAL', 'Total Opens', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(230, 'NOT_OPEN', 'Not Opened', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(231, 'OPEN_DATE', 'Open Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(232, 'PERCENT_OPEN', '%s of HTML e-mails have been opened', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(233, 'SENT_HTML', 'Sent in HTML', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(234, 'SENT_TEXT', 'Sent in Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(235, 'FAILED', 'Failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(236, 'CHARTS', 'Charts', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(237, 'RECEIVED_VERSION', 'Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(238, 'URL', 'URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(239, 'URL_NAME', 'URL Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(240, 'URL_EDIT', 'Edit the URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(241, 'UNIQUE_HITS', 'Unique Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(242, 'TOTAL_HITS', 'Total Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(243, 'CLICK_STATISTICS', 'Click Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(244, 'CLICKED_LINK', 'Clicked a link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(245, 'PERCENT_CLICK', '%s of users clicked on a link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(246, 'TOTAL_EMAIL_SENT', '%s e-mails sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(247, 'FORWARDED', 'Forwarded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(248, 'EMAIL_NAME', 'E-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(249, 'SEND_HTML', 'Send HTML Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(250, 'NEXT_GENERATE', 'Next Generate Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(251, 'GENERATE_FREQUENCY', 'Generate Frequency', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(252, 'FREQUENCY', 'Frequency', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(253, 'ISSUE_NB', 'Issue Number', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(254, 'GENERATE_MODE', 'Generating mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(255, 'NOTIFICATION_TO', 'Send notification to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(256, 'EVERY', 'Every', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(257, 'CREATOR', 'Creator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(258, 'ATTACHMENTS', 'Attachments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(259, 'ATTACHED_FILES', 'Attached Files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(260, 'NEWSLETTERS', 'Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(261, 'NEWSLETTER', 'Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(262, 'JOOMEXT_VISIBLE', 'Visible', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(263, 'JOOMEXT_ALIAS', 'Alias', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(264, 'TEMPLATE_NAME', 'Template Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(265, 'ACY_TEMPLATE', 'Template', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(266, 'BACKGROUND_COLOUR', 'Background Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(267, 'FOLLOWUP', 'Follow up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(268, 'CAMPAIGN', 'Campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(269, 'DELAY', 'Delay', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(270, 'FOLLOWUP_ADD', 'Add a new follow-up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(271, 'CAMPAIGN_START', 'When a user subscribes to one of the following lists, this user will start receiving the campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(272, 'NUM_FOLLOWUP_CAMPAIGN', 'There are %s follow-ups in this Campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(273, 'SENDER_INFORMATIONS', 'Sender Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(274, 'FROM_NAME', 'From Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(275, 'FROM_ADDRESS', 'From Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(276, 'REPLYTO_NAME', 'Reply-to Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(277, 'REPLYTO_ADDRESS', 'Reply-to Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(278, 'BOUNCE_ADDRESS', 'Bounce Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(279, 'LIST', 'List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(280, 'LISTS', 'Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(281, 'LIST_NAME', 'List Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(282, 'RECEIVE', 'Receive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(283, 'LIST_CREATE', 'Please create a list first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(284, 'LIST_RECEIVERS', 'The Newsletter will be sent to the following selected lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(285, 'NEWSLETTER_SENT_TO', 'This Newsletter will be sent to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(286, 'LIST_PUBLISH', 'Please enable this list first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(287, 'EMAIL_AFFECT', 'Please assign this Email to one or several enabled lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(288, 'COLOUR', 'Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(289, 'MSG_UNSUB', 'Unsubscribe Message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(290, 'MSG_WELCOME', 'Welcome Message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(291, 'NB_PENDING', 'Number of pending users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(292, 'SUB_USERS', 'Subscribe Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(293, 'ACCESS_LEVEL', 'Access Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(294, 'ACCESS_LEVEL_SUB', 'View/Subscription Access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(295, 'ACCESS_LEVEL_MANAGE', 'Front-End Management', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(296, 'SEND_TEST', 'Send a test', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(297, 'SEND_TEST_TO', 'Send a test to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(298, 'EMAIL_ADDRESS', 'Email Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(299, 'SEND_VERSION', 'Send Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(300, 'HTML', 'HTML', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(301, 'JOOMEXT_TEXT', 'Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(302, 'SEND', 'Send', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(303, 'CRON', 'Cron', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(304, 'NEXT_RUN', 'Next Run time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(305, 'CRON_URL', 'Cron URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(306, 'REPORT', 'Report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(307, 'REPORT_SEND', 'Send a report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(308, 'REPORT_SEND_TO', 'Send the report to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(309, 'REPORT_SAVE', 'Save the report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(310, 'REPORT_SAVE_TO', 'Save the report to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(311, 'REPORT_DELETE', 'Delete the report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(312, 'REPORT_SEE', 'See the report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(313, 'REPORT_EDIT', 'Edit Report Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(314, 'LAST_CRON', 'Last Cron', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(315, 'LAST_RUN', 'Last Run time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(316, 'CRON_TRIGGERED_IP', 'Triggered from the IP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(317, 'MAIL_CONFIG', 'Mail Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(318, 'QUEUE_PROCESS', 'Queue process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(319, 'PLUGINS', 'Plugins', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(320, 'LANGUAGES', 'Languages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(321, 'MAILER_METHOD', 'Mailer Method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(322, 'ENCODING_FORMAT', 'Encoding Format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(323, 'CHARSET', 'Charset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(324, 'WORD_WRAPPING', 'Word Wrapping', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(325, 'HOSTNAME', 'Hostname', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(326, 'EMBED_IMAGES', 'Embed Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(327, 'EMBED_ATTACHMENTS', 'Embed Attachments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(328, 'MULTIPLE_PART', 'Send Multiple Part', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(329, 'SENDMAIL_PATH', 'SendMail Path', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(330, 'SMTP_CONFIG', 'SMTP Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(331, 'SMTP_SERVER', 'Server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(332, 'SMTP_PORT', 'Port', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(333, 'SMTP_SECURE', 'Secure Method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(334, 'SMTP_ALIVE', 'Keep Alive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(335, 'SMTP_AUTHENT', 'Authentication', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(336, 'SMTP_PASSWORD', 'Password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(337, 'MAX_NB_TRY', 'Maximum number of tries', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(338, 'QUEUE_PROCESSING', 'Queue Processing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(339, 'EDIT_CONF_MAIL', 'Edit Confirmation Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(340, 'EDIT_NOTIFICATION_MAIL', 'Edit Notification Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(341, 'EDIT_LANGUAGE_FILE', 'Edit the language File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(342, 'ADD_LANGUAGE_FILE', 'Add the language File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(343, 'CONFIGURATION', 'Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(344, 'SHARE', 'Share', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(345, 'SHARE_CONFIRMATION_1', 'This Language File will be sent to the Acyba translation team and may be included in the next version.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(346, 'SHARE_CONFIRMATION_2', 'By sharing this file, you allow Acyba to use your work for any purpose.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(347, 'SHARE_CONFIRMATION_3', 'You can add a personal message in the following area which will be included in the e-mail sent to the team.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(348, 'LOAD_ENGLISH_1', 'AcyMailing is actually not translated in this language.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(349, 'LOAD_ENGLISH_2', 'The English version will be loaded so that you can translate it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(350, 'LOAD_ENGLISH_3', 'Once you are done, don\'t forget to share your translation with the rest of the community!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(351, 'LOAD_LATEST_LANGUAGE', 'Load the latest version from our server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(352, 'INTERFACE', 'Interfaces', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(353, 'SHOW_FOOTER', 'Display the brand', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(354, 'FOOTER', 'Footer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(355, 'MENU', 'Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(356, 'ACYMAILING_MENU', 'Menu Linked to AcyMailing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(357, 'PLUG_INTE', 'Integrations with AcyMailing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(358, 'PLUG_TAG', 'Plugins for the tag system', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(359, 'FORWARD_FEATURE', 'Enable the Forward to a friend', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(360, 'FEATURES', 'Features', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(361, 'ADD_NAMES', 'Add Names', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(362, 'TEST_EMAIL', 'If you receive this message, that means your configuration is Ok', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(363, 'USE_SEF', 'Use SEF Urls', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(364, 'CSS_MODULE_DESC', 'Select the css file you want to load for the front-end Module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(365, 'CSS_FRONTEND_DESC', 'Select the css file you want to load for the front-end Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(366, 'CSS_BACKEND_DESC', 'Select the css file you want to load for the back-end', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(367, 'CSS_MODULE', 'Module CSS File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(368, 'CSS_FRONTEND', 'Component Front-end CSS File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(369, 'CSS_BACKEND', 'Back-end CSS File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(370, 'USE_SEF_DESC', 'You have the possibility to add SEF Urls in the Newsletter itself or keep normal URLs.<br />This option will only apply to e-mails sent from the front-end.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(371, 'ADD_NAMES_DESC', 'Add the Name of the user in the header of the e-mail.<br />Some Mail Servers don\'t accept names, in that case you have to disable this option.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(372, 'FROM_NAME_DESC', 'Default From Name used in all your Newsletters.<br />You can override this property for each Newsletter you write', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(373, 'FROM_ADDRESS_DESC', 'Default E-mail address used as <b><i>from</i></b> in all your Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(374, 'REPLYTO_NAME_DESC', 'Default <b><i>Reply To</i></b> Name used in all your Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(375, 'REPLYTO_ADDRESS_DESC', 'Default E-mail address used as <b><i>reply-to</i></b> in all your Newsletters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(376, 'BOUNCE_ADDRESS_DESC', 'This e-mail address will receive all the automatic responses from your receivers.<br />If you don\'t know what this field is, please leave it empty as this field can block your send process if it\'s not configured properly.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(377, 'MAILER_METHOD_DESC', 'Mailer method used to send your e-mails.<br />We recommend the <b><i>PHP Mail Function</i></b>.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(378, 'ENCODING_FORMAT_DESC', 'Encoding format used for all your Newsletters.<br />We recommend <b><i>8-Bit</i></b>.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(379, 'CHARSET_DESC', 'Charset used for all your Newsletters.<br />We recommend <b><i>UTF-8</i></b>.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(380, 'WORD_WRAPPING_DESC', 'Some servers don\'t allow you to send e-mails with more than xx characters per line.<br />This parameter enables you to set this limitation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(381, 'HOSTNAME_DESC', 'Sets the host name to use in Message-Id and Received headers and as default HELO string.<br />Leave this field empty if you don\'t know what is it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(382, 'EMBED_IMAGES_DESC', 'Should AcyMailing embed your pictures inside the Newsletter?<br />If so, the send process will take more time but the recipient won\'t have to download the picture from your website.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(383, 'EMBED_ATTACHMENTS_DESC', 'Should AcyMailing embed your attachments inside the Newsletter?<br />If not, AcyMailing will add a list of attachments with links to your website in order to download them.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(384, 'MULTIPLE_PART_DESC', 'Should AcyMailing send multiple part e-mails?<br />If so, AcyMailing will send the text and the html version in the e-mail so that depending on the recipient, the appropriate version will be opened.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(385, 'SENDMAIL_PATH_DESC', 'Path used to call the SendMail function.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(386, 'SMTP_SERVER_DESC', 'SMTP Server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(387, 'SMTP_PORT_DESC', 'SMTP Port', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(388, 'SMTP_SECURE_DESC', 'Should AcyMailing use an SMTP Secure Connection?<br />For GMail, you should select SSL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(389, 'SMTP_ALIVE_DESC', 'Should AcyMailing keep your SMTP Connection opened during the send Process?<br />We recommend to turn ON this option.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(390, 'SMTP_AUTHENT_DESC', 'If you need a username and a password to connect to your SMTP Server, please turn ON this option.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(391, 'USERNAME_DESC', 'Username used to connect to your SMTP Server.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(392, 'SMTP_PASSWORD_DESC', 'Password used to connect to your SMTP Server.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(393, 'CRON_URL_DESC', 'Cron URL to trigger AcyMailing.<br />You should enter this URL to create your cron task.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(394, 'REPORT_SEND_DESC', 'When should AcyMailing send a report?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(395, 'REPORT_SAVE_DESC', 'Which report should AcyMailing save in the log file?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(396, 'REPORT_SEND_TO_DESC', 'You can enter one or several e-mail addresses so that AcyMailing will send the report to those users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(397, 'REPORT_SAVE_TO_DESC', 'Location of the log file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(398, 'LAST_RUN_DESC', 'Last time AcyMailing executed actions via the cron URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(399, 'CRON_TRIGGERED_IP_DESC', 'AcyMailing has been triggered by the following IP.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(400, 'REPORT_DESC', 'Latest report generated by AcyMailing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(401, 'ALLOWED_FILES_DESC', 'List of allowed file extensions for the attachments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(402, 'UPLOAD_FOLDER_DESC', 'Folder in which the attachments will be uploaded.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(403, 'DISPLAY_MSG_SUBSCRIPTION_DESC', 'Should AcyMailing display a confirmation message when the user subscribes to your website?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(404, 'DISPLAY_MSG_CONFIRM_DESC', 'Should AcyMailing display a confirmation message when the user confirms their subscription?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(405, 'DISPLAY_MSG_WELCOME_DESC', 'Should AcyMailing display a confirmation message when AcyMailing sends a welcome e-mail?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(406, 'DISPLAY_MSG_UNSUB_DESC', 'Should AcyMailing display a confirmation message when AcyMailing sends an unsubscribe e-mail?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(407, 'ACYMAILING_MENU_DESC', 'Select the Menu you want to link to AcyMailing.<br />Users having problems with access levels should select a menu which is accessible to non-registered users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(408, 'EDITOR_DESC', 'Select the editor you want to use when editing your AcyMailing E-mails.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(409, 'SHOW_FOOTER_DESC', 'Display the AcyMailing footer on each page?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(410, 'MAX_NB_TRY_DESC', 'If AcyMailing can not send the e-mail after X tries, AcyMailing will delete the e-mail from the queue.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(411, 'QUEUE_PROCESSING_DESC', 'If you use the <b><i>automatic only</i></b> method, AcyMailing will always use the automatic process and won\'t even start the manual send process if you send an e-mail from the back-end.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(412, 'NEWS_PRIORITY_DESC', 'When AcyMailing queues your e-mails, it will order them depending on the send date and the priority.<br />So, if you want your Newsletter to be sent immediately, you can enter a lower number and it will be sent before the others.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(413, 'FOLLOW_PRIORITY_DESC', 'Priority for the Follow-up messages.<br />Usually, you want those e-mails to be sent immediately, so they need a lower number than Newsletters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(414, 'ALLOW_VISITOR_DESC', 'Do you allow non-logged in visitors to subscribe to your Mailing Lists?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(415, 'REQUIRE_CONFIRM_DESC', 'Should the user have to click on a confirmation link before being considered as a subscriber?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(416, 'NOTIF_CREATE_DESC', 'Send an e-mail to those e-mail addresses each time a new user is created.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(417, 'NOTIF_UNSUBALL_DESC', 'Send an e-mail to those e-mail addresses if a user unsubscribes from all your lists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(418, 'NOTIF_REFUSE_DESC', 'Send an e-mail to those e-mail addresses if a user refuses to receive messages from your website.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(419, 'REDIRECTION_CONFIRM_DESC', 'Enter the url you want the user to be redirected to after he clicks on the confirmation link in the confirmation e-mail.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(420, 'REDIRECTION_UNSUB_DESC', 'Enter the url you want the user to be redirected to after he unsubscribes.<br />This redirection URL does not apply to the Module Unsubscription! Please edit the AcyMailing module for that.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(421, 'FORWARD_DESC', 'If you select <b><i>No</i></b>, the forward to a friend function won\'t be enabled on your website.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(422, 'FE_INTERFACE', 'Front-end Interface', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(423, 'DEFAULT_SENDER', 'Creator as <b><i>Sender</i></b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(424, 'DEFAULT_REPLY', 'Creator as <b><i>Reply-to</i></b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(425, 'DEFAULT_SENDER_DESC', 'Do you want the logged-in user to be the default <b><i>sender</i></b> of a Newsletter created from the front-end?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(426, 'DEFAULT_REPLY_DESC', 'Do you want the logged-in user to be the default <b><i>reply-to</i></b> of a Newsletter created from the front-end?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(427, 'FRONTEND_PRINT', 'Print Icon', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(428, 'FRONTEND_PDF', 'PDF Icon', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(429, 'FRONTEND_PRINT_DESC', 'Do you want AcyMailing to add a Print Icon on the archive Newsletter?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(430, 'FRONTEND_PDF_DESC', 'Do you want AcyMailing to add a PDF Icon on the archive Newsletter?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(431, 'ALLOW_MODIFICATION_DESC', 'Do you allow the user to modify his data without being identified?<br />If you select <b><i>No</i></b>, the data entered by the user cannot be changed afterwards except if he\'s identified by the system.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(432, 'ALLOW_MODIFICATION', 'Allow user data modifications without identification', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(433, 'ONLY_SUBSCRIPTION', 'Only his subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(434, 'IDENTIFICATION_SENT', 'An email to verify your identity has been sent to you.<br />Please click on the link in the email to be able to modify your subscription.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(435, 'QUEUE_PAUSE', 'Pause between two batches', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(436, 'QUEUE_PAUSE_DESC', 'If you use the manual send process, you can configure AcyMailing to make a pause between two batches to throttle your send process (in seconds).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(437, 'SHOW_DESCRIPTION', 'Display list description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(438, 'SHOW_DESCRIPTION_DESC', 'Display the list description on the archive Newsletters?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(439, 'SHOW_SENDDATE', 'Display send-date column', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(440, 'SHOW_SENDDATE_DESC', 'Display the send-date on the archive Newsletters?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(441, 'SHOW_FILTER', 'Display Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(442, 'SHOW_FILTER_DESC', 'Display the filter on the archive Newsletters?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(443, 'ACY_ERROR_INSTALLAGAIN', 'And then click here to trigger the install process again.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(444, 'DISPLAY_MSG_CONFIRMATION', 'Display a message when sending the confirmation e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(445, 'DISPLAY_MSG_CONFIRMATION_DESC', 'Should AcyMailing display a confirmation message when AcyMailing sends the confirmation e-mails?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(446, 'DISPLAY_MSG_UNSUBSCRIPTION', 'Display a message on unsubscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(447, 'DISPLAY_MSG_UNSUBSCRIPTION_DESC', 'Should AcyMailing display a message when the user unsubscribes from your website?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(448, 'REDIRECTION_MODIF', 'Redirection after Subscription modification', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(449, 'REDIRECTION_SUB', 'Redirection after Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(450, 'REDIRECTION_SUB_DESC', 'Enter the url you want the user to be redirected to after he subscribes.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(451, 'REDIRECTION_MODIF_DESC', 'Enter the url you want the user to be redirected to after he modified his subscription.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(452, 'REDIRECTION_NOT_MODULE', 'This redirection URL does not apply to the Module! Please edit the AcyMailing module for that.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(453, 'FIELD_EXPORT', 'Fields to export', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(454, 'EXPORT_FORMAT', 'Exporting format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(455, 'EXPORT_SUB_LIST', 'Only Users subscribed to at least one of the selected lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(456, 'EXPORT_CONFIRMED', 'Only Confirmed Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(457, 'EXPORT_REGISTERED', 'Only Registered Users (Joomla users)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(458, 'UPLOAD_FILE', 'Upload a file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(459, 'CHARSET_FILE', 'File Charset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(460, 'IMPORT', 'Import', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(461, 'IMPORT_HEADER', 'The first line of your file ( %s ) must contain only columns of the acymailing_subscriber table', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(462, 'IMPORT_EMAIL', 'You need at least the column <b><i>email</i></b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(463, 'IMPORT_EXAMPLE', 'Example : name,email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(464, 'IMPORT_ARGUMENTS', 'You need %s arguments per line', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(465, 'IMPORT_ERRORLINE', 'The line %s could not be imported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(466, 'ACY_IMPORT_REPORT', '%s Users in the imported file : %s new Users Imported, %s Invalid Email addresses, %s already existing users or duplicate entries', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(467, 'IMPORT_SUBSCRIBE_CONFIRMATION', '%s users have been subscribed to the list %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(468, 'IMPORT_REMOVE', '%s users removed from the list %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(469, 'IMPORT_ERROR_FIELD', 'The column %s is not in the list of possible columns : %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(470, 'IMPORT_UPDATE', '%s AcyMailing users updated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(471, 'IMPORT_DELETE', '%s AcyMailing users deleted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(472, 'IMPORT_NEW', '%s new users imported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(473, 'IMPORT_SUBSCRIPTION', '%s subscriptions have been inserted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(474, 'IMPORT_LIST', 'List %s imported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(475, 'IMPORT_JOOMLA', 'Joomla Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(476, 'UNKNOWN', 'Unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(477, 'IMPORT_FROM', 'Import Data from', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(478, 'IMPORT_SUBSCRIBE', 'Subscribe the imported users to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(479, 'IMPORT_SUBSCRIBE_REMOVE', 'Subscribe (or Remove) the selected users to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(480, 'CONTENT_AREA', 'Style for the article area', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(481, 'CONTENT_HEADER', 'Style for the article titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(482, 'CONTENT_READMORE', 'Style for the <b><i>read more</i></b> link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(483, 'ADD_STYLE', 'Add a new Style', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(484, 'STYLES', 'Style : Classes replaced by inline CSS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(485, 'CLASS_NAME', 'Name of the CSS Class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(486, 'CSS_STYLE', 'CSS applied to the class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(487, 'STYLE_UNSUB', 'Style for the Unsubscribe Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(488, 'STYLE_VIEW', 'Style for the <b><i>View it online</i></b> Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(489, 'TAGS', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(490, 'INSERT_TAG', 'Insert the tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(491, 'CONFIRM_SUBSCRIPTION', 'Click here to confirm your Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(492, 'MODIFY_SUBSCRIPTION', 'Modify your Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(493, 'CONFIRM_SUBSCRIPTION_LINK', 'Insert a <b><i>confirm your subscription</i></b> link in your e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(494, 'MODIFY_SUBSCRIPTION_LINK', 'Insert a <b><i>modify your subscription</i></b> link in your e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(495, 'UNSUBSCRIBE_LINK', 'Insert an <b><i>unsubscribe</i></b> link in your e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(496, 'VIEW_ONLINE', 'Click here to view it online', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(497, 'FORWARD_FRIEND', 'Forward this e-mail to a friend', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(498, 'VIEW_ONLINE_LINK', 'Insert a <b><i>view it online</i></b> link in your e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(499, 'FORWARD_FRIEND_LINK', 'Insert a <b><i>forward</i></b> link in your e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(500, 'WEBSITE_LINKS', 'Website Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(501, 'JOOMLA_CONTENT', 'Joomla Content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(502, 'DISPLAY', 'Display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(503, 'CLICKABLE_TITLE', 'Clickable Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(504, 'AUTHOR_NAME', 'Author Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(505, 'JOOMEXT_READ_MORE', 'Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(506, 'JOOMLA_CONTENT_AUTO', 'Automatic Joomla Content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(507, 'MIN_ARTICLE', 'Min. number of items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(508, 'MIN_ARTICLE_TIP', 'Minimum number of Elements in order to generate the tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(509, 'MAX_ARTICLE', 'Max. number of items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(510, 'ONLY_NEW_CREATED', 'Only newly created', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(511, 'ONLY_NEW_MODIFIED', 'Only newly created or modified', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(512, 'MODIFIED_DATE', 'Modified Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(513, 'REPLACE_TAGS', 'Replace Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(514, 'ACY_COUPON', 'Coupon', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(515, 'COUPON_PERCENT', 'Percent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(516, 'COUPON_TOTAL', 'Total', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(517, 'COUPON_PERMANENT', 'Permanent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(518, 'COUPON_GIFT', 'Gift', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(519, 'COUPON_NAME', 'Coupon Code', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(520, 'COUPON_VALUE', 'Value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(521, 'ACY_PRODUCTS', 'Products', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(522, 'JOOMEXT_EVENT', 'Event', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(523, 'ACY_ORDERS', 'Orders', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(524, 'ACY_ONE_PRODUCT', 'At least one product', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(525, 'ACY_DIDNOTBOUGHT', 'didn\'t buy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(526, 'ACY_BOUGHT', 'bought', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(527, 'SHOPPER_GROUP', 'Shopper Group', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(528, 'UPCOMING_EVENTS', 'Upcoming Events', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(529, 'MAX_STARTING_DATE', 'Maximum Starting Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(530, 'SUBSCRIBER_SUBSCRIBER', 'Subscriber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(531, 'SUBSCRIBER_ID', 'ID of the subscriber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(532, 'SUBSCRIBER_EMAIL', 'Email of the subscriber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(533, 'SUBSCRIBER_NAME', 'Name of the subscriber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(534, 'SUBSCRIBER_USERID', 'ID of the subscriber in the Joomla User table', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(535, 'SUBSCRIBER_IP', 'IP of the subscriber when he opted in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(536, 'SUBSCRIBER_CREATED', 'Creation date of the subscriber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(537, 'SUBSCRIBER_FIRSTPART', 'First part of the subscriber name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(538, 'SUBSCRIBER_LASTPART', 'Last part of the subscriber name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(539, 'SUBSCRIBER_FIRSTPART_DESC', '(the first part of the subscriber <b><i>John Doe</i></b> is <b><i>John</i></b>)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(540, 'SUBSCRIBER_LASTPART_DESC', '(the last part of the subscriber <b><i>John Doe</i></b> is <b><i>Doe</i></b>)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(541, 'TAGUSER_TAGUSER', 'Joomla User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(542, 'TAGUSER_ID', 'Joomla ID of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(543, 'TAGUSER_EMAIL', 'Email of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(544, 'TAGUSER_NAME', 'Name of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(545, 'TAGUSER_USERNAME', 'Username of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(546, 'TAGUSER_GROUP', 'Main group of the user (Super Administrator, Manager, Author...)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(547, 'TAGUSER_LASTVISIT', 'Date of the last visit of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(548, 'TAGUSER_REGISTRATION', 'Registration date of the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(549, 'DISPLAY_PICTURES', 'Display pictures', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(550, 'TAG_ELEMENTS', 'Elements', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(551, 'TAG_CATEGORIES', 'Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(552, 'USERS_DESC_CREATE', 'Create / Modify / Delete your users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(553, 'USERS_DESC_MANAGE', 'Manage the subscription of each user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(554, 'USERS_DESC_IMPORT', 'Import / Export Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(555, 'LISTS_DESC_CREATE', 'Create / Modify / Delete your Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(556, 'LISTS_DESC_SUBSCRIPTION', 'Mass Subscription using filters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(557, 'TEMPLATES_DESC_CREATE', 'Create / Modify / Delete Newsletter templates that you will be able to use on each e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(558, 'NEWSLETTERS_DESC_CREATE', 'Create / Modify / Delete a Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(559, 'NEWSLETTERS_DESC_TEST', 'Test your Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(560, 'NEWSLETTERS_DESC_SEND', 'Send a Newsletter to one or several Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(561, 'QUEUE_DESC_CONTROL', 'Control the list of e-mails which are ready to be sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(562, 'QUEUE_DESC_BOUNCE', 'Launch the bounce handling', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(563, 'CONFIG_DESC_CONFIG', 'Configure AcyMailing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(564, 'CONFIG_DESC_MODIFY', 'Modify any string used in AcyMailing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(565, 'CONFIG_DESC_PLUGIN', 'Turn ON/OFF AcyMailing Plugins', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(566, 'ONLY_FROM_ESSENTIAL', 'Only available from AcyMailing Essential', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(567, 'ONLY_FROM_BUSINESS', 'Only available from AcyMailing Business', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(568, 'ONLY_FROM_ENTERPRISE', 'Only available with AcyMailing Enterprise', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(569, 'STATS_DESC_CHARTS', 'Subscription Charts', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(570, 'STATS_DESC_CLICK', 'How many users clicked on which link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(571, 'STATS_DESC_VIEW', 'How many e-mail sent, how many received, who received, who opened...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(572, 'AUTONEWS_DESC', 'Manage your automatic Newsletters which can be sent regularly to one or several Mailing Lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(573, 'CAMPAIGN_DESC_CREATE', 'Create your Marketing Campaigns with follow-up autoresponders messages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(574, 'CAMPAIGN_DESC_AFFECT', 'Attach each Campaign to one or several Mailing Lists so each new subscriber will start receiving your campaign based on his own subscription date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(575, 'UPDATE_ABOUT', 'Update / About', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(576, 'UPDATE_DESC', 'Check for new update', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(577, 'ABOUT_DESC', 'About', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(578, 'CHANGELOG_DESC', 'See the changelog', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(579, 'BOUNCE_HANDLING', 'Bounce Handling', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(580, 'BOUNCE_FEATURE', 'Enable the Automatic Bounce Handling', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(581, 'BOUNCE_FEATURE_DESC', 'Turn ON or OFF the Bounce Handling system.<br />If you turn it on, AcyMailing will automatically connect to your account in order to handle bounce messages.<br />If you turn it off, you can only use the Bounce Handling system manually by clicking on the button <b><i>Handle Bounces</i></b> on the queue page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(582, 'BOUNCE_CONNECTION', 'Connection Method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(583, 'BOUNCE_CERTIF', 'Self-signed Certificates', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(584, 'BOUNCE_CONNECT_SUCC', 'Successfully connected to %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(585, 'NB_MAIL_MAILBOX', 'There are %s messages in your mailbox', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(586, 'BOUNCE_TIMEOUT', 'Connection timeout (seconds)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(587, 'BOUNCE_PROCESS', 'Bounce Handling', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(588, 'BOUNCE_MAX_EMAIL', 'Maximum Number of e-mails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(589, 'BOUNCE_RULES', 'Rules', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(590, 'BOUNCE_REGEX', 'Regex', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(591, 'BOUNCE_ACTION', 'Action on the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(592, 'EMAIL_ACTION', 'Action on the e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(593, 'FORWARD_EMAIL', 'Forward the message to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(594, 'DELETE_EMAIL', 'Delete the message from your mailbox', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(595, 'UNSUB_USER', 'Unsubscribe the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(596, 'SUBSCRIBE_USER', 'Subscribe the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(597, 'DELETE_USER', 'Delete the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(598, 'BOUNCES', 'Bounces', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(599, 'PLUG_INSTALLED', 'Plugin %s installed successfully', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(600, 'PLUG_ERROR', 'Error installing Plugin %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(601, 'MODULE_INSTALLED', 'Module %s installed successfully', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(602, 'MODULE_ERROR', 'Error installing Module %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(603, 'INSTALL_CONTINUE', 'Continue the Install Process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(604, 'TEMPLATES_INSTALL', '%s Templates Installed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(605, 'ADVICE_BOUNCE', 'The specified bounce e-mail address %s might cause the problem, please delete it (leave the field bounce address empty) and try again.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(606, 'ADVICE_SMTP_AUTH', 'You specified an SMTP password but you don\'t require an authentification, you might want to turn the SMTP authentication ON.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(607, 'ADVICE_LOCALHOST', 'Your local website may not have a mail server. Please make sure you can send e-mails with Joomla first (password request, registration confirmation...).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(608, 'DEFAULT_LANGUAGE', 'Default language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(609, 'ACY_CUSTOM', 'Custom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(610, 'FIELD_LABEL', 'Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(611, 'FIELD_COLUMN', 'Column name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(612, 'FIELD_TYPE', 'Field type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(613, 'REQUIRED', 'Required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(614, 'CORE', 'Core', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(615, 'FIELD_SIZE', 'Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(616, 'FIELD_DEFAULT', 'Default value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(617, 'FIELD_VALUES', 'Values', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(618, 'FIELD_COLUMNS', 'Columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(619, 'FIELD_ROWS', 'Rows', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(620, 'FIELD_TEXT', 'Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(621, 'FIELD_TEXTAREA', 'Textarea', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(622, 'FIELD_RADIO', 'Radio Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(623, 'FIELD_CHECKBOX', 'Checkbox', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(624, 'EXTRA_INFORMATION', 'Extra information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(625, 'EXTRA_FIELDS', 'Custom Fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(626, 'FIELD', 'Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(627, 'FIELD_SINGLEDROPDOWN', 'Single Dropdown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(628, 'FIELD_MULTIPLEDROPDOWN', 'Multiple Dropdown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(629, 'FIELD_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(630, 'FIELD_VALUE', 'Value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(631, 'FIELD_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(632, 'FIELD_ADDVALUE', 'Add a new value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(633, 'FIELD_VALID', 'Please enter a value for the field %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(634, 'FIELD_ERROR', 'Custom Error Message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(635, 'FORMAT', 'Format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(636, 'FIRSTNAMECAPTION', 'First Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(637, 'LASTNAMECAPTION', 'Last Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(638, 'CITYCAPTION', 'City', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(639, 'COUNTRYCAPTION', 'Country', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(640, 'PHONECAPTION', 'Phone Number', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(641, 'ADDRESSCAPTION', 'Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(642, 'BIRTHDAYCAPTION', 'Birthday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(643, 'FIELD_BIRTHDAY', 'Birthday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(644, 'SOCIAL_SHARE', 'Share on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(645, 'SHARE_TEXT', 'Currently reading %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(646, 'SECURITY', 'Security', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(647, 'CAPTCHA', 'Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(648, 'ENABLE_CATCHA', 'Enable the captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(649, 'CAPTCHA_CHARS', 'Characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(650, 'CAPTCHA_CHARS_DESC', 'List of characters used to create the captcha text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(651, 'SECURITY_KEY', 'Security Key', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(652, 'SECURITY_KEY_DESC', 'If you use the subscription via URL, you will have to add this key in the url otherwise the submission won\'t be accepted<br /><br />%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(653, 'MODULE_VIEW', 'Subscription via the AcyMailing Module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(654, 'COMPONENT_VIEW', 'Subscription via the AcyMailing Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(655, 'CAPTCHA_NBCHAR', 'Number of characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(656, 'CAPTCHA_HEIGHT', 'Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(657, 'CAPTCHA_WIDTH', 'Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(658, 'CAPTCHA_BACKGROUND', 'Background color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(659, 'CAPTCHA_COLOR', 'Font color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(660, 'ERROR_SECURE_KEY', 'The secure key is not the right one', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(661, 'ERROR_CAPTCHA', 'Please enter the security code displayed in the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(662, 'FE_EDITION', 'Front-end edition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(663, 'FE_MODIFICATION', 'Allow modifications', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(664, 'FE_MODIFICATION_DESC', 'Do you allow a user to edit the Newsletter created by another user?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(665, 'FE_MODIFICATION_SENT', 'Allow post-sent edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(666, 'FE_MODIFICATION_SENT_DESC', 'Do you allow the user to edit the Newsletter after the Newsletter has been sent?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(667, 'ARCHIVE_SECTION', 'Archive section', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(668, 'SUBJECT_DISPLAY_DESC', 'Display the Newsletter subject on the archive Newsletter?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(669, 'SUBJECT_DISPLAY', 'Display subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(670, 'ALREADY_SENT', '%s e-mails have already been sent for this Newsletter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(671, 'REMOVE_ALREADY_SENT', 'Do you want to send this Newsletter only to your new users?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(672, 'SEND_TO_ALL', 'No, send to all users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(673, 'CLICK_BOUNCE', 'CLICK HERE to handle the messages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(674, 'NOTIF_UNSUB', 'When a user unsubscribes from a list, send an e-mail to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(675, 'NOTIF_UNSUB_DESC', 'Send an e-mail to those e-mail addresses if a user unsubscribes from a list.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(676, 'TEMPLATE_STYLESHEET', 'Stylesheet', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(677, 'BLOCK_USER', 'Block the user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(678, 'COMMENTS_ENABLED', 'User Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(679, 'COMMENTS_ENABLED_DESC', 'Add user comments on your archive section', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(680, 'IMPORT_CONFIRMED', 'Import the users as confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(681, 'IMPORT_TEXTAREA', 'Textarea', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(682, 'GENERATE_NAME', 'Auto-generate User\'s name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(683, 'ACTION_SELECT', 'Select an action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(684, 'ADD_FILTER', 'Add a filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(685, 'ADD_ACTION', 'Add an action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(686, 'ACTIONS', 'Actions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(687, 'ACY_ORDER', 'Order by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(688, 'ACY_ID', 'ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(689, 'ACY_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(690, 'ACY_DESCRIPTION', 'Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(691, 'ACY_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(692, 'OPEN_POPUP_DESC', 'Do you want to open the archive Newsletter in a popup?<br /> If not, the Newsletter archive will be opened inside your Joomla template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(693, 'OPEN_POPUP', 'Open the archive in a popup', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(694, 'SUBSCRIBE_TO', 'Subscribe users to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(695, 'REMOVE_FROM', 'Remove users from', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(696, 'ENTER_TITLE', 'Please enter a title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(697, 'REMOVE_SUB', 'Delete the user subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(698, 'MORE_PLUGINS', 'Click here to download more plugins', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(699, 'MORE_TEMPLATES', 'Click here to download more templates', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(700, 'ACY_LOAD', 'Load', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(701, 'ACY_FILTERS', 'Filters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(702, 'ACY_FILTER', 'Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(703, 'CONFIRM_USERS', 'Confirm users\' subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(704, 'BLOCK_USERS', 'Block users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(705, 'ENABLE_USERS', 'Enable users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(706, 'NB_CONFIRMED', '%s users confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(707, 'AUTO_TRIGGER_FILTER', 'Automatically trigger the filter:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(708, 'AUTO_CRON_FILTER', 'Every day (using the cron task) at', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(709, 'ON_USER_CREATE', 'On user creation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(710, 'ON_USER_CHANGE', 'On user modification', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(711, 'ON_USER_CLICK', 'When the user clicks on an url from your Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(712, 'ON_OPEN_NEWS', 'When the user opens your Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(713, 'SUBSCRIBE_LIST', 'Click here to subscribe users to this list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(714, 'MISSING_LANGUAGE', 'Your language file is currently not installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(715, 'UPDATE_LANGUAGE', 'Your language file is not up to date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(716, 'DONT_REMIND', 'I know, don\'t remind me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(717, 'META_DATA', 'Metadata', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(718, 'META_KEYWORDS', 'Meta Keywords', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(719, 'META_DESC', 'Meta Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(720, 'STYLE_IND', 'Individual styling', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(721, 'CUSTOM_TEXT', 'Custom text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(722, 'RESIZED', 'Resized', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(723, 'EXISTING_FILTERS', 'Existing filters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(724, 'SELECT', 'Selection', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(725, 'SELECT_LISTS', 'Select one or several lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(726, 'AUTO_SUBSCRIBE', 'Auto-subscribe on Joomla registration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(727, 'AUTO_SUBSCRIBE_DESC', 'Users will be automatically subscribed to the selected lists if they register on your website via the Joomla registration page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(728, 'FOLLOWUP_PUBLISHED_INFORMED', 'You just published this follow-up.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(729, 'FOLLOWUP_CHANGED_DELAY_INFORMED', 'You just changed the delay for this follow-up.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(730, 'FOLLOWUP_CHANGED_DELAY', 'Click here to update the send date with this new delay on the follow-up already inserted in your queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(731, 'NB_EMAILS_UPDATED', '%s e-mails have been updated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(732, 'ADD_QUEUE', 'Add an e-mail in the queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(733, 'REMOVE_QUEUE', 'Remove an e-mail from the queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(734, 'TABLENAME', 'Table Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(735, 'SPECIFYTABLE', 'Please enter a table name from your database: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(736, 'SPECIFYFIELD', 'The field %s could not be found. Please specify a field from the table: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(737, 'SPECIFYFIELDEMAIL', 'An equivalent for the email field is required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(738, 'DATABASE', 'Database', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(739, 'CATEGORY_VIEW', 'Category View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(740, 'DETAILS_VIEW', 'Details View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(741, 'ACY_HELP', 'Help', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(742, 'ACY_TEMPLATES', 'Templates', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(743, 'ACY_PREVIEW', 'Preview', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(744, 'ACY_COPY', 'Copy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(745, 'ACY_PUBLISHED', 'Published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(746, 'ACY_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(747, 'ACY_USER', 'User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(748, 'ACY_EXPORT', 'Export', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(749, 'ACY_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(750, 'ACY_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(751, 'ACY_SAVE', 'Save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(752, 'ACY_CLOSE', 'Close', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(753, 'ACY_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(754, 'ACY_FILES', 'Files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(755, 'ACY_APPLY', 'Apply', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(756, 'ACY_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(757, 'ACY_FILE', 'File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(758, 'ACY_NUM', '#', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(759, 'ACY_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(760, 'ACY_EDITOR', 'Editor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(761, 'ACY_NONE', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(762, 'ACY_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(763, 'ACY_VALIDDELETEITEMS', 'Are you sure you want to delete the selected Items?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(764, 'ACY_MINUTES', 'Minutes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(765, 'ACY_SECONDS', 'Seconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(766, 'ACY_TIME', 'Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(767, 'ACY_ALL', 'All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(768, 'ACY_CREATED', 'Created', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(769, 'YES_SUBSCRIBE_ME', 'Yes, I want to receive Newsletters from your website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(770, 'OVERWRITE_EXISTING', 'Overwrite existing user\'s information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(771, 'WARNING_LIMITATION', 'Most hosting companies apply some limitations on the number of e-mails you can send per hour.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(772, 'WARNING_LIMITATION_CONFIG', 'Please make sure you configured AcyMailing to stay under these limitations.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(773, 'USERS_IN_COMP', 'There are %s users in %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(774, 'ACY_NOTALLOWED', 'You are not authorized to view this resource.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(775, 'DISPLAY_EFFECT', 'Display Effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(776, 'VISIBLE_LISTS', 'Display the lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(777, 'AUTO_SUBSCRIBE_TO', 'Automatically subscribe to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(778, 'DISPLAY_MODE', 'Display Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(779, 'LISTS_CHECKED_DEFAULT', 'Lists checked by default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(780, 'CHECKED_MODE', 'Check the lists according to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(781, 'DROPDOWN_LISTS', 'Lists in a dropdown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(782, 'DESC_OVERLAY', 'Description as an overlay', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(783, 'LINKED_ARCHIVE', 'Add a link to the archive section', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(784, 'DISP_FIELDS', 'Displayed fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(785, 'CAPT_NAME', 'Name Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(786, 'CAPT_EMAIL', 'Email Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(787, 'DISP_TEXT_MODE', 'Display Text Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(788, 'INTRO_TEXT', 'Intro Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(789, 'POST_TEXT', 'Post Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(790, 'DISP_SUB_BUTTON', 'Subscribe button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(791, 'CAPT_SUB', 'Subscribe Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(792, 'CAPT_SUB_LOGGED', 'Subscribe Caption for logged-in users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(793, 'DISP_UNSUB_BUTTON', 'Unsubscribe button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(794, 'CAPT_UNSUB', 'Unsubscribe Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(795, 'TERMS_CONTENT', 'Terms and Conditions Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(796, 'TERMS_POPUP', 'Article displayed in a popup', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(797, 'MOO_BOX_HEIGHT', 'Popup Box height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(798, 'MOO_BOX_WIDTH', 'Popup Box width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(799, 'MOO_BUTTON', 'Mootools Button Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(800, 'MOO_INTRO', 'Intro Text for Mootools', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(801, 'REDIRECT_MODE', 'Redirect Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(802, 'REDIRECT_LINK', 'Redirect Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(803, 'ACY_IN', 'In', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(804, 'ACY_NOT_IN', 'Not in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(805, 'ACY_NUMERIC', 'Numeric', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(806, 'ACY_STRING', 'String', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(807, 'ACY_BEGINS_WITH', 'Begins with', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(808, 'ACY_ENDS_WITH', 'Ends with', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(809, 'ACY_CONTAINS', 'Contains', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(810, 'EXPIRY_DATE', 'Expiry Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(811, 'CLICK_DATE', 'Click date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(812, 'ACY_DKIM', 'DKIM', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(813, 'ACY_DKIM_DESC', 'DomainKeys Identified Mail enables you to sign your messages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(814, 'DKIM_DOMAIN', 'Domain', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(815, 'DKIM_SELECTOR', 'Selector', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(816, 'DKIM_PASSPHRASE', 'Passphrase', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(817, 'DKIM_IDENTITY', 'Identity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(818, 'DKIM_PRIVATE', 'Private key', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(819, 'DKIM_PUBLIC', 'Public Key', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(820, 'ACY_TABLECONTENTS', 'Table of Contents', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(821, 'ACY_EXISTINGANCHOR', 'Existing anchors', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(822, 'ACY_GENERATEANCHOR', 'Generate the table of contents based on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(823, 'ACY_SENT_EMAILS', 'E-mails sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(824, 'ACY_VIEW', 'View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(825, 'ACY_MANAGE', 'Manage', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(826, 'ACY_SUBSCRIBER', 'Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(827, 'ACY_SEPARATOR', 'Separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(828, 'ACL_WRONG_CONFIG', 'You can not exclude yourself from the configuration management', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(829, 'NO_LIST_SELECTED', 'Please select the lists you want to subscribe to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(830, 'ACY_LEVEL', 'Level %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(831, 'ACY_HISTORY', 'History', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(832, 'ACY_SOURCE', 'Source', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(833, 'ACY_DETAILS', 'Details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(834, 'ACY_ACTION', 'Action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(835, 'ACTION_CREATED', 'Created', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(836, 'ACTION_MODIFIED', 'Modified', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(837, 'ACTION_CONFIRMED', 'Confirmed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(838, 'ACTION_UNSUBSCRIBED', 'Unsubscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(839, 'EXECUTED_BY', 'Executed by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(840, 'REASON', 'Reason', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(841, 'VIEW_DETAILS', 'View details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(842, 'DATABASE_MAINTENANCE', 'Database Maintenance', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(843, 'DATABASE_MAINTENANCE_DESC', 'AcyMailing may save an important amount of information in the database.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(844, 'DATABASE_MAINTENANCE_DESC2', 'This area enables you to automatically delete some old information after X days.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(845, 'DELETE_DETAILED_STATS', 'Delete detailed statistics after', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(846, 'DELETE_HISTORY', 'Delete user history after', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(847, 'UNSUB_INTRO', 'Hello {user:name}, <br /><br />We are sorry to find you are no longer interested in our newsletters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(848, 'UNSUB_SURVEY', 'Before you go, we\'d be grateful if you\'d let us know why you\'re unsubscribing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(849, 'UNSUB_SURVEY_FREQUENT', 'The emails we send you are too frequent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(850, 'UNSUB_SURVEY_RELEVANT', 'The emails we send are not relevant to you', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(851, 'UNSUB_SURVEY_OTHER', 'Please add any other reasons here:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(852, 'UNSUB_PAGE', 'Unsubscribe page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(853, 'UNSUB_DISP_CHOICE', 'Display unsubscribe options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(854, 'UNSUB_DISP_SURVEY', 'Display a survey', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(855, 'UNSUB_INTRODUCTION', 'Introduction text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(856, 'PLEASE_SELECT_USERS', 'Please select some users on the list first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(857, 'AUTO_SEND_PROCESS', 'Automatic send process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(858, 'SEND_X_EVERY_Y', 'Send %s e-mails every %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(859, 'MANUAL_SEND_PROCESS', 'Manual send process', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(860, 'SEND_X_WAIT_Y', 'Send %s e-mails and then wait %s before sending another batch', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(861, 'CREATE_CRON_REMINDER', 'Your cron does not seem to be enabled, don\'t forget to create it!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(862, 'DELETE_USERS', 'Delete Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(863, 'BOUNCE_SAVE_MESSAGE', 'Save message in database', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(864, 'ACTION_BOUNCE', 'Bounced', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(865, 'ACY_THEME', 'Theme', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(866, 'ACY_DOWNLOAD', 'Download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(867, 'FILTER_AND', 'And', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(868, 'SELECTED_USERS', '%s users selected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(869, 'ACY_NEW', 'New', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(870, 'MENU_POSITION', 'Menu Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(871, 'UNDER_TITLE', 'Under the title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(872, 'ABOVE_MAIN_AREA', 'Above the main area', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(873, 'NB_UNSUB_USERS', '%s users unsubscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(874, 'NB_OPEN_USERS', '%s users opened the Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(875, 'NB_CLICK_USERS', '%s users clicked on a link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(876, 'NB_BOUNCED_USERS', '%s bounced', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(877, 'MOST_POPULAR_LINKS', 'Most popular links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(878, 'NB_USERS_CLICKED_ON', '%s users clicked on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(879, 'ACY_PRINT', 'Print', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(880, 'ACY_LINK_STYLE', 'Style of the links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(881, 'ACY_RULE', 'Rule', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(882, 'REGEX_ON', 'Execute the regex on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(883, 'ACY_BODY', 'Body', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(884, 'BOUNCE_EXEC_MIN', 'Execute the following actions only after receiving %s bounce messages from this user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(885, 'BOUNCE_STATS', 'Increment the bounce statistics if the rule matches', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(886, 'BOUNCE_RECEIVED', 'We received %s messages from the user %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(887, 'BOUNCE_MIN_EXEC', 'Actions will be executed after %s messages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(888, 'PLEASE_SELECT', 'Please make a selection from the list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(889, 'CONFIRM_REINSTALL_RULES', 'AcyMailing will delete your existing rules and install the default ones.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(890, 'REINSTALL_RULES', 'Re-install rules', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(891, 'SEND_SERVER', 'Send e-mails using your server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(892, 'SEND_EXTERNAL', 'Send e-mails using an external server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(893, 'SMTP_DESC', '%s is a delivery service you can use to send your e-mails.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(894, 'NO_ACCOUNT_YET', 'No account yet?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(895, 'CREATE_ACCOUNT', 'Create your account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(896, 'ACTION_FORWARD', 'Forwarded a Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(897, 'TELL_ME_MORE', 'Tell me more about it', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(898, 'ACY_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(899, 'RECEIVER_INFORMATION', 'Receiver Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(900, 'ACY_DAY', 'Day', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(901, 'ACY_MONTH', 'Month', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(902, 'ACY_YEAR', 'Year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(903, 'RECEIVER_LISTS', 'Only users subscribed to at least one of the above selected lists will receive the Newsletter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(904, 'RECEIVER_FILTER', 'You can refine the user selection by adding criteria:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(905, 'FILTER_ONLY_IF', 'They should also meet ALL of the following criteria:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(906, 'USER_FIELDS', 'User Fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(907, 'ADVANCED_EMAIL_VERIFICATION', 'Advanced email verification', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(908, 'CHECK_DOMAIN_EXISTS', 'Check if the domain exists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(909, 'LATEST_NEWSLETTER', 'Latest Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(910, 'CUSTOM_TRANS', 'Custom translations', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(911, 'CUSTOM_TRANS_DESC', 'The following strings won\'t be overwritten if you update/upgrade AcyMailing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(912, 'CONFIRM_SHARE_TRANS', 'Are you sure you want to send us this translation? Please do not send it if you didn\'t modify the translation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(913, 'PLEASE_CONFIRM_SUB', 'Please confirm your subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(914, 'CONFIRM_MSG', 'You\'ve subscribed to our Newsletters from our website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(915, 'CONFIRM_MSG_ACTIVATE', 'We need you to activate your subscription by clicking the link below:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(916, 'LIST_RECEIVE', 'Recipient', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(917, 'IN_TEMPLATE', 'In your template', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(918, 'WITHOUT_TEMPLATE', 'Without template', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(919, 'MINUTES_AGO', '%s minutes ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(920, 'SENT_TO_NUMBER', 'This e-mail will be sent to %s users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(921, 'FIELD_FILE', 'File upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(922, 'CONFIG_TRY', 'Try %s times to deliver the message.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(923, 'CONFIG_TRY_ACTION', 'If it still fails, %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(924, 'DO_NOTHING', 'Do nothing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(925, 'TAG_MODULES', 'Modules', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(926, 'ACY_NOT_CONTAINS', 'Does not contain', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(927, 'SPAM_TEST', 'Spam Test', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(928, 'CREATE_NEWSLETTER', 'New newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(929, 'MODULE_ALIGNMENT', 'Module Alignment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(930, 'MODULE_AUTOID', 'Display user information if logged in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(931, 'MODULE_CACHING', 'Caching', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(932, 'MODULE_JS', 'Include JS files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(933, 'ACY_ITEMID', 'Menu ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(934, 'MODULE_CLASSSUF', 'Module Class Suffix', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(935, 'SHOW_COLUMN_X', 'Display the column %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(936, 'RECEIVE_VIA_EMAIL', 'Receive via e-mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(937, 'SEND_SELECT_NEWS', 'Send the selected Newsletters to...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(938, 'ACY_FROM_DATE', 'From', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(939, 'ACY_TO_DATE', 'To', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(940, 'X_INTEGRATION', '%s integration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(941, 'ACY_PERIOD', 'Date range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(942, 'ACY_INTERVAL', 'Interval', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(943, 'CHART_TYPE', 'Chart type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(944, 'COLUMN_CHART', 'Column chart', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(945, 'LINE_CHART', 'Line chart', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(946, 'ACY_COMPARE', 'Compare...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(947, 'ACY_YEARS', 'Years', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(948, 'GENERATE_CHART', 'Generate chart', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(949, 'ACY_IMAGE', 'Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(950, 'FIELD_PHONE', 'Phone', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(951, 'ADVICE_PORT', 'The port you specified (%s) is not a common port for smtp connexions... Please leave the port empty and give it a new try', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(952, 'SET_SUBSCRIBER_VALUE', 'Set subscriber\'s profile value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(953, 'NB_MODIFIED', '%s users modified', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(954, 'ONLY_SOMETHING_WRONG', 'Only if an error occurs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(955, 'MESSAGE_TO_FORWARD', 'Hello {subtag:name},<br /> {user:name} ( {user:email} ) wanted to forward you this email with the message :<br /> {forwardmsg}', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(956, 'ADD_FORWARD_MESSAGE', 'Do you want to add a note to the message sent?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(957, 'YOUR_NAME', 'Your name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(958, 'YOUR_EMAIL', 'Your email address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(959, 'FRIEND_NAME', 'Friend\'s name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(960, 'FRIEND_EMAIL', 'Friend\'s email address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(961, 'ADD_FRIEND', 'Add another friend', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(962, 'FILL_ALL', 'Please fill all information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(963, 'EXPORT_ENABLED', 'Only Enabled Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(964, 'ACY_NEW_ORDERING_SAVED', 'New ordering saved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(965, 'ACY_GUESSPORT', 'What port can I use from my website?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(966, 'ACY_SELECTUSER', 'Select a user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(967, 'NOT_SENT', 'Not sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(968, 'CHANGE_TEMPLATE', 'The new template will replace the whole newsletter, the content you wrote will be deleted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(969, 'REDIRECTION_MODULE', 'Allowed domains for the redirection via the module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(970, 'REDIRECTION_MODULE_DESC', 'Write here the list of domains allowed to be used in the module redirection.<br />You should separate each domain by a | .', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(971, 'NO_REASON', 'No reason specified', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(972, 'COM_ACYMAILING_ARCHIVE_VIEW_DEFAULT_TITLE', 'Mailing List Archive (single list)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(973, 'COM_ACYMAILING_FRONTSUBSCRIBER_VIEW_DEFAULT_TITLE', 'Front-end user management', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(974, 'COM_ACYMAILING_LISTS_VIEW_DEFAULT_TITLE', 'Mailing Lists Archive (All lists)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(975, 'COM_ACYMAILING_FRONTNEWSLETTER_VIEW_DEFAULT_TITLE', 'Create Newsletter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(976, 'COM_ACYMAILING_USER_VIEW_DEFAULT_TITLE', 'Create/modify a subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(977, 'SEPARATOR_COMMA', 'Comma ( , )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(978, 'SEPARATOR_SEMICOLON', 'Semicolon ( ; )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(979, 'DKIM_CONFIGURE', 'Configure your DNS by adding a TXT record on your domain %s using the key/value as shown below.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(980, 'DKIM_LET_ME', 'Let me enter my own keys.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(981, 'DKIM_KEY', 'Key', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(982, 'DKIM_VALUE', 'Value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(983, 'ACY_STATS_ADDUP', 'Add up the results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(984, 'ACY_THUMBNAIL', 'Thumbnail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(985, 'READMORE_PICTURE', 'Read more picture', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(986, 'DELETE_PICT', 'Delete picture', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(987, 'ACYEDITOR_DELETEAREA', 'Are you sure you want to delete this area?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(988, 'ACYEDITOR_TEMPLATEDELETE', 'Deletable', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(989, 'ACYEDITOR_TEMPLATETEXT', 'Editable (Text)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(990, 'ACYEDITOR_TEMPLATEPICTURE', 'Editable (Picture)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(991, 'ACYEDITOR_SHOWAREAS', 'Show areas', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(992, 'ACYEDITOR_ADDAREAS', 'Your template does not contain editable areas, click here if you want the software to add them automatically.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(993, 'ACYEDITOR_ADDAREAS_ONLYFINISHED', 'You should do that only once your template is finished.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(994, 'ACYEDITOR_ADDAREAS_DONE', 'Editable areas successfully added', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(995, 'USER_ALREADY_EXISTS', 'A user already exists with the e-mail address %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(996, 'CLICK_EDIT_USER', 'Click here to edit this user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(997, 'TRUNCATE_AFTER', 'Truncate the text after %s characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(998, 'STATS_PER_LIST', 'Stats per list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(999, 'ACY_SSLCHOICE_DESC', 'Do you use the https protocol on your front-end? If so, turn this option ON.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1000, 'ACY_SSLCHOICE', 'Use https urls', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1001, 'TRACKING', 'Tracking', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1002, 'TRACKINGSYSTEM', 'Track clicks with', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1003, 'USE_BOOTSTRAP_FRONTEND', 'Use Bootstrap on the front-end', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1004, 'NEWSLETTER_INSTALLED', 'Newsletter imported successfully', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1005, 'ACY_TYPE', 'Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1006, 'GEOLOCATION', 'Geolocation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1007, 'GEOLOCATION_TYPE', 'When does AcyMailing save the user\'s position?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1008, 'GEOLOCATION_TYPE_DESC', 'AcyMailing will save the user\'s location at distinct times to provide more information about the user.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1009, 'GEOLOC_CONFIRM_SUB', 'Confirmation of subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1010, 'GEOLOCATION_API_KEY_DESC', 'You need an api key to use the geolocation. Please create an account and enter your API key here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1011, 'GEOLOC_UNSUB', 'Unsubscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1012, 'STATECAPTION', 'State', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1013, 'GEOLOC_NB_ACTIONS', 'Number of actions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1014, 'GEOLOC_COUNTRYCODE', 'Code of the country', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1015, 'GEOLOC_STATECODE', 'Code of the region/state', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1016, 'GEOLOC_POSTALCODE', 'Zipcode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1017, 'GEOLOC_LATITUDE', 'Latitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1018, 'GEOLOC_LONGITUDE', 'Longitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1019, 'GEOLOC_RECENT', 'Most recent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1020, 'GEOLOC_TEST_API_KEY', 'Test the geolocation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1021, 'ACY_SEARCH', 'Search...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1022, 'ACY_NEIGHBOUR', 'Users with same IP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1023, 'GEOLOC_NB_USERS', 'Number of users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1024, 'IMPORT_BLOCKED', 'Import users as blocked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1025, 'JOOMEXT_YES_CAMPAIGN', 'Yes + Campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1026, 'JOOMEXT_YES_FORWARD', 'Yes + Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1027, 'NOTIF_CONTACT_DESC', 'Send an e-mail to those e-mail addresses if a user submits the subscription form.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1028, 'NOTIF_CONTACT', 'When a user submits the subscription form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1029, 'NOTIF_CONFIRM_DESC', 'Send an e-mail to those e-mail addresses if a user confirms his subscription.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1030, 'NOTIF_CONFIRM', 'When a user confirms his subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1031, 'LINK_ID', 'Link id', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1032, 'ACY_ASAP', 'As soon as possible', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1033, 'ACY_ONTHE', 'On the', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1034, 'ACY_DAYOFMONTH', 'of the month', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1035, 'FREQUENCY_FIRST', '1st', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1036, 'FREQUENCY_SECOND', '2nd', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1037, 'FREQUENCY_THIRD', '3rd', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1038, 'FREQUENCY_LAST', 'Last', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1039, 'JOOMLA_CONFIRM_LINK', 'Insert a Joomla user confirmation link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1040, 'JOOMLA_CONFIRM_ACCOUNT', 'Confirm your account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1041, 'CURRENT_USER_INFO', 'Current user information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1042, 'CLICK_HANDLE_ALL_BOUNCES', 'Click here to handle all messages until your mailbox is empty', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1043, 'FIELD_AUTHORIZED_CONTENT', 'Authorized content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1044, 'ONLY_NUMBER', 'Numbers Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1045, 'ONLY_LETTER', 'Letters only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1046, 'ONLY_NUMBER_LETTER', 'Numbers and letters only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1047, 'MY_REGEXP', 'My regular expression', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1048, 'FIELD_ERROR_AUTHORIZED_CONTENT', 'Error message if invalid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1049, 'FIELD_CONTENT_VALID', 'Please enter a correct value for the field %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1050, 'DISPLAY_FRONTJOOMLEREGISTRATION', 'J! Registration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1051, 'DISPLAY_JOOMLAPROFILE', 'J! User Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1052, 'FRONTEND', 'Front-end', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1053, 'BACKEND', 'Back-end', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1054, 'DISPLAY_ACYPROFILE', 'Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1055, 'DISPLAY_ACYLISTING', 'Listing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1056, 'FILTER_VIEW_USERS', 'View users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1057, 'ACY_FILTEREDUSERS', 'First %1$s users filtered out of %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1058, 'TRIGGER_CAMPAIGN', 'Trigger the campaign %1$s %2$s after the filter is executed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1059, 'SEND_COMMENT', 'Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1060, 'SEND_COMMENT_DESC', 'This comment will be displayed at the begining of your test email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1061, 'JGRID_CHECKBOX_ROW_N', 'Checkbox for row %d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1062, 'LISTS_IN_COMP', 'There are %s lists in %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1063, 'IMPORT_X_LISTS', 'You can import those %s lists and so keep the subscription assigned to each user.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1064, 'IMPORT_LIST_TOO', 'Import the %s lists too?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1065, 'ACYTEMPLATE_EXPORTED', 'Your template has been exported successfully in the media/com_acymailing/tmp folder. Click %1$sHERE%2$s to download it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1066, 'NEWS_IN_COMP', 'There are %s newsletters in %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1067, 'IMPORT_NEWSLETTERS_TOO', 'Import the %s newsletters too?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1068, 'NB_IMPORT_NEWSLETTER', '%s newsletters imported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1069, 'ACY_START_CAMPAIGN', 'Start the campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1070, 'START_ON_SUBSCRIBE', 'When the user subscribes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1071, 'START_ON_DAY', 'The next %s after the user subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1072, 'AUTO_GENERATED_HTML', 'Auto-generated from the HTML version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1073, 'USE_DEFAULT_VALUE', 'Use default value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1074, 'SUCCESS_FILE_UPLOAD', 'Image successfully uploaded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1075, 'NO_FILE_FOUND', 'No file found in this folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1076, 'IMAGE_RESIZED', 'Image has been resized to be 700px', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1077, 'ACY_OR', 'or', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1078, 'MEDIA_BACK', 'Back', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1079, 'INSERT_IMAGE_FROM_URL', 'Insert image from url', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1080, 'UPLOAD_NEW_IMAGE', 'Upload a new image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1081, 'ALIGNMENT', 'Alignment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1082, 'NOT_SET', 'Not set', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1083, 'ACY_MARGIN', 'Margin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1084, 'ACY_BORDER', 'Border', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1085, 'ACY_LINK', 'Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1086, 'INSERT', 'Insert', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1087, 'MEDIA_FOLDER_DESC', 'Folders used to browse images when using the Acyeditor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1088, 'MEDIA_FOLDER', 'Media Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1089, 'FILE_RENAMED', 'An image with this name already exists. Image has been renamed as %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1090, 'IMAGE_NOT_FOUND', 'Sorry, but we did not find anything there...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1091, 'IMAGE_FOUND', 'Looks like we found it!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1092, 'IMAGE_TIMEOUT', 'Image cannot be loaded due to timeout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1093, 'NO_ACCESS_NEWSLETTER', 'You can not have access to this Newsletter (%s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1094, 'ACY_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1095, 'ACY_LEFT', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1096, 'LIST_POSITION', 'Display the lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1097, 'ACY_BEFORE_FIELDS', 'Before the fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1098, 'ACY_AFTER_FIELDS', 'After the fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1099, 'IPTIMECHECK', 'Limit same IP subscriptions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1100, 'IPTIMECHECK_DESC', 'Limit the subscriptions to maximum 3 per two hours from the same IP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1101, 'DBVALUES', 'Values from Database', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1102, 'ACY_WHERE', 'Where', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1103, 'ACY_ANY_CATEGORY', 'Any category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1104, 'IMPORT_SUBSCRIBE_CREATE', 'Subscribe users to a new list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1105, 'JOOMLA_NOTIFICATIONS', 'Joomla notifications', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1106, 'ACY_SENT', 'Sent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1107, 'WANNA_REINSTALL_RULES', 'The bounce rules have been updated, you may want to reinstall your rules to use the latest version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1108, 'AUTONEWS_GENERATE_INTRO', 'Hi {subtag:name},<br />The Newsletter below has been generated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1109, 'AUTONEWS_GENERATE_INTRO_SENT', 'This Newsletter has been scheduled and will be sent asap.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1110, 'AUTONEWS_GENERATE_INTRO_REVIEW', 'Please review it and click on this link to send it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1111, 'AUTONEWS_GENERATE_DONE', 'The Newsletter is published, maybe it has been sent already?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1112, 'ARCHIVE_INDEX_FOLLOW_DESC', 'Do you want your archived newsletters not to be indexed by search engines (noindex) and that they don\'t follow the links contained in your newsletter (nofollow)?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1113, 'ARCHIVE_INDEX_FOLLOW', 'Index/Follow Archive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1114, 'DATABASE_INTEGRITY', 'Check database integrity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1115, 'ACYEDITOR_TEMPLATEMORE', 'More actions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1116, 'ACYEDITOR_DUPLICATE_AFTER', 'Duplicate after', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1117, 'ACYEDITOR_DEFAULTTEXT', 'Click here to edit your text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1118, 'CREATE_FOLDER', 'Create Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1119, 'FOLDER_NAME', 'Folder\'s Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1120, 'FOLDER_ALREADY_EXISTS', 'This folder already exists, please try again.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1121, 'CUSTOM_VIEW', 'Custom view', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1122, 'CUSTOM_VIEW_DESC', 'Set a custom view name from Zoho CRM to only import users from this view', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1123, 'FOLLOWUP_ADDQUEUE_USERS', 'Click here to add this follow-up in the queue for users subscribed to your campaign since %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1124, 'FOLLOWUP_ADDQUEUE_ALLUSERS', 'Click here to add this follow-up in the queue for all users subscribed to your campaign', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1125, 'ACY_MAX_RUN', 'Based on our check, we can run each batch for %s seconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1126, 'ACY_TIMEOUT_AGAIN', 'Calculate the real maximum execution time again', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1127, 'ACY_TIMEOUT_CURRENT', 'We are currently checking your real maximum execution time... At least %s seconds so far', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1128, 'ACY_MAX_EXECUTION_TIME', 'Maximum execution time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1129, 'ACY_TIMEOUT_SERVER', 'Based on your server configuration, each batch can run for %s seconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1130, 'ACY_LANGUAGE', 'Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1131, 'ACY_CLOSE_TIMEOUT', 'You can close this configuration page while we are checking your timeout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1132, 'ACYEDITOR_REINIT_ZONE_TOOLTIP', 'Reinitialize areas', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1133, 'ACYEDITOR_REINIT_ZONE_CONFIRMATION', 'Are you sure you want to reinitialize all areas?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1134, 'ACY_JPAGETITLE', '%1$s - %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1135, 'ACY_ACTION_UNCONFIRM', 'Unconfirm users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1136, 'ACY_LOADZOHOFIELDS', 'Load ZohoCRM fields list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1137, 'ACY_LOADFIELDS', 'Load fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1138, 'ACY_FIELDSLOADED', 'Fields loaded successfully', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1139, 'ACY_NOFIELD', 'ZohoCRM returned no field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1140, 'ACY_ZOHOLIST', 'ZohoCRM list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1141, 'ACY_SUB_NOT_CONFIRMED', 'Your subscription to our newsletter is not confirmed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1142, 'ACY_RELATIVE_DATE', 'Relative date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1143, 'ACY_SPECIFIC_DATE', 'Specific date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1144, 'ACY_BEFORE', 'Before', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1145, 'ACY_AFTER', 'After', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1146, 'ACY_EXECUTION_TIME', 'Execution time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1147, 'ACY_PHONE_NOCOUNTRY', 'No Country', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1148, 'ACY_ZOHO_GENERATE_NAME', 'Generate name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1149, 'ACY_ZOHO_GENERATE_NAME_DESC', 'Choose whether to generate the name of the user created from the email or from the fields title, first and last name (if the name field is not assigned to any Zoho field)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1150, 'ACY_ZOHO_GENERATE_NAME_FROM_EMAIL', 'From email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1151, 'ACY_ZOHO_GENERATE_NAME_FROM_FIELDS', 'From concatenation of title, first and last name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1152, 'ACY_SSLCHOICE_CONFIRMATION', 'If you turn this option on but do not support HTTPS, images, urls and other things could break within your site. Are you sure?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1153, 'ACY_TRACKINGSYSTEM_EXTERNAL_LINKS', 'Track links for external websites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1154, 'ABTESTING', 'A/B Testing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1155, 'PLEASE_SELECT_NEWSLETTERS', 'Please select at least two newsletters first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1156, 'ABTESTING_TITLE', '%s Testing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1157, 'ABTESTING_PART_RECEIVER', 'Test sending on %s of the receivers. The test will be equally divided between the following newsletters:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1158, 'ABTESTING_MODIFY_RECEIVERS', 'Modify these receivers by editing %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1159, 'ABTESTING_DELAY_ACTION', 'After %s days:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1160, 'ABTESTING_ACTION_GENERATE_OPEN', 'Generate and send automatically the newsletter with the best open rate', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1161, 'ABTESTING_ACTION_GENERATE_CLICK', 'Generate and send automatically the newsletter with the best click rate', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1162, 'ABTESTING_ACTION_GENERATE_MIX', 'Generate and send automatically a newsletter with the subject of the best open rate and the body of the best click rate', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1163, 'ABTESTING_TEST', 'Test', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1164, 'ABTESTING_STAT_WARNING', 'Launching a new test will delete existing statistics on the selected newsletters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(1165, 'ABTESTING_INPROGRESS', 'There is a test saved. Modifying it will stop the test and start from the beginning. This may send again newsletter to the same users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1166, 'ABTESTING_TESTMAILINQUEUE', 'At least one of these newsletters is currently in the queue. You need to remove them from the queue or wait the end of sending before continuing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1167, 'ABTESTING_FINALMAILINQUEUE', 'You are currently sending the final message. Please wait the end of the sending or empty the queue before you can launch a new test.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1168, 'ABTESTING_SUCCESSADD', 'The A/B test has been launched successfully. %s emails have been added in the queue.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1169, 'ABTESTING_SENTTO_NUMBER', 'This test will be sent to %1$s / %2$s users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1170, 'ABTESTING_READYTOSEND', 'The test is finished, you can choose which mail to send to the remaining subscribers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1171, 'ABTESTING_COMPLETE', 'The test and corresponding sending are finished', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1172, 'ABTESTING_FINALSEND', 'The newsletter %s has been added into queue for the remaining receivers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1173, 'ABTESTING_TESTEXIST', 'One of the newsletters is used in another test. This test will be displayed here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1174, 'ABTESTING_NEEDVALUE', 'You need to set a percentage of receivers before proceeding', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1175, 'ABTESTING_NOTENOUGHUSER', 'You need at least 50 subscribers to the lists to launch your test (you only have %s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1176, 'ACY_CLASS', 'Class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1177, 'ACY_IMPORT_NO_CONTENT', 'The imported data must contain some content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1178, 'ACY_FIRST_LINES', 'First %s lines of your file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1179, 'ACY_IMPORT_LISTS', 'The imported users will be subscribed to the lists', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1180, 'ACY_IGNORE', 'Ignore', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1181, 'ACY_IGNORE_LINE', 'This first line will be ignored', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1182, 'ACY_CREATE_FIELD', 'Create a new field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1183, 'ACY_ASSIGN_COLUMNS', 'Assign columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1184, 'ACY_ASSIGN_COLUMNS_DESC', 'Assign the imported columns to an AcyMailing field, create new custom fields or ignore some imported columns.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1185, 'ACY_MATCH_DATA', 'Match the data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1186, 'ACY_DOWNLOAD_IMPORT_ERRORS', 'Click here to download all lines containing errors', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1187, 'NOTIF_CONTACT_MENU_DESC', 'Send an e-mail to those e-mail addresses if a user submits the subscription form from menu Subscribe/Modify your subscription.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1188, 'NOTIF_CONTACT_MENU', 'When a user submits the menu subscription form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1189, 'ACY_ONLYAUTOPROCESS', 'You configured AcyMailing to use the automatic send process only. You can\'t trigger the send process via this button unless you allow the manual send process via the AcyMailing configuration page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1190, 'ACY_RAND_LIMIT', 'Randomly select %s users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1191, 'ACY_IGNORE_UNASSIGNED', 'Ignore unassigned columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1192, 'ACY_ZOHO_IMPORT_NEW', 'Only new and modified users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1193, 'ACY_ORDER_SEND_QUEUE', 'Order the send process by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1194, 'ACY_NO_RAND_FOR_MULTQUEUE', 'You should not use the random ordering if you use the multiple queue system.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1195, 'ABTESTING_MISSINGEMAIL', 'At least one email of this test has been deleted. There is nothing to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1196, 'ACY_CATEGORY', 'Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1197, 'ACY_NEW_CATEGORY', 'Create a new category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1198, 'ACYEDITOR_SORTABLE_AREA_TOOLTIP', 'Sortable areas', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1199, 'ACY_CRON_CHANGE_FREQUENCY_WARNING', 'Our web cron service triggers your website every 15 minutes, you should keep a 15 minutes frequency here unless you create your own cron', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1200, 'ACY_OPERATOR_ADDEND', 'Add at the end', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1201, 'ACY_OPERATOR_ADDBEGINNING', 'Add at the beginning', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1202, 'ACY_SUB_GROUPS', 'Include sub-groups', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1203, 'ACYEXPORT_GEOLOC_VALUE', 'Geolocation values', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1204, 'ACYEXPORT_LAST_GEOL_SAVED', 'Last saved data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1205, 'SEPARATOR_FIRST_GEOL_SAVED', 'First saved data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1206, 'ACYFIELD_EDITABLE_CREATE_FRONT', 'Editable on user creation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1207, 'ACYFIELD_EDITABLE_MODIFY_FRONT', 'Editable on user modification', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1208, 'ACY_SUMMARY', 'Summary', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1209, 'ACY_SUMMARY_PLACEHOLDER', 'This description will be displayed in the archive zone.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1210, 'ACY_SENT_ON', 'Sent on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1211, 'ACY_ALL_CATEGORIES', 'All categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1212, 'ACY_FIELD_CAT_TAG', 'HTML tag for categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1213, 'ACY_FIELD_CAT_CLASS', 'CSS class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1214, 'ACY_INBOX_ACTIONS', 'Inbox actions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1215, 'ACY_BUTTON_CONFIRM', 'One clic confirm', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1216, 'ACY_BUTTON_SAVE', 'One clic save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1217, 'ACY_GOTO', 'Go-To', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1218, 'ACY_BUTTON_TEXT', 'Button text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1219, 'ACY_INBOX_ACTIONS_WHITELIST', 'You MUST ask Google to whitelist you in order to be able to use the inbox actions otherwise no button will be displayed in the receiver\'s inbox.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1220, 'ACY_STARTER_SPAMTEST', 'Our spam test tool is a feature available in all our paid versions.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1221, 'ACY_FEATURES', 'Check out our extra features', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1222, 'ACY_FIELD_DISPLAYLIMITED', 'Display only if', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1223, 'ACY_NO_CATEGORY', 'No category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1224, 'ACY_VALID_DELETE_FROM_QUEUE', 'Are you sure you want to delete these %s emails from the queue?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1225, 'ACY_FE_DELETE_BUTTON', 'Delete button behavior', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1226, 'ACY_FE_DELETE_BUTTON_DESC', 'Should the delete button really delete the user or simply unsubscribe him from the current list?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1227, 'ACY_UNSUB_FROM', 'Unsubscribe users from', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1228, 'ACY_NON_LOGGED_IN', 'Non-logged in users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1229, 'ALL_RULES', 'All rules', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1230, 'NO_RULE_SAVED', 'No rule recorded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1231, 'ACY_CLICK_EFFICIENCY', 'Efficiency', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1232, 'ACY_CLICK_EFFICIENCY_DESC', '%s users who opened the email clicked on a link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1233, 'ACY_STAT_OPEN_RATE', 'Open rate', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1234, 'ACY_STAT_OPEN_CLICK', 'Open / Click total', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1235, 'ACY_STAT_OPEN_CLICK_DAY', 'Open / Click per day', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1236, 'ACY_STAT_BROWSER', 'Browsers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1237, 'ACY_STAT_MOBILE_USAGE', 'Devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1238, 'ACY_STAT_MOBILE', 'Mobile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1239, 'ACY_STAT_NOMOBILE', 'Computer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1240, 'ACY_STAT_MOBILEOS', 'Mobile OS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1241, 'ACY_LANG_VERSION', '4.9.3', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_acymailing.ini'),
(1242, 'COM_AJAX', 'Ajax Interface', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1243, 'COM_AJAX_XML_DESCRIPTION', 'An extendable Ajax interface for Joomla.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1244, 'COM_AJAX_SPECIFY_FORMAT', 'Please specify a valid response format, other than that of HTML, such as json, raw, debug, etc.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1245, 'COM_AJAX_METHOD_NOT_EXISTS', 'Method %s does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1246, 'COM_AJAX_FILE_NOT_EXISTS', 'The file at %s does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1247, 'COM_AJAX_MODULE_NOT_ACCESSIBLE', 'Module %s is not published, you do not have access to it, or it\'s not assigned to the current menu item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_ajax.ini'),
(1248, 'COM_CONFIG', 'Admin Services', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1249, 'COM_CONFIG_CONFIGURATION', 'Admin Services Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1250, 'COM_CONFIG_ERROR_CONTROLLER_NOT_FOUND', 'Controller Not found!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1251, 'COM_CONFIG_FIELD_DEFAULT_ACCESS_LEVEL_DESC', 'Select the default access level for new content, menu items and other items created on your site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1252, 'COM_CONFIG_FIELD_DEFAULT_ACCESS_LEVEL_LABEL', 'Default Access Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1253, 'COM_CONFIG_FIELD_DEFAULT_LIST_LIMIT_DESC', 'Sets the default length of lists in the Control Panel for all users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1254, 'COM_CONFIG_FIELD_DEFAULT_LIST_LIMIT_LABEL', 'Default List Limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1255, 'COM_CONFIG_FIELD_METADESC_DESC', 'Enter a description of the overall website that is to be used by search engines. Generally, a maximum of 20 words is optimal.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1256, 'COM_CONFIG_FIELD_METADESC_LABEL', 'Site Meta Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1257, 'COM_CONFIG_FIELD_METAKEYS_DESC', 'Enter the keywords and phrases that best describe your website. Separate keywords and phrases with a comma.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1258, 'COM_CONFIG_FIELD_METAKEYS_LABEL', 'Site Meta Keywords', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1259, 'COM_CONFIG_FIELD_SEF_URL_DESC', 'Select whether or not the URLs are optimised for Search Engines.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1260, 'COM_CONFIG_FIELD_SEF_URL_LABEL', 'Search Engine Friendly URLs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1261, 'COM_CONFIG_FIELD_SITE_NAME_DESC', 'Enter the name of your website. This will be used in various locations (eg the Backend browser title bar and <em>Site Offline</em> pages).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1262, 'COM_CONFIG_FIELD_SITE_NAME_LABEL', 'Site Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1263, 'COM_CONFIG_FIELD_VALUE_AFTER', 'After', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1264, 'COM_CONFIG_FIELD_VALUE_BEFORE', 'Before', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1265, 'COM_CONFIG_FIELD_SITE_OFFLINE_DESC', 'Select whether access to the Site Frontend is available. If Yes, the Frontend will display a message if set such in Backend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1266, 'COM_CONFIG_FIELD_SITE_OFFLINE_LABEL', 'Site Offline', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1267, 'COM_CONFIG_FIELD_SITENAME_PAGETITLES_DESC', 'Begin or end all Page Titles with the site name (for example, My Site Name - My Article Name).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1268, 'COM_CONFIG_FIELD_SITENAME_PAGETITLES_LABEL', 'Include Site Name in Page Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1269, 'COM_CONFIG_METADATA_SETTINGS', 'Metadata Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1270, 'COM_CONFIG_MODULES_MODULE_NAME', 'Module Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1271, 'COM_CONFIG_MODULES_MODULE_TYPE', 'Module Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1272, 'COM_CONFIG_MODULES_SETTINGS_TITLE', 'Module Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1273, 'COM_CONFIG_MODULES_SAVE_SUCCESS', 'Module successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1274, 'COM_CONFIG_SAVE_SUCCESS', 'Configuration successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1275, 'COM_CONFIG_SEO_SETTINGS', 'SEO Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1276, 'COM_CONFIG_SITE_SETTINGS', 'Site Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1277, 'COM_CONFIG_TEMPLATE_SETTINGS', 'Template Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1278, 'COM_CONFIG_XML_DESCRIPTION', 'Frontend Admin Services Configuration Manager.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_config.ini'),
(1279, 'COM_CONTACT_ADDRESS', 'Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1280, 'COM_CONTACT_ARTICLES_HEADING', 'Contact\'s articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1281, 'COM_CONTACT_CAPTCHA_LABEL', 'Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1282, 'COM_CONTACT_CAPTCHA_DESC', 'Type in the textbox what you see in the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1283, 'COM_CONTACT_CAT_NUM', '# of Contacts :', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1284, 'COM_CONTACT_CONTACT_EMAIL_A_COPY_DESC', 'Sends a copy of the message to the address you have supplied.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1285, 'COM_CONTACT_CONTACT_EMAIL_A_COPY_LABEL', 'Send Copy to Yourself', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1286, 'COM_CONTACT_CONTACT_EMAIL_NAME_DESC', 'Your name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1287, 'COM_CONTACT_CONTACT_EMAIL_NAME_LABEL', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1288, 'COM_CONTACT_CONTACT_ENTER_MESSAGE_DESC', 'Enter your message here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1289, 'COM_CONTACT_CONTACT_ENTER_MESSAGE_LABEL', 'Message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1290, 'COM_CONTACT_CONTACT_ENTER_VALID_EMAIL', 'Please enter a valid email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1291, 'COM_CONTACT_CONTENT_TYPE_CONTACT', 'Contact', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1292, 'COM_CONTACT_CONTENT_TYPE_CATEGORY', 'Contact Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1293, 'COM_CONTACT_FILTER_LABEL', 'Filter Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1294, 'COM_CONTACT_FILTER_SEARCH_DESC', 'Contact Filter Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1295, 'COM_CONTACT_CONTACT_MESSAGE_SUBJECT_DESC', 'Enter the subject of your message here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1296, 'COM_CONTACT_CONTACT_MESSAGE_SUBJECT_LABEL', 'Subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1297, 'COM_CONTACT_CONTACT_SEND', 'Send Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1298, 'COM_CONTACT_COPYSUBJECT_OF', 'Copy of: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1299, 'COM_CONTACT_COPYTEXT_OF', 'This is a copy of the following message you sent to %s via %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1300, 'COM_CONTACT_COUNT', 'Contact count:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1301, 'COM_CONTACT_COUNTRY', 'Country', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1302, 'COM_CONTACT_DEFAULT_PAGE_TITLE', 'Contacts', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1303, 'COM_CONTACT_DETAILS', 'Contact', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1304, 'COM_CONTACT_DOWNLOAD_INFORMATION_AS', 'Download information as:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1305, 'COM_CONTACT_EMAIL_BANNEDTEXT', 'The %s of your email contains banned text.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1306, 'COM_CONTACT_EMAIL_DESC', 'Email Address for contact.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1307, 'COM_CONTACT_EMAIL_FORM', 'Contact Form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1308, 'COM_CONTACT_EMAIL_LABEL', 'Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1309, 'COM_CONTACT_EMAIL_THANKS', 'Thank you for your email.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1310, 'COM_CONTACT_ENQUIRY_TEXT', 'This is an enquiry email via %s from:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1311, 'COM_CONTACT_ERROR_CONTACT_NOT_FOUND', 'Contact not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1312, 'COM_CONTACT_FAX', 'Fax', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1313, 'COM_CONTACT_FAX_NUMBER', 'Fax: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1314, 'COM_CONTACT_FORM_LABEL', 'Send an Email. All fields with an * are required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1315, 'COM_CONTACT_FORM_NC', 'Please make sure the form is complete and valid.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1316, 'COM_CONTACT_IMAGE_DETAILS', 'Contact image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1317, 'COM_CONTACT_LINKS', 'Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1318, 'COM_CONTACT_MAILENQUIRY', '%s Enquiry', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1319, 'COM_CONTACT_MOBILE', 'Mobile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1320, 'COM_CONTACT_MOBILE_NUMBER', 'Mobile: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1321, 'COM_CONTACT_NO_CONTACTS', 'There are no Contacts to display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1322, 'COM_CONTACT_NOT_MORE_THAN_ONE_EMAIL_ADDRESS', 'You can\'t enter more than one email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1323, 'COM_CONTACT_OPTIONAL', '(optional)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1324, 'COM_CONTACT_OTHER_INFORMATION', 'Miscellaneous Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1325, 'COM_CONTACT_POSITION', 'Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1326, 'COM_CONTACT_PROFILE', 'Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1327, 'COM_CONTACT_PROFILE_HEADING', 'Contact profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1328, 'COM_CONTACT_SELECT_CONTACT', 'Select a contact:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1329, 'COM_CONTACT_STATE', 'State', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1330, 'COM_CONTACT_SUBURB', 'Suburb', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1331, 'COM_CONTACT_TELEPHONE', 'Phone', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1332, 'COM_CONTACT_TELEPHONE_NUMBER', 'Phone: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1333, 'COM_CONTACT_VCARD', 'vCard', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_contact.ini'),
(1334, 'COM_CONTENT_ACCESS_DELETE_DESC', 'Inherited state for <strong>delete actions</strong> on this article and the calculated state based on the menu selection.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1335, 'COM_CONTENT_ACCESS_EDITSTATE_DESC', 'Inherited state for <strong>edit state actions</strong> on this article and the calculated state based on the menu selection.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1336, 'COM_CONTENT_ACCESS_EDIT_DESC', 'Inherited state for <strong>edit actions</strong> on this article and the calculated state based on the menu selection.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1337, 'COM_CONTENT_ARTICLE_CONTENT', 'Content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1338, 'COM_CONTENT_ARTICLE_HITS', 'Hits: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1339, 'COM_CONTENT_ARTICLE_INFO', 'Details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1340, 'COM_CONTENT_ARTICLE_VOTE_SUCCESS', 'Thank You for rating this Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1341, 'COM_CONTENT_ARTICLE_VOTE_FAILURE', 'You already rated this Article today!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1342, 'COM_CONTENT_AUTHOR_FILTER_LABEL', 'Author Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1343, 'COM_CONTENT_CATEGORY', 'Category: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1344, 'COM_CONTENT_CHECKED_OUT_BY', 'Checked out by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1345, 'COM_CONTENT_CONTENT_TYPE_ARTICLE', 'Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1346, 'COM_CONTENT_CONTENT_TYPE_CATEGORY', 'Article Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1347, 'COM_CONTENT_CREATE_ARTICLE', 'Submit new article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1348, 'COM_CONTENT_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1349, 'COM_CONTENT_CREATED_DATE_ON', 'Created: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1350, 'COM_CONTENT_EDIT_ITEM', 'Edit Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1351, 'COM_CONTENT_ERROR_ARTICLE_NOT_FOUND', 'Article not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1352, 'COM_CONTENT_ERROR_LOGIN_TO_VIEW_ARTICLE', 'Please login to view the article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1353, 'COM_CONTENT_ERROR_PARENT_CATEGORY_NOT_FOUND', 'Parent category not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1354, 'COM_CONTENT_FEED_READMORE', 'Read More ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1355, 'COM_CONTENT_FILTER_SEARCH_DESC', 'Content Filter Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1356, 'COM_CONTENT_FORM_EDIT_ARTICLE', 'Edit an article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1357, 'COM_CONTENT_HEADING_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1358, 'COM_CONTENT_HITS_FILTER_LABEL', 'Hits Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1359, 'COM_CONTENT_INTROTEXT', 'Article must have some content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1360, 'COM_CONTENT_INVALID_RATING', 'Article Rating: Invalid Rating: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1361, 'COM_CONTENT_LAST_UPDATED', 'Last Updated: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1362, 'COM_CONTENT_METADATA', 'Metadata', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1363, 'COM_CONTENT_MODIFIED_DATE', 'Modified Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1364, 'COM_CONTENT_MONTH', 'Month', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1365, 'COM_CONTENT_MORE_ARTICLES', 'More Articles ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1366, 'COM_CONTENT_NEW_ARTICLE', 'New Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1367, 'COM_CONTENT_NO_ARTICLES', 'There are no articles in this category. If subcategories display on this page, they may contain articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1368, 'COM_CONTENT_NONE', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1369, 'COM_CONTENT_NUM_ITEMS', 'Article Count:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1370, 'COM_CONTENT_ON_NEW_CONTENT', 'A new Article has been submitted by \'%1$s\' entitled \'%2$s\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1371, 'COM_CONTENT_ORDERING', 'Ordering:<br />New articles default to the first position in the Category. The ordering can be changed in Backend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1372, 'COM_CONTENT_PAGEBREAK_DOC_TITLE', 'Page Break', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1373, 'COM_CONTENT_PAGEBREAK_INSERT_BUTTON', 'Insert Page Break', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1374, 'COM_CONTENT_PAGEBREAK_TITLE', 'Page Title:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1375, 'COM_CONTENT_PAGEBREAK_TOC', 'Table of Contents Alias:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1376, 'COM_CONTENT_PARENT', 'Parent Category: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1377, 'COM_CONTENT_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1378, 'COM_CONTENT_PUBLISHED_DATE_ON', 'Published: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1379, 'COM_CONTENT_PUBLISHING', 'Publishing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1380, 'COM_CONTENT_READ_MORE', 'Read more: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1381, 'COM_CONTENT_READ_MORE_TITLE', 'Read more ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1382, 'COM_CONTENT_REGISTER_TO_READ_MORE', 'Register to read more ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1383, 'COM_CONTENT_SAVE_SUCCESS', 'Article successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1384, 'COM_CONTENT_SAVE_WARNING', 'Alias already existed so a number was added at the end. If you want to change the alias, please contact a site administrator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1385, 'COM_CONTENT_SELECT_AN_ARTICLE', 'Select an Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1386, 'COM_CONTENT_SUBMIT_SAVE_SUCCESS', 'Article successfully submitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1387, 'COM_CONTENT_TITLE_FILTER_LABEL', 'Title Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1388, 'COM_CONTENT_WRITTEN_BY', 'Written by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1389, 'COM_CONTENT_FIELD_FULL_DESC', 'Image for the single article display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1390, 'COM_CONTENT_FIELD_FULL_LABEL', 'Full Article Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1391, 'COM_CONTENT_FIELD_IMAGE_DESC', 'The image to be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1392, 'COM_CONTENT_FIELD_IMAGE_ALT_DESC', 'Alternative text used for visitors without access to images. Replaced with caption text if it is present.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1393, 'COM_CONTENT_FIELD_IMAGE_ALT_LABEL', 'Alt Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1394, 'COM_CONTENT_FIELD_IMAGE_CAPTION_DESC', 'Caption attached to the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1395, 'COM_CONTENT_FIELD_IMAGE_CAPTION_LABEL', 'Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1396, 'COM_CONTENT_FIELD_INTRO_DESC', 'Image for the intro text layouts such as blogs and featured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1397, 'COM_CONTENT_FIELD_INTRO_LABEL', 'Intro Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1398, 'COM_CONTENT_FIELD_URLC_LABEL', 'Link C', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1399, 'COM_CONTENT_FIELD_URL_DESC', 'Link for display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1400, 'COM_CONTENT_FIELD_URLA_LABEL', 'Link A', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1401, 'COM_CONTENT_FIELD_URLA_LINK_TEXT_LABEL', 'Link A Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1402, 'COM_CONTENT_FIELD_URLB_LABEL', 'Link B', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1403, 'COM_CONTENT_FIELD_URL_LINK_TEXT_DESC', 'Text to display for the link.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1404, 'COM_CONTENT_FIELD_URLB_LINK_TEXT_LABEL', 'Link B Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1405, 'COM_CONTENT_FIELD_URLC_LINK_TEXT_LABEL', 'Link C Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1406, 'COM_CONTENT_FLOAT_DESC', 'Controls placement of the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1407, 'COM_CONTENT_FLOAT_LABEL', 'Image Float', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1408, 'COM_CONTENT_FLOAT_INTRO_LABEL', 'Intro Image float', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1409, 'COM_CONTENT_FLOAT_FULLTEXT_LABEL', 'Full text image float.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1410, 'COM_CONTENT_LEFT', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1411, 'COM_CONTENT_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1412, 'COM_CONTENT_FIELD_URL_LINK_TEXT_LABEL', 'Link Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1413, 'COM_CONTENT_IMAGES_AND_URLS', 'Images and Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_content.ini'),
(1414, 'COM_FINDER', 'Smart Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1415, 'COM_FINDER_ADVANCED_SEARCH_TOGGLE', 'Advanced Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1416, 'COM_FINDER_ADVANCED_TIPS', '<p>Here are a few examples of how you can use the search feature:</p><p>Entering <span class=\"term\">this and that</span> into the search form will return results containing both &quot;this&quot; and &quot;that&quot;.</p><p>Entering <span class=\"term\">this not that</span> into the search form will return results containing &quot;this&quot; and not &quot;that&quot;.</p><p>Entering <span class=\"term\">this or that</span> into the search form will return results containing either &quot;this&quot; or &quot;that&quot;.</p><p>Entering <span class=\"term\">&quot;this and that&quot;</span> (with quotes) into the search form will return results containing the exact phrase &quot;this and that&quot;.</p><p>Search results can also be filtered using a variety of criteria. Select one or more filters below to get started.</p>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1417, 'COM_FINDER_DEFAULT_PAGE_TITLE', 'Search Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1418, 'COM_FINDER_FILTER_BRANCH_LABEL', 'Search by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1419, 'COM_FINDER_FILTER_DATE_BEFORE', 'Before', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1420, 'COM_FINDER_FILTER_DATE_EXACTLY', 'Exactly', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1421, 'COM_FINDER_FILTER_DATE_AFTER', 'After', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1422, 'COM_FINDER_FILTER_DATE1', 'Start Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1423, 'COM_FINDER_FILTER_DATE1_DESC', 'Enter a date in YYYY-MM-DD format.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1424, 'COM_FINDER_FILTER_DATE2', 'End Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1425, 'COM_FINDER_FILTER_DATE2_DESC', 'Enter a date in YYYY-MM-DD format.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1426, 'COM_FINDER_FILTER_SELECT_ALL_LABEL', 'Search All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1427, 'COM_FINDER_FILTER_WHEN_AFTER', 'After', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1428, 'COM_FINDER_FILTER_WHEN_BEFORE', 'Before', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1429, 'COM_FINDER_QUERY_DATE_CONDITION_AFTER', 'after', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1430, 'COM_FINDER_QUERY_DATE_CONDITION_BEFORE', 'before', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1431, 'COM_FINDER_QUERY_DATE_CONDITION_EXACT', 'exactly on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1432, 'COM_FINDER_QUERY_END_DATE', 'ending date <span class=\"when\">%s</span> <span class=\"date\">%s</span>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1433, 'COM_FINDER_QUERY_OPERATOR_AND', 'and', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1434, 'COM_FINDER_QUERY_OPERATOR_OR', 'or', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1435, 'COM_FINDER_QUERY_OPERATOR_NOT', 'not', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1436, 'COM_FINDER_QUERY_FILTER_BRANCH_VENUE', 'venue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1437, 'COM_FINDER_QUERY_START_DATE', 'beginning date <span class=\"when\">%s</span> <span class=\"date\">%s</span>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1438, 'COM_FINDER_QUERY_TAXONOMY_NODE', 'with <span class=\"node\">%s</span> as <span class=\"branch\">%s</span> ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1439, 'COM_FINDER_QUERY_TOKEN_EXCLUDED', '<span class=\"term\">%s</span> should be excluded.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1440, 'COM_FINDER_QUERY_TOKEN_GLUE', ', and ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1441, 'COM_FINDER_QUERY_TOKEN_INTERPRETED', 'Assuming %s, the following results were found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1442, 'COM_FINDER_QUERY_TOKEN_OPTIONAL', '<span class=\"term\">%s</span> is optional.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1443, 'COM_FINDER_QUERY_TOKEN_REQUIRED', '<span class=\"term\">%s</span> is required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1444, 'COM_FINDER_SEARCH_NO_RESULTS_BODY', 'No search results could be found for query: %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1445, 'COM_FINDER_SEARCH_NO_RESULTS_BODY_MULTILANG', 'No search results (in English-UK) could be found for query: %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1446, 'COM_FINDER_SEARCH_NO_RESULTS_HEADING', 'No Results Found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1447, 'COM_FINDER_SEARCH_RESULTS_OF', 'Results <strong>%s</strong> - <strong>%s</strong> of <strong>%s</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1448, 'COM_FINDER_SEARCH_SIMILAR', 'Did you mean: %s?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1449, 'COM_FINDER_SEARCH_TERMS', 'Search Terms:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_finder.ini'),
(1450, 'COM_JOOMGALLERY_EXIF_DATA', 'Exif-Data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1451, 'COM_JOOMGALLERY_GPSTAGS', 'GPS-Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1452, 'COM_JOOMGALLERY_GPS_GPSALTITUDE', 'Altitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1453, 'COM_JOOMGALLERY_GPS_GPSALTITUDEREF', 'Altitude Reference', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1454, 'COM_JOOMGALLERY_GPS_GPSALTITUDEREF_0', 'Sea level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1455, 'COM_JOOMGALLERY_GPS_GPSALTITUDEREF_1', 'Sea level reference (negative value)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1456, 'COM_JOOMGALLERY_GPS_GPSALTITUDEREF_DESCRIPTION', 'Indicates the altitude used as the reference altitude.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1457, 'COM_JOOMGALLERY_GPS_GPSALTITUDE_DESCRIPTION', 'Indicates the altitude based on the reference in GPSAltitudeRef.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1458, 'COM_JOOMGALLERY_GPS_GPSALTITUDE_UNIT', 'metres', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1459, 'COM_JOOMGALLERY_GPS_GPSLATITUDE', 'Latitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1460, 'COM_JOOMGALLERY_GPS_GPSLATITUDEREF', 'North or South Latitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1461, 'COM_JOOMGALLERY_GPS_GPSLATITUDEREF_DESCRIPTION', 'Indicates whether the latitude is north or south latitude.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1462, 'COM_JOOMGALLERY_GPS_GPSLATITUDEREF_N', 'North latitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1463, 'COM_JOOMGALLERY_GPS_GPSLATITUDEREF_S', 'South latitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1464, 'COM_JOOMGALLERY_GPS_GPSLATITUDE_DESCRIPTION', 'Indicates the latitude.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1465, 'COM_JOOMGALLERY_GPS_GPSLONGITUDE', 'Longitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1466, 'COM_JOOMGALLERY_GPS_GPSLONGITUDEREF', 'East or West Longitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1467, 'COM_JOOMGALLERY_GPS_GPSLONGITUDEREF_DESCRIPTION', 'Indicates whether the longitude is east or west longitude.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1468, 'COM_JOOMGALLERY_GPS_GPSLONGITUDEREF_E', 'East longitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1469, 'COM_JOOMGALLERY_GPS_GPSLONGITUDEREF_W', 'West longitude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1470, 'COM_JOOMGALLERY_GPS_GPSLONGITUDE_DESCRIPTION', 'Indicates the longitude.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1471, 'COM_JOOMGALLERY_IFD0TAGS', 'IFD0-Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1472, 'COM_JOOMGALLERY_IFD0_ARTIST', 'Artist Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1473, 'COM_JOOMGALLERY_IFD0_ARTIST_DESCRIPTION', 'Name of Artist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1474, 'COM_JOOMGALLERY_IFD0_COPYRIGHT', 'Copyright', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1475, 'COM_JOOMGALLERY_IFD0_COPYRIGHT_DESCRIPTION', 'Shows copyright information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1476, 'COM_JOOMGALLERY_IFD0_DATETIME', 'Last Modified Date/Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1477, 'COM_JOOMGALLERY_IFD0_DATETIME_DESCRIPTION', 'Date and Time of image was last modified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1478, 'COM_JOOMGALLERY_IFD0_DOTSPERRESOLUTIONUNIT', 'Dots per Resolution Unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1479, 'COM_JOOMGALLERY_IFD0_IMAGEDESCRIPTION', 'Image Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1480, 'COM_JOOMGALLERY_IFD0_IMAGEDESCRIPTION_DESCRIPTION', 'Describes image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1481, 'COM_JOOMGALLERY_IFD0_MAKE', 'Camera Make (Manufacturer)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1482, 'COM_JOOMGALLERY_IFD0_MAKE_DESCRIPTION', 'Shows manufacturer of digicam.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1483, 'COM_JOOMGALLERY_IFD0_MODEL', 'Camera Model', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1484, 'COM_JOOMGALLERY_IFD0_MODEL_DESCRIPTION', 'Shows model number of digicam.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1485, 'COM_JOOMGALLERY_IFD0_ORIENTATION', 'Picture Orientation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1486, 'COM_JOOMGALLERY_IFD0_ORIENTATION_1', 'The 0th row is at the visual top of the image, and the 0th column is the visual left-hand side.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1487, 'COM_JOOMGALLERY_IFD0_ORIENTATION_2', 'The 0th row is at the visual top of the image, and the 0th column is the visual right-hand side.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1488, 'COM_JOOMGALLERY_IFD0_ORIENTATION_3', 'The 0th row is at the visual bottom of the image, and the 0th column is the visual right-hand side.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1489, 'COM_JOOMGALLERY_IFD0_ORIENTATION_4', 'The 0th row is at the visual bottom of the image, and the 0th column is the visual left-hand side.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1490, 'COM_JOOMGALLERY_IFD0_ORIENTATION_5', 'The 0th row is the visual left-hand side of the image, and the 0th column is the visual top.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1491, 'COM_JOOMGALLERY_IFD0_ORIENTATION_6', 'The 0th row is the visual right-hand side of the image, and the 0th column is the visual top.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1492, 'COM_JOOMGALLERY_IFD0_ORIENTATION_7', 'The 0th row is the visual right-hand side of the image, and the 0th column is the visual bottom.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1493, 'COM_JOOMGALLERY_IFD0_ORIENTATION_8', 'The 0th row is the visual left-hand side of the image, and the 0th column is the visual bottom.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1494, 'COM_JOOMGALLERY_IFD0_ORIENTATION_DESCRIPTION', 'The orientation of the camera relative to the scene, when the image was captured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1495, 'COM_JOOMGALLERY_IFD0_PRIMARYCHROMATICITIES', 'Primary Chromaticities', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1496, 'COM_JOOMGALLERY_IFD0_PRIMARYCHROMATICITIES_DESCRIPTION', 'Defines chromaticity of the primaries of the image (Red x,y, Green x,y, Blue x,y coordinates on a 1931 CIE xy chromaticity diagram).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1497, 'COM_JOOMGALLERY_IFD0_REFERENCEBLACKWHITE', 'Reference Black point and White point', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1498, 'COM_JOOMGALLERY_IFD0_REFERENCEBLACKWHITE_DESCRIPTION', 'Shows reference value of black point/white point. In case of YCbCr format, first 2 show black/white of Y, next 2 are Cb, last 2 are Cr. In case of RGB format, first 2 show black/white of R, next 2 are G, last 2 are B.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1499, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT', 'X/Y-Resolution Unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1500, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_1', 'no-unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1501, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_2', 'inch', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1502, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_3', 'cm', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1503, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_4', 'mm', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1504, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_5', '&micro;m', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1505, 'COM_JOOMGALLERY_IFD0_RESOLUTIONUNIT_DESCRIPTION', 'Resolution Unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1506, 'COM_JOOMGALLERY_IFD0_SOFTWARE', 'Software/Firmware', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1507, 'COM_JOOMGALLERY_IFD0_SOFTWARE_DESCRIPTION', 'Shows firmware(internal software of digicam) version number.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(1508, 'COM_JOOMGALLERY_IFD0_WHITEPOINT', 'White Point Chromaticity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1509, 'COM_JOOMGALLERY_IFD0_WHITEPOINT_DESCRIPTION', 'Defines chromaticity of white point of the image (x,y coordinates on a 1931 CIE xy chromaticity diagram).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1510, 'COM_JOOMGALLERY_IFD0_XRESOLUTION', 'X-Resolution', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1511, 'COM_JOOMGALLERY_IFD0_XRESOLUTION_DESCRIPTION', 'Display/Print x-resolution of image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1512, 'COM_JOOMGALLERY_IFD0_YCBCRCOEFFICIENTS', 'Y/Cb/Cr Coefficients', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1513, 'COM_JOOMGALLERY_IFD0_YCBCRCOEFFICIENTS_DESCRIPTION', 'When image format is YCbCr, this value shows a constant to translate it to RGB format.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1514, 'COM_JOOMGALLERY_IFD0_YCBCRPOSITIONING', 'Y/Cb/Cr Positioning (Subsampling)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1515, 'COM_JOOMGALLERY_IFD0_YCBCRPOSITIONING_1', 'Chrominance components centred in relation to luminance components', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1516, 'COM_JOOMGALLERY_IFD0_YCBCRPOSITIONING_2', 'Chrominance and luminance components Co-Sited', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1517, 'COM_JOOMGALLERY_IFD0_YCBCRPOSITIONING_DESCRIPTION', 'Specifies location of chrominance and luminance components.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1518, 'COM_JOOMGALLERY_IFD0_YRESOLUTION', 'Y-Resolution', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1519, 'COM_JOOMGALLERY_IFD0_YRESOLUTION_DESCRIPTION', 'Display/Print y-resolution of image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1520, 'COM_JOOMGALLERY_SECONDS', 'seconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1521, 'COM_JOOMGALLERY_SUBIFDTAGS', 'Sub-IFD-Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1522, 'COM_JOOMGALLERY_SUBIFD_APERTUREVALUE', 'APEX Aperture Value (Av)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1523, 'COM_JOOMGALLERY_SUBIFD_APERTUREVALUE_DESCRIPTION', 'The actual aperture value of lens when the image was taken. Unit is APEX.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1524, 'COM_JOOMGALLERY_SUBIFD_APERTUREVALUE_UNIT', 'Av', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1525, 'COM_JOOMGALLERY_SUBIFD_BRIGHTNESSVALUE', 'APEX Brightness Value (Bv)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1526, 'COM_JOOMGALLERY_SUBIFD_BRIGHTNESSVALUE_DESCRIPTION', 'Brightness of taken subject, unit is APEX.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1527, 'COM_JOOMGALLERY_SUBIFD_BRIGHTNESSVALUE_UNIT', 'Bv', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1528, 'COM_JOOMGALLERY_SUBIFD_COLORSPACE', 'Color Space', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1529, 'COM_JOOMGALLERY_SUBIFD_COLORSPACE_65535', 'Uncalibrated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1530, 'COM_JOOMGALLERY_SUBIFD_COLORSPACE_DESCRIPTION', 'Defines Color Space.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1531, 'COM_JOOMGALLERY_SUBIFD_COLORSPACE_SRGB', 'sRGB', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1532, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION', 'Components Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1533, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_0', 'Does not exist', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1534, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_1', 'Y (Luminance)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1535, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_2', 'Cb (Chroma minus Blue)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1536, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_3', 'Cr(Chroma minus Red)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1537, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_4', 'R (Red)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1538, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_5', 'G (Green)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1539, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_6', 'B (Blue)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1540, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_COMPONENT', 'Component ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1541, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_DESCRIPTION', 'Information specific to compressed data.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1542, 'COM_JOOMGALLERY_SUBIFD_COMPONENTSCONFIGURATION_UNKNOWN', 'Unknown value:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1543, 'COM_JOOMGALLERY_SUBIFD_COMPRESSEDBITSPERPIXEL', 'Compressed Bits Per Pixel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1544, 'COM_JOOMGALLERY_SUBIFD_COMPRESSEDBITSPERPIXEL_DESCRIPTION', 'The compression mode used for a compressed image is indicated in unit bits per pixel.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1545, 'COM_JOOMGALLERY_SUBIFD_COMPRESSEDBITSPERPIXEL_UNIT', 'bpp', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1546, 'COM_JOOMGALLERY_SUBIFD_CONTRAST', 'Contrast', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1547, 'COM_JOOMGALLERY_SUBIFD_CONTRAST_0', 'Normal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1548, 'COM_JOOMGALLERY_SUBIFD_CONTRAST_1', 'Soft', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1549, 'COM_JOOMGALLERY_SUBIFD_CONTRAST_2', 'Hard', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1550, 'COM_JOOMGALLERY_SUBIFD_CONTRAST_DESCRIPTION', 'This tag indicates the direction of contrast processing applied by the camera when the image was shot.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1551, 'COM_JOOMGALLERY_SUBIFD_DATETIMEDIGITIZED', 'Date and Time when Digitized', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1552, 'COM_JOOMGALLERY_SUBIFD_DATETIMEDIGITIZED_DESCRIPTION', 'Date/Time of image digitized.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1553, 'COM_JOOMGALLERY_SUBIFD_DATETIMEORIGINAL', 'Date and Time of Original', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1554, 'COM_JOOMGALLERY_SUBIFD_DATETIMEORIGINAL_DESCRIPTION', 'Date/Time of original image taken.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1555, 'COM_JOOMGALLERY_SUBIFD_DIGITALZOOMRATIO', 'Digital Zoom Ratio', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1556, 'COM_JOOMGALLERY_SUBIFD_DIGITALZOOMRATIO_DESCRIPTION', 'This tag indicates the digital zoom ratio when the image was shot.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1557, 'COM_JOOMGALLERY_SUBIFD_EXIFIMAGELENGTH', 'Image Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1558, 'COM_JOOMGALLERY_SUBIFD_EXIFIMAGELENGTH_DESCRIPTION', 'Size of main image (height).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1559, 'COM_JOOMGALLERY_SUBIFD_EXIFIMAGEWIDTH', 'Image Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1560, 'COM_JOOMGALLERY_SUBIFD_EXIFIMAGEWIDTHLENGTH_UNIT', 'px', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1561, 'COM_JOOMGALLERY_SUBIFD_EXIFIMAGEWIDTH_DESCRIPTION', 'Size of main image (width).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1562, 'COM_JOOMGALLERY_SUBIFD_EXIFVERSION', 'Exif Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1563, 'COM_JOOMGALLERY_SUBIFD_EXIFVERSION_DESCRIPTION', 'Exif version number.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1564, 'COM_JOOMGALLERY_SUBIFD_EXIFVERSION_VERSION', 'Version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1565, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREBIASVALUE', 'APEX Exposure Bias Value (Ev)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1566, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREBIASVALUE_DESCRIPTION', 'The exposure bias. The unit is the APEX value.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1567, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREBIASVALUE_UNIT', 'Ev', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1568, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREINDEX', 'Exposure Index', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1569, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREINDEX_DESCRIPTION', 'Indicates the exposure index selected on the camera or input device at the time the image is captured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1570, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREMODE', 'Exposure Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1571, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREMODE_0', 'Auto Exposure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1572, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREMODE_1', 'Manual Exposure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1573, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREMODE_2', 'Auto Bracket', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1574, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREMODE_DESCRIPTION', 'Indicates the exposure mode selected on the camera or input device at the time the image is captured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1575, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM', 'Exposure Program', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1576, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_0', 'Not defined', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1577, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_1', 'Manual', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1578, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_2', 'Normal program', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1579, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_3', 'Aperture priority', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1580, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_4', 'Shutter priority', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1581, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_5', 'Creative program (biased toward depth of field)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1582, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_6', 'Action program (biased toward fast shutter speed)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1583, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_7', 'Portrait mode (for closeup photos with the background out of focus)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1584, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_8', 'Landscape mode (for landscape photos with the background in focus)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1585, 'COM_JOOMGALLERY_SUBIFD_EXPOSUREPROGRAM_DESCRIPTION', 'Exposure program that the camera used when image was taken.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1586, 'COM_JOOMGALLERY_SUBIFD_EXPOSURETIME', 'Exposure Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1587, 'COM_JOOMGALLERY_SUBIFD_EXPOSURETIME_DESCRIPTION', 'Exposure time (reciprocal of shutter speed).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1588, 'COM_JOOMGALLERY_SUBIFD_FILESOURCE', 'File Source', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1589, 'COM_JOOMGALLERY_SUBIFD_FILESOURCE_3', 'Digital Still Camera', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1590, 'COM_JOOMGALLERY_SUBIFD_FILESOURCE_DESCRIPTION', 'Shows source of image file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1591, 'COM_JOOMGALLERY_SUBIFD_FILESOURCE_UNKNOWN', 'Source unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1592, 'COM_JOOMGALLERY_SUBIFD_FLASH', 'Flash', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1593, 'COM_JOOMGALLERY_SUBIFD_FLASH_0', 'Flash did not fire', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1594, 'COM_JOOMGALLERY_SUBIFD_FLASH_13', 'Flash fired, compulsory flash mode, return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1595, 'COM_JOOMGALLERY_SUBIFD_FLASH_15', 'Flash fired, compulsory flash mode, return light detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1596, 'COM_JOOMGALLERY_SUBIFD_FLASH_16', 'Flash did not fire, compulsory flash mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1597, 'COM_JOOMGALLERY_SUBIFD_FLASH_1', 'Flash fired', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1598, 'COM_JOOMGALLERY_SUBIFD_FLASH_20', 'Off, Flash did not fire, return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1599, 'COM_JOOMGALLERY_SUBIFD_FLASH_24', 'Flash did not fire, auto mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1600, 'COM_JOOMGALLERY_SUBIFD_FLASH_25', 'Flash fired, auto mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1601, 'COM_JOOMGALLERY_SUBIFD_FLASH_29', 'Flash fired, auto mode, return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1602, 'COM_JOOMGALLERY_SUBIFD_FLASH_31', 'Flash fired, auto mode, return light detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1603, 'COM_JOOMGALLERY_SUBIFD_FLASH_32', 'No flash function', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1604, 'COM_JOOMGALLERY_SUBIFD_FLASH_48', 'Off, no flash function', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1605, 'COM_JOOMGALLERY_SUBIFD_FLASH_5', 'Strobe return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1606, 'COM_JOOMGALLERY_SUBIFD_FLASH_65', 'Flash fired, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1607, 'COM_JOOMGALLERY_SUBIFD_FLASH_69', 'Flash fired, red-eye reduction mode, return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1608, 'COM_JOOMGALLERY_SUBIFD_FLASH_71', 'Flash fired, red-eye reduction mode, return light detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1609, 'COM_JOOMGALLERY_SUBIFD_FLASH_73', 'Flash fired, compulsory flash mode, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1610, 'COM_JOOMGALLERY_SUBIFD_FLASH_77', 'Flash fired, compulsory flash mode, red-eye reduction mode, return light not detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1611, 'COM_JOOMGALLERY_SUBIFD_FLASH_79', 'Flash fired, compulsory flash mode, red-eye reduction mode, return light detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1612, 'COM_JOOMGALLERY_SUBIFD_FLASH_7', 'Strobe return light detected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1613, 'COM_JOOMGALLERY_SUBIFD_FLASH_80', 'Off, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1614, 'COM_JOOMGALLERY_SUBIFD_FLASH_88', 'Flash did not fire, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1615, 'COM_JOOMGALLERY_SUBIFD_FLASH_89', 'Flash fired, auto mode, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1616, 'COM_JOOMGALLERY_SUBIFD_FLASH_8', 'On, Flash did not fire', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1617, 'COM_JOOMGALLERY_SUBIFD_FLASH_93', 'Flash fired, auto mode, return light not detected, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1618, 'COM_JOOMGALLERY_SUBIFD_FLASH_95', 'Flash fired, auto mode, return light detected, red-eye reduction mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1619, 'COM_JOOMGALLERY_SUBIFD_FLASH_9', 'Flash fired, compulsory flash mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1620, 'COM_JOOMGALLERY_SUBIFD_FLASH_DESCRIPTION', 'Shows information about flash if used.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1621, 'COM_JOOMGALLERY_SUBIFD_FNUMBER', 'Aperture F Number', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1622, 'COM_JOOMGALLERY_SUBIFD_FNUMBER_DESCRIPTION', 'The actual F-number(F-stop) of lens when the image was taken.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1623, 'COM_JOOMGALLERY_SUBIFD_FNUMBER_F', 'F', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1624, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTH', 'Focal Length', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1625, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTHIN35MMFILM', 'Equivalent Focal Length In 35mm Film', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1626, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTHIN35MMFILM_DESCRIPTION', 'This tag indicates the equivalent focal length assuming a 35mm film camera, in mm.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1627, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTHIN35MMFILM_UNIT', 'mm', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1628, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTH_DESCRIPTION', 'Focal length of lens used to take image. Unit is millimeter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1629, 'COM_JOOMGALLERY_SUBIFD_FOCALLENGTH_UNIT', 'mm', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1630, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANERESOLUTIONUNIT', 'Focal Plane Resolution Unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1631, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANERESOLUTIONUNIT_1', 'No unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1632, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANERESOLUTIONUNIT_2', 'Inches', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1633, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANERESOLUTIONUNIT_3', 'Centimetres', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1634, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANERESOLUTIONUNIT_DESCRIPTION', 'Indicates the unit for measuring FocalPlaneXResolution and FocalPlaneYResolution.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1635, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANEXRESOLUTION', 'Focal Plane X Resolution', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1636, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANEXRESOLUTION_DESCRIPTION', 'Indicates the number of pixels in the image width (X) direction per FocalPlaneResolutionUnit on the camera focal plane.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1637, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANEXYRESOLUTION_UNIT', 'Pixel per Focal Plane Resolution Unit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1638, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANEYRESOLUTION', 'Focal Plane Y Resolution', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1639, 'COM_JOOMGALLERY_SUBIFD_FOCALPLANEYRESOLUTION_DESCRIPTION', 'Indicates the number of pixels in the image height (Y) direction per FocalPlaneResolutionUnit on t he camera focal plane.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1640, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL', 'Gain Control', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1641, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_0', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1642, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_1', 'Low gain up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1643, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_2', 'High gain up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1644, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_3', 'Low gain down', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1645, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_4', 'High gain down', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1646, 'COM_JOOMGALLERY_SUBIFD_GAINCONTROL_DESCRIPTION', 'This tag indicates the degree of overall image gain adjustment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1647, 'COM_JOOMGALLERY_SUBIFD_ISOSPEEDRATINGS', 'ISO Speed Ratings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1648, 'COM_JOOMGALLERY_SUBIFD_ISOSPEEDRATINGS_DESCRIPTION', 'CCD sensitivity equivalent to Ag-Hr film speedrate.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1649, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE', 'Light Source', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1650, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_0', 'Unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1651, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_10', 'Cloudy weather', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1652, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_11', 'Shade', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1653, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_12', 'Daylight fluorescent (D 5700 - 7100K)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1654, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_13', 'Day white fluorescent (N 4600 - 5400K)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1655, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_14', 'Cool white fluorescent (W 3900 - 4500K)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1656, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_15', 'White fluorescent (WW 3200 - 3700K)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1657, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_17', 'Standard light A', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1658, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_18', 'Standard light B', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1659, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_19', 'Standard light C', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1660, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_1', 'Daylight', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1661, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_20', 'D55', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1662, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_21', 'D65', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1663, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_22', 'D75', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1664, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_23', 'D50', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1665, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_24', 'ISO studio tungsten', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1666, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_255', 'Other light source', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1667, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_2', 'Fluorescent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1668, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_3', 'Tungsten (incandescent light)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1669, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_4', 'Flash', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1670, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_9', 'Fine weather', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1671, 'COM_JOOMGALLERY_SUBIFD_LIGHTSOURCE_DESCRIPTION', 'Light source, actually this means white balance setting.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1672, 'COM_JOOMGALLERY_SUBIFD_MAXAPERTUREVALUE', 'APEX Maximum Aperture Value', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1673, 'COM_JOOMGALLERY_SUBIFD_MAXAPERTUREVALUE_DESCRIPTION', 'The smallest F number of the lens. The unit is the APEX value.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1674, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE', 'Metering Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1675, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_0', 'Unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1676, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_1', 'Average', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1677, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_255', 'Other', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1678, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_2', 'Center Weighted Average', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1679, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_3', 'Spot', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1680, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_4', 'Multi-Spot', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1681, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_5', 'Pattern', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1682, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_6', 'Partial', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1683, 'COM_JOOMGALLERY_SUBIFD_METERINGMODE_DESCRIPTION', 'Exposure metering method.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1684, 'COM_JOOMGALLERY_SUBIFD_SATURATION', 'Saturation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1685, 'COM_JOOMGALLERY_SUBIFD_SATURATION_0', 'Normal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1686, 'COM_JOOMGALLERY_SUBIFD_SATURATION_1', 'low Saturation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1687, 'COM_JOOMGALLERY_SUBIFD_SATURATION_2', 'high Saturation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1688, 'COM_JOOMGALLERY_SUBIFD_SATURATION_DESCRIPTION', 'This tag indicates the direction of saturation processing applied by the camera when the image was shot.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1689, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE', 'Scene Capture Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1690, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE_0', 'Standard', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1691, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE_1', 'Landscape', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1692, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE_2', 'Portrait', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1693, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE_3', 'Night scene', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1694, 'COM_JOOMGALLERY_SUBIFD_SCENECAPTURETYPE_DESCRIPTION', 'This tag indicates the type of scene that was shot. It can also be used to record the mode in which the image was shot. Note that this differs from the scene type (SceneType) tag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1695, 'COM_JOOMGALLERY_SUBIFD_SCENETYPE', 'Scene Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1696, 'COM_JOOMGALLERY_SUBIFD_SCENETYPE_1', 'A directly photographed image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1697, 'COM_JOOMGALLERY_SUBIFD_SCENETYPE_DESCRIPTION', 'Shows type of scene', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1698, 'COM_JOOMGALLERY_SUBIFD_SCENETYPE_UNKNOWN', 'Type unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1699, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD', 'Sensing Method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1700, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_1', 'Not defined', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1701, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_2', 'One-chip color area sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1702, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_3', 'Two-chip color area sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1703, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_4', 'Three-chip color area sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1704, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_5', 'Color sequential area sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1705, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_7', 'Trilinear sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1706, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_8', 'Color sequential linear sensor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1707, 'COM_JOOMGALLERY_SUBIFD_SENSINGMETHOD_DESCRIPTION', 'Shows type of image sensor unit.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1708, 'COM_JOOMGALLERY_SUBIFD_SHARPNESS', 'Sharpness', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1709, 'COM_JOOMGALLERY_SUBIFD_SHARPNESS_0', 'Normal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1710, 'COM_JOOMGALLERY_SUBIFD_SHARPNESS_1', 'Soft', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1711, 'COM_JOOMGALLERY_SUBIFD_SHARPNESS_2', 'Hard', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1712, 'COM_JOOMGALLERY_SUBIFD_SHARPNESS_DESCRIPTION', 'This tag indicates the direction of sharpness processing applied by the camera when the image was shot.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1713, 'COM_JOOMGALLERY_SUBIFD_SHUTTERSPEEDVALUE', 'APEX Shutter Speed Value (Tv)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1714, 'COM_JOOMGALLERY_SUBIFD_SHUTTERSPEEDVALUE_DESCRIPTION', 'Shutter speed. The unit is the APEX (Additive System of Photographic Exposure) setting.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1715, 'COM_JOOMGALLERY_SUBIFD_SHUTTERSPEEDVALUE_UNIT', 'Tv', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1716, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCE', 'Subject Distance', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1717, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE', 'Subject Distance Range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1718, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE_0', 'Unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1719, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE_1', 'Macro', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1720, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE_2', 'Close view', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1721, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE_3', 'Distant view', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1722, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCERANGE_DESCRIPTION', 'This tag indicates the distance to the subject.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1723, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCE_DESCRIPTION', 'The distance to the subject, given in meters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1724, 'COM_JOOMGALLERY_SUBIFD_SUBJECTDISTANCE_UNIT', 'metres', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1725, 'COM_JOOMGALLERY_SUBIFD_WHITEBALANCE', 'White Balance', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1726, 'COM_JOOMGALLERY_SUBIFD_WHITEBALANCE_0', 'Auto', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1727, 'COM_JOOMGALLERY_SUBIFD_WHITEBALANCE_1', 'Manual', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1728, 'COM_JOOMGALLERY_SUBIFD_WHITEBALANCE_DESCRIPTION', 'This tag indicates the white balance mode set when the image was shot.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1729, 'COM_JOOMGALLERY_TAG', 'Tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1730, 'COM_JOOMGALLERY_TAGDESCRIPTION', 'Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1731, 'COM_JOOMGALLERY_TAGNAME', 'Tag-Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1732, 'COM_JOOMGALLERY_TAGNR', 'Tag-Nr.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.exif.ini'),
(1733, 'COM_JOOMGALLERY_AJAXUPLOAD_ALERT_FILENAME_DOUBLE', 'You already have selected that image for upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1734, 'COM_JOOMGALLERY_AJAXUPLOAD_ALERT_FILE_EMPTY', 'Image is empty, please select files again without it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1735, 'COM_JOOMGALLERY_AJAXUPLOAD_ALERT_FILE_TOO_SMALL', 'Image is too small, minimum file size is', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1736, 'COM_JOOMGALLERY_AJAXUPLOAD_ALERT_NO_FILES', 'No images to upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1737, 'COM_JOOMGALLERY_AJAXUPLOAD_ALERT_ON_LEAVE', 'The images are being uploaded, if you leave now the upload will be cancelled.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1738, 'COM_JOOMGALLERY_AJAXUPLOAD_CLEAR_UPLOAD_LIST', 'Clear list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1739, 'COM_JOOMGALLERY_AJAXUPLOAD_DRAGNDROPHINT', '* Note that Drag and Drop may not be supported with your browser.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1740, 'COM_JOOMGALLERY_AJAXUPLOAD_DRAGZONETEXT', 'Drop images here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1741, 'COM_JOOMGALLERY_AJAXUPLOAD_DROPPROCESSINGTEXT', 'Processing dropped images...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1742, 'COM_JOOMGALLERY_AJAXUPLOAD_ERROR_CHUNKSDIR_NOTWRITABLE', 'Directory %s for saving image chunks isn\'t writable.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1743, 'COM_JOOMGALLERY_AJAXUPLOAD_PROCESSING', 'Processing...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1744, 'COM_JOOMGALLERY_AJAXUPLOAD_SELECT_IMAGES', 'Select or drop images here for upload *', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1745, 'COM_JOOMGALLERY_AJAXUPLOAD_UPLOAD_FAILED', 'Upload failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1746, 'COM_JOOMGALLERY_CATEGORY_COOLIRISLINK_TEXT', 'Start Cooliris!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1747, 'COM_JOOMGALLERY_CATEGORY_FEED_SUBCATEGORIES_TIPTEXT', 'Here you can subscribe to a news feed for the images in this category and all of its sub-categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1748, 'COM_JOOMGALLERY_CATEGORY_FEED_TIPCAPTION', 'Subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1749, 'COM_JOOMGALLERY_CATEGORY_FEED_TIPTEXT', 'Here you can subscribe to a news feed for the images in this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1750, 'COM_JOOMGALLERY_CATEGORY_MSG_DELETE_NOT_PERMITTED', 'You are not allowed to delete this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1751, 'COM_JOOMGALLERY_CATEGORY_MSG_EDITSTATE_NOT_PERMITTED', 'You are not allowed to edit the state of this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1752, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY', 'Sort by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1753, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_ASC', 'ascending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1754, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1755, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1756, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_DEFAULT', 'General Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1757, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_DESC', 'descending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1758, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_HITS', 'Number of Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1759, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_RATING', 'Rating', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1760, 'COM_JOOMGALLERY_CATEGORY_OPTION_USER_ORDERBY_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1761, 'COM_JOOMGALLERY_CATEGORY_THERE_ARE_IMAGES_IN_CATEGORY', 'There are %s images in category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1762, 'COM_JOOMGALLERY_CATEGORY_THERE_ARE_SUBCATEGORIES_IN_CATEGORY', 'There are %d sub-categories in this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1763, 'COM_JOOMGALLERY_COMMON_ACCESS', 'Access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1764, 'COM_JOOMGALLERY_COMMON_ACTION', 'Action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1765, 'COM_JOOMGALLERY_COMMON_ALERT_CATEGORY_MUST_HAVE_TITLE', 'Category must have a title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1766, 'COM_JOOMGALLERY_COMMON_ALERT_IMAGE_MUST_HAVE_TITLE', 'Image must have a title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1767, 'COM_JOOMGALLERY_COMMON_ALERT_NO_DETAILVIEW_FOR_GUESTS', 'Guests are not allowed to view image details. Please login.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1768, 'COM_JOOMGALLERY_COMMON_ALERT_SURE_DELETE_SELECTED_ITEM', 'Are you sure you want to delete selected item?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1769, 'COM_JOOMGALLERY_COMMON_ALERT_WRONG_EXTENSION', 'Wrong Filetype! Only .jpg, .jpeg, .jpe, .gif and .png are acceptable.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1770, 'COM_JOOMGALLERY_COMMON_ALERT_WRONG_FILENAME', 'No special characters are allowed in this field (a-z, A-Z, -, Blanks and _ are acceptable).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1771, 'COM_JOOMGALLERY_COMMON_ALERT_WRONG_VALUE', 'Incorrect entry in field!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1772, 'COM_JOOMGALLERY_COMMON_ALERT_YOU_MUST_SELECT_CATEGORY', 'You must select a category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1773, 'COM_JOOMGALLERY_COMMON_ALERT_YOU_MUST_SELECT_ONE_FILE', 'Please select a file. ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1774, 'COM_JOOMGALLERY_COMMON_ALERT_YOU_MUST_SELECT_ONE_IMAGE', 'Please select an image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1775, 'COM_JOOMGALLERY_COMMON_ALIAS', 'Alias', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1776, 'COM_JOOMGALLERY_COMMON_ALL', '- Select Category -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1777, 'COM_JOOMGALLERY_COMMON_APPROVED', 'Approved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1778, 'COM_JOOMGALLERY_COMMON_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1779, 'COM_JOOMGALLERY_COMMON_AUTHOR_OWNER', 'Author/Owner', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1780, 'COM_JOOMGALLERY_COMMON_AUTHOR_VAR', 'Author: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1781, 'COM_JOOMGALLERY_COMMON_BACK_TO_CATEGORY', 'Back to Category Overview', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1782, 'COM_JOOMGALLERY_COMMON_BACK_TO_GALLERY', 'Back to Gallery Overview', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1783, 'COM_JOOMGALLERY_COMMON_BACK_TO_USER_PANEL', 'Back to \'My Gallery\'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1784, 'COM_JOOMGALLERY_COMMON_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1785, 'COM_JOOMGALLERY_COMMON_CATEGORIES', 'Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1786, 'COM_JOOMGALLERY_COMMON_CATEGORIES_MORE_RESULTS', 'More Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1787, 'COM_JOOMGALLERY_COMMON_CATEGORIES_NO_RESULTS', 'No suitable categories found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1788, 'COM_JOOMGALLERY_COMMON_CATEGORY', 'Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1789, 'COM_JOOMGALLERY_COMMON_CATEGORY_VAR', 'Category: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1790, 'COM_JOOMGALLERY_COMMON_CHECK_PERMISSIONS', 'Check permissions.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1791, 'COM_JOOMGALLERY_COMMON_COMMENT', 'Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1792, 'COM_JOOMGALLERY_COMMON_COMMENTS_LASTDATE', 'Last commented:<br />%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1793, 'COM_JOOMGALLERY_COMMON_COMMENTS_VAR', 'Comments: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1794, 'COM_JOOMGALLERY_COMMON_COMMENT_WITH_AUTHOR', '%1$s: \"%2$s\"', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1795, 'COM_JOOMGALLERY_COMMON_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1796, 'COM_JOOMGALLERY_COMMON_DECIMAL_SEPARATOR', '.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1797, 'COM_JOOMGALLERY_COMMON_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1798, 'COM_JOOMGALLERY_COMMON_DELETE_CATEGORY_TIPCAPTION', 'Delete category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1799, 'COM_JOOMGALLERY_COMMON_DELETE_CATEGORY_TIPTEXT', 'Click to delete the category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1800, 'COM_JOOMGALLERY_COMMON_DELETE_IMAGE_TIPCAPTION', 'Delete image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1801, 'COM_JOOMGALLERY_COMMON_DELETE_IMAGE_TIPTEXT', 'Click to delete the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1802, 'COM_JOOMGALLERY_COMMON_DESCRIPTION', 'Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1803, 'COM_JOOMGALLERY_COMMON_DESCRIPTION_VAR', 'Description: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1804, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGES_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1805, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGES_TIPCAPTION', 'Add all images to list of zip download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1806, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGES_TIPTEXT', 'Here you can add all images of this category (without the ones of the sub-categories) to your list for the zip download. With the link <i>Zip Download</i> you can see all chosen images and download them in a zipfile.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1807, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGE_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1808, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGE_TIPCAPTION', 'Add image to list of zip download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1809, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_ADD_IMAGE_TIPTEXT', 'Here you can add this image to your list for the zip download. With the link <i>Zip Download</i> you can see all chosen images and download them in a zipfile.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1810, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_DOWNLOAD_ALLOWED_TIPTEXT', 'You are then able to download these images all together in a zipfile, too.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1811, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_DOWNLOAD_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1812, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_DOWNLOAD_TIPTEXT', 'Here you can see all the images chosen by you for the zip download (These images can be downloaded all together in a zipfile). In order to add an image to this list you have to click on the respective symbol near to the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1813, 'COM_JOOMGALLERY_COMMON_DOWNLOADZIP_MY', 'Zip Download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1814, 'COM_JOOMGALLERY_COMMON_DOWNLOAD_LOGIN_TIPTEXT', 'You need to login to download the image! ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1815, 'COM_JOOMGALLERY_COMMON_DOWNLOAD_TIPCAPTION', 'Download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1816, 'COM_JOOMGALLERY_COMMON_DOWNLOAD_TIPTEXT', 'Click to download the image. ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1817, 'COM_JOOMGALLERY_COMMON_EDIT_CATEGORY_TIPCAPTION', 'Edit category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1818, 'COM_JOOMGALLERY_COMMON_EDIT_CATEGORY_TIPTEXT', 'Click to edit the category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1819, 'COM_JOOMGALLERY_COMMON_EDIT_IMAGE_TIPCAPTION', 'Edit image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1820, 'COM_JOOMGALLERY_COMMON_EDIT_IMAGE_TIPTEXT', 'Click to edit the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(1821, 'COM_JOOMGALLERY_COMMON_ERROR_CATEGORY_MUST_HAVE_TITLE', 'Category must have a title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1822, 'COM_JOOMGALLERY_COMMON_ERROR_IMAGE_MUST_HAVE_TITLE', 'Image must have a title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1823, 'COM_JOOMGALLERY_COMMON_ERROR_IMAGE_NOT_FOUND', 'Image with ID %d not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1824, 'COM_JOOMGALLERY_COMMON_ERROR_INVALID_FILENAME', 'Invalid name of image for file system. Please ask your administrator for more information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1825, 'COM_JOOMGALLERY_COMMON_ERROR_NO_CATEGORY_SELECTED', 'No category selected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1826, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGES_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the favourites function.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1827, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGES_TIPCAPTION', 'Add all images to favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1828, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGES_TIPTEXT', 'Here you can add all images of this category (without the ones of the sub-categories) to your favourites. With the link <i>My Favourites</i> you can see all images chosen by you.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1829, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGE_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the favourites function.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1830, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGE_TIPCAPTION', 'Add image to favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1831, 'COM_JOOMGALLERY_COMMON_FAVOURITES_ADD_IMAGE_TIPTEXT', 'Here you can add this image to your favourites. With the link <i>My Favourites</i> you can see all images chosen by you.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1832, 'COM_JOOMGALLERY_COMMON_FAVOURITES_DOWNLOAD_NOT_ALLOWED_TIPTEXT', 'Sorry, you have not enough rights to use the favourites function.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1833, 'COM_JOOMGALLERY_COMMON_FAVOURITES_DOWNLOAD_TIPTEXT', 'Here you can see all your favourite images. In order to add an image to your favourites you have to click on the respective symbol near to the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1834, 'COM_JOOMGALLERY_COMMON_FAVOURITES_MY', 'My Favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1835, 'COM_JOOMGALLERY_COMMON_FILTER_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1836, 'COM_JOOMGALLERY_COMMON_GALLERY', 'Gallery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1837, 'COM_JOOMGALLERY_COMMON_GUEST', 'Guest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1838, 'COM_JOOMGALLERY_COMMON_HIDDEN_ASTERISK', '*', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1839, 'COM_JOOMGALLERY_COMMON_HITS', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1840, 'COM_JOOMGALLERY_COMMON_HITS_VAR', 'Hits: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1841, 'COM_JOOMGALLERY_COMMON_HOME', 'Home', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1842, 'COM_JOOMGALLERY_COMMON_ID', 'ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1843, 'COM_JOOMGALLERY_COMMON_IMAGE', 'Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1844, 'COM_JOOMGALLERY_COMMON_IMAGE_NAME', 'Image Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1845, 'COM_JOOMGALLERY_COMMON_IMG_HW', '%s KB (%s x %s px)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1846, 'COM_JOOMGALLERY_COMMON_IMPORTANT_NOTICE', 'I M P O R T A N T &nbsp;&nbsp;&nbsp; N O T I C E ! !', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1847, 'COM_JOOMGALLERY_COMMON_MSG_CATEGORY_SAVED', 'Category saved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1848, 'COM_JOOMGALLERY_COMMON_MSG_FORM_NOT_FILLED', 'Unfortunately, the form wasn\'t filled completely.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1849, 'COM_JOOMGALLERY_COMMON_MSG_IMAGE_NOT_EXIST', 'Image does not exist', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1850, 'COM_JOOMGALLERY_COMMON_MSG_IMAGE_SAVED', 'Image saved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1851, 'COM_JOOMGALLERY_COMMON_MSG_MIME_NOT_ALLOWED', 'MIME not allowed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1852, 'COM_JOOMGALLERY_COMMON_MSG_NOT_ALLOWED_STORE_IMAGE_IN_CATEGORY', 'You tried to store the image in a category for which you don\'t have the permission to use. Because of that the image was stored in the old category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1853, 'COM_JOOMGALLERY_COMMON_MSG_NOT_ALLOWED_TO_EDIT_CATEGORY', 'You are not allowed to edit this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1854, 'COM_JOOMGALLERY_COMMON_MSG_NOT_ALLOWED_TO_EDIT_IMAGE', 'You are not allowed to edit this image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1855, 'COM_JOOMGALLERY_COMMON_MSG_NOT_ALLOWED_VIEW_IMAGE', 'You are not allowed to view this image!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1856, 'COM_JOOMGALLERY_COMMON_MSG_NO_ACCESS', 'No access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1857, 'COM_JOOMGALLERY_COMMON_MSG_NO_VALID_CATEGORY_SELECTED', 'You haven\'t selected a valid category, so the image was stored in the previous category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1858, 'COM_JOOMGALLERY_COMMON_MSG_ORIGINAL_NOT_AVAILABLE', 'Original image not available', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1859, 'COM_JOOMGALLERY_COMMON_MSG_SUCCESS_CHANGE_PUBLISH_STATE', 'The status of the publication has been successfully changed!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1860, 'COM_JOOMGALLERY_COMMON_MSG_SUCCESS_DELETING_CATEGORY', 'Category successfully deleted. ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1861, 'COM_JOOMGALLERY_COMMON_MSG_YOU_ARE_NOT_ALLOWED_TO_UPLOAD', 'You are not allowed to upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1862, 'COM_JOOMGALLERY_COMMON_MSG_YOU_ARE_NOT_ALLOWED_TO_UPLOAD_INTO_THIS_CATEGORY', 'You are not allowed to upload into this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1863, 'COM_JOOMGALLERY_COMMON_MSG_YOU_ARE_NOT_LOGGED', 'You are not logged in.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1864, 'COM_JOOMGALLERY_COMMON_NEW_CATEGORY', 'New category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1865, 'COM_JOOMGALLERY_COMMON_NOT_ALLOWED_TO_PUBLISH_CATEGORY', 'The category with ID %d cannot be published because its parent category isn\'t published.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1866, 'COM_JOOMGALLERY_COMMON_NOT_ALLOWED_TO_PUBLISH_IMAGE', 'The image with ID %d cannot be published because its category isn\'t published.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1867, 'COM_JOOMGALLERY_COMMON_NOT_ALLOWED_TO_PUBLISH_NEW_CATEGORY', 'The category cannot be published because its parent category isn\'t published.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1868, 'COM_JOOMGALLERY_COMMON_NOT_ALLOWED_TO_PUBLISH_NEW_IMAGE', 'The image cannot be published because its category isn\'t published.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1869, 'COM_JOOMGALLERY_COMMON_NO_ACCESS', 'No access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1870, 'COM_JOOMGALLERY_COMMON_NO_CATEGORY', '[None]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1871, 'COM_JOOMGALLERY_COMMON_NO_CATEGORY_SPECIFIED', 'There wasn\'t any category specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1872, 'COM_JOOMGALLERY_COMMON_NO_COMMENTS', 'No Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1873, 'COM_JOOMGALLERY_COMMON_NO_DATA', 'No Data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1874, 'COM_JOOMGALLERY_COMMON_NO_IMAGE_SPECIFIED', 'There wasn\'t any image specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1875, 'COM_JOOMGALLERY_COMMON_NO_VOTES', 'No Votes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1876, 'COM_JOOMGALLERY_COMMON_NUMB_HITS_ALL_IMAGES', 'Total number of hits on all images: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1877, 'COM_JOOMGALLERY_COMMON_NUMB_IMAGES_ALL_CATEGORIES', 'Total images in all categories: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1878, 'COM_JOOMGALLERY_COMMON_OF', 'of', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1879, 'COM_JOOMGALLERY_COMMON_ONE_VOTE', 'Vote', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1880, 'COM_JOOMGALLERY_COMMON_OPTION_APPROVED_ONLY', 'only approved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1881, 'COM_JOOMGALLERY_COMMON_OPTION_CENTERED', 'Centered', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1882, 'COM_JOOMGALLERY_COMMON_OPTION_FLUSH_LEFT', 'Flush Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1883, 'COM_JOOMGALLERY_COMMON_OPTION_FLUSH_RIGHT', 'Flush Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1884, 'COM_JOOMGALLERY_COMMON_OPTION_NOT_APPROVED_ONLY', 'only not approved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1885, 'COM_JOOMGALLERY_COMMON_OPTION_NOT_PUBLISHED_ONLY', 'only not published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1886, 'COM_JOOMGALLERY_COMMON_OPTION_PUBLISHED_ONLY', 'only published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1887, 'COM_JOOMGALLERY_COMMON_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1888, 'COM_JOOMGALLERY_COMMON_ORDERING_ASC', 'Ascending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1889, 'COM_JOOMGALLERY_COMMON_ORDERING_DESC', 'Descending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1890, 'COM_JOOMGALLERY_COMMON_ORDERING_DISABLED', 'Please sort by \'Ordering Ascending\' and disable all filters to enable reordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1891, 'COM_JOOMGALLERY_COMMON_OWNER', 'Owner', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1892, 'COM_JOOMGALLERY_COMMON_PAGE', 'Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1893, 'COM_JOOMGALLERY_COMMON_PAGENAVIGATION_BEGIN', '&laquo;&laquo;&nbsp;Start', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1894, 'COM_JOOMGALLERY_COMMON_PAGENAVIGATION_ELLIPSIS', '&hellip;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1895, 'COM_JOOMGALLERY_COMMON_PAGENAVIGATION_END', 'End&nbsp;&raquo;&raquo;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1896, 'COM_JOOMGALLERY_COMMON_PAGENAVIGATION_NEXT', 'Next&nbsp;&raquo;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1897, 'COM_JOOMGALLERY_COMMON_PAGENAVIGATION_PREVIOUS', '&laquo;&nbsp;Prev', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1898, 'COM_JOOMGALLERY_COMMON_PARENT_CATEGORY', 'Parent Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1899, 'COM_JOOMGALLERY_COMMON_PERMISSION_DENIED', 'Permission denied.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1900, 'COM_JOOMGALLERY_COMMON_PLEASE_SELECT_IMAGE', 'Please select an image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1901, 'COM_JOOMGALLERY_COMMON_PUBLISHED', 'Published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1902, 'COM_JOOMGALLERY_COMMON_PUBLISHED_BUT_HIDDEN', 'published, but hidden', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1903, 'COM_JOOMGALLERY_COMMON_PUBLISH_CATEGORY_TIPCAPTION', 'Publish category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1904, 'COM_JOOMGALLERY_COMMON_PUBLISH_CATEGORY_TIPTEXT', 'Click to publish the category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1905, 'COM_JOOMGALLERY_COMMON_PUBLISH_IMAGE_TIPCAPTION', 'Publish image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1906, 'COM_JOOMGALLERY_COMMON_PUBLISH_IMAGE_TIPTEXT', 'Click to publish the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1907, 'COM_JOOMGALLERY_COMMON_RATING_TIPCAPTION', 'Rating', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1908, 'COM_JOOMGALLERY_COMMON_RATING_TIPTEXT_VAR', '%1$.2f (%2$d votes)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1909, 'COM_JOOMGALLERY_COMMON_RATING_VAR', 'Rating: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1910, 'COM_JOOMGALLERY_COMMON_REJECTED', 'Not approved resp rejected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1911, 'COM_JOOMGALLERY_COMMON_REMOVE_CATTHUMB_TIP', 'Here you may remove the current thumbnail for this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1912, 'COM_JOOMGALLERY_COMMON_REORDER', 'Reorder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1913, 'COM_JOOMGALLERY_COMMON_REPORT_IMAGE_NOT_ALLOWED_TIPTEXT', 'Please login in order to be able to request a deletion of this image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1914, 'COM_JOOMGALLERY_COMMON_REPORT_IMAGE_TIPCAPTION', 'Report on this image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1915, 'COM_JOOMGALLERY_COMMON_REPORT_IMAGE_TIPTEXT', 'If you want that image to be removed or censored you may request that here by sending a comment or reasons.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1916, 'COM_JOOMGALLERY_COMMON_REPORT_NOT_SENT', 'Unfortunately, there was an error sending your report. Please contact an administrator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1917, 'COM_JOOMGALLERY_COMMON_REPORT_SEND_REPORT', 'Send', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1918, 'COM_JOOMGALLERY_COMMON_REPORT_SENT', 'Your report was sent successfully and will be processed as soon as possible.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1919, 'COM_JOOMGALLERY_COMMON_REPORT_YOUR_EMAIL', 'Your e-mail address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1920, 'COM_JOOMGALLERY_COMMON_REPORT_YOUR_NAME', 'Your name:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1921, 'COM_JOOMGALLERY_COMMON_REPORT_YOUR_REPORT', 'Your request, comment, reasons:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1922, 'COM_JOOMGALLERY_COMMON_REQUEST_ERROR', 'Error while performing an Ajax request', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1923, 'COM_JOOMGALLERY_COMMON_RESTRICTED_CATEGORIES', 'Restricted Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1924, 'COM_JOOMGALLERY_COMMON_RETRY', 'Retry', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1925, 'COM_JOOMGALLERY_COMMON_SAVE', 'Save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1926, 'COM_JOOMGALLERY_COMMON_SEARCH', 'Search gallery...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1927, 'COM_JOOMGALLERY_COMMON_SEARCH_LIMIT', 'Search limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1928, 'COM_JOOMGALLERY_COMMON_SELECT', 'Select', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1929, 'COM_JOOMGALLERY_COMMON_SELECT_STATE', '- Select State -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1930, 'COM_JOOMGALLERY_COMMON_SELECT_THUMBNAIL_TIP', 'Select a thumbnail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1931, 'COM_JOOMGALLERY_COMMON_SORT_BY_ORDERING', 'Sort by order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1932, 'COM_JOOMGALLERY_COMMON_STATES', 'States', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1933, 'COM_JOOMGALLERY_COMMON_SUBCATEGORIES', 'Sub-Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1934, 'COM_JOOMGALLERY_COMMON_THOUSANDS_SEPARATOR', ',', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1935, 'COM_JOOMGALLERY_COMMON_THUMBNAIL', 'Thumbnail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1936, 'COM_JOOMGALLERY_COMMON_THUMBNAIL_ALIGN', 'Thumbnail Alignment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1937, 'COM_JOOMGALLERY_COMMON_THUMBNAIL_ALIGN_TIP', 'Please select the alignment for the category thumbnail you have chosen above.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1938, 'COM_JOOMGALLERY_COMMON_THUMBNAIL_PREVIEW', 'Thumbnail Preview', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1939, 'COM_JOOMGALLERY_COMMON_TIP_YOU_NOT_ACCESS_THIS_CATEGORY', 'You are not allowed to access this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1940, 'COM_JOOMGALLERY_COMMON_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1941, 'COM_JOOMGALLERY_COMMON_TOPLIST_LAST_ADDED', 'Last Added', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1942, 'COM_JOOMGALLERY_COMMON_TOPLIST_LAST_COMMENTED', 'Last Commented', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1943, 'COM_JOOMGALLERY_COMMON_TOPLIST_MOST_VIEWED', 'Most Viewed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1944, 'COM_JOOMGALLERY_COMMON_TOPLIST_TOP_RATED', 'Top Rated', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1945, 'COM_JOOMGALLERY_COMMON_UNPUBLISHED', 'Not published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1946, 'COM_JOOMGALLERY_COMMON_UNPUBLISH_CATEGORY_TIPCAPTION', 'Unpublish category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1947, 'COM_JOOMGALLERY_COMMON_UNPUBLISH_CATEGORY_TIPTEXT', 'Click to unpublish the category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1948, 'COM_JOOMGALLERY_COMMON_UNPUBLISH_IMAGE_TIPCAPTION', 'Unpublish image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1949, 'COM_JOOMGALLERY_COMMON_UNPUBLISH_IMAGE_TIPTEXT', 'Click to unpublish the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1950, 'COM_JOOMGALLERY_COMMON_UPLOAD_DATE', 'Upload date: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1951, 'COM_JOOMGALLERY_COMMON_UPLOAD_NEW_IMAGE', 'Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1952, 'COM_JOOMGALLERY_COMMON_USER_PANEL', 'User Panel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1953, 'COM_JOOMGALLERY_COMMON_VOTES', 'Votes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1954, 'COM_JOOMGALLERY_DEBUG_MODE', 'Debug Mode?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1955, 'COM_JOOMGALLERY_DEBUG_MODE_ASTERISK', 'With activated debug mode all processing steps will be shown. In case of errors they are always displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1956, 'COM_JOOMGALLERY_DETAIL_ALT_DELETE_COMMENT', 'Delete Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1957, 'COM_JOOMGALLERY_DETAIL_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1958, 'COM_JOOMGALLERY_DETAIL_BBCODE_IMG', 'Include image ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1959, 'COM_JOOMGALLERY_DETAIL_BBCODE_IS', 'BBCode is %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1960, 'COM_JOOMGALLERY_DETAIL_BBCODE_LINK', 'Link image ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1961, 'COM_JOOMGALLERY_DETAIL_BBCODE_OFF', 'off', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1962, 'COM_JOOMGALLERY_DETAIL_BBCODE_ON', 'on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1963, 'COM_JOOMGALLERY_DETAIL_BBCODE_SHARE', 'Share this image in Forums (BBcode) ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1964, 'COM_JOOMGALLERY_DETAIL_COMMENTS_ALERT_ENTER_CODE', 'Please enter image code!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1965, 'COM_JOOMGALLERY_DETAIL_COMMENTS_ALERT_ENTER_COMMENT', 'Please enter your comment!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1966, 'COM_JOOMGALLERY_DETAIL_COMMENTS_COMMENT_ADDED', 'Comment added on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1967, 'COM_JOOMGALLERY_DETAIL_COMMENTS_EXISTING', 'Comments for this image ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1968, 'COM_JOOMGALLERY_DETAIL_COMMENTS_GUEST_NAME', 'Guest: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1969, 'COM_JOOMGALLERY_DETAIL_COMMENTS_NOT_BY_GUEST', 'Guests are not allowed to post comments. Please register...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1970, 'COM_JOOMGALLERY_DETAIL_COMMENTS_NOT_EXISTING', 'There are no comments for this image yet. ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1971, 'COM_JOOMGALLERY_DETAIL_COMMENTS_NOT_FOR_UNREG', 'Comments are not shown to unregistered users. Please register ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1972, 'COM_JOOMGALLERY_DETAIL_COMMENTS_SEND_COMMENT', 'Post comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1973, 'COM_JOOMGALLERY_DETAIL_COMMENTS_WRITE_FIRST', 'Post the first comment! ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1974, 'COM_JOOMGALLERY_DETAIL_IMG_FULLSIZE_LOGIN_TIPTEXT', 'You need to login to view the full size image!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1975, 'COM_JOOMGALLERY_DETAIL_IMG_FULLSIZE_TIPCAPTION', 'View full size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1976, 'COM_JOOMGALLERY_DETAIL_IMG_FULLSIZE_TIPTEXT', 'Click the magnifying glass to display the image in original size in a new window.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1977, 'COM_JOOMGALLERY_DETAIL_IMG_IMAGE_OF_IMAGES', 'Image %s of %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1978, 'COM_JOOMGALLERY_DETAIL_IMG_NEXT', 'Next', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1979, 'COM_JOOMGALLERY_DETAIL_IMG_PREVIOUS', 'Previous', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1980, 'COM_JOOMGALLERY_DETAIL_INFO', 'Image information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1981, 'COM_JOOMGALLERY_DETAIL_INFO_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1982, 'COM_JOOMGALLERY_DETAIL_INFO_FILESIZE', 'Filesize', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1983, 'COM_JOOMGALLERY_DETAIL_INFO_FILESIZE_ORIGINAL', 'File size of the original image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1984, 'COM_JOOMGALLERY_DETAIL_INFO_FILESIZE_ORIGINAL_NOT_AVAILABLE', 'Original image is not available!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1985, 'COM_JOOMGALLERY_DETAIL_INFO_RATING', 'Rating', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1986, 'COM_JOOMGALLERY_DETAIL_LOGIN_FIRST', 'Please login first...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1987, 'COM_JOOMGALLERY_DETAIL_MAPS_BROWSER_IS_INCOMPATIBLE', 'Unfortunately, your internet browser doesn\'t support Google Maps or another error occured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1988, 'COM_JOOMGALLERY_DETAIL_MAPS_GEOTAGGING', 'GeoTagging', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1989, 'COM_JOOMGALLERY_DETAIL_MSG_COMMENT_DELETED', 'The Comment has been deleted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1990, 'COM_JOOMGALLERY_DETAIL_MSG_COMMENT_SAVED', 'Your comment has been saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1991, 'COM_JOOMGALLERY_DETAIL_MSG_COMMENT_SAVED_BUT_NEEDS_ARROVAL', 'Your comment has been saved, but needs to be approved by admin ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1992, 'COM_JOOMGALLERY_DETAIL_MSG_COMMENT_SECURITY_CODE_WRONG', 'The entered security code (CAPTCHA) is wrong!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1993, 'COM_JOOMGALLERY_DETAIL_MSG_NOT_ALLOWED_VIEW_DEFAULT_DETAIL_VIEW', 'You are not allowed to view the detail page of the images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1994, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_ALERT_SURE_DELETE', 'Are you sure you want to remove your name tag?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1995, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_ALERT_SURE_DELETE_OTHERS', 'Are you sure you want to remove this name tag?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1996, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_DELETE_OTHERS_TIPCAPTION', 'Remove this name tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1997, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_DELETE_OTHERS_TIPTEXT', 'You can remove this name tag by clicking this link.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1998, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_DELETE_TIPCAPTION', 'Remove my name tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(1999, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_DELETE_TIPTEXT', 'You can remove your name tag by clicking this link. After it has been removed you can add a new one.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2000, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_DELETED', 'Your name tag has successfully been removed from the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2001, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_ERROR_DELETING', 'Unfortunately, there was an error deleting the nametag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2002, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_ERROR_SAVING', 'Unfortunately, there was an error saving the nametag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2003, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_NOT_SAVED', 'Your name tag can not be saved because it is located in a reserved area (start position for all name tags) on the top left of the image. Please choose a different location outside the reserved area.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2004, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_SAVED', 'Your name tag has successfully been added to the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2005, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_USER_ALREADY_TAGGED', 'The selected user is already tagged on this image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2006, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_MSG_YOU_ARE_ALREADY_TAGGED', 'You are already tagged on this image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2007, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_OTHERS_TIPCAPTION', 'Save name tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2008, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_OTHERS_TIPTEXT', 'Please click here in order to save this name tag at its current position.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2009, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_SELECT_MYSELF', 'Myself', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2010, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_SELECT_OTHERS_TIPCAPTION', 'Select name tag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2011, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_SELECT_OTHERS_TIPTEXT', 'If you spot someone in this image you may add a name tag to it by clicking here. Use your mouse to drag the name tag to the desired place within the image and click the icon near to the tag to save it at its current position. Make sure you do not cover any existing name tags! Existing name tags have priority and will cover the ones added later! You can remove the tag anytime.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2012, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_SELECT_USER', '- Select User -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2013, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_TIPCAPTION', 'Save my name tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2014, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_TIPTEXT', 'If you spot yourself in an image you may add a name tag to it. The name tag is already visible in the top left corner of the image. Use your mouse to drag it to the desired place within the image. Make sure you do not cover any existing name tags! Existing name tags have priority and will cover the ones added later! Once you positioned your name tag click on this link. You can remove the tag anytime.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2015, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_UNREGISTERED_TIPCAPTION', 'Add my name tag?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2016, 'COM_JOOMGALLERY_DETAIL_NAMETAGS_UNREGISTERED_TIPTEXT', 'Only registered users are permitted to add name tags. Please register!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2017, 'COM_JOOMGALLERY_DETAIL_RATING', 'Image Rating', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2018, 'COM_JOOMGALLERY_DETAIL_RATINGS_MSG_YOUR_VOTE_COUNTED', 'Your vote has been counted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2019, 'COM_JOOMGALLERY_DETAIL_RATINGS_MSG_YOUR_VOTE_NOT_COUNTED', 'You can only vote once for every image! Your rating has not been counted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2020, 'COM_JOOMGALLERY_DETAIL_RATING_BAD', 'Bad', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2021, 'COM_JOOMGALLERY_DETAIL_RATING_GOOD', 'Good', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2022, 'COM_JOOMGALLERY_DETAIL_RATING_NOT_ON_OWN_IMAGES', 'You can not vote for your own images!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2023, 'COM_JOOMGALLERY_DETAIL_RATING_NO_SCRIPT', '[Please activate JavaScript in order to use image rating]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2024, 'COM_JOOMGALLERY_DETAIL_RATING_STARS_TIPCAPTION', 'Vote', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2025, 'COM_JOOMGALLERY_DETAIL_RATING_STARS_TIPTEXT_VAR', '%d star(s) of %d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2026, 'COM_JOOMGALLERY_DETAIL_RATING_VOTE', 'Vote!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2027, 'COM_JOOMGALLERY_DETAIL_REPORT_IMAGE', 'Request a deletion of this image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2028, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND', 'Send to Friend', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2029, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_ALERT_ENTER_NAME_EMAIL', 'Please enter name and email!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2030, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_FRIENDS_MAIL', 'Your Friend\'s Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2031, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_FRIENDS_NAME', 'Your Friend\'s Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2032, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_MSG_MAIL_NOT_SENT', 'Unfortunately, there was an error sending the mail.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2033, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_MSG_MAIL_SENT', 'Mail was sent...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2034, 'COM_JOOMGALLERY_DETAIL_SENDTOFRIEND_SEND_EMAIL', 'Send Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2035, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW', 'SlideShow', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2036, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_IMAGES', 'Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2037, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_NO_SCRIPT', '[Please activate JavaScript in order to see the slideshow]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2038, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_PAUSE', 'Pause', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2039, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_REPEAT', 'Repeat slideshow beginning with first image?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2040, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_START', 'Start', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2041, 'COM_JOOMGALLERY_DETAIL_SLIDESHOW_STOP', 'Stop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2042, 'COM_JOOMGALLERY_DOWNLOADZIP_BACK_TO_FAVOURITES', 'Back to overview of selected images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2043, 'COM_JOOMGALLERY_DOWNLOADZIP_CREATEZIP_REMOVE_ALL', 'If you want to remove all images from your list for the zip download please click here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2044, 'COM_JOOMGALLERY_DOWNLOADZIP_CREATE_TIPTEXT', 'Please click here to generate a zipfile with all listed images which you can download afterwards.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2045, 'COM_JOOMGALLERY_DOWNLOADZIP_DOWNLOAD', 'Download Zipfile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2046, 'COM_JOOMGALLERY_DOWNLOADZIP_DOWNLOAD_READY', 'You can now download the zipfile here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2047, 'COM_JOOMGALLERY_DOWNLOADZIP_FILESIZE', 'It has a filesize of about %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2048, 'COM_JOOMGALLERY_DOWNLOADZIP_HEADING', 'Images chosen for the zip download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2049, 'COM_JOOMGALLERY_DOWNLOADZIP_MY', 'Zip Download', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2050, 'COM_JOOMGALLERY_DOWNLOADZIP_NO_IMAGES', 'You have not chosen any image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2051, 'COM_JOOMGALLERY_DOWNLOADZIP_REMOVE_TIPCAPTION', 'Remove image from your download list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2052, 'COM_JOOMGALLERY_DOWNLOADZIP_REMOVE_TIPTEXT', 'Here you can remove this image from your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2053, 'COM_JOOMGALLERY_DOWNLOADZIP_ZIPFILE_NOT_FOUND', 'The requested Zip archive could not be found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2054, 'COM_JOOMGALLERY_EDITCATEGORY_ACCESS_TIP', 'Access level for this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2055, 'COM_JOOMGALLERY_EDITCATEGORY_ALIAS_TIP', 'Leave this blank and JoomGallery will fill in a default value, which is the category path in lower case and with dashes instead of spaces. You may enter the Alias manually. If you do so please use lowercase letters and hypens (-). No spaces or underscores are allowed. The Alias will be used in the SEF URL. Default value will be a date and time if the alias is typed in non-latin letters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2056, 'COM_JOOMGALLERY_EDITCATEGORY_DESCRIPTION_TIP', 'You may enter here a description for the category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2057, 'COM_JOOMGALLERY_EDITCATEGORY_ERROR_NO_AVAILABLE_PARENT_CATEGORIES', 'There aren\'t any categories in which you are allowed to create sub-categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2058, 'COM_JOOMGALLERY_EDITCATEGORY_MODIFY_CATEGORY', 'Edit category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2059, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_CATEGORY_CONTAINS_IMAGES', 'The Category with the id %d contains still images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2060, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_CATEGORY_CONTAINS_SUBCATEGORIES', 'The Category with the id %d contains still sub-categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2061, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_NOT_ALLOWED_CREATE_MORE_USERCATEGORIES', 'You are not allowed to create more user categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2062, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_NOT_ALLOWED_STORE_CATEGORY_IN_PARENT', 'You are not allowed to store the category in the selected parent category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2063, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_UNABLE_CREATE_FOLDERS', 'Unable to create folders', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2064, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_UNABLE_DELETE_DIRECTORIES', 'Unable to delete directories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2065, 'COM_JOOMGALLERY_EDITCATEGORY_MSG_UNABLE_MOVE_FOLDERS', 'Unable to move folders', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2066, 'COM_JOOMGALLERY_EDITCATEGORY_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2067, 'COM_JOOMGALLERY_EDITCATEGORY_ORDERING_TIP', 'You may change the position of this category here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2068, 'COM_JOOMGALLERY_EDITCATEGORY_OTHER', 'Other', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2069, 'COM_JOOMGALLERY_EDITCATEGORY_PARENT_CATEGORY_TIP', 'The parent category the category is placed in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2070, 'COM_JOOMGALLERY_EDITCATEGORY_PUBLISHED_TIP', 'The publication status of the category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2071, 'COM_JOOMGALLERY_EDITCATEGORY_PUBLISHING', 'Publishing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2072, 'COM_JOOMGALLERY_EDITCATEGORY_THUMBNAIL_TIP', 'Here you may select an image which is set as the thumbnail of this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2073, 'COM_JOOMGALLERY_EDITCATEGORY_TITLE_TIP', 'Title of the category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2074, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_COMMENTS', 'Could not delete the comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2075, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_IMAGE', 'Could not delete the detail image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2076, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_IMAGE_DATA', 'Could not delete the image data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2077, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_NAMETAGS', 'Could not delete the name tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2078, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_ORIG', 'Could not delete the original image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2079, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_THUMB', 'Could not delete the thumbnail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2080, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_MOVE_IMAGE', 'Could not move the detail image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2081, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_MOVE_ORIG', 'Could not move the original image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2082, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_MOVE_THUMB', 'Could not move the thumbnail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2083, 'COM_JOOMGALLERY_EDITIMAGE_MSG_DEST_IMG_ALREADY_EXISTS', 'The detail image to move seems to be already existent in destination directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2084, 'COM_JOOMGALLERY_EDITIMAGE_MSG_DEST_ORIG_ALREADY_EXISTS', 'The original image to move seems to be already existent in destination directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2085, 'COM_JOOMGALLERY_EDITIMAGE_MSG_DEST_THUMB_ALREADY_EXISTS', 'The thumbnail to move seems to be already existent in destination directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2086, 'COM_JOOMGALLERY_EDITIMAGE_MSG_SOURCE_IMG_NOT_EXISTS', 'The detail image to move wasn\'t found: \'%s\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2087, 'COM_JOOMGALLERY_EDITIMAGE_MSG_SOURCE_THUMB_NOT_EXISTS', 'The thumbnail to move wasn\'t found: \'%s\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2088, 'COM_JOOMGALLERY_EDIT_ACCESS_TIP', 'Access level for the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2089, 'COM_JOOMGALLERY_EDIT_ALIAS_TIP', 'Leave this blank and JoomGallery will fill in a default value, which is the title in lower case and with dashes instead of spaces. Additionally the ID of the image will be added to ensure uniqueness. You may enter the Alias manually. If you do so please use lowercase letters and hypens (-). No spaces or underscores are allowed. The Alias will be used in the SEF URL. Default value will be a date and time if the title is typed in non-latin letters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2090, 'COM_JOOMGALLERY_EDIT_AUTHOR_TIP', 'Author of the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2091, 'COM_JOOMGALLERY_EDIT_CATEGORY_TIP', 'The category the image belongs to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2092, 'COM_JOOMGALLERY_EDIT_DESCRIPTION_TIP', 'You may enter here a description for the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2093, 'COM_JOOMGALLERY_EDIT_EDIT_IMAGE', 'Edit Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2094, 'COM_JOOMGALLERY_EDIT_IMAGE_TIP', 'That\'s the image you are editing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2095, 'COM_JOOMGALLERY_EDIT_OTHER', 'Other', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2096, 'COM_JOOMGALLERY_EDIT_OWNER_TIP', 'Owner of the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2097, 'COM_JOOMGALLERY_EDIT_PUBLISHED_TIP', 'Publication status of the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2098, 'COM_JOOMGALLERY_EDIT_PUBLISHING', 'Publishing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2099, 'COM_JOOMGALLERY_EDIT_TITLE_TIP', 'Title of the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2100, 'COM_JOOMGALLERY_ERROR_CREATING_ZIP', 'Unfortunately, there was an error creating the zip: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2101, 'COM_JOOMGALLERY_FAVOURITES_CREATEZIP_REMOVE_ALL', 'If you want to remove all images from your favourites please click here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2102, 'COM_JOOMGALLERY_FAVOURITES_DOWNLOAD', 'Download Zipfile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2103, 'COM_JOOMGALLERY_FAVOURITES_ERROR_CREATEZIP', 'The archive file could not be written to the file system!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2104, 'COM_JOOMGALLERY_FAVOURITES_HEADING', 'My Favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2105, 'COM_JOOMGALLERY_FAVOURITES_MSG_ALL_REMOVED', 'All images were removed from your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2106, 'COM_JOOMGALLERY_FAVOURITES_MSG_ALREADY_IN', 'This image is already marked as one of your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2107, 'COM_JOOMGALLERY_FAVOURITES_MSG_ALREADY_MAX', 'Sorry, you have already marked the maximum number of images as favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2108, 'COM_JOOMGALLERY_FAVOURITES_MSG_NOT_ALLOWED', 'Zip download is not allowed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2109, 'COM_JOOMGALLERY_FAVOURITES_MSG_NOT_IN', 'This image isn\'t marked as one of your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2110, 'COM_JOOMGALLERY_FAVOURITES_MSG_NO_IMAGES', 'You haven\'t any images marked as your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2111, 'COM_JOOMGALLERY_FAVOURITES_MSG_SUCCESSFULLY_ADDED', 'This image was successfully added to your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2112, 'COM_JOOMGALLERY_FAVOURITES_MSG_SUCCESSFULLY_ADDED_MORE', 'The images were successfully added to your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2113, 'COM_JOOMGALLERY_FAVOURITES_MSG_SUCCESSFULLY_REMOVED', 'This image was successfully removed from your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2114, 'COM_JOOMGALLERY_FAVOURITES_MSG_WOULD_EXCEED', 'Adding these images would exceed the maximum number of images allowed for favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2115, 'COM_JOOMGALLERY_FAVOURITES_MY', 'My Favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2116, 'COM_JOOMGALLERY_FAVOURITES_NO_IMAGES', 'You have not marked any image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2117, 'COM_JOOMGALLERY_FAVOURITES_NO_IMAGES_TO_ADD', 'There were no images found that can be added to your list.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2118, 'COM_JOOMGALLERY_FAVOURITES_REMOVE_ALL', 'Clear list', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2119, 'COM_JOOMGALLERY_FAVOURITES_REMOVE_TIPCAPTION', 'Remove image from your favourites', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2120, 'COM_JOOMGALLERY_FAVOURITES_REMOVE_TIPTEXT', 'Here you can remove this image from your favourites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2121, 'COM_JOOMGALLERY_FAVOURITES_SWITCH_LAYOUT', 'Switch layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(2122, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_ALL_REMOVED', 'All images were removed from your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2123, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_ALREADY_IN', 'This image is already in your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2124, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_ALREADY_MAX', 'Sorry, you have already the maximum number of images in your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2125, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_NOT_IN', 'This image isn\'t in your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2126, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_NO_IMAGES', 'You haven\'t any images in your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2127, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_SUCCESSFULLY_ADDED', 'This image was successfully added to your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2128, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_SUCCESSFULLY_ADDED_MORE', 'The images were successfully added to your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2129, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_SUCCESSFULLY_REMOVED', 'This image was successfully removed from your list for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2130, 'COM_JOOMGALLERY_FAVOURITES_ZIP_MSG_WOULD_EXCEED', 'Adding these images would exceed the maximum number of images allowed for the zip download.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2131, 'COM_JOOMGALLERY_FAVOURITES_ZIP_SIZEKB', '%s KB', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2132, 'COM_JOOMGALLERY_FAVOURITES_ZIP_SIZEMB', '%s MB', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2133, 'COM_JOOMGALLERY_GALLERY_IMAGES', '(%s images)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2134, 'COM_JOOMGALLERY_GALLERY_ONE_IMAGE', '(%s image)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2135, 'COM_JOOMGALLERY_GALLERY_THERE_ARE_CATEGORIES_IN_GALLERY', 'There are %s categories in gallery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2136, 'COM_JOOMGALLERY_GALLERY_THERE_IS_ONE_CATEGORY_IN_GALLERY', 'There is one category in gallery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2137, 'COM_JOOMGALLERY_IMAGE_MSG_DELETE_NOT_PERMITTED', 'You are not allowed to delete this image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2138, 'COM_JOOMGALLERY_IMAGE_MSG_EDITSTATE_NOT_PERMITTED', 'You are not allowed to edit the state of this image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2139, 'COM_JOOMGALLERY_IMAGE_WRONG_DOCUMENT_TYPE', '<p>If you have found this page while investigating an image displaying problem or by accident please read <a href=\"http://www.en.joomgallery.net/faq/general-faq/detail-original-images-arent-displayed.html\">this article</a>, it should be able to help you.<br />If you aren\'t the administrator of this website please notify him and send him the link which is currently displayed in your browser address bar.</p>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2140, 'COM_JOOMGALLERY_MESSAGE_IMAGE_FROM_FRIEND_BODY', '%1$s has invited you to view an image. Please use the following link to display it: %3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2141, 'COM_JOOMGALLERY_MESSAGE_IMAGE_FROM_FRIEND_SUBJECT', 'A recommended image from your friend', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2142, 'COM_JOOMGALLERY_MESSAGE_NEW_COMMENT_BODY', 'A new comment from %s has been submitted. This comment needs to be approved before it can be published.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2143, 'COM_JOOMGALLERY_MESSAGE_NEW_COMMENT_SUBJECT', 'New Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2144, 'COM_JOOMGALLERY_MESSAGE_NEW_COMMENT_TO_OWNER_BODY', '%1$s has commented on your image \'%2$s\' (ID: %3$d). Please have a look.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2145, 'COM_JOOMGALLERY_MESSAGE_NEW_COMMENT_TO_OWNER_SUBJECT', 'One of your images has been commented', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2146, 'COM_JOOMGALLERY_MESSAGE_NEW_DOWNLOAD_BODY', 'The image with the title %1$s (Filename: %2$s) has been downloaded by %3$s!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2147, 'COM_JOOMGALLERY_MESSAGE_NEW_DOWNLOAD_SUBJECT', 'An image has been downloaded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2148, 'COM_JOOMGALLERY_MESSAGE_NEW_IMAGES_SUBMITTED_BODY', '%2$d new images have been submitted by %1$s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2149, 'COM_JOOMGALLERY_MESSAGE_NEW_IMAGES_SUBMITTED_SUBJECT', 'New Images Uploaded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2150, 'COM_JOOMGALLERY_MESSAGE_NEW_IMAGE_SUBMITTED_BODY', 'A new image has been submitted by %1$s (Title: %2$s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2151, 'COM_JOOMGALLERY_MESSAGE_NEW_NAMETAG_BODY', '%1$s has tagged himself on the image \'%2$s\' (ID: %3$d).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2152, 'COM_JOOMGALLERY_MESSAGE_NEW_NAMETAG_OTHERS_BODY', '%2$s has tagged %1$s on the image \'%3$s\' (ID: %4$d).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2153, 'COM_JOOMGALLERY_MESSAGE_NEW_NAMETAG_SUBJECT', 'A new nametag was added', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2154, 'COM_JOOMGALLERY_MESSAGE_NEW_ZIPDOWNLOAD_BODY', 'The zip %1$s has been downloaded by %2$s! It contains the following image files:\\n%3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2155, 'COM_JOOMGALLERY_MESSAGE_NEW_ZIPDOWNLOAD_SUBJECT', 'A zip has been downloaded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2156, 'COM_JOOMGALLERY_MESSAGE_YOU_WERE_TAGGED_BODY', '%1$s has found you on the image \'%2$s\'. Please have a look:\\n\\n%3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2157, 'COM_JOOMGALLERY_MESSAGE_YOU_WERE_TAGGED_SUBJECT', '%s: You were tagged on an image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2158, 'COM_JOOMGALLERY_MINI_ADD_CLASS', 'Additional style class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2159, 'COM_JOOMGALLERY_MINI_ADD_CLASS_TIP', 'Here you may enter an additional CSS class which will be applied to the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2160, 'COM_JOOMGALLERY_MINI_ALTTEXT', 'Alternative Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2161, 'COM_JOOMGALLERY_MINI_ALTTEXT_TIP', 'If you don\'t select an alternative text for the image here the image title will be used for the \'alt\' attribute of the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2162, 'COM_JOOMGALLERY_MINI_CATEGORY_COLUMNS', 'Thumbnail columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2163, 'COM_JOOMGALLERY_MINI_CATEGORY_COLUMNS_TIP', 'Please specify here in how many columns the thumbnails shall be displayed later on.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2164, 'COM_JOOMGALLERY_MINI_CATEGORY_LIMIT', 'Number of thumbnails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2165, 'COM_JOOMGALLERY_MINI_CATEGORY_LIMIT_TIP', 'Please specify here how many thumbnails shall be inserted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2166, 'COM_JOOMGALLERY_MINI_CATEGORY_MODE', 'Insert thumbnails or text?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2167, 'COM_JOOMGALLERY_MINI_CATEGORY_MODE_TEXTLINK', 'Linked text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2168, 'COM_JOOMGALLERY_MINI_CATEGORY_MODE_THUMBNAILS', 'Thumbnails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2169, 'COM_JOOMGALLERY_MINI_CATEGORY_MODE_TIP', 'Please select whether thumbnails shall be inserted or a linked text to the category view.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2170, 'COM_JOOMGALLERY_MINI_CATEGORY_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2171, 'COM_JOOMGALLERY_MINI_CATEGORY_NAME_DESCRIPTION', 'Please enter a name for the new category here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2172, 'COM_JOOMGALLERY_MINI_CATEGORY_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2173, 'COM_JOOMGALLERY_MINI_CATEGORY_ORDERING_ORDERING', 'like in category view', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2174, 'COM_JOOMGALLERY_MINI_CATEGORY_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2175, 'COM_JOOMGALLERY_MINI_CATEGORY_ORDERING_TIP', 'Please select whether the thumbnails shall be ordered by chance or if the current ordering in the category shall be used.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2176, 'COM_JOOMGALLERY_MINI_CATEGORY_SELECT', 'Select category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2177, 'COM_JOOMGALLERY_MINI_CATEGORY_SELECT_TIP', 'Please select the category to insert.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2178, 'COM_JOOMGALLERY_MINI_CATEGORY_TEXTLINK', 'Linked text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2179, 'COM_JOOMGALLERY_MINI_CATEGORY_TEXTLINK_TIP', 'Please enter the text which will linked with the category here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2180, 'COM_JOOMGALLERY_MINI_CATEGORY_VIEW', 'Category View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2181, 'COM_JOOMGALLERY_MINI_CREATE_CATEGORY', 'Create Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2182, 'COM_JOOMGALLERY_MINI_DETAIL', 'Detail image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2183, 'COM_JOOMGALLERY_MINI_DETAIL_VIEW', 'Detail View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2184, 'COM_JOOMGALLERY_MINI_EXTENDED', 'Further options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2185, 'COM_JOOMGALLERY_MINI_FILTER_BY_CATEGORY', 'Filter by category:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2186, 'COM_JOOMGALLERY_MINI_IMAGES_FOUND', 'There were %d images found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2187, 'COM_JOOMGALLERY_MINI_INSERT_CATEGORY', 'Insert Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2188, 'COM_JOOMGALLERY_MINI_INSERT_IMAGE', 'Insert Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2189, 'COM_JOOMGALLERY_MINI_LINKED', 'Linked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2190, 'COM_JOOMGALLERY_MINI_LINKED_IMAGE_TYPE', 'Linked image type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2191, 'COM_JOOMGALLERY_MINI_LINKED_IMAGE_TYPE_TIP', 'Here you may select the image size of the image to which the inserted image links. This option is only available if the inserted image is a thumbnail and if it links to the detail view (and not to the default detail view).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2192, 'COM_JOOMGALLERY_MINI_LINKED_TIP', 'Please choose whether the inserted image should be linked with a bigger one or whether it should be linked with the category view.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2193, 'COM_JOOMGALLERY_MINI_MSG_NOT_INSTALLED_OR_ACTIVATED', 'Content Plugin isn\'t installed or not yet activated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2194, 'COM_JOOMGALLERY_MINI_NO_IMAGES', 'There were no images found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2195, 'COM_JOOMGALLERY_MINI_NO_THUMB', 'Thumb not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2196, 'COM_JOOMGALLERY_MINI_NO_THUMB_TIP', 'The thumbnail of the image with the id %1$d \"%2$s\" is not available', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2197, 'COM_JOOMGALLERY_MINI_ONE_IMAGE_FOUND', 'There was one image found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2198, 'COM_JOOMGALLERY_MINI_ORIGINAL', 'Original image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2199, 'COM_JOOMGALLERY_MINI_PLEASE_ENTER_TEXT', 'Please enter some text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2200, 'COM_JOOMGALLERY_MINI_POSITION', 'Alignment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2201, 'COM_JOOMGALLERY_MINI_POSITION_TIP', 'Here you may select the alignment of the image you want to insert.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2202, 'COM_JOOMGALLERY_MINI_SAVE', 'Save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2203, 'COM_JOOMGALLERY_MINI_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2204, 'COM_JOOMGALLERY_MINI_SEARCH_IMAGE', 'Search image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2205, 'COM_JOOMGALLERY_MINI_TEXTLINK', 'Linked text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2206, 'COM_JOOMGALLERY_MINI_TEXTLINK_TIP', 'If you enter text into this field that text will be inserted and linked instead of the selected image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2207, 'COM_JOOMGALLERY_MINI_TITLE_DESCRIPTION', 'Please enter a title for the image here. This title will be used as the alternative text of the image if no other alternative text is specified while inserting the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2208, 'COM_JOOMGALLERY_MINI_TYPE', 'Image type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2209, 'COM_JOOMGALLERY_MINI_TYPE_TIP', 'Please select the size of the image you want to insert here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2210, 'COM_JOOMGALLERY_MINI_UPLOAD_IMAGE', 'Upload Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2211, 'COM_JOOMGALLERY_POPUP_CLOSE', 'Close', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2212, 'COM_JOOMGALLERY_POPUP_ESC', '(Esc)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2213, 'COM_JOOMGALLERY_POPUP_NEXT', 'Next', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2214, 'COM_JOOMGALLERY_POPUP_OF', 'of', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2215, 'COM_JOOMGALLERY_POPUP_PREVIOUS', 'Previous', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2216, 'COM_JOOMGALLERY_REPORT_IMAGE_BODY', '%3$s (%4$s) complained about the image with ID %1$d (%2$s).\\n\\nLink to the image in gallery:\\n\\n%5$s\\n\\nLink directly to the detail image:\\n\\n%6$s\\n\\nAnnotations of %3$s:\\n\\n%7$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2217, 'COM_JOOMGALLERY_REPORT_IMAGE_SUBJECT', 'Somebody complains about an image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2218, 'COM_JOOMGALLERY_SEARCH_RESULTS', 'Search results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2219, 'COM_JOOMGALLERY_SEARCH_RESULTS_FOR', 'Search results for %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2220, 'COM_JOOMGALLERY_SEARCH_RESULTS_NO_IMAGES', 'There were no images found that match the search pattern!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2221, 'COM_JOOMGALLERY_SELECT_NAMETAG', 'Whom do you want to tag?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2222, 'COM_JOOMGALLERY_TOPLIST_BEST_RATED_IMAGE', 'Top %s best rated images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2223, 'COM_JOOMGALLERY_TOPLIST_LAST_ADDED_IMAGE', 'Top %s last added images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2224, 'COM_JOOMGALLERY_TOPLIST_LAST_COMMENTED_IMAGE', 'Top %s last commented images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2225, 'COM_JOOMGALLERY_TOPLIST_MOST_VIEWED_IMAGE', 'Top %s most viewed images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2226, 'COM_JOOMGALLERY_TOPLIST_NO_IMAGES', 'There were no images found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2227, 'COM_JOOMGALLERY_TOPLIST_TOP', 'TOP %d:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2228, 'COM_JOOMGALLERY_TOPLIST_WROTE_AT', 'wrote %s on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2229, 'COM_JOOMGALLERY_UPLOAD_ALERT_FILENAME_DOUBLE_ONE', 'Identical Files! In field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2230, 'COM_JOOMGALLERY_UPLOAD_ALERT_FILENAME_DOUBLE_TWO', 'and field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2231, 'COM_JOOMGALLERY_UPLOAD_BATCH_UPLOAD_NOTE', 'Please do not upload zipped directories!<br />Only zipped image files will be stored correctly.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2232, 'COM_JOOMGALLERY_UPLOAD_BATCH_ZIP_FILE', 'Image Package File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2233, 'COM_JOOMGALLERY_UPLOAD_BATCH_ZIP_FILE_DESC', 'Please select an archived package file. Possible formats are \'.zip\', \'.tar\', \'.gzip\' and \'.bzip2\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2234, 'COM_JOOMGALLERY_UPLOAD_COUNTER_NUMBER', 'Numbering start', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2235, 'COM_JOOMGALLERY_UPLOAD_COUNTER_NUMBER_ASTERISK', 'With the general title consecutive numbers are assigned to the images. In case you want the numbering to start with a chosen value enter it in this field. Otherwise leave the field empty', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2236, 'COM_JOOMGALLERY_UPLOAD_CREATE_SPECIAL_GIF', 'Special Image Files?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2237, 'COM_JOOMGALLERY_UPLOAD_CREATE_SPECIAL_GIF_ASTERISK', 'This option allows the upload of special image files. Solely choose this option in case your upload exclusively consists of animated or transparent .png or .gif files. Keep in mind that the files do not get resized and therefore are displayed full size in detail view!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2238, 'COM_JOOMGALLERY_UPLOAD_CREATE_THUMBNAIL_FROM', 'Creating thumbnail from', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2239, 'COM_JOOMGALLERY_UPLOAD_DELETE_ORIGINAL_AFTER_UPLOAD', 'Delete Originals?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2240, 'COM_JOOMGALLERY_UPLOAD_DELETE_ORIGINAL_AFTER_UPLOAD_ASTERISK', 'Choosing this option will delete the original files from the server after they have been uploaded. Only choose this if you run short of server space. Although the thumbnail and the detailed image are left untouched from this option the popup will no longer be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2241, 'COM_JOOMGALLERY_UPLOAD_ERROR_CODE', 'Error-Code: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2242, 'COM_JOOMGALLERY_UPLOAD_ERROR_FILE_NOT_UPLOADED', 'No file has been uploaded!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2243, 'COM_JOOMGALLERY_UPLOAD_ERROR_FILE_PARTLY_UPLOADED', 'The file has been uploaded only partly!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2244, 'COM_JOOMGALLERY_UPLOAD_ERROR_HTML_MAXFILESIZE', 'The size of the file is larger than MAX_FILE_SIZE in the HTML form!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2245, 'COM_JOOMGALLERY_UPLOAD_ERROR_PHP_MAXFILESIZE', 'The size of the file is larger than the \'upload_max_filesize\' limit set up in php.ini!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2246, 'COM_JOOMGALLERY_UPLOAD_ERROR_TEMP_MISSING', 'The temporary directory is missing! Please inform the administrator about this issue.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2247, 'COM_JOOMGALLERY_UPLOAD_ERROR_UNKNOWN', 'Unknown Error!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2248, 'COM_JOOMGALLERY_UPLOAD_ERROR_UPLOADING', 'Error uploading file \'%s\'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2249, 'COM_JOOMGALLERY_UPLOAD_FILENAME', 'Filename: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2250, 'COM_JOOMGALLERY_UPLOAD_FILE_NOT_FOUND', 'ERROR: Source file not found!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2251, 'COM_JOOMGALLERY_UPLOAD_GD_LIBARY_NOT_INSTALLED', 'GD image library not installed!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2252, 'COM_JOOMGALLERY_UPLOAD_GD_NO_TRUECOLOR', 'GD image library does not support truecolor thumbnailing!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2253, 'COM_JOOMGALLERY_UPLOAD_GD_ONLY_JPG_PNG', 'ERROR: GD can only handle JPG and PNG files!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2254, 'COM_JOOMGALLERY_UPLOAD_GENERIC_DESCRIPTION_OPTIONAL', 'Generic Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2255, 'COM_JOOMGALLERY_UPLOAD_GENERIC_TITLE', 'Generic Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2256, 'COM_JOOMGALLERY_UPLOAD_IMAGENAME_SEPARATOR', '_', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2257, 'COM_JOOMGALLERY_UPLOAD_IMAGE_ASSIGN_TO_CATEGORY', 'Category photos will be assigned to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2258, 'COM_JOOMGALLERY_UPLOAD_IMAGE_PATH', 'Path to the image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2259, 'COM_JOOMGALLERY_UPLOAD_JUPLOAD_IMAGE_MUST_HAVE_TITLE', 'Image must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2260, 'COM_JOOMGALLERY_UPLOAD_JUPLOAD_NOTE', 'In order to use the Java upload your browser needs a Java plugin of version 1.5 or higher, otherwise the applet cannot be started. Furthermore, you need to accept the certificate for this applet.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2261, 'COM_JOOMGALLERY_UPLOAD_JUPLOAD_SELECT_CATEGORY', 'You must select a category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2262, 'COM_JOOMGALLERY_UPLOAD_MESSAGE_NEW_IMAGE_UPLOADED', 'New image uploaded', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2263, 'COM_JOOMGALLERY_UPLOAD_MORE_UPLOADS', 'Upload more Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2264, 'COM_JOOMGALLERY_UPLOAD_MSG_SUCCESSFULL', 'Upload successfull!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2265, 'COM_JOOMGALLERY_UPLOAD_NEW_FILENAME', 'New filename: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2266, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_COPYRIGHT', '<b>COPYRIGHT NOTICE:</b> <br /><div align=\"justify\">The owner of this website grants you the right to upload images on the server that will then be visible to and accessible by the public. Images underlie copyrights and third party rights. Solely upload images that you have taken yourself and that are certainly free of third party rights. The owner of the website rejects any responsiblility for images uploaded by you and will pass on all third party claims that subject copyright violation or other forms of misuse. By uploading image you give your explicit consent to this agreement.</div>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2267, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_MAXSIZE', 'Maximum size of single images to be uploaded: %s byte', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2268, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_NOTE', 'Upload Quota', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2269, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_REMAINDER', 'Number of images left that can be uploaded: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2270, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_YOURCOUNT', 'Number of images you have already uploaded: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2271, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_ERROR_MEM_EXCEED', 'Memory limit exceeded. No further processing of the image. Memory requirement:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2272, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_EXEC_DISABLED', 'The function exec() has been disabled in php.ini. It\'s not possible to use ImageMagick in JoomGallery because of this disabled function. Ask your webhoster for more information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2273, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_FILES_IN_BATCH', '%s files found in batch', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2274, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_FILE_IN_BATCH', '1 file found in batch', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2275, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_IMAGE_SUCCESSFULLY_ADDED', 'Image successfully added', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2276, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_IMG_NOT_CREATED', 'Error creating detail image \'%s\'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2277, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_INVALID_IMAGE_FILE', 'The uploaded image doesn\'t seem to be a valid image file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2278, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_INVALID_IMAGE_TYPE', 'Invalid image type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2279, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_MAX_ALLOWED_FILESIZE', 'Error: Max allowed file size is %s byte', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2280, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_ORIGINAL_DELETED', 'The image has been deleted from the directory containing the original files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2281, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_PROBLEM_COPYING', 'Problem copying file to: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2282, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_PROBLEM_DELETING_ORIGINAL', 'The image could not be deleted from the directory containing the original files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2283, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_DTLDEL_NOK', 'Rollback: Deletion of detail image not successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2284, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_DTLDEL_OK', 'Rollback: Deletion of detail image successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2285, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_ORGDEL_NOK', 'Rollback: Deletion of original image not successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2286, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_ORGDEL_OK', 'Rollback: Deletion of original image successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2287, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_THBDEL_NOK', 'Rollback: Deletion of thumbnail image not successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2288, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RB_THBDEL_OK', 'Rollback: Deletion of thumbnail image successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2289, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_RESIZED_TO_MAXWIDTH', 'Resize to maximum width complete...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2290, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_THUMBNAIL_CREATED', 'Thumbnail created...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2291, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_THUMBNAIL_NOT_CREATED', 'Error creating thumbnail \'%s\'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2292, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_UPLOAD_COMPLETE', 'Upload complete...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2293, 'COM_JOOMGALLERY_UPLOAD_PLEASE_SELECT_IMAGES', 'Select Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2294, 'COM_JOOMGALLERY_UPLOAD_POSITION', 'Position: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2295, 'COM_JOOMGALLERY_UPLOAD_RESIZE_NOT_NECESSARY', 'Resize is not necessary because the image is already small enough', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2296, 'COM_JOOMGALLERY_UPLOAD_RESIZE_TO_MAX', 'Resizing to max width...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2297, 'COM_JOOMGALLERY_UPLOAD_START_BATCHUPLOAD', 'Begin Uploading', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2298, 'COM_JOOMGALLERY_UPLOAD_TAB_AJAX_UPLOAD', 'Drag\'n\'Drop Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2299, 'COM_JOOMGALLERY_UPLOAD_TAB_BATCH_UPLOAD', 'Batch Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2300, 'COM_JOOMGALLERY_UPLOAD_TAB_JAVA_UPLOAD', 'Java Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2301, 'COM_JOOMGALLERY_UPLOAD_TAB_SINGLE_UPLOAD', 'Single Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2302, 'COM_JOOMGALLERY_UPLOAD_UNSUPPORTED_RESIZING_METHOD', 'Unsupported resizing method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2303, 'COM_JOOMGALLERY_UPLOAD_UPLOAD', 'Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2304, 'COM_JOOMGALLERY_USERCATEGORIES_GUESTS_CANNOT_OWN_CATEGORIES', 'You cannot see any categories here because you aren\'t logged in. Guests cannot own any categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2305, 'COM_JOOMGALLERY_USERCATEGORIES_IMAGES', 'Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2306, 'COM_JOOMGALLERY_USERCATEGORIES_NEW_CATEGORY_MAXCOUNT', 'Maximal number of categories, you can create: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2307, 'COM_JOOMGALLERY_USERCATEGORIES_NEW_CATEGORY_NOTE', 'Limits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2308, 'COM_JOOMGALLERY_USERCATEGORIES_NEW_CATEGORY_REMAINDER', 'Number of categories left that can be created: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2309, 'COM_JOOMGALLERY_USERCATEGORIES_NEW_CATEGORY_YOURCOUNT', 'Number of categories you have already created: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2310, 'COM_JOOMGALLERY_USERCATEGORIES_YOU_NOT_HAVE_CATEGORY', 'You do not have any category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2311, 'COM_JOOMGALLERY_USERPANEL_GUESTS_CANNOT_OWN_IMAGES', 'You cannot see any images here because you aren\'t logged in. Guests cannot own any images.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2312, 'COM_JOOMGALLERY_USERPANEL_MSG_NO_CATEGORIES_FOUND_MATCHING_YOUR_QUERY', 'There were no categories found matching your query.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2313, 'COM_JOOMGALLERY_USERPANEL_MSG_NO_IMAGES_FOUND_MATCHING_YOUR_QUERY', 'There were no images found matching your query.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2314, 'COM_JOOMGALLERY_USERPANEL_YOU_DO_NOT_HAVE_IMAGE', 'You do not have any images.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2315, 'JGLOBAL_CHECK_ALL', 'CHECK ALL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2316, 'JGRID_CHECKBOX_ROW_N', 'Checkbox for row %d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2317, 'JNO', 'No', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2318, 'JOPTION_ORDER_FIRST', 'Order First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2319, 'JOPTION_ORDER_LAST', 'Order Last', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2320, 'JYES', 'Yes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2321, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_MAXCOUNT', 'Maximum number of images that you can upload: %s %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2322, 'COM_JOOMGALLERY_UPLOAD_OUTPUT_MAY_ADD_MAX_OF', 'Sorry, your upload limit of %s image(s) %s is reached. Contact the administrator if you want to upload more images.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2323, 'COM_JOOMGALLERY_CATEGORY_BUTTON_UNLOCK', 'Unlock', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2324, 'COM_JOOMGALLERY_CATEGORY_BUTTON_UNLOCKING', 'Unlocking...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2325, 'COM_JOOMGALLERY_CATEGORY_PASSWORD', 'Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2326, 'COM_JOOMGALLERY_CATEGORY_PASSWORD_PROTECTED', 'This category is password protected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2327, 'COM_JOOMGALLERY_CATEGORY_THERE_IS_ONE_IMAGE_IN_CATEGORY', 'There is one image in this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2328, 'COM_JOOMGALLERY_CATEGORY_THERE_IS_ONE_SUBCATEGORY_IN_CATEGORY', 'There is one sub-category in this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2329, 'COM_JOOMGALLERY_CATEGORY_WRONG_PASSWORD', 'Wrong password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2330, 'COM_JOOMGALLERY_COMMON_CATEGORY_PASSWORD_PROTECTED', 'Password-protected', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2331, 'COM_JOOMGALLERY_COMMON_CATEGORY_PASSWORD_PROTECTED_TIPTEXT', 'This category is password-protected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2332, 'COM_JOOMGALLERY_COMMON_DOWNLOADS', 'Downloads', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2333, 'COM_JOOMGALLERY_COMMON_DOWNLOADS_VAR', 'Downloads: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2334, 'COM_JOOMGALLERY_COMMON_UPLOAD_ICON_TIPCAPTION', 'Upload in this category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2335, 'COM_JOOMGALLERY_COMMON_UPLOAD_ICON_TIPTEXT', 'Click here if you want to upload images into this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2336, 'COM_JOOMGALLERY_MINI_AJAX_UPLOAD_NOTE', 'This image was uploaded successfully. If you cancel inserting it now please don\'t upload it again later, but look for it in tab \'Insert Image\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2337, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_MAXCOUNT_TIMESPAN_1', 'each day', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2338, 'COM_JOOMGALLERY_UPLOAD_NEW_IMAGE_MAXCOUNT_TIMESPAN_MORE', 'in %d days', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2339, 'COM_JOOMGALLERY_COMMON_ENTER_IMAGE_TITLE', 'Enter an image title!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2340, 'COM_JOOMGALLERY_AJAXUPLOAD_GENERICTITLE_MODE', 'Generic Title Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2341, 'COM_JOOMGALLERY_AJAXUPLOAD_GENERICTITLE_MODE_DESC', 'If checked all images uploaded will have the same generic title entered below. Uncheck this option to enter an individual image title for each image before upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2342, 'COM_JOOMGALLERY_EDITIMAGE_MSG_COULD_NOT_DELETE_VOTES', 'Could not delete the votes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2343, 'COM_JOOMGALLERY_COMMON_MSG_IMAGE_AND_COMMENTS_DELETED', 'Image and related comments, votes and nametags were successfully deleted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.ini'),
(2344, 'COM_JOOMGALLERY_IPTC_DATA', 'IPTC-Data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2345, 'COM_JOOMGALLERY_IPTCTAGS', 'IPTC-Tags&nbsp;&sup1;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2346, 'COM_JOOMGALLERY_TAG', 'Tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2347, 'COM_JOOMGALLERY_TAGDESCRIPTION', 'Definition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2348, 'COM_JOOMGALLERY_TAGNAME', 'Tag-Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2349, 'COM_JOOMGALLERY_TAGNR', 'Tag-Nr.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2350, 'COM_JOOMGALLERY_IPTC_CITYLEGACY', 'City', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2351, 'COM_JOOMGALLERY_IPTC_CITYLEGACY_DEFINITION', 'Name of the city the content is focussing on -- either the place shown in visual media or referenced by text or audio media. This element is at the third level of a top-down geographical hierarchy.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2352, 'COM_JOOMGALLERY_IPTC_CONTACT', 'Contact', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2353, 'COM_JOOMGALLERY_IPTC_CONTACT_DEFINITION', 'A generic structure providing a basic set of information to get in contact with a person or organisation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2354, 'COM_JOOMGALLERY_IPTC_COPYRIGHTNOTICE', 'Copyright Notice', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2355, 'COM_JOOMGALLERY_IPTC_COPYRIGHTNOTICE_DEFINITION', 'Contains any necessary copyright notice for claiming the intellectual property for this item and should identify the current owner of the copyright for the item. Other entities like the creator of the item may be added in the corresponding field. Notes on usage rights should be provided in \"Rights usage terms\".', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2356, 'COM_JOOMGALLERY_IPTC_COUNTRYCODELEGACY', 'Country Code', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2357, 'COM_JOOMGALLERY_IPTC_COUNTRYCODELEGACY_DEFINITION', 'Code of the country the content is focussing on -- either the country shown in visual media or referenced in text or audio media. This element is at the top/first level of a top-down geographical hierarchy. The code should be taken from ISO 3166 two or three letter code. The full name of a country should go to the \"Country\" element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2358, 'COM_JOOMGALLERY_IPTC_COUNTRYLEGACY', 'Country', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2359, 'COM_JOOMGALLERY_IPTC_COUNTRYLEGACY_DEFINITION', 'Full name of the country the content is focussing on -- either the country shown in visual media or referenced in text or audio media. This element is at the top/first level of a top-down geographical hierarchy. The full name should be expressed as a verbal name and not as a code, a code should go to the element \"CountryCode\".', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2360, 'COM_JOOMGALLERY_IPTC_CREATOR', 'Creator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2361, 'COM_JOOMGALLERY_IPTC_CREATORSJOBTITLE', 'Creator\'s Jobtitle', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2362, 'COM_JOOMGALLERY_IPTC_CREATORSJOBTITLE_DEFINITION', 'Contains the job title of the person who created the content of this item. As this is sort of a qualifier the Creator element has to be filled in as mandatory prerequisite for using Creator\'s Jobtitle.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2363, 'COM_JOOMGALLERY_IPTC_CREATOR_DEFINITION', 'Contains the name of the person who created the content of this item, a photographer for photos, a graphic artist for graphics, or a writer for textual news, but in cases where the photographer should not be identified the name of a company or organisation may be appropriate.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2364, 'COM_JOOMGALLERY_IPTC_CREDITLINE', 'Credit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2365, 'COM_JOOMGALLERY_IPTC_CREDITLINE_DEFINITION', 'The credit to person(s) and/or organisation(s) required by the supplier of the item to be used when published. This is a free-text field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2366, 'COM_JOOMGALLERY_IPTC_DATECREATED', 'Date Created', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2367, 'COM_JOOMGALLERY_IPTC_DATECREATED_DEFINITION', 'Designates the date the intellectual content was created rather than the date of the creation of the physical representation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2368, 'COM_JOOMGALLERY_IPTC_DESCRIPTION', 'Caption/Abstract', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2369, 'COM_JOOMGALLERY_IPTC_DESCRIPTIONWRITER', 'Writer/Editor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2370, 'COM_JOOMGALLERY_IPTC_DESCRIPTIONWRITER_DEFINITION', 'Identifier or the name of the person involved in writing, editing or correcting the description of the content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2371, 'COM_JOOMGALLERY_IPTC_DESCRIPTION_DEFINITION', 'A textual description, including captions, of the item\'s content, particularly used where the object is not text.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2372, 'COM_JOOMGALLERY_IPTC_HEADLINE', 'Headline', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2373, 'COM_JOOMGALLERY_IPTC_HEADLINE_DEFINITION', 'A brief synopsis of the caption. Headline is not the same as Title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2374, 'COM_JOOMGALLERY_IPTC_INSTRUCTIONS', 'Instructions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2375, 'COM_JOOMGALLERY_IPTC_INSTRUCTIONS_DEFINITION', 'Any of a number of instructions from the provider or creator to the receiver of the item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2376, 'COM_JOOMGALLERY_IPTC_INTELLECTUALGENRE', 'Intellectual Genre', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2377, 'COM_JOOMGALLERY_IPTC_INTELLECTUALGENRE_DEFINITION', 'Describes the nature, intellectual, artistic or journalistic characteristic of a item, not specifically its content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2378, 'COM_JOOMGALLERY_IPTC_KEYWORDS', 'Keywords', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2379, 'COM_JOOMGALLERY_IPTC_KEYWORDS_DEFINITION', 'Keywords to express the subject of the content. Keywords may be free text and don\'t have to be taken from a controlled vocabulary. Codes from the controlled vocabulary IPTC Subject NewsCodes must go to the \"Subject Code\" field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2380, 'COM_JOOMGALLERY_IPTC_PROVINCEORSTATELEGACY', 'Province/State', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2381, 'COM_JOOMGALLERY_IPTC_PROVINCEORSTATELEGACY_DEFINITION', 'Name of the subregion of a country -- either called province or state or anything else -- the content is focussing on -- either the subregion shown in visual media or referenced by text or audio media. This element is at the second level of a top-down geographical hierarchy.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2382, 'COM_JOOMGALLERY_IPTC_SOURCE', 'Source', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2383, 'COM_JOOMGALLERY_IPTC_SOURCE_DEFINITION', 'Identifies the original owner of the copyright for the intellectual content of the item. This could be an agency, a member of an agency or an individual. Source could be different from Creator and from the entities in the CopyrightNotice.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2384, 'COM_JOOMGALLERY_IPTC_SUBLOCATIONLEGACY', 'Location', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2385, 'COM_JOOMGALLERY_IPTC_SUBLOCATIONLEGACY_DEFINITION', 'Name of a sublocation the content is focussing on -- either the location shown in visual media or referenced by text or audio media. This location name could either be the name of a sublocation to a city or the name of a well known location or (natural) monument outside a city. In the sense of a sublocation to a city this element is at the fourth level of a top-down geographical hierarchy.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2386, 'COM_JOOMGALLERY_IPTC_TIMECREATED', 'Time Created', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2387, 'COM_JOOMGALLERY_IPTC_TIMECREATED_DEFINITION', 'Designates the time the intellectual content was created rather than the time of the creation of the physical representation. If no time is given the value should default to 00:00:00.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2388, 'COM_JOOMGALLERY_IPTC_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2389, 'COM_JOOMGALLERY_IPTC_TITLE_DEFINITION', 'A shorthand reference for the digital image. Title provides a short human readable name which can be a text and/or numeric reference. It is not the same as Headline.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_joomgallery.iptc.ini'),
(2390, 'COM_KOMENTO_ERROR', 'Error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2391, 'COM_KOMENTO_LOADING', 'Loading', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2392, 'COM_KOMENTO_GUEST', 'Guest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2393, 'COM_KOMENTO_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2394, 'COM_KOMENTO_NOT_ALLOWED', 'Not allowed to perform such action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2395, 'COM_KOMENTO_INVALID_ID', 'Invalid ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2396, 'COM_KOMENTO_INVALID_TOKEN', 'Invalid Token', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2397, 'COM_KOMENTO_BUGREPORT', 'Sorry, something went wrong. Please include the following information in your error report.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2398, 'COM_KOMENTO_UNABLE_TO_LOAD_ARTICLE_DETAILS', 'Unable to load article details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2399, 'COM_KOMENTO_SORT_BY', 'Sort by:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2400, 'COM_KOMENTO_SORT_DEFAULT', 'Sort by Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(2401, 'COM_KOMENTO_SORT_LATEST', 'Sort by Latest First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2402, 'COM_KOMENTO_SORT_OLDEST', 'Sort by Oldest First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2403, 'COM_KOMENTO_SUBSCRIBE_RSS', 'Subscribe with RSS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2404, 'COM_KOMENTO_SUBSCRIBE_EMAIL', 'Subscribe with Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2405, 'COM_KOMENTO_SUBSCRIBE_WITH_EMAIL', 'Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2406, 'COM_KOMENTO_ADMIN_MODE', 'Admin Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2407, 'COM_KOMENTO_MENU_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2408, 'COM_KOMENTO_MENU_FLAGS', 'Reported Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2409, 'COM_KOMENTO_MENU_PENDING', 'Pending Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2410, 'COM_KOMENTO_MENU_SUBSCRIBERS', 'Subscribers', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2411, 'COM_KOMENTO_COMMENTS_NO_COMMENT', 'No comments found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2412, 'COM_KOMENTO_TOTAL_COMMENTS', 'Total Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2413, 'COM_KOMENTO_X_YEAR_AGO', 'about %1s year ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2414, 'COM_KOMENTO_X_MONTH_AGO', 'about %1s month ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2415, 'COM_KOMENTO_X_WEEK_AGO', 'about %1s week ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2416, 'COM_KOMENTO_X_DAY_AGO', '%1s day ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2417, 'COM_KOMENTO_X_HOUR_AGO', '%1s hour ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2418, 'COM_KOMENTO_X_MINUTE_AGO', '%1s minute ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2419, 'COM_KOMENTO_X_SECOND_AGO', '%1s second ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2420, 'COM_KOMENTO_X_YEARS_AGO', 'about %1s years ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2421, 'COM_KOMENTO_X_MONTHS_AGO', 'about %1s months ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2422, 'COM_KOMENTO_X_WEEKS_AGO', 'about %1s weeks ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2423, 'COM_KOMENTO_X_DAYS_AGO', 'about %1s days ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2424, 'COM_KOMENTO_X_HOURS_AGO', '%1s hours ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2425, 'COM_KOMENTO_X_MINUTES_AGO', '%1s minutes ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2426, 'COM_KOMENTO_X_SECONDS_AGO', '%1s seconds ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2427, 'COM_KOMENTO_ONE_SECOND_AGO', '1 second ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2428, 'COM_KOMENTO_COMMENT_ID_TITLE', 'Comment #', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2429, 'COM_KOMENTO_COMPONENT_TITLE', 'Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2430, 'COM_KOMENTO_ARTICLE_ID_TITLE', 'Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2431, 'COM_KOMENTO_STATUS_TITLE', 'Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2432, 'COM_KOMENTO_FLAG_TITLE', 'Flag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2433, 'COM_KOMENTO_LIST_LOAD_PREVIOUS', 'Load Previous Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2434, 'COM_KOMENTO_LIST_LOAD_MORE', 'Load More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2435, 'COM_KOMENTO_STICKIES_TITLE', 'Stickies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2436, 'COM_KOMENTO_LOVIES_TITLE', 'Lovies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2437, 'COM_KOMENTO_COMMENT_CONVERSATION_BAR_TITLE', 'People in this conversation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2438, 'COM_KOMENTO_COMMENT_FORM_NOT_ALLOWED', 'You don\'t have permission to view or post comments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2439, 'COM_KOMENTO_COMMENTS_LOADING', 'Loading comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2440, 'COM_KOMENTO_COMMENT_IN_REPLY_TO', 'In reply to: <a class=\"parentLink kmt-parent-link\" href=\"%1s\"># %2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2441, 'COM_KOMENTO_COMMENT_IN_REPLY_TO_NAME', 'In reply to: <a class=\"parentLink kmt-parent-link\" href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2442, 'COM_KOMENTO_COMMENT_LIKES', 'Likes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2443, 'COM_KOMENTO_COMMENT_LIKES_COUNTER', 'Likes: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2444, 'COM_KOMENTO_COMMENT_PEOPLE_WHO_LIKED_THIS', 'People who liked this', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2445, 'COM_KOMENTO_COMMENT_NO_USER_LIKE_THIS', 'No users liked this yet', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2446, 'COM_KOMENTO_COMMENT_UNLIKE', 'Unlike', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2447, 'COM_KOMENTO_COMMENT_LIKE', 'Like', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2448, 'COM_KOMENTO_COMMENT_SHARE', 'Share', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2449, 'COM_KOMENTO_COMMENT_SHARE_LOADING', 'Loading', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2450, 'COM_KOMENTO_COMMENT_SHARE_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2451, 'COM_KOMENTO_COMMENT_SHORT_URL', 'Short URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2452, 'COM_KOMENTO_COMMENT_URL', 'URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2453, 'COM_KOMENTO_COMMENT_REPORT', 'Report', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2454, 'COM_KOMENTO_COMMENT_REPORTED', 'Reported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2455, 'COM_KOMENTO_COMMENT_REPLY', 'Reply', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2456, 'COM_KOMENTO_COMMENT_REPLY_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2457, 'COM_KOMENTO_COMMENT_ADMIN_TOOLS', 'Admin Tools', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2458, 'COM_KOMENTO_COMMENT_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2459, 'COM_KOMENTO_COMMENT_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2460, 'COM_KOMENTO_COMMENT_EDITTED_BY', 'Comment last edited on %1s by %2s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2461, 'COM_KOMENTO_COMMENT_EDIT_CANCEL', 'Cancel Edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2462, 'COM_KOMENTO_COMMENT_STICK', 'Stick', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2463, 'COM_KOMENTO_COMMENT_UNSTICK', 'Unstick', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2464, 'COM_KOMENTO_COMMENT_PERMALINK', 'Permalink', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2465, 'COM_KOMENTO_COMMENT_PERMANENT_LINK', 'Permanent Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2466, 'COM_KOMENTO_COMMENT_FLAGGED', 'Comment flagged as %1s by %2s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2467, 'COM_KOMENTO_COMMENT_NOT_ALLOWED', 'You are not allowed to view comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2468, 'COM_KOMENTO_COMMENT_PUBLISH', 'Publish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2469, 'COM_KOMENTO_COMMENT_UNPUBLISH', 'Unpublish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2470, 'COM_KOMENTO_COMMENT_CAPTCHA_TITLE', 'Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2471, 'COM_KOMENTO_CAPTCHA_INVALID_RESPONSE', 'Invalid Captcha response', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2472, 'COM_KOMENTO_COMMENT_CAPTCHA_RELOAD', 'Reload Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2473, 'COM_KOMENTO_RECAPTCHA_INVALID_RESPONSE', 'Invalid reCAPTCHA response', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2474, 'COM_KOMENTO_RECAPTCHA_MISSING_KEYS', 'Missing reCAPTCHA keys', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2475, 'COM_KOMENTO_COMMENT_ATTACHMENTS', 'Attachments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2476, 'COM_KOMENTO_ATTACHMENT_INVALID_ID', 'Invalid attachment ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2477, 'COM_KOMENTO_ATTACHMENT_NO_PERMISSION', 'No permission to download this file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2478, 'COM_KOMENTO_COMMENT_ATTACHMENTS_NO_PERMISSION_TO_VIEW', 'No permission to view attachments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2479, 'COM_KOMENTO_ATTACHMENT_CONFIRM_DELETE', 'Are you sure you want to delete the attachment \'%1s\'?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2480, 'COM_KOMENTO_ATTACHMENT_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2481, 'COM_KOMENTO_ATTACHMENT_DELETE_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2482, 'COM_KOMENTO_ATTACHMENT_INVALID_COMMENT_ATTACHMENT', 'Invalid comment attachment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2483, 'COM_KOMENTO_COMMENT_WHERE_ARE_YOU', 'Where are you?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2484, 'COM_KOMENTO_COMMENT_FROM', 'from', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2485, 'COM_KOMENTO_FORM_ADD_COMMENTS', 'Add comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2486, 'COM_KOMENTO_FORM_LEAVE_YOUR_COMMENTS', 'Leave your comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2487, 'COM_KOMENTO_FORM_POST_COMMENT_AS_GUEST', 'Post comment as a guest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2488, 'COM_KOMENTO_FORM_USER_COMMENTS_WILL_BE_MODERATED', 'Your comments are subjected to administrator\'s moderation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2489, 'COM_KOMENTO_FORM_IN_REPLY_TO', 'In reply to: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2490, 'COM_KOMENTO_FORM_SUBMIT', 'Submit Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2491, 'COM_KOMENTO_FORM_REPLY', 'Reply', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2492, 'COM_KOMENTO_FORM_SAVE', 'Save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2493, 'COM_KOMENTO_FORM_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2494, 'COM_KOMENTO_FORM_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2495, 'COM_KOMENTO_FORM_EMAIL', 'Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2496, 'COM_KOMENTO_FORM_WEBSITE', 'Website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2497, 'COM_KOMENTO_FORM_SUBSCRIBE', 'Subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2498, 'COM_KOMENTO_FORM_UNSUBSCRIBE', 'Unsubscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2499, 'COM_KOMENTO_FORM_REGISTER', 'Register', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2500, 'COM_KOMENTO_FORM_ALREADY_SUBSCRIBE', 'Already subscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2501, 'COM_KOMENTO_FORM_SUBSCRIBE_ENTER_DETAILS', 'Fill in the from to subscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2502, 'COM_KOMENTO_FORM_SUBSCRIBE_FILL_IN_ALL_THE_FIELDS', 'Please fill in all the required fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2503, 'COM_KOMENTO_FORM_SUBSCRIBE_WITH_CURRENT_DETAILS', 'Subscribe with current details?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2504, 'COM_KOMENTO_FORM_SUBSCRIBE_PENDING', 'Subscription pending confirmation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2505, 'COM_KOMENTO_FORM_AGREE_TNC', 'Agree to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2506, 'COM_KOMENTO_FORM_TNC', 'Terms and Condition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2507, 'COM_KOMENTO_FORM_READ_TNC', 'terms and condition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2508, 'COM_KOMENTO_FORM_LOCATION_AUTODETECT', 'Detect Location', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2509, 'COM_KOMENTO_FORM_LOCATION_DETECTING', 'Detecting...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2510, 'COM_KOMENTO_FORM_NOT_ALLOWED', 'You are not allowed to comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2511, 'COM_KOMENTO_FORM_GUEST_NOT_ALLOWED', 'Please login to comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2512, 'COM_KOMENTO_FORM_CHARACTERS', 'characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2513, 'COM_KOMENTO_FORM_CHARACTER_LIMIT', 'character limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2514, 'COM_KOMENTO_FORM_REQUIRED', 'Required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2515, 'COM_KOMENTO_FORM_ATTACH_FILE', 'Attach file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2516, 'COM_KOMENTO_FORM_OR_DROP_FILES_HERE', 'or drop files here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2517, 'COM_KOMENTO_FORM_MAXIMUM_FILES_ALLOWED', 'Maximum files allowed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2518, 'COM_KOMENTO_FORM_UPLOAD_QUEUE_TITLE_FILE_QUEUE', 'File queue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2519, 'COM_KOMENTO_FORM_UPLOAD_QUEUE_TITLE_FILENAME', 'Filename', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2520, 'COM_KOMENTO_FORM_UPLOAD_QUEUE_TITLE_SIZE', 'Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2521, 'COM_KOMENTO_FORM_LOCKED', 'Comment posting has been locked by admin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2522, 'COM_KOMENTO_FORM_CHARACTER_RESTRICTION', 'Character restriction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2523, 'COM_KOMENTO_FORM_CHARACTER_BETWEEN', 'Your text should be in between %1s-%2s characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2524, 'COM_KOMENTO_FORM_CHARACTER_MIN', 'Your text should be more than %1s characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2525, 'COM_KOMENTO_FORM_CHARACTER_MAX', 'Your text should be less than %1s characters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2526, 'COM_KOMENTO_FORM_NOTIFICATION_FIELD_REQUIRED', 'Please fill in all the required fields', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2527, 'COM_KOMENTO_FORM_NOTIFICATION_COMMENT_REQUIRED', 'Please enter some comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2528, 'COM_KOMENTO_FORM_NOTIFICATION_COMMENT_TOO_SHORT', 'Comment too short', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2529, 'COM_KOMENTO_FORM_NOTIFICATION_COMMENT_TOO_LONG', 'Comment too long', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2530, 'COM_KOMENTO_FORM_NOTIFICATION_USERNAME_REQUIRED', 'Username required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2531, 'COM_KOMENTO_FORM_NOTIFICATION_NAME_REQUIRED', 'Name required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2532, 'COM_KOMENTO_FORM_NOTIFICATION_EMAIL_REQUIRED', 'Email required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2533, 'COM_KOMENTO_FORM_NOTIFICATION_EMAIL_INVALID', 'Invalid Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2534, 'COM_KOMENTO_FORM_NOTIFICATION_WEBSITE_REQUIRED', 'Website required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2535, 'COM_KOMENTO_FORM_NOTIFICATION_WEBSITE_INVALID', 'Invalid Website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2536, 'COM_KOMENTO_FORM_NOTIFICATION_TNC_REQUIRED', 'You need to agree to Terms and Condition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2537, 'COM_KOMENTO_FORM_NOTIFICATION_CAPTCHA_REQUIRED', 'Captcha required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2538, 'COM_KOMENTO_FORM_NOTIFICATION_FLOOD', 'Please submit again in a while', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2539, 'COM_KOMENTO_FORM_NOTIFICATION_AKISMET_SPAM', 'Akismet detected spam in comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2540, 'COM_KOMENTO_FORM_NOTIFICATION_SUBMITTED', 'Comment posted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2541, 'COM_KOMENTO_FORM_NOTIFICATION_PENDING', 'Comment submitted and pending approval from admins', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2542, 'COM_KOMENTO_FORM_NOTIFICATION_SUBSCRIBED', 'Subscribed!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2543, 'COM_KOMENTO_FORM_NOTIFICATION_SUBSCRIBE_CONFIRMATION_REQUIRED', 'Confirmation Email Sent!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2544, 'COM_KOMENTO_FORM_NOTIFICATION_SUBSCRIBE_ERROR', 'Subscribe error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2545, 'COM_KOMENTO_FORM_NOTIFICATION_UNSUBSCRIBED', 'Unsubscribed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2546, 'COM_KOMENTO_FORM_NOTIFICATION_UNSUBSCRIBED_ERROR', 'Unsubscribe error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2547, 'COM_KOMENTO_FORM_NOTIFICATION_UNSUBSCRIBED_SUCCESSFULLY', 'Successfully unsubscribed!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2548, 'COM_KOMENTO_FORM_NOTIFICATION_MAX_FILE_SIZE', 'File size error. Maximum file size: %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2549, 'COM_KOMENTO_FORM_NOTIFICATION_MAX_FILE_ITEM', 'Maximum files error. Maximum files allowed: %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2550, 'COM_KOMENTO_FORM_NOTIFICATION_FILE_EXTENSION', 'File extension error. Allowed file extensions: %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2551, 'COM_KOMENTO_FORM_NOTIFICATION_UPLOAD_NOT_ALLOWED', 'Not allowed to upload attachment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2552, 'COM_KOMENTO_BBCODE_BOLD', 'Bold', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2553, 'COM_KOMENTO_BBCODE_ITALIC', 'Italic', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2554, 'COM_KOMENTO_BBCODE_UNDERLINE', 'Underline', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2555, 'COM_KOMENTO_BBCODE_LINK', 'Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2556, 'COM_KOMENTO_BBCODE_PICTURE', 'Picture', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2557, 'COM_KOMENTO_BBCODE_VIDEO', 'Video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2558, 'COM_KOMENTO_BBCODE_BULLETLIST', 'Bullet List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2559, 'COM_KOMENTO_BBCODE_NUMERICLIST', 'Numeric List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2560, 'COM_KOMENTO_BBCODE_BULLET', 'Bullet', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2561, 'COM_KOMENTO_BBCODE_QUOTE', 'Quote', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2562, 'COM_KOMENTO_BBCODE_CODE', 'Code', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2563, 'COM_KOMENTO_BBCODE_CLEAN', 'Clean', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2564, 'COM_KOMENTO_BBCODE_SMILE', 'Smile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2565, 'COM_KOMENTO_BBCODE_HAPPY', 'Happy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2566, 'COM_KOMENTO_BBCODE_SURPRISED', 'Surprised', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2567, 'COM_KOMENTO_BBCODE_TONGUE', 'Tongue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2568, 'COM_KOMENTO_BBCODE_UNHAPPY', 'Unhappy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2569, 'COM_KOMENTO_BBCODE_WINK', 'Wink', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2570, 'COM_KOMENTO_BBCODE_LINK_TEXT', 'Your text to link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2571, 'COM_KOMENTO_SUPPORTED_VIDEOS', 'Supported Videos\\nYoutube, Vimeo, Dailymotion, Google, Liveleak, Metacafe, Nicovideo, Yahoo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2572, 'COM_KOMENTO_INSERT_VIDEO', 'Insert Video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2573, 'COM_KOMENTO_INSERT_VIDEO_DESC', 'Video embedding is supported for the following video providers:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2574, 'COM_KOMENTO_INSERT_VIDEO_URL', 'Video URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2575, 'COM_KOMENTO_INSERT_VIDEO_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2576, 'COM_KOMENTO_VIDEO_YOUTUBE', 'Youtube', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2577, 'COM_KOMENTO_VIDEO_VIMEO', 'Vimeo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2578, 'COM_KOMENTO_VIDEO_DAILYMOTION', 'Daily Motion', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2579, 'COM_KOMENTO_VIDEO_GOOGLE', 'Google Video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2580, 'COM_KOMENTO_VIDEO_LIVELEAK', 'LiveLeak', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2581, 'COM_KOMENTO_VIDEO_METACAFE', 'MetaCafe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2582, 'COM_KOMENTO_VIDEO_NICOVIDEO', 'NicoVideo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2583, 'COM_KOMENTO_VIDEO_YAHOO', 'Yahoo Video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2584, 'COM_KOMENTO_PUBLISHED', 'Published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2585, 'COM_KOMENTO_PUBLISH', 'Publish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2586, 'COM_KOMENTO_UNPUBLISHED', 'Unpublished', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2587, 'COM_KOMENTO_UNPUBLISH', 'Unpublish', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2588, 'COM_KOMENTO_MODERATE', 'Pending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2589, 'COM_KOMENTO_FLAGGED', 'Flagged', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2590, 'COM_KOMENTO_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2591, 'COM_KOMENTO_NOFLAG', 'No Flag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2592, 'COM_KOMENTO_CLEAR', 'Clear', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2593, 'COM_KOMENTO_SPAM', 'Spam', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2594, 'COM_KOMENTO_OFFENSIVE', 'Offensive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2595, 'COM_KOMENTO_OFFTOPIC', 'Offtopic', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2596, 'COM_KOMENTO_MARK_NOFLAG', 'Clear all reports', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2597, 'COM_KOMENTO_MARK_SPAM', 'Mark as Spam', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2598, 'COM_KOMENTO_MARK_OFFENSIVE', 'Mark as Offensive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2599, 'COM_KOMENTO_MARK_OFFTOPIC', 'Mark as Offtopic', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2600, 'COM_KOMENTO_COMMENTS_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2601, 'COM_KOMENTO_RESET_BUTTON', 'Reset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2602, 'COM_KOMENTO_COMMENTS_FILTER_STATUS', 'Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2603, 'COM_KOMENTO_COMMENTS_FILTER_COMPONENT', 'Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2604, 'COM_KOMENTO_COMMENTS_FILTER_FLAG', 'Flag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2605, 'COM_KOMENTO_COLUMN_NUM', '#', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2606, 'COM_KOMENTO_COLUMN_COMPONENT', 'Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2607, 'COM_KOMENTO_COLUMN_ARTICLE', 'Article Id', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2608, 'COM_KOMENTO_COLUMN_COMMENT', 'Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2609, 'COM_KOMENTO_COLUMN_COMMENT_CHILD', 'Replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2610, 'COM_KOMENTO_COLUMN_STATUS', 'Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2611, 'COM_KOMENTO_COLUMN_FLAG', 'Flag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2612, 'COM_KOMENTO_COLUMN_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2613, 'COM_KOMENTO_COLUMN_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2614, 'COM_KOMENTO_COLUMN_FLAG_DETAILS', 'Report Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2615, 'COM_KOMENTO_COLUMN_FLAG_RESOLVE', 'Resolve Action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2616, 'COM_KOMENTO_COLUMN_ACTION', 'Actions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2617, 'COM_KOMENTO_ALL_STATUS', 'All Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2618, 'COM_KOMENTO_ALL_FLAGS', 'All Flags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2619, 'COM_KOMENTO_ALL_COMPONENTS', 'All Components', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2620, 'COM_KOMENTO_CONFIRM_DELETE_AFFECT_ALL_CHILD', 'This comment contains replies. Do you want to delete all replies as well?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2621, 'COM_KOMENTO_CONFIRM_DELETE', 'Do you want to delete this comment?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2622, 'COM_KOMENTO_DELETE_COMMENT', 'Delete comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2623, 'COM_KOMENTO_DELETE_ALL_CHILD', 'Delete all replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2624, 'COM_KOMENTO_DELETE_MOVE_CHILD_UP', 'Keep all replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2625, 'COM_KOMENTO_DELETING', 'Deleting', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2626, 'COM_KOMENTO_CONFIRM_PUBLISH_AFFECT_ALL_CHILD', 'This comment contains replies. Do you want to publish all replies as well?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2627, 'COM_KOMENTO_PUBLISH_ALL_CHILD', 'Publish all replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2628, 'COM_KOMENTO_PUBLISH_SINGLE', 'Publish only this comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2629, 'COM_KOMENTO_CONFIRM_UNPUBLISH_AFFECT_ALL_CHILD', 'This will unpublish all replies as well. Are you sure to unpublish all replies?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2630, 'COM_KOMENTO_UNPUBLISH_ALL_CHILD', 'Unpublish all replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2631, 'COM_KOMENTO_CHILD_UNPUBLISHED', 'This comment contains replies. This comment and all the replies has been unpublished.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2632, 'COM_KOMENTO_CONFIRM_FLAG_AFFECT_ALL_CHILD', 'Mark all replies as well or only this comment?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2633, 'COM_KOMENTO_FLAG_ALL_CHILD', 'Mark all replies', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2634, 'COM_KOMENTO_FLAG_SINGLE', 'Mark only this comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2635, 'COM_KOMENTO_FEEDS_LATEST_TITLE', 'Latest comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2636, 'COM_KOMENTO_FEEDS_LATEST_TITLE_DESCRIPTION', 'Latest comments for Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2637, 'COM_KOMENTO_FEEDS_ALL_COMMENTS_TITLE', 'All comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2638, 'COM_KOMENTO_FEEDS_ALL_COMMENTS_TITLE_DESCRIPTION', 'All comments for Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2639, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_TITLE', 'All guest comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2640, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_TITLE_DESCRIPTION', 'All guest comments for Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2641, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_TITLE', 'Comments for User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2642, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_TITLE_DESCRIPTION', 'Comments from a specific user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2643, 'COM_KOMENTO_FEEDS_COMMENTS_FOR_COMPONENT_TITLE', 'Comments for Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2644, 'COM_KOMENTO_FEEDS_COMMENTS_FOR_COMPONENT_TITLE_DESCRIPTION', 'Comments from a specific component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2645, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_FOR_COMPONENT_TITLE', 'Guest comments for Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2646, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_FOR_COMPONENT_TITLE_DESCRIPTION', 'Guest comments from a specific component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2647, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_FOR_COMPONENT_TITLE', 'User comments for Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2648, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_FOR_COMPONENT_TITLE_DESCRIPTION', 'User comments from a specific component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2649, 'COM_KOMENTO_FEEDS_COMMENTS_FOR_COMPONENT_OF_ARTICLE_TITLE', 'Comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2650, 'COM_KOMENTO_FEEDS_COMMENTS_FOR_COMPONENT_OF_ARTICLE_TITLE_DESCRIPTION', 'Comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2651, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_FOR_COMPONENT_OF_ARTICLE_TITLE', 'Guest comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2652, 'COM_KOMENTO_FEEDS_GUEST_COMMENTS_FOR_COMPONENT_OF_ARTICLE_TITLE_DESCRIPTION', 'Guest comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2653, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_FOR_COMPONENT_TITLE_OF_ARTICLE', 'User comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2654, 'COM_KOMENTO_FEEDS_COMMENTS_FROM_USER_FOR_COMPONENT_TITLE_OF_ARTICLE_DESCRIPTION', 'User comments for Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2655, 'COM_KOMENTO_COM_ACESHOP', 'AceShop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2656, 'COM_KOMENTO_COM_CONTENT', 'Joomla Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2657, 'COM_KOMENTO_COM_CONTENTBUILDER', 'ContentBuilder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2658, 'COM_KOMENTO_COM_DOCMAN', 'Docman', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2659, 'COM_KOMENTO_COM_EASYBLOG', 'EasyBlog', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2660, 'COM_KOMENTO_COM_FLEXICONTENT', 'FlexiContent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2661, 'COM_KOMENTO_COM_HWDMEDIASHARE', 'hwdMediaShare', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2662, 'COM_KOMENTO_COM_JDOWNLOADS', 'JDownloads', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2663, 'COM_KOMENTO_COM_JEVENTS', 'JEvents', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2664, 'COM_KOMENTO_COM_K2', 'K2', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2665, 'COM_KOMENTO_COM_MTREE', 'MosetsTree', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2666, 'COM_KOMENTO_COM_OHANAH', 'Ohanah', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2667, 'COM_KOMENTO_COM_REDSHOP', 'Redshop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2668, 'COM_KOMENTO_COM_SOBIPRO', 'SobiPro', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2669, 'COM_KOMENTO_COM_VIRTUEMART', 'Virtuemart', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2670, 'COM_KOMENTO_COM_ZOO', 'Zoo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2671, 'COM_KOMENTO_FRONTPAGE_COMMENT', 'Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2672, 'COM_KOMENTO_FRONTPAGE_READMORE', 'Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2673, 'COM_KOMENTO_FRONTPAGE_HITS', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2674, 'COM_KOMENTO_LIKES_YOU_HAVE_ALREADY_LIKED_THIS_ITEM', 'You have already liked this item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2675, 'COM_KOMENTO_LIKES_ERROR_SAVING_LIKES', 'There was a problem saving this.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2676, 'COM_KOMENTO_NOTIFICATION_HELLO', 'Good day', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2677, 'COM_KOMENTO_NOTIFICATION_NEW_COMMENT_POSTED', 'A new comment is posted on:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2678, 'COM_KOMENTO_NOTIFICATION_NEW_COMMENT_PENDING', 'A new comment is posted and pending your moderation on:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2679, 'COM_KOMENTO_NOTIFICATION_SUBSCRIBE_CONFIRMATION_PENDING', 'Please click on the confirmation button to confirm your subscription to comment updates in the article:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2680, 'COM_KOMENTO_NOTIFICATION_NEW_COMMENT_SNIPPET', 'Below is a snippet from the comment that has been posted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2681, 'COM_KOMENTO_NOTIFICATION_POSTED_ON', 'Posted on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2682, 'COM_KOMENTO_NOTIFICATION_VIEW_COMMENT', 'View Comment &nbsp; &raquo;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2683, 'COM_KOMENTO_NOTIFICATION_NEW_COMMENT_SUBJECT', 'A new comment is posted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2684, 'COM_KOMENTO_NOTIFICATION_PENDING_COMMENT_SUBJECT', 'A new comment is pending your moderation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2685, 'COM_KOMENTO_NOTIFICATION_CONFIRM_SUBSCRIPTION_SUBJECT', 'Pending subscribe confirmation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2686, 'COM_KOMENTO_NOTIFICATION_CONFIRM_SUBSCRIPTION', 'Confirm Subscription', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2687, 'COM_KOMENTO_NOTIFICATION_UNSUBSCRIBE_TEXT', 'This email was sent to you because you have subscribed to comments update', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2688, 'COM_KOMENTO_NOTIFICATION_UNSUBSCRIBE', 'To unsubscribe', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2689, 'COM_KOMENTO_NOTIFICATION_UNSUBSCRIBE_HERE', 'click here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2690, 'COM_KOMENTO_NOTIFICATION_APPROVE_COMMENT', 'Approve Comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2691, 'COM_KOMENTO_NOTIFICATION_REPORT_COMMENT_SUBJECT', 'A comment has been reported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2692, 'COM_KOMENTO_NOTIFICATION_COMMENT_REPORTED', 'User %1s reported a comment on:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2693, 'COM_KOMENTO_NOTIFICATION_COMMENT_REPORTED_SNIPPET', 'Below is a snippet from the comment that was reported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2694, 'COM_KOMENTO_PROFILE', 'Komento User Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2695, 'COM_KOMENTO_PROFILE_NOT_FOUND', 'Profile not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2696, 'COM_KOMENTO_PROFILE_TAB_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2697, 'COM_KOMENTO_PROFILE_TAB_ACTIVITIES', 'Activities', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2698, 'COM_KOMENTO_PROFILE_TAB_POPULAR', 'Popular', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2699, 'COM_KOMENTO_PROFILE_TAB_STICKED', 'Sticked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2700, 'COM_KOMENTO_USER_TOTAL_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2701, 'COM_KOMENTO_USER_TOTAL_LIKES_RECEIVED', 'Liked Received', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2702, 'COM_KOMENTO_USER_TOTAL_LIKES_GIVEN', 'Likes Given', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2703, 'COM_KOMENTO_ACTIVITY_COMMENTED_ON', 'Commented on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2704, 'COM_KOMENTO_ACTIVITY_COMMENTED_IN', 'in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2705, 'COM_KOMENTO_ACTIVITY_REPLIED_TO', 'Replied to comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2706, 'COM_KOMENTO_ACTIVITY_REPLIED_ON', 'on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2707, 'COM_KOMENTO_ACTIVITY_REPLIED_IN', 'in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2708, 'COM_KOMENTO_ACTIVITY_LIKED_ON', 'Liked a comment on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2709, 'COM_KOMENTO_ACTIVITY_LIKED_IN', 'in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2710, 'COM_KOMENTO_JOMSOCIAL_ACTIVITY_COMMENT_ADDED', '{actor} added a new comment in <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2711, 'COM_KOMENTO_JOMSOCIAL_ACTIVITY_REPLY_ADDED', '{actor} replied to a <a href=\"%1s\">comment</a> in <a href=\"%2s\">%3s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2712, 'COM_KOMENTO_JOMSOCIAL_ACTIVITY_LIKED_COMMENT', '{actor} liked a <a href=\"%1s\">comment</a> in <a href=\"%2s\">%3s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2713, 'COM_KOMENTO_NOTIFICATION_NEW_COMMENT', '%1s new comment(s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2714, 'COM_KOMENTO_RELOAD_COMMENTS', 'Reload comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2715, 'COM_KOMENTO_ACL_NO_PERMISSION', 'No permission to perform such action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2716, 'COM_KOMENTO_FORM_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2717, 'COM_KOMENTO_TITLE_IN_COMPONENT', 'in %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2718, 'COM_KOMENTO_COMMENT_CAPTCHA_DESC', 'Type the text presented in the image below. Not clear?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2719, 'COM_KOMENTO_PROFILE_SYSTEM_DISABLED', 'Sorry, you are not allowed to access this section as the profile system is disabled.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2720, 'COM_KOMENTO_MEMBER_SINCE', 'Member since', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2721, 'COM_KOMENTO_LAST_LOGIN', 'Last login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2722, 'COM_KOMENTO_NO_COMMENTS_FOUND', 'No comments found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2723, 'COM_KOMENTO_NO_ACTIVITIES_FOUND', 'No activities found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2724, 'COM_KOMENTO_AUP_POST_COMMENT', 'New comment posted at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2725, 'COM_KOMENTO_AUP_REPLY_COMMENT', 'New reply posted at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2726, 'COM_KOMENTO_AUP_LIKE_COMMENT', 'Liked a comment at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2727, 'COM_KOMENTO_AUP_UNLIKE_COMMENT', 'Unliked a comment at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2728, 'COM_KOMENTO_AUP_REPORT_COMMENT', 'Reported a comment at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2729, 'COM_KOMENTO_AUP_UNREPORT_COMMENT', 'Unreported a comment at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2730, 'COM_KOMENTO_AUP_COMMENT_LIKED', 'Comment liked at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2731, 'COM_KOMENTO_AUP_COMMENT_UNLIKED', 'Comment unliked at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2732, 'COM_KOMENTO_AUP_COMMENT_REMOVED', 'Comment removed at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2733, 'COM_KOMENTO_AUP_COMMENT_REPORTED', 'Comment reported at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2734, 'COM_KOMENTO_AUP_COMMENT_UNREPORTED', 'Comment unreported at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2735, 'COM_KOMENTO_AUP_COMMENT_STICKED', 'Comment sticked at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2736, 'COM_KOMENTO_AUP_COMMENT_UNSTICKED', 'Comment unsticked at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2737, 'COM_KOMENTO_AUP_ADD_COMMENT_AUTHOR', 'New comment posted on user\'s article at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2738, 'COM_KOMENTO_AUP_REMOVED_COMMENT_AUTHOR', 'Comment removed from user\'s article at <a href=\"%1s\">%2s</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2739, 'COM_KOMENTO_DISCUSS_HISTORY_ADD_COMMENT', 'New comment posted at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2740, 'COM_KOMENTO_DISCUSS_HISTORY_REPLY_COMMENT', 'New reply posted at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2741, 'COM_KOMENTO_DISCUSS_HISTORY_LIKE_COMMENT', 'Liked a comment at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2742, 'COM_KOMENTO_DISCUSS_HISTORY_UNLIKE_COMMENT', 'Unliked a comment at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2743, 'COM_KOMENTO_DISCUSS_HISTORY_REPORT_COMMENT', 'Reported a comment at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2744, 'COM_KOMENTO_DISCUSS_HISTORY_UNREPORT_COMMENT', 'Unreported a comment at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2745, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_LIKED', 'Comment liked at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2746, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_UNLIKED', 'Comment unliked at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2747, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_REMOVED', 'Comment removed at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2748, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_REPORTED', 'Comment reported at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2749, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_UNREPORTED', 'Comment unreported at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2750, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_STICKED', 'Comment sticked at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2751, 'COM_KOMENTO_DISCUSS_HISTORY_COMMENT_UNSTICKED', 'Comment unsticked at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2752, 'COM_KOMENTO_DISCUSS_HISTORY_ADD_COMMENT_ARTICLE_AUTHOR', 'New comment posted on user\'s article at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2753, 'COM_KOMENTO_DISCUSS_HISTORY_REMOVE_COMMENT_ARTICLE_AUTHOR', 'Comment removed from user\'s article at %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2754, 'COM_KOMENTO_POWERED_BY_KOMENTO', 'Powered by Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2755, 'COM_KOMENTO_FORM_EXTENSION_RESTRICTION', 'Extension Restriction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2756, 'COM_KOMENTO_FORM_EXTENSION_ALLOWED_LIST', 'Allowed file extensions: %1s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2757, 'COM_KOMENTO_EMAIL_BATCH_PROCESS_FINISHED', 'Email batch process finished.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2758, 'COM_KOMENTO_CLEAR_CAPTCHA_PROCESS_FINISHED', 'Clear captcha process finished.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2759, 'COM_KOMENTO_INVALID_COMPONENT', 'Invalid component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2760, 'COM_KOMENTO_LOGIN_TO_COMMENT', 'Login to post a comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2761, 'COM_KOMENTO_LOGIN_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2762, 'COM_KOMENTO_LOGIN_REGISTER', 'Register', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2763, 'COM_KOMENTO_LOGIN_PASSWORD', 'Password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2764, 'COM_KOMENTO_LOGIN_FORGOT_PASSWORD', 'Forgot password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2765, 'COM_KOMENTO_LOGIN_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2766, 'COM_KOMENTO_LOGIN_BUTTON', 'Login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2767, 'COM_KOMENTO_PREVIEW_POPULAR_COMMENTS_TITLE', 'Popular comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2768, 'COM_KOMENTO_PREVIEW_RECENT_COMMENTS_TITLE', 'Recent comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2769, 'COM_KOMENTO_PREVIEW_COMMENTS_VIEW_OTHER_COMMENTS', 'View other comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2770, 'COM_KOMENTO_COMMENTS_ADD_YOURS', 'Add yours', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2771, 'COM_KOMENTO_APPROVE_COMMENT_INVALID_COMMENT_ID', 'Invalid comment id.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(2772, 'COM_KOMENTO_APPROVE_COMMENT_ADMIN_REMOVED_COMMENT', 'This comment has been removed by admin.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2773, 'COM_KOMENTO_PROFILE_NOTIFICATION_TITLE_KOMENTO', 'Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2774, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_COMMENT', 'New comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2775, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_COMMENT_DESC', 'Determines if the system should notify you if there is a new comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2776, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_REPLY', 'New reply', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2777, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_REPLY_DESC', 'Determines if the system should notify you if there is a new reply.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2778, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_LIKE', 'New comment like', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2779, 'COM_KOMENTO_PROFILE_NOTIFICATION_SETTINGS_KOMENTO_LIKE_DESC', 'Determines if the system should notify you if someone likes your comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2780, 'COM_KOMENTO_POINTS_EXTENSION_COM_KOMENTO', 'Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2781, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_ADDED_AUTHOR', 'Komento - comment added author\'s article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2782, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_ADDED_AUTHOR_DESC', 'Add points for article author when a user posts a new comment on that article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2783, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_ADDED', 'Komento - comment added to article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2784, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_ADDED_DESC', 'Add points to user when a user post a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2785, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_LIKED', 'Komento - comment liked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2786, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_LIKED_DESC', 'Add points to comment author when a user likes the comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2787, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_REMOVED', 'Komento - comment removed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2788, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_REMOVED_DESC', 'Deduct points to comment author when a comment is removed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2789, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_REPORTED', 'Komento - comment reported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2790, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_REPORTED_DESC', 'Deduct points to comment author when a comment is reported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2791, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_STICKED', 'Komento - comment sticked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2792, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_STICKED_DESC', 'Add points to comment author when a comment is sticked.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2793, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNLIKED', 'Komento - comment unliked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2794, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNLIKED_DESC', 'Deduct points to comment author when a user unlike the comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2795, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNREPORTED', 'Komento - comment unreported', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2796, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNREPORTED_DESC', 'Add points to comment author when a comment is unreported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2797, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNSTICKED', 'Komento - comment unsticked', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2798, 'COM_KOMENTO_EASYSOCIAL_POINTS_COMMENT_UNSTICKED_DESC', 'Deduct points to comment author when a comment is unsticked.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2799, 'COM_KOMENTO_EASYSOCIAL_POINTS_LIKE_COMMENT', 'Komento - like a comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2800, 'COM_KOMENTO_EASYSOCIAL_POINTS_LIKE_COMMENT_DESC', 'Add points to user when a user likes a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2801, 'COM_KOMENTO_EASYSOCIAL_POINTS_REMOVE_COMMENT_AUTHOR', 'Komento - comment removed from article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2802, 'COM_KOMENTO_EASYSOCIAL_POINTS_REMOVE_COMMENT_AUTHOR_DESC', 'Deduct points for article author when a comment is removed from that article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2803, 'COM_KOMENTO_EASYSOCIAL_POINTS_REPLY_COMMENT', 'Komento - reply comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2804, 'COM_KOMENTO_EASYSOCIAL_POINTS_REPLY_COMMENT_DESC', 'Add points to user when a user reply to a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2805, 'COM_KOMENTO_EASYSOCIAL_POINTS_REPORT_COMMENT', 'Komento - report comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2806, 'COM_KOMENTO_EASYSOCIAL_POINTS_REPORT_COMMENT_DESC', 'Add points to user when a user reports a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2807, 'COM_KOMENTO_EASYSOCIAL_POINTS_UNLIKE_COMMENT', 'Komento - unlike a comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2808, 'COM_KOMENTO_EASYSOCIAL_POINTS_UNLIKE_COMMENT_DESC', 'Deduct points to user when a user unlike a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2809, 'COM_KOMENTO_EASYSOCIAL_POINTS_UNREPORT_COMMENT', 'Komento - unreport a comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2810, 'COM_KOMENTO_EASYSOCIAL_POINTS_UNREPORT_COMMENT_DESC', 'Deduct points to user when a user unreports a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2811, 'COM_KOMENTO_EASYSOCIAL_POINTS_UPLOAD_ATTACHMENT', 'Komento - upload an attachment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2812, 'COM_KOMENTO_EASYSOCIAL_POINTS_UPLOAD_ATTACHMENT_DESC', 'Add points to user when a user upload an attachment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2813, 'COM_KOMENTO_BADGES_EXTENSION_COM_KOMENTO', 'Komento', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2814, 'COM_KOMENTO_EASYSOCIAL_BADGES_ADD_COMMENTS_TITLE', 'Attention Grabber', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2815, 'COM_KOMENTO_EASYSOCIAL_BADGES_ADD_COMMENTS_DESC', 'Add comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2816, 'COM_KOMENTO_EASYSOCIAL_BADGES_ADD_COMMENTS_HOWTO', 'To unlock this badge, you need to add comments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2817, 'COM_KOMENTO_EASYSOCIAL_BADGES_ADD_COMMENTS_MESSAGE', 'Adds a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2818, 'COM_KOMENTO_EASYSOCIAL_BADGES_LIKE_COMMENTS_TITLE', 'Lovey-dovey', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2819, 'COM_KOMENTO_EASYSOCIAL_BADGES_LIKE_COMMENTS_DESC', 'Like comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2820, 'COM_KOMENTO_EASYSOCIAL_BADGES_LIKE_COMMENTS_HOWTO', 'To unlock this badge, you need to like comments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2821, 'COM_KOMENTO_EASYSOCIAL_BADGES_LIKE_COMMENTS_MESSAGE', 'Likes a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2822, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPORT_COMMENTS_TITLE', 'Police', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2823, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPORT_COMMENTS_DESC', 'Report comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2824, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPORT_COMMENTS_HOWTO', 'To unlock this badge, you need to report comments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2825, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPORT_COMMENTS_MESSAGE', 'Reports a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2826, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPLY_COMMENTS_TITLE', 'Discussion Booster', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2827, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPLY_COMMENTS_DESC', 'Reply comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2828, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPLY_COMMENTS_HOWTO', 'To unlock this badge, you need to reply comments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2829, 'COM_KOMENTO_EASYSOCIAL_BADGES_REPLY_COMMENTS_MESSAGE', 'Replies to a comment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2830, 'COM_KOMENTO_EASYSOCIAL_BADGES_UPLOAD_ATTACHMENTS_TITLE', 'Distributor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2831, 'COM_KOMENTO_EASYSOCIAL_BADGES_UPLOAD_ATTACHMENTS_DESC', 'Upload attachments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2832, 'COM_KOMENTO_EASYSOCIAL_BADGES_UPLOAD_ATTACHMENTS_HOWTO', 'To unlock this badge, you need to upload attachments.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2833, 'COM_KOMENTO_EASYSOCIAL_BADGES_UPLOAD_ATTACHMENTS_MESSAGE', 'Uploads an attachment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2834, 'COM_KOMENTO_OVERALL_RATING', 'Overall Rating (%1$s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2835, 'COM_KOMENTO_RATING_TOTAL', '%1$s out of 5 stars', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2836, 'COM_KOMENTO_RATING_RATED_TOTAL', 'Rated %1$s out of 5 stars', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2837, 'COM_KOMENTO_RATING_THIS_ITEM', 'Rate this article :', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_komento.ini'),
(2838, 'COM_MAILTO', 'Mailto', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2839, 'COM_MAILTO_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2840, 'COM_MAILTO_CLOSE_WINDOW', 'Close Window', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2841, 'COM_MAILTO_EMAIL_ERR_NOINFO', 'Please provide a valid email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2842, 'COM_MAILTO_EMAIL_INVALID', 'The address \'%s\' does not appear to be a valid email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2843, 'COM_MAILTO_EMAIL_MSG', 'This is an email from (%s) sent by %s (%s). You may also find the following link interesting: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2844, 'COM_MAILTO_EMAIL_NOT_SENT', 'Email could not be sent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2845, 'COM_MAILTO_EMAIL_SENT', 'Email was sent successfully.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2846, 'COM_MAILTO_EMAIL_TO', 'Email to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2847, 'COM_MAILTO_EMAIL_TO_A_FRIEND', 'Email this link to a friend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2848, 'COM_MAILTO_LINK_IS_MISSING', 'Link is missing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2849, 'COM_MAILTO_SEND', 'Send', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2850, 'COM_MAILTO_SENDER', 'Sender', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2851, 'COM_MAILTO_SENT_BY', 'Item sent by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2852, 'COM_MAILTO_SUBJECT', 'Subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2853, 'COM_MAILTO_YOUR_EMAIL', 'Your Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_mailto.ini'),
(2854, 'COM_MEDIA_ALIGN', 'Image Float', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2855, 'COM_MEDIA_ALIGN_DESC', 'This will apply the classes \'pull-left\', \'pull-center\' or \'pull-right\' to the \'<figure>\' or \'<img>\' element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2856, 'COM_MEDIA_BROWSE_FILES', 'Browse Files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2857, 'COM_MEDIA_CAPTION', 'Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2858, 'COM_MEDIA_CAPTION_CLASS_LABEL', 'Caption Class', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2859, 'COM_MEDIA_CAPTION_CLASS_DESC', 'This will apply the entered class to the \'<figcaption>\' element. For example: \'text-left\', \'text-right\', \'text-center\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2860, 'COM_MEDIA_CLEAR_LIST', 'Clear List', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2861, 'COM_MEDIA_CONFIGURATION', 'Media Manager Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2862, 'COM_MEDIA_CREATE_FOLDER', 'Create Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2863, 'COM_MEDIA_CURRENT_PROGRESS', 'Current progress', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2864, 'COM_MEDIA_DESCFTP', 'To upload, change and delete media files, Joomla! will most likely need your FTP account details. Please enter them in the form fields below.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2865, 'COM_MEDIA_DESCFTPTITLE', 'FTP Login Details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2866, 'COM_MEDIA_DETAIL_VIEW', 'Detail View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2867, 'COM_MEDIA_DIRECTORY', 'Directory', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2868, 'COM_MEDIA_DIRECTORY_UP', 'Directory Up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2869, 'COM_MEDIA_ERROR_BAD_REQUEST', 'Bad Request', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2870, 'COM_MEDIA_ERROR_FILE_EXISTS', 'File already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2871, 'COM_MEDIA_ERROR_UNABLE_TO_CREATE_FOLDER_WARNDIRNAME', 'Unable to create directory. Directory name must only contain alphanumeric characters and no spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2872, 'COM_MEDIA_ERROR_UNABLE_TO_BROWSE_FOLDER_WARNDIRNAME', 'Unable to browse:&#160;%s. Directory name must only contain alphanumeric characters and no spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2873, 'COM_MEDIA_ERROR_UNABLE_TO_DELETE', ' Unable to delete:&#160;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2874, 'COM_MEDIA_ERROR_UNABLE_TO_DELETE_FILE_WARNFILENAME', 'Unable to delete:&#160;%s. File name must only contain alphanumeric characters and no spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2875, 'COM_MEDIA_ERROR_UNABLE_TO_DELETE_FOLDER_NOT_EMPTY', 'Unable to delete:&#160;%s. Folder is not empty!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2876, 'COM_MEDIA_ERROR_UNABLE_TO_DELETE_FOLDER_WARNDIRNAME', 'Unable to delete:&#160;%s. Directory name must only contain alphanumeric characters and no spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2877, 'COM_MEDIA_ERROR_UNABLE_TO_UPLOAD_FILE', 'Unable to upload file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2878, 'COM_MEDIA_ERROR_WARNFILETOOLARGE', 'This file is too large to upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2879, 'COM_MEDIA_ERROR_WARNUPLOADTOOLARGE', 'Total size of upload exceeds the limit.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2880, 'COM_MEDIA_FIELD_CHECK_MIME_DESC', 'Use MIME Magic or Fileinfo to attempt to verify files. Try disabling this if you get invalid mime type errors.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2881, 'COM_MEDIA_FIELD_CHECK_MIME_LABEL', 'Check MIME Types', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2882, 'COM_MEDIA_FIELD_IGNORED_EXTENSIONS_DESC', 'Ignored file extensions for MIME type checking and restricted uploads.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2883, 'COM_MEDIA_FIELD_IGNORED_EXTENSIONS_LABEL', 'Ignored Extensions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2884, 'COM_MEDIA_FIELD_ILLEGAL_MIME_TYPES_DESC', 'A comma separated list of illegal MIME types for upload (blacklist).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2885, 'COM_MEDIA_FIELD_ILLEGAL_MIME_TYPES_LABEL', 'Illegal MIME Types', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2886, 'COM_MEDIA_FIELD_LEGAL_EXTENSIONS_DESC', ' Extensions (file types) you are allowed to upload (comma separated).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2887, 'COM_MEDIA_FIELD_LEGAL_EXTENSIONS_LABEL', 'Legal Extensions (File Types)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2888, 'COM_MEDIA_FIELD_LEGAL_IMAGE_EXTENSIONS_DESC', ' Image extensions (file types) you are allowed to upload (comma separated). These are used to check for valid image headers.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2889, 'COM_MEDIA_FIELD_LEGAL_IMAGE_EXTENSIONS_LABEL', 'Legal Image Extensions (File Types)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2890, 'COM_MEDIA_FIELD_LEGAL_MIME_TYPES_DESC', 'A comma separated list of legal MIME types for upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2891, 'COM_MEDIA_FIELD_LEGAL_MIME_TYPES_LABEL', 'Legal MIME Types', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2892, 'COM_MEDIA_FIELD_MAXIMUM_SIZE_DESC', 'The maximum size for an upload (in bytes). Use zero for no limit. Note: your server has a maximum limit.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2893, 'COM_MEDIA_FIELD_MAXIMUM_SIZE_LABEL', 'Maximum Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2894, 'COM_MEDIA_FIELD_PATH_FILE_FOLDER_DESC', 'Enter the path to the file folder relative to root.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2895, 'COM_MEDIA_FIELD_PATH_FILE_FOLDER_LABEL', 'Path to File Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2896, 'COM_MEDIA_FIELD_PATH_IAMGE_FOLDER_DESC', 'Enter the path to the image folder relative to root.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2897, 'COM_MEDIA_FIELD_PATH_IMAGE_FOLDER_LABEL', 'Path to Image Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2898, 'COM_MEDIA_FIELD_RESTRICT_UPLOADS_DESC', 'Restrict uploads for lower than manager users to just images if Fileinfo or MIME Magic isn\'t installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2899, 'COM_MEDIA_FIELD_RESTRICT_UPLOADS_LABEL', 'Restrict Uploads', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2900, 'COM_MEDIA_FILES', 'Files', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2901, 'COM_MEDIA_FILESIZE', 'File size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2902, 'COM_MEDIA_FOLDER', 'Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2903, 'COM_MEDIA_FOLDERS', 'Folders', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2904, 'COM_MEDIA_IMAGE_DESCRIPTION', 'Image Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2905, 'COM_MEDIA_IMAGE_URL', 'Image URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2906, 'COM_MEDIA_INSERT', 'Insert', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2907, 'COM_MEDIA_INSERT_IMAGE', 'Insert Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2908, 'COM_MEDIA_MAXIMUM_SIZE', 'Maximum Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2909, 'COM_MEDIA_MEDIA', 'Media', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2910, 'COM_MEDIA_NAME', 'Image Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2911, 'COM_MEDIA_NO_IMAGES_FOUND', 'No Images Found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2912, 'COM_MEDIA_NOT_SET', 'Not Set', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2913, 'COM_MEDIA_OVERALL_PROGRESS', 'Overall Progress', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2914, 'COM_MEDIA_PIXEL_DIMENSIONS', 'Pixel Dimensions (w x h)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2915, 'COM_MEDIA_START_UPLOAD', 'Start Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2916, 'COM_MEDIA_THUMBNAIL_VIEW', 'Thumbnail View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2917, 'COM_MEDIA_TITLE', 'Image Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2918, 'COM_MEDIA_UP', 'Up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2919, 'COM_MEDIA_UPLOAD', 'Upload', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2920, 'COM_MEDIA_UPLOAD_COMPLETE', 'Upload Complete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2921, 'COM_MEDIA_UPLOAD_FILE', 'Upload file', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2922, 'COM_MEDIA_UPLOAD_FILES', 'Upload files (Maximum Size: %s MB)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2923, 'COM_MEDIA_UPLOAD_FILES_NOLIMIT', 'Upload files (No maximum size)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2924, 'COM_MEDIA_UPLOAD_SUCCESSFUL', 'Upload Successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_media.ini'),
(2925, 'COM_MESSAGES_ERR_SEND_FAILED', 'The user has locked their mailbox. Message failed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_messages.ini'),
(2926, 'COM_MESSAGES_NEW_MESSAGE_ARRIVED', 'A new private message has arrived from %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_messages.ini'),
(2927, 'COM_MESSAGES_PLEASE_LOGIN', 'Please log in to %s to read your message.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_messages.ini'),
(2928, 'COM_NEWSFEEDS_CACHE_DIRECTORY_UNWRITABLE', 'The cache directory is unwritable. The news feed can\'t be displayed. Please contact a site administrator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2929, 'COM_NEWSFEEDS_CAT_NUM', '# of News feeds :', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2930, 'COM_NEWSFEEDS_CONTENT_TYPE_NEWSFEED', 'News Feed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2931, 'COM_NEWSFEEDS_CONTENT_TYPE_CATEGORY', 'News Feed Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2932, 'COM_NEWSFEEDS_DEFAULT_PAGE_TITLE', 'News Feeds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2933, 'COM_NEWSFEEDS_ERROR_FEED_NOT_FOUND', 'Error. Feed not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2934, 'COM_NEWSFEEDS_ERRORS_FEED_NOT_RETRIEVED', 'Error. Feed could not be retrieved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2935, 'COM_NEWSFEEDS_FEED_LINK', 'Feed Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2936, 'COM_NEWSFEEDS_FEED_NAME', 'Feed Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2937, 'COM_NEWSFEEDS_FILTER_LABEL', 'Filter Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2938, 'COM_NEWSFEEDS_FILTER_SEARCH_DESC', 'News Feed Filter Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2939, 'COM_NEWSFEEDS_NO_ARTICLES', 'No Articles for this News Feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2940, 'COM_NEWSFEEDS_NUM_ARTICLES', '# Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2941, 'COM_NEWSFEEDS_NUM_ARTICLES_COUNT', '# Articles: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2942, 'COM_NEWSFEEDS_NUM_ITEMS', '# News feeds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_newsfeeds.ini'),
(2943, 'COM_SEARCH_ALL_WORDS', 'All words', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2944, 'COM_SEARCH_ALPHABETICAL', 'Alphabetical', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2945, 'COM_SEARCH_ANY_WORDS', 'Any words', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2946, 'COM_SEARCH_ERROR_ENTERKEYWORD', 'Enter a search keyword', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2947, 'COM_SEARCH_ERROR_IGNOREKEYWORD', 'One or more common words were ignored in the search.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2948, 'COM_SEARCH_ERROR_SEARCH_MESSAGE', 'Search term must be a minimum of %1$s characters and a maximum of %2$s characters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2949, 'COM_SEARCH_EXACT_PHRASE', 'Exact Phrase', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2950, 'COM_SEARCH_FIELD_SEARCH_AREAS_DESC', 'Show the search areas checkboxes.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2951, 'COM_SEARCH_FIELD_SEARCH_AREAS_LABEL', 'Use Search Areas', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2952, 'COM_SEARCH_FOR', 'Search for:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2953, 'COM_SEARCH_MOST_POPULAR', 'Most Popular', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2954, 'COM_SEARCH_NEWEST_FIRST', 'Newest First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2955, 'COM_SEARCH_OLDEST_FIRST', 'Oldest First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2956, 'COM_SEARCH_ORDERING', 'Ordering:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2957, 'COM_SEARCH_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2958, 'COM_SEARCH_SEARCH_AGAIN', 'Search Again', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2959, 'COM_SEARCH_SEARCH_KEYWORD', 'Search Keyword:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2960, 'COM_SEARCH_SEARCH_KEYWORD_N_RESULTS_1', '<strong>Total: One result found.</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2961, 'COM_SEARCH_SEARCH_KEYWORD_N_RESULTS', '<strong>Total: %s results found.</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2962, 'COM_SEARCH_SEARCH_ONLY', 'Search Only:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2963, 'COM_SEARCH_SEARCH_RESULT', 'Search Result', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_search.ini'),
(2964, 'COM_SOCIALLOGIN_INSTALLATION_STATUS', 'Social Login And Social Share Installation completed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2965, 'COM_SOCIALLOGIN_INSTALLATION_THANK', 'Thank you very much for installing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2966, 'COM_SOCIALLOGIN_INSTALLATION_CONFIG', 'Please configure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2967, 'COM_SOCIALLOGIN_INSTALLATION_COM', 'component first.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2968, 'COM_SOCIALLOGIN_INSTALLATION_FREE', 'Feel free to', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2969, 'COM_SOCIALLOGIN_INSTALLATION_CONTACT', 'contact us', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2970, 'COM_SOCIALLOGIN_INSTALLATION_ASSIST', 'if you need any assistance.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2971, 'COM_SOCIALLOGIN_INSTALLATION_THANKYOU', 'Thank you!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2972, 'COM_SOCIALLOGIN_INSTALLATION_MODULE_ERROR', 'Another module is installed with the same name Please uninstalled it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2973, 'COM_SOCIALLOGIN_INSTALLATION_MODULE_DIR_ERROR', 'Installation process Failed to create module directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2974, 'COM_SOCIALLOGIN_INSTALLATION_MODULE_PLG_ERROR', 'Installation process failed to create plugin directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2975, 'COM_SOCIALLOGIN_JOMFISH_ERROR', 'Social Login component for jomfish were not installed beacuse jomfish not installed on your system.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2976, 'COM_SOCIALLOGIN_LINK_ACCOUNT_HEAD', 'Link your account with another social account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2977, 'COM_SOCIALLOGIN_LINK_ACCOUNT_TEXT', 'Link Your account with:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2978, 'COM_SOCIALLOGIN_LINK_ACCOUNT_DESC', 'By adding another account, you can log in with the new account as well!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2979, 'COM_SOCIALLOGIN_LINK_ACCOUNT_MSG', 'You can also use', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2980, 'COM_SOCIALLOGIN_LINK_ACCOUNT_MSGONE', 'Currently connected with', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2981, 'COM_SOCIALLOGIN_LINK_ACCOUNT_REMOVE', 'Remove', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2982, 'COM_SOCIALLOGIN_LINK_ACCOUNT_DELETE', 'Mapped Account identity successfully deleted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_socialloginandsocialshare.ini'),
(2983, 'COM_TAGS_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2984, 'COM_TAGS_FILTER_SEARCH_DESC', 'Enter all or part of the title to search for.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2985, 'COM_TAGS_MODIFIED_DATE', 'Modified Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2986, 'COM_TAGS_NO_ITEMS', 'No matching items were found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2987, 'COM_TAGS_NO_TAGS', 'There are no tags.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2988, 'COM_TAGS_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2989, 'COM_TAGS_TITLE_FILTER_LABEL', 'Enter Part of Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_tags.ini'),
(2990, 'COM_USERS_ACTIVATION_TOKEN_NOT_FOUND', 'Verification code not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2991, 'COM_USERS_CAPTCHA_LABEL', 'Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2992, 'COM_USERS_CAPTCHA_DESC', 'Type in the textbox what you see in the image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2993, 'COM_USERS_DATABASE_ERROR', 'Error getting the user from the database: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2994, 'COM_USERS_DESIRED_PASSWORD', 'Enter your desired password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2995, 'COM_USERS_DESIRED_USERNAME', 'Enter your desired username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2996, 'COM_USERS_EDIT_PROFILE', 'Edit Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2997, 'COM_USERS_EMAIL_ACCOUNT_DETAILS', 'Account Details for %s at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2998, 'COM_USERS_EMAIL_ACTIVATE_WITH_ADMIN_ACTIVATION_BODY', 'Hello administrator,\\n\\nA new user has registered at %s.\\nThe user has verified his email address and requests that you approve his account.\\nThis email contains their details:\\n\\n  Name :  %s \\n  email:  %s \\n Username:  %s \\n\\nYou can activate the user by clicking on the link below:\\n %s \\n', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(2999, 'COM_USERS_EMAIL_ACTIVATE_WITH_ADMIN_ACTIVATION_SUBJECT', 'Registration approval required for account of %s at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3000, 'COM_USERS_EMAIL_ACTIVATED_BY_ADMIN_ACTIVATION_BODY', 'Hello %s,\\n\\nYour account has been activated by an administrator. You can now login at %s using the username %s and the password you chose while registering.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3001, 'COM_USERS_EMAIL_ACTIVATED_BY_ADMIN_ACTIVATION_SUBJECT', 'Account activated for %s at %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3002, 'COM_USERS_EMAIL_PASSWORD_RESET_BODY', 'Hello,\\n\\nA request has been made to reset your %s account password. To reset your password, you will need to submit this verification code in order to verify that the request was legitimate.\\n\\nThe verification code is %s\\n\\nClick on the URL below and proceed with resetting your password.\\n\\n %s \\n\\nThank you.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3003, 'COM_USERS_EMAIL_PASSWORD_RESET_SUBJECT', 'Your %s password reset request', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3004, 'COM_USERS_EMAIL_REGISTERED_BODY', 'Hello %s,\\n\\nThank you for registering at %s.\\n\\nYou may now log in to %s using the following username and password:\\n\\nUsername: %s\\nPassword: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3005, 'COM_USERS_EMAIL_REGISTERED_BODY_NOPW', 'Hello %s,\\n\\nThank you for registering at %s.\\n\\nYou may now log in to %s using the username and password you registered with.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3006, 'COM_USERS_EMAIL_REGISTERED_NOTIFICATION_TO_ADMIN_BODY', 'Hello administrator, \\n\\nA new user \'%s\', username \'%s\', has registered at %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3007, 'COM_USERS_EMAIL_REGISTERED_WITH_ACTIVATION_BODY', 'Hello %s,\\n\\nThank you for registering at %s. Your account is created and must be activated before you can use it.\\nTo activate the account click on the following link or copy-paste it in your browser:\\n%s \\n\\nAfter activation you may login to %s using the following username and password:\\n\\nUsername: %s\\nPassword: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3008, 'COM_USERS_EMAIL_REGISTERED_WITH_ACTIVATION_BODY_NOPW', 'Hello %s,\\n\\nThank you for registering at %s. Your account is created and must be activated before you can use it.\\nTo activate the account click on the following link or copy-paste it in your browser:\\n%s \\n\\nAfter activation you may login to %s using the following username and the password you entered during registration:\\n\\nUsername: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3009, 'COM_USERS_EMAIL_REGISTERED_WITH_ADMIN_ACTIVATION_BODY', 'Hello %s,\\n\\nThank you for registering at %s. Your account is created and must be verified before you can use it.\\nTo verify the account click on the following link or copy-paste it in your browser:\\n %s \\n\\nAfter verification an administrator will be notified to activate your account. You\'ll receive a confirmation when it\'s done.\\nOnce that account has been activated you may login to %s using the following username and password:\\n\\nUsername: %s\\nPassword: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3010, 'COM_USERS_EMAIL_REGISTERED_WITH_ADMIN_ACTIVATION_BODY_NOPW', 'Hello %s,\\n\\nThank you for registering at %s. Your account is created and must be verified before you can use it.\\nTo verify the account click on the following link or copy-paste it in your browser:\\n %s \\n\\nAfter verification an administrator will be notified to activate your account. You\'ll receive a confirmation when it\'s done.\\nOnce that account has been activated you may login to %s using the following username and the password you entered during registration:\\n\\nUsername: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3011, 'COM_USERS_EMAIL_USERNAME_REMINDER_BODY', 'Hello,\\n\\nA username reminder has been requested for your %s account.\\n\\nYour username is %s.\\n\\nTo login to your account, click on the link below.\\n\\n%s \\n\\nThank you.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3012, 'COM_USERS_EMAIL_USERNAME_REMINDER_SUBJECT', 'Your %s username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3013, 'COM_USERS_ERROR_SECRET_CODE_WITHOUT_TFA', 'You have entered a Secret Code but two factor authentication is not enabled in your user account. If you want to use a secret code to secure your login please edit your user profile and enable two factor authentication.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3014, 'COM_USERS_FIELD_PASSWORD_RESET_DESC', 'Please enter the email address associated with your User account.<br />A verification code will be sent to you. Once you have received the verification code, you will be able to choose a new password for your account.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3015, 'COM_USERS_FIELD_PASSWORD_RESET_LABEL', 'Email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3016, 'COM_USERS_FIELD_REMIND_EMAIL_DESC', 'Please enter the email address associated with your User account.<br />Your username will be emailed to the email address on file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3017, 'COM_USERS_FIELD_REMIND_EMAIL_LABEL', 'Email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3018, 'COM_USERS_FIELD_RESET_CONFIRM_TOKEN_DESC', 'Enter the password reset verification code you received by email.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3019, 'COM_USERS_FIELD_RESET_CONFIRM_TOKEN_LABEL', 'Verification Code:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3020, 'COM_USERS_FIELD_RESET_CONFIRM_USERNAME_DESC', 'Enter your username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3021, 'COM_USERS_FIELD_RESET_CONFIRM_USERNAME_LABEL', 'Username:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3022, 'COM_USERS_FIELD_RESET_PASSWORD1_DESC', 'Enter your new password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3023, 'COM_USERS_FIELD_RESET_PASSWORD1_LABEL', 'Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3024, 'COM_USERS_FIELD_RESET_PASSWORD1_MESSAGE', 'The passwords you entered do not match. Please enter your desired password in the password field and confirm your entry by entering it in the confirm password field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3025, 'COM_USERS_FIELD_RESET_PASSWORD2_DESC', 'Confirm your new password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3026, 'COM_USERS_FIELD_RESET_PASSWORD2_LABEL', 'Confirm Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3027, 'COM_USERS_INVALID_EMAIL', 'Invalid email address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3028, 'COM_USERS_LOGIN_IMAGE_ALT', 'Login image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3029, 'COM_USERS_LOGIN_REGISTER', 'Don\'t have an account?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3030, 'COM_USERS_LOGIN_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3031, 'COM_USERS_LOGIN_REMIND', 'Forgot your username?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3032, 'COM_USERS_LOGIN_RESET', 'Forgot your password?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3033, 'COM_USERS_LOGIN_USERNAME_LABEL', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3034, 'COM_USERS_MAIL_FAILED', 'Failed sending email.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3035, 'COM_USERS_MAIL_SEND_FAILURE_BODY', 'An error was encountered when sending the user registration email. The error is: %s The user who attempted to register is: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3036, 'COM_USERS_MAIL_SEND_FAILURE_SUBJECT', 'Error sending email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3037, 'COM_USERS_MSG_NOT_ENOUGH_INTEGERS_N', 'Password does not contain enough digits. At least %s digits are required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3038, 'COM_USERS_MSG_NOT_ENOUGH_INTEGERS_N_1', 'Password does not contain enough digits. At least 1 digit is required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3039, 'COM_USERS_MSG_NOT_ENOUGH_SYMBOLS_N', 'Password does not contain enough symbols. At least %s symbols are required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3040, 'COM_USERS_MSG_NOT_ENOUGH_SYMBOLS_N_1', 'Password does not contain enough symbols. At least 1 symbol is required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3041, 'COM_USERS_MSG_NOT_ENOUGH_UPPERCASE_LETTERS_N', 'Password does not contain enough uppercase characters. At least %s upper case characters are required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3042, 'COM_USERS_MSG_NOT_ENOUGH_UPPERCASE_LETTERS_N_1', 'Password does not contain enough uppercase characters. At least 1 upper case character is required.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3043, 'COM_USERS_MSG_PASSWORD_TOO_LONG', 'Password is too long. Passwords must be less than 100 characters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3044, 'COM_USERS_MSG_PASSWORD_TOO_SHORT_N', 'Password is too short. Passwords must have at least %s characters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3045, 'COM_USERS_MSG_SPACES_IN_PASSWORD', 'Password must not contain spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3046, 'COM_USERS_OPTIONAL', '(optional)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3047, 'COM_USERS_OR', 'or', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3048, 'COM_USERS_PROFILE', 'User Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3049, 'COM_USERS_PROFILE_BIND_FAILED', 'Could not bind profile data: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3050, 'COM_USERS_PROFILE_CORE_LEGEND', 'Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3051, 'COM_USERS_PROFILE_CUSTOM_LEGEND', 'Custom Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3052, 'COM_USERS_PROFILE_DEFAULT_LABEL', 'Edit Your Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3053, 'COM_USERS_PROFILE_EMAIL1_DESC', 'Enter your email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3054, 'COM_USERS_PROFILE_EMAIL1_LABEL', 'Email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3055, 'COM_USERS_PROFILE_EMAIL1_MESSAGE', 'The email address you entered is already in use or invalid. Please enter another email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3056, 'COM_USERS_PROFILE_EMAIL2_DESC', 'Confirm your email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3057, 'COM_USERS_PROFILE_EMAIL2_LABEL', 'Confirm email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3058, 'COM_USERS_PROFILE_EMAIL2_MESSAGE', 'The email addresses you entered do not match. Please enter your email address in the email address field and confirm your entry by entering it in the confirm email address field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3059, 'COM_USERS_PROFILE_LAST_VISITED_DATE_LABEL', 'Last Visited Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3060, 'COM_USERS_PROFILE_MY_PROFILE', 'My Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3061, 'COM_USERS_PROFILE_NAME_DESC', 'Enter your full name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3062, 'COM_USERS_PROFILE_NAME_LABEL', 'Name:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3063, 'COM_USERS_PROFILE_NEVER_VISITED', 'This is the first time you visit this site', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3064, 'COM_USERS_PROFILE_NOCHANGE_USERNAME_DESC', 'If you want to change your username, please contact a site administrator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3065, 'COM_USERS_PROFILE_OTEPS', 'One time emergency passwords', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3066, 'COM_USERS_PROFILE_OTEPS_DESC', 'If you do not have access to your two factor authentication device you can use any of the following passwords instead of a regular security code. Each one of these emergency passwords is immediately destroyed upon use. We recommend printing these passwords out and keeping the printout in a safe and accessible location, eg your wallet or a safety deposit box.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3067, 'COM_USERS_PROFILE_OTEPS_WAIT_DESC', 'There are currently no emergency one time passwords generated in your account. The passwords will be generated automatically and displayed here as soon as you activate two factor authentication.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3068, 'COM_USERS_PROFILE_PASSWORD1_LABEL', 'Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3069, 'COM_USERS_PROFILE_PASSWORD1_MESSAGE', 'The passwords you entered do not match. Please enter your desired password in the password field and confirm your entry by entering it in the confirm password field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3070, 'COM_USERS_PROFILE_PASSWORD2_DESC', 'Confirm your password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3071, 'COM_USERS_PROFILE_PASSWORD2_LABEL', 'Confirm Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3072, 'COM_USERS_PROFILE_REGISTERED_DATE_LABEL', 'Registered Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3073, 'COM_USERS_PROFILE_SAVE_FAILED', 'Profile could not be saved: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3074, 'COM_USERS_PROFILE_SAVE_SUCCESS', 'Profile successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3075, 'COM_USERS_PROFILE_TWO_FACTOR_AUTH', 'Two Factor Authentication', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3076, 'COM_USERS_PROFILE_TWOFACTOR_LABEL', 'Authentication Method', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3077, 'COM_USERS_PROFILE_TWOFACTOR_DESC', 'Which two factor authentication method you want to activate on the user account.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3078, 'COM_USERS_PROFILE_USERNAME_DESC', 'Enter your desired username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3079, 'COM_USERS_PROFILE_USERNAME_LABEL', 'Username:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3080, 'COM_USERS_PROFILE_USERNAME_MESSAGE', 'The username you entered is not available. Please pick another username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3081, 'COM_USERS_PROFILE_VALUE_NOT_FOUND', 'No Information Entered', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3082, 'COM_USERS_PROFILE_WELCOME', 'Welcome, %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3083, 'COM_USERS_REGISTER_DEFAULT_LABEL', 'Create An Account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(3084, 'COM_USERS_REGISTER_EMAIL1_DESC', 'Enter your email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3085, 'COM_USERS_REGISTER_EMAIL1_LABEL', 'Email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3086, 'COM_USERS_REGISTER_EMAIL1_MESSAGE', 'The email address you entered is already in use or invalid. Please enter another email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3087, 'COM_USERS_REGISTER_EMAIL2_DESC', 'Confirm your email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3088, 'COM_USERS_REGISTER_EMAIL2_LABEL', 'Confirm email Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3089, 'COM_USERS_REGISTER_EMAIL2_MESSAGE', 'The email addresses you entered do not match. Please enter your email address in the email address field and confirm your entry by entering it in the confirm email address field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3090, 'COM_USERS_REGISTER_NAME_DESC', 'Enter your full name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3091, 'COM_USERS_REGISTER_NAME_LABEL', 'Name:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3092, 'COM_USERS_REGISTER_PASSWORD1_LABEL', 'Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3093, 'COM_USERS_REGISTER_PASSWORD1_MESSAGE', 'The passwords you entered do not match. Please enter your desired password in the password field and confirm your entry by entering it in the confirm password field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3094, 'COM_USERS_REGISTER_PASSWORD2_DESC', 'Confirm your password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3095, 'COM_USERS_REGISTER_PASSWORD2_LABEL', 'Confirm Password:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3096, 'COM_USERS_REGISTER_REQUIRED', '<strong class=\"red\">*</strong> Required field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3097, 'COM_USERS_REGISTER_USERNAME_DESC', 'Enter your desired username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3098, 'COM_USERS_REGISTER_USERNAME_LABEL', 'Username:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3099, 'COM_USERS_REGISTER_USERNAME_MESSAGE', 'The username you entered is not available. Please pick another username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3100, 'COM_USERS_REGISTRATION', 'User Registration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3101, 'COM_USERS_REGISTRATION_ACTIVATE_SUCCESS', 'Your Account has been successfully activated. You can now log in using the username and password you chose during the registration.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3102, 'COM_USERS_REGISTRATION_ACTIVATION_NOTIFY_SEND_MAIL_FAILED', 'An error was encountered while sending activation notification email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3103, 'COM_USERS_REGISTRATION_ACTIVATION_SAVE_FAILED', 'Failed to save activation data: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3104, 'COM_USERS_REGISTRATION_ADMINACTIVATE_SUCCESS', 'The user\'s account has been successfully activated and the user has been notified about it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3105, 'COM_USERS_REGISTRATION_BIND_FAILED', 'Failed to bind registration data: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3106, 'COM_USERS_REGISTRATION_COMPLETE_ACTIVATE', 'Your account has been created and an activation link has been sent to the email address you entered. Note that you must activate the account by clicking on the activation link when you get the email before you can login.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3107, 'COM_USERS_REGISTRATION_COMPLETE_VERIFY', 'Your account has been created and a verification link has been sent to the email address you entered. Note that you must verify the account by clicking on the verification link when you get the email and then an administrator will activate your account before you can login.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3108, 'COM_USERS_REGISTRATION_DEFAULT_LABEL', 'User Registration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3109, 'COM_USERS_REGISTRATION_SAVE_FAILED', 'Registration failed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3110, 'COM_USERS_REGISTRATION_SAVE_SUCCESS', 'Thank you for registering. You may now log in using the username and password you registered with.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3111, 'COM_USERS_REGISTRATION_SEND_MAIL_FAILED', 'An error was encountered while sending the registration email. A message has been sent to the administrator of this site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3112, 'COM_USERS_REGISTRATION_VERIFY_SUCCESS', 'Your email address has been verified. Once an administrator approves your account you will be notified by email and you can login to the site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3113, 'COM_USERS_REMIND', 'Reminder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3114, 'COM_USERS_REMIND_DEFAULT_LABEL', 'Please enter the email address associated with your User account. Your username will be emailed to the email address on file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3115, 'COM_USERS_REMIND_EMAIL_LABEL', 'Your Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3116, 'COM_USERS_REMIND_LIMIT_ERROR_N_HOURS', 'You have exceeded the maximum number of password resets allowed. Please try again in %s hours.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3117, 'COM_USERS_REMIND_LIMIT_ERROR_N_HOURS_1', 'You have exceeded the maximum number of password resets allowed. Please try again in one hour.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3118, 'COM_USERS_REMIND_REQUEST_FAILED', 'Reminder failed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3119, 'COM_USERS_REMIND_REQUEST_SUCCESS', 'Reminder successfully sent. Please check your mail.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3120, 'COM_USERS_REMIND_SUPERADMIN_ERROR', 'A Super User can\'t request a password reminder. Please contact another Super User or use an alternative method.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3121, 'COM_USERS_RESET', 'Password Reset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3122, 'COM_USERS_RESET_COMPLETE_ERROR', 'Error completing password reset.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3123, 'COM_USERS_RESET_COMPLETE_FAILED', 'Completing reset password failed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3124, 'COM_USERS_RESET_COMPLETE_LABEL', 'To complete the password reset process, please enter a new password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3125, 'COM_USERS_RESET_COMPLETE_SUCCESS', 'Reset password successful. You may now login to the site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3126, 'COM_USERS_RESET_CONFIRM_ERROR', 'Error while confirming the password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3127, 'COM_USERS_RESET_CONFIRM_FAILED', 'Your password reset confirmation failed because the verification code was invalid. %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3128, 'COM_USERS_RESET_CONFIRM_LABEL', 'An email has been sent to your email address. The email contains a verification code, please paste the verification code in the field below to prove that you are the owner of this account.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3129, 'COM_USERS_RESET_COMPLETE_TOKENS_MISSING', 'Your password reset confirmation failed because the verification code was missing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3130, 'COM_USERS_RESET_REQUEST_ERROR', 'Error requesting password reset.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3131, 'COM_USERS_RESET_REQUEST_FAILED', 'Reset password failed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3132, 'COM_USERS_RESET_REQUEST_LABEL', 'Please enter the email address for your account. A verification code will be sent to you. Once you have received the verification code, you will be able to choose a new password for your account.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3133, 'COM_USERS_SETTINGS_FIELDSET_LABEL', 'Basic Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3134, 'COM_USERS_USER_BLOCKED', 'This user is blocked. If this is an error, please contact an administrator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3135, 'COM_USERS_USER_FIELD_BACKEND_LANGUAGE_DESC', 'Choose your default language for the Backend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3136, 'COM_USERS_USER_FIELD_BACKEND_LANGUAGE_LABEL', 'Backend Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3137, 'COM_USERS_USER_FIELD_BACKEND_TEMPLATE_DESC', 'Select the template style for the Administrator Backend interface. This will only affect this User.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3138, 'COM_USERS_USER_FIELD_BACKEND_TEMPLATE_LABEL', 'Backend Template Style', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3139, 'COM_USERS_USER_FIELD_EDITOR_DESC', 'Choose your text editor.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3140, 'COM_USERS_USER_FIELD_EDITOR_LABEL', 'Editor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3141, 'COM_USERS_USER_FIELD_FRONTEND_LANGUAGE_DESC', 'Choose your default language for the Frontend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3142, 'COM_USERS_USER_FIELD_FRONTEND_LANGUAGE_LABEL', 'Frontend Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3143, 'COM_USERS_USER_FIELD_HELPSITE_DESC', 'Help site for the Backend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3144, 'COM_USERS_USER_FIELD_HELPSITE_LABEL', 'Help Site', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3145, 'COM_USERS_USER_FIELD_TIMEZONE_DESC', 'Choose your time zone.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3146, 'COM_USERS_USER_FIELD_TIMEZONE_LABEL', 'Time Zone', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3147, 'COM_USERS_USER_NOT_FOUND', 'User not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3148, 'COM_USERS_USER_SAVE_FAILED', 'Failed to save user: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_users.ini'),
(3149, 'COM_WEBLINKS_CONTENT_TYPE_WEBLINK', 'Web Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3150, 'COM_WEBLINKS_CONTENT_TYPE_CATEGORY', 'Web Links Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3151, 'COM_WEBLINKS_DEFAULT_PAGE_TITLE', 'Web Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3152, 'COM_WEBLINKS_EDIT', 'Edit Web link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3153, 'COM_WEBLINKS_ERR_TABLES_NAME', 'There is already a Web Link with that name in this category. Please try again.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3154, 'COM_WEBLINKS_ERR_TABLES_PROVIDE_URL', 'Please provide a valid URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3155, 'COM_WEBLINKS_ERR_TABLES_TITLE', 'Your Web Link must contain a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3156, 'COM_WEBLINKS_ERROR_CATEGORY_NOT_FOUND', 'Web Link category not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3157, 'COM_WEBLINKS_ERROR_UNIQUE_ALIAS', 'Another Web Link from this category has the same alias.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3158, 'COM_WEBLINKS_ERROR_WEBLINK_NOT_FOUND', 'Web Link not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3159, 'COM_WEBLINKS_ERROR_WEBLINK_URL_INVALID', 'Invalid Web link URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3160, 'COM_WEBLINKS_FIELD_ALIAS_DESC', 'The alias is for internal use only. Leave this blank and Joomla will fill in a default value from the title. It has to be unique for each web link in the same category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3161, 'COM_WEBLINKS_FIELD_CATEGORY_DESC', 'You must select a Category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3162, 'COM_WEBLINKS_FIELD_DESCRIPTION_DESC', 'Enter a description for your Web link.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3163, 'COM_WEBLINKS_FILTER_LABEL', 'Filter Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3164, 'COM_WEBLINKS_FILTER_SEARCH_DESC', 'Web Links filter search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3165, 'COM_WEBLINKS_FIELD_TITLE_DESC', 'Your Web Link must have a Title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3166, 'COM_WEBLINKS_FIELD_URL_DESC', 'You must enter a URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3167, 'COM_WEBLINKS_FIELD_URL_LABEL', 'URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3168, 'COM_WEBLINKS_FORM_CREATE_WEBLINK', 'Submit a Web Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3169, 'COM_WEBLINKS_GRID_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3170, 'COM_WEBLINKS_LINK', 'Web Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3171, 'COM_WEBLINKS_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3172, 'COM_WEBLINKS_NO_WEBLINKS', 'There are no Web Links in this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3173, 'COM_WEBLINKS_NUM', '# of links:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3174, 'COM_WEBLINKS_FORM_EDIT_WEBLINK', 'Edit a Web Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3175, 'COM_WEBLINKS_FORM_SUBMIT_WEBLINK', 'Submit a Web Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3176, 'COM_WEBLINKS_SAVE_SUCCESS', 'Web link successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3177, 'COM_WEBLINKS_SUBMIT_SAVE_SUCCESS', 'Web Link successfully submitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3178, 'COM_WEBLINKS_WEB_LINKS', 'Web Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3179, 'JGLOBAL_NEWITEMSLAST_DESC', 'New Web Links default to the last position. Ordering can be changed after this Web Link has been saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_weblinks.ini'),
(3180, 'COM_WRAPPER_NO_IFRAMES', 'This option will not work correctly. Unfortunately, your browser does not support inline frames.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.com_wrapper.ini'),
(3181, 'FILES_JOOMLA', 'Joomla CMS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.files_joomla.sys.ini'),
(3182, 'FILES_JOOMLA_ERROR_FILE_FOLDER', 'Error on deleting file or folder %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.files_joomla.sys.ini'),
(3183, 'FILES_JOOMLA_ERROR_MANIFEST', 'Error on updating manifest cache: (type, element, folder, client) = (%s, %s, %s, %s)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.files_joomla.sys.ini'),
(3184, 'FILES_JOOMLA_XML_DESCRIPTION', 'Joomla! 3 Content Management System.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.files_joomla.sys.ini'),
(3185, 'FINDER_CLI', 'Smart Search INDEXER', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3186, 'FINDER_CLI_BATCH_COMPLETE', ' * Processed batch %s in %s seconds.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3187, 'FINDER_CLI_FILTER_RESTORE_WARNING', 'Warning: Did not find taxonomy %s/%s in filter %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3188, 'FINDER_CLI_INDEX_PURGE', 'Purging index', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3189, 'FINDER_CLI_INDEX_PURGE_FAILED', '- index purge failed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3190, 'FINDER_CLI_INDEX_PURGE_SUCCESS', '- index purge successful', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3191, 'FINDER_CLI_PROCESS_COMPLETE', 'Total Processing Time: %s seconds.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3192, 'FINDER_CLI_RESTORE_FILTER_COMPLETED', '- number of filters restored: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3193, 'FINDER_CLI_RESTORE_FILTERS', 'Restoring filters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3194, 'FINDER_CLI_SAVE_FILTER_COMPLETED', '- number of saved filters: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3195, 'FINDER_CLI_SAVE_FILTERS', 'Saving filters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3196, 'FINDER_CLI_SETTING_UP_PLUGINS', 'Setting up Smart Search plugins', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3197, 'FINDER_CLI_SETUP_ITEMS', 'Setup %s items in %s seconds.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3198, 'FINDER_CLI_STARTING_INDEXER', 'Starting Indexer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.finder_cli.ini'),
(3199, 'JERROR_PARSING_LANGUAGE_FILE', '&#160;: error(s) in line(s) %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3200, 'ERROR', 'Error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3201, 'MESSAGE', 'Message', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3202, 'NOTICE', 'Notice', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3203, 'WARNING', 'Warning', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3204, 'J1', '1', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3205, 'J2', '2', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3206, 'J3', '3', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3207, 'J4', '4', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3208, 'J5', '5', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3209, 'J6', '6', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3210, 'J7', '7', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3211, 'J8', '8', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3212, 'J9', '9', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3213, 'J10', '10', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3214, 'J15', '15', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3215, 'J20', '20', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3216, 'J25', '25', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3217, 'J30', '30', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3218, 'J50', '50', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3219, 'J100', '100', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3220, 'JACTION_ADMIN', 'Configure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3221, 'JACTION_ADMIN_GLOBAL', 'Super User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3222, 'JACTION_COMPONENT_SETTINGS', 'Component Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3223, 'JACTION_CREATE', 'Create', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3224, 'JACTION_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3225, 'JACTION_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3226, 'JACTION_EDITOWN', 'Edit Own', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3227, 'JACTION_EDITSTATE', 'Edit State', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3228, 'JACTION_LOGIN_ADMIN', 'Admin Login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3229, 'JACTION_LOGIN_SITE', 'Site Login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3230, 'JACTION_MANAGE', 'Access Administration Interface', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3231, 'JADMINISTRATOR', 'Administrator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3232, 'JALL', 'All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3233, 'JALL_LANGUAGE', 'All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3234, 'JARCHIVED', 'Archived', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3235, 'JAUTHOR', 'Author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3236, 'JCANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3237, 'JCATEGORY', 'Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3238, 'JDATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3239, 'JDEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3240, 'JDETAILS', 'Details', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3241, 'JDISABLED', 'Disabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3242, 'JEDITOR', 'Editor', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3243, 'JENABLED', 'Enabled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3244, 'JEXPIRED', 'Expired', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3245, 'JFALSE', 'False', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3246, 'JFEATURED', 'Featured', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3247, 'JHIDE', 'Hide', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3248, 'JINVALID_TOKEN', 'Invalid Token', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3249, 'JLOGIN', 'Log in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3250, 'JLOGOUT', 'Log out', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3251, 'JNEW', 'New', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3252, 'JNEXT', 'Next', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3253, 'JNO', 'No', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3254, 'JNONE', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3255, 'JNOTPUBLISHEDYET', 'Not published yet', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3256, 'JNOTICE', 'Notice', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3257, 'JOFF', 'Off', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3258, 'JOFFLINE_MESSAGE', 'This site is down for maintenance.<br />Please check back again soon.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3259, 'JON', 'On', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3260, 'JOPTIONS', 'Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3261, 'JPAGETITLE', '%1$s - %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3262, 'JPREV', 'Prev', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3263, 'JPREVIOUS', 'Previous', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3264, 'JPUBLISHED', 'Published', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3265, 'JREGISTER', 'Register', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3266, 'JREQUIRED', 'Required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3267, 'JSAVE', 'Save', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3268, 'JSHOW', 'Show', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3269, 'JSITE', 'Site', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3270, 'JSTATUS', 'Status', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3271, 'JSUBMIT', 'Submit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3272, 'JTAG', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3273, 'JTAG_DESC', 'Add and delete tags to an item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3274, 'JTOOLBAR_VERSIONS', 'Versions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3275, 'JTRASH', 'Trash', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3276, 'JTRASHED', 'Trashed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3277, 'JTRUE', 'True', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3278, 'JUNPUBLISHED', 'Unpublished', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3279, 'JYEAR', 'Year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3280, 'JYES', 'Yes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3281, 'JBROWSERTARGET_MODAL', 'Modal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3282, 'JBROWSERTARGET_NEW', 'Open in new window', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3283, 'JBROWSERTARGET_PARENT', 'Open in parent window', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3284, 'JBROWSERTARGET_POPUP', 'Open in popup', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3285, 'JERROR_ALERTNOAUTHOR', 'You are not authorised to view this resource.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3286, 'JERROR_ALERTNOTEMPLATE', '<strong>The template for this display is not available. Please contact a Site administrator.</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3287, 'JERROR_AN_ERROR_HAS_OCCURRED', 'An error has occurred.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3288, 'JERROR_COULD_NOT_FIND_TEMPLATE', 'Could not find template \"%s\".', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3289, 'JERROR_ERROR', 'Error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3290, 'JERROR_LAYOUT_AN_OUT_OF_DATE_BOOKMARK_FAVOURITE', 'an <strong>out-of-date bookmark/favourite</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3291, 'JERROR_LAYOUT_ERROR_HAS_OCCURRED_WHILE_PROCESSING_YOUR_REQUEST', 'An error has occurred while processing your request.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3292, 'JERROR_LAYOUT_GO_TO_THE_HOME_PAGE', 'Go to the Home Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3293, 'JERROR_LAYOUT_HOME_PAGE', 'Home Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3294, 'JERROR_LAYOUT_MIS_TYPED_ADDRESS', 'a <strong>mistyped address</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3295, 'JERROR_LAYOUT_NOT_ABLE_TO_VISIT', 'You may not be able to visit this page because of:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3296, 'JERROR_LAYOUT_PAGE_NOT_FOUND', 'The requested page can\'t be found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3297, 'JERROR_LAYOUT_PLEASE_CONTACT_THE_SYSTEM_ADMINISTRATOR', 'If difficulties persist, please contact the System Administrator of this site and report the error below.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3298, 'JERROR_LAYOUT_PLEASE_TRY_ONE_OF_THE_FOLLOWING_PAGES', 'Please try one of the following pages:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3299, 'JERROR_LAYOUT_REQUESTED_RESOURCE_WAS_NOT_FOUND', 'The requested resource was not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3300, 'JERROR_LAYOUT_SEARCH', 'You may wish to search the site or visit the home page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3301, 'JERROR_LAYOUT_SEARCH_ENGINE_OUT_OF_DATE_LISTING', 'a search engine that has an <strong>out-of-date listing for this site</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3302, 'JERROR_LAYOUT_SEARCH_PAGE', 'Search this site', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3303, 'JERROR_LAYOUT_YOU_HAVE_NO_ACCESS_TO_THIS_PAGE', 'you have <strong>no access</strong> to this page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3304, 'JERROR_LOADING_MENUS', 'Error loading Menus: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3305, 'JERROR_LOGIN_DENIED', 'You can\'t access the private section of this site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3306, 'JERROR_NOLOGIN_BLOCKED', 'Login denied! Your account has either been blocked or you have not activated it yet.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3307, 'JERROR_SESSION_STARTUP', 'Error initialising the session.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3308, 'JERROR_TABLE_BIND_FAILED', 'hmm %s ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3309, 'JERROR_USERS_PROFILE_NOT_FOUND', 'User profile not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3310, 'JFIELD_ACCESS_DESC', 'Access level for this content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3311, 'JFIELD_ACCESS_LABEL', 'Access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3312, 'JFIELD_ALIAS_DESC', 'The Alias will be used in the SEF URL. Leave this blank and Joomla! will fill in a default value from the title. This value will depend on the SEO settings (Global Configuration->Site). <br />Using Unicode will produce UTF-8 aliases. You may also enter manually any UTF-8 character. Spaces and some forbidden characters will be changed to hyphens.<br />When using default transliteration it will produce an alias in lower case and with dashes instead of spaces. You may enter the Alias manually. Use lowercase letters and hyphens (-). No spaces or underscores are allowed. Default value will be a date and time if the title is typed in non-latin letters .', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3313, 'JFIELD_ALIAS_LABEL', 'Alias', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3314, 'JFIELD_ALIAS_PLACEHOLDER', 'Auto-generate from title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3315, 'JFIELD_ALT_PAGE_TITLE_LABEL', 'Alternative Page Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3316, 'JFIELD_CATEGORY_DESC', 'Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3317, 'JFIELD_LANGUAGE_DESC', 'Assign a language to this article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3318, 'JFIELD_LANGUAGE_LABEL', 'Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3319, 'JFIELD_META_DESCRIPTION_DESC', 'Metadata description.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3320, 'JFIELD_META_DESCRIPTION_LABEL', 'Meta Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3321, 'JFIELD_META_KEYWORDS_DESC', 'Keywords describing the content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3322, 'JFIELD_META_KEYWORDS_LABEL', 'Keywords', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3323, 'JFIELD_META_RIGHTS_DESC', 'Describe what rights others have to use this content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3324, 'JFIELD_META_RIGHTS_LABEL', 'Content Rights', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3325, 'JFIELD_ORDERING_DESC', 'Ordering of the article within the category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3326, 'JFIELD_ORDERING_LABEL', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3327, 'JFIELD_PUBLISHED_DESC', 'Set publication status.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3328, 'JFIELD_TITLE_DESC', 'Title for the article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3329, 'JGLOBAL_ARTICLES', 'Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3330, 'JGLOBAL_AUTH_ACCESS_DENIED', 'Access Denied', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3331, 'JGLOBAL_AUTH_ACCESS_GRANTED', 'Access Granted', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3332, 'JGLOBAL_AUTH_BIND_FAILED', 'Failed binding to LDAP server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3333, 'JGLOBAL_AUTH_CANCEL', 'Authentication cancelled', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3334, 'JGLOBAL_AUTH_CURL_NOT_INSTALLED', 'Curl isn\'t installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3335, 'JGLOBAL_AUTH_EMPTY_PASS_NOT_ALLOWED', 'Empty password not allowed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3336, 'JGLOBAL_AUTH_FAIL', 'Authentication failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3337, 'JGLOBAL_AUTH_FAILED', 'Failed to authenticate: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3338, 'JGLOBAL_AUTH_INCORRECT', 'Incorrect username/password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3339, 'JGLOBAL_AUTH_INVALID_PASS', 'Username and password do not match or you do not have an account yet.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3340, 'JGLOBAL_AUTH_INVALID_SECRETKEY', 'The two factor authentication Secret Key is invalid.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3341, 'JGLOBAL_AUTH_NO_BIND', 'Unable to bind to LDAP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3342, 'JGLOBAL_AUTH_NO_CONNECT', 'Unable to connect to LDAP server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3343, 'JGLOBAL_AUTH_NO_REDIRECT', 'Could not redirect to server: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3344, 'JGLOBAL_AUTH_NO_USER', 'Username and password do not match or you do not have an account yet.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3345, 'JGLOBAL_AUTH_NOT_CREATE_DIR', 'Could not create the FileStore directory %s. Please check the effective permissions.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3346, 'JGLOBAL_AUTH_PASS_BLANK', 'LDAP can\'t have blank password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3347, 'JGLOBAL_AUTH_UNKNOWN_ACCESS_DENIED', 'Result Unknown. Access Denied', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3348, 'JGLOBAL_AUTH_USER_BLACKLISTED', 'User is blacklisted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3349, 'JGLOBAL_AUTH_USER_NOT_FOUND', 'Unable to find user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3350, 'JGLOBAL_AUTO', 'Auto', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3351, 'JGLOBAL_CATEGORY_NOT_FOUND', 'Category not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3352, 'JGLOBAL_CENTER', 'Center', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3353, 'JGLOBAL_CHECK_ALL', 'Check All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3354, 'JGLOBAL_CLICK_TO_SORT_THIS_COLUMN', 'Click to sort by this column', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3355, 'JGLOBAL_CREATED_DATE_ON', 'Created on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3356, 'JGLOBAL_DESCRIPTION', 'Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3357, 'JGLOBAL_DISPLAY_NUM', 'Display #', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3358, 'JGLOBAL_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3359, 'JGLOBAL_EMAIL', 'Email', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3360, 'JGLOBAL_FIELD_CREATED_BY_ALIAS_DESC', 'Uses another name than the author\'s for display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3361, 'JGLOBAL_FIELD_CREATED_BY_ALIAS_LABEL', 'Author\'s Alias', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3362, 'JGLOBAL_FIELD_FEATURED_DESC', 'Assign the article to the featured blog layout.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3363, 'JGLOBAL_FIELD_FEATURED_LABEL', 'Featured', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3364, 'JGLOBAL_FIELD_PUBLISH_DOWN_DESC', 'An optional date to stop publishing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3365, 'JGLOBAL_FIELD_PUBLISH_DOWN_LABEL', 'Finish Publishing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3366, 'JGLOBAL_FIELD_PUBLISH_UP_DESC', 'An optional date to start publishing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3367, 'JGLOBAL_FIELD_PUBLISH_UP_LABEL', 'Start Publishing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3368, 'JGLOBAL_FIELD_VERSION_NOTE_DESC', 'Enter an optional note for this version of the item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3369, 'JGLOBAL_FIELD_VERSION_NOTE_LABEL', 'Version Note', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3370, 'JGLOBAL_FILTER_BUTTON', 'Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3371, 'JGLOBAL_FILTER_LABEL', 'Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3372, 'JGLOBAL_FULL_TEXT', 'Full Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3373, 'JGLOBAL_GT', '&gt;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3374, 'JGLOBAL_HELPREFRESH_BUTTON', 'Refresh', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3375, 'JGLOBAL_HITS', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3376, 'JGLOBAL_HITS_COUNT', 'Hits: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3377, 'JGLOBAL_ICON_SEP', '|', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3378, 'JGLOBAL_INHERIT', 'Inherit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3379, 'JGLOBAL_INTRO_TEXT', 'Intro Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3380, 'JGLOBAL_KEEP_TYPING', 'Keep typing ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3381, 'JGLOBAL_LEFT', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3382, 'JGLOBAL_LOOKING_FOR', 'Looking for', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3383, 'JGLOBAL_LT', '&lt;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3384, 'JGLOBAL_NEWITEMSLAST_DESC', 'New items default to the last position. Ordering can be changed after this item has been saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3385, 'JGLOBAL_NO_MATCHING_RESULTS', 'No Matching Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3386, 'JGLOBAL_NUM', '#', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3387, 'JGLOBAL_OTPMETHOD_NONE', 'Disable Two Factor Authentication', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3388, 'JGLOBAL_PASSWORD', 'Password', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3389, 'JGLOBAL_PASSWORD_RESET_REQUIRED', 'You are required to reset your password before proceeding.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3390, 'JGLOBAL_PRINT', 'Print', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3391, 'JGLOBAL_RECORD_NUMBER', 'Record ID: %d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3392, 'JGLOBAL_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3393, 'JGLOBAL_REMEMBER_MUST_LOGIN', 'For security reasons you must login before editing your personal information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3394, 'JGLOBAL_RESOURCE_NOT_FOUND', 'Resource not found', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3395, 'JGLOBAL_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3396, 'JGLOBAL_ROOT', 'Root', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3397, 'JGLOBAL_SECRETKEY', 'Secret Key', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3398, 'JGLOBAL_SECRETKEY_HELP', 'If you have enabled two factor authentication in your user account please enter your secret key. If you do not know what this means, you can leave this field blank.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3399, 'JGLOBAL_SELECT_AN_OPTION', 'Select an option', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3400, 'JGLOBAL_SELECT_NO_RESULTS_MATCH', 'No results match', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3401, 'JGLOBAL_SELECT_SOME_OPTIONS', 'Select some options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3402, 'JGLOBAL_START_PUBLISH_AFTER_FINISH', 'Item start publishing date must be before finish publishing date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3403, 'JGLOBAL_SUBCATEGORIES', 'Subcategories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3404, 'JGLOBAL_SUBHEADING_DESC', 'Optional text to show as a subheading.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3405, 'JGLOBAL_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3406, 'JGLOBAL_USE_GLOBAL', 'Use Global', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3407, 'JGLOBAL_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3408, 'JGLOBAL_VALIDATION_FORM_FAILED', 'Invalid form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3409, 'JGLOBAL_YOU_MUST_LOGIN_FIRST', 'Please login first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3410, 'JGRID_HEADING_ACCESS', 'Access', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3411, 'JGRID_HEADING_ID', 'ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3412, 'JGRID_HEADING_LANGUAGE', 'Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3413, 'JLIB_DATABASE_ERROR_ADAPTER_MYSQL', 'The MySQL adapter \'mysql\' is not available.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3414, 'JLIB_DATABASE_ERROR_ADAPTER_MYSQLI', 'The MySQL adapter \'mysqli\' is not available.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3415, 'JLIB_DATABASE_ERROR_CONNECT_DATABASE', 'Unable to connect to the Database: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3416, 'JLIB_DATABASE_ERROR_CONNECT_MYSQL', 'Could not connect to MySQL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3417, 'JLIB_DATABASE_ERROR_DATABASE_CONNECT', 'Could not connect to database', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3418, 'JLIB_DATABASE_ERROR_LOAD_DATABASE_DRIVER', 'Unable to load Database Driver: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3419, 'JLIB_ERROR_INFINITE_LOOP', 'Infinite loop detected in JError', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3420, 'JOPTION_SELECT_ACCESS', '- Select Access -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3421, 'JOPTION_SELECT_AUTHOR', '- Select Author -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3422, 'JOPTION_SELECT_CATEGORY', '- Select Category -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3423, 'JOPTION_SELECT_LANGUAGE', '- Select Language -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3424, 'JOPTION_SELECT_PUBLISHED', '- Select Status -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3425, 'JOPTION_SELECT_MAX_LEVELS', '- Select Max Levels -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3426, 'JOPTION_SELECT_TAG', '- Select Tag -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3427, 'JOPTION_USE_DEFAULT', '- Use Default -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3428, 'JSEARCH_FILTER_CLEAR', 'Clear', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3429, 'JSEARCH_FILTER_LABEL', 'Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3430, 'JSEARCH_FILTER_SUBMIT', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3431, 'JSEARCH_FILTER', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3432, 'DATE_FORMAT_LC', 'l, d F Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3433, 'DATE_FORMAT_LC1', 'l, d F Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3434, 'DATE_FORMAT_LC2', 'l, d F Y H:i', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3435, 'DATE_FORMAT_LC3', 'd F Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3436, 'DATE_FORMAT_LC4', 'Y-m-d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3437, 'DATE_FORMAT_JS1', 'y-m-d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3438, 'JANUARY_SHORT', 'Jan', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3439, 'JANUARY', 'January', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3440, 'FEBRUARY_SHORT', 'Feb', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3441, 'FEBRUARY', 'February', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3442, 'MARCH_SHORT', 'Mar', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3443, 'MARCH', 'March', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3444, 'APRIL_SHORT', 'Apr', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3445, 'APRIL', 'April', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3446, 'MAY_SHORT', 'May', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3447, 'MAY', 'May', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3448, 'JUNE_SHORT', 'Jun', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3449, 'JUNE', 'June', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3450, 'JULY_SHORT', 'Jul', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3451, 'JULY', 'July', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3452, 'AUGUST_SHORT', 'Aug', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3453, 'AUGUST', 'August', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3454, 'SEPTEMBER_SHORT', 'Sep', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3455, 'SEPTEMBER', 'September', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3456, 'OCTOBER_SHORT', 'Oct', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3457, 'OCTOBER', 'October', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3458, 'NOVEMBER_SHORT', 'Nov', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3459, 'NOVEMBER', 'November', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3460, 'DECEMBER_SHORT', 'Dec', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3461, 'DECEMBER', 'December', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3462, 'SAT', 'Sat', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3463, 'SATURDAY', 'Saturday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3464, 'SUN', 'Sun', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3465, 'SUNDAY', 'Sunday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3466, 'MON', 'Mon', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3467, 'MONDAY', 'Monday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3468, 'TUE', 'Tue', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3469, 'TUESDAY', 'Tuesday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3470, 'WED', 'Wed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3471, 'WEDNESDAY', 'Wednesday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3472, 'THU', 'Thu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3473, 'THURSDAY', 'Thursday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3474, 'FRI', 'Fri', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3475, 'FRIDAY', 'Friday', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3476, 'DECIMALS_SEPARATOR', '.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3477, 'THOUSANDS_SEPARATOR', ',', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3478, 'PHPMAILER_PROVIDE_ADDRESS', 'You must provide at least one recipient email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3479, 'PHPMAILER_MAILER_IS_NOT_SUPPORTED', ' Mailer is not supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3480, 'PHPMAILER_EXECUTE', 'Could not execute: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3481, 'PHPMAILER_INSTANTIATE', 'Could not start mail function.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3482, 'PHPMAILER_AUTHENTICATE', 'SMTP Error! Could not authenticate.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3483, 'PHPMAILER_FROM_FAILED', 'The following from address failed: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3484, 'PHPMAILER_RECIPIENTS_FAILED', 'SMTP Error! The following recipients failed: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3485, 'PHPMAILER_DATA_NOT_ACCEPTED', 'SMTP Error! Data not accepted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3486, 'PHPMAILER_CONNECT_HOST', 'SMTP Error! Could not connect to SMTP host.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3487, 'PHPMAILER_FILE_ACCESS', 'Could not access file: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3488, 'PHPMAILER_FILE_OPEN', 'File Error: Could not open file: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3489, 'PHPMAILER_ENCODING', 'Unknown encoding: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3490, 'PHPMAILER_SIGNING_ERROR', 'Signing error: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3491, 'PHPMAILER_SMTP_ERROR', 'SMTP server error: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3492, 'PHPMAILER_EMPTY_MESSAGE', 'Empty message body', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3493, 'PHPMAILER_INVALID_ADDRESS', 'Invalid address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3494, 'PHPMAILER_VARIABLE_SET', 'Can\'t set or reset variable: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(3495, 'PHPMAILER_SMTP_CONNECT_FAILED', 'SMTP connect failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3496, 'PHPMAILER_TLS', 'Could not start TLS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3497, 'MYSQL', 'MySQL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3498, 'MYSQLI', 'MySQLi', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3499, 'ORACLE', 'Oracle', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3500, 'PDOMYSQL', 'MySQL (PDO)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3501, 'POSTGRESQL', 'PostgreSQL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3502, 'SQLAZURE', 'Microsoft SQL Azure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3503, 'SQLITE', 'SQLite', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3504, 'SQLSRV', 'Microsoft SQL Server', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3505, 'JSEARCH_TOOLS', 'Search tools', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3506, 'JSEARCH_TOOLS_DESC', 'Filter the list items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3507, 'JSEARCH_TOOLS_ORDERING', 'Order by:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.ini'),
(3508, 'LIB_FOF_XML_DESCRIPTION', 'Framework-on-Framework (FOF) - A rapid component development framework for Joomla!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_fof.sys.ini'),
(3509, 'LIB_IDNA_XML_DESCRIPTION', 'The class idna_convert allows to convert internationalised domain names (see RFC 3490, 3491, 3492 and 3454 for details) as they can be used with various registries worldwide to be translated between their original (localised) form and their encoded form as it will be used in the DNS (Domain Name System).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_idna_convert.sys.ini'),
(3510, 'JERROR_PARSING_LANGUAGE_FILE', '&#160;: error(s) in line(s) %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3511, 'JLIB_APPLICATION_ERROR_ACCESS_FORBIDDEN', 'Access forbidden', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3512, 'JLIB_APPLICATION_ERROR_APPLICATION_GET_NAME', 'JApplication: :getName() : Can\'t get or parse class name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3513, 'JLIB_APPLICATION_ERROR_APPLICATION_LOAD', 'Unable to load application: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3514, 'JLIB_APPLICATION_ERROR_BATCH_CANNOT_CREATE', 'You are not allowed to create new items in this category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3515, 'JLIB_APPLICATION_ERROR_BATCH_CANNOT_EDIT', 'You are not allowed to edit one or more of these items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3516, 'JLIB_APPLICATION_ERROR_BATCH_FAILED', 'Batch process failed with following error: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3517, 'JLIB_APPLICATION_ERROR_BATCH_MOVE_CATEGORY_NOT_FOUND', 'Can\'t find the destination category for this move.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3518, 'JLIB_APPLICATION_ERROR_BATCH_MOVE_ROW_NOT_FOUND', 'Can\'t find the item being moved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3519, 'JLIB_APPLICATION_ERROR_CHECKIN_FAILED', 'Check-in failed with the following error: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3520, 'JLIB_APPLICATION_ERROR_CHECKIN_NOT_CHECKED', 'Item is not checked out.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3521, 'JLIB_APPLICATION_ERROR_CHECKIN_USER_MISMATCH', 'The user checking in does not match the user who checked out the item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3522, 'JLIB_APPLICATION_ERROR_CHECKOUT_FAILED', 'Check-out failed with the following error: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3523, 'JLIB_APPLICATION_ERROR_CHECKOUT_USER_MISMATCH', 'The user checking out does not match the user who checked out the item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3524, 'JLIB_APPLICATION_ERROR_COMPONENT_NOT_FOUND', 'Component not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3525, 'JLIB_APPLICATION_ERROR_COMPONENT_NOT_LOADING', 'Error loading component: %1$s, %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3526, 'JLIB_APPLICATION_ERROR_CONTROLLER_GET_NAME', 'JController: :getName() : Can\'t get or parse class name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3527, 'JLIB_APPLICATION_ERROR_CREATE_RECORD_NOT_PERMITTED', 'Create record not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3528, 'JLIB_APPLICATION_ERROR_DELETE_NOT_PERMITTED', 'Delete not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3529, 'JLIB_APPLICATION_ERROR_EDITSTATE_NOT_PERMITTED', 'Edit state is not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3530, 'JLIB_APPLICATION_ERROR_EDIT_ITEM_NOT_PERMITTED', 'Edit is not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3531, 'JLIB_APPLICATION_ERROR_EDIT_NOT_PERMITTED', 'Edit not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3532, 'JLIB_APPLICATION_ERROR_HISTORY_ID_MISMATCH', 'Error restoring item version from history.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3533, 'JLIB_APPLICATION_ERROR_INSUFFICIENT_BATCH_INFORMATION', 'Insufficient information to perform the batch operation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3534, 'JLIB_APPLICATION_ERROR_INVALID_CONTROLLER_CLASS', 'Invalid controller class: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3535, 'JLIB_APPLICATION_ERROR_INVALID_CONTROLLER', 'Invalid controller: name=\'%s\', format=\'%s\'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3536, 'JLIB_APPLICATION_ERROR_LAYOUTFILE_NOT_FOUND', 'Layout %s not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3537, 'JLIB_APPLICATION_ERROR_LIBRARY_NOT_FOUND', 'Library not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3538, 'JLIB_APPLICATION_ERROR_LIBRARY_NOT_LOADING', 'Error loading library: %1$s, %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3539, 'JLIB_APPLICATION_ERROR_MODEL_GET_NAME', 'JModel: :getName() : Can\'t get or parse class name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3540, 'JLIB_APPLICATION_ERROR_MODULE_LOAD', 'Error loading module %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3541, 'JLIB_APPLICATION_ERROR_PATHWAY_LOAD', 'Unable to load pathway: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3542, 'JLIB_APPLICATION_ERROR_REORDER_FAILED', 'Reorder failed. Error: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3543, 'JLIB_APPLICATION_ERROR_ROUTER_LOAD', 'Unable to load router: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3544, 'JLIB_APPLICATION_ERROR_MODELCLASS_NOT_FOUND', 'Model class %s not found in file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3545, 'JLIB_APPLICATION_ERROR_SAVE_FAILED', 'Save failed with the following error: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3546, 'JLIB_APPLICATION_ERROR_SAVE_NOT_PERMITTED', 'Save not permitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3547, 'JLIB_APPLICATION_ERROR_TABLE_NAME_NOT_SUPPORTED', 'Table %s not supported. File not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3548, 'JLIB_APPLICATION_ERROR_TASK_NOT_FOUND', 'Task [%s] not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3549, 'JLIB_APPLICATION_ERROR_UNHELD_ID', 'You are not permitted to use that link to directly access that page (#%d).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3550, 'JLIB_APPLICATION_ERROR_VIEW_CLASS_NOT_FOUND', 'View class not found [class, file]: %1$s, %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3551, 'JLIB_APPLICATION_ERROR_VIEW_GET_NAME_SUBSTRING', 'JView: :getName() : Your classname contains the substring \'view\'. This causes problems when extracting the classname from the name of your objects view. Avoid Object names with the substring \'view\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3552, 'JLIB_APPLICATION_ERROR_VIEW_GET_NAME', 'JView: :getName() : Can\'t get or parse class name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3553, 'JLIB_APPLICATION_ERROR_VIEW_NOT_FOUND', 'View not found [name, type, prefix]: %1$s, %2$s, %3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3554, 'JLIB_APPLICATION_SAVE_SUCCESS', 'Item successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3555, 'JLIB_APPLICATION_SUBMIT_SAVE_SUCCESS', 'Item successfully submitted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3556, 'JLIB_APPLICATION_SUCCESS_BATCH', 'Batch process completed successfully.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3557, 'JLIB_APPLICATION_SUCCESS_ITEM_REORDERED', 'Ordering successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3558, 'JLIB_APPLICATION_SUCCESS_ORDERING_SAVED', 'Ordering successfully saved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3559, 'JLIB_APPLICATION_SUCCESS_LOAD_HISTORY', 'Prior version successfully restored. Saved on %s %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3560, 'JLIB_LOGIN_AUTHENTICATE', 'Username and password do not match or you do not have an account yet.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3561, 'JLIB_CACHE_ERROR_CACHE_HANDLER_LOAD', 'Unable to load Cache Handler: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3562, 'JLIB_CACHE_ERROR_CACHE_STORAGE_LOAD', 'Unable to load Cache Storage: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3563, 'JLIB_CAPTCHA_ERROR_PLUGIN_NOT_FOUND', 'Captcha plugin not set or not found. Please contact a site administrator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3564, 'JLIB_CLIENT_ERROR_JFTP_NO_CONNECT', 'JFTP: :connect: Could not connect to host \' %1$s \' on port \' %2$s \'', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3565, 'JLIB_CLIENT_ERROR_JFTP_NO_CONNECT_SOCKET', 'JFTP: :connect: Could not connect to host \' %1$s \' on port \' %2$s \'. Socket error number: %3$s and error message: %4$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3566, 'JLIB_CLIENT_ERROR_JFTP_BAD_RESPONSE', 'JFTP: :connect: Bad response. Server response: %s [Expected: 220]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3567, 'JLIB_CLIENT_ERROR_JFTP_BAD_USERNAME', 'JFTP: :login: Bad Username. Server response: %1$s [Expected: 331]. Username sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3568, 'JLIB_CLIENT_ERROR_JFTP_BAD_PASSWORD', 'JFTP: :login: Bad Password. Server response: %1$s [Expected: 230]. Password sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3569, 'JLIB_CLIENT_ERROR_JFTP_PWD_BAD_RESPONSE_NATIVE', 'FTP: :pwd: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3570, 'JLIB_CLIENT_ERROR_JFTP_PWD_BAD_RESPONSE', 'JFTP: :pwd: Bad response. Server response: %s [Expected: 257]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3571, 'JLIB_CLIENT_ERROR_JFTP_SYST_BAD_RESPONSE_NATIVE', 'JFTP: :syst: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3572, 'JLIB_CLIENT_ERROR_JFTP_SYST_BAD_RESPONSE', 'JFTP: :syst: Bad response. Server response: %s [Expected: 215]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3573, 'JLIB_CLIENT_ERROR_JFTP_CHDIR_BAD_RESPONSE_NATIVE', 'JFTP: :chdir: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3574, 'JLIB_CLIENT_ERROR_JFTP_CHDIR_BAD_RESPONSE', 'JFTP: :chdir: Bad response. Server response: %1$s [Expected: 250]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3575, 'JLIB_CLIENT_ERROR_JFTP_REINIT_BAD_RESPONSE_NATIVE', 'JFTP: :reinit: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3576, 'JLIB_CLIENT_ERROR_JFTP_REINIT_BAD_RESPONSE', 'JFTP: :reinit: Bad response. Server response: %s [Expected: 220]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3577, 'JLIB_CLIENT_ERROR_JFTP_RENAME_BAD_RESPONSE_NATIVE', 'JFTP: :rename: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3578, 'JLIB_CLIENT_ERROR_JFTP_RENAME_BAD_RESPONSE_FROM', 'JFTP: :rename: Bad response. Server response: %1$s [Expected: 350]. From path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3579, 'JLIB_CLIENT_ERROR_JFTP_RENAME_BAD_RESPONSE_TO', 'JFTP: :rename: Bad response. Server response: %1$s [Expected: 250]. To path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3580, 'JLIB_CLIENT_ERROR_JFTP_CHMOD_BAD_RESPONSE_NATIVE', 'JFTP: :chmod: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3581, 'JLIB_CLIENT_ERROR_JFTP_CHMOD_BAD_RESPONSE', 'JFTP: :chmod: Bad response. Server response: %1$s [Expected: 250]. Path sent: %2$s. Mode sent: %3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3582, 'JLIB_CLIENT_ERROR_JFTP_DELETE_BAD_RESPONSE_NATIVE', 'JFTP: :delete: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3583, 'JLIB_CLIENT_ERROR_JFTP_DELETE_BAD_RESPONSE', 'JFTP: :delete: Bad response. Server response: %1$s [Expected: 250]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3584, 'JLIB_CLIENT_ERROR_JFTP_MKDIR_BAD_RESPONSE_NATIVE', 'JFTP: :mkdir: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3585, 'JLIB_CLIENT_ERROR_JFTP_MKDIR_BAD_RESPONSE', 'JFTP: :mkdir: Bad response. Server response: %1$s [Expected: 257]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3586, 'JLIB_CLIENT_ERROR_JFTP_RESTART_BAD_RESPONSE_NATIVE', 'JFTP: :restart: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3587, 'JLIB_CLIENT_ERROR_JFTP_RESTART_BAD_RESPONSE', 'JFTP: :restart: Bad response. Server response: %1$s [Expected: 350]. Restart point sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3588, 'JLIB_CLIENT_ERROR_JFTP_CREATE_BAD_RESPONSE_BUFFER', 'JFTP: :create: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3589, 'JLIB_CLIENT_ERROR_JFTP_CREATE_BAD_RESPONSE_PASSIVE', 'JFTP: :create: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3590, 'JLIB_CLIENT_ERROR_JFTP_CREATE_BAD_RESPONSE', 'JFTP: :create: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3591, 'JLIB_CLIENT_ERROR_JFTP_CREATE_BAD_RESPONSE_TRANSFER', 'JFTP: :create: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3592, 'JLIB_CLIENT_ERROR_JFTP_READ_BAD_RESPONSE_BUFFER', 'JFTP: :read: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3593, 'JLIB_CLIENT_ERROR_JFTP_READ_BAD_RESPONSE_PASSIVE', 'JFTP: :read: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3594, 'JLIB_CLIENT_ERROR_JFTP_READ_BAD_RESPONSE', 'JFTP: :read: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3595, 'JLIB_CLIENT_ERROR_JFTP_READ_BAD_RESPONSE_TRANSFER', 'JFTP: :read: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3596, 'JLIB_CLIENT_ERROR_JFTP_GET_BAD_RESPONSE', 'JFTP: :get: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3597, 'JLIB_CLIENT_ERROR_JFTP_GET_PASSIVE', 'JFTP: :get: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3598, 'JLIB_CLIENT_ERROR_JFTP_GET_WRITING_LOCAL', 'JFTP: :get: Unable to open local file for writing. Local path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3599, 'JLIB_CLIENT_ERROR_JFTP_GET_BAD_RESPONSE_RETR', 'JFTP: :get: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3600, 'JLIB_CLIENT_ERROR_JFTP_GET_BAD_RESPONSE_TRANSFER', 'JFTP: :get: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3601, 'JLIB_CLIENT_ERROR_JFTP_STORE_PASSIVE', 'JFTP: :store: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3602, 'JLIB_CLIENT_ERROR_JFTP_STORE_BAD_RESPONSE', 'JFTP: :store: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3603, 'JLIB_CLIENT_ERROR_JFTP_STORE_READING_LOCAL', 'JFTP: :store: Unable to open local file for reading. Local path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3604, 'JLIB_CLIENT_ERROR_JFTP_STORE_FIND_LOCAL', 'JFTP: :store: Unable to find local file. Local path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3605, 'JLIB_CLIENT_ERROR_JFTP_STORE_BAD_RESPONSE_STOR', 'JFTP: :store: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3606, 'JLIB_CLIENT_ERROR_JFTP_STORE_DATA_PORT', 'JFTP: :store: Unable to write to data port socket.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3607, 'JLIB_CLIENT_ERROR_JFTP_STORE_BAD_RESPONSE_TRANSFER', 'JFTP: :store: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3608, 'JLIB_CLIENT_ERROR_JFTP_WRITE_PASSIVE', 'JFTP: :write: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3609, 'JLIB_CLIENT_ERROR_JFTP_WRITE_BAD_RESPONSE', 'JFTP: :write: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3610, 'JLIB_CLIENT_ERROR_JFTP_WRITE_BAD_RESPONSE_STOR', 'JFTP: :write: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3611, 'JLIB_CLIENT_ERROR_JFTP_WRITE_DATA_PORT', 'JFTP: :write: Unable to write to data port socket.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3612, 'JLIB_CLIENT_ERROR_JFTP_WRITE_BAD_RESPONSE_TRANSFER', 'JFTP: :write: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3613, 'JLIB_CLIENT_ERROR_JFTP_LISTNAMES_PASSIVE', 'JFTP: :listNames: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3614, 'JLIB_CLIENT_ERROR_JFTP_LISTNAMES_BAD_RESPONSE', 'JFTP: :listNames: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3615, 'JLIB_CLIENT_ERROR_JFTP_LISTNAMES_BAD_RESPONSE_NLST', 'JFTP: :listNames: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3616, 'JLIB_CLIENT_ERROR_JFTP_LISTNAMES_BAD_RESPONSE_TRANSFER', 'JFTP: :listNames: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3617, 'JLIB_CLIENT_ERROR_JFTP_LISTDETAILS_BAD_RESPONSE', 'JFTP: :listDetails: Bad response.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3618, 'JLIB_CLIENT_ERROR_JFTP_LISTDETAILS_PASSIVE', 'JFTP: :listDetails: Unable to use passive mode.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3619, 'JLIB_CLIENT_ERROR_JFTP_LISTDETAILS_BAD_RESPONSE_LIST', 'JFTP: :listDetails: Bad response. Server response: %1$s [Expected: 150 or 125]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3620, 'JLIB_CLIENT_ERROR_JFTP_LISTDETAILS_BAD_RESPONSE_TRANSFER', 'JFTP: :listDetails: Transfer Failed. Server response: %1$s [Expected: 226]. Path sent: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3621, 'JLIB_CLIENT_ERROR_JFTP_LISTDETAILS_UNRECOGNISED', 'JFTP: :listDetails: Unrecognised directory listing format.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3622, 'JLIB_CLIENT_ERROR_JFTP_PUTCMD_UNCONNECTED', 'JFTP: :_putCmd: Not connected to the control port.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3623, 'JLIB_CLIENT_ERROR_JFTP_PUTCMD_SEND', 'JFTP: :_putCmd: Unable to send command: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3624, 'JLIB_CLIENT_ERROR_JFTP_VERIFYRESPONSE', 'JFTP: :_verifyResponse: Timeout or unrecognised response while waiting for a response from the server. Server response: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3625, 'JLIB_CLIENT_ERROR_JFTP_PASSIVE_CONNECT_PORT', 'JFTP: :_passive: Not connected to the control port.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3626, 'JLIB_CLIENT_ERROR_JFTP_PASSIVE_RESPONSE', 'JFTP: :_passive: Timeout or unrecognised response while waiting for a response from the server. Server response: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3627, 'JLIB_CLIENT_ERROR_JFTP_PASSIVE_IP_OBTAIN', 'JFTP: :_passive: Unable to obtain IP and port for data transfer. Server response: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3628, 'JLIB_CLIENT_ERROR_JFTP_PASSIVE_IP_VALID', 'JFTP: :_passive: IP and port for data transfer not valid. Server response: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3629, 'JLIB_CLIENT_ERROR_JFTP_PASSIVE_CONNECT', 'JFTP: :_passive: Could not connect to host %1$s on port %2$s. Socket error number: %3$s and error message: %4$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3630, 'JLIB_CLIENT_ERROR_JFTP_MODE_BINARY', 'JFTP: :_mode: Bad response. Server response: %s [Expected: 200]. Mode sent: Binary.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3631, 'JLIB_CLIENT_ERROR_JFTP_MODE_ASCII', 'JFTP: :_mode: Bad response. Server response: %s [Expected: 200]. Mode sent: Ascii.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3632, 'JLIB_CLIENT_ERROR_HELPER_SETCREDENTIALSFROMREQUEST_FAILED', 'Looks like User\'s credentials are no good.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3633, 'JLIB_CLIENT_ERROR_LDAP_ADDRESS_NOT_AVAILABLE', 'Address not available.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3634, 'JLIB_DATABASE_ERROR_ADAPTER_MYSQL', 'The MySQL adapter \'mysql\' is not available.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3635, 'JLIB_DATABASE_ERROR_ADAPTER_MYSQLI', 'The MySQL adapter \'mysqli\' is not available.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3636, 'JLIB_DATABASE_ERROR_BIND_FAILED_INVALID_SOURCE_ARGUMENT', '%s: :bind failed. Invalid source argument.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3637, 'JLIB_DATABASE_ERROR_ARTICLE_UNIQUE_ALIAS', 'Another article from this category has the same alias.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3638, 'JLIB_DATABASE_ERROR_CATEGORY_UNIQUE_ALIAS', 'Another category with the same parent category has the same alias.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3639, 'JLIB_DATABASE_ERROR_CHECK_FAILED', '%s: :check Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3640, 'JLIB_DATABASE_ERROR_CHECKIN_FAILED', '%s: :check-in failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3641, 'JLIB_DATABASE_ERROR_CHECKOUT_FAILED', '%s: :check-out failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3642, 'JLIB_DATABASE_ERROR_CHILD_ROWS_CHECKED_OUT', 'Child rows checked out.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3643, 'JLIB_DATABASE_ERROR_CLASS_DOES_NOT_SUPPORT_ORDERING', '%s does not support ordering.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3644, 'JLIB_DATABASE_ERROR_CLASS_IS_MISSING_FIELD', 'Missing field in the database: %s &#160; %s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3645, 'JLIB_DATABASE_ERROR_CLASS_NOT_FOUND_IN_FILE', 'Table class %s not found in file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3646, 'JLIB_DATABASE_ERROR_CONNECT_DATABASE', 'Unable to connect to the Database: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3647, 'JLIB_DATABASE_ERROR_CONNECT_MYSQL', 'Could not connect to MySQL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3648, 'JLIB_DATABASE_ERROR_DATABASE_CONNECT', 'Could not connect to database.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3649, 'JLIB_DATABASE_ERROR_DELETE_CATEGORY', 'Left-Right data inconsistency. Can\'t delete category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3650, 'JLIB_DATABASE_ERROR_DELETE_FAILED', '%s: :delete failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3651, 'JLIB_DATABASE_ERROR_DELETE_ROOT_CATEGORIES', 'Root categories can\'t be deleted.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3652, 'JLIB_DATABASE_ERROR_EMAIL_INUSE', 'This email address is already registered.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3653, 'JLIB_DATABASE_ERROR_EMPTY_ROW_RETURNED', 'The database row is empty.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3654, 'JLIB_DATABASE_ERROR_FUNCTION_FAILED', 'DB function failed with error number %s <br /><span style=\"color: red;\">%s</span>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3655, 'JLIB_DATABASE_ERROR_GET_NEXT_ORDER_FAILED', '%s: :getNextOrder failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3656, 'JLIB_DATABASE_ERROR_GET_TREE_FAILED', '%s: :getTree Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3657, 'JLIB_DATABASE_ERROR_GETNODE_FAILED', '%s: :_getNode Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3658, 'JLIB_DATABASE_ERROR_GETROOTID_FAILED', '%s: :getRootId Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3659, 'JLIB_DATABASE_ERROR_HIT_FAILED', '%s: :hit failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3660, 'JLIB_DATABASE_ERROR_INVALID_LOCATION', '%s: :setLocation - Invalid location.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3661, 'JLIB_DATABASE_ERROR_INVALID_NODE_RECURSION', '%s: :move Failed - Can\'t move the node to be a child of itself.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3662, 'JLIB_DATABASE_ERROR_INVALID_PARENT_ID', 'Invalid parent ID.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3663, 'JLIB_DATABASE_ERROR_LANGUAGE_NO_TITLE', 'The language should have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3664, 'JLIB_DATABASE_ERROR_LANGUAGE_UNIQUE_IMAGE', 'A content language already exists with this Image Prefix.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3665, 'JLIB_DATABASE_ERROR_LANGUAGE_UNIQUE_LANG_CODE', 'A content language already exists with this Language Tag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3666, 'JLIB_DATABASE_ERROR_LANGUAGE_UNIQUE_SEF', 'A content language already exists with this URL Language Code.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3667, 'JLIB_DATABASE_ERROR_LOAD_DATABASE_DRIVER', 'Unable to load Database Driver: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3668, 'JLIB_DATABASE_ERROR_MENUTYPE', 'Some menu items or some menu modules related to this menutype are checked out by another user or the default menu item is in this menu.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3669, 'JLIB_DATABASE_ERROR_MENUTYPE_CHECKOUT', 'The user checking out does not match the user who checked out this menu and/or its linked menu module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3670, 'JLIB_DATABASE_ERROR_MENUTYPE_EMPTY', 'Menu type empty.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3671, 'JLIB_DATABASE_ERROR_MENUTYPE_EXISTS', 'Menu type exists: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3672, 'JLIB_DATABASE_ERROR_MENU_CANNOT_UNSET_DEFAULT', 'The Language parameter for this menu item must be set to \'All\'. At least one Default menu item must have Language set to All, even if the site is multilingual.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3673, 'JLIB_DATABASE_ERROR_MENU_CANNOT_UNSET_DEFAULT_DEFAULT', 'At least one menu item has to be set as Default.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3674, 'JLIB_DATABASE_ERROR_MENU_UNPUBLISH_DEFAULT_HOME', 'Can\'t unpublish default home.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3675, 'JLIB_DATABASE_ERROR_MENU_DEFAULT_CHECKIN_USER_MISMATCH', 'The current home menu for this language is checked out.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3676, 'JLIB_DATABASE_ERROR_MENU_UNIQUE_ALIAS', 'Another menu item with the same parent has this alias.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3677, 'JLIB_DATABASE_ERROR_MENU_UNIQUE_ALIAS_ROOT', 'Another menu item has the same alias in Root. Root is the top level parent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3678, 'JLIB_DATABASE_ERROR_MENU_HOME_NOT_COMPONENT', 'The home menu item must be a component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3679, 'JLIB_DATABASE_ERROR_MENU_HOME_NOT_UNIQUE_IN_MENU', 'A menu should contain only one Default home.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3680, 'JLIB_DATABASE_ERROR_MENU_ROOT_ALIAS_COMPONENT', 'A first level menu item alias can\'t be \'component\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3681, 'JLIB_DATABASE_ERROR_MENU_ROOT_ALIAS_FOLDER', 'A first level menu item alias can\'t be \'%s\' because \'%s\' is a sub-folder of your joomla installation folder.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3682, 'JLIB_DATABASE_ERROR_MOVE_FAILED', '%s: :move failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3683, 'JLIB_DATABASE_ERROR_MUSTCONTAIN_A_TITLE_CATEGORY', 'Category must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3684, 'JLIB_DATABASE_ERROR_MUSTCONTAIN_A_TITLE_EXTENSION', 'Extension must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3685, 'JLIB_DATABASE_ERROR_MUSTCONTAIN_A_TITLE_MODULE', 'Module must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3686, 'JLIB_DATABASE_ERROR_MUSTCONTAIN_A_TITLE_UPDATESITE', 'Update site must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3687, 'JLIB_DATABASE_ERROR_NEGATIVE_NOT_PERMITTED', '%s can\'t be negative.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3688, 'JLIB_DATABASE_ERROR_NO_ROWS_SELECTED', 'No rows selected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3689, 'JLIB_DATABASE_ERROR_NOT_SUPPORTED_FILE_NOT_FOUND', 'Table %s not supported. File not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3690, 'JLIB_DATABASE_ERROR_NULL_PRIMARY_KEY', 'Null primary key not allowed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3691, 'JLIB_DATABASE_ERROR_ORDERDOWN_FAILED', '%s: :orderDown Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3692, 'JLIB_DATABASE_ERROR_ORDERUP_FAILED', '%s: :orderUp Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3693, 'JLIB_DATABASE_ERROR_PLEASE_ENTER_A_USER_NAME', 'Please enter a username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3694, 'JLIB_DATABASE_ERROR_PLEASE_ENTER_YOUR_NAME', 'Please enter your name.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3695, 'JLIB_DATABASE_ERROR_PUBLISH_FAILED', '%s: :publish failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3696, 'JLIB_DATABASE_ERROR_REBUILD_FAILED', '%s: :rebuild Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3697, 'JLIB_DATABASE_ERROR_REBUILDPATH_FAILED', '%s: :rebuildPath Failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3698, 'JLIB_DATABASE_ERROR_REORDER_FAILED', '%s: :reorder failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3699, 'JLIB_DATABASE_ERROR_REORDER_UPDATE_ROW_FAILED', '%s: :reorder update the row %s failed - %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3700, 'JLIB_DATABASE_ERROR_ROOT_NODE_NOT_FOUND', 'Root node not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3701, 'JLIB_DATABASE_ERROR_STORE_FAILED_UPDATE_ASSET_ID', 'The asset_id field could not be updated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3702, 'JLIB_DATABASE_ERROR_STORE_FAILED', '%1$s: :store failed<br />%2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3703, 'JLIB_DATABASE_ERROR_USERGROUP_TITLE', 'User group must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3704, 'JLIB_DATABASE_ERROR_USERGROUP_TITLE_EXISTS', 'User group title already exists. Title must be unique with the same parent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3705, 'JLIB_DATABASE_ERROR_USERLEVEL_NAME_EXISTS', 'Level with the name &quot;%s&quot; already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3706, 'JLIB_DATABASE_ERROR_USERNAME_CANNOT_CHANGE', 'Can\'t use this username.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3707, 'JLIB_DATABASE_ERROR_USERNAME_INUSE', 'Username in use.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3708, 'JLIB_DATABASE_ERROR_VALID_AZ09', 'Please enter a valid username. No space at beginning or end, at least %d characters and must <strong>not</strong> contain the following characters: < > \\ &quot; \' &#37; ; ( ) &.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3709, 'JLIB_DATABASE_ERROR_VALID_MAIL', 'Please enter a valid email address.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3710, 'JLIB_DATABASE_ERROR_VIEWLEVEL', 'Viewlevel must have a title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3711, 'JLIB_DATABASE_FUNCTION_NOERROR', 'DB function reports no errors.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3712, 'JLIB_DATABASE_QUERY_FAILED', 'Database query failed (error # %s): %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3713, 'JLIB_DOCUMENT_ERROR_UNABLE_LOAD_DOC_CLASS', 'Unable to load document class.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3714, 'JLIB_ENVIRONMENT_SESSION_EXPIRED', 'Your session has expired. Please log in again.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3715, 'JLIB_ERROR_INFINITE_LOOP', 'Infinite loop detected in JError.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3716, 'JLIB_EVENT_ERROR_DISPATCHER', 'JEventDispatcher: :register: Event handler not recognised. Handler: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3717, 'JLIB_FILESYSTEM_BZIP_NOT_SUPPORTED', 'BZip2 Not Supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3718, 'JLIB_FILESYSTEM_BZIP_UNABLE_TO_READ', 'Unable to read archive (bz2).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3719, 'JLIB_FILESYSTEM_BZIP_UNABLE_TO_WRITE', 'Unable to write archive (bz2).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3720, 'JLIB_FILESYSTEM_BZIP_UNABLE_TO_WRITE_FILE', 'Unable to write file (bz2).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3721, 'JLIB_FILESYSTEM_GZIP_NOT_SUPPORTED', 'GZlib Not Supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3722, 'JLIB_FILESYSTEM_GZIP_UNABLE_TO_READ', 'Unable to read archive (gz).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3723, 'JLIB_FILESYSTEM_GZIP_UNABLE_TO_WRITE', 'Unable to write archive (gz).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3724, 'JLIB_FILESYSTEM_GZIP_UNABLE_TO_WRITE_FILE', 'Unable to write file (gz).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3725, 'JLIB_FILESYSTEM_GZIP_UNABLE_TO_DECOMPRESS', 'Unable to decompress data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3726, 'JLIB_FILESYSTEM_TAR_UNABLE_TO_READ', 'Unable to read archive (tar).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3727, 'JLIB_FILESYSTEM_TAR_UNABLE_TO_DECOMPRESS', 'Unable to decompress data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3728, 'JLIB_FILESYSTEM_TAR_UNABLE_TO_CREATE_DESTINATION', 'Unable to create destination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3729, 'JLIB_FILESYSTEM_TAR_UNABLE_TO_WRITE_ENTRY', 'Unable to write entry.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3730, 'JLIB_FILESYSTEM_ZIP_NOT_SUPPORTED', 'Zlib Not Supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3731, 'JLIB_FILESYSTEM_ZIP_UNABLE_TO_READ', 'Unable to read archive (zip).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3732, 'JLIB_FILESYSTEM_ZIP_INFO_FAILED', 'Get ZIP Information failed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3733, 'JLIB_FILESYSTEM_ZIP_UNABLE_TO_CREATE_DESTINATION', 'Unable to create destination.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3734, 'JLIB_FILESYSTEM_ZIP_UNABLE_TO_WRITE_ENTRY', 'Unable to write entry.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3735, 'JLIB_FILESYSTEM_ZIP_UNABLE_TO_READ_ENTRY', 'Unable to read entry.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3736, 'JLIB_FILESYSTEM_ZIP_UNABLE_TO_OPEN_ARCHIVE', 'Unable to open archive.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3737, 'JLIB_FILESYSTEM_ZIP_INVALID_ZIP_DATA', 'Invalid ZIP data.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3738, 'JLIB_FILESYSTEM_STREAM_FAILED', 'Failed to register string stream.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3739, 'JLIB_FILESYSTEM_UNKNOWNARCHIVETYPE', 'Unknown Archive type.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3740, 'JLIB_FILESYSTEM_UNABLE_TO_LOAD_ARCHIVE', 'Unable to load archive.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3741, 'JLIB_FILESYSTEM_ERROR_JFILE_FIND_COPY', 'JFile: :copy: Can\'t find or read file: $%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3742, 'JLIB_FILESYSTEM_ERROR_JFILE_STREAMS', 'JFile: :copy(%1$s, %2$s): %3$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3743, 'JLIB_FILESYSTEM_ERROR_COPY_FAILED', 'Copy failed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3744, 'JLIB_FILESYSTEM_DELETE_FAILED', 'Failed deleting %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3745, 'JLIB_FILESYSTEM_CANNOT_FIND_SOURCE_FILE', 'Can\'t find source file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3746, 'JLIB_FILESYSTEM_ERROR_JFILE_MOVE_STREAMS', 'JFile: :move: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3747, 'JLIB_FILESYSTEM_ERROR_RENAME_FILE', 'Rename failed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3748, 'JLIB_FILESYSTEM_ERROR_READ_UNABLE_TO_OPEN_FILE', 'JFile: :read: Unable to open file: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3749, 'JLIB_FILESYSTEM_ERROR_WRITE_STREAMS', 'JFile: :write(%1$s): %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3750, 'JLIB_FILESYSTEM_ERROR_UPLOAD', 'JFile: :upload: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3751, 'JLIB_FILESYSTEM_ERROR_WARNFS_ERR01', 'Warning: Failed to change file permissions!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3752, 'JLIB_FILESYSTEM_ERROR_WARNFS_ERR02', 'Warning: Failed to move file!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3753, 'JLIB_FILESYSTEM_ERROR_WARNFS_ERR03', 'Warning: File %s not uploaded for security reasons!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3754, 'JLIB_FILESYSTEM_ERROR_FIND_SOURCE_FOLDER', 'Can\'t find source folder.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3755, 'JLIB_FILESYSTEM_ERROR_FOLDER_EXISTS', 'Folder already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3756, 'JLIB_FILESYSTEM_ERROR_FOLDER_CREATE', 'Unable to create target folder.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3757, 'JLIB_FILESYSTEM_ERROR_FOLDER_OPEN', 'Unable to open source folder.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3758, 'JLIB_FILESYSTEM_ERROR_FOLDER_LOOP', 'Infinite loop detected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3759, 'JLIB_FILESYSTEM_ERROR_FOLDER_PATH', 'Path not in open_basedir paths.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3760, 'JLIB_FILESYSTEM_ERROR_COULD_NOT_CREATE_DIRECTORY', 'Could not create directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3761, 'JLIB_FILESYSTEM_ERROR_DELETE_BASE_DIRECTORY', 'You can\'t delete a base directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3762, 'JLIB_FILESYSTEM_ERROR_PATH_IS_NOT_A_FOLDER', 'JFolder: :delete: Path is not a folder. Path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3763, 'JLIB_FILESYSTEM_ERROR_FOLDER_DELETE', 'JFolder: :delete: Could not delete folder. Path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3764, 'JLIB_FILESYSTEM_ERROR_FOLDER_RENAME', 'Rename failed: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3765, 'JLIB_FILESYSTEM_ERROR_PATH_IS_NOT_A_FOLDER_FILES', 'JFolder: :files: Path is not a folder. Path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3766, 'JLIB_FILESYSTEM_ERROR_PATH_IS_NOT_A_FOLDER_FOLDER', 'JFolder: :folder: Path is not a folder. Path: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3767, 'JLIB_FILESYSTEM_ERROR_STREAMS_FILE_SIZE', 'Failed to get file size. This may not work for all streams!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3768, 'JLIB_FILESYSTEM_ERROR_STREAMS_FILE_NOT_OPEN', 'File not open.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3769, 'JLIB_FILESYSTEM_ERROR_STREAMS_FILENAME', 'File name not set.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3770, 'JLIB_FILESYSTEM_ERROR_NO_DATA_WRITTEN', 'Warning: No data written.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3771, 'JLIB_FILESYSTEM_ERROR_STREAMS_FAILED_TO_OPEN_WRITER', 'Failed to open writer: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3772, 'JLIB_FILESYSTEM_ERROR_STREAMS_FAILED_TO_OPEN_READER', 'Failed to open reader: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3773, 'JLIB_FILESYSTEM_ERROR_STREAMS_NOT_UPLOADED_FILE', 'Not an uploaded file!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3774, 'JLIB_FORM_BUTTON_CLEAR', 'Clear', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3775, 'JLIB_FORM_BUTTON_SELECT', 'Select', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3776, 'JLIB_FORM_CHANGE_IMAGE', 'Change Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3777, 'JLIB_FORM_CHANGE_IMAGE_BUTTON', 'Change Image Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3778, 'JLIB_FORM_CHANGE_USER', 'Select User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3779, 'JLIB_FORM_ERROR_FIELDS_CATEGORY_ERROR_EXTENSION_EMPTY', 'Extension attribute is empty in the category field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3780, 'JLIB_FORM_ERROR_FIELDS_GROUPEDLIST_ELEMENT_NAME', 'Unknown element type: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3781, 'JLIB_FORM_ERROR_NO_DATA', 'No data', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3782, 'JLIB_FORM_ERROR_VALIDATE_FIELD', 'Invalid xml field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3783, 'JLIB_FORM_ERROR_XML_FILE_DID_NOT_LOAD', 'XML file did not load.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3784, 'JLIB_FORM_FIELD_INVALID', 'Invalid field:&#160', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3785, 'JLIB_FORM_INPUTMODE', 'latin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3786, 'JLIB_FORM_INVALID_FORM_OBJECT', 'Invalid Form Object: :%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3787, 'JLIB_FORM_INVALID_FORM_RULE', 'Invalid Form Rule: :%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3788, 'JLIB_FORM_MEDIA_PREVIEW_ALT', 'Selected image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3789, 'JLIB_FORM_MEDIA_PREVIEW_EMPTY', 'No image selected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3790, 'JLIB_FORM_MEDIA_PREVIEW_SELECTED_IMAGE', 'Selected image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3791, 'JLIB_FORM_MEDIA_PREVIEW_TIP_TITLE', 'Preview', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3792, 'JLIB_FORM_SELECT_USER', 'Select a User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3793, 'JLIB_FORM_VALIDATE_FIELD_INVALID', 'Invalid field: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3794, 'JLIB_FORM_VALIDATE_FIELD_REQUIRED', 'Field required: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3795, 'JLIB_FORM_VALIDATE_FIELD_RULE_MISSING', 'Validation Rule missing: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3796, 'JLIB_FORM_VALUE_CACHE_APC', 'Alternative PHP Cache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3797, 'JLIB_FORM_VALUE_CACHE_CACHELITE', 'Cache_Lite', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3798, 'JLIB_FORM_VALUE_CACHE_EACCELERATOR', 'eAccelerator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3799, 'JLIB_FORM_VALUE_CACHE_FILE', 'File', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3800, 'JLIB_FORM_VALUE_CACHE_MEMCACHE', 'Memcache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3801, 'JLIB_FORM_VALUE_CACHE_MEMCACHED', 'Memcached (Experimental)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3802, 'JLIB_FORM_VALUE_CACHE_REDIS', 'Redis', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3803, 'JLIB_FORM_VALUE_CACHE_WINCACHE', 'Windows Cache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3804, 'JLIB_FORM_VALUE_CACHE_XCACHE', 'XCache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3805, 'JLIB_FORM_VALUE_SESSION_APC', 'Alternative PHP Cache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3806, 'JLIB_FORM_VALUE_SESSION_DATABASE', 'Database', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3807, 'JLIB_FORM_VALUE_SESSION_EACCELERATOR', 'eAccelerator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3808, 'JLIB_FORM_VALUE_SESSION_MEMCACHE', 'Memcache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(3809, 'JLIB_FORM_VALUE_SESSION_MEMCACHED', 'Memcached (Experimental)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3810, 'JLIB_FORM_VALUE_SESSION_NONE', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3811, 'JLIB_FORM_VALUE_SESSION_WINCACHE', 'Windows Cache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3812, 'JLIB_FORM_VALUE_SESSION_XCACHE', 'XCache', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3813, 'JLIB_FORM_VALUE_TIMEZONE_UTC', 'Universal Time, Coordinated (UTC)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3814, 'JLIB_FORM_VALUE_FROM_TEMPLATE', 'From Template', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3815, 'JLIB_FORM_VALUE_INHERITED', 'Inherited', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3816, 'JLIB_HTML_ACCESS_MODIFY_DESC_CAPTION_ACL', 'ACL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3817, 'JLIB_HTML_ACCESS_MODIFY_DESC_CAPTION_TABLE', 'Table', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3818, 'JLIB_HTML_ACCESS_SUMMARY_DESC_CAPTION', 'ACL Summary Table', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3819, 'JLIB_HTML_ACCESS_SUMMARY_DESC', 'Shown below is an overview of the permission settings for this article. Click the tabs above to customise these settings by action.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3820, 'JLIB_HTML_ACCESS_SUMMARY', 'Summary', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3821, 'JLIB_HTML_ADD_TO_ROOT', 'Add to root', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3822, 'JLIB_HTML_ADD_TO_THIS_MENU', 'Add to this menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3823, 'JLIB_HTML_BATCH_ACCESS_LABEL', 'Set Access Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3824, 'JLIB_HTML_BATCH_ACCESS_LABEL_DESC', 'Not making a selection will keep the original access levels when processing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3825, 'JLIB_HTML_BATCH_COPY', 'Copy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3826, 'JLIB_HTML_BATCH_LANGUAGE_LABEL', 'Set Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3827, 'JLIB_HTML_BATCH_LANGUAGE_LABEL_DESC', 'Not making a selection will keep the original language when processing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3828, 'JLIB_HTML_BATCH_LANGUAGE_NOCHANGE', '- Keep original Language -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3829, 'JLIB_HTML_BATCH_MENU_LABEL', 'Select Category for Move/Copy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3830, 'JLIB_HTML_BATCH_MOVE', 'Move', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3831, 'JLIB_HTML_BATCH_NOCHANGE', '- Keep original Access Levels -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3832, 'JLIB_HTML_BATCH_TAG_LABEL', 'Add Tag', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3833, 'JLIB_HTML_BATCH_TAG_LABEL_DESC', 'Add a tag to selected items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3834, 'JLIB_HTML_BATCH_TAG_NOCHANGE', '- Keep original Tags -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3835, 'JLIB_HTML_BATCH_USER_LABEL', 'Set User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3836, 'JLIB_HTML_BATCH_USER_LABEL_DESC', 'Not making a selection will keep the original user when processing.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3837, 'JLIB_HTML_BATCH_USER_NOCHANGE', '- Keep original User -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3838, 'JLIB_HTML_BATCH_USER_NOUSER', 'No User', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3839, 'JLIB_HTML_BEHAVIOR_ABOUT_THE_CALENDAR', 'About the Calendar', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3840, 'JLIB_HTML_BEHAVIOR_CLOSE', 'Close', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3841, 'JLIB_HTML_BEHAVIOR_DATE_SELECTION', 'Date selection:\\n', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3842, 'JLIB_HTML_BEHAVIOR_DISPLAY_S_FIRST', 'Display %s first', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3843, 'JLIB_HTML_BEHAVIOR_DRAG_TO_MOVE', 'Drag to move', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3844, 'JLIB_HTML_BEHAVIOR_GO_TODAY', 'Go to today', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3845, 'JLIB_HTML_BEHAVIOR_GREEN', 'Green', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3846, 'JLIB_HTML_BEHAVIOR_HOLD_MOUSE', '- Hold mouse button on any of the buttons above for faster selection.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3847, 'JLIB_HTML_BEHAVIOR_MONTH_SELECT', '- Use the < and > buttons to select month\\n', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3848, 'JLIB_HTML_BEHAVIOR_NEXT_MONTH_HOLD_FOR_MENU', 'Click to move to the next month. Click and hold for a list of the months.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3849, 'JLIB_HTML_BEHAVIOR_NEXT_YEAR_HOLD_FOR_MENU', 'Click to move to the next year. Click and hold for a list of years.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3850, 'JLIB_HTML_BEHAVIOR_PREV_MONTH_HOLD_FOR_MENU', 'Click to move to the previous month. Click and hold for a list of the months.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3851, 'JLIB_HTML_BEHAVIOR_PREV_YEAR_HOLD_FOR_MENU', 'Click to move to the previous year. Click and hold for a list of years.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3852, 'JLIB_HTML_BEHAVIOR_SELECT_DATE', 'Select a date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3853, 'JLIB_HTML_BEHAVIOR_SHIFT_CLICK_OR_DRAG_TO_CHANGE_VALUE', '(Shift-)Click or Drag to change the value.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3854, 'JLIB_HTML_BEHAVIOR_TIME', 'Time:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3855, 'JLIB_HTML_BEHAVIOR_TODAY', 'Today', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3856, 'JLIB_HTML_BEHAVIOR_TT_DATE_FORMAT', '%a, %b %e', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3857, 'JLIB_HTML_BEHAVIOR_WK', 'wk', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3858, 'JLIB_HTML_BEHAVIOR_YEAR_SELECT', '- Use the « and » buttons to select year\\n', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3859, 'JLIB_HTML_BUTTON_BASE_CLASS', 'Could not load button base class.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3860, 'JLIB_HTML_BUTTON_NO_LOAD', 'Could not load button %s (%s);', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3861, 'JLIB_HTML_BUTTON_NOT_DEFINED', 'Button not defined for type = %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3862, 'JLIB_HTML_CALENDAR', 'Calendar', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3863, 'JLIB_HTML_CHECKED_OUT', 'Checked out', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3864, 'JLIB_HTML_CHECKIN', 'Check-in', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3865, 'JLIB_HTML_CLOAKING', 'This email address is being protected from spambots. You need JavaScript enabled to view it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3866, 'JLIB_HTML_DATE_RELATIVE_DAYS', '%s days ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3867, 'JLIB_HTML_DATE_RELATIVE_DAYS_1', '%s day ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3868, 'JLIB_HTML_DATE_RELATIVE_DAYS_0', '%s days ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3869, 'JLIB_HTML_DATE_RELATIVE_HOURS', '%s hours ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3870, 'JLIB_HTML_DATE_RELATIVE_HOURS_1', '%s hour ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3871, 'JLIB_HTML_DATE_RELATIVE_HOURS_0', '%s hours ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3872, 'JLIB_HTML_DATE_RELATIVE_LESSTHANAMINUTE', 'Less than a minute ago.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3873, 'JLIB_HTML_DATE_RELATIVE_MINUTES', '%s minutes ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3874, 'JLIB_HTML_DATE_RELATIVE_MINUTES_1', '%s minute ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3875, 'JLIB_HTML_DATE_RELATIVE_MINUTES_0', '%s minutes ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3876, 'JLIB_HTML_DATE_RELATIVE_WEEKS', '%s weeks ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3877, 'JLIB_HTML_DATE_RELATIVE_WEEKS_1', '%s week ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3878, 'JLIB_HTML_DATE_RELATIVE_WEEKS_0', '%s weeks ago', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3879, 'JLIB_HTML_EDIT_MENU_ITEM', 'Edit menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3880, 'JLIB_HTML_EDIT_MENU_ITEM_ID', 'Item ID: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3881, 'JLIB_HTML_EDIT_MODULE', 'Edit module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3882, 'JLIB_HTML_EDIT_MODULE_IN_POSITION', 'Position: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3883, 'JLIB_HTML_EDITOR_CANNOT_LOAD', 'Can\'t load the editor.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3884, 'JLIB_HTML_END', 'End', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3885, 'JLIB_HTML_ERROR_FUNCTION_NOT_SUPPORTED', 'Function not supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3886, 'JLIB_HTML_ERROR_NOTFOUNDINFILE', '%s: :%s not found in file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3887, 'JLIB_HTML_ERROR_NOTSUPPORTED_NOFILE', '%s: :%s not supported. File not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3888, 'JLIB_HTML_ERROR_NOTSUPPORTED', '%s: :%s not supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3889, 'JLIB_HTML_MOVE_DOWN', 'Move Down', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3890, 'JLIB_HTML_MOVE_UP', 'Move Up', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3891, 'JLIB_HTML_NO_PARAMETERS_FOR_THIS_ITEM', 'There are no parameters for this item.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3892, 'JLIB_HTML_NO_RECORDS_FOUND', 'No records found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3893, 'JLIB_HTML_PAGE_CURRENT_OF_TOTAL', 'Page %s of %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3894, 'JLIB_HTML_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST', 'Please first make a selection from the list.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3895, 'JLIB_HTML_PUBLISH_ITEM', 'Publish Item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3896, 'JLIB_HTML_PUBLISHED_EXPIRED_ITEM', 'Published, but has Expired.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3897, 'JLIB_HTML_PUBLISHED_FINISHED', 'Finish: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3898, 'JLIB_HTML_PUBLISHED_ITEM', 'Published and is Current.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3899, 'JLIB_HTML_PUBLISHED_PENDING_ITEM', 'Published, but is Pending.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3900, 'JLIB_HTML_PUBLISHED_START', 'Start: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3901, 'JLIB_HTML_RESULTS_OF', 'Results %s - %s of %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3902, 'JLIB_HTML_SAVE_ORDER', 'Save Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3903, 'JLIB_HTML_SELECT_STATE', 'Select State', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3904, 'JLIB_HTML_START', 'Start', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3905, 'JLIB_HTML_UNPUBLISH_ITEM', 'Unpublish Item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3906, 'JLIB_HTML_VIEW_ALL', 'View All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3907, 'JLIB_HTML_SETDEFAULT_ITEM', 'Set default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3908, 'JLIB_HTML_UNSETDEFAULT_ITEM', 'Unset default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3909, 'JLIB_INSTALLER_ABORT', 'Aborting language installation: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3910, 'JLIB_INSTALLER_ABORT_ALREADYINSTALLED', 'Extension is already installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3911, 'JLIB_INSTALLER_ABORT_ALREADY_EXISTS', 'Extension %1$s: Extension %2$s already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3912, 'JLIB_INSTALLER_ABORT_COMP_BUILDADMINMENUS_FAILED', 'Error building Admin Menus.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3913, 'JLIB_INSTALLER_ABORT_COMP_COPY_MANIFEST', 'Component %1$s: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3914, 'JLIB_INSTALLER_ABORT_COMP_COPY_SETUP', 'Component %1$s: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3915, 'JLIB_INSTALLER_ABORT_COMP_FAIL_ADMIN_FILES', 'Component %s: Failed to copy admin files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3916, 'JLIB_INSTALLER_ABORT_COMP_FAIL_SITE_FILES', 'Component %s: Failed to copy site files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3917, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_COPY_SETUP', 'Component Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3918, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_CUSTOM_INSTALL_FAILURE', 'Component Install: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3919, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_MANIFEST', 'Component Install: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3920, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_PHP_INSTALL', 'Component Install: Could not copy PHP install file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3921, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_PHP_UNINSTALL', 'Component Install: Could not copy PHP uninstall file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3922, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_ROLLBACK', 'Component Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3923, 'JLIB_INSTALLER_ABORT_COMP_INSTALL_SQL_ERROR', 'Component Install: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3924, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_ADMIN_ELEMENT', 'Component Update: The XML file did not contain an administration element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3925, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_COPY_SETUP', 'Component Update: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3926, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_MANIFEST', 'Component Update: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3927, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_PHP_INSTALL', 'Component Update: Could not copy PHP install file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3928, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_PHP_UNINSTALL', 'Component Update: Could not copy PHP uninstall file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3929, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_ROLLBACK', 'Component Update: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3930, 'JLIB_INSTALLER_ABORT_COMP_UPDATE_SQL_ERROR', 'Component Update: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3931, 'JLIB_INSTALLER_ABORT_CREATE_DIRECTORY', 'Extension %1$s: Failed to create directory: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3932, 'JLIB_INSTALLER_ABORT_DEBUG', 'Installation unexpectedly terminated:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3933, 'JLIB_INSTALLER_ABORT_DETECTMANIFEST', 'Unable to detect manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3934, 'JLIB_INSTALLER_ABORT_DIRECTORY', 'Extension %1$s: Another %2$s is already using the named directory: %3$s. Are you trying to install the same extension again?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3935, 'JLIB_INSTALLER_ABORT_EXTENSIONNOTVALID', 'Extension is not valid.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3936, 'JLIB_INSTALLER_ABORT_FILE_INSTALL_COPY_SETUP', 'Files Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3937, 'JLIB_INSTALLER_ABORT_FILE_INSTALL_CUSTOM_INSTALL_FAILURE', 'Files Install: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3938, 'JLIB_INSTALLER_ABORT_FILE_INSTALL_FAIL_SOURCE_DIRECTORY', 'Files Install: Failed to find source directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3939, 'JLIB_INSTALLER_ABORT_FILE_INSTALL_ROLLBACK', 'Files Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3940, 'JLIB_INSTALLER_ABORT_FILE_INSTALL_SQL_ERROR', 'Files %1$s: SQL error file %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3941, 'JLIB_INSTALLER_ABORT_FILE_ROLLBACK', 'Files Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3942, 'JLIB_INSTALLER_ABORT_FILE_SAME_NAME', 'Files Install: Another extension with same name already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3943, 'JLIB_INSTALLER_ABORT_FILE_UPDATE_SQL_ERROR', 'Files Update: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3944, 'JLIB_INSTALLER_ABORT_INSTALL_CUSTOM_INSTALL_FAILURE', 'Extension %s: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3945, 'JLIB_INSTALLER_ABORT_LIB_COPY_FILES', 'Library %s: Could not copy files from the source.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3946, 'JLIB_INSTALLER_ABORT_LIB_INSTALL_ALREADY_INSTALLED', 'Library Install: Library already installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3947, 'JLIB_INSTALLER_ABORT_LIB_INSTALL_COPY_SETUP', 'Library Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3948, 'JLIB_INSTALLER_ABORT_LIB_INSTALL_FAILED_TO_CREATE_DIRECTORY', 'Library Install: Failed to create directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3949, 'JLIB_INSTALLER_ABORT_LIB_INSTALL_NOFILE', 'Library Install: No library file specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3950, 'JLIB_INSTALLER_ABORT_LIB_INSTALL_ROLLBACK', 'Library Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3951, 'JLIB_INSTALLER_ABORT_LOAD_DETAILS', 'Failed to load extension details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3952, 'JLIB_INSTALLER_ABORT_MANIFEST', 'Extension %1$s: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3953, 'JLIB_INSTALLER_ABORT_METHODNOTSUPPORTED', 'Method not supported for this extension type.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3954, 'JLIB_INSTALLER_ABORT_METHODNOTSUPPORTED_TYPE', 'Method not supported for this extension type: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3955, 'JLIB_INSTALLER_ABORT_MOD_COPY_FILES', 'Module %s: Could not copy files from the source.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3956, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_COPY_SETUP', 'Module Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3957, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_CREATE_DIRECTORY', 'Module %1$s: Failed to create directory: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3958, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_CUSTOM_INSTALL_FAILURE', 'Module Install: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3959, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_DIRECTORY', 'Module %1$s: Another module is already using directory: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3960, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_MANIFEST', 'Module Install: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3961, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_NOFILE', 'Module %s: No module file specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3962, 'JLIB_INSTALLER_ABORT_MOD_INSTALL_SQL_ERROR', 'Module %1$s: SQL error file %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3963, 'JLIB_INSTALLER_ABORT_MOD_ROLLBACK', 'Module %1$s: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3964, 'JLIB_INSTALLER_ABORT_MOD_UNINSTALL_UNKNOWN_CLIENT', 'Module Uninstall: Unknown client type [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3965, 'JLIB_INSTALLER_ABORT_MOD_UNKNOWN_CLIENT', 'Module %1$s: Unknown client type [%2$s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3966, 'JLIB_INSTALLER_ABORT_NOINSTALLPATH', 'Install path does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3967, 'JLIB_INSTALLER_ABORT_NOUPDATEPATH', 'Update path does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3968, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_COPY_SETUP', 'Package Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3969, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_CREATE_DIRECTORY', 'Package Install: Failed to create directory:%s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3970, 'JLIB_INSTALLER_ABORT_PACKAGE_INSTALL_CUSTOM_INSTALL_FAILURE', 'Package Install: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3971, 'JLIB_INSTALLER_ABORT_PACKAGE_INSTALL_MANIFEST', 'Installation failed: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3972, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_ERROR_EXTENSION', 'Package %1$s: There was an error installing an extension: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3973, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_NO_FILES', 'Package %s: There were no files to install!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3974, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_NO_PACK', 'Package %s: No package file specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3975, 'JLIB_INSTALLER_ABORT_PACK_INSTALL_ROLLBACK', 'Package Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3976, 'JLIB_INSTALLER_ABORT_PLG_COPY_FILES', 'Plugin %s: Could not copy files from the source.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3977, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_ALLREADY_EXISTS', 'Plugin %1$s: Plugin %2$s already exists.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3978, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_COPY_SETUP', 'Plugin %s: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3979, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_CREATE_DIRECTORY', 'Plugin %1$s: Failed to create directory: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3980, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_CUSTOM_INSTALL_FAILURE', 'Plugin Install: Custom install routine failure.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3981, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_DIRECTORY', 'Plugin %1$s: Another plugin is already using directory: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3982, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_MANIFEST', 'Plugin %s: Could not copy PHP manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3983, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_NO_FILE', 'Plugin %s: No plugin file specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3984, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_ROLLBACK', 'Plugin %1$s: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3985, 'JLIB_INSTALLER_ABORT_PLG_INSTALL_SQL_ERROR', 'Plugin %1$s: SQL error file %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3986, 'JLIB_INSTALLER_ABORT_PLG_UNINSTALL_SQL_ERROR', 'Plugin Uninstall: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3987, 'JLIB_INSTALLER_ABORT_REFRESH_MANIFEST_CACHE', 'Refresh Manifest Cache failed: Extension is not currently installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3988, 'JLIB_INSTALLER_ABORT_REFRESH_MANIFEST_CACHE_VALID', 'Refresh Manifest Cache failed: Extension is not valid.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3989, 'JLIB_INSTALLER_ABORT_ROLLBACK', 'Extension %1$s: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3990, 'JLIB_INSTALLER_ABORT_SQL_ERROR', 'Extension %1$s: SQL error processing query: %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3991, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_ALREADY_INSTALLED', 'Template Install: Template already installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3992, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_ANOTHER_TEMPLATE_USING_DIRECTORY', 'Template Install: There is already a Template using the named directory: %s. Are you trying to install the same template again?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3993, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_COPY_FILES', 'Template Install: Could not copy files from the %s source.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3994, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_COPY_SETUP', 'Template Install: Could not copy setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3995, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_FAILED_CREATE_DIRECTORY', 'Template Install: Failed to create directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3996, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_ROLLBACK', 'Template Install: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3997, 'JLIB_INSTALLER_ABORT_TPL_INSTALL_UNKNOWN_CLIENT', 'Template Install: Unknown client type [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3998, 'JLIB_INSTALLER_AVAILABLE_UPDATE_PHP_VERSION', 'For the extension %1$s version %2$s is available, but it requires at least PHP version %3$s while your system only has %4$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(3999, 'JLIB_INSTALLER_PURGED_UPDATES', 'Purged updates', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4000, 'JLIB_INSTALLER_FAILED_TO_PURGE_UPDATES', 'Failed to purge updates.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4001, 'JLIB_INSTALLER_DEFAULT_STYLE', '%s - Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4002, 'JLIB_INSTALLER_DISCOVER', 'Discover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4003, 'JLIB_INSTALLER_ERROR_COMP_DISCOVER_STORE_DETAILS', 'Component Discover install: Failed to store component details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4004, 'JLIB_INSTALLER_ERROR_COMP_FAILED_TO_CREATE_DIRECTORY', 'Component %1$s: Failed to create directory: %2$s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4005, 'JLIB_INSTALLER_ERROR_COMP_INSTALL_ADMIN_ELEMENT', 'Component Install: The XML file did not contain an administration element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4006, 'JLIB_INSTALLER_ERROR_COMP_INSTALL_DIR_ADMIN', 'Component Install: Another component is already using directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4007, 'JLIB_INSTALLER_ERROR_COMP_INSTALL_DIR_SITE', 'Component Install: Another component is already using directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4008, 'JLIB_INSTALLER_ERROR_COMP_INSTALL_FAILED_TO_CREATE_DIRECTORY_ADMIN', 'Component Install: Failed to create admin directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4009, 'JLIB_INSTALLER_ERROR_COMP_INSTALL_FAILED_TO_CREATE_DIRECTORY_SITE', 'Component Install: Failed to create site directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4010, 'JLIB_INSTALLER_ERROR_COMP_REFRESH_MANIFEST_CACHE', 'Component Refresh manifest cache: Failed to store component details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4011, 'JLIB_INSTALLER_ERROR_COMP_REMOVING_ADMIN_MENUS_FAILED', 'Could not delete the Administrator menus.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4012, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_CUSTOM', 'Component Uninstall: Custom Uninstall script unsuccessful.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4013, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_FAILED_DELETE_CATEGORIES', 'Component Uninstall: Unable to delete the component categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4014, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_ERRORREMOVEMANUALLY', 'Component Uninstall: Can\'t uninstall. Please remove manually.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4015, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_ERRORUNKOWNEXTENSION', 'Component Uninstall: Unknown Extension.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4016, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_FAILED_REMOVE_DIRECTORY_ADMIN', 'Component Uninstall: Unable to remove the component admin directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4017, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_FAILED_REMOVE_DIRECTORY_SITE', 'Component Uninstall: Unable to remove the component site directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4018, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_NO_OPTION', 'Component Uninstall: Option field empty, can\'t remove files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4019, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_SQL_ERROR', 'Component Uninstall: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4020, 'JLIB_INSTALLER_ERROR_COMP_UNINSTALL_WARNCORECOMPONENT', 'Component Uninstall: Trying to uninstall a core component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4021, 'JLIB_INSTALLER_ERROR_COMP_UPDATE_FAILED_TO_CREATE_DIRECTORY_ADMIN', 'Component Update: Failed to create admin directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4022, 'JLIB_INSTALLER_ERROR_COMP_UPDATE_FAILED_TO_CREATE_DIRECTORY_SITE', 'Component Update: Failed to create site directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4023, 'JLIB_INSTALLER_ERROR_CREATE_DIRECTORY', 'JInstaller: :Install: Failed to create directory: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4024, 'JLIB_INSTALLER_ERROR_CREATE_FOLDER_FAILED', 'Failed to create directory [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4025, 'JLIB_INSTALLER_ERROR_DEPRECATED_FORMAT', 'Deprecated install format (client=\"both\"), use package installer in future.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4026, 'JLIB_INSTALLER_ERROR_DISCOVER_INSTALL_UNSUPPORTED', 'A %s extension can not be installed using the discover method. Please install this extension from Extension Manager: Install.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4027, 'JLIB_INSTALLER_ERROR_DOWNLOAD_SERVER_CONNECT', 'Error connecting to the server: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4028, 'JLIB_INSTALLER_ERROR_FAIL_COPY_FILE', 'JInstaller: :Install: Failed to copy file %1$s to %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4029, 'JLIB_INSTALLER_ERROR_FAIL_COPY_FOLDER', 'JInstaller: :Install: Failed to copy folder %1$s to %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4030, 'JLIB_INSTALLER_ERROR_FAILED_READING_NETWORK_RESOURCES', 'Failed reading network resource: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4031, 'JLIB_INSTALLER_ERROR_FILE_EXISTS', 'JInstaller: :Install: File already exists %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4032, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_INVALID_MANIFEST', 'Files Uninstall: Invalid manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4033, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Files Uninstall: Manifest file invalid or not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4034, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_LOAD_ENTRY', 'Files Uninstall: Could not load extension entry.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4035, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_LOAD_MANIFEST', 'Files Uninstall: Could not load manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4036, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_SQL_ERROR', 'Files Uninstall: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4037, 'JLIB_INSTALLER_ERROR_FILE_UNINSTALL_WARNCOREFILE', 'File Uninstall: Trying to uninstall core files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4038, 'JLIB_INSTALLER_ERROR_FOLDER_IN_USE', 'Another extension is already using directory [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4039, 'JLIB_INSTALLER_ERROR_LANG_DISCOVER_STORE_DETAILS', 'Language Discover install: Failed to store language details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4040, 'JLIB_INSTALLER_ERROR_LANG_UNINSTALL_DEFAULT', 'This language can\'t be uninstalled as long as it is defined as a default language.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4041, 'JLIB_INSTALLER_ERROR_LANG_UNINSTALL_DIRECTORY', 'Language Uninstall: Unable to remove the specified Language directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4042, 'JLIB_INSTALLER_ERROR_LANG_UNINSTALL_ELEMENT_EMPTY', 'Language Uninstall: Element is empty, can\'t uninstall files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4043, 'JLIB_INSTALLER_ERROR_LANG_UNINSTALL_PATH_EMPTY', 'Language Uninstall: Language path is empty, can\'t uninstall files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4044, 'JLIB_INSTALLER_ERROR_LANG_UNINSTALL_PROTECTED', 'This language can\'t be uninstalled. It is protected in the database (usually en-GB).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4045, 'JLIB_INSTALLER_ERROR_LIB_DISCOVER_STORE_DETAILS', 'Library Discover install: Failed to store library details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4046, 'JLIB_INSTALLER_ERROR_LIB_UNINSTALL_INVALID_MANIFEST', 'Library Uninstall: Invalid manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4047, 'JLIB_INSTALLER_ERROR_LIB_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Library Uninstall: Manifest file invalid or not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4048, 'JLIB_INSTALLER_ERROR_LIB_UNINSTALL_LOAD_MANIFEST', 'Library Uninstall: Could not load manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4049, 'JLIB_INSTALLER_ERROR_LIB_UNINSTALL_WARNCORELIBRARY', 'Library Uninstall: Trying to uninstall a core library.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4050, 'JLIB_INSTALLER_ERROR_LOAD_XML', 'JInstaller: :Install: Failed to load XML File: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4051, 'JLIB_INSTALLER_ERROR_MOD_DISCOVER_STORE_DETAILS', 'Module Discover install: Failed to store module details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4052, 'JLIB_INSTALLER_ERROR_MOD_REFRESH_MANIFEST_CACHE', 'Module Refresh manifest cache: Failed to store module details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4053, 'JLIB_INSTALLER_ERROR_MOD_UNINSTALL_ERRORUNKOWNEXTENSION', 'Module Uninstall: Unknown Extension.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4054, 'JLIB_INSTALLER_ERROR_MOD_UNINSTALL_EXCEPTION', 'Module Uninstall: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4055, 'JLIB_INSTALLER_ERROR_MOD_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Module Uninstall: Manifest file invalid or not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4056, 'JLIB_INSTALLER_ERROR_MOD_UNINSTALL_SQL_ERROR', 'Module Uninstall: SQL error file %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4057, 'JLIB_INSTALLER_ERROR_MOD_UNINSTALL_WARNCOREMODULE', 'Module Uninstall: Trying to uninstall a core module: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4058, 'JLIB_INSTALLER_ERROR_NO_CORE_LANGUAGE', 'No core pack exists for the language [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4059, 'JLIB_INSTALLER_ERROR_NO_FILE', 'JInstaller: :Install: File does not exist %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4060, 'JLIB_INSTALLER_ERROR_NO_LANGUAGE_TAG', 'The package did not specify a language tag. Are you trying to install an old language package?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4061, 'JLIB_INSTALLER_ERROR_NOTFINDJOOMLAXMLSETUPFILE', 'JInstaller: :Install: Can\'t find Joomla XML setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4062, 'JLIB_INSTALLER_ERROR_NOTFINDXMLSETUPFILE', 'JInstaller: :Install: Can\'t find XML setup file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4063, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_INVALID_MANIFEST', 'Package Uninstall: Invalid manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4064, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Package Uninstall: Manifest file invalid or not found: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4065, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_LOAD_MANIFEST', 'Package Uninstall: Could not load manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4066, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_MANIFEST_NOT_REMOVED', 'Package Uninstall: Errors were detected, manifest file not removed!', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4067, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_MISSINGMANIFEST', 'Package Uninstall: Missing manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4068, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_NOT_PROPER', 'Package Uninstall: This extension may have already been uninstalled or might not have been uninstall properly: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4069, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_WARNCOREPACK', 'Package Uninstall: Trying to uninstall core package.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4070, 'JLIB_INSTALLER_ERROR_PLG_DISCOVER_STORE_DETAILS', 'Plugin Discover install: Failed to store plugin details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4071, 'JLIB_INSTALLER_ERROR_PLG_REFRESH_MANIFEST_CACHE', 'Plugin Refresh manifest cache: Failed to store plugin details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4072, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_ERRORUNKOWNEXTENSION', 'Plugin Uninstall: Unknown Extension.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4073, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_FOLDER_FIELD_EMPTY', 'Plugin Uninstall: Folder field empty, can\'t remove files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4074, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_INVALID_MANIFEST', 'Plugin Uninstall: Invalid manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4075, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Plugin Uninstall: Manifest file invalid or not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4076, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_LOAD_MANIFEST', 'Plugin Uninstall: Could not load manifest file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4077, 'JLIB_INSTALLER_ERROR_PLG_UNINSTALL_WARNCOREPLUGIN', 'Plugin Uninstall: Trying to uninstall a core plugin: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4078, 'JLIB_INSTALLER_ERROR_SQL_ERROR', 'JInstaller: :Install: Error SQL %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4079, 'JLIB_INSTALLER_ERROR_SQL_FILENOTFOUND', 'JInstaller: :Install: SQL File not found %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4080, 'JLIB_INSTALLER_ERROR_SQL_READBUFFER', 'JInstaller: :Install: SQL File Buffer Read Error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4081, 'JLIB_INSTALLER_ERROR_TPL_DISCOVER_STORE_DETAILS', 'Template Discover install: Failed to store template details.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4082, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_ERRORUNKOWNEXTENSION', 'Template Uninstall: Unknown Extension.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4083, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_INVALID_CLIENT', 'Template Uninstall: Invalid client.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4084, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_INVALID_NOTFOUND_MANIFEST', 'Template Uninstall: Manifest file invalid or not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4085, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_TEMPLATE_DEFAULT', 'Template Uninstall: Can\'t remove default template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4086, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_TEMPLATE_DIRECTORY', 'Template Uninstall: Directory does not exist, can\'t remove files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4087, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_TEMPLATE_ID_EMPTY', 'Template Uninstall: Template ID is empty, can\'t uninstall files.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4088, 'JLIB_INSTALLER_ERROR_TPL_UNINSTALL_WARNCORETEMPLATE', 'Template Uninstall: Trying to uninstall a core template: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4089, 'JLIB_INSTALLER_ERROR_UNKNOWN_CLIENT_TYPE', 'Unknown Client Type [%s]', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4090, 'JLIB_INSTALLER_INSTALL', 'Install', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4091, 'JLIB_INSTALLER_NOTICE_LANG_RESET_USERS', 'Language set to Default for %d users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4092, 'JLIB_INSTALLER_NOTICE_LANG_RESET_USERS_1', 'Language set to Default for %d user.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4093, 'JLIB_INSTALLER_UNINSTALL', 'Uninstall', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4094, 'JLIB_INSTALLER_UPDATE', 'Update', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4095, 'JLIB_INSTALLER_ERROR_EXTENSION_INVALID_CLIENT_IDENTIFIER', 'Invalid client identifier specified in extension manifest.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4096, 'JLIB_INSTALLER_ERROR_PACK_UNINSTALL_UNKNOWN_EXTENSION', 'Attempting to uninstall unknown extension from package. This extension may have already been removed earlier.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4097, 'JLIB_INSTALLER_NOT_ERROR', 'If the error is related to the installation of TinyMCE language files it has no effect on the installation of the language(s). Some language packs created prior to Joomla! 3.2.0 may try to install separate TinyMCE language files. As these are now included in the core they no longer need to be installed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4098, 'JLIB_INSTALLER_UPDATE_LOG_QUERY', 'Ran query from file %1$s. Query text: %2$s.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4099, 'JLIB_MAIL_FUNCTION_DISABLED', 'The mail() function has been disabled and the mail can\'t be sent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4100, 'JLIB_MAIL_FUNCTION_OFFLINE', 'The mail function has been temporarily disabled on this site, please try again later.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4101, 'JLIB_MAIL_INVALID_EMAIL_SENDER', 'JMail: : Invalid email Sender: %s, JMail: :setSender(%s).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4102, 'JLIB_MEDIA_ERROR_UPLOAD_INPUT', 'Unable to upload file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4103, 'JLIB_MEDIA_ERROR_WARNFILENAME', 'File name must only contain alphanumeric characters and no spaces.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4104, 'JLIB_MEDIA_ERROR_WARNFILETOOLARGE', 'This file is too large to upload.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4105, 'JLIB_MEDIA_ERROR_WARNFILETYPE', 'This file type is not supported.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4106, 'JLIB_MEDIA_ERROR_WARNIEXSS', 'Possible IE XSS Attack found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4107, 'JLIB_MEDIA_ERROR_WARNINVALID_IMG', 'Not a valid image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4108, 'JLIB_MEDIA_ERROR_WARNINVALID_MIME', 'Illegal or invalid mime type detected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4109, 'JLIB_MEDIA_ERROR_WARNNOTADMIN', 'Uploaded file is not an image file and you do not have permission.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4110, 'JLIB_PLUGIN_ERROR_LOADING_PLUGINS', 'Error loading Plugins: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4111, 'JLIB_REGISTRY_EXCEPTION_LOAD_FORMAT_CLASS', 'Unable to load format class.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4112, 'JLIB_RULES_ACTION', 'Action', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4113, 'JLIB_RULES_ALLOWED', 'Allowed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4114, 'JLIB_RULES_ALLOWED_ADMIN', 'Allowed (Super User).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4115, 'JLIB_RULES_CALCULATED_SETTING', 'Calculated Setting <sup>2</sup>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4116, 'JLIB_RULES_CONFLICT', 'Conflict', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4117, 'JLIB_RULES_DENIED', 'Denied', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4118, 'JLIB_RULES_GROUP', '%s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4119, 'JLIB_RULES_GROUPS', 'Groups', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4120, 'JLIB_RULES_INHERIT', 'Inherit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4121, 'JLIB_RULES_INHERITED', 'Inherited', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4122, 'JLIB_RULES_NOT_ALLOWED', 'Not Allowed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4123, 'JLIB_RULES_NOT_ALLOWED_ADMIN_CONFLICT', 'Conflict', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4124, 'JLIB_RULES_NOT_ALLOWED_LOCKED', 'Not Allowed (Locked).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(4125, 'JLIB_RULES_NOT_SET', 'Not Set', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4126, 'JLIB_RULES_SELECT_ALLOW_DENY_GROUP', 'Allow or deny %s for users in the %s group.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4127, 'JLIB_RULES_SELECT_SETTING', 'Select New Setting <sup>1</sup>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4128, 'JLIB_RULES_SETTING_NOTES', '1. If you change the setting, it will apply to this and all child groups, components and content. Note that <em>Denied</em> will overrule any inherited setting and also the setting in any child group, component or content. In the case of a setting conflict, <em>Deny</em> will take precedence. <em>Not Set</em> is equivalent to <em>Denied</em> but can be changed in child groups, components and content.<br />2. If you select a new setting, click <em>Save</em> to refresh the calculated settings.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4129, 'JLIB_RULES_SETTING_NOTES_ITEM', '1. If you change the setting, it will apply to this item. Note that:<br /><em>Inherited</em> means that the permissions from global configuration, parent group and category will be used.<br /><em>Denied</em> means that no matter what the global configuration, parent group or category settings are, the group being edited can\'t take this action on this item.<br /><em>Allowed</em> means that the group being edited will be able to take this action for this item (but if this is in conflict with the global configuration, parent group or category it will have no impact; a conflict will be indicated by <em>Not Allowed (Locked)</em> under Calculated Settings).<br />2. If you select a new setting, click <em>Save</em> to refresh the calculated settings.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4130, 'JLIB_RULES_SETTINGS_DESC', 'Manage the permission settings for the user groups below. See notes at the bottom.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4131, 'JLIB_UNKNOWN', 'Unknown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4132, 'JLIB_UPDATER_ERROR_COLLECTION_FOPEN', 'The PHP allow_url_fopen setting is disabled. This setting must be enabled for the updater to work.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4133, 'JLIB_UPDATER_ERROR_COLLECTION_OPEN_URL', 'Update: :Collection: Could not open %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4134, 'JLIB_UPDATER_ERROR_COLLECTION_PARSE_URL', 'Update: :Collection: Could not parse %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4135, 'JLIB_UPDATER_ERROR_EXTENSION_OPEN_URL', 'Update: :Extension: Could not open %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4136, 'JLIB_UPDATER_ERROR_EXTENSION_PARSE_URL', 'Update: :Extension: Could not parse %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4137, 'JLIB_UPDATER_ERROR_OPEN_UPDATE_SITE', 'Update: Could not open update site #%d &quot;%s&quot;, URL: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4138, 'JLIB_USER_ERROR_AUTHENTICATION_FAILED_LOAD_PLUGIN', 'JAuthentication: :authenticate: Failed to load plugin: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4139, 'JLIB_USER_ERROR_AUTHENTICATION_LIBRARIES', 'JAuthentication: :__construct: Could not load authentication libraries.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4140, 'JLIB_USER_ERROR_BIND_ARRAY', 'Unable to bind array to user object.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4141, 'JLIB_USER_ERROR_CANNOT_DEMOTE_SELF', 'You can\'t remove your own Super User permissions.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4142, 'JLIB_USER_ERROR_CANNOT_REUSE_PASSWORD', 'You can\'t reuse your current password, please enter a new password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4143, 'JLIB_USER_ERROR_ID_NOT_EXISTS', 'JUser: :_load: User %s does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4144, 'JLIB_USER_ERROR_NOT_SUPERADMIN', 'Only users with Super User permissions can change other Super User user accounts.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4145, 'JLIB_USER_ERROR_PASSWORD_NOT_MATCH', 'Passwords do not match. Please re-enter password.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4146, 'JLIB_USER_ERROR_UNABLE_TO_FIND_USER', 'Unable to find a user with given activation string.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4147, 'JLIB_USER_ERROR_UNABLE_TO_LOAD_USER', 'JUser: :_load: Unable to load user with ID: %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4148, 'JLIB_USER_EXCEPTION_ACCESS_USERGROUP_INVALID', 'User group does not exist.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4149, 'JLIB_UTIL_ERROR_APP_INSTANTIATION', 'Application Startup Error.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4150, 'JLIB_UTIL_ERROR_CONNECT_DATABASE', 'JDatabase: :getInstance: Could not connect to database <br />joomla.library: %1$s - %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4151, 'JLIB_UTIL_ERROR_DOMIT', 'DommitDocument is deprecated. Use DomDocument instead.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4152, 'JLIB_UTIL_ERROR_LOADING_FEED_DATA', 'Error loading feed data.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4153, 'JLIB_UTIL_ERROR_XML_LOAD', 'Failed loading XML file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.ini'),
(4154, 'LIB_JOOMLA_XML_DESCRIPTION', 'The Joomla! Platform is the Core of the Joomla! Content Management System.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_joomla.sys.ini'),
(4155, 'LIB_PHPASS_XML_DESCRIPTION', 'phpass is a portable password hashing framework for use in PHP applications. The preferred (most secure) hashing method supported by phpass is the OpenBSD-style bcrypt (known in PHP as CRYPT_BLOWFISH), with a fallback to BSDI-style extended DES-based hashes (known in PHP as CRYPT_EXT_DES) and a last resort fallback to an MD5-based variable iteration count password hashing method implemented in phpass itself.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_phpass.sys.ini'),
(4156, 'LIB_PHPUTF8_XML_DESCRIPTION', 'Classes for UTF-8.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_phputf8.sys.ini'),
(4157, 'LIB_SIMPLEPIE_XML_DESCRIPTION', 'PHP based RSS and Atom Feed Framework.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.lib_simplepie.sys.ini'),
(4158, 'MOD_ARTICLES_ARCHIVE', 'Articles - Archived', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.ini'),
(4159, 'MOD_ARTICLES_ARCHIVE_FIELD_COUNT_LABEL', '# of Months', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.ini'),
(4160, 'MOD_ARTICLES_ARCHIVE_FIELD_COUNT_DESC', 'The number of months to display (the default is 10).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.ini'),
(4161, 'MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION', 'This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.ini'),
(4162, 'MOD_ARTICLES_ARCHIVE_DATE', '%1$s, %2$s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.ini'),
(4163, 'MOD_ARTICLES_ARCHIVE', 'Articles - Archived', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.sys.ini'),
(4164, 'MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION', 'This module shows a list of the calendar months containing Archived Articles. After you have changed the status of an Article to Archived, this list will be automatically generated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.sys.ini'),
(4165, 'MOD_ARTICLES_ARCHIVE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_archive.sys.ini'),
(4166, 'MOD_ARTICLES_CATEGORIES', 'Articles - Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4167, 'MOD_ARTICLES_CATEGORIES_FIELD_COUNT_DESC', 'Select the number of first level subcategories to display. Default is all.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4168, 'MOD_ARTICLES_CATEGORIES_FIELD_COUNT_LABEL', '# First Subcategories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4169, 'MOD_ARTICLES_CATEGORIES_FIELD_MAXLEVEL_DESC', 'Select the maximum level depth for each subcategory. Default is all.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4170, 'MOD_ARTICLES_CATEGORIES_FIELD_MAXLEVEL_LABEL', 'Maximum Level Depth', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4171, 'MOD_ARTICLES_CATEGORIES_FIELD_PARENT_DESC', 'Choose a parent category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4172, 'MOD_ARTICLES_CATEGORIES_FIELD_PARENT_LABEL', 'Parent Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4173, 'MOD_ARTICLES_CATEGORIES_FIELD_SHOW_CHILDREN_DESC', 'Show or hide subcategories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4174, 'MOD_ARTICLES_CATEGORIES_FIELD_SHOW_CHILDREN_LABEL', 'Show Subcategories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4175, 'MOD_ARTICLES_CATEGORIES_FIELD_NUMITEMS_DESC', 'Show or hide number of articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4176, 'MOD_ARTICLES_CATEGORIES_FIELD_NUMITEMS_LABEL', 'Show Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4177, 'MOD_ARTICLES_CATEGORIES_FIELD_SHOW_DESCRIPTION_DESC', 'Show or hide category descriptions.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4178, 'MOD_ARTICLES_CATEGORIES_FIELD_SHOW_DESCRIPTION_LABEL', 'Category Descriptions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4179, 'MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION', 'This module displays a list of categories from one parent category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4180, 'MOD_ARTICLES_CATEGORIES_TITLE_HEADING_LABEL', 'Heading Style', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4181, 'MOD_ARTICLES_CATEGORIES_TITLE_HEADING_DESC', 'Set the heading style to use.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.ini'),
(4182, 'MOD_ARTICLES_CATEGORIES', 'Articles - Categories', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.sys.ini'),
(4183, 'MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION', 'This module displays a list of categories from one parent category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.sys.ini'),
(4184, 'MOD_ARTICLES_CATEGORIES_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_categories.sys.ini'),
(4185, 'MOD_ARTICLES_CATEGORY', 'Articles - Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4186, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEGROUPING_DESC', 'Select how you would like the articles to be grouped.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4187, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEGROUPING_LABEL', 'Article Grouping', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4188, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEGROUPINGDIR_DESC', 'Select the direction you would like the Article Groupings to be ordered by.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4189, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEGROUPINGDIR_LABEL', 'Grouping Direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4190, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEORDERING_DESC', 'Select which field you would like Articles to be ordered by. Featured Ordering should only be used when Filtering Option for Featured Articles is set to \'Only\'.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4191, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEORDERING_LABEL', 'Article Field to Order By', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4192, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEORDERINGDIR_DESC', 'Select the direction you would like Articles to be ordered by.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4193, 'MOD_ARTICLES_CATEGORY_FIELD_ARTICLEORDERINGDIR_LABEL', 'Ordering Direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4194, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHOR_DESC', 'Select one or more authors from the list below.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4195, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHOR_LABEL', 'Authors', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4196, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORALIAS_DESC', 'Select one or more author aliases from the list below.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4197, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORALIAS_LABEL', 'Author Aliases', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4198, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORALIASFILTERING_DESC', 'Select Inclusive to Include the Selected Author Aliases, Exclusive to Exclude the Selected Author Aliases.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4199, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORALIASFILTERING_LABEL', 'Author Alias Filtering Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4200, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORFILTERING_DESC', 'Select Inclusive to Include the Selected Authors, Exclusive to Exclude the Selected Authors.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4201, 'MOD_ARTICLES_CATEGORY_FIELD_AUTHORFILTERING_LABEL', 'Author Filtering Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4202, 'MOD_ARTICLES_CATEGORY_FIELD_CATDEPTH_DESC', 'The number of child category levels to return.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4203, 'MOD_ARTICLES_CATEGORY_FIELD_CATDEPTH_LABEL', 'Category Depth', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4204, 'MOD_ARTICLES_CATEGORY_FIELD_CATEGORY_DESC', 'Please select one or more categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4205, 'MOD_ARTICLES_CATEGORY_FIELD_CATFILTERINGTYPE_DESC', 'Select Inclusive to Include the Selected Categories, Exclusive to Exclude the Selected Categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4206, 'MOD_ARTICLES_CATEGORY_FIELD_CATFILTERINGTYPE_LABEL', 'Category Filtering Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4207, 'MOD_ARTICLES_CATEGORY_FIELD_COUNT_DESC', 'The number of items to display. The default value of 0 will display all articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4208, 'MOD_ARTICLES_CATEGORY_FIELD_COUNT_LABEL', 'Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4209, 'MOD_ARTICLES_CATEGORY_FIELD_DATERANGEFIELD_DESC', 'Select which date field you want the date range to be applied to.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4210, 'MOD_ARTICLES_CATEGORY_FIELD_DATERANGEFIELD_LABEL', 'Date Range Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4211, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFIELD_DESC', 'Select which date field you want to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4212, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFIELD_LABEL', 'Date Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4213, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFIELDFORMAT_DESC', 'Please enter in a valid date format. See: http://php.net/date for formatting information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4214, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFIELDFORMAT_LABEL', 'Date Format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4215, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFILTERING_DESC', 'Select Date Filtering Type.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4216, 'MOD_ARTICLES_CATEGORY_FIELD_DATEFILTERING_LABEL', 'Date Filtering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4217, 'MOD_ARTICLES_CATEGORY_FIELD_ENDDATE_DESC', 'If Date Range is selected above, please enter an End Date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4218, 'MOD_ARTICLES_CATEGORY_FIELD_ENDDATE_LABEL', 'To Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4219, 'MOD_ARTICLES_CATEGORY_FIELD_EXCLUDEDARTICLES_DESC', 'Please enter each Article ID on a new line.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4220, 'MOD_ARTICLES_CATEGORY_FIELD_EXCLUDEDARTICLES_LABEL', 'Article IDs to Exclude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4221, 'MOD_ARTICLES_CATEGORY_FIELD_GROUP_DISPLAY_LABEL', 'Display Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4222, 'MOD_ARTICLES_CATEGORY_FIELD_GROUP_DYNAMIC_LABEL', 'Dynamic Mode Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4223, 'MOD_ARTICLES_CATEGORY_FIELD_GROUP_FILTERING_LABEL', 'Filtering Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4224, 'MOD_ARTICLES_CATEGORY_FIELD_GROUP_GROUPING_LABEL', 'Grouping Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4225, 'MOD_ARTICLES_CATEGORY_FIELD_GROUP_ORDERING_LABEL', 'Ordering Options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4226, 'MOD_ARTICLES_CATEGORY_FIELD_INTROTEXTLIMIT_DESC', 'Please enter in a numeric character limit value. The introtext will be trimmed to the number of characters you enter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4227, 'MOD_ARTICLES_CATEGORY_FIELD_INTROTEXTLIMIT_LABEL', 'Introtext Limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4228, 'MOD_ARTICLES_CATEGORY_FIELD_LINKTITLES_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4229, 'MOD_ARTICLES_CATEGORY_FIELD_LINKTITLES_DESC', 'Linked titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4230, 'MOD_ARTICLES_CATEGORY_FIELD_MODE_DESC', 'Please select the mode you would like to use. If Normal Mode is chosen, then simply configure the module and it will display a static list of Articles on the menu items you assign the module to. If Dynamic Mode is chosen, then you can still configure the module normally, however now the Category option will no longer be used. Instead, the module will dynamically detect whether or not you are on a Category view and will display the list of articles within that Category accordingly. When Dynamic Mode is chosen, it is best to leave the module set to display on all pages, as it will decide whether or not to display anything dynamically.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4231, 'MOD_ARTICLES_CATEGORY_FIELD_MODE_LABEL', 'Mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4232, 'MOD_ARTICLES_CATEGORY_FIELD_MONTHYEARFORMAT_DESC', 'Please enter in a valid date format. See: http://php.net/date for formatting information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4233, 'MOD_ARTICLES_CATEGORY_FIELD_MONTHYEARFORMAT_LABEL', 'Month and Year Display Format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4234, 'MOD_ARTICLES_CATEGORY_FIELD_RELATIVEDATE_DESC', 'If Relative Date is selected above, please enter in a numeric day value. Results will be retrieved relative to the current date and the value you enter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4235, 'MOD_ARTICLES_CATEGORY_FIELD_RELATIVEDATE_LABEL', 'Relative Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4236, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWAUTHOR_DESC', 'Select Show if you would like the author (or author alias instead, if available) to be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4237, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWCATEGORY_DESC', 'Select Show if you would like the category name displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4238, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWCHILDCATEGORYARTICLES_DESC', 'Include or Exclude Articles from Child Categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4239, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWCHILDCATEGORYARTICLES_LABEL', 'Child Category Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4240, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWDATE_DESC', 'Select Show if you would like the date displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4241, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWFEATURED_DESC', 'Select to Show, Hide, or Only display Featured Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4242, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWFEATURED_LABEL', 'Featured Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4243, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWHITS_DESC', 'Select Show if you would like the hits for each article to be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4244, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWHITS_LABEL', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4245, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWINTROTEXT_DESC', 'Select Show if you would like the introtext to be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4246, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWINTROTEXT_LABEL', 'Introtext', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4247, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWONARTICLEPAGE_DESC', 'Select to Show or Hide Article List from Article Pages. This means that the module will only display itself dynamically on Category Pages.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4248, 'MOD_ARTICLES_CATEGORY_FIELD_SHOWONARTICLEPAGE_LABEL', 'Show on Article Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4249, 'MOD_ARTICLES_CATEGORY_FIELD_STARTDATE_DESC', 'If Date Range is selected above, please enter a Starting Date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4250, 'MOD_ARTICLES_CATEGORY_FIELD_STARTDATE_LABEL', 'Start Date Range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4251, 'MOD_ARTICLES_CATEGORY_OPTION_ASCENDING_VALUE', 'Ascending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4252, 'MOD_ARTICLES_CATEGORY_OPTION_CREATED_VALUE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4253, 'MOD_ARTICLES_CATEGORY_OPTION_DATERANGE_VALUE', 'Date Range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4254, 'MOD_ARTICLES_CATEGORY_OPTION_DESCENDING_VALUE', 'Descending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4255, 'MOD_ARTICLES_CATEGORY_OPTION_DYNAMIC_VALUE', 'Dynamic', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4256, 'MOD_ARTICLES_CATEGORY_OPTION_EXCLUDE_VALUE', 'Exclude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4257, 'MOD_ARTICLES_CATEGORY_OPTION_EXCLUSIVE_VALUE', 'Exclusive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4258, 'MOD_ARTICLES_CATEGORY_OPTION_HITS_VALUE', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4259, 'MOD_ARTICLES_CATEGORY_OPTION_ID_VALUE', 'ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4260, 'MOD_ARTICLES_CATEGORY_OPTION_INCLUDE_VALUE', 'Include', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4261, 'MOD_ARTICLES_CATEGORY_OPTION_INCLUSIVE_VALUE', 'Inclusive', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4262, 'MOD_ARTICLES_CATEGORY_OPTION_MODIFIED_VALUE', 'Modified Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4263, 'MOD_ARTICLES_CATEGORY_OPTION_MONTHYEAR_VALUE', 'Month and Year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4264, 'MOD_ARTICLES_CATEGORY_OPTION_NORMAL_VALUE', 'Normal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4265, 'MOD_ARTICLES_CATEGORY_OPTION_OFF_VALUE', 'Off', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4266, 'MOD_ARTICLES_CATEGORY_OPTION_ONLYFEATURED_VALUE', 'Only', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4267, 'MOD_ARTICLES_CATEGORY_OPTION_ORDERING_VALUE', 'Article Manager Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4268, 'MOD_ARTICLES_CATEGORY_OPTION_ORDERINGFEATURED_VALUE', 'Featured Articles Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4269, 'MOD_ARTICLES_CATEGORY_OPTION_RELATIVEDAY_VALUE', 'Relative Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4270, 'MOD_ARTICLES_CATEGORY_OPTION_STARTPUBLISHING_VALUE', 'Start Publishing Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4271, 'MOD_ARTICLES_CATEGORY_OPTION_FINISHPUBLISHING_VALUE', 'Finish Publishing Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4272, 'MOD_ARTICLES_CATEGORY_OPTION_YEAR_VALUE', 'Year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4273, 'MOD_ARTICLES_CATEGORY_READ_MORE', 'Read more: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4274, 'MOD_ARTICLES_CATEGORY_READ_MORE_TITLE', 'Read More ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4275, 'MOD_ARTICLES_CATEGORY_REGISTER_TO_READ_MORE', 'Register to read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4276, 'MOD_ARTICLES_CATEGORY_XML_DESCRIPTION', 'This module displays a list of articles from one or more categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.ini'),
(4277, 'MOD_ARTICLES_CATEGORY', 'Articles - Category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.sys.ini'),
(4278, 'MOD_ARTICLES_CATEGORY_XML_DESCRIPTION', 'This module displays a list of articles from one or more categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.sys.ini'),
(4279, 'MOD_ARTICLES_CATEGORY_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_category.sys.ini'),
(4280, 'MOD_ARTICLES_LATEST', 'Articles - Latest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4281, 'MOD_LATEST_NEWS_FIELD_CATEGORY_DESC', 'Selects Articles from one or more Categories. If no selection will show all categories as default.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4282, 'MOD_LATEST_NEWS_FIELD_COUNT_DESC', 'The number of Articles to display (the default is 5).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4283, 'MOD_LATEST_NEWS_FIELD_COUNT_LABEL', 'Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4284, 'MOD_LATEST_NEWS_FIELD_FEATURED_DESC', 'Show/Hide articles designated as featured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4285, 'MOD_LATEST_NEWS_FIELD_FEATURED_LABEL', 'Featured Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4286, 'MOD_LATEST_NEWS_FIELD_ORDERING_DESC', 'Recently Added First: order the articles using their creation date<br />Recently Modified First: order the articles using their modification date<br />Recently Published First: order the articles using their publication date.<br />Recently Touched First: order the articles using their modification or creation dates.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4287, 'MOD_LATEST_NEWS_FIELD_ORDERING_LABEL', 'Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4288, 'MOD_LATEST_NEWS_FIELD_USER_DESC', 'Filter by author.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4289, 'MOD_LATEST_NEWS_FIELD_USER_LABEL', 'Authors', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4290, 'MOD_LATEST_NEWS_VALUE_ADDED_BY_ME', 'Added or modified by me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4291, 'MOD_LATEST_NEWS_VALUE_ANYONE', 'Anyone', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4292, 'MOD_LATEST_NEWS_VALUE_NOTADDED_BY_ME', 'Not added or modified by me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4293, 'MOD_LATEST_NEWS_VALUE_ONLY_SHOW_FEATURED', 'Only show Featured Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4294, 'MOD_LATEST_NEWS_VALUE_RECENT_ADDED', 'Recently Added First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4295, 'MOD_LATEST_NEWS_VALUE_RECENT_MODIFIED', 'Recently Modified First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4296, 'MOD_LATEST_NEWS_VALUE_RECENT_RAND', 'Random Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4297, 'MOD_LATEST_NEWS_VALUE_RECENT_PUBLISHED', 'Recently Published First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4298, 'MOD_LATEST_NEWS_VALUE_RECENT_TOUCHED', 'Recently Touched First', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4299, 'MOD_LATEST_NEWS_XML_DESCRIPTION', 'This module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.ini'),
(4300, 'MOD_ARTICLES_LATEST', 'Articles - Latest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.sys.ini'),
(4301, 'MOD_LATEST_NEWS_XML_DESCRIPTION', 'This module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.sys.ini'),
(4302, 'MOD_ARTICLES_LATEST_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_latest.sys.ini'),
(4303, 'MOD_ARTICLES_NEWS', 'Articles - Newsflash', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4304, 'MOD_ARTICLES_NEWS_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4305, 'MOD_ARTICLES_NEWS_FIELD_IMAGES_DESC', 'Display Article images.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4306, 'MOD_ARTICLES_NEWS_FIELD_IMAGES_LABEL', 'Show Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4307, 'MOD_ARTICLES_NEWS_FIELD_ITEMS_DESC', 'The number of Articles to display within this module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4308, 'MOD_ARTICLES_NEWS_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4309, 'MOD_ARTICLES_NEWS_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4310, 'MOD_ARTICLES_NEWS_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4311, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4312, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4313, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4314, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4315, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4316, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4317, 'MOD_ARTICLES_NEWS_FIELD_READMORE_DESC', 'If set to Show, the \'Read more ...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4318, 'MOD_ARTICLES_NEWS_FIELD_READMORE_LABEL', '\'Read more ...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4319, 'MOD_ARTICLES_NEWS_FIELD_SEPARATOR_DESC', 'Show separator after last Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4320, 'MOD_ARTICLES_NEWS_FIELD_SEPARATOR_LABEL', 'Show Last Separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4321, 'MOD_ARTICLES_NEWS_FIELD_TITLE_DESC', 'Show or hide the Article title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4322, 'MOD_ARTICLES_NEWS_FIELD_TITLE_LABEL', 'Show Article Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4323, 'MOD_ARTICLES_NEWS_READMORE', 'Read more ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4324, 'MOD_ARTICLES_NEWS_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4325, 'MOD_ARTICLES_NEWS_TITLE_HEADING', 'Header Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4326, 'MOD_ARTICLES_NEWS_TITLE_HEADING_DESCRIPTION', 'Select the desired HTML header level for the Article titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4327, 'MOD_ARTICLES_NEWS_XML_DESCRIPTION', 'The Article Newsflash Module will display a fixed number of Articles from a specific Category or a set of Categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.ini'),
(4328, 'MOD_ARTICLES_NEWS', 'Articles - Newsflash', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.sys.ini'),
(4329, 'MOD_ARTICLES_NEWS_XML_DESCRIPTION', 'The Newsflash Module will display a fixed number of articles from a specific category.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.sys.ini'),
(4330, 'MOD_ARTICLES_NEWS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news.sys.ini'),
(4331, 'MOD_ARTICLES_NEWS_ADV', 'Articles - Newsflash (Advanced)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4332, 'MOD_ARTICLES_NEWS_ADV_XML_DESCRIPTION', 'The Article Newsflash Module will display a fixed number of Articles from a specific Category or a set of Categories. Has more options than default Articles - Newsflash module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4333, 'MOD_ARTICLES_NEWS_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4334, 'MOD_ARTICLES_NEWS_FIELD_IMAGES_DESC', 'Article images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4335, 'MOD_ARTICLES_NEWS_ADV_FIELD_IMAGES_LABEL', 'Content Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4336, 'MOD_ARTICLES_NEWS_FIELD_ITEMS_DESC', 'The number of Articles to display within this module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4337, 'MOD_ARTICLES_NEWS_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4338, 'MOD_ARTICLES_NEWS_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4339, 'MOD_ARTICLES_NEWS_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4340, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOW_TAGS_LABEL', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4341, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOW_TAGS_DESC', 'Show tags for module articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4342, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4343, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4344, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4345, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4346, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4347, 'MOD_ARTICLES_NEWS_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4348, 'MOD_ARTICLES_NEWS_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4349, 'MOD_ARTICLES_NEWS_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4350, 'MOD_ARTICLES_NEWS_FIELD_SEPARATOR_DESC', 'Show separator after last Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4351, 'MOD_ARTICLES_NEWS_FIELD_SEPARATOR_LABEL', 'Show last separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4352, 'MOD_ARTICLES_NEWS_FIELD_TITLE_DESC', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4353, 'MOD_ARTICLES_NEWS_FIELD_TITLE_LABEL', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4354, 'MOD_ARTICLES_NEWS_READMORE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4355, 'MOD_ARTICLES_NEWS_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4356, 'MOD_ARTICLES_ADV_NEWS_TITLE_HEADING', 'Article Title Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4357, 'MOD_ARTICLES_NEWS_TITLE_HEADING_DESCRIPTION', 'Select the desired HTML header level for the Article titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4358, 'MOD_ARTICLES_NEWS_ADV_MASONRY_LABEL', 'Masonry Plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4359, 'MOD_ARTICLES_NEWS_ADV_MASONRY_DESC', 'Masonry Plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4360, 'MOD_ARTICLES_NEWS_FIELD_CUSTOM_LINK_LABEL', 'Custom link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4361, 'MOD_ARTICLES_NEWS_FIELD_CUSTOM_LINK_DESC', 'Please choose if you want to display a custom link after the module title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4362, 'MOD_ARTICLES_NEWS_ADV_FIELD_CUSTOM_LINK_ROUTE_LABEL', 'Custom link route', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4363, 'MOD_ARTICLES_NEWS_ADV_FIELD_CUSTOM_LINK_ROUTE_DESC', 'Please select if you want the custom link to lead to the menu item or custom URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4364, 'MOD_ARTICLES_NEWS_FIELD_CUSTOM_LINK_URL_LABEL', 'Custom link URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4365, 'MOD_ARTICLES_NEWS_FIELD_CUSTOM_LINK_MENU_LABEL', 'Custom Menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4366, 'MOD_ARTICLES_NEWS_FIELD_CUSTOM_LINK_TITLE_LABEL', 'Custom link title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4367, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTRO_IMAGES_LABEL', 'intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4368, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTRO_IMAGES_DESC', 'Select if you want to display article intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4369, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTRO_IMAGES_ALIGN_LABEL', 'Intro image align', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4370, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTRO_IMAGES_ALIGN_DESC', 'Select intro image alignment. Overrides article settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4371, 'COM_MODULES_ITEM_SETTINGS_FIELDSET_LABEL', 'Item Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4372, 'MOD_ARTICLES_NEWS_ADV_FIELD_PUBLISHED_LABEL', 'Published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4373, 'MOD_ARTICLES_NEWS_ADV_FIELD_PUBLISHED_DESC', 'Display item\'s published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4374, 'MOD_ARTICLES_NEWS_ADV_FIELD_CREATEDBY_LABEL', 'Created by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4375, 'MOD_ARTICLES_NEWS_ADV_FIELD_CREATEDBY_DESC', 'Display article\'s author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4376, 'MOD_ARTICLES_NEWS_ADV_FIELD_BOOTSTRAP_LAYOUT_LABEL', 'Bootstrap Layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4377, 'MOD_ARTICLES_NEWS_ADV_FIELD_BOOTSTRAP_LAYOUT_DESC', 'Please choose if you want module to use fixed or fluid bootstrap grid to place articles. Can be used only with \'bootstrapCols\' alternative layout.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4378, 'MOD_ARTICLES_NEWS_ADV_FIELD_COLUMNS_LABEL', 'Columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4379, 'MOD_ARTICLES_NEWS_ADV_FIELD_COLUMNS_DESC', 'Number of columns for \'horizontal\' and \'bootstrapCols\' layouts.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4380, 'MOD_ARTICLES_NEWS_ADV_FIELD_PRETEXT_LABEL', 'Pretext', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4381, 'MOD_ARTICLES_NEWS_ADV_FIELD_PRETEXT_DESC', 'Please input text you want to display before module content. Doesn\'t support any HTML tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4382, 'MOD_ARTICLES_NEWS_ADV_BY', 'by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4383, 'MOD_ARTICLES_NEWS_ADV_FIELD_ARTICLEORDERINGDIR_LABEL', 'Ordering Direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4384, 'MOD_ARTICLES_NEWS_ADV_FIELD_ARTICLEORDERINGDIR_DESC', 'Select the direction you would like Articles to be ordered by.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4385, 'MOD_ARTICLES_NEWS_ADV_OPTION_ASCENDING_VALUE', 'Ascending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4386, 'MOD_ARTICLES_NEWS_ADV_OPTION_DESCENDING_VALUE', 'Descending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4387, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOWCHILDCATEGORYARTICLES_LABEL', 'Child Category Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4388, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOWCHILDCATEGORYARTICLES_DESC', 'Include or Exclude Articles from Child Categories.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4389, 'MOD_ARTICLES_NEWS_ADV_OPTION_INCLUDE_VALUE', 'Include', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4390, 'MOD_ARTICLES_NEWS_ADV_OPTION_EXCLUDE_VALUE', 'Exclude', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4391, 'MOD_ARTICLES_NEWS_ADV_FIELD_CATDEPTH_LABEL', 'Category Depth', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4392, 'MOD_ARTICLES_NEWS_ADV_FIELD_CATDEPTH_DESC', 'The number of child category levels to return.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4393, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOWINTROTEXT_LABEL', 'Introtext', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4394, 'MOD_ARTICLES_NEWS_ADV_FIELD_SHOWINTROTEXT_DESC', 'Select Show if you would like the introtext to be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4395, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTROTEXTLIMIT_LABEL', 'Introtext Limit', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4396, 'MOD_ARTICLES_NEWS_ADV_FIELD_INTROTEXTLIMIT_DESC', 'Please enter in a numeric character limit value. The introtext will be trimmed to the number of characters you enter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.ini'),
(4397, 'MOD_ARTICLES_NEWS_ADV', 'Articles - Newsflash (Advanced)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.sys.ini'),
(4398, 'MOD_ARTICLES_NEWS_ADV_XML_DESCRIPTION', 'The Article Newsflash Module will display a fixed number of Articles from a specific Category or a set of Categories. Has more options than default Articles - Newsflash module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_news_adv.sys.ini'),
(4399, 'MOD_ARTICLES_POPULAR', 'Articles - Most Read', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4400, 'MOD_POPULAR_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4401, 'MOD_POPULAR_FIELD_COUNT_DESC', 'The number of Articles to display (the default is 5).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4402, 'MOD_POPULAR_FIELD_COUNT_LABEL', 'Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4403, 'MOD_POPULAR_FIELD_FEATURED_DESC', 'Show/Hide Articles designated as Featured.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4404, 'MOD_POPULAR_FIELD_FEATURED_LABEL', 'Featured Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4405, 'MOD_POPULAR_XML_DESCRIPTION', 'This module shows a list of the currently published Articles which have the highest number of page views.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4406, 'MOD_POPULAR_FIELD_DATEFIELD_DESC', 'Select which date field you want the date filter to be applied to.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4407, 'MOD_POPULAR_FIELD_DATEFIELD_LABEL', 'Date Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4408, 'MOD_POPULAR_FIELD_DATEFILTERING_DESC', 'Select Date Filtering Type.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4409, 'MOD_POPULAR_FIELD_DATEFILTERING_LABEL', 'Date Filtering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(4410, 'MOD_POPULAR_FIELD_ENDDATE_DESC', 'If Date Range is selected above, please enter an End Date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4411, 'MOD_POPULAR_FIELD_ENDDATE_LABEL', 'End Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4412, 'MOD_POPULAR_FIELD_STARTDATE_DESC', 'If Date Range is selected above, please enter a Starting Date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4413, 'MOD_POPULAR_FIELD_STARTDATE_LABEL', 'Start Date Range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4414, 'MOD_POPULAR_FIELD_RELATIVEDATE_DESC', 'If Relative Date is selected above, please enter a numeric day value. Results will be retrieved relative to the current date and the value you enter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4415, 'MOD_POPULAR_FIELD_RELATIVEDATE_LABEL', 'Relative Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4416, 'MOD_POPULAR_OPTION_CREATED_VALUE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4417, 'MOD_POPULAR_OPTION_DATERANGE_VALUE', 'Date Range', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4418, 'MOD_POPULAR_OPTION_MODIFIED_VALUE', 'Modified Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4419, 'MOD_POPULAR_OPTION_OFF_VALUE', 'Off', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4420, 'MOD_POPULAR_OPTION_RELATIVEDAY_VALUE', 'Relative Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4421, 'MOD_POPULAR_OPTION_STARTPUBLISHING_VALUE', 'Start Publishing Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.ini'),
(4422, 'MOD_ARTICLES_POPULAR', 'Articles - Most Read', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.sys.ini'),
(4423, 'MOD_POPULAR_XML_DESCRIPTION', 'This module shows a list of the currently published Articles which have the highest number of page views.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.sys.ini'),
(4424, 'MOD_ARTICLES_POPULAR_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_popular.sys.ini'),
(4425, 'MOD_ARTICLES_SINGLE', 'Articles - Single', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4426, 'MOD_ARTICLES_SINGLE_XML_DESCRIPTION', 'Articles Single module renders single article specified by ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4427, 'MOD_ARTICLES_SINGLE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4428, 'MOD_ARTICLES_SINGLE_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4429, 'MOD_ARTICLES_SINGLE_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4430, 'MOD_ARTICLES_SINGLE_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4431, 'MOD_ARTICLES_SINGLE_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4432, 'MOD_ARTICLES_SINGLE_FIELD_TITLE_DESC', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4433, 'MOD_ARTICLES_SINGLE_FIELD_TITLE_LABEL', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4434, 'MOD_ARTICLES_SINGLE_READMORE', 'Read more...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4435, 'MOD_ARTICLES_SINGLE_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4436, 'MOD_ARTICLES_SINGLE_TITLE_HEADING', 'Header Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4437, 'MOD_ARTICLES_SINGLE_TITLE_HEADING_DESCRIPTION', 'Articles Single module renders single article specified by ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4438, 'MOD_ARTICLES_SINGLE_FIELD_ART_ID', 'Select Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4439, 'MOD_ARTICLES_SINGLE_FIELD_ART_ID_DESC', 'Select the desired article from the list.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4440, 'MOD_ARTICLES_SINGLE_PUBLISHED_DATE_LABEL', 'Published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4441, 'MOD_ARTICLES_SINGLE_PUBLISHED_DATE_DESC', 'Please select if you want to display article\'s published date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4442, 'MOD_ARTICLES_SINGLE_SHOW_INTRO_IMAGE', 'Intro Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4443, 'MOD_ARTICLES_SINGLE_SHOW_INTRO_IMAGE_DESC', 'Please select if you want to display article intro image.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4444, 'MOD_ARTICLES_SINGLE_FIELD_CUSTOM_LINK_LABEL', 'Custom link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4445, 'MOD_ARTICLES_SINGLE_FIELD_CUSTOM_LINK_DESC', 'Please choose if you want to display a custom link after the module title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4446, 'MOD_ARTICLES_SINGLE_ADV_FIELD_CUSTOM_LINK_ROUTE_LABEL', 'Custom link route', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4447, 'MOD_ARTICLES_SINGLE_ADV_FIELD_CUSTOM_LINK_ROUTE_DESC', 'Please select if you want the custom link to lead to the menu item or custom URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4448, 'MOD_ARTICLES_SINGLE_FIELD_CUSTOM_LINK_URL_LABEL', 'Custom link URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4449, 'MOD_ARTICLES_SINGLE_FIELD_CUSTOM_LINK_MENU_LABEL', 'Custom Menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4450, 'MOD_ARTICLES_SINGLE_FIELD_CUSTOM_LINK_TITLE_LABEL', 'Custom link title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.ini'),
(4451, 'MOD_ARTICLES_SINGLE', 'Articles - Single', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.sys.ini'),
(4452, 'MOD_ARTICLES_SINGLE_XML_DESCRIPTION', 'Articles Single module renders single article specified by ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.sys.ini'),
(4453, 'MOD_ARTICLES_SINGLE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_articles_single.sys.ini'),
(4454, 'COM_BANNERS_NO_CLIENT', '- No client -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4455, 'MOD_BANNERS', 'Banners', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4456, 'MOD_BANNERS_BANNER', 'Banner', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4457, 'MOD_BANNERS_FIELD_BANNERCLIENT_DESC', 'Select banners only from a single client.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4458, 'MOD_BANNERS_FIELD_BANNERCLIENT_LABEL', 'Client', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4459, 'MOD_BANNERS_FIELD_CACHETIME_DESC', 'The time before the module is recached.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4460, 'MOD_BANNERS_FIELD_CACHETIME_LABEL', 'Cache Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4461, 'MOD_BANNERS_FIELD_CATEGORY_DESC', 'Select banners from a specific Category or a set of Categories. If no selection then it will show all categories as default.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4462, 'MOD_BANNERS_FIELD_COUNT_DESC', 'The number of banners to display (default 5).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4463, 'MOD_BANNERS_FIELD_COUNT_LABEL', 'Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4464, 'MOD_BANNERS_FIELD_FOOTER_DESC', 'Text or HTML to display after the group of banners.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4465, 'MOD_BANNERS_FIELD_FOOTER_LABEL', 'Footer Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4466, 'MOD_BANNERS_FIELD_HEADER_DESC', 'Text or HTML to display before the group of banners.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4467, 'MOD_BANNERS_FIELD_HEADER_LABEL', 'Header Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4468, 'MOD_BANNERS_FIELD_RANDOMISE_DESC', 'Randomise the ordering of the banners.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4469, 'MOD_BANNERS_FIELD_RANDOMISE_LABEL', 'Randomise', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4470, 'MOD_BANNERS_FIELD_TAG_DESC', 'Banner is selected by matching the banner tags to the current document meta keywords.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4471, 'MOD_BANNERS_FIELD_TAG_LABEL', 'Search by Meta Keyword', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4472, 'MOD_BANNERS_FIELD_TARGET_DESC', 'Target window when the link is clicked.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4473, 'MOD_BANNERS_FIELD_TARGET_LABEL', 'Target', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4474, 'MOD_BANNERS_VALUE_STICKYORDERING', 'Pinned, Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4475, 'MOD_BANNERS_VALUE_STICKYRANDOMISE', 'Pinned, Randomise', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4476, 'MOD_BANNERS_XML_DESCRIPTION', 'The Banner Module displays the active Banners from the Component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.ini'),
(4477, 'MOD_BANNERS', 'Banners', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.sys.ini'),
(4478, 'MOD_BANNERS_XML_DESCRIPTION', 'The Banner Module displays the active Banners from the Component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.sys.ini'),
(4479, 'MOD_BANNERS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_banners.sys.ini'),
(4480, 'MOD_BOOTSTRAP_COLLAPSE', 'Bootstrap Collapse', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4481, 'MOD_BOOTSTRAP_COLLAPSE_XML_DESCRIPTION', 'The Bootstrap Collapse Module will display a fixed number of Articles from a specific Category or a set of Categories. Has more options than default Articles - Newsflash module. Get base styles and flexible support for collapsible components like accordions and navigation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4482, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4483, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_IMAGES_DESC', 'Display Article images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4484, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_IMAGES_LABEL', 'Show Content Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4485, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ITEMS_DESC', 'The number of Articles to display within this module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4486, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4487, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4488, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4489, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_SHOW_TAGS_LABEL', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4490, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_SHOW_TAGS_DESC', 'Show tags for module articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4491, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4492, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4493, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4494, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4495, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4496, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4497, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4498, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4499, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_SEPARATOR_DESC', 'Show separator after last Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4500, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_SEPARATOR_LABEL', 'Show last separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4501, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_TITLE_DESC', 'Show/hide Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4502, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_TITLE_LABEL', 'Show Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4503, 'MOD_BOOTSTRAP_COLLAPSE_READMORE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4504, 'MOD_BOOTSTRAP_COLLAPSE_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4505, 'MOD_BOOTSTRAP_COLLAPSE_TITLE_HEADING', 'Article Title Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4506, 'MOD_BOOTSTRAP_COLLAPSE_TITLE_HEADING_DESCRIPTION', 'Select the desired HTML header level for the Article titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4507, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_LABEL', 'Custom link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4508, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_DESC', 'Please choose if you want to display a custom link after the module title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4509, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_ROUTE_LABEL', 'Custom link route', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4510, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_ROUTE_DESC', 'Please select if you want the custom link to lead to the menu item or custom URL.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4511, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_URL_LABEL', 'Custom link URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4512, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_MENU_LABEL', 'Custom Menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4513, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CUSTOM_LINK_TITLE_LABEL', 'Custom link title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4514, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_INTRO_IMAGES_LABEL', 'Show intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4515, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_INTRO_IMAGES_DESC', 'Select if you want to display article intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4516, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_INTRO_IMAGES_ALIGN_LABEL', 'Intro image align', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4517, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_INTRO_IMAGES_ALIGN_DESC', 'Select intro image alignment. Overrides article settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4518, 'COM_MODULES_ITEM_SETTINGS_FIELDSET_LABEL', 'Item Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4519, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_PUBLISHED_LABEL', 'Published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4520, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_PUBLISHED_DESC', 'Display item\'s published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4521, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CREATEDBY_LABEL', 'Created by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4522, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_CREATEDBY_DESC', 'Display article\'s author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4523, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_BOOTSTRAP_LAYOUT_LABEL', 'Bootstrap Layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4524, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_BOOTSTRAP_LAYOUT_DESC', 'Please choose if you want module to use fixed or fluid bootstrap grid to place articles. Can be used only with \'bootstrapCols\' alternative layout.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4525, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_COLUMNS_LABEL', 'Columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4526, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_COLUMNS_DESC', 'Number of columns for \'horizontal\' and \'bootstrapCols\' layouts.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4527, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_PRETEXT_LABEL', 'Pretext', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4528, 'MOD_BOOTSTRAP_COLLAPSE_FIELD_PRETEXT_DESC', 'Please input text you want to display before module content. Doesn\'t support any HTML tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4529, 'MOD_BOOTSTRAP_COLLAPSE_BY', 'by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.ini'),
(4530, 'MOD_BOOTSTRAP_COLLAPSE', 'Bootstrap Collapse', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.sys.ini'),
(4531, 'MOD_BOOTSTRAP_COLLAPSE_XML_DESCRIPTION', 'The Bootstrap Collapse Module will display a fixed number of Articles from a specific Category or a set of Categories. Has more options than default Articles - Newsflash module. Get base styles and flexible support for collapsible components like accordions and navigation.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstrap_collapse.sys.ini'),
(4532, 'MOD_BOOTSTRAPTABS', 'Bootstrap Tabs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4533, 'MOD_BOOTSTRAPTABS_XML_DESCRIPTION', 'The Bootstrap Tabs Module will display a fixed number of Articles from a specific Category or a set of Categories. Has Bootstrap Tabs laoyut', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4534, 'MOD_BOOTSTRAPTABS_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4535, 'MOD_BOOTSTRAPTABS_FIELD_IMAGES_DESC', 'Display Article images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4536, 'MOD_BOOTSTRAPTABS_FIELD_IMAGES_LABEL', 'Show Content Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4537, 'MOD_BOOTSTRAPTABS_FIELD_ITEMS_DESC', 'The number of Articles to display within this module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4538, 'MOD_BOOTSTRAPTABS_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4539, 'MOD_BOOTSTRAPTABS_FIELD_SHOW_TAGS_LABEL', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4540, 'MOD_BOOTSTRAPTABS_FIELD_SHOW_TAGS_DESC', 'Show tags for module articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4541, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4542, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4543, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4544, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4545, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4546, 'MOD_BOOTSTRAPTABS_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4547, 'MOD_BOOTSTRAPTABS_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4548, 'MOD_BOOTSTRAPTABS_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4549, 'MOD_BOOTSTRAPTABS_READMORE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4550, 'MOD_BOOTSTRAPTABS_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4551, 'MOD_BOOTSTRAPTABS_FIELD_INTRO_IMAGES_LABEL', 'Show intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4552, 'MOD_BOOTSTRAPTABS_FIELD_INTRO_IMAGES_DESC', 'Select if you want to display article intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4553, 'MOD_BOOTSTRAPTABS_FIELD_INTRO_IMAGES_ALIGN_LABEL', 'Intro image align', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4554, 'MOD_BOOTSTRAPTABS_FIELD_INTRO_IMAGES_ALIGN_DESC', 'Select intro image alignment. Overrides article settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4555, 'COM_MODULES_ITEM_SETTINGS_FIELDSET_LABEL', 'Item Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4556, 'MOD_BOOTSTRAPTABS_FIELD_PUBLISHED_LABEL', 'Published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4557, 'MOD_BOOTSTRAPTABS_FIELD_PUBLISHED_DESC', 'Display item\'s published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4558, 'MOD_BOOTSTRAPTABS_FIELD_CREATEDBY_LABEL', 'Created by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4559, 'MOD_BOOTSTRAPTABS_FIELD_CREATEDBY_DESC', 'Display article\'s author', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4560, 'MOD_BOOTSTRAPTABS_BY', 'by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.ini'),
(4561, 'MOD_BOOTSTRAPTABS', 'Bootstrap Tabs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.sys.ini'),
(4562, 'MOD_BOOTSTRAPTABS_XML_DESCRIPTION', 'The Bootstrap Tabs Module will display a fixed number of Articles from a specific Category or a set of Categories. Has Bootstrap Tabs layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_bootstraptabs.sys.ini'),
(4563, 'MOD_BREADCRUMBS', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4564, 'MOD_BREADCRUMBS_FIELD_HOMETEXT_DESC', 'This text will be shown as Home entry. If the field is left empty, it will use the default value from the mod_breadcrumbs.ini language file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4565, 'MOD_BREADCRUMBS_FIELD_HOMETEXT_LABEL', 'Text for Home Entry', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4566, 'MOD_BREADCRUMBS_FIELD_SEPARATOR_DESC', 'A text separator.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4567, 'MOD_BREADCRUMBS_FIELD_SEPARATOR_LABEL', 'Text Separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4568, 'MOD_BREADCRUMBS_FIELD_SHOWHERE_DESC', 'Show/Hide &quot;You are here&quot; text in the pathway.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4569, 'MOD_BREADCRUMBS_FIELD_SHOWHERE_LABEL', 'Show &quot;You are here&quot;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4570, 'MOD_BREADCRUMBS_FIELD_SHOWHOME_DESC', 'Show/Hide the Home element in the pathway.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4571, 'MOD_BREADCRUMBS_FIELD_SHOWHOME_LABEL', 'Show Home', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4572, 'MOD_BREADCRUMBS_FIELD_SHOWLAST_DESC', 'Show/Hide the last element in the pathway.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4573, 'MOD_BREADCRUMBS_FIELD_SHOWLAST_LABEL', 'Show Last', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4574, 'MOD_BREADCRUMBS_HERE', 'You are here: ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4575, 'MOD_BREADCRUMBS_HOME', 'Home', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4576, 'MOD_BREADCRUMBS_XML_DESCRIPTION', 'This module displays the Breadcrumbs.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.ini'),
(4577, 'MOD_BREADCRUMBS', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.sys.ini'),
(4578, 'MOD_BREADCRUMBS_XML_DESCRIPTION', 'This module displays the Breadcrumbs.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.sys.ini'),
(4579, 'MOD_BREADCRUMBS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_breadcrumbs.sys.ini'),
(4580, 'MOD_CAROUFREDSEL', 'carouFredSel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4581, 'MOD_CAROUFREDSEL_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4582, 'MOD_CAROUFREDSEL_FIELD_IMAGES_DESC', 'Article images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4583, 'MOD_CAROUFREDSEL_FIELD_IMAGES_LABEL', 'Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4584, 'MOD_CAROUFREDSEL_FIELD_ITEMS_DESC', 'The number of Articles to display within this module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4585, 'MOD_CAROUFREDSEL_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4586, 'MOD_CAROUFREDSEL_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4587, 'MOD_CAROUFREDSEL_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4588, 'MOD_CAROUFREDSEL_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4589, 'MOD_CAROUFREDSEL_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4590, 'MOD_CAROUFREDSEL_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4591, 'MOD_CAROUFREDSEL_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4592, 'MOD_CAROUFREDSEL_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4593, 'MOD_CAROUFREDSEL_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4594, 'MOD_CAROUFREDSEL_FIELD_SHOW_TAGS_LABEL', 'Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4595, 'MOD_CAROUFREDSEL_FIELD_SHOW_TAGS_DESC', 'Show tags for module articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4596, 'MOD_CAROUFREDSEL_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4597, 'MOD_CAROUFREDSEL_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4598, 'MOD_CAROUFREDSEL_FIELD_SEPARATOR_DESC', 'Show separator after last Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4599, 'MOD_CAROUFREDSEL_FIELD_SEPARATOR_LABEL', 'Show last separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4600, 'MOD_CAROUFREDSEL_FIELD_TITLE_DESC', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4601, 'MOD_CAROUFREDSEL_FIELD_TITLE_LABEL', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4602, 'MOD_CAROUFREDSEL_READMORE', 'Read more...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4603, 'MOD_CAROUFREDSEL_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4604, 'MOD_CAROUFREDSEL_TITLE_HEADING', 'Header Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4605, 'MOD_CAROUFREDSEL_TITLE_HEADING_DESCRIPTION', 'Select the desired HTML header level for the Article titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4606, 'MOD_CAROUFREDSEL_XML_DESCRIPTION', 'CarouFredSel module is a combination of default Joomla Articles newsflash module and CarouFredSel jQuery plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4607, 'MOD_CAROUFREDSEL_FIELD_PUBLISHED_LABEL', 'Published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4608, 'MOD_CAROUFREDSEL_FIELD_PUBLISHED_DESC', 'Display item\'s published date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4609, 'COM_MODULES_CAROUFREDSEL_FIELDSET_LABEL', 'CarouFredSel Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4610, 'MOD_CAROUFREDSEL_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4611, 'MOD_CAROUFREDSEL_CUSTOM', 'Custom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4612, 'MOD_CAROUFREDSEL_THEME_LABEL', 'Theme', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4613, 'MOD_CAROUFREDSEL_THEME_DESC', 'Please select CarouFredSel module styling. To use \'custom\' option you should have carouFredSel.css style pleaced to your template CSS directory', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4614, 'MOD_CAROUFREDSEL_SCRIPT_LABEL', 'Script', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4615, 'MOD_CAROUFREDSEL_SCRIPT_DESC', 'Please select CarouFredSel script file. To use \'custom\' option you should have jquery.carouFredSel.js style pleaced to your template JS directory', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4616, 'MOD_CAROUFREDSEL_SPEED', 'Speed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4617, 'MOD_CAROUFREDSEL_SPEED_DESC', 'Animation speed in milliseconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4618, 'MOD_CAROUFREDSEL_IMAGE_WIDTH', 'Image Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4619, 'MOD_CAROUFREDSEL_IMAGE_WIDTH_DESC', 'Please set images width in pixels', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4620, 'MOD_CAROUFREDSEL_IMAGE_MARGIN', 'Margin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4621, 'MOD_CAROUFREDSEL_IMAGE_MARGIN_DESC', 'Right image margin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4622, 'MOD_CAROUFREDSEL_IMAGE_BORDER', 'Border', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4623, 'MOD_CAROUFREDSEL_IMAGE_BORDER_DESC', 'Image border width in pixels', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4624, 'MOD_CAROUFREDSEL_MIN_ITEMS', 'Min Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4625, 'MOD_CAROUFREDSEL_MIN_ITEMS_DESC', 'Minimal number of items to display on window resize.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4626, 'MOD_CAROUFREDSEL_CURRENT', 'Current', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4627, 'MOD_CAROUFREDSEL_CURRENT_DESC', 'Index of the current item. When you resize the window, the carousel will make sure this item is visible', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4628, 'MOD_CAROUFREDSEL_ID_LABEL', 'Carousel ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4629, 'MOD_CAROUFREDSEL_ID_DESC', 'Please type a unique carousel identifier. Single word recommended. ', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4630, 'MOD_CAROUFREDSEL_DIRECTION_LABEL', 'Direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4631, 'MOD_CAROUFREDSEL_DIRECTION_DESC', 'Please select carousel direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4632, 'MOD_CAROUFREDSEL_MIN_ITEMS_LABEL', 'Min items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4633, 'MOD_CAROUFREDSEL_MAX_ITEMS_LABEL', 'Max items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4634, 'MOD_CAROUFREDSEL_MAX_ITEMS_DESC', 'Maximal number of items to display. Eqals the number of visible items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4635, 'MOD_CAROUFREDSEL_MAX_WIDTH_LABEL', 'Max item width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4636, 'MOD_CAROUFREDSEL_MAX_WIDTH_DESC', 'Please set maximum item width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4637, 'MOD_CAROUFREDSEL_SPACER_FX_LABEL', 'FX', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4638, 'MOD_CAROUFREDSEL_SPACER_FX_DESC', 'Indicates which effect to use for the transition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4639, 'MOD_CAROUFREDSEL_SPACER_EASING_LABEL', 'Easing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4640, 'MOD_CAROUFREDSEL_SPACER_EASING_DESC', 'Indicates which easing function to use for the transition', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4641, 'MOD_CAROUFREDSEL_DURATION_ITEMS_LABEL', 'Duration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4642, 'MOD_CAROUFREDSEL_DURATION_ITEMS_DESC', 'Please define carousel animatin speed in milliseconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4643, 'MOD_CAROUFREDSEL_NAV_LABEL', 'Navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4644, 'MOD_CAROUFREDSEL_NAV_DESC', 'Please select if you want to display carousel navigation buttons (Prev/Next)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4645, 'MOD_CAROUFREDSEL_PAG_LABEL', 'Pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4646, 'MOD_CAROUFREDSEL_PAG_DESC', 'Please select if you want to display carousel pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4647, 'MOD_CAROUFREDSEL_SPACER_GENERAL_LABEL', '<b>General</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4648, 'MOD_CAROUFREDSEL_SPACER_ITEMS_LABEL', '<b>Items</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4649, 'MOD_CAROUFREDSEL_SPACER_ANIMATION_LABEL', '<b>Animation</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4650, 'MOD_CAROUFREDSEL_SPACER_CONTROLS_LABEL', '<b>Controls</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4651, 'MOD_CAROUFREDSEL_HIDE', 'Hide', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4652, 'MOD_CAROUFREDSEL_SHOW', 'Show', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4653, 'MOD_CAROUFREDSEL_FIELD_INTRO_IMAGES_LABEL', 'Show intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4654, 'MOD_CAROUFREDSEL_FIELD_INTRO_IMAGES_DESC', 'Select if you want to display article intro images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4655, 'MOD_CAROUFREDSEL_FIELD_INTRO_IMAGES_ALIGN_LABEL', 'Intro image align', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4656, 'MOD_CAROUFREDSEL_FIELD_INTRO_IMAGES_ALIGN_DESC', 'Select intro image alignment. Overrides article settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.ini'),
(4657, 'MOD_CAROUFREDSEL', 'carouFredSel', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.sys.ini'),
(4658, 'MOD_CAROUFREDSEL_XML_DESCRIPTION', 'carouFredSel module is a combination of default Joomla Articles newsflash module and carouFredSel jQuery plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.sys.ini'),
(4659, 'MOD_CAROUFREDSEL_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_caroufredsel.sys.ini'),
(4660, 'MOD_COUNTERS', 'Counters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4661, 'MOD_COUNTERS_XML_DESCRIPTION', 'This module allows you to create a countdown timer.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4662, 'MOD_COUNTERS_YEARS', 'Years', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4663, 'MOD_COUNTERS_MONTHS', 'Months', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4664, 'MOD_COUNTERS_DAYS', 'Days', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4665, 'MOD_COUNTERS_HOURS', 'Hours', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4666, 'MOD_COUNTERS_MINUTES', 'Minutes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4667, 'MOD_COUNTERS_SECONDS', 'Seconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.ini'),
(4668, 'MOD_COUNTERS', 'Counters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.sys.ini'),
(4669, 'MOD_COUNTERS_XML_DESCRIPTION', 'This module allows you to create a countdown timer.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.sys.ini'),
(4670, 'MOD_COUNTERS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_counters.sys.ini'),
(4671, 'MOD_CUSTOM', 'Custom HTML', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4672, 'MOD_CUSTOM_FIELD_PREPARE_CONTENT_DESC', 'Optionally prepare the content with the Joomla Content Plugins.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4673, 'MOD_CUSTOM_FIELD_PREPARE_CONTENT_LABEL', 'Prepare Content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4674, 'MOD_CUSTOM_XML_DESCRIPTION', 'This module allows you to create your own HTML Module using a WYSIWYG editor.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4675, 'MOD_CUSTOM_FIELD_BACKGROUNDIMAGE_LABEL', 'Select a Background Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4676, 'MOD_BACKGROUNDIMAGE_FIELD_LOGO_DESC', 'If you select an image here it will automatically be inserted as an inline style for the wrapping div element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.ini'),
(4677, 'MOD_CUSTOM', 'Custom HTML', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.sys.ini'),
(4678, 'MOD_CUSTOM_XML_DESCRIPTION', 'This module allows you to create your own HTML Module using a WYSIWYG editor.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.sys.ini'),
(4679, 'MOD_CUSTOM_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_custom.sys.ini'),
(4680, 'MOD_FEED', 'Feed Display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4681, 'MOD_FEED_ERR_CACHE', 'Please make cache directory writeable.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4682, 'MOD_FEED_ERR_FEED_NOT_RETRIEVED', 'Feed not found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4683, 'MOD_FEED_ERR_NO_URL', 'No feed URL specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4684, 'MOD_FEED_FIELD_DESCRIPTION_DESC', 'Show the description text for the entire feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4685, 'MOD_FEED_FIELD_DESCRIPTION_LABEL', 'Feed Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4686, 'MOD_FEED_FIELD_IMAGE_DESC', 'Show the image associated with the entire feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4687, 'MOD_FEED_FIELD_IMAGE_LABEL', 'Feed Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4688, 'MOD_FEED_FIELD_ITEMDESCRIPTION_DESC', 'Show the description or intro text of individual RSS items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4689, 'MOD_FEED_FIELD_ITEMDESCRIPTION_LABEL', 'Item Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4690, 'MOD_FEED_FIELD_ITEMS_DESC', 'Enter number of RSS items to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4691, 'MOD_FEED_FIELD_ITEMS_LABEL', 'Feed Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4692, 'MOD_FEED_FIELD_RSSTITLE_DESC', 'Display news feed title.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4693, 'MOD_FEED_FIELD_RSSTITLE_LABEL', 'Feed Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4694, 'MOD_FEED_FIELD_RSSURL_DESC', 'Enter the URL of the RSS/RDF/ATOM feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4695, 'MOD_FEED_FIELD_RSSURL_LABEL', 'Feed URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4696, 'MOD_FEED_FIELD_RTL_DESC', 'Display feed in RTL direction.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4697, 'MOD_FEED_FIELD_RTL_LABEL', 'RTL Feed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4698, 'MOD_FEED_FIELD_WORDCOUNT_DESC', 'Allows you to limit the amount of visible Item description text. 0 will show all the text.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4699, 'MOD_FEED_FIELD_WORDCOUNT_LABEL', 'Word Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4700, 'MOD_FEED_XML_DESCRIPTION', 'This module allows the displaying of a syndicated feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.ini'),
(4701, 'MOD_FEED', 'Feed Display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.sys.ini'),
(4702, 'MOD_FEED_XML_DESCRIPTION', 'This module allows the displaying of a syndicated feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.sys.ini'),
(4703, 'MOD_FEED_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_feed.sys.ini'),
(4704, 'COM_FINDER_FILTER_BRANCH_LABEL', 'Search by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4705, 'COM_FINDER_FILTER_SELECT_ALL_LABEL', 'Search All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4706, 'COM_FINDER_ADVANCED_SEARCH', 'Advanced Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4707, 'COM_FINDER_SELECT_SEARCH_FILTER', '- No Filter -', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4708, 'MOD_FINDER', 'Smart Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4709, 'MOD_FINDER_CONFIG_OPTION_BOTTOM', 'Bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4710, 'MOD_FINDER_CONFIG_OPTION_TOP', 'Top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4711, 'MOD_FINDER_FIELDSET_ADVANCED_ALT_DESCRIPTION', 'An alternative label for the search field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4712, 'MOD_FINDER_FIELDSET_ADVANCED_ALT_LABEL', 'Alternative Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4713, 'MOD_FINDER_FIELDSET_ADVANCED_BUTTON_POS_DESCRIPTION', 'The position of the search button relative to the search field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4714, 'MOD_FINDER_FIELDSET_ADVANCED_BUTTON_POS_LABEL', 'Button Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4715, 'MOD_FINDER_FIELDSET_ADVANCED_FIELD_SIZE_DESCRIPTION', 'The width of the search field by character length.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4716, 'MOD_FINDER_FIELDSET_ADVANCED_FIELD_SIZE_LABEL', 'Search Field Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4717, 'MOD_FINDER_FIELDSET_ADVANCED_LABEL_POS_DESCRIPTION', 'The position of the search label relative to the search field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4718, 'MOD_FINDER_FIELDSET_ADVANCED_LABEL_POS_LABEL', 'Label Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4719, 'MOD_FINDER_FIELDSET_ADVANCED_SETITEMID_DESCRIPTION', 'Assign an ItemID by selecting a menu item in the list for the display of the search results if there is no com_finder menu item and a specific display is desired. If you do not know what this means, you may not need it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4720, 'MOD_FINDER_FIELDSET_ADVANCED_SETITEMID_LABEL', 'Set ItemID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4721, 'MOD_FINDER_FIELDSET_ADVANCED_SHOW_BUTTON_DESCRIPTION', 'Toggle whether a button should be displayed for the search form.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4722, 'MOD_FINDER_FIELDSET_ADVANCED_SHOW_BUTTON_LABEL', 'Search Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4723, 'MOD_FINDER_FIELDSET_ADVANCED_SHOW_LABEL_DESCRIPTION', 'Toggle whether a label should be displayed for the search field.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4724, 'MOD_FINDER_FIELDSET_ADVANCED_SHOW_LABEL_LABEL', 'Search Field Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4725, 'MOD_FINDER_FIELDSET_BASIC_AUTOSUGGEST_DESCRIPTION', 'Toggle whether automatic search suggestions should be displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4726, 'MOD_FINDER_FIELDSET_BASIC_AUTOSUGGEST_LABEL', 'Search Suggestions', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4727, 'MOD_FINDER_FIELDSET_BASIC_SEARCHFILTER_DESCRIPTION', 'Selecting a Search Filter will limit any searches submitted through this module to use the selected filter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4728, 'MOD_FINDER_FIELDSET_BASIC_SEARCHFILTER_LABEL', 'Search Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4729, 'MOD_FINDER_FIELDSET_BASIC_SHOW_ADVANCED_DESCRIPTION', 'Toggle whether users should be able to see advanced search options. If set to Link to Component option creates a Smart Search link which redirects to the smart search view. If set to show, the advanced search options will be displayed inline.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4730, 'MOD_FINDER_FIELDSET_BASIC_SHOW_ADVANCED_LABEL', 'Advanced Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4731, 'MOD_FINDER_FIELDSET_BASIC_SHOW_ADVANCED_OPTION_LINK', 'Link to Component', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(4732, 'MOD_FINDER_FIELD_OPENSEARCH_DESCRIPTION', 'Some browsers can add support for your site\'s search if this option is enabled.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4733, 'MOD_FINDER_FIELD_OPENSEARCH_LABEL', 'OpenSearch Autodiscovery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4734, 'MOD_FINDER_FIELD_OPENSEARCH_TEXT_DESCRIPTION', 'Text displayed in supported browsers when adding your site as a search provider.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4735, 'MOD_FINDER_FIELD_OPENSEARCH_TEXT_LABEL', 'OpenSearch title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4736, 'MOD_FINDER_SEARCHBUTTON_TEXT', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4737, 'MOD_FINDER_SEARCH_BUTTON', 'Go', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4738, 'MOD_FINDER_SEARCH_VALUE', 'Search ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4739, 'MOD_FINDER_SELECT_MENU_ITEMID', 'Select a menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4740, 'MOD_FINDER_XML_DESCRIPTION', 'This is a Smart Search module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.ini'),
(4741, 'MOD_FINDER', 'Smart Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.sys.ini'),
(4742, 'MOD_FINDER_XML_DESCRIPTION', 'This is a search module for the Smart Search system.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.sys.ini'),
(4743, 'MOD_FINDER_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_finder.sys.ini'),
(4744, 'MOD_FOOTER', 'Footer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.ini'),
(4745, 'MOD_FOOTER_LINE1', 'Copyright &#169; %date% %sitename%. All Rights Reserved.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.ini'),
(4746, 'MOD_FOOTER_LINE2', '<a href=\"http://www.joomla.org\">Joomla!</a> is Free Software released under the <a href=\"http://www.gnu.org/licenses/gpl-2.0.html\">GNU General Public License.</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.ini'),
(4747, 'MOD_FOOTER_XML_DESCRIPTION', 'This module shows the Joomla! copyright information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.ini'),
(4748, 'MOD_FOOTER', 'Footer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.sys.ini'),
(4749, 'MOD_FOOTER_XML_DESCRIPTION', 'This module shows the Joomla! copyright information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.sys.ini'),
(4750, 'MOD_FOOTER_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_footer.sys.ini'),
(4751, 'ICEMEGAMENU_DESC', '<h2>IceMegaMenu Module</h2>IceMegaMenu extension is a powerful Joomla (module + plugin) to help you take the most from the navigation system. Top features includes ability to split dropdown columns, option to load modules inside the dropdown, works without JavaScript and much more.<br><br><ul><li><a href=http://icetheme.com/Joomla-Extensions/icemegamenu.html>IceMegaMenu Page</a></li><li><a target=_blank href=http://icetheme.com/Forums/IceMegaMenu/>Get Support</a></li></ul></li></ul>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4752, 'ICEMEGAMENU_LABEL', 'IceMegaMenu Paramters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4753, 'SPACER_1', 'General Menu Configuration', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4754, 'SPACER_2', 'Effects Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4755, 'SPACER_3', 'Optional Feature', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4756, 'SELECT_THEME', 'Select Theme', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4757, 'SELECT_THEME_DESC', 'Select the theme style from the list that you want to use.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4758, 'MODULE_CLASS_SUFFIX', 'Module Class Suffix', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4759, 'MODULE_CLASS_SUFFIX_DESC', 'A suffix to be applied to the CSS class of the Module. This allows for individual Module styling.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4760, 'MENU_NAME', 'Select Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4761, 'MENU_NAME_DESC', 'Select a menu from that list that you want to use with the IceMegaMenu extension', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4762, 'TARGET_POSITION', 'Target Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4763, 'TARGET_POSITION_DESC', 'Target Position.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4764, 'MENU_TAG_ID', 'Menu Tag ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4765, 'MENU_TAG_ID_DESC', 'An ID attribute to assign to the root UL tag of the menu (optional)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4766, 'START_LEVEL', 'Start Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4767, 'START_LEVEL_DESC', 'Level to start rendering the menu at. Setting the start and end levels to the same # and setting \'Show Sub-menu Items\' to yes will only display that single level.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4768, 'END_LEVEL', 'End Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4769, 'END_LEVEL_DESC', 'Level to stop rendering the menu at. If you choose \'All\', all levels will be shown depending on \'Show Sub-menu Items\' setting.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4770, 'SHOW_SUB_MENU_ITEMS', 'Expand the menu and make its sub-menu items always visible.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4771, 'MENU_CLASS_SUFFIX', 'Menu Class Suffix', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4772, 'MENU_CLASS_SUFFIX_DESC', 'A suffix to be applied to the CSS class of the Menu Items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4773, 'MENU_EFFECT', 'Menu Effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4774, 'MENU_EFFECT_DESC', 'Select your desired effect from the list to apply a animation style for the module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4775, 'DURATION_OF_THE_EFFECT', 'Duration Effect (ms)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4776, 'DURATION_OF_THE_EFFECT_DESC', 'Duration of the effect in milliseconds.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4777, 'EFFECT_BEHAVES', 'Transition Effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4778, 'EFFECT_BEHAVES_DESC', 'Select a transition effect from the list to animate the dropdown on open/close', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4779, 'MENU_HIDE_DELAY', 'Hide Delay (ms)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4780, 'MENU_HIDE_DELAY_DESC', 'In milliseconds, the time that the dropdown will disappear after you move out the mouse from it', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4781, 'SUBMENUS_OPACITY', 'Submenu Opacity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4782, 'SUBMENUS_OPACITY_DESC', 'Add the opacity value from 1-100.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4783, 'CACHING', 'Caching', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4784, 'CACHING_DESC', 'Select whether to cache the content of this module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4785, 'CACHE_TIME', 'Cache time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4786, 'CACHE_TIME_DESC', 'The maximum length of time in minutes for a cache file to be stored before it is refreshed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4787, 'USE_JAVASCREAPT', 'Use Javascript', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4788, 'USE_JAVASCREAPT_DESC', 'In case you may hassle conflict with the IceMegaMenu module JavaScript or simply you want a more fast loading website you may disable the JavaScript and run the dropdown only with CSS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4789, 'SHOW_MENU_ICONS', 'Show Menu Icons', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4790, 'SHOW_MENU_ICONS_DESC', 'Show Menu Icons.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4791, 'MENU_ICON_ALIGMENT', 'Menu Icon Alignment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4792, 'MENU_ICON_ALIGMENT_DESC', 'Menu Icon Alignment.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4793, 'MENU_ICON_LINK', 'Menu Icon Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4794, 'MENU_ICON_LINK_DESC', 'Menu Icon Link.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4795, 'EXPAND_MENU', 'Expand Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4796, 'EXPAND_MENU_DESC', 'Expand Menu.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4797, 'ACTIVATE_PARENT', 'Activate parent', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4798, 'ACTIVATE_PARENT_DESC', 'Activate parent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4799, 'FULL_ACTIVE_HIGHLIGHTING', 'Full Active highlighting', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4800, 'FULL_ACTIVE_HIGHLIGHTING_DESC', 'Full Active highlighting.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4801, 'INDENT_IMAGE', 'Indent Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4802, 'INDENT_IMAGE_DESC', 'Choose which indent image system to utilise.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4803, 'SPACER', 'Spacer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4804, 'SPACER_DESC', 'Spacer for Horizontal menu.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4805, 'END_SPACER', 'End Spacer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4806, 'END_SPACER_DESC', 'End Spacer for Horizontal menu.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4807, 'ALWAYS_SHOW_SUB_MENU_ITEMS_LABEL', 'Always show</br>submenu items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4808, 'RESIZABLE_MENU', 'Resizable Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4809, 'RESIZABLE_MENU_DESC', 'Enable/Disable the Resizable feature for your icemegamenu module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4810, 'ENABLE_BOOTSTRAP', 'Enable Bootstrap', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4811, 'ENABLE_BOOTSTRAP_DESC', 'Enable or Disable Bootstrap framework for this module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4812, 'ICE_MAIN_MENU', 'Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_icemegamenu.ini'),
(4813, 'MOD_IMAGE_SWOOP', 'Image Swoop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4814, 'MOD_IMAGE_SWOOP_FIELD_CATEGORY_DESC', 'Select Articles from a specific Category or a set of Categories. If no selection will show all categories as default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4815, 'MOD_IMAGE_SWOOP_FIELD_IMAGES_DESC', 'Display Article images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4816, 'MOD_IMAGE_SWOOP_FIELD_IMAGES_LABEL', 'Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4817, 'MOD_IMAGE_SWOOP_FIELD_ITEMS_DESC', 'The number of Articles to display within this module', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4818, 'MOD_IMAGE_SWOOP_FIELD_ITEMS_LABEL', 'Number of Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4819, 'MOD_IMAGE_SWOOP_FIELD_LINKTITLE_DESC', 'Link the Article titles to Articles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4820, 'MOD_IMAGE_SWOOP_FIELD_LINKTITLE_LABEL', 'Linked Titles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4821, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4822, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4823, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_CREATED_DATE', 'Created Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4824, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_PUBLISHED_DATE', 'Published Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4825, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_ORDERING', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4826, 'MOD_IMAGE_SWOOP_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4827, 'MOD_IMAGE_SWOOP_FIELD_READMORE_DESC', 'If set to Show, the \'Read more...\' link will show if Main text has been provided for an Article.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4828, 'MOD_IMAGE_SWOOP_FIELD_READMORE_LABEL', '\'Read more...\' Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4829, 'MOD_IMAGE_SWOOP_FIELD_SEPARATOR_DESC', 'Show separator after last Article', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4830, 'MOD_IMAGE_SWOOP_FIELD_SEPARATOR_LABEL', 'Show last separator', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4831, 'MOD_IMAGE_SWOOP_FIELD_TITLE_DESC', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4832, 'MOD_IMAGE_SWOOP_FIELD_TITLE_LABEL', 'Article title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4833, 'MOD_IMAGE_SWOOP_FIELD_PUBLISHED_LABEL', 'Publish date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4834, 'MOD_IMAGE_SWOOP_FIELD_PUBLISHED_DESC', 'Please select if you want to display article publish date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4835, 'MOD_IMAGE_SWOOP_READMORE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4836, 'MOD_IMAGE_SWOOP_READMORE_REGISTER', 'Register to Read More', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4837, 'MOD_IMAGE_SWOOP_FIELD_ITEM_URL', 'Item URLs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4838, 'MOD_IMAGE_SWOOP_FIELD_ITEM_URL_DESC', 'Please define slides URLs. Type URLs separated by semicolon(;)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4839, 'MOD_IMAGE_SWOOP_FIELD_TARGET_LABEL', 'URL target', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4840, 'MOD_IMAGE_SWOOP_FIELD_TARGET_DESC', 'Please select slide URL target', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4841, 'MOD_IMAGE_SWOOP_TITLE_HEADING', 'Header Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4842, 'MOD_IMAGE_SWOOP_TITLE_HEADING_DESCRIPTION', 'Select the desired HTML header level for the Article titles.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4843, 'MOD_IMAGE_SWOOP_XML_DESCRIPTION', 'Image Swoop module is a combination of default Joomla Articles newsflash module and Camera Slideshow jQuery plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4844, 'COM_MODULES_SLIDESHOW_FIELDSET_LABEL', 'Image Swoop Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4845, 'MOD_IMAGE_SWOOP_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4846, 'MOD_IMAGE_SWOOP_CUSTOM', 'Custom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4847, 'MOD_IMAGE_SWOOP_MINIFIED', 'Minified', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4848, 'MOD_IMAGE_SWOOP_THEME', 'Theme', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4849, 'MOD_IMAGE_SWOOP_THEME_DESC', 'Please select Image Swoop styling. To use \'custom\' option you should have camera.css style pleaced to your template CSS directory', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4850, 'MOD_IMAGE_SWOOP_SCRIPT', 'Script', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4851, 'MOD_IMAGE_SWOOP_SCRIPT_DESC', 'Select the script you want to load. To use custom option you should have camera.js file located in the templates/your_template/js directory', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4852, 'MOD_IMAGE_SWOOP_SKIN', 'Color skin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4853, 'MOD_IMAGE_SWOOP_SKIN_DESC', 'Please select slider color skin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4854, 'MOD_IMAGE_SWOOP_ALIGNEMENT', 'Alignement', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4855, 'MOD_IMAGE_SWOOP_ALIGNEMENT_DESC', 'Select slider alignement', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4856, 'MOD_IMAGE_SWOOP_SLIDESHOW_ADVANCE', 'Advance', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4857, 'MOD_IMAGE_SWOOP_SLIDESHOW_ADVANCE_DESC', 'Select if you want to enable or disable automatic slides change', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4858, 'MOD_IMAGE_SWOOP_SLIDESHOW_MOBILE_ADVANCE', 'Mobile Advance', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4859, 'MOD_IMAGE_SWOOP_SLIDESHOW_MOBILE_ADVANCE_DESC', 'Advance option for mobile devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4860, 'MOD_IMAGE_SWOOP_BAR_DIRECTION', 'Bar direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4861, 'MOD_IMAGE_SWOOP_BAR_DIRECTION_DESC', 'Select loading bar animation direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4862, 'MOD_IMAGE_SWOOP_BAR_POSITION', 'Bar position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4863, 'MOD_IMAGE_SWOOP_BAR_POSITION_DESC', 'Select loading bar position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4864, 'MOD_IMAGE_SWOOP_COLS', 'Cols', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4865, 'MOD_IMAGE_SWOOP_COLS_DESC', 'Animation columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4866, 'MOD_IMAGE_SWOOP_ROWS', 'Rows', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4867, 'MOD_IMAGE_SWOOP_ROWS_DESC', 'Animation rows', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4868, 'MOD_IMAGE_SWOOP_SLICED_COLS', 'Sliced cols', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4869, 'MOD_IMAGE_SWOOP_SLICED_COLS_DESC', 'Sliced animation cols. If 0 the same value of cols', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4870, 'MOD_IMAGE_SWOOP_SLICED_ROWS', 'Sliced rows', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4871, 'MOD_IMAGE_SWOOP_SLICED_ROWS_DESC', 'Sliced animation rows. If 0 the same value of rows', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4872, 'MOD_IMAGE_SWOOP_EASING', 'Easing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4873, 'MOD_IMAGE_SWOOP_EASING_DESC', 'Select easing animation effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4874, 'MOD_IMAGE_SWOOP_MOBILE_EASING', 'Mobile Easing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4875, 'MOD_IMAGE_SWOOP_MOBILE_EASING_DESC', 'Select easing animation effect for mobile devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4876, 'MOD_IMAGE_SWOOP_FX', 'FX', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4877, 'MOD_IMAGE_SWOOP_FX_DESC', 'Select FX animation effect. Avaibale options:<br/>	random,<br/>	simpleFade,<br/>	curtainTopLeft,<br/>	curtainTopRight,<br/>	curtainBottomLeft,<br/>	curtainBottomRight,<br/>	curtainSliceLeft,<br/>	curtainSliceRight,<br/>	blindCurtainTopLeft,<br/>	blindCurtainTopRight,<br/>	blindCurtainBottomLeft,<br/>	blindCurtainBottomRight,<br/>	blindCurtainSliceBottom,<br/>	blindCurtainSliceTop,<br/>	stampede,<br/>	mosaic,<br/>	mosaicReverse,<br/>	mosaicRandom,<br/>	mosaicSpiral,<br/>	mosaicSpiralReverse,<br/>	topLeftBottomRight,<br/>	bottomRightTopLeft,<br/>	bottomLeftTopRight,<br/>	bottomLeftTopRight	<br/>	<br/>	//you can also use more than one effect, just separate them with commas: simpleFade, scrollRight, scrollBottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4878, 'MOD_IMAGE_SWOOP_FX_SET', 'FX Set', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4879, 'MOD_IMAGE_SWOOP_FX_SET_DESC', 'Select if you want to use multiple FX options', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4880, 'MOD_IMAGE_SWOOP_MOBILE_FX', 'FX Mobile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4881, 'MOD_IMAGE_SWOOP_MOBILE_FX_DESC', 'Select FX animation effect for mobile devices. Leave empty if you want to display the same effect on mobile devices and on desktop etc', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4882, 'MOD_IMAGE_SWOOP_GRID_DIFF', 'Grid difference', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4883, 'MOD_IMAGE_SWOOP_GRID_DIFF_DESC', 'To make the grid blocks slower than the slices, this value must be smaller than transPeriod', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4884, 'MOD_IMAGE_SWOOP_HEIGHT', 'Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4885, 'MOD_IMAGE_SWOOP_HEIGHT_DESC', 'Slideshow height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4886, 'MOD_IMAGE_SWOOP_IMAGE_PATH', 'Camera Image path', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4887, 'MOD_IMAGE_SWOOP_IMAGE_PATH_DESC', 'Choose camera slider images path.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4888, 'MOD_IMAGE_SWOOP_HOVER', 'Pause on Hover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4889, 'MOD_IMAGE_SWOOP_HOVER_DESC', 'Pause on state hover. Not available for mobile devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4890, 'MOD_IMAGE_SWOOP_LOADER', 'Loader', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4891, 'MOD_IMAGE_SWOOP_LOADER_DESC', 'Select slideshow loading icon', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4892, 'MOD_IMAGE_SWOOP_PIE_DIAMETER', 'Pie diameter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4893, 'MOD_IMAGE_SWOOP_PIE_DIAMETER_DESC', 'Set pie loading icon diameter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4894, 'MOD_IMAGE_SWOOP_PIE_POSITION', 'Pie position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4895, 'MOD_IMAGE_SWOOP_PIE_POSITION_DESC', 'Select pie loading icon position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4896, 'MOD_IMAGE_SWOOP_LOADER_COLOR', 'Loader color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4897, 'MOD_IMAGE_SWOOP_LOADER_COLOR_DESC', 'Select loading icon color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4898, 'MOD_IMAGE_SWOOP_LOADER_BG_COLOR', 'Loader BG color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4899, 'MOD_IMAGE_SWOOP_LOADER_BG_COLOR_DESC', 'Select loading icon background color', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4900, 'MOD_IMAGE_SWOOP_LOADER_OPACITY', 'Loader opacity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4901, 'MOD_IMAGE_SWOOP_LOADER_OPACITY_DESC', 'Loading icon opacity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4902, 'MOD_IMAGE_SWOOP_LOADER_PADDING', 'Loader padding', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4903, 'MOD_IMAGE_SWOOP_LOADER_PADDING_DESC', 'How many empty pixels you want to display between the loader and its background', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4904, 'MOD_IMAGE_SWOOP_LOADER_STROKE', 'Loader stroke', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4905, 'MOD_IMAGE_SWOOP_LOADER_STROKE_DESC', 'The thickness both of the pie loader and of the bar loader. Remember: for the pie, the loader thickness must be less than a half of the pie diameter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4906, 'MOD_IMAGE_SWOOP_LOADER_MIN_HEIGHT', 'Min height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4907, 'MOD_IMAGE_SWOOP_LOADER_MIN_HEIGHT_DESC', 'Slider minimal height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4908, 'MOD_IMAGE_SWOOP_NAVIGATION', 'Navigation and controls', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4909, 'MOD_IMAGE_SWOOP_NAVIGATION_DESC', 'Select if you want to display animation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4910, 'MOD_IMAGE_SWOOP_NAV_ON_HOVER', 'Navigation on hover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4911, 'MOD_IMAGE_SWOOP_NAV_ON_HOVER_DESC', 'Select if you wantr to display navigation only on hover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4912, 'MOD_IMAGE_SWOOP_MOBILE_NAV_HOVER', 'Navigation on hover(Mobile)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4913, 'MOD_IMAGE_SWOOP_MOBILE_NAV_HOVER_DESC', 'Display navigation only on hover for mobile devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4914, 'MOD_IMAGE_SWOOP_OPACITY_ON_GRID', 'Opacity on grid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4915, 'MOD_IMAGE_SWOOP_OPACITY_ON_GRID_DESC', 'Decide to apply a fade effect to blocks and slices: if your slideshow is fullscreen or simply big, we recommend to set it false to have a smoother effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4916, 'MOD_IMAGE_SWOOP_OVERLAYER', 'Overlayer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4917, 'MOD_IMAGE_SWOOP_OVERLAYER_DESC', 'Decide to put a layer on the images to prevent the users grab them simply by clicking the right button of their mouse', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4918, 'MOD_IMAGE_SWOOP_PATTERN', 'Overlay image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4919, 'MOD_IMAGE_SWOOP_PATTERN_DESC', 'Please select overlayer image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4920, 'MOD_IMAGE_SWOOP_PAGINATION', 'Pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4921, 'MOD_IMAGE_SWOOP_PAGINATION_DESC', 'Select if you want to display slider pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4922, 'MOD_IMAGE_SWOOP_THUMB_PAGINATION', 'Thumbnail Pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4923, 'MOD_IMAGE_SWOOP_THUMB_PAGINATION_DESC', 'Please select if you want to display thumbnail pagination', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4924, 'MOD_IMAGE_SWOOP_PLAY_PAUSE', 'Play/pause', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4925, 'MOD_IMAGE_SWOOP_PLAY_PAUSE_DESC', 'Select if you want to display play and pause buttons', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4926, 'MOD_IMAGE_SWOOP_PAUSE_ON_CLICK', 'Pause on click', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4927, 'MOD_IMAGE_SWOOP_PAUSE_ON_CLICK_DESC', 'Select if you want to stop slider clicking on it', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4928, 'MOD_IMAGE_SWOOP_PORTRAIT', 'Portrait', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4929, 'MOD_IMAGE_SWOOP_PORTRAIT_DESC', 'Select if your slider is in portrait format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4930, 'MOD_IMAGE_SWOOP_SLIDE_ON', 'Slide on', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4931, 'MOD_IMAGE_SWOOP_SLIDE_ON_DESC', 'Decide if the transition effect will be applied to the current (prev) or the next slide', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4932, 'MOD_IMAGE_SWOOP_THUMBNAILS', 'Thumbnails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4933, 'MOD_IMAGE_SWOOP_THUMBNAILS_DESC', 'Select if you ewant to display slider thumbnails. Uploaded XSmall images will be displayed as slider thumbnails', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4934, 'MOD_IMAGE_SWOOP_TIME', 'Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4935, 'MOD_IMAGE_SWOOP_TIME_DESC', 'Milliseconds between the end of the sliding effect and the start of the nex one', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4936, 'MOD_IMAGE_SWOOP_TRANS_PERIOD', 'Transition period', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4937, 'MOD_IMAGE_SWOOP_TRANS_PERIOD_DESC', 'Length of the sliding effect in milliseconds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4938, 'MOD_IMAGE_SWOOP_GENERAL', '<b>General</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4939, 'MOD_IMAGE_SWOOP_LOADING', '<b>Loading</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4940, 'MOD_IMAGE_SWOOP_NAVIGATION_SP', '<b>Navigation and controls</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4941, 'MOD_IMAGE_SWOOP_ANIMATION', '<b>Animation</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4942, 'MOD_IMAGE_SWOOP_CAPTION_EFFECT', 'Caption Animation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4943, 'MOD_IMAGE_SWOOP_CAPTION_EFFECT_DESC', 'Select caption animation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4944, 'MOD_IMAGE_SWOOP_CAPTION', '<b>Caption Settings</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4945, 'MOD_IMAGE_SWOOP_SHOW_CAPTION', 'Display Caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4946, 'MOD_IMAGE_SWOOP_SHOW_CAPTION_DESC', 'PLease select if you want to display caption', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4947, 'MOD_IMAGE_SWOOP_LOAD_EASING', 'Load easing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4948, 'MOD_IMAGE_SWOOP_LOAD_EASING_DESC', 'Load easing library (set false if it is loaded from the template files)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4949, 'MOD_IMAGE_SWOOP_LOAD_JQERY_MOBILE', 'Load jQuery mobile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4950, 'MOD_IMAGE_SWOOP_LOAD_JQERY_MOBILE_DESC', 'Load jQuery mobile ((set false if it is loaded from the template files))', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.ini'),
(4951, 'MOD_IMAGE_SWOOP', 'Image Swoop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.sys.ini'),
(4952, 'MOD_IMAGE_SWOOP_XML_DESCRIPTION', 'Image Swoop module is a combination of default Joomla Articles newsflash module and Camera Slideshow jQuery plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.sys.ini'),
(4953, 'MOD_IMAGE_SWOOP_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_image_swoop.sys.ini'),
(4954, 'MOD_LANGUAGES', 'Language Switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4955, 'MOD_LANGUAGES_FIELD_ACTIVE_DESC', 'Display or not the active language. If displayed, the class \'lang-active\' will be added to the element.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4956, 'MOD_LANGUAGES_FIELD_ACTIVE_LABEL', 'Active Language', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4957, 'MOD_LANGUAGES_FIELD_CACHING_DESC', 'Select whether to cache or not the content of this module.<br />This should be set to \'No caching\' when using Items Associations.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4958, 'MOD_LANGUAGES_FIELD_DROPDOWN_DESC', 'If set to \'Yes\', the display parameters below will be ignored. The content languages native names will display in a dropdown.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4959, 'MOD_LANGUAGES_FIELD_DROPDOWN_LABEL', 'Use Dropdown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4960, 'MOD_LANGUAGES_FIELD_FOOTER_DESC', 'This is the text or HTML that is displayed below the language switcher.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4961, 'MOD_LANGUAGES_FIELD_FOOTER_LABEL', 'Post-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4962, 'MOD_LANGUAGES_FIELD_FULL_NAME_DESC', 'If set to \'Yes\' and image flags set to \'No\', full content language native names are displayed. If set to \'No\', upper case abbreviations from the content languages URL Language Code are used. Example: EN for English, FR for French.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4963, 'MOD_LANGUAGES_FIELD_FULL_NAME_LABEL', 'Languages Full Names', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4964, 'MOD_LANGUAGES_FIELD_HEADER_DESC', 'This is the text or HTML that is displayed above the language switcher.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4965, 'MOD_LANGUAGES_FIELD_HEADER_LABEL', 'Pre-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4966, 'MOD_LANGUAGES_FIELD_INLINE_DESC', 'Default is set to \'Yes\', ie to horizontal display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4967, 'MOD_LANGUAGES_FIELD_INLINE_LABEL', 'Horizontal Display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4968, 'MOD_LANGUAGES_FIELD_MODULE_LAYOUT_DESC', 'Use a different layout from the supplied module or overrides in the default template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4969, 'MOD_LANGUAGES_FIELD_USEIMAGE_DESC', 'If set to \'Yes\', will display language choice as image flags. Otherwise will use the content language native names.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4970, 'MOD_LANGUAGES_FIELD_USEIMAGE_LABEL', 'Use Image Flags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4971, 'MOD_LANGUAGES_OPTION_DEFAULT_LANGUAGE', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4972, 'MOD_LANGUAGES_SPACERDROP_LABEL', '<u>If Use Dropdown is set to \'Yes\', <br />the display options below will be ignored</u>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4973, 'MOD_LANGUAGES_SPACERNAME_LABEL', '<u>If Use Image Flags is set to \'Yes\', <br />the display options below will be ignored</u>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4974, 'MOD_LANGUAGES_XML_DESCRIPTION', 'This module displays a list of available Content Languages (as defined and published in Language Manager Content tab) for switching between them when one wants to use Joomla! as a multilingual site. <br />--The plugin \'System - Language Filter\' has to be enabled.--<br />When switching languages and if the item displayed in the page is not associated to another item, the module redirects to the Home page defined for the chosen language.<br />Otherwise, if the parameter is set for the Language filter plugin, it will redirect to the associated item in the language chosen. Thereafter, the navigation will be the one defined for that language. <br />If the plugin <strong>\'System - Language Filter\'</strong> is disabled, this may have unwanted results.<br /><strong>Method:</strong><br />1. Open Language Manager Content tab and make sure the Languages you want to use in contents are published and have a Language Code for the URL as well as prefix for the image used in the module display.<br />2. Create a Home page by assigning a language to a menu item and defining it as Default Home page for each published content language. <br />3. Thereafter, you can assign a language to any Article, Category, Module, News Feed, Web Links in Joomla.<br />4. Make sure the module is published and the plugin is enabled. <br />5. When using associated items, make sure the module is displayed on the pages concerned. <br />6. The way the flags or names of the languages are displayed is defined by the ordering in the Language Manager - Content Languages.<br ><br >If this module is published, it is suggested to publish the Administrator multilingual status module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.ini'),
(4975, 'MOD_LANGUAGES', 'Language Switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.sys.ini'),
(4976, 'MOD_LANGUAGES_XML_DESCRIPTION', 'This module displays a list of available Content Languages (as defined and published in Language Manager Content tab) for switching between them when one wants to use Joomla! as a multilingual site. <br />--The plugin \'System - Language Filter\' has to be enabled.--<br />When switching languages and if the item displayed in the page is not associated to another item, the module redirects to the Home page defined for the chosen language.<br />Otherwise, if the parameter is set for the Language filter plugin, it will redirect to the associated item in the language chosen. Thereafter, the navigation will be the one defined for that language. <br />If the plugin <strong>\'System - Language Filter\'</strong> is disabled, this may have unwanted results.<br /><strong>Method:</strong><br />1. Open Language Manager Content tab and make sure the Languages you want to use in contents are published and have a Language Code for the URL as well as prefix for the image used in the module display.<br />2. Create a Home page by assigning a language to a menu item and defining it as Default Home page for each published content language. <br />3. Thereafter, you can assign a language to any Article, Category, Module, News Feed, Web Links in Joomla.<br />4. Make sure the module is published and the plugin is enabled. <br />5. When using associated items, make sure the module is displayed on the pages concerned. <br />6. The way the flags or names of the languages are displayed is defined by the ordering in the Language Manager - Content Languages.<br ><br >If this module is published, it is suggested to publish the Administrator multilingual status module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.sys.ini'),
(4977, 'MOD_LANGUAGES_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_languages.sys.ini'),
(4978, 'MOD_LOGIN', 'Login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4979, 'MOD_LOGIN_FIELD_GREETING_DESC', 'Show/Hide the simple greeting text.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4980, 'MOD_LOGIN_FIELD_GREETING_LABEL', 'Show Greeting', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4981, 'MOD_LOGIN_FIELD_LOGIN_REDIRECTURL_DESC', 'Select the page the user will be redirected to after a successful login. Select from all the pages listed in the dropdown menu. Choosing &quot;Default&quot; will return to the same page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4982, 'MOD_LOGIN_FIELD_LOGIN_REDIRECTURL_LABEL', 'Login Redirection Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4983, 'MOD_LOGIN_FIELD_LOGOUT_REDIRECTURL_DESC', 'Select the page the user will be redirected to after successfully ending their current session by logging out. Select from all the pages listed in the dropdown menu. Choosing &quot;Default&quot; will return to the same page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4984, 'MOD_LOGIN_FIELD_LOGOUT_REDIRECTURL_LABEL', 'Logout Redirection Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4985, 'MOD_LOGIN_FIELD_NAME_DESC', 'Displays name or username after logging in.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4986, 'MOD_LOGIN_FIELD_NAME_LABEL', 'Show Name/Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4987, 'MOD_LOGIN_FIELD_POST_TEXT_DESC', 'This is the text or HTML that is displayed below the login form.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4988, 'MOD_LOGIN_FIELD_POST_TEXT_LABEL', 'Post-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4989, 'MOD_LOGIN_FIELD_PRE_TEXT_DESC', 'This is the text or HTML that is displayed above the login form.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4990, 'MOD_LOGIN_FIELD_PRE_TEXT_LABEL', 'Pre-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4991, 'MOD_LOGIN_FIELD_USESECURE_DESC', 'Submit encrypted login data (requires SSL). Do not enable this option if Joomla is not accessible using the https:// protocol prefix.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4992, 'MOD_LOGIN_FIELD_USESECURE_LABEL', 'Encrypt Login Form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4993, 'MOD_LOGIN_FIELD_USETEXT_DESC', 'Choose text or icons to display the field labels. Default is icons.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4994, 'MOD_LOGIN_FIELD_USETEXT_LABEL', 'Display Labels', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4995, 'MOD_LOGIN_FORGOT_YOUR_PASSWORD', 'Forgot your password?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4996, 'MOD_LOGIN_FORGOT_YOUR_USERNAME', 'Forgot your username?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4997, 'MOD_LOGIN_HINAME', 'Hi %s,', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4998, 'MOD_LOGIN_REGISTER', 'Create an account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(4999, 'MOD_LOGIN_REMEMBER_ME', 'Remember Me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5000, 'MOD_LOGIN_VALUE_ICONS', 'Icons', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5001, 'MOD_LOGIN_VALUE_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5002, 'MOD_LOGIN_VALUE_TEXT', 'Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5003, 'MOD_LOGIN_VALUE_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5004, 'MOD_LOGIN_XML_DESCRIPTION', 'This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in User Manager > Options), another link will be shown to enable self-registration for users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.ini'),
(5005, 'MOD_LOGIN', 'Login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.sys.ini'),
(5006, 'MOD_LOGIN_XML_DESCRIPTION', 'This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in User Manager > Options), another link will be shown to enable self-registration for users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.sys.ini'),
(5007, 'MOD_LOGIN_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_login.sys.ini'),
(5008, 'MOD_MENU', 'Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5009, 'MOD_MENU_FIELD_ACTIVE_DESC', 'Select a menu item to always be used as the base for the menu display. You must set the Start Level to the same level or higher than the level of the base item. This will cause the module to be displayed on all assigned pages. If Current is selected the currently active item is used as the base. This causes the module to only display when the parent menu item is active.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5010, 'MOD_MENU_FIELD_ACTIVE_LABEL', 'Base Item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5011, 'MOD_MENU_FIELD_ALLCHILDREN_DESC', 'Expand the menu and make its sub-menu items always visible.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5012, 'MOD_MENU_FIELD_ALLCHILDREN_LABEL', 'Show Sub-menu Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5013, 'MOD_MENU_FIELD_CLASS_DESC', 'A suffix to be applied to the CSS class of the menu items.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5014, 'MOD_MENU_FIELD_CLASS_LABEL', 'Menu Class Suffix', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5015, 'MOD_MENU_FIELD_ENDLEVEL_DESC', 'Level to stop rendering the menu at. If you choose \'All\', all levels will be shown depending on \'Show Sub-menu Items\' setting.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5016, 'MOD_MENU_FIELD_ENDLEVEL_LABEL', 'End Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5017, 'MOD_MENU_FIELD_MENUTYPE_DESC', 'Select a menu in the list.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5018, 'MOD_MENU_FIELD_MENUTYPE_LABEL', 'Select Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5019, 'MOD_MENU_FIELD_STARTLEVEL_DESC', 'Level to start rendering the menu at. Setting the start and end levels to the same # and setting \'Show Sub-menu Items\' to yes will only display that single level.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5020, 'MOD_MENU_FIELD_STARTLEVEL_LABEL', 'Start Level', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5021, 'MOD_MENU_FIELD_TAG_ID_DESC', 'An ID attribute to assign to the root ul tag of the menu (optional).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5022, 'MOD_MENU_FIELD_TAG_ID_LABEL', 'Menu Tag ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5023, 'MOD_MENU_FIELD_TARGET_DESC', 'JavaScript values to position a popup window, eg top=50,left=50,width=200,height=300.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5024, 'MOD_MENU_FIELD_TARGET_LABEL', 'Target Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5025, 'MOD_MENU_XML_DESCRIPTION', 'This module displays a menu on the Frontend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.ini'),
(5026, 'MOD_MENU', 'Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.sys.ini'),
(5027, 'MOD_MENU_XML_DESCRIPTION', 'This module displays a menu on the Frontend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.sys.ini'),
(5028, 'MOD_MENU_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_menu.sys.ini'),
(5029, 'MOD_RANDOM_IMAGE', 'Random Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5030, 'MOD_RANDOM_IMAGE_FIELD_FOLDER_DESC', 'Path to the image folder relative to the site URL (eg images).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5031, 'MOD_RANDOM_IMAGE_FIELD_FOLDER_LABEL', 'Image Folder', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5032, 'MOD_RANDOM_IMAGE_FIELD_HEIGHT_DESC', 'Image height forces all images to be displayed with the height in pixels.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5033, 'MOD_RANDOM_IMAGE_FIELD_HEIGHT_LABEL', 'Height (px)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5034, 'MOD_RANDOM_IMAGE_FIELD_LINK_DESC', 'A URL to redirect to if the image is clicked upon (eg http://www.joomla.org).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5035, 'MOD_RANDOM_IMAGE_FIELD_LINK_LABEL', 'Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(5036, 'MOD_RANDOM_IMAGE_FIELD_TYPE_DESC', 'Type of image PNG/GIF/JPG etc (the default is JPG).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5037, 'MOD_RANDOM_IMAGE_FIELD_TYPE_LABEL', 'Image Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5038, 'MOD_RANDOM_IMAGE_FIELD_WIDTH_DESC', 'Image width forces all images to be displayed with this width in pixels.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5039, 'MOD_RANDOM_IMAGE_FIELD_WIDTH_LABEL', 'Width (px)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5040, 'MOD_RANDOM_IMAGE_NO_IMAGES', 'No Images', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5041, 'MOD_RANDOM_IMAGE_XML_DESCRIPTION', 'This module displays a random image from your chosen directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.ini'),
(5042, 'MOD_RANDOM_IMAGE', 'Random Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.sys.ini'),
(5043, 'MOD_RANDOM_IMAGE_XML_DESCRIPTION', 'This module displays a random image from your chosen directory.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.sys.ini'),
(5044, 'MOD_RANDOM_IMAGE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_random_image.sys.ini'),
(5045, 'MOD_RELATED_FIELD_MAX_DESC', 'The maximum number of related articles to display (default is 5).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5046, 'MOD_RELATED_FIELD_MAX_LABEL', 'Maximum Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5047, 'MOD_RELATED_FIELD_SHOWDATE_DESC', 'Show/Hide date.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5048, 'MOD_RELATED_FIELD_SHOWDATE_LABEL', 'Show Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5049, 'MOD_RELATED_ITEMS', 'Articles - Related', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5050, 'MOD_RELATED_XML_DESCRIPTION', 'This module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta keywords. <br />All the keywords of the current Article are searched against all the keywords of all other published Articles. For example, you may have an Article on &quot;Breeding Parrots&quot; and another on &quot;Hand Raising Black Cockatoos&quot;. If you include the keyword &quot;parrot&quot; in both Articles, then the Related Items Module will list the &quot;Breeding Parrots&quot; Article when viewing &quot;Hand Raising Black Cockatoos&quot; and vice-versa.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.ini'),
(5051, 'MOD_RELATED_ITEMS', 'Articles - Related', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.sys.ini'),
(5052, 'MOD_RELATED_XML_DESCRIPTION', 'This module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta keywords. <br />All the keywords of the current Article are searched against all the keywords of all other published Articles. For example, you may have an Article on &quot;Breeding Parrots&quot; and another on &quot;Hand Raising Black Cockatoos&quot;. If you include the keyword &quot;parrot&quot; in both Articles, then the Related Items Module will list the &quot;Breeding Parrots&quot; Article when viewing &quot;Hand Raising Black Cockatoos&quot; and vice-versa.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.sys.ini'),
(5053, 'MOD_RELATED_ITEMS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_related_items.sys.ini'),
(5054, 'MOD_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5055, 'MOD_SEARCH_FIELD_BOXWIDTH_DESC', 'Size of the search text box in characters.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5056, 'MOD_SEARCH_FIELD_BOXWIDTH_LABEL', 'Box Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5057, 'MOD_SEARCH_FIELD_BUTTON_DESC', 'Display a search button.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5058, 'MOD_SEARCH_FIELD_BUTTON_LABEL', 'Search Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5059, 'MOD_SEARCH_FIELD_BUTTONPOS_DESC', 'Position of the button relative to the search box.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5060, 'MOD_SEARCH_FIELD_BUTTONPOS_LABEL', 'Button Position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5061, 'MOD_SEARCH_FIELD_BUTTONTEXT_DESC', 'The text that appears in the search button. If left blank, it will load the \'searchbutton\' string from your language file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5062, 'MOD_SEARCH_FIELD_BUTTONTEXT_LABEL', 'Button Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5063, 'MOD_SEARCH_FIELD_IMAGEBUTTON_DESC', 'Use an image as button. This image has to be named searchButton.gif and must be located in templates/*your template name*/images/.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5064, 'MOD_SEARCH_FIELD_IMAGEBUTTON_LABEL', 'Search Button Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5065, 'MOD_SEARCH_FIELD_SETITEMID_DESC', 'Assign an ItemID by selecting a menu item in the list for the display of the search results if there is no com_search menu and a specific display is desired. If you do not know what this means, you may not need it.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5066, 'MOD_SEARCH_FIELD_SETITEMID_LABEL', 'Set ItemID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5067, 'MOD_SEARCH_FIELD_LABEL_TEXT_DESC', 'The text that appears in the label of search box. If left blank, it will load \'label\' string from your language file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5068, 'MOD_SEARCH_FIELD_LABEL_TEXT_LABEL', 'Box Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5069, 'MOD_SEARCH_FIELD_OPENSEARCH_LABEL', 'OpenSearch Autodiscovery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5070, 'MOD_SEARCH_FIELD_OPENSEARCH_TEXT_LABEL', 'OpenSearch Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5071, 'MOD_SEARCH_FIELD_OPENSEARCH_TEXT_DESC', 'Text displayed in supported browsers when adding your site as a search provider.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5072, 'MOD_SEARCH_FIELD_OPENSEARCH_DESC', 'Some browsers can add support for your site\'s search if this option is enabled.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5073, 'MOD_SEARCH_FIELD_TEXT_DESC', 'The text that appears in the search text box. If left blank, it will load the \'searchbox\' string from your language file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5074, 'MOD_SEARCH_FIELD_TEXT_LABEL', 'Box Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5075, 'MOD_SEARCH_FIELD_VALUE_BOTTOM', 'Bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5076, 'MOD_SEARCH_FIELD_VALUE_LEFT', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5077, 'MOD_SEARCH_FIELD_VALUE_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5078, 'MOD_SEARCH_FIELD_VALUE_TOP', 'Top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5079, 'MOD_SEARCH_LABEL_TEXT', 'Search ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5080, 'MOD_SEARCH_SEARCHBOX_TEXT', 'Search ...', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5081, 'MOD_SEARCH_SEARCHBUTTON_TEXT', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5082, 'MOD_SEARCH_SELECT_MENU_ITEMID', 'Select a menu item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5083, 'MOD_SEARCH_XML_DESCRIPTION', 'This module will display a search box.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.ini'),
(5084, 'MOD_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.sys.ini'),
(5085, 'MOD_SEARCH_XML_DESCRIPTION', 'This module will display a search box.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.sys.ini'),
(5086, 'MOD_SEARCH_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_search.sys.ini'),
(5087, 'MOD_LOGINRADIUS', 'Social Login And Social Share', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5088, 'MOD_LOGINRADIUS_XML_DESCRIPTION', 'LoginRadius enables social login on Joomla websites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5089, 'MOD_LOGINRADIUS_FORGOT_YOUR_PASSWORD', 'Forgot your password?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5090, 'MOD_LOGINRADIUS_FORGOT_YOUR_USERNAME', 'Forgot your username?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5091, 'MOD_LOGINRADIUS_HINAME', 'Hi %s,', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5092, 'MOD_LOGINRADIUS_REGISTER', 'Create an account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5093, 'MOD_LOGINRADIUS_REMEMBER_ME', 'Remember Me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5094, 'MOD_LOGINRADIUS_VALUE_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5095, 'MOD_LOGINRADIUS_VALUE_USERNAME', 'User Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5096, 'MOD_LOGINRADIUS_PLUGIN_ERROR', 'Please install or Enable the Social Login Plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5097, 'MOD_LOGINRADIUS_USERS_REGISTRATION', 'User Registration not allowed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5098, 'MOD_LOGINRADIUS_FIELD_LOGIN_REDIRECTURL_DESC', 'Users will be redirected to the page selected, after logging in through login form shown with social login interface. Choosing QQ Default QQ will return to the same page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5099, 'MOD_LOGINRADIUS_FIELD_LOGIN_REDIRECTURL_LABEL', 'Login Redirection Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5100, 'MOD_LOGINRADIUS_FIELD_LOGOUT_REDIRECTURL_DESC', 'Select the page the user will be redirected to after successfully ending their current session by logging out. Select from all the pages listed in the dropdown menu. Choosing \" Default \" will return to the same page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5101, 'MOD_LOGINRADIUS_FIELD_LOGOUT_REDIRECTURL_LABEL', 'Logout Redirection Page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5102, 'MOD_LOGINRADIUS_FIELD_POST_TEXT_DESC', 'This text will be displayed just below LoginRadius interface.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5103, 'MOD_LOGINRADIUS_FIELD_POST_TEXT_LABEL', 'Post-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5104, 'MOD_LOGINRADIUS_FIELD_PRE_TEXT_DESC', 'This text will be displayed just above LoginRadius interface.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5105, 'MOD_LOGINRADIUS_FIELD_PRE_TEXT_LABEL', 'Pre-text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5106, 'MOD_LOGINRADIUS_FIELD_USESECURE_DESC', 'Do you want to submit encrypted login data? Do not enable this option if your Joomla is not accessible through HTTPS:// protocol.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5107, 'MOD_LOGINRADIUS_FIELD_USESECURE_LABEL', 'Encrypt Login Form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5108, 'MOD_LOGINRADIUS_VALUE_ACCOUNT', 'My Account', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5109, 'MOD_LOGINRADIUS_VALUE_MAP', 'You have', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5110, 'MOD_LOGINRADIUS_VALUE_MAPONE', 'account mapped with your account.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5111, 'MOD_SOCIALLOGIN_AND_SOCIALSHARE_UNPLUSH_ERROR', '<div style=\'color:red; margin-bottom:5px\'> LoginRadius Plugin is not configured! </div><br/><div style=\'line-height:1.3; margin-bottom:4px\'> To activate the plugin, Navigate <b> Components > Social Share And Social Share </b> insert LoginRadius API Key & Secret in your Joomla Admin. Follow <a href=\'http://support.loginradius.com/customer/portal/articles/677100-how-to-get-loginradius-api-key-and-secret\' target=\'_blank\'> this document </a> to learn how to get API Key & Secret </div>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.ini'),
(5112, 'MOD_LOGINRADIUS', 'Social Login And Social Share', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.sys.ini'),
(5113, 'MOD_LOGINRADIUS_XML_DESCRIPTION', 'LoginRadius enables social login on Joomla websites.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.sys.ini'),
(5114, 'MOD_LOGINRADIUS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_socialloginandsocialshare.sys.ini'),
(5115, 'MOD_STATS', 'Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5116, 'MOD_STATS_ARTICLES', 'Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5117, 'MOD_STATS_ARTICLES_VIEW_HITS', 'Articles View Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5118, 'MOD_STATS_CACHING', 'Caching', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5119, 'MOD_STATS_FIELD_COUNTER_DESC', 'Display hit counter.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5120, 'MOD_STATS_FIELD_COUNTER_LABEL', 'Hit Counter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5121, 'MOD_STATS_FIELD_INCREASECOUNTER_DESC', 'Enter the number of hits to increase the counter by.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5122, 'MOD_STATS_FIELD_INCREASECOUNTER_LABEL', 'Increase Counter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5123, 'MOD_STATS_FIELD_SERVERINFO_DESC', 'Display server information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5124, 'MOD_STATS_FIELD_SERVERINFO_LABEL', 'Server Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5125, 'MOD_STATS_FIELD_SITEINFO_DESC', 'Display site information.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5126, 'MOD_STATS_FIELD_SITEINFO_LABEL', 'Site Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5127, 'MOD_STATS_GZIP', 'GZip', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5128, 'MOD_STATS_MYSQL', 'MySQL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5129, 'MOD_STATS_OS', 'OS', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5130, 'MOD_STATS_PHP', 'PHP', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5131, 'MOD_STATS_TIME', 'Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5132, 'MOD_STATS_USERS', 'Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5133, 'MOD_STATS_WEBLINKS', 'Web Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5134, 'MOD_STATS_XML_DESCRIPTION', 'The Statistics Module shows information about your server installation together with statistics on the website users, number of Articles in your database and the number of Web links you provide.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.ini'),
(5135, 'MOD_STATS', 'Statistics', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.sys.ini'),
(5136, 'MOD_STATS_XML_DESCRIPTION', 'The Statistics Module shows information about your server installation together with statistics on the website users, number of Articles in your database and the number of Web links you provide.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.sys.ini'),
(5137, 'MOD_STATS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_stats.sys.ini'),
(5138, 'MOD_SYNDICATE', 'Syndication Feeds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5139, 'MOD_SYNDICATE_DEFAULT_FEED_ENTRIES', 'Feed Entries', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5140, 'MOD_SYNDICATE_FIELD_DISPLAYTEXT_DESC', 'If set to \'Yes\', text will be displayed next to the icon.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5141, 'MOD_SYNDICATE_FIELD_DISPLAYTEXT_LABEL', 'Display Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5142, 'MOD_SYNDICATE_FIELD_FORMAT_DESC', 'Select the format for the Syndication Feed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5143, 'MOD_SYNDICATE_FIELD_FORMAT_LABEL', 'Feed Format', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5144, 'MOD_SYNDICATE_FIELD_TEXT_DESC', 'If \'Display Text\' is activated, the text entered here will be displayed next to the icon along with the RSS Link. If this field is left empty, the default text displayed will be picked from the site language ini file.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5145, 'MOD_SYNDICATE_FIELD_TEXT_LABEL', 'Text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5146, 'MOD_SYNDICATE_FIELD_VALUE_ATOM', 'Atom 1.0', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5147, 'MOD_SYNDICATE_FIELD_VALUE_RSS', 'RSS 2.0', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5148, 'MOD_SYNDICATE_XML_DESCRIPTION', 'Smart Syndication Module that creates a Syndicated Feed for the page where the Module is displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.ini'),
(5149, 'MOD_SYNDICATE', 'Syndication Feeds', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.sys.ini'),
(5150, 'MOD_SYNDICATE_XML_DESCRIPTION', 'Smart Syndication Module that creates a Syndicated Feed for the page where the Module is displayed.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.sys.ini'),
(5151, 'MOD_SYNDICATE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_syndicate.sys.ini'),
(5152, 'MOD_TAGS_POPULAR', 'Tags - Popular', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5153, 'MOD_TAGS_POPULAR_FIELD_ALL_TIME', 'All time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5154, 'MOD_TAGS_POPULAR_FIELD_DISPLAY_COUNT_DESC', 'Choose if the number of tagged items should be displayed next to each tag.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5155, 'MOD_TAGS_POPULAR_FIELD_DISPLAY_COUNT_LABEL', 'Display Number of Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5156, 'MOD_TAGS_POPULAR_FIELD_LAST_DAY', 'Last day', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5157, 'MOD_TAGS_POPULAR_FIELD_LAST_HOUR', 'Last hour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5158, 'MOD_TAGS_POPULAR_FIELD_LAST_MONTH', 'Last month', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5159, 'MOD_TAGS_POPULAR_FIELD_LAST_WEEK', 'Last week', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5160, 'MOD_TAGS_POPULAR_FIELD_LAST_YEAR', 'Last year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5161, 'MOD_TAGS_POPULAR_FIELD_MAX_DESC', 'Sets the maximum number of tags to display in the module. Enter &quot;0&quot; to display all tags.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5162, 'MOD_TAGS_POPULAR_FIELD_MAX_LABEL', 'Maximum Tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5163, 'MOD_TAGS_POPULAR_FIELD_MAXSIZE_DESC', 'The maximum font size used for the tags, proportional to the site\'s default font size (eg &quot;2&quot; means 200% of the default size).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5164, 'MOD_TAGS_POPULAR_FIELD_MAXSIZE_LABEL', 'Maximum Font Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5165, 'MOD_TAGS_POPULAR_FIELD_MINSIZE_DESC', 'The minimum font size used for the tags, proportional to the site\'s default font size (eg &quot;2&quot; means 200% of the default size).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5166, 'MOD_TAGS_POPULAR_FIELD_MINSIZE_LABEL', 'Minimum Font Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5167, 'MOD_TAGS_POPULAR_FIELD_NO_RESULTS_DESC', 'Will show a message if no matching tags are found instead of hiding the module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5168, 'MOD_TAGS_POPULAR_FIELD_NO_RESULTS_LABEL', 'Show &quot;No results&quot; text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5169, 'MOD_TAGS_POPULAR_FIELD_ORDER_VALUE_COUNT', 'Number of Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5170, 'MOD_TAGS_POPULAR_FIELD_ORDER_VALUE_DESC', 'The order that tags will show in.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5171, 'MOD_TAGS_POPULAR_FIELD_ORDER_VALUE_LABEL', 'Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5172, 'MOD_TAGS_POPULAR_FIELD_ORDER_VALUE_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5173, 'MOD_TAGS_POPULAR_FIELD_ORDER_VALUE_TITLE', 'Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5174, 'MOD_TAGS_POPULAR_FIELD_TIMEFRAME_DESC', 'Sets the time period for which to calculate popularity.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5175, 'MOD_TAGS_POPULAR_FIELD_TIMEFRAME_LABEL', 'Time Period', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5176, 'MOD_TAGS_POPULAR_FIELDSET_CLOUD_LABEL', 'Cloud Layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5177, 'MOD_TAGS_POPULAR_MAX_DESC', 'Sets the maximum number of tags to display in the module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5178, 'MOD_TAGS_POPULAR_MAX_LABEL', 'Maximum tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5179, 'MOD_TAGS_POPULAR_NO_ITEMS_FOUND', 'No Tags found.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5180, 'MOD_TAGS_POPULAR_XML_DESCRIPTION', 'This module displays tags used on the site in a list or a cloud layout. Tags can be ordered by title or by the number of tagged items and limited to a specific time period.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.ini'),
(5181, 'MOD_TAGS_POPULAR', 'Tags - Popular', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.sys.ini'),
(5182, 'MOD_TAGS_POPULAR_LAYOUT_CLOUD', 'Cloud', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.sys.ini'),
(5183, 'MOD_TAGS_POPULAR_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.sys.ini'),
(5184, 'MOD_TAGS_POPULAR_XML_DESCRIPTION', 'This module displays tags used on the site in a list or a cloud layout. Tags can be ordered by title or by the number of tagged items and limited to a specific time period.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_popular.sys.ini'),
(5185, 'MOD_TAGS_SIMILAR', 'Tags - Similar', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5186, 'MOD_TAGS_SIMILAR_FIELD_ALL', 'All', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5187, 'MOD_TAGS_SIMILAR_FIELD_HALF', 'Half', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5188, 'MOD_TAGS_SIMILAR_FIELD_MATCHTYPE_DESC', 'How closely an item\'s tags need to match. All - requires that all tags in the displayed item be matched. Any - requires that at least one tag match. Half - requires that at least half of the tags match (rounded up in the case of decimals).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5189, 'MOD_TAGS_SIMILAR_FIELD_MATCHTYPE_LABEL', 'Match Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5190, 'MOD_TAGS_SIMILAR_FIELD_ONE', 'Any', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5191, 'MOD_TAGS_SIMILAR_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5192, 'MOD_TAGS_SIMILAR_MAX_DESC', 'Maximum number of items to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5193, 'MOD_TAGS_SIMILAR_MAX_LABEL', 'Maximum Items', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5194, 'MOD_TAGS_SIMILAR_NO_MATCHING_TAGS', 'No matching tags.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5195, 'MOD_TAGS_SIMILAR_XML_DESCRIPTION', 'The Similar Tags Module displays links to other items with similar tags. The closeness of the match can be specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5196, 'MOD_TAGS_SIMILAR_FIELD_ORDERING_LABEL', 'Order Results', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5197, 'MOD_TAGS_SIMILAR_FIELD_ORDERING_DESC', 'Select the order in which you want query results presented.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5198, 'MOD_TAGS_SIMILAR_FIELD_ORDERING_COUNT', 'Number of matching tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5199, 'MOD_TAGS_SIMILAR_FIELD_ORDERING_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5200, 'MOD_TAGS_SIMILAR_FIELD_ORDERING_COUNT_AND_RANDOM', 'Number of matching tags & Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.ini'),
(5201, 'MOD_TAGS_SIMILAR', 'Tags - Similar', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.sys.ini'),
(5202, 'MOD_TAGS_SIMILAR_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.sys.ini'),
(5203, 'MOD_TAGS_SIMILAR_XML_DESCRIPTION', 'The Similar Tags Module displays links to other items with similar tags. The closeness of the match can be specified.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tags_similar.sys.ini'),
(5204, 'MOD_TM_AJAX_CONTACT_FORM', 'TM Ajax Contact Form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5205, 'MOD_TM_AJAX_CONTACT_FORM_XML_DESCRIPTION', '\r\n			<p>Helps to visitors to contact you.</p>\r\n			<h3>Features</h3>\r\n			<ul>\r\n				<li>Compatibility with Joomla3.2.x and above</li>\r\n				<li>Captcha Facility is available.</li>\r\n				<li>Easy and friendly back-end administration.</li>\r\n			</ul>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5206, 'JREQUIRED', 'Required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5207, 'MOD_TM_AJAX_CONTACT_FORM_NOT_JREQUIRED', 'Not Required', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5208, 'MOD_TM_AJAX_CONTACT_FORM_MODULE_SETTINGS', 'Module Settings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5209, 'MOD_TM_AJAX_CONTACT_FORM_EMAIL_REQUIRE_DESC', 'Whether E-Mail field is required or not?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5210, 'MOD_TM_AJAX_CONTACT_FORM_PHONE_LABEL', 'Phone', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5211, 'MOD_TM_AJAX_CONTACT_FORM_WEBSITE_LABEL', 'Website', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5212, 'MOD_TM_AJAX_CONTACT_FORM_PHONE_REQUIRE_DESC', 'Whether Phone field is required or not?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5213, 'MOD_TM_AJAX_CONTACT_FORM_ADMIN_EMAIL_DESC', 'Enter Recipient Mail Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5214, 'MOD_TM_AJAX_CONTACT_FORM_ADMIN_EMAIL_LABEL', 'Admin E-Mail', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5215, 'MOD_TM_AJAX_CONTACT_FORM_CC_DESC', 'Enter CC Mail Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5216, 'MOD_TM_AJAX_CONTACT_FORM_CC_LABEL', 'CC', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5217, 'MOD_TM_AJAX_CONTACT_FORM_BCC_DESC', 'Enter BCC Mail Address', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5218, 'MOD_TM_AJAX_CONTACT_FORM_BCC_LABEL', 'BCC', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5219, 'MOD_TM_AJAX_CONTACT_FORM_SUCCESS_DESC', 'Enter Notification Message on Successfull Sending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5220, 'MOD_TM_AJAX_CONTACT_FORM_SUCCESS_LABEL', 'Notification on Success', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5221, 'MOD_TM_AJAX_CONTACT_FORM_ERROR_DESC', 'Enter Notification Message on Sending Failure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5222, 'MOD_TM_AJAX_CONTACT_FORM_ERROR_LABEL', 'Notification on Failure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5223, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_ERROR_DESC', 'Enter Notification Message on Captcha Failure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5224, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_ERROR_LABEL', 'Notification on Captcha Failure', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5225, 'MOD_TM_AJAX_CONTACT_FORM_MINLENGTH_DESC', 'Enter Minimum Length of characters for Message field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5226, 'MOD_TM_AJAX_CONTACT_FORM_MINLENGTH_LABEL', 'Message Minlength', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5227, 'MOD_TM_AJAX_CONTACT_FORM_ERRORS_POS_DESC', 'Select Inputs errors position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5228, 'MOD_TM_AJAX_CONTACT_FORM_ERRORS_POS_LABEL', 'Inputs errors position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5229, 'MOD_TM_AJAX_CONTACT_FORM_CAPTHA_KEYS', '<strong>To use captcha facility, you need to need to register at <a href=\'https://www.google.com/recaptcha/admin\' target=\'_blank\'>https://www.google.com/recaptcha/admin</a> and get public and private keys.</strong>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5230, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_LABEL', 'Captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5231, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_DESC', 'Whether Captcha field is required or not?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5232, 'MOD_TM_AJAX_CONTACT_FORM_PUB_KEY_DESC', 'Enter Public Key ( If captcha is required. )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5233, 'MOD_TM_AJAX_CONTACT_FORM_PUB_KEY_LABEL', 'Public Key ( If captcha is required )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5234, 'MOD_TM_AJAX_CONTACT_FORM_PRIV_KEY_DESC', 'Enter Private Key ( If captcha is required. )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5235, 'MOD_TM_AJAX_CONTACT_FORM_PRIV_KEY_LABEL', 'Private Key ( If captcha is required )', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5236, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_THEME_LABEL', 'Captcha Theme', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5237, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_THEME_DESC', 'to change the theme of captcha', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5238, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_RED_LABEL', 'Red(default)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5239, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_WHITE_LABEL', 'White', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5240, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_BLACK_LABEL', 'Black Glass', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5241, 'MOD_TM_AJAX_CONTACT_FORM_CAPTCHA_CLEAN_LABEL', 'Clean', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5242, 'MOD_TM_AJAX_CONTACT_FORM_EMAIL_PUBLISH_DESC', 'Do you want to publish E-Mail field?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5243, 'MOD_TM_AJAX_CONTACT_FORM_PHONE_DESC', 'Do you want to publish Phone field?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5244, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_LABEL', 'Subject', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5245, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_DESC', 'Do you want to publish Subject field?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5246, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_TYPE_LABEL', 'Subject Type', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5247, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_TYPE_DESC', 'Do you want to dropdown or texbox?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5248, 'MOD_TM_AJAX_CONTACT_FORM_RESET_LABEL', 'Reset button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5249, 'MOD_TM_AJAX_CONTACT_FORM_RESET_DESC', 'Do you want to publish Reset button?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5250, 'MOD_TM_AJAX_CONTACT_FORM_NAME_NAME_LABEL', 'Name of Name Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5251, 'MOD_TM_AJAX_CONTACT_FORM_NAME_NAME_DESC', 'Enter the name of Name Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5252, 'MOD_TM_AJAX_CONTACT_FORM_EMAIL_NAME_LABEL', 'Name of Email Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5253, 'MOD_TM_AJAX_CONTACT_FORM_EMAIL_NAME_DESC', 'Enter the name of Email Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5254, 'MOD_TM_AJAX_CONTACT_FORM_PHONE_NAME_LABEL', 'Name of Phone Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5255, 'MOD_TM_AJAX_CONTACT_FORM_PHONE_NAME_DESC', 'Enter the name of Phone Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5256, 'MOD_TM_AJAX_CONTACT_FORM_WEBSITE_NAME_LABEL', 'Name of Website Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5257, 'MOD_TM_AJAX_CONTACT_FORM_WEBSITE_NAME_DESC', 'Enter the name of Website Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5258, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_NAME_LABEL', 'Name of Subject Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5259, 'MOD_TM_AJAX_CONTACT_FORM_SUBJECT_NAME_DESC', 'Enter the name of Subject Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5260, 'MOD_TM_AJAX_CONTACT_FORM_MESSAGE_NAME_LABEL', 'Name of Message Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5261, 'MOD_TM_AJAX_CONTACT_FORM_MESSAGE_NAME_DESC', 'Enter the name of Message Field', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5262, 'MOD_TM_AJAX_CONTACT_FORM_RESET_NAME_LABEL', 'Enter the name of Reset Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5263, 'MOD_TM_AJAX_CONTACT_FORM_RESET_NAME_DESC', 'Name of the reset button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5264, 'MOD_TM_AJAX_CONTACT_FORM_SUBMIT_NAME_LABEL', 'Enter the name of Submit Button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5265, 'MOD_TM_AJAX_CONTACT_FORM_SUBMIT_NAME_DESC', 'Name of the submit button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5266, 'MOD_TM_AJAX_CONTACT_FORM_ENTER_ADMIN_EMAIL', 'Please Enter Admin E-Mail address in the backend.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5267, 'MOD_TM_AJAX_CONTACT_FORM_CONTACTED_THROUGH', 'Contacted through', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5268, 'MOD_TM_AJAX_CONTACT_FORM_QUESTION', 'Question', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5269, 'MOD_TM_AJAX_CONTACT_FORM_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5270, 'MOD_TM_AJAX_CONTACT_FORM_OTHER', 'Other', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5271, 'MOD_TM_AJAX_CONTACT_FORM_INSIDE', 'Inside', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5272, 'MOD_TM_AJAX_CONTACT_FORM_OUTSIDE', 'Outside', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5273, 'MOD_TM_AJAX_CONTACT_FORM_LABELS_POS_LABEL', 'Labels position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5274, 'MOD_TM_AJAX_CONTACT_FORM_LABELS_POS_DESC', 'Choose a Labels position', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5275, 'MOD_TM_AJAX_CONTACT_FORM_PRETEXT_LABEL', 'Pretext', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5276, 'MOD_TM_AJAX_CONTACT_FORM_PRETEXT_DESC', 'Please input text you want to display before module content. Doesn\'t support any HTML tags', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.ini'),
(5277, 'MOD_TM_AJAX_CONTACT_FORM', 'TM Ajax Contact Form', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.sys.ini'),
(5278, 'MOD_TM_AJAX_CONTACT_FORM_XML_DESCRIPTION', 'Helps to visitors to contact you.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_ajax_contact_form.sys.ini'),
(5279, 'MOD_TM_BG_YOUTUBE', 'TM Youtube background video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.ini'),
(5280, 'MOD_TM_BG_YOUTUBE_XML_DESCRIPTION', 'This module allows you to create Youtube background video.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.ini'),
(5281, 'MOD_TM_BG_YOUTUBE_FIELD_ID_LABEL', 'Enter a Youtube video id', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.ini'),
(5282, 'MOD_TM_BG_YOUTUBE_FIELD_ID_DESC', 'Enter a Youtube video id', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.ini'),
(5283, 'MOD_TM_BG_YOUTUBE_FIELD_MUTE_LABEL', 'Mute', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.ini'),
(5284, 'MOD_TM_BG_YOUTUBE', 'TM Youtube background video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.sys.ini'),
(5285, 'MOD_TM_BG_YOUTUBE_XML_DESCRIPTION', 'This module allows you to create Youtube background video.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_bg_youtube.sys.ini'),
(5286, 'MOD_TM_FACEBOOK_PAGE_PLUGIN', 'TM Facebook Page Plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5287, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_XML_DESCRIPTION', 'This module allows you to create Facebook Page Plugin. for more information please visit <a target=\"_blank\" href=\"https://developers.facebook.com/docs/plugins/page-plugin\">Official documentation page</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5288, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_APP_ID_LABEL', 'Facebook App ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5289, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_APP_ID_DESC', 'Facebook App ID will be here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5290, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_PAGE_URL_LABEL', 'Facebook Page URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5291, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_PAGE_URL_DESC', 'Facebook Page URL Link will be here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5292, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_YOUR_COMPANY_NAME_LABEL', 'Your Company Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5293, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_YOUR_COMPANY_NAME_DESC', 'Your Company Name will be here', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5294, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_WIDTH_LABEL', 'Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5295, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_WIDTH_DESC', 'The pixel width of the embed (Min. 280 to Max. 500)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5296, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_HEIGHT_LABEL', 'Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5297, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_HEIGHT_DESC', 'The pixel height of the embed (Min. 130)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5298, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_FACES_LABEL', 'Show Friend\'s Faces', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5299, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_FACES_DESC', 'Show profile photos when friends like this', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5300, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_POSTS_LABEL', 'Show Page Posts', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5301, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_POSTS_DESC', 'Show posts from the Page\'s timeline.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5302, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_COVER_LABEL', 'Hide Cover Photo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5303, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_COVER_DESC', 'Hide cover photo in the header', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.ini'),
(5304, 'MOD_TM_FACEBOOK_PAGE_PLUGIN', 'TM Facebook Page Plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.sys.ini'),
(5305, 'MOD_TM_FACEBOOK_PAGE_PLUGIN_XML_DESCRIPTION', 'This module allows you to create Facebook Page Plugin. for more information please visit <a target=\"_blank\" href=\"https://developers.facebook.com/docs/plugins/page-plugin\">Official documentation page</a>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_facebook_page_plugin.sys.ini'),
(5306, 'MOD_TM_INSTAGRAM_XML_DESCRIPTION', 'Module that shows user\'s last photos from the Instagram.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5307, 'MOD_TM_INSTAGRAM_PHOTO_COUNT', 'Number of photos', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5308, 'MOD_TM_INSTAGRAM_PHOTO_COUNT_DESC', 'Number of photos that will show in the module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5309, 'MOD_TM_INSTAGRAM_CLIENT_ID', 'Your Instagram CLIENT ID.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5310, 'MOD_TM_INSTAGRAM_CLIENT_ID_DESC', 'You need to create an instagram-account and then create your App (http://instagram.com/developer/clients/manage/). Instagram will give you the unique CLIENT ID.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5311, 'MOD_TM_INSTAGRAM_USER_NAME', 'Instagram username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5312, 'MOD_TM_INSTAGRAM_USER_NAME_DESC', 'This module will show this user\'s photos.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.ini'),
(5313, 'MOD_TM_INSTAGRAM_XML_DESCRIPTION', 'Module that shows user\'s last photos from the Instagram.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5314, 'MOD_TM_INSTAGRAM_PHOTO_COUNT', 'Number of photos', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5315, 'MOD_TM_INSTAGRAM_PHOTO_COUNT_DESC', 'Number of photos that will show in the module.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5316, 'MOD_TM_INSTAGRAM_CLIENT_ID', 'Your Instagram CLIENT ID.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5317, 'MOD_TM_INSTAGRAM_CLIENT_ID_DESC', 'You need to create an instagram-account and then create your App (http://instagram.com/developer/clients/manage/). Instagram will give you the unique CLIENT ID.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5318, 'MOD_TM_INSTAGRAM_USER_NAME', 'Instagram username', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5319, 'MOD_TM_INSTAGRAM_USER_NAME_DESC', 'This module will show this user\'s photos.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_instagram.sys.ini'),
(5320, 'MOD_TM_OLARK_CHAT', 'Olark live chat', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.ini'),
(5321, 'MOD_TM_OLARK_CHAT_XML_DESCRIPTION', 'This Module allows you to embed olark live chat to your website page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.ini'),
(5322, 'MOD_TM_OLARK_CHAT_SITE_ID_LABEL', 'Site ID', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.ini'),
(5323, 'MOD_TM_OLARK_CHAT', 'Olark live chat', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.sys.ini'),
(5324, 'MOD_TM_OLARK_CHAT_XML_DESCRIPTION', 'This Module allows you to embed olark live chat to your website page.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.sys.ini'),
(5325, 'MOD_TM_OLARK_CHAT_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_olark_chat.sys.ini'),
(5326, 'MOD_TM_STYLE_SWITCHER', 'TM Ajax Style Switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.ini'),
(5327, 'MOD_TM_STYLE_SWITCHER_XML_DESCRIPTION', '<p>Helps you setup template color scheme.</p>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.ini'),
(5328, 'MOD_TM_STYLE_SWITCHER_BOX_LABEL', 'The customization tool allows you to make color changes in your theme.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.ini'),
(5329, 'MOD_TM_STYLE_SWITCHER_BOX_DESC', 'Click save to keep your changes and update color scheme.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.ini'),
(5330, 'MOD_TM_STYLE_SWITCHER_DEMO', 'This option is not available in the demo version', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.ini'),
(5331, 'MOD_TM_STYLE_SWITCHER', 'TM Ajax Style Switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.sys.ini'),
(5332, 'MOD_TM_STYLE_SWITCHER_XML_DESCRIPTION', 'Helps you setup template color scheme.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_tm_style_switcher.sys.ini'),
(5333, 'MOD_USERS_LATEST', 'Latest Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5334, 'MOD_USERS_LATEST_FIELD_FILTER_GROUPS_DESC', 'Choose to filter by groups of the connected user.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5335, 'MOD_USERS_LATEST_FIELD_FILTER_GROUPS_LABEL', 'Filter Groups', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5336, 'MOD_USERS_LATEST_FIELD_LINKTOWHAT_DESC', 'Choose the type of information to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5337, 'MOD_USERS_LATEST_FIELD_LINKTOWHAT_LABEL', 'User Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5338, 'MOD_USERS_LATEST_FIELD_NUMBER_DESC', 'Number of latest registered users to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5339, 'MOD_USERS_LATEST_FIELD_NUMBER_LABEL', 'Number of Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(5340, 'MOD_USERS_LATEST_FIELD_VALUE_CONTACT', 'Contact', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5341, 'MOD_USERS_LATEST_FIELD_VALUE_PROFILE', 'Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5342, 'MOD_USERS_LATEST_XML_DESCRIPTION', 'This module displays the latest registered users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.ini'),
(5343, 'MOD_USERS_LATEST', 'Latest Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.sys.ini'),
(5344, 'MOD_USERS_LATEST_XML_DESCRIPTION', 'This module displays the latest registered users.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.sys.ini'),
(5345, 'MOD_USERS_LATEST_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_users_latest.sys.ini'),
(5346, 'MOD_WEBLINKS', 'Weblinks', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5347, 'MOD_WEBLINKS_FIELD_CATEGORY_DESC', 'Choose the Web Links category to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5348, 'MOD_WEBLINKS_FIELD_COUNT_DESC', 'Number of Web Links to display.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5349, 'MOD_WEBLINKS_FIELD_COUNT_LABEL', 'Count', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5350, 'MOD_WEBLINKS_FIELD_COUNTCLICKS_DESC', 'If set to yes, the number of times the link has been clicked will be recorded.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5351, 'MOD_WEBLINKS_FIELD_COUNTCLICKS_LABEL', 'Count Clicks', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5352, 'MOD_WEBLINKS_FIELD_DESCRIPTION_DESC', 'Display Web Link description.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5353, 'MOD_WEBLINKS_FIELD_DESCRIPTION_LABEL', 'Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5354, 'MOD_WEBLINKS_FIELD_FOLLOW_DESC', 'Robots index - allow to follow or not.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5355, 'MOD_WEBLINKS_FIELD_FOLLOW_LABEL', 'Follow/No Follow', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5356, 'MOD_WEBLINKS_FIELD_HITS_DESC', 'Show hits.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5357, 'MOD_WEBLINKS_FIELD_HITS_LABEL', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5358, 'MOD_WEBLINKS_FIELD_ORDERDIRECTION_DESC', 'Set the ordering direction.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5359, 'MOD_WEBLINKS_FIELD_ORDERDIRECTION_LABEL', 'Direction', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5360, 'MOD_WEBLINKS_FIELD_ORDERING_DESC', 'Ordering for the Web Links.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5361, 'MOD_WEBLINKS_FIELD_ORDERING_LABEL', 'Ordering', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5362, 'MOD_WEBLINKS_FIELD_TARGET_DESC', 'Target browser window when the link is clicked.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5363, 'MOD_WEBLINKS_FIELD_TARGET_LABEL', 'Target Window', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5364, 'MOD_WEBLINKS_FIELD_VALUE_ASCENDING', 'Ascending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5365, 'MOD_WEBLINKS_FIELD_VALUE_DESCENDING', 'Descending', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5366, 'MOD_WEBLINKS_FIELD_VALUE_FOLLOW', 'Follow', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5367, 'MOD_WEBLINKS_FIELD_VALUE_HITS', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5368, 'MOD_WEBLINKS_FIELD_VALUE_NOFOLLOW', 'No follow', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5369, 'MOD_WEBLINKS_FIELD_VALUE_ORDER', 'Order', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5370, 'MOD_WEBLINKS_HITS', 'Hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5371, 'MOD_WEBLINKS_XML_DESCRIPTION', 'This modules displays web links from a category defined in the Web Links component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.ini'),
(5372, 'MOD_WEBLINKS', 'Web Links', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.sys.ini'),
(5373, 'MOD_WEBLINKS_XML_DESCRIPTION', 'This modules displays Web Links from a category defined in the Web Links component.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.sys.ini'),
(5374, 'MOD_WEBLINKS_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_weblinks.sys.ini'),
(5375, 'MOD_WHOSONLINE', 'Who\'s Online', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5376, 'MOD_WHOSONLINE_FIELD_FILTER_GROUPS_DESC', 'Choose to filter by groups of the connected user', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5377, 'MOD_WHOSONLINE_FIELD_FILTER_GROUPS_LABEL', 'Filter groups', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5378, 'MOD_WHOSONLINE_FIELD_LINKTOWHAT_DESC', 'Choose the type of information to display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5379, 'MOD_WHOSONLINE_FIELD_LINKTOWHAT_LABEL', 'Information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5380, 'MOD_WHOSONLINE_FIELD_VALUE_BOTH', 'Both', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5381, 'MOD_WHOSONLINE_FIELD_VALUE_CONTACT', 'Contact', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5382, 'MOD_WHOSONLINE_FIELD_VALUE_NAMES', 'Usernames', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5383, 'MOD_WHOSONLINE_FIELD_VALUE_NUMBER', '# of Guests / Users', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5384, 'MOD_WHOSONLINE_FIELD_VALUE_PROFILE', 'Profile', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5385, 'MOD_WHOSONLINE_GUESTS', '%s&#160;guests', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5386, 'MOD_WHOSONLINE_GUESTS_1', 'one guest', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5387, 'MOD_WHOSONLINE_GUESTS_0', 'no guests', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5388, 'MOD_WHOSONLINE_MEMBERS', '%s&#160;members', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5389, 'MOD_WHOSONLINE_MEMBERS_1', 'one member', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5390, 'MOD_WHOSONLINE_MEMBERS_0', 'no members', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5391, 'MOD_WHOSONLINE_SAME_GROUP_MESSAGE', 'List of Users who belong to your user groups or your user groups\' child groups', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5392, 'MOD_WHOSONLINE_SHOWMODE_DESC', 'Select what will be shown', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5393, 'MOD_WHOSONLINE_SHOWMODE_LABEL', 'Display', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5394, 'MOD_WHOSONLINE_XML_DESCRIPTION', 'The Who\'s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged-in) that are currently accessing the Web site.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5395, 'MOD_WHOSONLINE_WE_HAVE', 'We have %1$s and %2$s online', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.ini'),
(5396, 'MOD_WHOSONLINE', 'Who\'s Online', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.sys.ini'),
(5397, 'MOD_WHOSONLINE_XML_DESCRIPTION', 'The Who\'s Online Module displays the number of Anonymous Users (Guests) and Registered Users (users logged-in) that are currently accessing the website.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.sys.ini'),
(5398, 'MOD_WHOSONLINE_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_whosonline.sys.ini'),
(5399, 'MOD_WRAPPER', 'Wrapper', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5400, 'MOD_WRAPPER_FIELD_ADD_DESC', 'By default, http:// will be added unless it detects http:// or https:// in the URL you provide. This allows you to switch this ability off.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5401, 'MOD_WRAPPER_FIELD_ADD_LABEL', 'Auto Add', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5402, 'MOD_WRAPPER_FIELD_AUTOHEIGHT_DESC', 'The height will automatically be set to the size of the external page. This will only work for pages on your own domain.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5403, 'MOD_WRAPPER_FIELD_AUTOHEIGHT_LABEL', 'Auto Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5404, 'MOD_WRAPPER_FIELD_HEIGHT_DESC', 'Height of the iframe window.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5405, 'MOD_WRAPPER_FIELD_HEIGHT_LABEL', 'Height', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5406, 'MOD_WRAPPER_FIELD_SCROLL_DESC', 'Show/Hide horizontal &amp; vertical scroll bars.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5407, 'MOD_WRAPPER_FIELD_SCROLL_LABEL', 'Scroll Bars', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5408, 'MOD_WRAPPER_FIELD_TARGET_DESC', 'Name of the iframe when used as target.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5409, 'MOD_WRAPPER_FIELD_TARGET_LABEL', 'Target Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5410, 'MOD_WRAPPER_FIELD_URL_DESC', 'URL to site/file you wish to display within the iframe.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5411, 'MOD_WRAPPER_FIELD_URL_LABEL', 'URL', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5412, 'MOD_WRAPPER_FIELD_VALUE_AUTO', 'Auto', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5413, 'MOD_WRAPPER_FIELD_WIDTH_DESC', 'Width of the iframe window. You can enter an absolute figure in pixels or a relative figure by adding a %.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5414, 'MOD_WRAPPER_FIELD_WIDTH_LABEL', 'Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5415, 'MOD_WRAPPER_NO_IFRAMES', 'No iframes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5416, 'MOD_WRAPPER_XML_DESCRIPTION', 'This module shows an iframe window to specified location.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5417, 'MOD_WRAPPER_FIELD_FRAME_LABEL', 'Frame border', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5418, 'MOD_WRAPPER_FIELD_FRAME_DESC', 'Show frame border which wraps the iframe.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.ini'),
(5419, 'MOD_WRAPPER', 'Wrapper', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.sys.ini'),
(5420, 'MOD_WRAPPER_NO_IFRAMES', 'No iframes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.sys.ini'),
(5421, 'MOD_WRAPPER_XML_DESCRIPTION', 'This module shows an iframe window to specified location.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.sys.ini'),
(5422, 'MOD_WRAPPER_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.mod_wrapper.sys.ini'),
(5423, 'TPL_BEEZ3_ADDITIONAL_INFORMATION', 'Additional information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5424, 'TPL_BEEZ3_ALTCLOSE', 'is closed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5425, 'TPL_BEEZ3_ALTOPEN', 'is open', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5426, 'TPL_BEEZ3_BIGGER', 'Bigger', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5427, 'TPL_BEEZ3_CLICK', 'click', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5428, 'TPL_BEEZ3_CLOSEMENU', 'Close Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5429, 'TPL_BEEZ3_DECREASE_SIZE', 'Decrease size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5430, 'TPL_BEEZ3_ERROR_JUMP_TO_NAV', 'Jump to navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5431, 'TPL_BEEZ3_FIELD_BOOTSTRAP_DESC', 'Create a comma separated list of any components for which Bootstrap is needed, for example com_name, com_anothername.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5432, 'TPL_BEEZ3_FIELD_BOOTSTRAP_LABEL', 'Components Requiring<br /> Bootstrap', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5433, 'TPL_BEEZ3_FIELD_DESCRIPTION_DESC', 'Please add your site description here.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5434, 'TPL_BEEZ3_FIELD_DESCRIPTION_LABEL', 'Site Description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5435, 'TPL_BEEZ3_FIELD_HEADER_BACKGROUND_COLOR_DESC', 'Choose a colour for the Background if the custom colour option is selected. If left blank the Default (#eeeeee) is used.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5436, 'TPL_BEEZ3_FIELD_HEADER_BACKGROUND_COLOR_LABEL', 'Background Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5437, 'TPL_BEEZ3_FIELD_HEADER_IMAGE_DESC', 'Use the selected header image when the custom colour option is selected.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5438, 'TPL_BEEZ3_FIELD_HEADER_IMAGE_LABEL', 'Header Image', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5439, 'TPL_BEEZ3_FIELD_LOGO_DESC', 'Please choose an image. If you do not want to display a logo, click on Clear and leave the field blank.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5440, 'TPL_BEEZ3_FIELD_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5441, 'TPL_BEEZ3_FIELD_NAVPOSITION_DESC', 'Navigation before or after content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5442, 'TPL_BEEZ3_FIELD_NAVPOSITION_LABEL', 'Position of Navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5443, 'TPL_BEEZ3_FIELD_SITETITLE_DESC', 'Please add your site title here, it\'s only displayed if you don\'t use a logo.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5444, 'TPL_BEEZ3_FIELD_SITETITLE_LABEL', 'Site Title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5445, 'TPL_BEEZ3_FIELD_TEMPLATECOLOR_DESC', 'Colour of the template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5446, 'TPL_BEEZ3_FIELD_TEMPLATECOLOR_LABEL', 'Template Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5447, 'TPL_BEEZ3_FIELD_WRAPPERLARGE_DESC', 'Wrapper width with closed additional columns in percent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5448, 'TPL_BEEZ3_FIELD_WRAPPERLARGE_LABEL', 'Wrapper Large (%)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5449, 'TPL_BEEZ3_FIELD_WRAPPERSMALL_DESC', 'Wrapper width with opened additional columns in percent.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5450, 'TPL_BEEZ3_FIELD_WRAPPERSMALL_LABEL', 'Wrapper Small (%)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5451, 'TPL_BEEZ3_FONTSIZE', 'Font Size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5452, 'TPL_BEEZ3_INCREASE_SIZE', 'Increase size', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5453, 'TPL_BEEZ3_JUMP_TO_INFO', 'Jump to additional information', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5454, 'TPL_BEEZ3_JUMP_TO_NAV', 'Jump to main navigation and login', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5455, 'TPL_BEEZ3_NAVIGATION', 'Navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5456, 'TPL_BEEZ3_NAV_VIEW_SEARCH', 'Nav view search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5457, 'TPL_BEEZ3_NEXTTAB', 'Next Tab', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5458, 'TPL_BEEZ3_OPENMENU', 'Open Menu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5459, 'TPL_BEEZ3_OPTION_AFTER_CONTENT', 'after content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5460, 'TPL_BEEZ3_OPTION_BEFORE_CONTENT', 'before content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5461, 'TPL_BEEZ3_OPTION_IMAGE', 'Custom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5462, 'TPL_BEEZ3_OPTION_NATURE', 'Nature', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5463, 'TPL_BEEZ3_OPTION_PERSONAL', 'Personal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5464, 'TPL_BEEZ3_OPTION_RED', 'Red', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5465, 'TPL_BEEZ3_OPTION_TURQ', 'Turquoise', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5466, 'TPL_BEEZ3_POWERED_BY', 'Powered by', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5467, 'TPL_BEEZ3_RESET', 'Reset', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5468, 'TPL_BEEZ3_REVERT_STYLES_TO_DEFAULT', 'Revert styles to default', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5469, 'TPL_BEEZ3_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5470, 'TPL_BEEZ3_SKIP_TO_CONTENT', 'Skip to content', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5471, 'TPL_BEEZ3_SKIP_TO_ERROR_CONTENT', 'Jump to error message and search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5472, 'TPL_BEEZ3_SMALLER', 'Smaller', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5473, 'TPL_BEEZ3_SYSTEM_MESSAGE', 'Error', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5474, 'TPL_BEEZ3_TEXTRIGHTCLOSE', 'Close info', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5475, 'TPL_BEEZ3_TEXTRIGHTOPEN', 'Open info', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5476, 'TPL_BEEZ3_XML_DESCRIPTION', 'Accessible template for Joomla! Beez, the HTML 4 version.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5477, 'TPL_BEEZ3_YOUR_SITE_DESCRIPTION', 'Your site description', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(5478, 'TPL_BEEZ3_POSITION_DEBUG', 'Debug', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5479, 'TPL_BEEZ3_POSITION_POSITION-0', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5480, 'TPL_BEEZ3_POSITION_POSITION-10', 'Footer middle', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5481, 'TPL_BEEZ3_POSITION_POSITION-11', 'Footer bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5482, 'TPL_BEEZ3_POSITION_POSITION-12', 'Middle top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5483, 'TPL_BEEZ3_POSITION_POSITION-13', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5484, 'TPL_BEEZ3_POSITION_POSITION-14', 'Footer last', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5485, 'TPL_BEEZ3_POSITION_POSITION-15', 'Header', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5486, 'TPL_BEEZ3_POSITION_POSITION-1', 'Top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5487, 'TPL_BEEZ3_POSITION_POSITION-2', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5488, 'TPL_BEEZ3_POSITION_POSITION-3', 'Right bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5489, 'TPL_BEEZ3_POSITION_POSITION-4', 'Left middle', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5490, 'TPL_BEEZ3_POSITION_POSITION-5', 'Left bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5491, 'TPL_BEEZ3_POSITION_POSITION-6', 'Right top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5492, 'TPL_BEEZ3_POSITION_POSITION-7', 'Left top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5493, 'TPL_BEEZ3_POSITION_POSITION-8', 'Right middle', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5494, 'TPL_BEEZ3_POSITION_POSITION-9', 'Footer top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5495, 'TPL_BEEZ3_XML_DESCRIPTION', 'Accessible template for Joomla! Beez, the HTML 4 version.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(5496, 'TPL_PROTOSTAR_XML_DESCRIPTION', 'Continuing the space theme (Solarflare from 1.0 and Milkyway from 1.5), Protostar is the Joomla 3 site template based on Bootstrap from Twitter and the launch of the Joomla User Interface library (JUI).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5497, 'TPL_PROTOSTAR_BACKGROUND_COLOR_DESC', 'Choose a background colour for static layouts. If left blank the Default (#f4f6f7) is used.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5498, 'TPL_PROTOSTAR_BACKGROUND_COLOR_LABEL', 'Background Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5499, 'TPL_PROTOSTAR_BACKTOTOP', 'Back to Top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5500, 'TPL_PROTOSTAR_COLOR_DESC', 'Choose an overall colour for the site template. If left blank the Default (#0088cc) is used.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5501, 'TPL_PROTOSTAR_COLOR_LABEL', 'Template Colour', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5502, 'TPL_PROTOSTAR_FLUID', 'Fluid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5503, 'TPL_PROTOSTAR_FLUID_LABEL', 'Fluid Layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5504, 'TPL_PROTOSTAR_FLUID_DESC', 'Use Bootstrap\'s Fluid or Static Container (both are Responsive).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5505, 'TPL_PROTOSTAR_FONT_LABEL', 'Google Font for Headings', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5506, 'TPL_PROTOSTAR_FONT_DESC', 'Load a Google font for the headings (H1, H2, H3, etc).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5507, 'TPL_PROTOSTAR_FONT_NAME_LABEL', 'Google Font Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5508, 'TPL_PROTOSTAR_FONT_NAME_DESC', 'Example: Open+Sans or Source+Sans+Pro.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5509, 'TPL_PROTOSTAR_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5510, 'TPL_PROTOSTAR_LOGO_DESC', 'Upload a custom logo for the site template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5511, 'TPL_PROTOSTAR_STATIC', 'Static', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(5512, 'TPL_PROTOSTAR_POSITION_BANNER', 'Banner', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5513, 'TPL_PROTOSTAR_POSITION_DEBUG', 'Debug', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5514, 'TPL_PROTOSTAR_POSITION_POSITION-0', 'Search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5515, 'TPL_PROTOSTAR_POSITION_POSITION-10', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5516, 'TPL_PROTOSTAR_POSITION_POSITION-11', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5517, 'TPL_PROTOSTAR_POSITION_POSITION-12', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5518, 'TPL_PROTOSTAR_POSITION_POSITION-13', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5519, 'TPL_PROTOSTAR_POSITION_POSITION-14', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5520, 'TPL_PROTOSTAR_POSITION_POSITION-15', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5521, 'TPL_PROTOSTAR_POSITION_POSITION-1', 'Navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5522, 'TPL_PROTOSTAR_POSITION_POSITION-2', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5523, 'TPL_PROTOSTAR_POSITION_POSITION-3', 'Top centre', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5524, 'TPL_PROTOSTAR_POSITION_POSITION-4', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5525, 'TPL_PROTOSTAR_POSITION_POSITION-5', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5526, 'TPL_PROTOSTAR_POSITION_POSITION-6', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5527, 'TPL_PROTOSTAR_POSITION_POSITION-7', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5528, 'TPL_PROTOSTAR_POSITION_POSITION-8', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5529, 'TPL_PROTOSTAR_POSITION_POSITION-9', 'Unused', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5530, 'TPL_PROTOSTAR_POSITION_FOOTER', 'Footer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5531, 'TPL_PROTOSTAR_XML_DESCRIPTION', 'Continuing the space theme (Solarflare from 1.0 and Milkyway from 1.5), Protostar is the Joomla 3 site template based on Bootstrap from Twitter and the launch of the Joomla User Interface library (JUI).', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(5532, 'DATE_FORMAT_LC', 'l, d F Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5533, 'DATE_FORMAT_LC2', 'l, d F Y H:i', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5534, 'DATE_FORMAT_LC3', 'd F Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5535, 'DATE_FORMAT_LC4', 'Y-m-d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5536, 'DATE_FORMAT_JS1', 'y-m-d', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5537, 'DATE_FORMAT_TPL1', 'M d, Y', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5538, 'DATE_FORMAT_TPL2', 'd', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5539, 'DATE_FORMAT_TPL3', 'M', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5540, 'TPL_THEME_LAYOUT_LABEL', 'Theme layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5541, 'TPL_THEME_LAYOUT_DESC', 'Please choose theme layout. Fluid or fixed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5542, 'TPL_FIXED', 'Fixed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5543, 'TPL_FLUID', 'Fluid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5544, 'TPL_LOGO_LABEL', '<b>Logo Settings</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5545, 'TPL_LOGO_DESC', 'Set the Logo parameters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5546, 'TPL_THEME_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5547, 'TPL_THEME_LOGO_DESC', 'Upload a custom logo for the site template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5548, 'TPL_LOGO_WIDTH', 'Logo Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5549, 'TPL_LOGO_WIDTH_DESC', 'Please select logo container grid width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5550, 'TPL_FOOTER_LABEL', '<b>Footer Settings</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5551, 'TPL_FOOTER_DESC', 'Set the Footer parameters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5552, 'TPL_FOOTER_LOGO_LABEL', 'Show Footer Logo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5553, 'TPL_THEME_FOOTER_LOGO_LABEL', 'Footer Logo', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5554, 'TPL_THEME_FOOTER_LOGO_DESC', 'Upload a custom footer logo for the site template.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5555, 'TPL_FOOTER_WIDTH', 'Footer Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5556, 'TPL_FOOTER_WIDTH_DESC', 'Please select footer container grid width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5557, 'TPL_COPY_LABEL', 'Show &copy;', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5558, 'TPL_YEAR_LABEL', 'Show Year', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5559, 'TPL_PRIVACY_LINK_LABEL', 'Privacy Policy Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5560, 'PRIVACY_LINK_MENU_LABEL', 'Privacy Policy Item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5561, 'PRIVACY_LINK_TITLE_LABEL', 'Privacy Policy Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5562, 'TPL_TERMS_LINK_LABEL', 'Terms of Use Link', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5563, 'TERMS_LINK_MENU_LABEL', 'Terms of Use Item', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5564, 'TERMS_LINK_TITLE_LABEL', 'Terms of Use Label', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5565, 'TPL_THEME_ASIDE_LEFT_WIDTH', 'Left Sidebar Width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5566, 'TPL_THEME_ASIDE_RIGHT_WIDTH', 'Right Sidebar width', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5567, 'TPL_THEME_ASIDE_LEFT_WIDTH_DESC', 'Set left sidebar width in grid columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5568, 'TPL_THEME_ASIDE_RIGHT_WIDTH_DESC', 'Set right sidebar width in grid columns', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5569, 'TPL_THEME_TOTOP', 'To Top button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5570, 'TPL_THEME_TOTOP_DESC', 'Please select if you want to display To Top button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5571, 'TPL_THEME_TOTOP_TEXT', 'Totop text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5572, 'TPL_THEME_TOTOP_TEXT_DESC', 'Please input toptop button text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5573, 'TPL_THEME_TODESKTOP', 'To Desktop button', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5574, 'TPL_THEME_TODESKTOP_DESC', 'Please select if you want to display To Desktop button at mobile devices', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5575, 'TPL_THEME_TODESKTOP_TEXT', 'Todesktop text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5576, 'TPL_THEME_TODESKTOP_TEXT_DESC', 'Please input todeskptop button text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5577, 'TPL_THEME_TOMOBILE_TEXT', 'Tomobile text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5578, 'TPL_THEME_TOMOBILE_TEXT_DESC', 'Please input tomobile button text', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5579, 'TPL_SPACER_ASIDES_LABEL', '<b>Asides:</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5580, 'TPL_SPACER_ASIDES_DESC', 'set grid width for the left and right sidebars.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5581, 'TPL_FIELDSET_LAYOUT', 'Layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5582, 'TPL_FIELDSET_GRID', 'Grid', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5583, 'TPL_FIELDSET_FEATURES', 'Features', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5584, 'TPL_FIELDSET_TYPOGRAPHY', 'Typography', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5585, 'TPL_PAGE_HEADING_LABEL', 'Page heading', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5586, 'TPL_ITEM_HEADING_LABEL', 'Item heading', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5587, 'TPL_PAGE_HEADING_DESC', 'Set tag for the page heading title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5588, 'TPL_ITEM_HEADING_DESC', 'Set tag for the item title', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5589, 'TPL_SPACER_CATEGORY_TYPO_LABEL', '<b>Category View:</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5590, 'TPL_SPACER_BLOG_TYPO_LABEL', '<b>Blog View:</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5591, 'TPL_SPACER_ITEM_TYPO_LABEL', '<b>Item View:</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5592, 'TPL_SPACER_FEATURED_TYPO_LABEL', '<b>Featured View:</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5593, 'TPL_ITEM_BLOG_HEADING_LABEL', 'Item heading (Blog)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5594, 'TPL_ITEM_BLOG_HEADING_DESC', 'Set tag for the item title. (Blog item view)', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5595, 'TPL_SPACER_FEATURED_TYPO_DESC', 'Applies for the Featured Articles page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5596, 'TPL_SPACER_CATEGORY_TYPO_DESC', 'Applies for the Category Articles, Gallery View and Archived Articles pages', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5597, 'TPL_SPACER_BLOG_TYPO_DESC', 'Applies for the Category Blog page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5598, 'TPL_SPACER_ITEM_TYPO_DESC', 'Applies for the Single Article page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5599, 'SOCIAL_SHARING_CODE_LABEL', 'Social Sharing', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5600, 'SOCIAL_SHARING_CODE_DESC', 'Social sharing code. Displayed under the article content.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5601, 'TPL_SPACER_TOTOP_LABEL', '<b>To top button</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5602, 'TPL_SPACER_TOTOP_DESC', 'To top batton parameters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5603, 'TPL_SPACER_TODESKTOP_LABEL', '<b>Back to desktop version button</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5604, 'TPL_SPACER_TODESKTOP_DESC', 'Back to desktop version button parameters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5605, 'TPL_SPACER_BLACK_AND_WHITE_LABEL', '<b>jQuery Black&White plugin</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5606, 'TPL_SPACER_BLACK_AND_WHITE_DESC', 'jQuery Black&White plugin parameters', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5607, 'TPL_BLACK_AND_WHITE', 'jQuery Black&White plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5608, 'TPL_BLACK_AND_WHITE_DESC', 'Enable or disable jQuery Black&White plugin', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5609, 'TPL_INVERT_HOVER_EFFECT', 'Invert hover effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5610, 'TPL_ANIMATION_IN_SPEED', 'Animation in speed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5611, 'TPL_ANIMATION_OUT_SPEED', 'Animation out speed', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5612, 'TPL_IN', 'in %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5613, 'TPL_ON', 'on %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5614, 'TPL_BY', 'by %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5615, 'TPL_WITH', 'with %s', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5616, 'TPL_HITS', 'hits', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5617, 'TPL_VIEWS', 'views', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5618, 'TPL_COM_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5619, 'TPL_ZOOM', 'Zoom In', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5620, 'TPL_COM_CONTENT_READ_MORE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5621, 'TPL_COM_CONTENT_READ_MORE_TITLE', 'Read more', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5622, 'TPL_RESET', 'Forgot your password?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5623, 'TPL_REMIND', 'Forgot your username?', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5624, 'TPL_CONTACT_ADDRESS', 'Address:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5625, 'TPL_CONTACT_PHONES', 'Phones:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5626, 'TPL_CONTACT_MAILTO', 'E-mail:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5627, 'TPL_CONTACT_MISC', 'Miscellaneous information:', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5628, 'TPL_THEME_MOD_FOOTER_ALL_RIGHTS_RESERVED', 'All rights reserved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5629, 'TPL_COM_CONTENT_GALLERY_FILTER_SHOW_ALL', 'Show all', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5630, 'TPL_COM_CONTENT_GALLERY_FILTER_BY_CATEGORY', 'Filter by category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5631, 'TPL_COM_CONTENT_GALLERY_SORT', 'Sort', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5632, 'TPL_COM_CONTENT_GALLERY_FILTER_NAME', 'Name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5633, 'TPL_COM_CONTENT_GALLERY_FILTER_DATE', 'Date', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5634, 'TPL_COM_CONTENT_GALLERY_FILTER_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5635, 'TPL_COM_CONTENT_GALLERY_FILTER_POPULARITY', 'Popularity', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5636, 'TPL_GALLERY_SHOW_FILTER_LABEL', 'Show Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5637, 'TPL_GALLERY_SHOW_FILTER_DESC', 'Select if you want to display Isotope filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5638, 'TPL_GALLERY_SHOW_SORT_LABEL', 'Show Sort', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5639, 'TPL_GALLERY_SHOW_SORT_DESC', 'Select if you want to display Isotope sort', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5640, 'TPL_GALLERY_SORT_EFFECT_LABEL', 'Sorting effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5641, 'TPL_GALLERY_SORT_EFFECT_DESC', 'Separated by comma, enclosed in quotes', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5642, 'TPL_COM_CONTENT_LAYOUT_MODE', 'Layout mode', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5643, 'TPL_PRIVACY_POLICY', 'Privacy policy', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5644, 'TPL_TERMS_OF_USE', 'Terms of use', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5645, 'TPL_ALL_RIGHTS_RESERVED', 'All rights reserved', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5646, 'COM_CONTENT_NONE', 'None', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5647, 'TPL_MOD_LOGIN_VALUE_USERNAME', 'User name', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5648, 'TPL_MOD_LOGIN_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5649, 'TPL_COM_KOMENTO_FORM_SUBMIT', 'Submit comment', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5650, 'TPL_KOMENTO_FRONTPAGE_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5651, 'JGLOBAL_SECRETKEY_HELP', 'If you have enabled two factor<br> authentication in your user account please<br> enter your secret key. If you do not know<br> what this means, you can leave this field<br> blank.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5652, 'TPL_FORGOT', 'Forgot', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5653, 'TPL_SPACER_COUNTDOWN_LABEL', '<b>Offline Countdown</b>', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5654, 'TPL_COUNTDOWN_TIME_LABEL', 'Offline Countdown Time', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(5655, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_TITLE', 'Gallery View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5656, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_OPTION', 'Gallery', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5657, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_DESC', 'Gallery category view with Isotope plugin integrated.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5658, 'TPL_GALLERY_SHOW_FILTER_LABEL', 'Show Filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5659, 'TPL_GALLERY_SHOW_FILTER_DESC', 'Select if you want to display Isotope filter', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5660, 'TPL_GALLERY_SHOW_SORT_LABEL', 'Show Sort', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5661, 'TPL_GALLERY_SHOW_SORT_DESC', 'Select if you want to display Isotope sort', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5662, 'TPL_GALLERY_SORT_EFFECT_LABEL', 'Sorting effect', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5663, 'TPL_GALLERY_SORT_EFFECT_DESC', 'Separated by comma, enclosed in quotes. The available effects are \'fade\', \'scale\', \'rotateZ\', \'rotateX\'*, \'rotateY\'*, \'blur\'*, and \'grayscale\'*.<br><br>*These effects are not supported on certain older CSS3 compatible browsers and will not show.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5664, 'TPL_GALLERY_SHOW_LAYOUT_MODE_LABEL', 'Layout mode switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5665, 'TPL_GALLERY_SHOW_LAYOUT_MODE_DESC', 'Show layout mode switcher', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5666, 'TPL_GALLERY_IMAGE_FLOAT_LABEL', 'Image Align', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5667, 'TPL_GALLERY_IMAGE_FLOAT_DESC', 'Select article image align for the gallery view.', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5668, 'TPL_LEFT', 'Left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5669, 'TPL_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5670, 'TPL_HOVER_INFO', 'Use css hover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5671, 'TPL_HOVER_INFO_DESC', 'Use css hover', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5672, 'TPL_HOVER_INFO_STYLE', 'Css hover style', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5673, 'TPL_HOVER_INFO_STYLE_DESC', 'Please choose a css hover style', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5674, 'TPL_COM_CONTENT_LIMIT_INTRO_LABEL', 'Words limit in intro section', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5675, 'TPL_COM_CONTENT_LIMIT_INTRO_DESC', 'Words limit in intro section', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5676, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_TITLE', 'Team View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5677, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_OPTION', 'Team', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5678, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_DESC', 'Team category view layout', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5679, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_TITLE', 'FAQs View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5680, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_OPTION', 'FAQs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5681, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_DESC', 'Page layout in Frequently Asked Questions format. Based on definition list markup', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5682, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_TITLE', 'Blog View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5683, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_OPTION', 'Blog View', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5684, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_DESC', 'Category template for Blog page', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5685, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_TITLE', 'Category Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5686, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_OPTION', 'Category Articles', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5687, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_DESC', 'Outputs articles from the specified category', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5688, 'TPL_theme3589_POSITION_DEBUG', 'debug', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5689, 'TPL_theme3589_POSITION_TOP', 'top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5690, 'TPL_theme3589_POSITION_HEADER', 'header', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5691, 'TPL_theme3589_POSITION_NAVIGATION', 'navigation', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5692, 'TPL_theme3589_POSITION_BREADCRUMBS', 'breadcrumbs', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5693, 'TPL_theme3589_POSITION_SHOWCASE', 'showcase', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5694, 'TPL_theme3589_POSITION_FEATURE', 'feature', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5695, 'TPL_theme3589_POSITION_MAINTOP', 'maintop', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5696, 'TPL_theme3589_POSITION_CONTENT-TOP', 'content-top', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5697, 'TPL_theme3589_POSITION_ASIDE-LEFT', 'aside-left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5698, 'TPL_theme3589_POSITION_ASIDE-RIGHT', 'aside-right', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5699, 'TPL_theme3589_POSITION_CONTENT-BOTTOM', 'content-bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5700, 'TPL_theme3589_POSITION_VIDEO', 'video', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5701, 'TPL_theme3589_POSITION_MAINBOTTOM', 'mainbottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5702, 'TPL_theme3589_POSITION_MAINBOTTOM-2', 'mainbottom-2', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5703, 'TPL_theme3589_POSITION_MAINBOTTOM-3', 'mainbottom-3', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5704, 'TPL_theme3589_POSITION_MAINBOTTOM-4', 'mainbottom-4', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5705, 'TPL_theme3589_POSITION_MAINBOTTOM-5', 'mainbottom-5', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5706, 'TPL_theme3589_POSITION_BOTTOM', 'bottom', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5707, 'TPL_theme3589_POSITION_FOOTER', 'footer', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5708, 'TPL_theme3589_POSITION_COPYRIGHT', 'copyright', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5709, 'TPL_theme3589_POSITION_MODAL', 'modal', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5710, 'TPL_theme3589_POSITION_404-SEARCH', '404-search', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5711, 'TPL_theme3589_POSITION_MEGAMENU', 'megamenu', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(5712, 'TPL_theme3589_POSITION_FIXED-SIDEBAR-LEFT', 'fixed-sidebar-left', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5713, 'TPL_CHANGE_POSITION_BUTTON', 'Select', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5714, 'COM_MODULES_CHANGE_POSITION_TITLE', 'Change', 'C:\\wamp\\www\\framework\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(5715, 'COM_KUNENA_ANN_DELETED', 'Announcement deleted', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5716, 'COM_KUNENA_ANN_SUCCESS_ADD', 'Announcement Added', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5717, 'COM_KUNENA_ANN_SUCCESS_EDIT', 'Announcement Edited', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5718, 'COM_KUNENA_ANN_SUCCESS_PUBLISH', 'Announcement \'%s\' has been successfully published!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5719, 'COM_KUNENA_ANN_SUCCESS_UNPUBLISH', 'Announcement \'%s\' has been successfully unpublished!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5720, 'COM_KUNENA_GEN_ALL_MARKED', 'All posts have been marked as read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5721, 'COM_KUNENA_GEN_CATEGORY_NAME_UNSUBCRIBED', 'You have been unsubscribed from the %s category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5722, 'COM_KUNENA_GEN_CATEGORY_SUBCRIBED', 'You have been subscribed to this category and will get notified by mail about new posts.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5723, 'COM_KUNENA_GEN_FORUM_MARKED', 'All posts in this category have been marked as read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5724, 'COM_KUNENA_WARNING_MENU_LOOP', 'Redirection loop detected inside your menu!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5725, 'COM_KUNENA_WARNING_MENU_NOT_EXISTS', 'Default Menu Item in <em>Entry Page</em> is pointing to missing or unauthorized menu item.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5726, 'COM_KUNENA_WARNING_MENU_NOT_KUNENA', 'Default Menu Item in <em>Entry Page</em> is not pointing to Kunena.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5727, 'COM_KUNENA_MODERATE_APPROVE_SUCCESS', 'Messages successfully approved.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5728, 'COM_KUNENA_POST_NO_UNFAVORITED_TOPIC', 'This topic has <strong>NOT</strong> been removed from your favorites.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5729, 'COM_KUNENA_POST_NO_UNSUBSCRIBED_TOPIC', 'This topic has <strong>NOT</strong> been removed from your subscriptions.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5730, 'COM_KUNENA_POST_SUCCESS_DELETE', 'The message has been successfully deleted.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5731, 'COM_KUNENA_POST_SUCCESS_MOVE', 'The Topic has been successfully moved.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5732, 'COM_KUNENA_POST_SUCCESS_UNDELETE', 'The message has been successfully restored.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5733, 'COM_KUNENA_FORUM', 'Forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5734, 'COM_KUNENA_POLL_CREATED', 'The poll has been successfully created', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5735, 'COM_KUNENA_POLL_DELETED', 'The poll has been successfully deleted', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5736, 'COM_KUNENA_POLL_EDITED', 'The poll has been successfully edited', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5737, 'COM_KUNENA_POST_FAVORITED_TOPIC', 'This topic has been added to your favorites.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5738, 'COM_KUNENA_POST_LOCK_NOT_SET', 'The topic could not be locked.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5739, 'COM_KUNENA_POST_LOCK_NOT_UNSET', 'The topic could not be unlocked.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5740, 'COM_KUNENA_POST_LOCK_UNSET', 'The topic has been unlocked.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5741, 'COM_KUNENA_POST_NO_FAVORITED_TOPIC', 'This topic has <strong>NOT</strong> been added to your favorites', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5742, 'COM_KUNENA_POST_NO_SUBSCRIBED_TOPIC', 'Your subscription to this topic could not be processed.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5743, 'COM_KUNENA_POST_STICKY_NOT_SET', 'The sticky bit could not be set for this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5744, 'COM_KUNENA_POST_STICKY_NOT_UNSET', 'The sticky bit could not be unset for this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5745, 'COM_KUNENA_POST_STICKY_SET', 'The sticky bit has been set for this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5746, 'COM_KUNENA_POST_STICKY_UNSET', 'The sticky bit has been unset for this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5747, 'COM_KUNENA_POST_SUBSCRIBED_TOPIC', 'You have been subscribed to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5748, 'COM_KUNENA_POST_SUCCESS_EDIT', 'The message has been successfully edited.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5749, 'COM_KUNENA_POST_SUCCESS_POSTED', 'Your message has been successfully posted.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5750, 'COM_KUNENA_POST_SUCCES_REVIEW', 'Your message has been successfully posted. It will be reviewed by a moderator before it will be published on the forum.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5751, 'COM_KUNENA_POST_TOPIC_FLOOD', 'The administrator of this forum has enabled flood protection. You must wait %d seconds before you can make another post.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5752, 'COM_KUNENA_POST_UNFAVORITED_TOPIC', 'This thread has been removed from your favorites.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5753, 'COM_KUNENA_POST_UNSUBSCRIBED_TOPIC', 'This thread has been removed from your subscriptions.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5754, 'COM_KUNENA_REPORT_FORG0T_SUB_MES', 'You have forgot to enter a reason or a message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5755, 'COM_KUNENA_REPORT_MSG', 'Message Reported', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5756, 'COM_KUNENA_REPORT_NOT_SEND', 'The report can\'t be sent', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5757, 'COM_KUNENA_REPORT_POST_LINK', 'Message Link:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5758, 'COM_KUNENA_REPORT_POST_MESSAGE', 'Message:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5759, 'COM_KUNENA_REPORT_POST_POSTER', 'Message Poster:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5760, 'COM_KUNENA_REPORT_POST_SUBJECT', 'Message Subject:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5761, 'COM_KUNENA_REPORT_RMESSAGE', 'Report Message:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5762, 'COM_KUNENA_REPORT_RREASON', 'Report Reason:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5763, 'COM_KUNENA_REPORT_RSENDER', 'Report Sender:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5764, 'COM_KUNENA_REPORT_SUCCESS', 'Report successfully sent!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5765, 'COM_KUNENA_THANKYOU_REMOVED_SUCCESS', 'Thank you removed successfully', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5766, 'COM_KUNENA_THANKYOU_SUCCESS', 'You left a Thank You for this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5767, 'COM_KUNENA_TOPIC_SUCCESS_DELETE', 'The topic has been successfully deleted.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5768, 'COM_KUNENA_TOPIC_SUCCESS_UNDELETE', 'The topic has been successfully restored.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5769, 'COM_KUNENA_TOPIC_VOTE_CHANGED_SUCCESS', 'You have changed your vote!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5770, 'COM_KUNENA_TOPIC_VOTE_RESET_SUCCESS', 'Votes reseted successfully', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5771, 'COM_KUNENA_TOPIC_VOTE_SUCCESS', 'You have given your vote!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5772, 'COM_KUNENA_BULKMSG_DELETED', 'Posts were deleted successfully', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5773, 'COM_KUNENA_CONTROLLER_NO_TASK', 'No task selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5774, 'COM_KUNENA_NO_MESSAGES_SELECTED', 'No messages selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5775, 'COM_KUNENA_NO_TOPICS_SELECTED', 'No topics selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5776, 'COM_KUNENA_USER_UNFAVORITE_YES', 'You have unfavorited the topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5777, 'COM_KUNENA_USER_UNSUBSCRIBE_YES', 'You have been unsubscribed from the topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5778, 'COM_KUNENA_ATTACHMENTS_DELETE_FAILED', 'Delete attachments has failed', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5779, 'COM_KUNENA_ATTACHMENTS_DELETE_SUCCESSFULLY', '%s attachments have been deleted successfully', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5780, 'COM_KUNENA_ATTACHMENTS_NO_ATTACHMENTS_SELECTED', 'You have forgot to select attachments', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5781, 'COM_KUNENA_KARMA_DECREASED', 'User\'s karma decreased.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5782, 'COM_KUNENA_KARMA_INCREASED', 'User\'s karma increased.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5783, 'COM_KUNENA_KARMA_SELF_DECREASE', 'Please do not attempt to decrease your own karma!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5784, 'COM_KUNENA_KARMA_SELF_INCREASE', 'Your karma has been decreased for attempting to increase it yourself!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5785, 'COM_KUNENA_KARMA_WAIT', 'You can modify only one person\'s karma every six hours. <br />Please wait until this timeout period has passed before modifying any person\'s karma again.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5786, 'COM_KUNENA_MODERATE_DELETED_BAD_AVATAR', 'The offending avatar has been removed successfully.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5787, 'COM_KUNENA_MODERATE_DELETED_BAD_AVATAR_FILESYSTEM', ' and it has been deleted from the file system.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5788, 'COM_KUNENA_MODERATE_DELETED_BAD_MESSAGES', 'All posts written by the user have been deleted successfully.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5789, 'COM_KUNENA_MODERATE_DELETED_BAD_PROFILEINFO', 'The offending profile information has been removed successfully.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5790, 'COM_KUNENA_MODERATE_DELETED_BAD_SIGNATURE', 'The offending signature has been removed successfully.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5791, 'COM_KUNENA_PROFILE_AVATAR_UPLOADED', 'Avatar uploaded successfully.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5792, 'COM_KUNENA_PROFILE_PASSWORD_MISMATCH', 'Passwords do not match!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5793, 'COM_KUNENA_PROFILE_PASSWORD_NOT_MINIMUM', 'You must enter a password with at least 5 characters', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5794, 'COM_KUNENA_PROFILE_SAVED', 'Your profile has been saved.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5795, 'COM_KUNENA_USER_ERROR_KARMA', 'You came to this page in error. Please inform the administrator which link is the cause of the error.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5796, 'COM_KUNENA_USER_UNBANNED_DONE', 'User ban successfully removed.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5797, 'COM_KUNENA_USER_UNBLOCKED_DONE', 'User account successfully enabled.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5798, 'COM_KUNENA_PROFILE_AVATAR_NOT_SAVED', 'Avatar couldn\'t be saved!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5799, 'COM_KUNENA_STOPFORUMSPAM_REPORT_SUCCESS', 'The user has been successfully reported to stopforumspam.com', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5800, 'COM_KUNENA_STOPFORUMSPAM_REPORT_FAILED', 'Error while reporting the user to stopforumspam.com. Reason given: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5801, 'COM_KUNENA_GEN_CATEGORY_UNSUBCRIBED', 'You have been unsubscribed from this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5802, 'COM_KUNENA_POST_ALREADY_SUBSCRIBED_TOPIC', 'You have already subscribed to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.controllers.ini'),
(5803, 'COM_KUNENA_ACCESS', 'Access', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5804, 'COM_KUNENA_ADMIN', 'Category Manager', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5805, 'COM_KUNENA_ADMIN_POLLS', 'Polls', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5806, 'COM_KUNENA_ADVANCEDDESC', 'Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5807, 'COM_KUNENA_ADVANCEDDESCINFO', 'Category Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5808, 'COM_KUNENA_ADVANCEDDISPINFO', 'Category Display', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5809, 'COM_KUNENA_ANN_ID', 'ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5810, 'COM_KUNENA_ATTACH', 'Attachment', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5811, 'COM_KUNENA_A_ACCESSTYPE_DESC', 'Access control type to be used in this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5812, 'COM_KUNENA_A_ACCESSTYPE_TITLE', 'Access Control Type:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5813, 'COM_KUNENA_A_CATEGORY_ALIAS', 'Alias:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5814, 'COM_KUNENA_A_DISPLAY', 'Display #', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5815, 'COM_KUNENA_A_POLL_CATEGORIES_ALLOWED', 'Allow Polls', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5816, 'COM_KUNENA_A_POLL_CATEGORIES_ALLOWED_DESC', 'Set to <em>Yes</em>, if you would like to allow polls in this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5817, 'COM_KUNENA_BASICSFORUMINFO', 'Category Name and Description', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5818, 'COM_KUNENA_BY', 'by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5819, 'COM_KUNENA_CANCEL', 'Cancel', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5820, 'COM_KUNENA_CATEGORY', 'Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5821, 'COM_KUNENA_CATEGORY_ANONYMOUS', 'Anonymous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5822, 'COM_KUNENA_CATEGORY_ANONYMOUS_ALLOW', 'Allow anonymous messages', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5823, 'COM_KUNENA_CATEGORY_ANONYMOUS_ALLOW_DESC', 'Anonymous messages can be used by registered users to post sensitive information to this category: <b>No user related information</b> will be stored with anonymous messages (including IP address).', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5824, 'COM_KUNENA_CATEGORY_ANONYMOUS_DEFAULT', 'By default post replies as', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5825, 'COM_KUNENA_CATEGORY_ANONYMOUS_DEFAULT_DESC', 'If anonymous messages have been enabled, this option selects the default choice for the user. Regular users can later edit their own posts to be anonymous, but only moderators have the ability to edit anonymous posts.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5826, 'COM_KUNENA_CATEGORY_CHANNELS', 'Category Channels', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5827, 'COM_KUNENA_CATEGORY_CHANNELS_DESC', '<em>Category Channels</em> allows you to change which topics people will see when they enter to the category. Feature allows you to create <strong>Category Aliases</strong>, <strong>Multi-Category Announcements</strong> and <strong>Category Collections</strong>.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5828, 'COM_KUNENA_CATEGORY_INFO', 'Basic Information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5829, 'COM_KUNENA_CATEGORY_PERMISSIONS', 'Category Permissions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5830, 'COM_KUNENA_CATEGORY_SUBSCRIPTIONS', 'Category Subscriptions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5831, 'COM_KUNENA_CATEGORY_TOPIC_ORDERING', 'Order Topics By', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5832, 'COM_KUNENA_CATEGORY_TOPIC_ORDERING_DESC', 'Select default topic ordering inside this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5833, 'COM_KUNENA_CATID', 'ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5834, 'COM_KUNENA_CHECKEDOUT', 'Check Out', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5835, 'COM_KUNENA_CLASS_SFX', 'Category CSS Class Suffix', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5836, 'COM_KUNENA_CLASS_SFXDESC', 'CSS suffixes applied to index, showcat, view, and allow for different designs per category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5837, 'COM_KUNENA_DESCRIPTIONADD', 'Description:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5838, 'COM_KUNENA_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5839, 'COM_KUNENA_EDITOR_INSERT', 'Insert', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5840, 'COM_KUNENA_EMAIL_DISABLED', 'No emails were sent (request was made from localhost)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5841, 'COM_KUNENA_EMAIL_INVALID', 'Forum tried to send email from invalid address. Please contact site administrator!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5842, 'COM_KUNENA_ERROR1', 'Section/Category must have a name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5843, 'COM_KUNENA_ERROR_TOKEN', 'You have entered information to an obsolete form from another session. Please verify that the user account is yours and please try again!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5844, 'COM_KUNENA_FILENAME', 'File Name:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5845, 'COM_KUNENA_FILESIZE', 'File Size:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5846, 'COM_KUNENA_FILTER', 'Filter', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5847, 'COM_KUNENA_GEN_EMAIL', 'E-mail', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5848, 'COM_KUNENA_GEN_REMOVE_FILE', 'Remove File', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5849, 'COM_KUNENA_GEN_SUBJECT', 'Subject', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5850, 'COM_KUNENA_GO', 'Go', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5851, 'COM_KUNENA_HEADERADD', 'Category Header:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5852, 'COM_KUNENA_LIB_HTML_DISPLAY_NUM', 'Display #', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5853, 'COM_KUNENA_LOCKED', 'Locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5854, 'COM_KUNENA_LOCKED1', 'Locked:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5855, 'COM_KUNENA_LOCKEDDESC', 'Set to <em>Yes</em> if you want to lock this category. Nobody but Moderators and Admins can create new topics or replies in a locked category (or move posts to it).', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5856, 'COM_KUNENA_MESSAGE', 'Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5857, 'COM_KUNENA_MODERATORS', 'Moderators', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5858, 'COM_KUNENA_MODHEADER', 'Moderation settings for this category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5859, 'COM_KUNENA_MODNEWDESC', 'Moderation', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5860, 'COM_KUNENA_MODSASSIGNED', 'Moderators assigned to this category:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5861, 'COM_KUNENA_MYPROFILE_BIRTHDATE', 'Birthdate', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5862, 'COM_KUNENA_MYPROFILE_GENDER', 'Gender', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5863, 'COM_KUNENA_MYPROFILE_LOCATION', 'Location', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5864, 'COM_KUNENA_MYPROFILE_WEBSITE', 'Web site', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5865, 'COM_KUNENA_NAMEADD', 'Name:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5866, 'COM_KUNENA_NO', 'No', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5867, 'COM_KUNENA_NOMODS', 'There are no Moderators assigned to this category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5868, 'COM_KUNENA_NO_ACCESS', 'You do not have permissions to access this page.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5869, 'COM_KUNENA_PAGE', 'Page:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5870, 'COM_KUNENA_PARENT', 'Parent:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5871, 'COM_KUNENA_PARENTDESC', 'Hint: To create a section, choose <em>Top Level</em> as the parent. A section is a container for categories.<br />Messages can be <strong>only</strong> posted to categories within sections.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5872, 'COM_KUNENA_PERMISSIONS', 'Permissions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5873, 'COM_KUNENA_PMS_INBOX', 'Private Messages', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5874, 'COM_KUNENA_PUBLISHED', 'Published', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5875, 'COM_KUNENA_REORDER', 'Reorder', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5876, 'COM_KUNENA_RESET', 'Reset', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5877, 'COM_KUNENA_REV', 'Review posts:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5878, 'COM_KUNENA_REVDESC', 'Set to <em>Yes</em> if you want posts to be reviewed by moderators prior to publishing them in this category. This is useful in a moderated categories only!<br />If you set this without any moderators specified, the site admin is solely responsible for approving/deleting submitted posts since these will be kept \'on hold\'!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5879, 'COM_KUNENA_REVIEW', 'Review', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5880, 'COM_KUNENA_SECTION', 'Section', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5881, 'COM_KUNENA_SHOW_12_HOURS', '12 Hours', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5882, 'COM_KUNENA_SHOW_24_HOURS', '24 Hours', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5883, 'COM_KUNENA_SHOW_48_HOURS', '48 Hours', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5884, 'COM_KUNENA_SHOW_4_HOURS', '4 Hours', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5885, 'COM_KUNENA_SHOW_8_HOURS', '8 Hours', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5886, 'COM_KUNENA_SHOW_LASTVISIT', 'Since last visit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5887, 'COM_KUNENA_SHOW_MONTH', 'Month', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5888, 'COM_KUNENA_SHOW_WEEK', 'Week', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5889, 'COM_KUNENA_SHOW_YEAR', 'Year', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5890, 'COM_KUNENA_STAT_FORUMSTATS', 'Forum Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5891, 'COM_KUNENA_SUBSCRIPTIONS', 'Subscriptions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5892, 'COM_KUNENA_TOPIC_LAST_LINK_TITLE', 'View Last Post in Topic \'%s\'', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5893, 'COM_KUNENA_UPLOAD_ERROR_CANT_WRITE', 'Failed to write file to disk.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5894, 'COM_KUNENA_UPLOAD_ERROR_EXTRA_CHUNK', 'Extra chunk in AJAX.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5895, 'COM_KUNENA_UPLOAD_ERROR_NOT_UPLOADED', 'File was not uploaded.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5896, 'COM_KUNENA_UPLOAD_ERROR_NO_FILE', 'No file was uploaded.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5897, 'COM_KUNENA_UPLOAD_ERROR_NO_TMP_DIR', 'Missing a temporary folder.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5898, 'COM_KUNENA_UPLOAD_ERROR_PARTIAL', 'The uploaded file was only partially uploaded.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5899, 'COM_KUNENA_UPLOAD_ERROR_PHP_EXTENSION', 'A PHP extension stopped the file upload.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5900, 'COM_KUNENA_UPLOAD_ERROR_SIZE', 'The file size exceeds the maximum set by the administrator.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5901, 'COM_KUNENA_UPLOAD_ERROR_UNKNOWN', 'Unknown error encountered.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5902, 'COM_KUNENA_UPLOAD_FAILED', 'Failed to upload file \'%s\'', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5903, 'COM_KUNENA_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5904, 'COM_KUNENA_USERNAME_ANONYMOUS', 'Anonymous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5905, 'COM_KUNENA_USER_BANNED_DONE', 'User successfully banned.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5906, 'COM_KUNENA_USER_BLOCKED_DONE', 'User account successfully blocked.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5907, 'COM_KUNENA_USER_ORDER_ASC', 'First post first', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5908, 'COM_KUNENA_USER_ORDER_DESC', 'Last post first', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5909, 'COM_KUNENA_USRL_AVATAR', 'Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5910, 'COM_KUNENA_USRL_HITS', 'Hits', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5911, 'COM_KUNENA_USRL_POSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5912, 'COM_KUNENA_VIEW_CATEGORY_LIST_CATEGORY_TITLE', 'View Category \'%s\'', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5913, 'COM_KUNENA_YES', 'Yes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5914, 'COM_KUNENA_AVATAR_UPLOAD_NOT_VALID_EXTENSIONS', 'The extensions allowed for avatar upload are : %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5915, 'COM_KUNENA_STATS_NOT_ALLOWED_TOSEE_STATS', 'You aren\'t allowed to see statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5916, 'COM_KUNENA_BUTTON_ANNOUNCEMENT_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5917, 'COM_KUNENA_BUTTON_ANNOUNCEMENT_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5918, 'COM_KUNENA_BUTTON_ANNOUNCEMENT_LIST', 'Control Panel', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5919, 'COM_KUNENA_BUTTON_CATEGORY_MANAGE', 'Manage Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5920, 'COM_KUNENA_BUTTON_CATEGORY_MANAGE_LONG', 'Enter to Category Manager.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5921, 'COM_KUNENA_BUTTON_CATEGORY_MARKREAD', 'Mark Topics Read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5922, 'COM_KUNENA_BUTTON_CATEGORY_MARKREAD_LONG', 'Mark all topics in this categeory as read.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5923, 'COM_KUNENA_BUTTON_CATEGORY_SUBSCRIBE', 'Subscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5924, 'COM_KUNENA_BUTTON_CATEGORY_SUBSCRIBE_LONG', 'Subscribe to this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5925, 'COM_KUNENA_BUTTON_CATEGORY_UNSUBSCRIBE', 'Unsubscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5926, 'COM_KUNENA_BUTTON_CATEGORY_UNSUBSCRIBE_LONG', 'Unsubscribe from this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5927, 'COM_KUNENA_BUTTON_FORUM_MARKREAD', 'Mark Everything Read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5928, 'COM_KUNENA_BUTTON_FORUM_MARKREAD_LONG', 'Mark all topics as read.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5929, 'COM_KUNENA_BUTTON_LAYOUT_FLAT', 'Flat', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5930, 'COM_KUNENA_BUTTON_LAYOUT_FLAT_LONG', 'Display messages in flat layout.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5931, 'COM_KUNENA_BUTTON_LAYOUT_INDENTED', 'Indented', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5932, 'COM_KUNENA_BUTTON_LAYOUT_INDENTED_LONG', 'Display messages in indented layout.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5933, 'COM_KUNENA_BUTTON_LAYOUT_THREADED', 'Threaded', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5934, 'COM_KUNENA_BUTTON_LAYOUT_THREADED_LONG', 'Display messages in tree-like layout.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5935, 'COM_KUNENA_BUTTON_MESSAGE_APPROVE', 'Approve', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5936, 'COM_KUNENA_BUTTON_MESSAGE_APPROVE_LONG', 'Approve this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5937, 'COM_KUNENA_BUTTON_MESSAGE_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5938, 'COM_KUNENA_BUTTON_MESSAGE_DELETE_LONG', 'Delete this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5939, 'COM_KUNENA_BUTTON_MESSAGE_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5940, 'COM_KUNENA_BUTTON_MESSAGE_EDIT_LONG', 'Edit this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5941, 'COM_KUNENA_BUTTON_MESSAGE_MODERATE', 'Moderate', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5942, 'COM_KUNENA_BUTTON_MESSAGE_MODERATE_LONG', 'Moderate this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5943, 'COM_KUNENA_BUTTON_MESSAGE_PERMDELETE', 'Permanently Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5944, 'COM_KUNENA_BUTTON_MESSAGE_PERMDELETE_LONG', 'Permanently delete this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5945, 'COM_KUNENA_BUTTON_MESSAGE_QUICKREPLY', 'Quick Reply', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5946, 'COM_KUNENA_BUTTON_MESSAGE_QUICKREPLY_LONG', 'Quick reply this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5947, 'COM_KUNENA_BUTTON_MESSAGE_QUOTE', 'Quote', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5948, 'COM_KUNENA_BUTTON_MESSAGE_QUOTE_LONG', 'Quote this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5949, 'COM_KUNENA_BUTTON_MESSAGE_REPLY', 'Reply', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5950, 'COM_KUNENA_BUTTON_MESSAGE_REPLY_LONG', 'Reply to this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5951, 'COM_KUNENA_BUTTON_MESSAGE_REPORT', 'Report This', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5952, 'COM_KUNENA_BUTTON_MESSAGE_REPORT_LONG', 'Report this message to moderators.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5953, 'COM_KUNENA_BUTTON_MESSAGE_THANKYOU', 'Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5954, 'COM_KUNENA_BUTTON_MESSAGE_THANKYOU_LONG', 'I want to thank you for this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5955, 'COM_KUNENA_BUTTON_MESSAGE_UNDELETE', 'Restore', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5956, 'COM_KUNENA_BUTTON_MESSAGE_UNDELETE_LONG', 'Restore this message.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5957, 'COM_KUNENA_BUTTON_SECTION_MARKREAD', 'Mark All Categories Read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5958, 'COM_KUNENA_BUTTON_TOPIC_CREATE', 'New Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5959, 'COM_KUNENA_BUTTON_TOPIC_CREATE_LONG', 'Create a new topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5960, 'COM_KUNENA_BUTTON_TOPIC_DELETE', 'Delete Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5961, 'COM_KUNENA_BUTTON_TOPIC_DELETE_LONG', 'Delete this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5962, 'COM_KUNENA_BUTTON_TOPIC_FAVORITE', 'Favorite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5963, 'COM_KUNENA_BUTTON_TOPIC_FAVORITE_LONG', 'Favorite this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5964, 'COM_KUNENA_BUTTON_TOPIC_LOCK', 'Lock', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5965, 'COM_KUNENA_BUTTON_TOPIC_LOCK_LONG', 'Lock this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5966, 'COM_KUNENA_BUTTON_TOPIC_MODERATE', 'Moderate Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5967, 'COM_KUNENA_BUTTON_TOPIC_MODERATE_LONG', 'Moderate this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5968, 'COM_KUNENA_BUTTON_TOPIC_REPLY', 'Reply Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5969, 'COM_KUNENA_BUTTON_TOPIC_REPLY_LONG', 'Reply to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5970, 'COM_KUNENA_BUTTON_TOPIC_STICKY', 'Sticky', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5971, 'COM_KUNENA_BUTTON_TOPIC_STICKY_LONG', 'Sticky this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5972, 'COM_KUNENA_BUTTON_TOPIC_SUBSCRIBE', 'Subscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5973, 'COM_KUNENA_BUTTON_TOPIC_SUBSCRIBE_LONG', 'Subscribe to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5974, 'COM_KUNENA_BUTTON_TOPIC_UNFAVORITE', 'Unfavorite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5975, 'COM_KUNENA_BUTTON_TOPIC_UNFAVORITE_LONG', 'Unfavorite this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5976, 'COM_KUNENA_BUTTON_TOPIC_UNLOCK', 'Unlock', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5977, 'COM_KUNENA_BUTTON_TOPIC_UNLOCK_LONG', 'Unlock this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5978, 'COM_KUNENA_BUTTON_TOPIC_UNSTICKY', 'Unsticky', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5979, 'COM_KUNENA_BUTTON_TOPIC_UNSTICKY_LONG', 'Unsticky this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5980, 'COM_KUNENA_BUTTON_TOPIC_UNSUBSCRIBE', 'Unsubscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5981, 'COM_KUNENA_BUTTON_TOPIC_UNSUBSCRIBE_LONG', 'Unsubscribe from this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5982, 'COM_KUNENA_BUTTON_TOPIC_UNDELETE', 'Restore Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5983, 'COM_KUNENA_BUTTON_TOPIC_UNDELETE_LONG', 'Restore this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5984, 'COM_KUNENA_BUTTON_UNSUBSCRIBE_CATEGORY', 'Unsubscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5985, 'COM_KUNENA_BUTTON_UNSUBSCRIBE_CATEGORY_LONG', 'Unsubscribe from category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5986, 'COM_KUNENA_THANKYOU_GOT_FROM', 'Received Thank You From', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5987, 'COM_KUNENA_THANKYOU_SAID_TO', 'Said Thank You To', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5988, 'COM_KUNENA_READMORE', 'Read More...', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5989, 'COM_KUNENA_ANN_ANNOUNCEMENTS', 'Announcements', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5990, 'COM_KUNENA_A_GEN_NEWCHAR', 'NEW', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5991, 'COM_KUNENA_BACK', 'Back', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5992, 'COM_KUNENA_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5993, 'COM_KUNENA_EDITOR_HELPLINE_OPTION', 'Poll: Option for the poll', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5994, 'COM_KUNENA_ERROR_SESSION_SAVE_FAILED', 'Kunena: Failed to save session information!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5995, 'COM_KUNENA_GEN_MODERATED', 'Category is moderated. Reviewed prior to publishing.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5996, 'COM_KUNENA_MANAGE_ATTACHMENTS', 'Attachment Manager', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5997, 'COM_KUNENA_MYPROFILE_GENDER_FEMALE', 'Female', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5998, 'COM_KUNENA_MYPROFILE_GENDER_MALE', 'Male', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(5999, 'COM_KUNENA_MYPROFILE_GENDER_UNKNOWN', 'Unknown', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6000, 'COM_KUNENA_PMS_INBOX_NEW', 'New Private Messages: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6001, 'COM_KUNENA_POST_LOCK_SET', 'The topic has been locked.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6002, 'COM_KUNENA_SEARCH_ADVSEARCH', 'Advanced Search', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6003, 'COM_KUNENA_SEARCH_SORTBY_VIEWS', 'Number of views', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6004, 'COM_KUNENA_TOGGLER_COLLAPSE', 'Collapse', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6005, 'COM_KUNENA_TOGGLER_EXPAND', 'Expand', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6006, 'COM_KUNENA_USRL_SEARCH', 'Find user', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.ini'),
(6007, 'COM_KUNENA_APPROVE_SELECTED', 'Approve selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6008, 'COM_KUNENA_BULK_CHOOSE_ACTION', '- Choose Action -', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6009, 'COM_KUNENA_BUTTON_PERMDELETE_LONG', 'Permanent Delete selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6010, 'COM_KUNENA_BUTTON_UNDELETE_LONG', 'Undelete selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(6011, 'COM_KUNENA_DELETE_SELECTED', 'Delete selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6012, 'COM_KUNENA_MOVE_SELECTED', 'Move selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6013, 'COM_KUNENA_UNSUBSCRIBE_SELECTED', 'Unsubscribe selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6014, 'COM_KUNENA_BULK_ANNOUNCEMENT_PUBLISH', 'Publish', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6015, 'COM_KUNENA_BULK_ANNOUNCEMENT_UNPUBLISH', 'Unpublish', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6016, 'COM_KUNENA__BULK_ANNOUNCEMENT_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6017, 'COM_KUNENA_GEN_SEARCH_BOX', 'Search Forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6018, 'COM_KUNENA_SEARCH_ERR_NOPOSTS', 'No messages containing all your search terms were found.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6019, 'COM_KUNENA_SEARCH_ERR_SHORTKEYWORD', 'At least one keyword should be over three characters long.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6020, 'COM_KUNENA_SEARCH_NORESULTS_FOUND', 'Your search %s did not match any topics.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6021, 'COM_KUNENA_UNFAVORITE_SELECTED', 'Unfavorite selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.models.ini'),
(6022, 'COM_KUNENA_ICON_CROSS', 'Cross', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6023, 'COM_KUNENA_ICON_DEFAULT', 'Default Icon', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6024, 'COM_KUNENA_ICON_EXCLAMATION', 'Exclamation', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6025, 'COM_KUNENA_ICON_GRIN', 'Grinning', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6026, 'COM_KUNENA_ICON_IDEA', 'New Idea', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6027, 'COM_KUNENA_ICON_LOVE', 'In Love', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6028, 'COM_KUNENA_ICON_MERGED', 'Merged', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6029, 'COM_KUNENA_ICON_QUESTION', 'Question?', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6030, 'COM_KUNENA_ICON_SHOCK', 'Shocked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6031, 'COM_KUNENA_ICON_SMILE', 'Smiling', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6032, 'COM_KUNENA_ICON_SOLVED', 'Solved', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6033, 'COM_KUNENA_ANN_ADD', 'Add New', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6034, 'COM_KUNENA_ANN_CPANEL', 'Announcement Control Panel', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6035, 'COM_KUNENA_ANN_DATE', 'Date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6036, 'COM_KUNENA_ANN_DELETE', 'Delete', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6037, 'COM_KUNENA_ANN_EDIT', 'Edit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6038, 'COM_KUNENA_ANN_LONGTEXT', 'Long Text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6039, 'COM_KUNENA_ANN_PUBLISH', 'Publish', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6040, 'COM_KUNENA_ANN_READMORE', 'Read More...', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6041, 'COM_KUNENA_ANN_SHOWDATE', 'Show Date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6042, 'COM_KUNENA_ANN_SORTTEXT', 'Short Text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6043, 'COM_KUNENA_ANN_TITLE', 'Title', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6044, 'COM_KUNENA_ATTACHMENTS', 'Attachments:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6045, 'COM_KUNENA_AUP_POINTS', 'Points:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6046, 'COM_KUNENA_BAN_ADDCOMMENT', 'Add Comment', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6047, 'COM_KUNENA_BAN_ADDCOMMENT_DESC', 'You can write your own comments for other moderators', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6048, 'COM_KUNENA_BAN_BANHISTORY', 'Ban History', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6049, 'COM_KUNENA_BAN_BANHISTORYFOR', 'Ban history for %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6050, 'COM_KUNENA_BAN_BANLEVEL', 'Ban From', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6051, 'COM_KUNENA_BAN_BANLEVEL_JOOMLA', 'Site', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6052, 'COM_KUNENA_BAN_BANLEVEL_KUNENA', 'Forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6053, 'COM_KUNENA_BAN_BANMANAGER', 'Ban Manager', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6054, 'COM_KUNENA_BAN_BANNEDFROM', 'Banned From', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6055, 'COM_KUNENA_BAN_BANNEDUSER', 'Banned User', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6056, 'COM_KUNENA_BAN_COMMENT_BY', 'Comment by %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6057, 'COM_KUNENA_BAN_CREATEDBY', 'Banned by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6058, 'COM_KUNENA_BAN_EDIT', 'Edit Ban', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6059, 'COM_KUNENA_BAN_EXPIRETIME', 'End Time', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6060, 'COM_KUNENA_BAN_LIFETIME', 'Lifetime', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6061, 'COM_KUNENA_BAN_MODIFIEDBY', 'Modified by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6062, 'COM_KUNENA_BAN_NEW', 'New Ban', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6063, 'COM_KUNENA_BAN_NO_BANNED_USERS', 'There are no banned users.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6064, 'COM_KUNENA_BAN_PRIVATEREASON', 'Private Reason', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6065, 'COM_KUNENA_BAN_PRIVATEREASON_DESC', 'Private reason of ban viewable by moderators', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6066, 'COM_KUNENA_BAN_PUBLICREASON', 'Public Reason', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6067, 'COM_KUNENA_BAN_PUBLICREASON_DESC', 'Public reason of ban viewable by all', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6068, 'COM_KUNENA_BAN_STARTTIME', 'Start Time', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6069, 'COM_KUNENA_BAN_UNBAN_USER', 'Unban user', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6070, 'COM_KUNENA_BAN_UNBLOCK_USER', 'Activate user', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6071, 'COM_KUNENA_BAN_USERID', 'User Id', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6072, 'COM_KUNENA_BAN_USERNAME', 'Username', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6073, 'COM_KUNENA_BAN_USER_NOHISTORY', 'User %s has never been banned.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6074, 'COM_KUNENA_BBCODE_EDITOR_JAVASCRIPT_DISABLED', 'BBCode Editor Disabled: Please enable JavaScript in your browser', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6075, 'COM_KUNENA_BBCODE_EDITOR_JAVASCRIPT_LOADING', 'Loading BBCode editor...', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6076, 'COM_KUNENA_BOARDCODE', 'Boardcode', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6077, 'COM_KUNENA_BULK_CHOOSE_DESTINATION', '- Choose Destination -', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6078, 'COM_KUNENA_CAPDESC', 'Enter code here', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6079, 'COM_KUNENA_CATEGORY_SUBSCRIPTIONS_NONE', 'No category subscriptions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6080, 'COM_KUNENA_CATEGORY_X', 'Category: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6081, 'COM_KUNENA_CHECK_ALL', 'Check all', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6082, 'COM_KUNENA_COLOR_ADMINISTRATOR', 'Site Administrator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6083, 'COM_KUNENA_COLOR_BANNED', 'Banned', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6084, 'COM_KUNENA_COLOR_GLOBAL_MODERATOR', 'Global Moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6085, 'COM_KUNENA_COLOR_GUEST', 'Guest', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6086, 'COM_KUNENA_COLOR_MODERATOR', 'Moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6087, 'COM_KUNENA_COLOR_USER', 'User', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6088, 'COM_KUNENA_COPYRIGHT', 'Copyright', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6089, 'COM_KUNENA_EDITING_LASTEDIT', 'Last Edit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6090, 'COM_KUNENA_EDITING_REASON', 'Reason for Editing', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6091, 'COM_KUNENA_EDITOR_ATTACHMENTS', 'Attachments', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6092, 'COM_KUNENA_EDITOR_CODE_INSERT', 'Insert', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6093, 'COM_KUNENA_EDITOR_CODE_TYPE', 'Code', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6094, 'COM_KUNENA_EDITOR_ENLARGE', 'Enlarge', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6095, 'COM_KUNENA_EDITOR_HELPLINE_ADDPOLLOPTION', 'Poll: Add an option', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6096, 'COM_KUNENA_EDITOR_HELPLINE_CANCEL', 'Click here to cancel your message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6097, 'COM_KUNENA_EDITOR_HELPLINE_CODEAPPLY', 'Insert code', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6098, 'COM_KUNENA_EDITOR_HELPLINE_CODETYPE', 'Select a programming language', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6099, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_L', 'Fontsize: [size=4]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6100, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_M', 'Fontsize: [size=3]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6101, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_S', 'Fontsize: [size=2]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6102, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_XL', 'Fontsize: [size=5]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6103, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_XS', 'Fontsize: [size=1]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6104, 'COM_KUNENA_EDITOR_HELPLINE_FONTSIZE_XXL', 'Fontsize: [size=6]text size[/size] - Tip: sizes range from 1 to 6', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6105, 'COM_KUNENA_EDITOR_HELPLINE_HINT', 'bbCode Help - Tip: bbCode can be used on selected text!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6106, 'COM_KUNENA_EDITOR_HELPLINE_IMAGELINKAPPLY', 'Image link: Apply link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6107, 'COM_KUNENA_EDITOR_HELPLINE_IMAGELINKSIZE', 'Image link: Size', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6108, 'COM_KUNENA_EDITOR_HELPLINE_IMAGELINKURL', 'Image link: URL of the image link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6109, 'COM_KUNENA_EDITOR_HELPLINE_LINKAPPLY', 'Link: Apply link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6110, 'COM_KUNENA_EDITOR_HELPLINE_LINKTEXT', 'Link: Text / Description of the link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6111, 'COM_KUNENA_EDITOR_HELPLINE_LINKURL', 'Link: URL of the link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6112, 'COM_KUNENA_EDITOR_HELPLINE_POLLLIFESPAN', 'Poll: Add a life time for the poll (optional)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6113, 'COM_KUNENA_EDITOR_HELPLINE_POLLTITLE', 'Poll: Set a title for the poll', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6114, 'COM_KUNENA_EDITOR_HELPLINE_PREVIEW', 'Click here to see what your message will look like when submitted', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6115, 'COM_KUNENA_EDITOR_HELPLINE_REMPOLLOPTION', 'Poll: Remove an option', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6116, 'COM_KUNENA_EDITOR_HELPLINE_SUBMIT', 'Click here to submit your message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6117, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOAPPLY1', 'Video: [video size=100 width=480 height=360 provider=clipfish]3423432[/video]', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6118, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOAPPLY2', 'Video: [video size=100 width=480 height=360]http://myvideodomain.com/myvideo[/video]', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6119, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOHEIGHT', 'Video: Height of the video', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6120, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOID', 'Video: ID of the video - you can see it in the video URL', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6121, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOPROVIDER', 'Video: Select video provider', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6122, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOSIZE', 'Video: Size of the video', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6123, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOURL', 'Video: URL of the video', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6124, 'COM_KUNENA_EDITOR_HELPLINE_VIDEOWIDTH', 'Video: Width of the video', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6125, 'COM_KUNENA_EDITOR_IMAGELINK_SIZE', 'Size', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6126, 'COM_KUNENA_EDITOR_IMAGELINK_URL', 'URL', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6127, 'COM_KUNENA_EDITOR_LINK_TEXT', 'Text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6128, 'COM_KUNENA_EDITOR_LINK_URL', 'URL', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6129, 'COM_KUNENA_EDITOR_SHRINK', 'Shrink', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6130, 'COM_KUNENA_EDITOR_SIZE_SAMPLETEXT', 'Sample Text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6131, 'COM_KUNENA_EDITOR_TOPIC_TAGS', 'Topic Tags', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6132, 'COM_KUNENA_EDITOR_TOPIC_TAGS_OWN', 'My Own Tags', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6133, 'COM_KUNENA_EDITOR_VIDEO_HEIGHT', 'Height', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6134, 'COM_KUNENA_EDITOR_VIDEO_ID', 'ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6135, 'COM_KUNENA_EDITOR_VIDEO_INSERT', 'Insert video', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6136, 'COM_KUNENA_EDITOR_VIDEO_PROVIDER', 'Provider', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6137, 'COM_KUNENA_EDITOR_VIDEO_SIZE', 'Size', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6138, 'COM_KUNENA_EDITOR_VIDEO_URL', 'URL', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6139, 'COM_KUNENA_EDITOR_VIDEO_WIDTH', 'Width', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6140, 'COM_KUNENA_FAVORITES', 'Favorites', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6141, 'COM_KUNENA_FILES_DELETE', 'Delete selected', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6142, 'COM_KUNENA_FILE_EXTENSIONS_ALLOWED', 'Allowed file extensions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6143, 'COM_KUNENA_FORUM_SEARCH', 'Searched for: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6144, 'COM_KUNENA_GEN_HITS', 'Views', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6145, 'COM_KUNENA_GEN_LAST_POST', 'Last Post', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6146, 'COM_KUNENA_GEN_NAME', 'Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6147, 'COM_KUNENA_GEN_REPLIES', 'Replies', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6148, 'COM_KUNENA_GEN_TOPIC_ICON', 'Topic icon', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6149, 'COM_KUNENA_GLOBAL_SETTINGS', 'Global Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6150, 'COM_KUNENA_HIDDEN_USERS', 'Hidden Users', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6151, 'COM_KUNENA_LEGEND', 'Legend', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6152, 'COM_KUNENA_LICENSE', 'License', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6153, 'COM_KUNENA_LOGIN_PASSWORD', 'Password:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6154, 'COM_KUNENA_LOGIN_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6155, 'COM_KUNENA_LOGIN_USERNAME', 'Username:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6156, 'COM_KUNENA_MESSAGE_ADMINISTRATION', 'Unapproved', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6157, 'COM_KUNENA_MODERATE_DELETE_ALL_POSTS', 'Delete all posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6158, 'COM_KUNENA_MODERATE_DELETE_BAD_AVATAR', 'Delete offending avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6159, 'COM_KUNENA_MODERATE_DELETE_BAD_PROFILEINFO', 'Delete all the profile info', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6160, 'COM_KUNENA_MODERATE_DELETE_BAD_SIGNATURE', 'Delete offending signature', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6161, 'COM_KUNENA_MODERATE_REMOVE_BAN', 'Remove ban', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6162, 'COM_KUNENA_MODERATE_THIS_USER', 'Moderate this User', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6163, 'COM_KUNENA_MODERATION_CHANGE_SUBJECT_ON_REPLIES', 'Set the subject for all replies', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6164, 'COM_KUNENA_MODERATION_DEST', 'Move Into', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6165, 'COM_KUNENA_MODERATION_DEST_CATEGORY', 'Target Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6166, 'COM_KUNENA_MODERATION_DEST_TOPIC', 'Target Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6167, 'COM_KUNENA_MODERATION_MOVE_NEWER', 'Move selected message and all %s messages posted after it', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6168, 'COM_KUNENA_MODERATION_MOVE_SELECTED', 'Move only selected message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6169, 'COM_KUNENA_MODERATION_TITLE_DEST_SUBJECT', 'New Subject', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6170, 'COM_KUNENA_MODERATION_TITLE_SELECTED', 'Selected Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6171, 'COM_KUNENA_MODERATION_TOPIC_SHADOW', 'Leave shadow topic pointing to new location', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6172, 'COM_KUNENA_MORE', 'More', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6173, 'COM_KUNENA_MYPROFILE_ABOUTME', 'About Me', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6174, 'COM_KUNENA_MYPROFILE_BANINFO', 'Ban reason', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6175, 'COM_KUNENA_MYPROFILE_BIRTHDATE_DESC', 'Year (YYYY) - Month (MM) - Day (DD)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6176, 'COM_KUNENA_MYPROFILE_LASTVISITDATE', 'Last Visit Date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6177, 'COM_KUNENA_MYPROFILE_LOCAL_TIME', 'Local Time', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6178, 'COM_KUNENA_MYPROFILE_PERSONALTEXT', 'Personal Text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6179, 'COM_KUNENA_MYPROFILE_POSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6180, 'COM_KUNENA_MYPROFILE_PROFILEVIEW', 'Profile Views', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6181, 'COM_KUNENA_MYPROFILE_RANK', 'Rank', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6182, 'COM_KUNENA_MYPROFILE_REGISTERDATE', 'Register Date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6183, 'COM_KUNENA_MYPROFILE_SEND_MESSAGE', 'Send a message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6184, 'COM_KUNENA_MYPROFILE_SIGNATURE', 'Signature', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6185, 'COM_KUNENA_MYPROFILE_SIGNATURE_DESC', 'You can use smileys and BBCodes in your signature', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6186, 'COM_KUNENA_MYPROFILE_THANKYOU_RECEIVED', 'Thank you received:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6187, 'COM_KUNENA_MYPROFILE_TIMEZONE', 'Time Zone', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6188, 'COM_KUNENA_MYPROFILE_WEBSITE_NAME', 'Web site Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6189, 'COM_KUNENA_MYPROFILE_WEBSITE_NAME_DESC', 'Example: Kunena', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6190, 'COM_KUNENA_MYPROFILE_WEBSITE_URL', 'Web site URL', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6191, 'COM_KUNENA_MYPROFILE_WEBSITE_URL_DESC', 'Example: www.kunena.org', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6192, 'COM_KUNENA_NO_POSTS', 'No Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6193, 'COM_KUNENA_OFFLINE', 'OFFLINE', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6194, 'COM_KUNENA_ONLINE', 'NOW ONLINE', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6195, 'COM_KUNENA_PASS', 'Password:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6196, 'COM_KUNENA_POLLUSERS_MORE', 'See more', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6197, 'COM_KUNENA_POLL_ADD_POLL_OPTION', 'Add Poll Option', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6198, 'COM_KUNENA_POLL_BUTTON_VOTE', 'Vote', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6199, 'COM_KUNENA_POLL_NAME', 'Poll:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6200, 'COM_KUNENA_POLL_NOT_LOGGED', 'Only registered users can participate to this poll', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6201, 'COM_KUNENA_POLL_NO_VOTE', 'No votes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6202, 'COM_KUNENA_POLL_OPTIONS', 'Poll options', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6203, 'COM_KUNENA_POLL_REMOVE_POLL_OPTION', 'Remove Poll Option', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6204, 'COM_KUNENA_POLL_TIME_TO_LIVE', 'Poll life span (optional)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6205, 'COM_KUNENA_POLL_TITLE', 'Poll title', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6206, 'COM_KUNENA_POLL_VOTERS_TOTAL', 'Total number of voters:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6207, 'COM_KUNENA_POSTED_AT', 'Posted', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6208, 'COM_KUNENA_POSTS', 'Posts:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6209, 'COM_KUNENA_POST_AS_ANONYMOUS', 'Anonymous Post', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6210, 'COM_KUNENA_POST_AS_ANONYMOUS_DESC', 'This post contains sensitive information. Remove all user information from this post.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6211, 'COM_KUNENA_POST_EMAIL_NEVER', 'your e-mail address will never be displayed on the site.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6212, 'COM_KUNENA_POST_EMAIL_REGISTERED', 'your e-mail address will only be available to registered users.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6213, 'COM_KUNENA_POST_NOTIFIED', 'Check this box to be notified of replies to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6214, 'COM_KUNENA_POST_SUBSCRIBE', 'Subscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6215, 'COM_KUNENA_POST_TOPIC_HISTORY_LAST', 'posts  -  <em>(Last post first)</em>', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6216, 'COM_KUNENA_POST_TOPIC_HISTORY_MAX', 'Max. showing the last', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6217, 'COM_KUNENA_PREVIEW', 'Preview', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6218, 'COM_KUNENA_PROFILEBOX_CREATE_ACCOUNT', 'Create an account', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6219, 'COM_KUNENA_PROFILEBOX_FORGOT_PASSWORD', 'Forgot your password?', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6220, 'COM_KUNENA_PROFILEBOX_FORGOT_USERNAME', 'Forgot your username?', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6221, 'COM_KUNENA_PROFILEBOX_GUEST', 'Guest', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6222, 'COM_KUNENA_PROFILEBOX_LOGIN', 'Login', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6223, 'COM_KUNENA_PROFILEBOX_LOGOUT', 'Logout', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6224, 'COM_KUNENA_PROFILEBOX_WELCOME', 'Welcome', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6225, 'COM_KUNENA_PROFILE_AVATAR_DELETE', 'Use Default Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6226, 'COM_KUNENA_PROFILE_AVATAR_GALLERY', 'Select Avatar From Gallery', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6227, 'COM_KUNENA_PROFILE_AVATAR_KEEP', 'Keep Current Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6228, 'COM_KUNENA_PROFILE_EDIT_AVATAR', 'Avatar Image', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6229, 'COM_KUNENA_PROFILE_EDIT_AVATAR_TITLE', 'Change Avatar Image', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6230, 'COM_KUNENA_PROFILE_EDIT_PROFILE', 'Profile Information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6231, 'COM_KUNENA_PROFILE_EDIT_PROFILE_TITLE', 'Edit Profile Information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6232, 'COM_KUNENA_PROFILE_EDIT_SETTINGS', 'Forum Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6233, 'COM_KUNENA_PROFILE_EDIT_SETTINGS_TITLE', 'Edit Forum Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6234, 'COM_KUNENA_PROFILE_EDIT_USER', 'User Account', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6235, 'COM_KUNENA_PROFILE_EDIT_USER_TITLE', 'Edit User Information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6236, 'COM_KUNENA_QMESSAGE_NOTE', 'Note: BBcode and smileys are still usable.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6237, 'COM_KUNENA_REALNAME', 'Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6238, 'COM_KUNENA_REASON', 'Reason', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6239, 'COM_KUNENA_REPORT_MESSAGE', 'Your Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6240, 'COM_KUNENA_REPORT_REASON', 'Reason', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6241, 'COM_KUNENA_REPORT_SEND', 'Send Report', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6242, 'COM_KUNENA_REPORT_TO_MODERATOR', 'Report This Message To Moderators', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6243, 'COM_KUNENA_SAVE', 'Save', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6244, 'COM_KUNENA_SEARCH_EXACT', 'Exact Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6245, 'COM_KUNENA_SEARCH_FIND_POSTS', 'Find Posts from', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6246, 'COM_KUNENA_SEARCH_KEYWORDS', 'Keywords', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6247, 'COM_KUNENA_SEARCH_RESULTS', 'Search Results', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6248, 'COM_KUNENA_SEARCH_SEARCHBY_KEYWORD', 'Search by Keyword', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6249, 'COM_KUNENA_SEARCH_SEARCHBY_USER', 'Search by User Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6250, 'COM_KUNENA_SEARCH_SEARCHIN', 'Search in Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6251, 'COM_KUNENA_SEARCH_SEARCHIN_CHILDREN', 'Also search in sub-categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6252, 'COM_KUNENA_SEARCH_SEND', 'Search', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6253, 'COM_KUNENA_SEARCH_SHOW', 'Show', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6254, 'COM_KUNENA_SEARCH_SHOW_NORMAL', 'Normal Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6255, 'COM_KUNENA_SEARCH_SHOW_TRASHED', 'Deleted Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6256, 'COM_KUNENA_SEARCH_SHOW_UNAPPROVED', 'Unapproved Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6257, 'COM_KUNENA_SEARCH_SORTBY', 'Sort Results by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6258, 'COM_KUNENA_SEARCH_START', 'Jump to Result Number', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6259, 'COM_KUNENA_SEARCH_UNAME', 'User Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6260, 'COM_KUNENA_STAT_LATEST_MEMBERS', 'Latest Member', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6261, 'COM_KUNENA_STAT_MORE_ABOUT_STATS', 'More Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6262, 'COM_KUNENA_STAT_TODAY_OPEN_THREAD', 'Today Open', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6263, 'COM_KUNENA_STAT_TODAY_TOTAL_ANSWER', 'Today Total Answer', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6264, 'COM_KUNENA_STAT_TOTAL_CATEGORIES', 'Total Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6265, 'COM_KUNENA_STAT_TOTAL_MESSAGES', 'Total Messages', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6266, 'COM_KUNENA_STAT_TOTAL_SECTIONS', 'Total Sections', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6267, 'COM_KUNENA_STAT_TOTAL_SUBJECTS', 'Total Subjects', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6268, 'COM_KUNENA_STAT_TOTAL_USERS', 'Total Users', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6269, 'COM_KUNENA_STAT_YESTERDAY_OPEN_THREAD', 'Yesterday Open', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6270, 'COM_KUNENA_STAT_YESTERDAY_TOTAL_ANSWER', 'Yesterday Total Answer', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6271, 'COM_KUNENA_SUBMIT', 'Submit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6272, 'COM_KUNENA_TEMPLATE_ACTIVE_FONT_COLOR', 'Active Tab Font Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6273, 'COM_KUNENA_TEMPLATE_ACTIVE_FONT_COLOR_DESC', 'Enter the color of the font in active menu tabs.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6274, 'COM_KUNENA_TEMPLATE_ACTIVE_TAB_COLOR', 'Active Tab Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6275, 'COM_KUNENA_TEMPLATE_ACTIVE_TAB_COLOR_DESC', 'Enter the color of the menu tab when active.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6276, 'COM_KUNENA_TEMPLATE_ANNOUNCEMENT_BOX_BACKGROUND', 'Announcement Box Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6277, 'COM_KUNENA_TEMPLATE_ANNOUNCEMENT_HEADER_BACKGROUND', 'Announcement Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6278, 'COM_KUNENA_TEMPLATE_BOTTOM', 'Bottom', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6279, 'COM_KUNENA_TEMPLATE_BUTTON_BORDER_COLOR', 'Button Border Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6280, 'COM_KUNENA_TEMPLATE_BUTTON_BORDER_COLOR_DESC', 'Enter the color of button borders.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6281, 'COM_KUNENA_TEMPLATE_BUTTON_BORDER_HOVER_COLOR', 'Button Border Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6282, 'COM_KUNENA_TEMPLATE_BUTTON_BORDER_HOVER_COLOR_DESC', 'Enter the color of button borders when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6283, 'COM_KUNENA_TEMPLATE_BUTTON_COLOR', 'Button Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6284, 'COM_KUNENA_TEMPLATE_BUTTON_COLOR_DESC', 'Enter the color of buttons.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6285, 'COM_KUNENA_TEMPLATE_BUTTON_HOVER_COLOR', 'Button Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6286, 'COM_KUNENA_TEMPLATE_BUTTON_HOVER_COLOR_DESC', 'Enter the color of buttons when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6287, 'COM_KUNENA_TEMPLATE_BUTTON_SET', 'Button Set', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6288, 'COM_KUNENA_TEMPLATE_BUTTON_SET_BLACKBIRD', 'Blackbird', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6289, 'COM_KUNENA_TEMPLATE_BUTTON_SET_BLUEBIRD', 'Bluebird', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6290, 'COM_KUNENA_TEMPLATE_BUTTON_SET_DESC', 'Choose the button set to display in your forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6291, 'COM_KUNENA_TEMPLATE_BUTTON_SET_GRAYBIRD', 'Graybird', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6292, 'COM_KUNENA_TEMPLATE_BUTTON_SET_WHITEBIRD', 'Whitebird', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6293, 'COM_KUNENA_TEMPLATE_BUTTON_TEXT_COLOR', 'Button Text Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6294, 'COM_KUNENA_TEMPLATE_BUTTON_TEXT_COLOR_DESC', 'Enter the color of button text.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6295, 'COM_KUNENA_TEMPLATE_BUTTON_TEXT_HOVER_COLOR', 'Button Text Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6296, 'COM_KUNENA_TEMPLATE_BUTTON_TEXT_HOVER_COLOR_DESC', 'Enter the color of button text when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6297, 'COM_KUNENA_TEMPLATE_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6298, 'COM_KUNENA_TEMPLATE_EDITOR_ICON_SET', 'Editor Icon Set', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6299, 'COM_KUNENA_TEMPLATE_EDITOR_ICON_SET_DESC', 'Choose the Editor Icon Set (BBCode) to display in your forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6300, 'COM_KUNENA_TEMPLATE_FRONTSTATS_HEADER_BACKGROUND', 'Frontstats Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6301, 'COM_KUNENA_TEMPLATE_HEADER_BACKGROUND_COLOR_DESC', 'Insert the HEX code (#FF0000) or text code (red) to change the background of your forum header', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6302, 'COM_KUNENA_TEMPLATE_INACTIVE_FONT_COLOR', 'Inactive Tab Font Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6303, 'COM_KUNENA_TEMPLATE_INACTIVE_FONT_COLOR_DESC', 'Enter the color of the font in inactive menu tabs.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6304, 'COM_KUNENA_TEMPLATE_INACTIVE_TAB_COLOR', 'Inactive Tab Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6305, 'COM_KUNENA_TEMPLATE_INACTIVE_TAB_COLOR_DESC', 'Enter the color of the menu tab when inactive.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6306, 'COM_KUNENA_TEMPLATE_LEFT', 'Left', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6307, 'COM_KUNENA_TEMPLATE_PAGINATION_BORDER_COLOR', 'Pagination Border Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6308, 'COM_KUNENA_TEMPLATE_PAGINATION_BORDER_COLOR_DESC', 'Enter the color of pagination link borders.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6309, 'COM_KUNENA_TEMPLATE_PAGINATION_BORDER_HOVER_COLOR', 'Pagination Border Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6310, 'COM_KUNENA_TEMPLATE_PAGINATION_BORDER_HOVER_COLOR_DESC', 'Enter the color of pagination link borders when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6311, 'COM_KUNENA_TEMPLATE_PAGINATION_COLOR', 'Pagination Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6312, 'COM_KUNENA_TEMPLATE_PAGINATION_COLOR_DESC', 'Enter the color of pagination links.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6313, 'COM_KUNENA_TEMPLATE_PAGINATION_HOVER_COLOR', 'Pagination Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(6314, 'COM_KUNENA_TEMPLATE_PAGINATION_HOVER_COLOR_DESC', 'Enter the color of pagination links when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6315, 'COM_KUNENA_TEMPLATE_PAGINATION_TEXT_COLOR', 'Pagination Text Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6316, 'COM_KUNENA_TEMPLATE_PAGINATION_TEXT_COLOR_DESC', 'Enter the color of pagination link text.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6317, 'COM_KUNENA_TEMPLATE_PAGINATION_TEXT_HOVER_COLOR', 'Pagination Text Hover Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6318, 'COM_KUNENA_TEMPLATE_PAGINATION_TEXT_HOVER_COLOR_DESC', 'Enter the color of pagination link text when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6319, 'COM_KUNENA_TEMPLATE_PROFILEPOSITION_DESC', 'You can change the position of the profile avatar in the topic view. Default is <em>Right</em>', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6320, 'COM_KUNENA_TEMPLATE_PROFILE_ICON_SET', 'Profile Icon Set', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6321, 'COM_KUNENA_TEMPLATE_PROFILE_ICON_SET_DESC', 'Choose the Profile Icon Set to display in your forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6322, 'COM_KUNENA_TEMPLATE_PROFILE_POSITION', 'Profile Position', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6323, 'COM_KUNENA_TEMPLATE_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6324, 'COM_KUNENA_TEMPLATE_TOP', 'Top', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6325, 'COM_KUNENA_TEMPLATE_TOP_BORDER_COLOR', 'Menu Border Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6326, 'COM_KUNENA_TEMPLATE_TOP_BORDER_COLOR_DESC', 'Enter the color of the border below the tab menu.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6327, 'COM_KUNENA_TEMPLATE_WHOISONLINE_HEADER_BACKGROUND', 'Who is Online Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6328, 'COM_KUNENA_THANK_YOU', 'Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6329, 'COM_KUNENA_TITLE_MODERATE_TOPIC', 'Moderate Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6330, 'COM_KUNENA_TOPIC', 'TOPIC:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6331, 'COM_KUNENA_TOPICS', 'Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6332, 'COM_KUNENA_TOPIC_REPLIES_TITLE', 'Replies in Topic: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6333, 'COM_KUNENA_TOPIC_TAGS', 'Tags: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6334, 'COM_KUNENA_UNAME', 'User Name:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6335, 'COM_KUNENA_USERPOSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6336, 'COM_KUNENA_USER_NO_ATTACHMENTS', 'No attachments', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6337, 'COM_KUNENA_USER_PROFILE', 'Profile for', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6338, 'COM_KUNENA_USER_RETURN_B', 'click here', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6339, 'COM_KUNENA_USRL_EMAIL', 'E-mail', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6340, 'COM_KUNENA_USRL_JOIN_DATE', 'Join date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6341, 'COM_KUNENA_USRL_KARMA', 'Karma', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6342, 'COM_KUNENA_USRL_LAST_LOGIN', 'Last login', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6343, 'COM_KUNENA_USRL_ONLINE', 'Status', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6344, 'COM_KUNENA_USRL_USERLIST', 'Userlist', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6345, 'COM_KUNENA_VIEW_COMMON_ANNOUNCE_LIST', 'View Announcements', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6346, 'COM_KUNENA_VIEW_COMMON_FOOTER_TIME', 'Time to create page: %01.3f seconds', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6347, 'COM_KUNENA_VIEW_COMMON_WHO_TITLE', 'Who Is Online', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6348, 'COM_KUNENA_VIEW_COMMON_WHO_TOTAL', 'Total users online: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6349, 'COM_KUNENA_VPASS', 'Verify Password:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6350, 'COM_KUNENA_USER_ATTACHMENT_FILE_WEIGHT', 'KB', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6351, 'COM_KUNENA_ATTACHMENT_MANAGER_TOPIC', 'Topic link', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6352, 'COM_KUNENA_MODERATION_CHANGE_TOPIC_ICON', 'Change topic icon', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6353, 'COM_KUNENA_MYPROFILE_AIM_DESC', 'This is your AOL Instant Messenger nickname.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6354, 'COM_KUNENA_MYPROFILE_BEBO_DESC', 'This is your Bebo member ID.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6355, 'COM_KUNENA_MYPROFILE_BIRTHDAYREMIND', 'Remind me of this birthday', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6356, 'COM_KUNENA_MYPROFILE_BLOGSPOT_DESC', 'This is your Blogger username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6357, 'COM_KUNENA_MYPROFILE_CANNOT_SAVE_USERINFO', 'Can not save user information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6358, 'COM_KUNENA_MYPROFILE_DELICIOUS_DESC', 'This is your Delicious username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6359, 'COM_KUNENA_MYPROFILE_DIGG_DESC', 'This is your Digg username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6360, 'COM_KUNENA_MYPROFILE_EDIT_KUNENA', 'Edit profile details', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6361, 'COM_KUNENA_MYPROFILE_FACEBOOK_DESC', 'This is your Facebook username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6362, 'COM_KUNENA_MYPROFILE_FLICKR_DESC', 'This is your Flickr username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6363, 'COM_KUNENA_MYPROFILE_FORUM_SETTINGS', 'Forum Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6364, 'COM_KUNENA_MYPROFILE_FRIENDFEED_DESC', 'This is your FriendFeed username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6365, 'COM_KUNENA_MYPROFILE_GTALK_DESC', 'This is your Gtalk nickname.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6366, 'COM_KUNENA_MYPROFILE_ICQ_DESC', 'This is your ICQ number.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6367, 'COM_KUNENA_MYPROFILE_INBOX', 'Inbox', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6368, 'COM_KUNENA_MYPROFILE_LINKEDIN_DESC', 'This is your LinkedIn username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6369, 'COM_KUNENA_MYPROFILE_LOOK_AND_LAYOUT', 'Look and Layout', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6370, 'COM_KUNENA_MYPROFILE_MSN_DESC', 'Your MSN messenger e-mail address.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6371, 'COM_KUNENA_MYPROFILE_MYAVATAR', 'My Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6372, 'COM_KUNENA_MYPROFILE_MYSPACE_DESC', 'This is your MySpace username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6373, 'COM_KUNENA_MYPROFILE_MY_FAVORITES', 'My Favorites', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6374, 'COM_KUNENA_MYPROFILE_MY_POSTS', 'My Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6375, 'COM_KUNENA_MYPROFILE_MY_PROFILE_INFO', 'My Profile Info', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6376, 'COM_KUNENA_MYPROFILE_MY_SUBSCRIBES', 'My Subscriptions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6377, 'COM_KUNENA_MYPROFILE_NEW_MESSAGE', 'New Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6378, 'COM_KUNENA_MYPROFILE_OUTBOX', 'Outbox', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6379, 'COM_KUNENA_MYPROFILE_PERSONAL_INFO', 'Personal Info', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6380, 'COM_KUNENA_MYPROFILE_PLUGIN_SETTINGS', 'My Profile Plug-in Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6381, 'COM_KUNENA_MYPROFILE_PRIVATE_MESSAGING', 'Private Messaging', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6382, 'COM_KUNENA_MYPROFILE_SKYPE_DESC', 'This is your Skype handle.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6383, 'COM_KUNENA_MYPROFILE_SUMMARY', 'Summary', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6384, 'COM_KUNENA_MYPROFILE_TRASH', 'Trash', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6385, 'COM_KUNENA_MYPROFILE_TWITTER_DESC', 'This is your Twitter username.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6386, 'COM_KUNENA_MYPROFILE_YIM_DESC', 'This is your Yahoo! Instant Messenger nickname.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6387, 'COM_KUNENA_CANCEL_DESC', 'Click here to cancel', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6388, 'COM_KUNENA_ON_DATE', 'on %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6389, 'COM_KUNENA_TOPICS_MODERATION_PERFORM', 'Perform', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6390, 'COM_KUNENA_TOPIC_IS_LOCKED', 'This topic is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6391, 'COM_KUNENA_TOPIC_STARTED_ON_DATE_BY_USER', 'Topic started on %s by %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6392, 'COM_KUNENA_ANN_AUTHOR', 'Author', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6393, 'COM_KUNENA_EDIT_CATEGORY', 'Edit Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6394, 'COM_KUNENA_NEW_CATEGORY', 'New Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6395, 'COM_KUNENA_VIEW_CATEGORY_NO_TOPICS', 'No Topics in This Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6396, 'COM_KUNENA_APPLY', 'Apply', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6397, 'COM_KUNENA_APPLY_DESC', 'Click here to apply your changes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6398, 'COM_KUNENA_A_ACCESSTYPE', 'Access Type:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6399, 'COM_KUNENA_BASIC_INFO', 'Basic Information', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6400, 'COM_KUNENA_MODERATION', 'Moderation', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6401, 'COM_KUNENA_MODERATOR_ADD', 'Add Moderator(s)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6402, 'COM_KUNENA_MODERATOR_ADD_DESC', 'Click here to add moderators', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6403, 'COM_KUNENA_SAVE_DESC', 'Click here to save your changes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6404, 'COM_KUNENA_SETTINGS', 'Settings', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6405, 'COM_KUNENA_STYLES', 'Styles', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6406, 'COM_KUNENA_THIS_MODERATOR_REMOVE', 'Remove this Moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6407, 'COM_KUNENA_VIEW_CATEGORY_LIST_SUBCATEGORY_TITLE', 'View Subcategory \'%s\'', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6408, 'COM_KUNENA_VIEW_CATEGORY_LIST_TOPICS_N_REPLIES', '(%d Topics / %d Replies)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6409, 'COM_KUNENA_NEW_CATEGORY_LONG', 'Click here to create a new category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6410, 'COM_KUNENA_VIEW_COMMON_LOGOUT_OWN_LINK_TITLE', 'View your Profile', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6411, 'COM_KUNENA_VIEW_COMMON_LOGOUT_LONG', 'Click log out button to log out of the forum.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6412, 'COM_KUNENA_VIEW_COMMON_LOGOUT_WELCOME', 'Welcome, %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6413, 'COM_KUNENA_VIEW_COMMON_STAT_LINK_TITLE', 'View Forum Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6414, 'COM_KUNENA_VIEW_COMMON_WHO_LINK', 'Member List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6415, 'COM_KUNENA_VIEW_COMMON_WHO_LINK_TITLE', 'View the Member List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6416, 'COM_KUNENA_SEARCH_ENTER_TOPICID', 'Enter topic ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6417, 'COM_KUNENA_TOPIC_NO_TAGS', 'No tags set', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6418, 'COM_KUNENA_TOPIC_TAGS_ADD_EDIT', 'Add/edit tags', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6419, 'COM_KUNENA_EDITING_ENTER_REASON', 'Enter Reason for Editing', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6420, 'COM_KUNENA_ENTER_MESSAGE', 'Enter your message here', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6421, 'COM_KUNENA_EDITOR_TOPIC_TAGS_ADD_COMMAS', 'Separate with comma', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6422, 'COM_KUNENA_ENTER_SUBJECT', 'Enter Subject', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6423, 'COM_KUNENA_MESSAGE_ENTER_EMAIL', 'Enter Your Email', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6424, 'COM_KUNENA_MESSAGE_ENTER_NAME', 'Enter Your Name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6425, 'COM_KUNENA_POST_AS_ANONYMOUS_CHECK', 'Check if you want post as Anonymous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6426, 'COM_KUNENA_UPLOAD_MAX_FILE_SIZE', 'Max file size %s kb', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6427, 'COM_KUNENA_UPLOAD_MAX_IMAGE_SIZE', 'Max image size %s kb', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6428, 'COM_KUNENA_BUTTON_MODERATE_MESSAGE', 'Move', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6429, 'COM_KUNENA_MODERATION_TITLE_DEST_ENTER_SUBJECT', 'Enter New Subject', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6430, 'COM_KUNENA_VIEW_RECENT_NO_TOPICS', 'No Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6431, 'COM_KUNENA_FILTER_MESSAGES_BY', 'Filter posts by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6432, 'COM_KUNENA_SHOW_LAST', 'Show most recent message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6433, 'COM_KUNENA_STAT_POPULAR', 'Most Popular', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6434, 'COM_KUNENA_TOPIC_ACTIONS_MOST_ANSWERS', 'Most Responses', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6435, 'COM_KUNENA_TOPIC_ACTIONS_NUMBER_THANK_YOUS', 'Number of Thank Yous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6436, 'COM_KUNENA_BAN_STARTEXPIRETIME_DESC_LONG', 'Select End Time in format YYYY-MM-DD - HH:MM:SS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6437, 'COM_KUNENA_MODERATE_DELETE_ALL_POSTS_DESC', 'Check for delete all posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6438, 'COM_KUNENA_MODERATE_DELETE_BAD_AVATAR_DESC', 'Check for delete offending avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6439, 'COM_KUNENA_MODERATE_DELETE_BAD_PROFILEINFO_DESC', 'Check for delete all the profile info', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6440, 'COM_KUNENA_MODERATE_DELETE_BAD_SIGNATURE_DESC', 'Check for delete offending signature', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6441, 'COM_KUNENA_MODERATE_REMOVE_BAN_DESC', 'Expire current ban', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6442, 'COM_KUNENA_MYPROFILE_LOCATION_DESC', 'Google map location: Helsinki, Finland', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6443, 'COM_KUNENA_MYPROFILE_PERSONALTEXT_DESC', 'Few words from yourself', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6444, 'COM_KUNENA_EDITOR_HELPLINE_SAVE', 'Click here to save', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6445, 'COM_KUNENA_TEMPLATE_COLORS', 'Colors', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6446, 'COM_KUNENA_TEMPLATE_CSS3_COLORS', 'Css3 Options', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6447, 'COM_KUNENA_TEMPLATE_FORUM_BODY_COLOR', 'Body Color text', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6448, 'COM_KUNENA_TEMPLATE_FORUM_BODY_COLOR_DESC', 'Body Color text. like category details', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6449, 'COM_KUNENA_TEMPLATE_FORUM_HOVER_CATEGORIES_ROW', 'Hover Category Odd Row Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6450, 'COM_KUNENA_TEMPLATE_FORUM_HOVER_CATEGORIES_ROW_DESC', 'Hover Category Odd Row Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6451, 'COM_KUNENA_TEMPLATE_FORUM_HOVER_CATEGORIES_ROW_EVEN', 'Hover Category Odd Even Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6452, 'COM_KUNENA_TEMPLATE_FORUM_HOVER_CATEGORIES_ROW_EVEN_DESC', 'Hover Category Odd Even Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6453, 'COM_KUNENA_TEMPLATE_FORUM_LINK_COLOR', 'Link Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6454, 'COM_KUNENA_TEMPLATE_FORUM_MSG_COLOR', 'Message font color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6455, 'COM_KUNENA_TEMPLATE_FORUM_MSG_COLOR_DESC', 'Message color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6456, 'COM_KUNENA_TEMPLATE_FORUM_ROW_EVEN', 'Backgound Gradient Color top row even', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6457, 'COM_KUNENA_TEMPLATE_FORUM_ROW_EVEN2', 'Backgound Gradient Color Bottom row even', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6458, 'COM_KUNENA_TEMPLATE_FORUM_ROW_EVEN2_DESC', 'Backgound Gradient Color Bottom row even', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6459, 'COM_KUNENA_TEMPLATE_FORUM_ROW_EVEN_DESC', 'Backgound Gradient Color top row even', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6460, 'COM_KUNENA_TEMPLATE_FORUM_ROW_ODD_BACKGROUND', 'Backgound Gradient Color top row odd', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6461, 'COM_KUNENA_TEMPLATE_FORUM_ROW_ODD_BACKGROUND2', 'Backgound Gradient Color bottom row odd', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6462, 'COM_KUNENA_TEMPLATE_FORUM_ROW_ODD_BACKGROUND2_DESC', 'Backgound Gradient Color bottom row odd', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6463, 'COM_KUNENA_TEMPLATE_FORUM_ROW_ODD_BACKGROUND_DESC', 'Backgound Gradient Color top row odd', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6464, 'COM_KUNENA_TEMPLATE_GENERAL_CONFIGURATION', 'General Configuration', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6465, 'COM_KUNENA_TEMPLATE_HEADER_BACKGROUND', 'Header color gradient top', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6466, 'COM_KUNENA_TEMPLATE_HEADER_COLOR', 'Header Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6467, 'COM_KUNENA_TEMPLATE_HEADER_GRADIENT_BACKGROUND', 'Header color gradient bottom', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6468, 'COM_KUNENA_TEMPLATE_HEADER_GRADIENT_BACKGROUND_COLOR_DESC', 'Create backbround gradient from Header Color to Header Gradient.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6469, 'COM_KUNENA_TEMPLATE_LEGEND_ADMIN_COLOR', 'Admin color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6470, 'COM_KUNENA_TEMPLATE_LEGEND_ADMIN_DESC', 'Legend color for Administrators.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6471, 'COM_KUNENA_TEMPLATE_LEGEND_COLORS', 'Legend', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6472, 'COM_KUNENA_TEMPLATE_LEGEND_GLOBAL_COLOR', 'Global color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6473, 'COM_KUNENA_TEMPLATE_LEGEND_GLOBAL_DESC', 'Legend color for Global Moderators.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6474, 'COM_KUNENA_TEMPLATE_LEGEND_GUEST_COLOR', 'Guest color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6475, 'COM_KUNENA_TEMPLATE_LEGEND_GUEST_DESC', 'Legend color for Guests.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6476, 'COM_KUNENA_TEMPLATE_LEGEND_MODERATOR_COLOR', 'Moderator color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6477, 'COM_KUNENA_TEMPLATE_LEGEND_MODERATOR_DESC', 'Legend color for Moderators.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6478, 'COM_KUNENA_TEMPLATE_LEGEND_USER_COLOR', 'User color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6479, 'COM_KUNENA_TEMPLATE_LEGEND_USER_DESC', 'Legend color for Users.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6480, 'COM_KUNENA_TEMPLATE_MIRAGE_TEMPLATE_DESC', 'This is new template for Kunena 2.0.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6481, 'COM_KUNENA_TEMPLATE_TABS', 'Tabs', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6482, 'COM_KUNENA_BUTTON_UNSUBSCRIBE_CATEGORY', 'Unsubscribe', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6483, 'COM_KUNENA_BUTTON_UNSUBSCRIBE_CATEGORY_LONG', 'Unsubscribe from category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6484, 'COM_KUNENA_VIEW_CATEGORY_DEFAULT_TOPICS', 'Topics In Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.templates.ini'),
(6485, 'COM_KUNENA_FAVORITE', 'Favorite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6486, 'COM_KUNENA_MYPOSTS', 'Contains my posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6487, 'COM_KUNENA_TOPIC_STARTED_ON', 'Topic started', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6488, 'COM_KUNENA_VIEW_NO_POSTS', 'There are no posts in this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6489, 'COM_KUNENA_VIEW_NO_TOPICS', 'There are no topics to display.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6490, 'COM_KUNENA_FORUM_HEADER', 'Category Header', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6491, 'COM_KUNENA_GEN_GOTOBOTTOM', 'Go to bottom', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6492, 'COM_KUNENA_GEN_MARK_ALL_FORUMS_READ', 'Mark all topics read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6493, 'COM_KUNENA_GEN_NOFORUMS', 'There are no categories in the section!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6494, 'COM_KUNENA_LOCKED_CATEGORY', 'Category is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6495, 'COM_KUNENA_SHOWCAT_PENDING', 'pending message(s)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6496, 'COM_KUNENA_NEW', 'New', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6497, 'COM_KUNENA_PUBLICACCESS', 'Public Access', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6498, 'COM_KUNENA_MY_POSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6499, 'COM_KUNENA_STAT_USERLIST', 'User List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6500, 'COM_KUNENA_FORUM_SEARCHRESULTS', 'Displaying %s out of %s results.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6501, 'COM_KUNENA_SEARCH_ANSWERS', 'Answers', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6502, 'COM_KUNENA_SEARCH_FIND_WITH', 'Find topics with', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6503, 'COM_KUNENA_SEARCH_LEAST', 'At least', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6504, 'COM_KUNENA_SEARCH_MOST', 'At most', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6505, 'COM_KUNENA_SEARCH_OPTIONS', 'Search Options', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6506, 'COM_KUNENA_SEARCH_USER_ACTIVE', 'Activity in Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6507, 'COM_KUNENA_SEARCH_USER_POSTED', 'Messages posted by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6508, 'COM_KUNENA_SEARCH_USER_STARTED', 'Topics started by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6509, 'COM_KUNENA_STAT_GENERAL_STATS', 'General Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6510, 'COM_KUNENA_GEN_GOTO', 'Goto', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6511, 'COM_KUNENA_REPORT', 'Report to moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6512, 'COM_KUNENA_THANKYOU', 'The following user(s) said Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6513, 'COM_KUNENA_THANKYOU_MORE_USERS', 'and this user have %s others thankyou', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6514, 'COM_KUNENA_TOPIC_VOTE_RESET', 'Reset votes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6515, 'COM_KUNENA_EDITOR_ADD_FILE', 'Add File', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6516, 'COM_KUNENA_POST_TOPIC_HISTORY', 'Topic History of', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6517, 'COM_KUNENA_POST_MODERATION_PROCEED', 'Proceed', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6518, 'COM_KUNENA_TITLE_MODERATE_MESSAGE', 'Moderate Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6519, 'COM_KUNENA_LOCKED_TOPIC', 'Topic is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6520, 'COM_KUNENA_FILETYPE', 'Type', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6521, 'COM_KUNENA_BAN_STARTEXPIRETIME_DESC', 'YYYY-MM-DD - HH:MM:SS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6522, 'COM_KUNENA_PROFILE_AVATAR_UPLOAD', 'Upload New Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6523, 'COM_KUNENA_USRL_REGISTERED_USERS', '%s has <strong>%d</strong> registered users', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6524, 'COM_KUNENA_TEMPLATE_BLUE_EAGLE3_DESC', 'Blue Eagle is the default template for Kunena.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6525, 'COM_KUNENA_TEMPLATE_DISPLAY_MENU', 'Display Kunena Menu', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6526, 'COM_KUNENA_TEMPLATE_DISPLAY_MENU_DESC', 'Display active Kunena menu inside Kunena template. Disable this feature if you want to use your main menu instead.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6527, 'COM_KUNENA_TEMPLATE_FORUM_HEADER_BACKGROUND', 'Forum Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6528, 'COM_KUNENA_TEMPLATE_FORUM_HEADER_BACKGROUND_DESC', 'Define the color of the forum header background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6529, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR', 'Hover Tab Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6530, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR_DESC', 'Enter the color of the menu tab when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6531, 'COM_KUNENA_TEMPLATE_SKINNER', 'Blend with Joomla Template', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6532, 'COM_KUNENA_TEMPLATE_SKINNER_DESC', 'Automatically blend the default template with the colors or you Joomla template.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6533, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR', 'Toggler Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6534, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR_DESC', 'Enter the color of the section toggler button.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6535, 'COM_KUNENA_TEMPLATE_LOAD_RESPONSIVE_CSS', 'Load Responsive CSS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6536, 'COM_KUNENA_TEMPLATE_LOAD_RESPONSIVE_CSS_DESC', 'Load responsive CSS to make the template to fit into mobile devices. This feature needs a responsive Joomla template to work correctly.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6537, 'COM_KUNENA_GEN_GOTOTOP', 'Go to top', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_blue_eagle.ini'),
(6538, 'COM_KUNENA_FAVORITE', 'Favorite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6539, 'COM_KUNENA_MYPOSTS', 'Contains my posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6540, 'COM_KUNENA_TOPIC_STARTED_ON', 'Topic started', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6541, 'COM_KUNENA_VIEW_NO_POSTS', 'There are no posts in this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6542, 'COM_KUNENA_VIEW_NO_TOPICS', 'There are no topics to display.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6543, 'COM_KUNENA_FORUM_HEADER', 'Category Header', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6544, 'COM_KUNENA_GEN_GOTOBOTTOM', 'Go to bottom', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6545, 'COM_KUNENA_GEN_MARK_ALL_FORUMS_READ', 'Mark all topics read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6546, 'COM_KUNENA_GEN_NOFORUMS', 'There are no categories in the section!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6547, 'COM_KUNENA_LOCKED_CATEGORY', 'Category is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6548, 'COM_KUNENA_SHOWCAT_PENDING', 'pending message(s)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6549, 'COM_KUNENA_NEW', 'New', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6550, 'COM_KUNENA_PUBLICACCESS', 'Public Access', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6551, 'COM_KUNENA_MY_POSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6552, 'COM_KUNENA_STAT_USERLIST', 'User List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6553, 'COM_KUNENA_FORUM_SEARCHRESULTS', 'Displaying %s out of %s results.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6554, 'COM_KUNENA_SEARCH_ANSWERS', 'Answers', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6555, 'COM_KUNENA_SEARCH_FIND_WITH', 'Find topics with', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6556, 'COM_KUNENA_SEARCH_LEAST', 'At least', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6557, 'COM_KUNENA_SEARCH_MOST', 'At most', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6558, 'COM_KUNENA_SEARCH_OPTIONS', 'Search Options', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6559, 'COM_KUNENA_SEARCH_USER_ACTIVE', 'Activity in Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6560, 'COM_KUNENA_SEARCH_USER_POSTED', 'Messages posted by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6561, 'COM_KUNENA_SEARCH_USER_STARTED', 'Topics started by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6562, 'COM_KUNENA_STAT_GENERAL_STATS', 'General Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6563, 'COM_KUNENA_GEN_GOTO', 'Goto', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6564, 'COM_KUNENA_REPORT', 'Report to moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6565, 'COM_KUNENA_THANKYOU', 'The following user(s) said Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6566, 'COM_KUNENA_THANKYOU_MORE_USERS', 'and this user have %s others thankyou', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6567, 'COM_KUNENA_TOPIC_VOTE_RESET', 'Reset votes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6568, 'COM_KUNENA_EDITOR_ADD_FILE', 'Add File', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6569, 'COM_KUNENA_POST_TOPIC_HISTORY', 'Topic History of', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6570, 'COM_KUNENA_POST_MODERATION_PROCEED', 'Proceed', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6571, 'COM_KUNENA_TITLE_MODERATE_MESSAGE', 'Moderate Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6572, 'COM_KUNENA_LOCKED_TOPIC', 'Topic is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6573, 'COM_KUNENA_FILETYPE', 'Type', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6574, 'COM_KUNENA_BAN_STARTEXPIRETIME_DESC', 'YYYY-MM-DD - HH:MM:SS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6575, 'COM_KUNENA_PROFILE_AVATAR_UPLOAD', 'Upload New Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6576, 'COM_KUNENA_USRL_REGISTERED_USERS', '%s has <strong>%d</strong> registered users', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6577, 'COM_KUNENA_TEMPLATE_CUSTOM_DESC', 'Custom template for Kunena.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6578, 'COM_KUNENA_TEMPLATE_DISPLAY_MENU', 'Display Kunena Menu', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6579, 'COM_KUNENA_TEMPLATE_DISPLAY_MENU_DESC', 'Display active Kunena menu inside Kunena template. Disable this feature if you want to use your main menu instead.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6580, 'COM_KUNENA_TEMPLATE_FORUM_HEADER_BACKGROUND', 'Forum Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6581, 'COM_KUNENA_TEMPLATE_FORUM_HEADER_BACKGROUND_DESC', 'Define the color of the forum header background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6582, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR', 'Hover Tab Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6583, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR_DESC', 'Enter the color of the menu tab when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6584, 'COM_KUNENA_TEMPLATE_SKINNER', 'Blend with Joomla Template', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6585, 'COM_KUNENA_TEMPLATE_SKINNER_DESC', 'Automatically blend the default template with the colors or you Joomla template.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6586, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR', 'Toggler Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6587, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR_DESC', 'Enter the color of the section toggler button.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6588, 'COM_KUNENA_TEMPLATE_LOAD_RESPONSIVE_CSS', 'Load Responsive CSS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6589, 'COM_KUNENA_TEMPLATE_LOAD_RESPONSIVE_CSS_DESC', 'Load responsive CSS to make the template to fit into mobile devices. This feature needs a responsive Joomla template to work correctly.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6590, 'COM_KUNENA_GEN_GOTOTOP', 'Go to top', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.tpl_custom.ini'),
(6591, 'COM_KUNENA_KARMA', 'Karma', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6592, 'COM_KUNENA_KARMA_APPLAUD', 'Applaud', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6593, 'COM_KUNENA_KARMA_SMITE', 'Smite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6594, 'COM_KUNENA_RSS_DISABLED', 'Sorry, RSS feeds have been disabled by administrator.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6595, 'COM_KUNENA_THREADS_IN_FORUM', 'Topics in Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6596, 'COM_KUNENA_ALLOW_ANONYMOUS', 'Allow Anonymous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6597, 'COM_KUNENA_ALLOW_POLLS', 'Allow Polls', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6598, 'COM_KUNENA_CATEGORIES', 'Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6599, 'COM_KUNENA_CATEGORY_EDIT', 'Edit Catagory: <em>%s</em>', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6600, 'COM_KUNENA_CATEGORY_NEW', 'Create New Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6601, 'COM_KUNENA_DISABLE_REVIEW', 'Disable Post Review', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6602, 'COM_KUNENA_DISALLOW_ANONYMOUS', 'Disallow Anonymous', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6603, 'COM_KUNENA_DISALLOW_POLLS', 'Disallow Polls', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6604, 'COM_KUNENA_ENABLE_REVIEW', 'Enable Post Review', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6605, 'COM_KUNENA_GEN_FORUM_NEWPOST', 'New Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6606, 'COM_KUNENA_GEN_FORUM_NOTNEW', 'No New Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6607, 'COM_KUNENA_LOCK', 'Lock', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6608, 'COM_KUNENA_PUBLISH', 'Publish', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(6609, 'COM_KUNENA_SELECT_BATCH_OPTION', '- Select batch action -', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6610, 'COM_KUNENA_UNLOCK', 'Unlock', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6611, 'COM_KUNENA_UNPUBLISH', 'Unpublish', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6612, 'COM_KUNENA_VIEW_CATEGORIES_DEFAULT', 'Category Index', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6613, 'COM_KUNENA_VIEW_CATEGORIES_INFO_EMPTY', 'There are no published categories in %s.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6614, 'COM_KUNENA_VIEW_CATEGORIES_USER', 'Subscribed Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6615, 'COM_KUNENA_VIEW_CATEGORY_DEFAULT', 'Topics in %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6616, 'COM_KUNENA_FORUM_TOP', 'Board Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6617, 'COM_KUNENA_LISTCAT_RSS', 'get the latest posts directly to your desktop', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6618, 'COM_KUNENA_MENU_TOPIC_CREATE', 'Create Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6619, 'COM_KUNENA_MENU_TOPIC_EDIT', 'Edit Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6620, 'COM_KUNENA_MENU_TOPIC_REPLY', 'Reply Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6621, 'COM_KUNENA_PROFILE_EDIT', 'Edit Profile', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6622, 'COM_KUNENA_WHO_AND', 'and', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6623, 'COM_KUNENA_WHO_ONLINE_GUEST', 'Guest', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6624, 'COM_KUNENA_WHO_ONLINE_GUESTS', 'Guests', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6625, 'COM_KUNENA_WHO_ONLINE_MEMBER', 'Member', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6626, 'COM_KUNENA_WHO_ONLINE_MEMBERS', 'Members', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6627, 'COM_KUNENA_WHO_ONLINE_NOW', 'Online', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6628, 'COM_KUNENA_CREDITS_PAGE_TITLE', 'Team credits', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6629, 'COM_KUNENA_CREDITS_INTRO', 'Kunena® Forum is an open source project that requires the dedication and investment of personal time from various contributors. This version has been made possible by the following <a target=\"_blank\" href=\"%s\">contributors</a> :', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6630, 'COM_KUNENA_CREDITS_CONTRIBUTION', 'Contribution', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6631, 'COM_KUNENA_CREDITS_DEVELOPEMENT', 'Developement', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6632, 'COM_KUNENA_CREDITS_DOCUMENTATION', 'Documentation', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6633, 'COM_KUNENA_CREDITS_DESIGN', 'Design', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6634, 'COM_KUNENA_CREDITS_LANGUAGES', 'Languages', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6635, 'COM_KUNENA_CREDITS_MODERATION', 'Forum Moderation', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6636, 'COM_KUNENA_CREDITS_SECURITY', 'Security', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6637, 'COM_KUNENA_CREDITS_TESTING', 'Testing', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6638, 'COM_KUNENA_CREDITS_FOUNDER', 'Founder', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6639, 'COM_KUNENA_CREDITS_X_AND_Y', '%s and %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6640, 'COM_KUNENA_CREDITS_THANKS', 'The Kunena Team would like to thank the <a target=\"_blank\" href=\"%s\">community</a> for its help and support. We also appreciate the hard work of everyone who have <a target=\"_blank\" href=\"%s\">translated</a> Kunena into many other languages. In addition we would like to thank many members of <a target=\"_blank\" href=\"%s\">www.kunena.org</a>, past and present, who have <a target=\"_blank\" href=\"%s\">contributed</a> and helped make this a more stable and bugfree version.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6641, 'COM_KUNENA_CREDITS_GO_BACK', 'To return to the forum', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6642, 'COM_KUNENA_VIEW_CREDITS_DEFAULT', 'Kunena Team Credits', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6643, 'COM_KUNENA_SEARCH_DATE_2WEEKS', '2 weeks ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6644, 'COM_KUNENA_SEARCH_DATE_3MONTHS', '3 months ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6645, 'COM_KUNENA_SEARCH_DATE_6MONTHS', '6 months ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6646, 'COM_KUNENA_SEARCH_DATE_ANY', 'Any date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6647, 'COM_KUNENA_SEARCH_DATE_LASTVISIT', 'Last visit', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6648, 'COM_KUNENA_SEARCH_DATE_MONTH', 'A month ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6649, 'COM_KUNENA_SEARCH_DATE_NEWER', 'And newer', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6650, 'COM_KUNENA_SEARCH_DATE_OLDER', 'And older', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6651, 'COM_KUNENA_SEARCH_DATE_WEEK', 'A week ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6652, 'COM_KUNENA_SEARCH_DATE_YEAR', 'A year ago', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6653, 'COM_KUNENA_SEARCH_DATE_YESTERDAY', 'Yesterday', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6654, 'COM_KUNENA_SEARCH_LIMIT10', 'Show 10 Search Results', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6655, 'COM_KUNENA_SEARCH_LIMIT15', 'Show 15 Search Results', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6656, 'COM_KUNENA_SEARCH_LIMIT20', 'Show 20 Search Results', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6657, 'COM_KUNENA_SEARCH_LIMIT5', 'Show 5 Search Results', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6658, 'COM_KUNENA_SEARCH_SEARCHIN_ALLCATS', 'All Categories', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6659, 'COM_KUNENA_SEARCH_SEARCH_POSTS', 'Search entire posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6660, 'COM_KUNENA_SEARCH_SEARCH_TITLES', 'Search titles only', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6661, 'COM_KUNENA_SEARCH_SORTBY_DEC', 'Decreasing order', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6662, 'COM_KUNENA_SEARCH_SORTBY_INC', 'Increasing order', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6663, 'COM_KUNENA_SEARCH_SORTBY_POST', 'Posting date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6664, 'COM_KUNENA_SEARCH_SORTBY_POSTS', 'Number of posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6665, 'COM_KUNENA_SEARCH_SORTBY_START', 'Topic start date', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6666, 'COM_KUNENA_SEARCH_SORTBY_TITLE', 'Title', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6667, 'COM_KUNENA_SEARCH_SORTBY_USER', 'User name', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6668, 'COM_KUNENA_ALL_DISCUSSIONS', 'Recent Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6669, 'COM_KUNENA_ATTACHMENTS_ERROR_NO_MESSAGE', 'ERROR: no message provided (attachments)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6670, 'COM_KUNENA_BUTTON_THANKYOU_REMOVE_LONG', 'Remove this Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6671, 'COM_KUNENA_MENU_LATEST_DESC', 'Recent Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6672, 'COM_KUNENA_MODERATION_CREATE_TOPIC', 'Create New Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6673, 'COM_KUNENA_MODERATION_ENTER_TOPIC', 'Manually Enter Topic ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6674, 'COM_KUNENA_MODERATION_MOVE_TOPIC', 'Move Topic Into Another Category', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6675, 'COM_KUNENA_POST_EDIT', 'Edit Post:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6676, 'COM_KUNENA_POST_NEW_TOPIC', 'New Topic', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6677, 'COM_KUNENA_POST_NEW_TOPIC_NO_PERMISSIONS', 'You do not have permissions to start a new topic! %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6678, 'COM_KUNENA_POST_REPLY_TOPIC', 'Reply Topic:', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6679, 'COM_KUNENA_REPLY_USER_REPLY_DISABLED', 'You cannot reply to this topic.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6680, 'COM_KUNENA_SELECT_CATEGORY', '- Select Category -', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6681, 'COM_KUNENA_VIEW_DISABLED', 'The administrator has disabled public write access.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6682, 'COM_KUNENA_VIEW_TOPICS_DEFAULT', 'Topic: %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6683, 'COM_KUNENA_VIEW_TOPIC_ERROR_LOOP', 'Internal Error: Loop detected in moved topics!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6684, 'COM_KUNENA_SHOW_ALL', 'All', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6685, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_DEFAULT', 'Recent Discussions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6686, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_DELETED', 'Deleted Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6687, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_LOCKED', 'Locked Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6688, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_NOREPLIES', 'No Replies', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6689, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_STICKY', 'Sticky Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6690, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_TOPICS', 'Recent Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6691, 'COM_KUNENA_VIEW_TOPICS_DEFAULT_MODE_UNAPPROVED', 'Unapproved Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6692, 'COM_KUNENA_VIEW_TOPICS_POSTS_MODE_DEFAULT', 'Recent Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6693, 'COM_KUNENA_VIEW_TOPICS_POSTS_MODE_DELETED', 'Deleted Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6694, 'COM_KUNENA_VIEW_TOPICS_POSTS_MODE_MYTHANKS', 'Given Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6695, 'COM_KUNENA_VIEW_TOPICS_POSTS_MODE_THANKYOU', 'Received Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6696, 'COM_KUNENA_VIEW_TOPICS_POSTS_MODE_UNAPPROVED', 'Unapproved Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6697, 'COM_KUNENA_VIEW_TOPICS_USERS_MODE_DEFAULT', 'My Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6698, 'COM_KUNENA_VIEW_TOPICS_USERS_MODE_FAVORITES', 'Favorite Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6699, 'COM_KUNENA_VIEW_TOPICS_USERS_MODE_POSTED', 'Topics Participated', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6700, 'COM_KUNENA_VIEW_TOPICS_USERS_MODE_STARTED', 'Topics Started', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6701, 'COM_KUNENA_VIEW_TOPICS_USERS_MODE_SUBSCRIPTIONS', 'Topic Subscriptions', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6702, 'COM_KUNENA_DEFAULT_GALLERY', 'Default Gallery', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6703, 'COM_KUNENA_LOCATION_UNKNOWN', 'Unknown', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6704, 'COM_KUNENA_PROFILEPAGE_NOT_ALLOWED_FOR_GUESTS', 'The profile page is not available for guests', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6705, 'COM_KUNENA_PROFILE_DISABLED', 'The profile page has been disabled', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6706, 'COM_KUNENA_USER_HIDEEMAIL', 'Hide E-mail', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6707, 'COM_KUNENA_USER_ORDER', 'Preferred Message Ordering', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6708, 'COM_KUNENA_USER_ORDER_KUNENA_GLOBAL', 'Default', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6709, 'COM_KUNENA_USER_SHOWONLINE', 'Show Online', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6710, 'COM_KUNENA_VIEW_USER_DEFAULT', 'Profile for %s', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6711, 'COM_KUNENA_VIEW_USER_EDIT_AUTH_FAILED', 'You are not allowed to edit user %s.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6712, 'COM_KUNENA_VIEW_USER_LIST', 'User List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.com_kunena.views.ini'),
(6713, 'COM_KUNENA_FAVORITE', 'Favorite', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6714, 'COM_KUNENA_MYPOSTS', 'Contains my posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6715, 'COM_KUNENA_TOPIC_STARTED_ON', 'Topic started', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6716, 'COM_KUNENA_VIEW_NO_POSTS', 'There are no posts in this category.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6717, 'COM_KUNENA_VIEW_NO_TOPICS', 'There are no topics to display.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6718, 'COM_KUNENA_FORUM_HEADER', 'Category Header', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6719, 'COM_KUNENA_GEN_GOTOBOTTOM', 'Go to bottom', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6720, 'COM_KUNENA_GEN_MARK_ALL_FORUMS_READ', 'Mark all topics read', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6721, 'COM_KUNENA_GEN_NOFORUMS', 'There are no categories in the section!', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6722, 'COM_KUNENA_LOCKED_CATEGORY', 'Category is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6723, 'COM_KUNENA_SHOWCAT_PENDING', 'pending message(s)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6724, 'COM_KUNENA_NEW', 'New', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6725, 'COM_KUNENA_PUBLICACCESS', 'Public Access', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6726, 'COM_KUNENA_MY_POSTS', 'Posts', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6727, 'COM_KUNENA_STAT_USERLIST', 'User List', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6728, 'COM_KUNENA_FORUM_SEARCHRESULTS', 'Displaying %s out of %s results.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6729, 'COM_KUNENA_SEARCH_ANSWERS', 'Answers', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6730, 'COM_KUNENA_SEARCH_FIND_WITH', 'Find topics with', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6731, 'COM_KUNENA_SEARCH_LEAST', 'At least', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6732, 'COM_KUNENA_SEARCH_MOST', 'At most', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6733, 'COM_KUNENA_SEARCH_OPTIONS', 'Search Options', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6734, 'COM_KUNENA_SEARCH_USER_ACTIVE', 'Activity in Topics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6735, 'COM_KUNENA_SEARCH_USER_POSTED', 'Messages posted by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6736, 'COM_KUNENA_SEARCH_USER_STARTED', 'Topics started by', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6737, 'COM_KUNENA_STAT_GENERAL_STATS', 'General Statistics', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6738, 'COM_KUNENA_GEN_GOTO', 'Goto', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6739, 'COM_KUNENA_REPORT', 'Report to moderator', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6740, 'COM_KUNENA_THANKYOU', 'The following user(s) said Thank You', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6741, 'COM_KUNENA_TOPIC_VOTE_RESET', 'Reset votes', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6742, 'COM_KUNENA_EDITOR_ADD_FILE', 'Add File', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6743, 'COM_KUNENA_POST_TOPIC_HISTORY', 'Topic History of', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6744, 'COM_KUNENA_POST_MODERATION_PROCEED', 'Proceed', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6745, 'COM_KUNENA_TITLE_MODERATE_MESSAGE', 'Moderate Message', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6746, 'COM_KUNENA_LOCKED_TOPIC', 'Topic is locked', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6747, 'COM_KUNENA_FILETYPE', 'Type', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6748, 'COM_KUNENA_BAN_STARTEXPIRETIME_DESC', 'YYYY-MM-DD - HH:MM:SS', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6749, 'COM_KUNENA_PROFILE_AVATAR_UPLOAD', 'Upload New Avatar', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6750, 'COM_KUNENA_USRL_REGISTERED_USERS', '%s has <strong>%d</strong> registered users', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6751, 'COM_KUNENA_TEMPLATE_FORUM_HEADER_BACKGROUND', 'Forum Header Background', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6752, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR', 'Hover Tab Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6753, 'COM_KUNENA_TEMPLATE_HOVER_TAB_COLOR_DESC', 'Enter the color of the menu tab when hovered over.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6754, 'COM_KUNENA_TEMPLATE_SKINNER', 'Blend with Joomla Template', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6755, 'COM_KUNENA_TEMPLATE_SKINNER_DESC', 'Automatically blend the default template with the colors or you Joomla template.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6756, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR', 'Toggler Color', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6757, 'COM_KUNENA_TEMPLATE_TOGGLER_COLOR_DESC', 'Enter the color of the section toggler button.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6758, 'COM_KUNENA_GEN_GOTOTOP', 'Go to top', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.ini'),
(6759, 'KUNENA_TMPL_STRAPLESS', 'Crypsis', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.sys.ini'),
(6760, 'KUNENA_TMPL_STRAPLESS_DESC', 'Bootstrap template', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.kunena_tmpl_crypsis.sys.ini'),
(6761, 'MOD_KUNENAMENU', 'Kunena Menu', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6762, 'MOD_KUNENAMENU_FIELD_ALLCHILDREN_DESC', 'Expand the menu and make its sub-menu items always visible.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6763, 'MOD_KUNENAMENU_FIELD_ALLCHILDREN_LABEL', 'Show Sub-menu Items', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6764, 'MOD_KUNENAMENU_FIELD_CLASS_DESC', 'A suffix to be applied to the CSS class of the menu items', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6765, 'MOD_KUNENAMENU_FIELD_CLASS_LABEL', 'Menu Class Suffix', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6766, 'MOD_KUNENAMENU_FIELD_ENDLEVEL_DESC', 'Level to stop rendering the menu at. If you choose \'All\', all levels will be shown depending on \'Show Sub-menu Items\' setting.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6767, 'MOD_KUNENAMENU_FIELD_ENDLEVEL_LABEL', 'End Level', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6768, 'MOD_KUNENAMENU_FIELD_MENUTYPE_DESC', 'Select a menu in the list', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6769, 'MOD_KUNENAMENU_FIELD_MENUTYPE_LABEL', 'Select Menu', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6770, 'MOD_KUNENAMENU_FIELD_STARTLEVEL_DESC', 'Level to start rendering the menu at. Setting the start and end levels to the same # and setting \'Show Sub-menu Items\' to yes will only display that single level.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6771, 'MOD_KUNENAMENU_FIELD_STARTLEVEL_LABEL', 'Start Level', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6772, 'MOD_KUNENAMENU_FIELD_TAG_ID_DESC', 'An ID attribute to assign to the root UL tag of the menu (optional)', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6773, 'MOD_KUNENAMENU_FIELD_TAG_ID_LABEL', 'Menu Tag ID', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6774, 'MOD_KUNENAMENU_FIELD_TARGET_DESC', 'JavaScript values to position a popup window, e.g. top=50,left=50,width=200,height=300', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6775, 'MOD_KUNENAMENU_FIELD_TARGET_LABEL', 'Target Position', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6776, 'MOD_KUNENAMENU_XML_DESCRIPTION', 'This module displays a menu on the frontend.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.ini'),
(6777, 'MOD_KUNENAMENU', 'Kunena Menu', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.sys.ini'),
(6778, 'MOD_KUNENAMENU_XML_DESCRIPTION', 'This module displays Kunena menu on the frontend.', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.sys.ini'),
(6779, 'MOD_KUNENAMENU_LAYOUT_DEFAULT', 'Default', 'C:\\wamp\\www\\framework\\components\\com_kunena\\language\\en-GB\\en-GB.mod_kunenamenu.sys.ini'),
(6780, 'TPL_BEEZ3_ADDITIONAL_INFORMATION', 'Additional information', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6781, 'TPL_BEEZ3_ALTCLOSE', 'is closed', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6782, 'TPL_BEEZ3_ALTOPEN', 'is open', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6783, 'TPL_BEEZ3_BIGGER', 'Bigger', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6784, 'TPL_BEEZ3_CLICK', 'click', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6785, 'TPL_BEEZ3_CLOSEMENU', 'Close Menu', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6786, 'TPL_BEEZ3_DECREASE_SIZE', 'Decrease size', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6787, 'TPL_BEEZ3_ERROR_JUMP_TO_NAV', 'Jump to navigation', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6788, 'TPL_BEEZ3_FIELD_BOOTSTRAP_DESC', 'Create a comma separated list of any components for which Bootstrap is needed, for example com_name, com_anothername.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6789, 'TPL_BEEZ3_FIELD_BOOTSTRAP_LABEL', 'Components Requiring<br /> Bootstrap', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6790, 'TPL_BEEZ3_FIELD_DESCRIPTION_DESC', 'Please add your site description here.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6791, 'TPL_BEEZ3_FIELD_DESCRIPTION_LABEL', 'Site Description', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6792, 'TPL_BEEZ3_FIELD_HEADER_BACKGROUND_COLOR_DESC', 'Choose a colour for the Background if the custom colour option is selected. If left blank the Default (#eeeeee) is used.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6793, 'TPL_BEEZ3_FIELD_HEADER_BACKGROUND_COLOR_LABEL', 'Background Colour', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6794, 'TPL_BEEZ3_FIELD_HEADER_IMAGE_DESC', 'Use the selected header image when the custom colour option is selected.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6795, 'TPL_BEEZ3_FIELD_HEADER_IMAGE_LABEL', 'Header Image', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6796, 'TPL_BEEZ3_FIELD_LOGO_DESC', 'Please choose an image. If you do not want to display a logo, click on Clear and leave the field blank.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6797, 'TPL_BEEZ3_FIELD_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6798, 'TPL_BEEZ3_FIELD_NAVPOSITION_DESC', 'Navigation before or after content.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6799, 'TPL_BEEZ3_FIELD_NAVPOSITION_LABEL', 'Position of Navigation', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6800, 'TPL_BEEZ3_FIELD_SITETITLE_DESC', 'Please add your site title here, it\'s only displayed if you don\'t use a logo.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6801, 'TPL_BEEZ3_FIELD_SITETITLE_LABEL', 'Site Title', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6802, 'TPL_BEEZ3_FIELD_TEMPLATECOLOR_DESC', 'Colour of the template.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6803, 'TPL_BEEZ3_FIELD_TEMPLATECOLOR_LABEL', 'Template colour', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6804, 'TPL_BEEZ3_FIELD_WRAPPERLARGE_DESC', 'Wrapper width with closed additional columns in percent.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6805, 'TPL_BEEZ3_FIELD_WRAPPERLARGE_LABEL', 'Wrapper Large (%)', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6806, 'TPL_BEEZ3_FIELD_WRAPPERSMALL_DESC', 'Wrapper width with opened additional columns in percent.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6807, 'TPL_BEEZ3_FIELD_WRAPPERSMALL_LABEL', 'Wrapper Small (%)', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6808, 'TPL_BEEZ3_FONTSIZE', 'Font size', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6809, 'TPL_BEEZ3_INCREASE_SIZE', 'Increase size', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6810, 'TPL_BEEZ3_JUMP_TO_INFO', 'Jump to additional information', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6811, 'TPL_BEEZ3_JUMP_TO_NAV', 'Jump to main navigation and login', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6812, 'TPL_BEEZ3_NAVIGATION', 'Navigation', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6813, 'TPL_BEEZ3_NAV_VIEW_SEARCH', 'Nav view search', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6814, 'TPL_BEEZ3_NEXTTAB', 'Next Tab', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6815, 'TPL_BEEZ3_OPENMENU', 'Open Menu', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6816, 'TPL_BEEZ3_OPTION_AFTER_CONTENT', 'after content', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6817, 'TPL_BEEZ3_OPTION_BEFORE_CONTENT', 'before content', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6818, 'TPL_BEEZ3_OPTION_IMAGE', 'Custom', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6819, 'TPL_BEEZ3_OPTION_NATURE', 'Nature', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6820, 'TPL_BEEZ3_OPTION_PERSONAL', 'Personal', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6821, 'TPL_BEEZ3_OPTION_RED', 'Red', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6822, 'TPL_BEEZ3_OPTION_TURQ', 'Turquoise', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6823, 'TPL_BEEZ3_POWERED_BY', 'Powered by', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6824, 'TPL_BEEZ3_RESET', 'Reset', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6825, 'TPL_BEEZ3_REVERT_STYLES_TO_DEFAULT', 'Revert styles to default', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6826, 'TPL_BEEZ3_SEARCH', 'Search', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6827, 'TPL_BEEZ3_SKIP_TO_CONTENT', 'Skip to content', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6828, 'TPL_BEEZ3_SKIP_TO_ERROR_CONTENT', 'Jump to error message and search', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6829, 'TPL_BEEZ3_SMALLER', 'Smaller', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6830, 'TPL_BEEZ3_SYSTEM_MESSAGE', 'Error', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6831, 'TPL_BEEZ3_TEXTRIGHTCLOSE', 'Close info', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6832, 'TPL_BEEZ3_TEXTRIGHTOPEN', 'Open info', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6833, 'TPL_BEEZ3_XML_DESCRIPTION', 'Accessible template for Joomla! Beez, the HTML 4 version.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6834, 'TPL_BEEZ3_YOUR_SITE_DESCRIPTION', 'Your site description', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.ini'),
(6835, 'TPL_BEEZ3_POSITION_DEBUG', 'Debug', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6836, 'TPL_BEEZ3_POSITION_POSITION-0', 'Search', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6837, 'TPL_BEEZ3_POSITION_POSITION-10', 'Footer middle', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6838, 'TPL_BEEZ3_POSITION_POSITION-11', 'Footer bottom', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6839, 'TPL_BEEZ3_POSITION_POSITION-12', 'Middle top', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6840, 'TPL_BEEZ3_POSITION_POSITION-13', 'Unused', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6841, 'TPL_BEEZ3_POSITION_POSITION-14', 'Footer last', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6842, 'TPL_BEEZ3_POSITION_POSITION-15', 'Header', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6843, 'TPL_BEEZ3_POSITION_POSITION-1', 'Top', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6844, 'TPL_BEEZ3_POSITION_POSITION-2', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6845, 'TPL_BEEZ3_POSITION_POSITION-3', 'Right bottom', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6846, 'TPL_BEEZ3_POSITION_POSITION-4', 'Left middle', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6847, 'TPL_BEEZ3_POSITION_POSITION-5', 'Left bottom', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6848, 'TPL_BEEZ3_POSITION_POSITION-6', 'Right top', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6849, 'TPL_BEEZ3_POSITION_POSITION-7', 'Left top', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6850, 'TPL_BEEZ3_POSITION_POSITION-8', 'Right middle', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6851, 'TPL_BEEZ3_POSITION_POSITION-9', 'Footer top', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6852, 'TPL_BEEZ3_XML_DESCRIPTION', 'Accessible template for Joomla! Beez, the HTML 4 version.', 'C:\\wamp\\www\\framework\\templates\\beez3\\language\\en-GB\\en-GB.tpl_beez3.sys.ini'),
(6853, 'TPL_PROTOSTAR_XML_DESCRIPTION', 'Continuing the space theme (Solarflare from 1.0 and Milkyway from 1.5), Protostar is the Joomla 3 site template based on Bootstrap from Twitter and the launch of the Joomla User Interface library (JUI).', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6854, 'TPL_PROTOSTAR_BACKGROUND_COLOR_DESC', 'Choose a background colour for static layouts. If left blank the Default (#f4f6f7) is used.', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6855, 'TPL_PROTOSTAR_BACKGROUND_COLOR_LABEL', 'Background Colour', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6856, 'TPL_PROTOSTAR_BACKTOTOP', 'Back to Top', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6857, 'TPL_PROTOSTAR_COLOR_DESC', 'Choose an overall colour for the site template. If left blank the Default (#0088cc) is used.', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6858, 'TPL_PROTOSTAR_COLOR_LABEL', 'Template Colour', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6859, 'TPL_PROTOSTAR_FLUID', 'Fluid', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6860, 'TPL_PROTOSTAR_FLUID_LABEL', 'Fluid Layout', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6861, 'TPL_PROTOSTAR_FLUID_DESC', 'Use Bootstrap\'s fluid or static container (both are responsive).', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6862, 'TPL_PROTOSTAR_FONT_LABEL', 'Google Font for Headings', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6863, 'TPL_PROTOSTAR_FONT_DESC', 'Load a Google font for the headings (H1, H2, H3, etc).', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6864, 'TPL_PROTOSTAR_FONT_NAME_LABEL', 'Google Font Name', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6865, 'TPL_PROTOSTAR_FONT_NAME_DESC', 'Example: Open+Sans or Source+Sans+Pro.', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6866, 'TPL_PROTOSTAR_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6867, 'TPL_PROTOSTAR_LOGO_DESC', 'Upload a custom logo for the site template.', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6868, 'TPL_PROTOSTAR_STATIC', 'Static', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.ini'),
(6869, 'TPL_PROTOSTAR_POSITION_BANNER', 'Banner', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6870, 'TPL_PROTOSTAR_POSITION_DEBUG', 'Debug', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6871, 'TPL_PROTOSTAR_POSITION_POSITION-0', 'Search', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6872, 'TPL_PROTOSTAR_POSITION_POSITION-10', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6873, 'TPL_PROTOSTAR_POSITION_POSITION-11', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6874, 'TPL_PROTOSTAR_POSITION_POSITION-12', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6875, 'TPL_PROTOSTAR_POSITION_POSITION-13', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6876, 'TPL_PROTOSTAR_POSITION_POSITION-14', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6877, 'TPL_PROTOSTAR_POSITION_POSITION-15', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6878, 'TPL_PROTOSTAR_POSITION_POSITION-1', 'Navigation', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6879, 'TPL_PROTOSTAR_POSITION_POSITION-2', 'Breadcrumbs', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6880, 'TPL_PROTOSTAR_POSITION_POSITION-3', 'Top center', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6881, 'TPL_PROTOSTAR_POSITION_POSITION-4', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6882, 'TPL_PROTOSTAR_POSITION_POSITION-5', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6883, 'TPL_PROTOSTAR_POSITION_POSITION-6', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6884, 'TPL_PROTOSTAR_POSITION_POSITION-7', 'Right', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6885, 'TPL_PROTOSTAR_POSITION_POSITION-8', 'Left', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6886, 'TPL_PROTOSTAR_POSITION_POSITION-9', 'Unused', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6887, 'TPL_PROTOSTAR_POSITION_FOOTER', 'Footer', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6888, 'TPL_PROTOSTAR_XML_DESCRIPTION', 'Continuing the space theme (Solarflare from 1.0 and Milkyway from 1.5), Protostar is the Joomla 3 site template based on Bootstrap from Twitter and the launch of the Joomla User Interface library (JUI).', 'C:\\wamp\\www\\framework\\templates\\protostar\\language\\en-GB\\en-GB.tpl_protostar.sys.ini'),
(6889, 'DATE_FORMAT_LC', 'l, d F Y', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6890, 'DATE_FORMAT_LC2', 'l, d F Y H:i', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6891, 'DATE_FORMAT_LC3', 'd F Y', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6892, 'DATE_FORMAT_LC4', 'Y-m-d', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6893, 'DATE_FORMAT_JS1', 'y-m-d', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6894, 'DATE_FORMAT_TPL1', 'M d, Y', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6895, 'DATE_FORMAT_TPL2', 'd', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6896, 'DATE_FORMAT_TPL3', 'M', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6897, 'TPL_THEME_LAYOUT_LABEL', 'Theme layout', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6898, 'TPL_THEME_LAYOUT_DESC', 'Please choose theme layout. Fluid or fixed', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6899, 'TPL_FIXED', 'Fixed', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6900, 'TPL_FLUID', 'Fluid', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6901, 'TPL_LOGO_LABEL', '<b>Logo Settings</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6902, 'TPL_LOGO_DESC', 'Set the Logo parameters', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6903, 'TPL_THEME_LOGO_LABEL', 'Logo', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6904, 'TPL_THEME_LOGO_DESC', 'Upload a custom logo for the site template.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6905, 'TPL_LOGO_WIDTH', 'Logo Width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6906, 'TPL_LOGO_WIDTH_DESC', 'Please select logo container grid width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6907, 'TPL_FOOTER_LABEL', '<b>Footer Settings</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6908, 'TPL_FOOTER_DESC', 'Set the Footer parameters', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6909, 'TPL_FOOTER_LOGO_LABEL', 'Show Footer Logo', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6910, 'TPL_THEME_FOOTER_LOGO_LABEL', 'Footer Logo', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6911, 'TPL_THEME_FOOTER_LOGO_DESC', 'Upload a custom footer logo for the site template.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6912, 'TPL_FOOTER_WIDTH', 'Footer Width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6913, 'TPL_FOOTER_WIDTH_DESC', 'Please select footer container grid width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6914, 'TPL_COPY_LABEL', 'Show &copy;', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6915, 'TPL_YEAR_LABEL', 'Show Year', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6916, 'TPL_PRIVACY_LINK_LABEL', 'Privacy Policy Link', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6917, 'PRIVACY_LINK_MENU_LABEL', 'Privacy Policy Item', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6918, 'PRIVACY_LINK_TITLE_LABEL', 'Privacy Policy Label', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6919, 'TPL_TERMS_LINK_LABEL', 'Terms of Use Link', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6920, 'TERMS_LINK_MENU_LABEL', 'Terms of Use Item', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6921, 'TERMS_LINK_TITLE_LABEL', 'Terms of Use Label', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6922, 'TPL_THEME_ASIDE_LEFT_WIDTH', 'Left Sidebar Width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6923, 'TPL_THEME_ASIDE_RIGHT_WIDTH', 'Right Sidebar width', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini');
INSERT INTO `#__overrider` (`id`, `constant`, `string`, `file`) VALUES
(6924, 'TPL_THEME_ASIDE_LEFT_WIDTH_DESC', 'Set left sidebar width in grid columns', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6925, 'TPL_THEME_ASIDE_RIGHT_WIDTH_DESC', 'Set right sidebar width in grid columns', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6926, 'TPL_THEME_TOTOP', 'To Top button', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6927, 'TPL_THEME_TOTOP_DESC', 'Please select if you want to display To Top button', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6928, 'TPL_THEME_TOTOP_TEXT', 'Totop text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6929, 'TPL_THEME_TOTOP_TEXT_DESC', 'Please input toptop button text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6930, 'TPL_THEME_TODESKTOP', 'To Desktop button', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6931, 'TPL_THEME_TODESKTOP_DESC', 'Please select if you want to display To Desktop button at mobile devices', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6932, 'TPL_THEME_TODESKTOP_TEXT', 'Todesktop text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6933, 'TPL_THEME_TODESKTOP_TEXT_DESC', 'Please input todeskptop button text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6934, 'TPL_THEME_TOMOBILE_TEXT', 'Tomobile text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6935, 'TPL_THEME_TOMOBILE_TEXT_DESC', 'Please input tomobile button text', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6936, 'TPL_SPACER_ASIDES_LABEL', '<b>Asides:</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6937, 'TPL_SPACER_ASIDES_DESC', 'set grid width for the left and right sidebars.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6938, 'TPL_FIELDSET_LAYOUT', 'Layout', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6939, 'TPL_FIELDSET_GRID', 'Grid', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6940, 'TPL_FIELDSET_FEATURES', 'Features', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6941, 'TPL_FIELDSET_TYPOGRAPHY', 'Typography', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6942, 'TPL_PAGE_HEADING_LABEL', 'Page heading', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6943, 'TPL_ITEM_HEADING_LABEL', 'Item heading', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6944, 'TPL_PAGE_HEADING_DESC', 'Set tag for the page heading title', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6945, 'TPL_ITEM_HEADING_DESC', 'Set tag for the item title', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6946, 'TPL_SPACER_CATEGORY_TYPO_LABEL', '<b>Category View:</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6947, 'TPL_SPACER_BLOG_TYPO_LABEL', '<b>Blog View:</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6948, 'TPL_SPACER_ITEM_TYPO_LABEL', '<b>Item View:</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6949, 'TPL_SPACER_FEATURED_TYPO_LABEL', '<b>Featured View:</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6950, 'TPL_ITEM_BLOG_HEADING_LABEL', 'Item heading (Blog)', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6951, 'TPL_ITEM_BLOG_HEADING_DESC', 'Set tag for the item title. (Blog item view)', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6952, 'TPL_SPACER_FEATURED_TYPO_DESC', 'Applies for the Featured Articles page', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6953, 'TPL_SPACER_CATEGORY_TYPO_DESC', 'Applies for the Category Articles, Gallery View and Archived Articles pages', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6954, 'TPL_SPACER_BLOG_TYPO_DESC', 'Applies for the Category Blog page', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6955, 'TPL_SPACER_ITEM_TYPO_DESC', 'Applies for the Single Article page', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6956, 'SOCIAL_SHARING_CODE_LABEL', 'Social Sharing', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6957, 'SOCIAL_SHARING_CODE_DESC', 'Social sharing code. Displayed under the article content.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6958, 'TPL_SPACER_TOTOP_LABEL', '<b>To top button</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6959, 'TPL_SPACER_TOTOP_DESC', 'To top batton parameters', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6960, 'TPL_SPACER_TODESKTOP_LABEL', '<b>Back to desktop version button</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6961, 'TPL_SPACER_TODESKTOP_DESC', 'Back to desktop version button parameters', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6962, 'TPL_SPACER_BLACK_AND_WHITE_LABEL', '<b>jQuery Black&White plugin</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6963, 'TPL_SPACER_BLACK_AND_WHITE_DESC', 'jQuery Black&White plugin parameters', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6964, 'TPL_BLACK_AND_WHITE', 'jQuery Black&White plugin', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6965, 'TPL_BLACK_AND_WHITE_DESC', 'Enable or disable jQuery Black&White plugin', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6966, 'TPL_INVERT_HOVER_EFFECT', 'Invert hover effect', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6967, 'TPL_ANIMATION_IN_SPEED', 'Animation in speed', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6968, 'TPL_ANIMATION_OUT_SPEED', 'Animation out speed', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6969, 'TPL_IN', 'in %s', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6970, 'TPL_ON', 'on %s', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6971, 'TPL_BY', 'by %s', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6972, 'TPL_WITH', 'with %s', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6973, 'TPL_HITS', 'hits', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6974, 'TPL_VIEWS', 'views', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6975, 'TPL_COM_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6976, 'TPL_ZOOM', 'Zoom In', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6977, 'TPL_COM_CONTENT_READ_MORE', 'Read more', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6978, 'TPL_COM_CONTENT_READ_MORE_TITLE', 'Read more', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6979, 'TPL_RESET', 'Forgot your password?', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6980, 'TPL_REMIND', 'Forgot your username?', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6981, 'TPL_CONTACT_ADDRESS', 'Address:', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6982, 'TPL_CONTACT_PHONES', 'Phones:', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6983, 'TPL_CONTACT_MAILTO', 'E-mail:', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6984, 'TPL_CONTACT_MISC', 'Miscellaneous information:', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6985, 'TPL_THEME_MOD_FOOTER_ALL_RIGHTS_RESERVED', 'All rights reserved', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6986, 'TPL_COM_CONTENT_GALLERY_FILTER_SHOW_ALL', 'Show all', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6987, 'TPL_COM_CONTENT_GALLERY_FILTER_BY_CATEGORY', 'Filter by category', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6988, 'TPL_COM_CONTENT_GALLERY_SORT', 'Sort', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6989, 'TPL_COM_CONTENT_GALLERY_FILTER_NAME', 'Name', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6990, 'TPL_COM_CONTENT_GALLERY_FILTER_DATE', 'Date', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6991, 'TPL_COM_CONTENT_GALLERY_FILTER_RANDOM', 'Random', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6992, 'TPL_COM_CONTENT_GALLERY_FILTER_POPULARITY', 'Popularity', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6993, 'TPL_GALLERY_SHOW_FILTER_LABEL', 'Show Filter', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6994, 'TPL_GALLERY_SHOW_FILTER_DESC', 'Select if you want to display Isotope filter', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6995, 'TPL_GALLERY_SHOW_SORT_LABEL', 'Show Sort', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6996, 'TPL_GALLERY_SHOW_SORT_DESC', 'Select if you want to display Isotope sort', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6997, 'TPL_GALLERY_SORT_EFFECT_LABEL', 'Sorting effect', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6998, 'TPL_GALLERY_SORT_EFFECT_DESC', 'Separated by comma, enclosed in quotes', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(6999, 'TPL_COM_CONTENT_LAYOUT_MODE', 'Layout mode', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7000, 'TPL_PRIVACY_POLICY', 'Privacy policy', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7001, 'TPL_TERMS_OF_USE', 'Terms of use', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7002, 'TPL_ALL_RIGHTS_RESERVED', 'All rights reserved', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7003, 'COM_CONTENT_NONE', 'None', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7004, 'TPL_MOD_LOGIN_VALUE_USERNAME', 'User name', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7005, 'TPL_MOD_LOGIN_REMEMBER_ME', 'Remember me', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7006, 'TPL_COM_KOMENTO_FORM_SUBMIT', 'Submit comment', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7007, 'TPL_KOMENTO_FRONTPAGE_COMMENTS', 'Comments', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7008, 'JGLOBAL_SECRETKEY_HELP', 'If you have enabled two factor<br> authentication in your user account please<br> enter your secret key. If you do not know<br> what this means, you can leave this field<br> blank.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7009, 'TPL_FORGOT', 'Forgot', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7010, 'TPL_SPACER_COUNTDOWN_LABEL', '<b>Offline Countdown</b>', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7011, 'TPL_COUNTDOWN_TIME_LABEL', 'Offline Countdown Time', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.ini'),
(7012, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_TITLE', 'Gallery View', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7013, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_OPTION', 'Gallery', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7014, 'TPL_COM_CONTENT_CATEGORY_VIEW_GALLERY_DESC', 'Gallery category view with Isotope plugin integrated.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7015, 'TPL_GALLERY_SHOW_FILTER_LABEL', 'Show Filter', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7016, 'TPL_GALLERY_SHOW_FILTER_DESC', 'Select if you want to display Isotope filter', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7017, 'TPL_GALLERY_SHOW_SORT_LABEL', 'Show Sort', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7018, 'TPL_GALLERY_SHOW_SORT_DESC', 'Select if you want to display Isotope sort', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7019, 'TPL_GALLERY_SORT_EFFECT_LABEL', 'Sorting effect', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7020, 'TPL_GALLERY_SORT_EFFECT_DESC', 'Separated by comma, enclosed in quotes. The available effects are \'fade\', \'scale\', \'rotateZ\', \'rotateX\'*, \'rotateY\'*, \'blur\'*, and \'grayscale\'*.<br><br>*These effects are not supported on certain older CSS3 compatible browsers and will not show.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7021, 'TPL_GALLERY_SHOW_LAYOUT_MODE_LABEL', 'Layout mode switcher', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7022, 'TPL_GALLERY_SHOW_LAYOUT_MODE_DESC', 'Show layout mode switcher', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7023, 'TPL_GALLERY_IMAGE_FLOAT_LABEL', 'Image Align', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7024, 'TPL_GALLERY_IMAGE_FLOAT_DESC', 'Select article image align for the gallery view.', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7025, 'TPL_LEFT', 'Left', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7026, 'TPL_RIGHT', 'Right', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7027, 'TPL_HOVER_INFO', 'Use css hover', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7028, 'TPL_HOVER_INFO_DESC', 'Use css hover', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7029, 'TPL_HOVER_INFO_STYLE', 'Css hover style', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7030, 'TPL_HOVER_INFO_STYLE_DESC', 'Please choose a css hover style', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7031, 'TPL_COM_CONTENT_LIMIT_INTRO_LABEL', 'Words limit in intro section', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7032, 'TPL_COM_CONTENT_LIMIT_INTRO_DESC', 'Words limit in intro section', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7033, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_TITLE', 'Team View', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7034, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_OPTION', 'Team', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7035, 'TPL_COM_CONTENT_CATEGORY_VIEW_TEAM_DESC', 'Team category view layout', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7036, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_TITLE', 'FAQs View', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7037, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_OPTION', 'FAQs', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7038, 'TPL_COM_CONTENT_CATEGORY_VIEW_FAQS_DESC', 'Page layout in Frequently Asked Questions format. Based on definition list markup', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7039, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_TITLE', 'Blog View', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7040, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_OPTION', 'Blog View', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7041, 'TPL_COM_CONTENT_CATEGORY_VIEW_BLOGVIEW_DESC', 'Category template for Blog page', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7042, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_TITLE', 'Category Articles', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7043, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_OPTION', 'Category Articles', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7044, 'TPL_COM_CONTENT_CATEGORY_VIEW_ARTICLES_DESC', 'Outputs articles from the specified category', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7045, 'TPL_theme3589_POSITION_DEBUG', 'debug', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7046, 'TPL_theme3589_POSITION_TOP', 'top', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7047, 'TPL_theme3589_POSITION_HEADER', 'header', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7048, 'TPL_theme3589_POSITION_NAVIGATION', 'navigation', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7049, 'TPL_theme3589_POSITION_BREADCRUMBS', 'breadcrumbs', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7050, 'TPL_theme3589_POSITION_SHOWCASE', 'showcase', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7051, 'TPL_theme3589_POSITION_FEATURE', 'feature', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7052, 'TPL_theme3589_POSITION_MAINTOP', 'maintop', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7053, 'TPL_theme3589_POSITION_CONTENT-TOP', 'content-top', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7054, 'TPL_theme3589_POSITION_ASIDE-LEFT', 'aside-left', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7055, 'TPL_theme3589_POSITION_ASIDE-RIGHT', 'aside-right', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7056, 'TPL_theme3589_POSITION_CONTENT-BOTTOM', 'content-bottom', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7057, 'TPL_theme3589_POSITION_VIDEO', 'video', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7058, 'TPL_theme3589_POSITION_MAINBOTTOM', 'mainbottom', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7059, 'TPL_theme3589_POSITION_MAINBOTTOM-2', 'mainbottom-2', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7060, 'TPL_theme3589_POSITION_MAINBOTTOM-3', 'mainbottom-3', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7061, 'TPL_theme3589_POSITION_MAINBOTTOM-4', 'mainbottom-4', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7062, 'TPL_theme3589_POSITION_MAINBOTTOM-5', 'mainbottom-5', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7063, 'TPL_theme3589_POSITION_BOTTOM', 'bottom', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7064, 'TPL_theme3589_POSITION_FOOTER', 'footer', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7065, 'TPL_theme3589_POSITION_COPYRIGHT', 'copyright', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7066, 'TPL_theme3589_POSITION_MODAL', 'modal', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7067, 'TPL_theme3589_POSITION_404-SEARCH', '404-search', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7068, 'TPL_theme3589_POSITION_MEGAMENU', 'megamenu', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7069, 'TPL_theme3589_POSITION_FIXED-SIDEBAR-LEFT', 'fixed-sidebar-left', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7070, 'TPL_CHANGE_POSITION_BUTTON', 'Select', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini'),
(7071, 'COM_MODULES_CHANGE_POSITION_TITLE', 'Change', 'C:\\wamp\\www\\framework\\templates\\theme3589\\language\\en-GB\\en-GB.tpl_theme3589.sys.ini');

DROP TABLE IF EXISTS `#__plg_slogin_profile`;
CREATE TABLE IF NOT EXISTS `#__plg_slogin_profile` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `slogin_id` varchar(150) NOT NULL,
  `provider` varchar(100) NOT NULL,
  `gender` int(1) NOT NULL DEFAULT '0',
  `f_name` varchar(100) NOT NULL,
  `l_name` varchar(100) NOT NULL,
  `phone` varchar(20) NOT NULL,
  `mobil_phone` varchar(20) NOT NULL,
  `email` varchar(50) NOT NULL,
  `social_profile_link` varchar(250) NOT NULL,
  `country` varchar(5) NOT NULL,
  `region` varchar(50) NOT NULL,
  `city` varchar(50) NOT NULL,
  `lat` varchar(50) NOT NULL,
  `lng` varchar(50) NOT NULL,
  `avatar` varchar(100) NOT NULL,
  `current_profile` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `user_prov` (`user_id`,`provider`),
  KEY `user_curr` (`user_id`,`current_profile`),
  KEY `user` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__postinstall_messages`;
CREATE TABLE IF NOT EXISTS `#__postinstall_messages` (
  `postinstall_message_id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `extension_id` bigint(20) NOT NULL DEFAULT '700' COMMENT 'FK to #__extensions',
  `title_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'Lang key for the title',
  `description_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'Lang key for description',
  `action_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `language_extension` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'com_postinstall' COMMENT 'Extension holding lang keys',
  `language_client_id` tinyint(3) NOT NULL DEFAULT '1',
  `type` varchar(10) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'link' COMMENT 'Message type - message, link, action',
  `action_file` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT '' COMMENT 'RAD URI to the PHP file containing action method',
  `action` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT '' COMMENT 'Action method name or URL',
  `condition_file` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'RAD URI to file holding display condition method',
  `condition_method` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'Display condition method, must return boolean',
  `version_introduced` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '3.2.0' COMMENT 'Version when this message was introduced',
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  PRIMARY KEY (`postinstall_message_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__postinstall_messages` (`postinstall_message_id`, `extension_id`, `title_key`, `description_key`, `action_key`, `language_extension`, `language_client_id`, `type`, `action_file`, `action`, `condition_file`, `condition_method`, `version_introduced`, `enabled`) VALUES
(1, 700, 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_TITLE', 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_BODY', 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_ACTION', 'plg_twofactorauth_totp', 1, 'action', 'site://plugins/twofactorauth/totp/postinstall/actions.php', 'twofactorauth_postinstall_action', 'site://plugins/twofactorauth/totp/postinstall/actions.php', 'twofactorauth_postinstall_condition', '3.2.0', 0),
(2, 700, 'COM_CPANEL_MSG_EACCELERATOR_TITLE', 'COM_CPANEL_MSG_EACCELERATOR_BODY', 'COM_CPANEL_MSG_EACCELERATOR_BUTTON', 'com_cpanel', 1, 'action', 'admin://components/com_admin/postinstall/eaccelerator.php', 'admin_postinstall_eaccelerator_action', 'admin://components/com_admin/postinstall/eaccelerator.php', 'admin_postinstall_eaccelerator_condition', '3.2.0', 1),
(3, 700, 'COM_CPANEL_WELCOME_BEGINNERS_TITLE', 'COM_CPANEL_WELCOME_BEGINNERS_MESSAGE', '', 'com_cpanel', 1, 'message', '', '', '', '', '3.2.0', 0),
(4, 700, 'COM_CPANEL_MSG_PHPVERSION_TITLE', 'COM_CPANEL_MSG_PHPVERSION_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/phpversion.php', 'admin_postinstall_phpversion_condition', '3.2.2', 1),
(5, 700, 'COM_CPANEL_MSG_LANGUAGEACCESS340_TITLE', 'COM_CPANEL_MSG_LANGUAGEACCESS340_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/languageaccess340.php', 'admin_postinstall_languageaccess340_condition', '3.4.1', 1),
(6, 700, 'PLG_PLG_RECAPTCHA_VERSION_1_POSTINSTALL_TITLE', 'PLG_PLG_RECAPTCHA_VERSION_1_POSTINSTALL_BODY', 'PLG_PLG_RECAPTCHA_VERSION_1_POSTINSTALL_ACTION', 'plg_captcha_recaptcha', 1, 'action', 'site://plugins/captcha/recaptcha/postinstall/actions.php', 'recaptcha_postinstall_action', 'site://plugins/captcha/recaptcha/postinstall/actions.php', 'recaptcha_postinstall_condition', '3.8.6', 1),
(7, 700, 'COM_CPANEL_MSG_UPDATEDEFAULTSETTINGS_TITLE', 'COM_CPANEL_MSG_UPDATEDEFAULTSETTINGS_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/updatedefaultsettings.php', 'admin_postinstall_updatedefaultsettings_condition', '3.8.8', 1),
(8, 700, 'COM_ACTIONLOGS_POSTINSTALL_TITLE', 'COM_ACTIONLOGS_POSTINSTALL_BODY', '', 'com_actionlogs', 1, 'message', '', '', '', '', '3.9.0', 1),
(9, 700, 'COM_PRIVACY_POSTINSTALL_TITLE', 'COM_PRIVACY_POSTINSTALL_BODY', '', 'com_privacy', 1, 'message', '', '', '', '', '3.9.0', 1),
(10, 700, 'COM_CPANEL_MSG_ADDNOSNIFF_TITLE', 'COM_CPANEL_MSG_ADDNOSNIFF_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/addnosniff.php', 'admin_postinstall_addnosniff_condition', '3.9.3', 1);

DROP TABLE IF EXISTS `#__privacy_consents`;
CREATE TABLE IF NOT EXISTS `#__privacy_consents` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `state` int(10) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `subject` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `body` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `remind` tinyint(4) NOT NULL DEFAULT '0',
  `token` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__privacy_requests`;
CREATE TABLE IF NOT EXISTS `#__privacy_requests` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `email` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `requested_at` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` tinyint(4) NOT NULL DEFAULT '0',
  `request_type` varchar(25) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `confirm_token` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `confirm_token_created_at` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE IF NOT EXISTS `#__redirect_links` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `old_url` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL,
  `new_url` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL,
  `referer` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `header` smallint(3) NOT NULL DEFAULT '301',
  PRIMARY KEY (`id`),
  KEY `idx_link_modifed` (`modified_date`),
  KEY `idx_old_url` (`old_url`(100))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE IF NOT EXISTS `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '3.9.3-2019-02-07'),
(10032, '3.3.0'),
(10072, 'install.mysql.utf8'),
(10148, '1.0.2');

DROP TABLE IF EXISTS `#__slogin_users`;
CREATE TABLE IF NOT EXISTS `#__slogin_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `slogin_id` varchar(150) NOT NULL,
  `provider` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `slogin_id` (`slogin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__tags`;
CREATE TABLE IF NOT EXISTS `#__tags` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `path` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `metadesc` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `modified_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `urls` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL,
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `tag_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_language` (`language`),
  KEY `idx_path` (`path`(100)),
  KEY `idx_alias` (`alias`(100))
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__tags` (`id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `created_by_alias`, `modified_user_id`, `modified_time`, `images`, `urls`, `hits`, `language`, `version`, `publish_up`, `publish_down`) VALUES
(1, 0, 0, 31, 0, '', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 213, '2018-06-25 16:06:04', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 1, 1, 2, 1, 'hot', 'hot', 'hot', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{}\\\"}\"}', 3, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(4, 1, 3, 4, 1, 'popular', 'popular', 'popular', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 3, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(5, 1, 5, 6, 1, 'public', 'public', 'public', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(6, 1, 7, 8, 1, 'information', 'information', 'information', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(7, 1, 9, 10, 1, 'fresh', 'fresh', 'fresh', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{}\\\"}\"}', 17, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(8, 1, 11, 12, 1, 'archive', 'archive', 'archive', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(9, 1, 13, 14, 1, 'news', 'news', 'news', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{}\\\"}\"}', 3, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(10, 1, 15, 16, 1, 'important', 'important', 'important', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 1, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(11, 1, 17, 18, 1, 'topic', 'topic', 'topic', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 1, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(12, 1, 19, 20, 1, 'publication', 'publication', 'publication', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 1, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(13, 1, 21, 22, 1, 'announcement', 'announcement', 'announcement', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(14, 1, 23, 24, 1, 'content', 'content', 'content', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{}\\\"}\"}', 11, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(15, 1, 25, 26, 1, 'latest', 'latest', 'latest', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(16, 1, 27, 28, 1, 'recent', 'recent', 'recent', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{}\\\"}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04'),
(17, 1, 29, 30, 1, 'text', 'text', 'text', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{\"tag_layout\":\"\",\"tag_link_class\":\"label label-info\"}', ' ', ' ', '{\"author\":\"\",\"robots\":\"\"}', 213, '2018-06-25 16:06:04', '', 213, '2018-06-25 16:06:04', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"0\":\"{\\\"0\\\":\\\"{\\\\\\\"0\\\\\\\":\\\\\\\"{\\\\\\\\\\\\\\\"urla\\\\\\\\\\\\\\\":\\\\\\\\\\\\\\\"\\\\\\\\\\\\\\\"}\\\\\\\"}\\\"}\"}', 2, '*', 1, '2018-06-25 16:06:04', '2018-06-25 16:06:04');

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE IF NOT EXISTS `#__template_styles` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `template` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `client_id` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `home` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `title` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(4, 'beez3', 0, '0', 'Beez3 - Default', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),
(7, 'protostar', 0, '0', 'protostar - Default', '{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}'),
(8, 'isis', 1, '1', 'isis - Default', '{\"templateColor\":\"\",\"logoFile\":\"\"}'),
(14, 'theme3589', 0, '1', 'theme3589 - Default', '{\"header_logo_width\":\"3\",\"mainmenu_width\":\"9\",\"enable_footer_logo\":\"0\",\"footer_logo_width\":\"3\",\"footer_logoimage\":\"\",\"footer_title\":\"\",\"footer_slogan\":\"\",\"footer_logo_aftertext\":\"\",\"page-loader\":\"1\",\"privacyLink\":\"0\",\"privacy_link_menu\":\"176\",\"privacy_link_title\":\"Privacy policy\",\"asideLeftWidth\":\"3\",\"asideRightWidth\":\"3\",\"top_layout\":\"normal\",\"header_layout\":\"normal\",\"map_layout\":\"normal\",\"breadcrumbs_layout\":\"normal\",\"position-1_layout\":\"normal\",\"position-2_layout\":\"normal\",\"position-3_layout\":\"normal\",\"position-4_layout\":\"normal\",\"position-5_layout\":\"normal\",\"position-6_layout\":\"normal\",\"position-7_layout\":\"normal\",\"position-8_layout\":\"normal\",\"position-9_layout\":\"normal\",\"position-10_layout\":\"normal\",\"position-11_layout\":\"normal\",\"position-12_layout\":\"normal\",\"position-13_layout\":\"normal\",\"position-14_layout\":\"normal\",\"position-15_layout\":\"normal\",\"footer_layout\":\"fullwidth\",\"footer-1_layout\":\"normal\",\"footer-2_layout\":\"normal\",\"footer-3_layout\":\"normal\",\"footer-4_layout\":\"normal\",\"featuredPageHeading\":\"h1\",\"featuredItemHeading\":\"h4\",\"categoryPageHeading\":\"h2\",\"categoryItemHeading\":\"h3\",\"blogPageHeading\":\"h3\",\"blogItemHeading\":\"h4\",\"itemItemHeading\":\"h2\",\"itemBlogItemHeading\":\"h4\",\"totop\":\"1\",\"totop_text\":\"\",\"todesktop\":\"1\",\"todesktop_text\":\"Back to desktop version\",\"tomobile_text\":\"Back to mobile version\",\"blackandwhite\":\"0\",\"invertHoverEffect\":\"1\",\"fadeIn\":\"500\",\"fadeOut\":\"500\",\"countdown_time\":\"\",\"color_scheme\":\"\",\"t3_template\":\"1\",\"devmode\":\"0\",\"themermode\":\"1\",\"legacy_css\":\"0\",\"responsive\":\"1\",\"non_responsive_width\":\"970px\",\"build_rtl\":\"0\",\"t3-assets\":\"t3-assets\",\"t3-rmvlogo\":\"0\",\"minify\":\"0\",\"minify_js\":\"0\",\"minify_js_tool\":\"jsmin\",\"minify_exclude\":null,\"link_titles\":null,\"logotype\":\"image\",\"sitename\":\"\",\"slogan\":\"\",\"logoimage\":\"images\\/logo.png\",\"enable_logoimage_sm\":\"0\",\"logoimage_sm\":\"\",\"mainlayout\":\"default\",\"sublayout\":\"\",\"mm_type\":\"main-menu\",\"navigation_trigger\":\"hover\",\"navigation_type\":\"megamenu\",\"navigation_animation\":\"fading\",\"navigation_animation_duration\":\"400\",\"mm_config\":\"{\\\"main-menu\\\":{\\\"item-101\\\":{\\\"sub\\\":{\\\"class\\\":\\\"megamenu\\\",\\\"width\\\":1170,\\\"rows\\\":[[{\\\"item\\\":608,\\\"width\\\":4},{\\\"position\\\":248,\\\"width\\\":4},{\\\"item\\\":610,\\\"width\\\":4}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-608\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":249,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-610\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":251,\\\"width\\\":12}],[{\\\"position\\\":241,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-335\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":138,\\\"width\\\":12}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-426\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":336,\\\"width\\\":12}]]}},\\\"item-622\\\":{\\\"sub\\\":{\\\"width\\\":330,\\\"rows\\\":[[{\\\"item\\\":623,\\\"width\\\":12}]]},\\\"xicon\\\":\\\"icon fa fa-user\\\",\\\"alignsub\\\":\\\"center\\\",\\\"class\\\":\\\"menu-login\\\"},\\\"item-623\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":252,\\\"width\\\":12}]]},\\\"class\\\":\\\"notitle\\\",\\\"group\\\":1},\\\"item-612\\\":{\\\"xicon\\\":\\\"icon fa fa-search\\\",\\\"alignsub\\\":\\\"right\\\",\\\"class\\\":\\\"menu-search\\\"}}}\",\"navigation_collapse_enable\":\"1\",\"addon_offcanvas_enable\":\"0\",\"addon_offcanvas_effect\":\"off-canvas-effect-4\",\"snippet_open_head\":null,\"snippet_close_head\":null,\"snippet_open_body\":null,\"snippet_close_body\":null,\"snippet_debug\":\"0\"}'),
(15, 'theme3589', 0, '0', 'theme3589 - Home', '{\"header_logo_width\":\"3\",\"mainmenu_width\":\"9\",\"enable_footer_logo\":\"0\",\"footer_logo_width\":\"3\",\"footer_logoimage\":\"\",\"footer_title\":\"\",\"footer_slogan\":\"\",\"footer_logo_aftertext\":\"\",\"page-loader\":\"1\",\"privacyLink\":\"0\",\"privacy_link_menu\":\"176\",\"privacy_link_title\":\"Privacy Policy\",\"asideLeftWidth\":\"3\",\"asideRightWidth\":\"3\",\"top_layout\":\"normal\",\"header_layout\":\"normal\",\"map_layout\":\"normal\",\"breadcrumbs_layout\":\"normal\",\"position-1_layout\":\"normal\",\"position-2_layout\":\"normal\",\"position-3_layout\":\"normal\",\"position-4_layout\":\"normal\",\"position-5_layout\":\"normal\",\"position-6_layout\":\"normal\",\"position-7_layout\":\"normal\",\"position-8_layout\":\"normal\",\"position-9_layout\":\"normal\",\"position-10_layout\":\"normal\",\"position-11_layout\":\"normal\",\"position-12_layout\":\"normal\",\"position-13_layout\":\"normal\",\"position-14_layout\":\"normal\",\"position-15_layout\":\"normal\",\"footer_layout\":\"fullwidth\",\"footer-1_layout\":\"normal\",\"footer-2_layout\":\"normal\",\"footer-3_layout\":\"normal\",\"footer-4_layout\":\"normal\",\"featuredPageHeading\":\"h1\",\"featuredItemHeading\":\"h3\",\"categoryPageHeading\":\"h2\",\"categoryItemHeading\":\"h3\",\"blogPageHeading\":\"h1\",\"blogItemHeading\":\"h3\",\"itemItemHeading\":\"h2\",\"itemBlogItemHeading\":\"h3\",\"totop\":\"1\",\"totop_text\":\"\",\"todesktop\":\"1\",\"todesktop_text\":\"Back to desktop version\",\"tomobile_text\":\"Back to mobile version\",\"blackandwhite\":\"0\",\"invertHoverEffect\":\"1\",\"fadeIn\":\"500\",\"fadeOut\":\"500\",\"countdown_time\":\"2017-06-08 13:38:03\",\"color_scheme\":\"\",\"t3_template\":\"1\",\"devmode\":\"0\",\"themermode\":\"1\",\"legacy_css\":\"0\",\"responsive\":\"1\",\"non_responsive_width\":\"970px\",\"build_rtl\":\"0\",\"t3-assets\":\"t3-assets\",\"t3-rmvlogo\":\"0\",\"minify\":\"0\",\"minify_js\":\"0\",\"minify_js_tool\":\"jsmin\",\"minify_exclude\":null,\"link_titles\":null,\"logotype\":\"image\",\"sitename\":\"\",\"slogan\":\"\",\"logoimage\":\"images\\/logo.png\",\"enable_logoimage_sm\":\"0\",\"logoimage_sm\":\"\",\"mainlayout\":\"default\",\"sublayout\":\"\",\"mm_type\":\"main-menu\",\"navigation_trigger\":\"hover\",\"navigation_type\":\"megamenu\",\"navigation_animation\":\"fading\",\"navigation_animation_duration\":\"400\",\"mm_config\":\"{\\\"main-menu\\\":{\\\"item-101\\\":{\\\"sub\\\":{\\\"class\\\":\\\"megamenu\\\",\\\"width\\\":1170,\\\"rows\\\":[[{\\\"item\\\":608,\\\"width\\\":4},{\\\"position\\\":248,\\\"width\\\":4},{\\\"item\\\":610,\\\"width\\\":4}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-608\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":249,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-610\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":251,\\\"width\\\":12}],[{\\\"position\\\":241,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-335\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":138,\\\"width\\\":12}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-426\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":336,\\\"width\\\":12}]]}},\\\"item-622\\\":{\\\"sub\\\":{\\\"width\\\":330,\\\"rows\\\":[[{\\\"item\\\":623,\\\"width\\\":12}]]},\\\"xicon\\\":\\\"icon fa fa-user\\\",\\\"alignsub\\\":\\\"center\\\",\\\"class\\\":\\\"menu-login\\\"},\\\"item-623\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":252,\\\"width\\\":12}]]},\\\"class\\\":\\\"notitle\\\",\\\"group\\\":1},\\\"item-612\\\":{\\\"xicon\\\":\\\"icon fa fa-search\\\",\\\"alignsub\\\":\\\"right\\\",\\\"class\\\":\\\"menu-search\\\"}}}\",\"navigation_collapse_enable\":\"1\",\"addon_offcanvas_enable\":\"0\",\"addon_offcanvas_effect\":\"off-canvas-effect-4\",\"snippet_open_head\":null,\"snippet_close_head\":null,\"snippet_open_body\":null,\"snippet_close_body\":null,\"snippet_debug\":\"0\"}'),
(16, 'theme3589', 0, '0', 'theme3589 - Careers', '{\"header_logo_width\":\"3\",\"mainmenu_width\":\"9\",\"enable_footer_logo\":\"0\",\"footer_logo_width\":\"3\",\"footer_logoimage\":\"images\\/logo.png\",\"footer_title\":\"\",\"footer_slogan\":\"\",\"footer_logo_aftertext\":\"\",\"page-loader\":\"1\",\"privacyLink\":\"1\",\"privacy_link_menu\":\"176\",\"privacy_link_title\":\"Privacy policy\",\"asideLeftWidth\":\"3\",\"asideRightWidth\":\"5\",\"top_layout\":\"normal\",\"header_layout\":\"normal\",\"map_layout\":\"normal\",\"breadcrumbs_layout\":\"normal\",\"position-1_layout\":\"normal\",\"position-2_layout\":\"normal\",\"position-3_layout\":\"normal\",\"position-4_layout\":\"normal\",\"position-5_layout\":\"normal\",\"position-6_layout\":\"normal\",\"position-7_layout\":\"normal\",\"position-8_layout\":\"normal\",\"position-9_layout\":\"normal\",\"position-10_layout\":\"normal\",\"position-11_layout\":\"normal\",\"position-12_layout\":\"normal\",\"position-13_layout\":\"normal\",\"position-14_layout\":\"normal\",\"position-15_layout\":\"normal\",\"footer_layout\":\"normal\",\"footer-1_layout\":\"normal\",\"footer-2_layout\":\"normal\",\"footer-3_layout\":\"normal\",\"footer-4_layout\":\"normal\",\"featuredPageHeading\":\"h3\",\"featuredItemHeading\":\"h4\",\"categoryPageHeading\":\"h2\",\"categoryItemHeading\":\"h4\",\"blogPageHeading\":\"h3\",\"blogItemHeading\":\"h4\",\"itemItemHeading\":\"h2\",\"itemBlogItemHeading\":\"h4\",\"totop\":\"1\",\"totop_text\":\"\",\"todesktop\":\"1\",\"todesktop_text\":\"Back to desktop version\",\"tomobile_text\":\"Back to mobile version\",\"blackandwhite\":\"0\",\"invertHoverEffect\":\"1\",\"fadeIn\":\"500\",\"fadeOut\":\"500\",\"countdown_time\":\"\",\"color_scheme\":\"\",\"t3_template\":\"1\",\"devmode\":\"0\",\"themermode\":\"1\",\"legacy_css\":\"0\",\"responsive\":\"1\",\"non_responsive_width\":\"970px\",\"build_rtl\":\"0\",\"t3-assets\":\"t3-assets\",\"t3-rmvlogo\":\"0\",\"minify\":\"0\",\"minify_js\":\"0\",\"minify_js_tool\":\"jsmin\",\"minify_exclude\":\"\",\"link_titles\":\"\",\"theme\":\"\",\"logotype\":\"image\",\"sitename\":\"\",\"slogan\":\"\",\"logoimage\":\"images\\/logo.png\",\"enable_logoimage_sm\":\"0\",\"logoimage_sm\":\"\",\"mainlayout\":\"default\",\"sublayout\":\"\",\"mm_type\":\"main-menu\",\"navigation_trigger\":\"hover\",\"navigation_type\":\"megamenu\",\"navigation_animation\":\"fading\",\"navigation_animation_duration\":\"400\",\"mm_config\":\"{\\\"main-menu\\\":{\\\"item-101\\\":{\\\"sub\\\":{\\\"class\\\":\\\"megamenu\\\",\\\"width\\\":1170,\\\"rows\\\":[[{\\\"item\\\":608,\\\"width\\\":4},{\\\"position\\\":248,\\\"width\\\":4},{\\\"item\\\":610,\\\"width\\\":4}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-608\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":249,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-610\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":251,\\\"width\\\":12}],[{\\\"position\\\":241,\\\"width\\\":12}]]},\\\"group\\\":1},\\\"item-335\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":138,\\\"width\\\":12}]]},\\\"alignsub\\\":\\\"center\\\"},\\\"item-426\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"item\\\":336,\\\"width\\\":12}]]}},\\\"item-622\\\":{\\\"sub\\\":{\\\"width\\\":330,\\\"rows\\\":[[{\\\"item\\\":623,\\\"width\\\":12}]]},\\\"xicon\\\":\\\"icon fa fa-user\\\",\\\"alignsub\\\":\\\"center\\\",\\\"class\\\":\\\"menu-login\\\"},\\\"item-623\\\":{\\\"sub\\\":{\\\"rows\\\":[[{\\\"position\\\":252,\\\"width\\\":12}]]},\\\"class\\\":\\\"notitle\\\",\\\"group\\\":1},\\\"item-612\\\":{\\\"xicon\\\":\\\"icon fa fa-search\\\",\\\"alignsub\\\":\\\"right\\\",\\\"class\\\":\\\"menu-search\\\"}}}\",\"navigation_collapse_enable\":\"1\",\"addon_offcanvas_enable\":\"0\",\"addon_offcanvas_effect\":\"off-canvas-effect-4\",\"snippet_open_head\":\"\",\"snippet_close_head\":\"\",\"snippet_open_body\":\"\",\"snippet_close_body\":\"\",\"snippet_debug\":\"0\"}');

DROP TABLE IF EXISTS `#__ucm_base`;
CREATE TABLE IF NOT EXISTS `#__ucm_base` (
  `ucm_id` int(10) UNSIGNED NOT NULL,
  `ucm_item_id` int(10) NOT NULL,
  `ucm_type_id` int(11) NOT NULL,
  `ucm_language_id` int(11) NOT NULL,
  PRIMARY KEY (`ucm_id`),
  KEY `idx_ucm_item_id` (`ucm_item_id`),
  KEY `idx_ucm_type_id` (`ucm_type_id`),
  KEY `idx_ucm_language_id` (`ucm_language_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__ucm_base` (`ucm_id`, `ucm_item_id`, `ucm_type_id`, `ucm_language_id`) VALUES
(1, 11, 1, 0),
(4, 13, 1, 0),
(5, 12, 1, 0),
(6, 14, 1, 0),
(8, 15, 1, 0),
(9, 118, 1, 0),
(10, 119, 1, 0),
(11, 120, 1, 0),
(12, 185, 1, 0),
(13, 186, 1, 0);

DROP TABLE IF EXISTS `#__ucm_content`;
CREATE TABLE IF NOT EXISTS `#__ucm_content` (
  `core_content_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `core_type_alias` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(400) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `core_alias` varchar(400) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL DEFAULT '',
  `core_body` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_checked_out_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `core_access` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `core_params` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_featured` tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `core_publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_content_item_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'ID from the individual type table',
  `asset_id` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `core_images` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_urls` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_hits` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `core_version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_metadesc` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `core_catid` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`core_content_id`),
  KEY `tag_idx` (`core_state`,`core_access`),
  KEY `idx_access` (`core_access`),
  KEY `idx_language` (`core_language`),
  KEY `idx_modified_time` (`core_modified_time`),
  KEY `idx_created_time` (`core_created_time`),
  KEY `idx_core_modified_user_id` (`core_modified_user_id`),
  KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`),
  KEY `idx_core_created_user_id` (`core_created_user_id`),
  KEY `idx_core_type_id` (`core_type_id`),
  KEY `idx_alias` (`core_alias`(100)),
  KEY `idx_title` (`core_title`(100)),
  KEY `idx_content_type` (`core_type_alias`(100))
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Contains core content data in name spaced fields';

INSERT INTO `#__ucm_content` (`core_content_id`, `core_type_alias`, `core_title`, `core_alias`, `core_body`, `core_state`, `core_checked_out_time`, `core_checked_out_user_id`, `core_access`, `core_params`, `core_featured`, `core_metadata`, `core_created_user_id`, `core_created_by_alias`, `core_created_time`, `core_modified_user_id`, `core_modified_time`, `core_language`, `core_publish_up`, `core_publish_down`, `core_content_item_id`, `asset_id`, `core_images`, `core_urls`, `core_hits`, `core_version`, `core_ordering`, `core_metakey`, `core_metadesc`, `core_catid`, `core_xreference`, `core_type_id`) VALUES
(1, 'com_content.article', 'Children\'s Book Exhibition', 'anniversary-showcase-of-fox-tv-shows-and-movies', '<p>In this article, you will find out about the Children\'s Book Exhibition - an annual event that gathers the world\'s most famous authors of infantile and teenage literature.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"theme3589:blog\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 11, 719, '{\"image_intro\":\"images\\/blog\\/blog-thumb8.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img8.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 512, 54, 1, '', '', 48, '', 1),
(4, 'com_content.article', 'Improving your confidence and self-defense skills', 'improving-your-confidence-and-self-defense-skills', '<p>Today we would like to touch the topic which is gaining popularity among employees of big and small companies as well as students, teachers and other strata of the population.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 13, 775, '{\"image_intro\":\"images\\/blog\\/blog-thumb6.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img6.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 14, 24, 0, '', '', 15, '', 1),
(5, 'com_content.article', 'Participate in discussion of an important topic', 'participate-in-discussion-of-an-important-topic', '<p>Are you a journalist or a creative personality? Do you want to share information with the world? Then our new project will be perfect for you to express your ideas and concepts.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 12, 776, '{\"image_intro\":\"images\\/blog\\/blog-thumb7.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img7.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 13, 33, 0, '', '', 14, '', 1),
(6, 'com_content.article', 'Pen & Paintbruh', 'pen-paintbruh', '<p>Discover the top secrets of creating a beautiful and original painting with a pen and a paintbrush...</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 846, '2018-06-29 13:25:32', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 14, 774, '{\"image_intro\":\"images\\/blog\\/blog-thumb5.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img5.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 15, 29, 0, '', '', 49, '', 1),
(8, 'com_content.article', 'Music is now officially proved to have influence on us', 'music-is-now-officially-proved-to-have-influence-on-us', '<p>During our latest visit, the scientists of the Seattle Scientific Company laboratory have unveiled some information about their current project, and today we can share the results of their research with you.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"theme3589:blog\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 15, 718, '{\"image_intro\":\"images\\/blog\\/blog-thumb4.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img4.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 10, 29, 0, '', '', 51, '', 1),
(9, 'com_content.article', 'Things I’ve Learned about Investing and Business', 'things-i-ve-learned-about-investing-and-business', '<p>The North American Auto Show, one of the most important annual events that influence the international automotive industry and exhibits its main achievements, is eventually confirmed to take place in Chicago, IL. Located on the southwestern coast of Lake Michigan, this city will host representatives of vehicle manufacturers from all over the world. They include American companies (Ford, General Motors), European (Alfa Romeo, Lotus, BMW, FIAT, Seat) as well as Japanese ones and many others.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 118, 697, '{\"image_intro\":\"images\\/blog\\/blog-thumb1.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img1.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 365, 56, 1, '', '', 52, '', 1),
(10, 'com_content.article', 'LinkedIn Stock Downgraded After Microsoft Deal ', 'linkedin-stock-downgraded-after-microsoft-deal', '<p>Fox TV Channel is showcasing the most successful series and full-length films of 20th Century Fox this month in all American cinemas with wide promotional campaign of their upcoming projects.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 119, 698, '{\"image_intro\":\"images\\/blog\\/blog-thumb2.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img2.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 24, 31, 0, '', '', 53, '', 1),
(11, 'com_content.article', 'London SE in Frankfurt?', 'london-se-in-frankfurt', '<p>Recently our partner, Jerry Conrad Lewis has revealed some of his own global plans alongside with a new set of social measures, designed to improve the world we live in.</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 213, '', '2018-06-25 16:06:04', 213, '2018-06-25 16:06:04', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 120, 699, '{\"image_intro\":\"images\\/blog\\/blog-thumb3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img3.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 24, 38, 0, '', '', 54, '', 1),
(12, 'com_content.article', 'Etching Demonstration', 'etching-demonstration', '<p>Meet the renowned artists during their demonstrations on September 4th through 7th...</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 846, '', '2018-06-25 16:06:04', 846, '2018-06-29 14:30:36', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 185, 864, '{\"image_intro\":\"images\\/blog\\/blog-thumb9.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img9.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 0, 2, 0, '', '', 49, '', 1),
(13, 'com_content.article', 'Miniature Art Show', 'miniature-art-show', '<p>Visit the world\'s most original Miniature Art Show that will take place in our art gallery...</p>\r\n', 1, '', 0, 1, '{\"article_layout\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_tags\":\"\",\"show_intro\":\"\",\"info_block_position\":\"\",\"info_block_show_title\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_associations\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_page_title\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', 0, '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', 846, '', '2018-06-25 16:06:04', 846, '2018-06-29 14:31:45', '*', '2018-06-25 16:06:04', '0000-00-00 00:00:00', 186, 866, '{\"image_intro\":\"images\\/blog\\/blog-thumb3.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/blog\\/blog-img10.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', 0, 2, 0, '', '', 49, '', 1);

DROP TABLE IF EXISTS `#__ucm_history`;
CREATE TABLE IF NOT EXISTS `#__ucm_history` (
  `version_id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `ucm_item_id` int(10) UNSIGNED NOT NULL,
  `ucm_type_id` int(10) UNSIGNED NOT NULL,
  `version_note` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'Optional version name',
  `save_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor_user_id` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `character_count` int(10) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Number of characters in this version.',
  `sha1_hash` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'SHA1 hash of the version_data column.',
  `version_data` longtext COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'json-encoded string of version data',
  `keep_forever` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0=auto delete; 1=keep',
  PRIMARY KEY (`version_id`),
  KEY `idx_ucm_item_id` (`ucm_type_id`,`ucm_item_id`),
  KEY `idx_save_date` (`save_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE IF NOT EXISTS `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `description` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `element` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `type` varchar(20) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `folder` varchar(20) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(32) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `data` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `detailsurl` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `infourl` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `extra_query` varchar(1000) COLLATE utf8mb4_unicode_ci DEFAULT '',
  PRIMARY KEY (`update_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Available Updates';

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE IF NOT EXISTS `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `type` varchar(20) COLLATE utf8mb4_unicode_ci DEFAULT '',
  `location` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  `extra_query` varchar(1000) COLLATE utf8mb4_unicode_ci DEFAULT '',
  PRIMARY KEY (`update_site_id`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`, `extra_query`) VALUES
(1, 'Joomla! Core', 'collection', 'https://update.joomla.org/core/list.xml', 1, 1550477795, ''),
(2, 'Joomla! Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 1550477795, ''),
(4, 'Joomla! Update Component Update Site', 'extension', 'http://update.joomla.org/core/extensions/com_joomlaupdate.xml', 1, 1550478351, ''),
(9, 'Joomla! Update Component Update Site', 'extension', 'https://update.joomla.org/core/extensions/com_joomlaupdate.xml', 1, 1550478352, ''),
(20, 'Articles Newsflash (Advanced) module Updates', 'extension', 'http://joomlacode.org/gf/project/tm_art_news_adv/scmsvn/?action=browse&path=%2F%2Acheckout%2A%2Ftrunk%2Fextension.xml', 1, 0, ''),
(21, 'JoomGallery Update Service', 'collection', 'http://www.en.joomgallery.net/components/com_newversion/xml/extensions3.xml', 1, 0, ''),
(22, '', 'extension', 'http://update.joomlart.com/service/tracking/j16/plg_system_t3.xml', 1, 0, ''),
(23, 'Joomline', 'extension', 'https://joomline.net/index.php?option=com_ars&view=update&task=stream&format=xml&id=5&dummy=extension.xml', 1, 0, ''),
(24, 'Accredited Joomla! Translations', 'collection', 'https://update.joomla.org/language/translationlist_3.xml', 1, 0, ''),
(25, 'Kunena 5.1 Update Site', 'collection', 'https://update.kunena.org/5.1/list.xml', 1, 0, ''),
(26, 'AcyMailing', 'extension', 'http://www.acyba.com/component/updateme/updatexml/component-acymailing/level-Starter/file-extension.xml', 1, 0, '');

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE IF NOT EXISTS `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='Links extensions to update sites';

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700),
(4, 28),
(9, 28),
(20, 10007),
(21, 10032),
(21, 10033),
(22, 10164),
(22, 10193),
(23, 10143),
(24, 802),
(25, 10020),
(26, 10204);

DROP TABLE IF EXISTS `#__utf8_conversion`;
CREATE TABLE IF NOT EXISTS `#__utf8_conversion` (
  `converted` tinyint(4) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__utf8_conversion` (`converted`) VALUES
(2);

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE IF NOT EXISTS `#__viewlevels` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[1]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(5, 'Guest', 0, '[9]'),
(6, 'Super Users', 0, '[8]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
  `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) UNSIGNED NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`, `lastResetTime`, `resetCount`, `otpKey`, `otep`, `requireReset`) VALUES
(846, 'Demo User', 'demo', 'demo@demolink.org', 'y.xksMc0Rh19yJxOtqUOIQZ7OaxfheK7zSAsak7elym/kwAzjqW', 0, 0, '2012-10-17 10:56:12', '2014-12-10 07:17:39', '', '{"admin_style":"","admin_language":"","language":"","editor":"","helpsite":"","timezone":""}', '0000-00-00 00:00:00', 0, '', '', 0),
(847, 'Lorem Ipsum', 'lorem_ipsum', 'lorem_ipsum@demolink.org', 'y/FxAHYMOjEIrvvJdKPfz4UB.qc9Fm1/eXeXc.ci', 0, 0, '2014-12-09 10:29:04', '2014-12-09 10:46:07', '', '{}', '0000-00-00 00:00:00', 0, '', '', 0),
(848, 'Dolor Sit', 'dolor_sit', 'dolor_sit@demolink.org', 'y/JUy', 0, 0, '2014-12-09 10:37:28', '2014-12-09 14:09:16', '', '{}', '0000-00-00 00:00:00', 0, '', '', 0);

INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES
(846, 8),
(847, 2),
(848, 2);